/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/platform","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(G){for(var e=[],b=0,I=G.length;b<I;b++)e[b]=me[G[b]];return e};define(me[52],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(I,T){if(!I)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=b}),define(me[53],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const b=Object.prototype.hasOwnProperty;function I(s){const C=[];for(let f in s)b.call(s,f)&&C.push(s[f]);return C}e.values=I;function T(s,C){for(let f in s)if(b.call(s,f)&&C({key:f,value:s[f]},function(){delete s[f]})===!1)return}e.forEach=T;function A(s,C){const f=Object.create(null);for(const h of s){const a=C(h);let u=f[a];u||(u=f[a]=[]),u.push(h)}return f}e.groupBy=A;function y(s){const C=Object.create(null);return s&&s.forEach((f,h)=>{C[h]=f}),C}e.fromMap=y;function k(s,C){const f=[],h=[];for(let a of s)C.has(a)||f.push(a);for(let a of C)s.has(a)||h.push(a);return{removed:f,added:h}}e.diffSets=k;function D(s,C){const f=[],h=[];for(let[a,u]of s)C.has(a)||f.push(u);for(let[a,u]of C)s.has(a)||h.push(u);return{removed:f,added:h}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(C,f){let h=this.map.get(C);h||(h=new Set,this.map.set(C,h)),h.add(f)}delete(C,f){const h=this.map.get(C);!h||(h.delete(f),h.size===0&&this.map.delete(C))}forEach(C,f){const h=this.map.get(C);!h||h.forEach(f)}}e.SetMap=P}),define(me[69],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function b(D){return(P,s,C)=>{let f=null,h=null;if(typeof C.value=="function"?(f="value",h=C.value):typeof C.get=="function"&&(f="get",h=C.get),!h)throw new Error("not supported");C[f]=D(h,s)}}e.createDecorator=b;let I=0;function T(){const D=`$memoize${I++}`;let P;const s=function(f,h,a){let u=null,E=null;if(typeof a.value=="function"?(u="value",E=a.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(u="get",E=a.get),!E)throw new Error("not supported");const v=`${D}:${h}`;a[u]=function(..._){return P=this,this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!0,enumerable:!1,writable:!0,value:E.apply(this,_)}),this[v]}};return s.clear=()=>{typeof P!="undefined"&&Object.getOwnPropertyNames(P).forEach(C=>{C.indexOf(D)===0&&delete P[C]})},s}e.createMemoizer=T;function A(D,P,s){return T()(D,P,s)}e.memoize=A;function y(D,P,s){return b((C,f)=>{const h=`$debounce$${f}`,a=`$debounce$result$${f}`;return function(...u){this[a]||(this[a]=s?s():void 0),clearTimeout(this[h]),P&&(this[a]=P(this[a],...u),u=[this[a]]),this[h]=setTimeout(()=>{C.apply(this,u),this[a]=s?s():void 0},D)}})}e.debounce=y;function k(D,P,s){return b((C,f)=>{const h=`$throttle$timer$${f}`,a=`$throttle$result$${f}`,u=`$throttle$lastRun$${f}`,E=`$throttle$pending$${f}`;return function(...v){if(this[a]||(this[a]=s?s():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),P&&(this[a]=P(this[a],...v)),!this[E]){const _=this[u]+D;_<=Date.now()?(this[u]=Date.now(),C.apply(this,[this[a]]),this[a]=s?s():void 0):(this[E]=!0,this[h]=setTimeout(()=>{this[E]=!1,this[u]=Date.now(),C.apply(this,[this[a]]),this[a]=s?s():void 0},_-Date.now()))}}})}e.throttle=k}),define(me[19],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(t=>{t(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=b,e.errorHandler=new b;function I(d){e.errorHandler.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=I;function T(d){D(d)||e.errorHandler.onUnexpectedError(d)}e.onUnexpectedError=T;function A(d){D(d)||e.errorHandler.onUnexpectedExternalError(d)}e.onUnexpectedExternalError=A;function y(d){if(d instanceof Error){let{name:n,message:t}=d;const r=d.stacktrace||d.stack;return{$isError:!0,name:n,message:t,stack:r}}return d}e.transformErrorForSerialization=y;const k="Canceled";function D(d){return d instanceof Error&&d.name===k&&d.message===k}e.isPromiseCanceledError=D;class P extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=P;function s(){const d=new Error(k);return d.name=d.message,d}e.canceled=s;function C(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.illegalArgument=C;function f(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.illegalState=f;function h(d){return d?new Error(`readonly property '${d} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function a(d){const n=new Error(`${d} has been disposed`);return n.name="DISPOSED",n}e.disposed=a;function u(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.getErrorMessage=u;class E extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=E;class v extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=v;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function g(d){const n=d;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=g;function l(d,n=Object.create(null)){const t=new Error(d);return n.actions&&(t.actions=n.actions),t}e.createErrorWithActions=l}),define(me[15],ge([0,1,19]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I(U,M=0){return U[U.length-(1+M)]}e.tail=I;function T(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=T;function A(U,M,L=(N,O)=>N===O){if(U===M)return!0;if(!U||!M||U.length!==M.length)return!1;for(let N=0,O=U.length;N<O;N++)if(!L(U[N],M[N]))return!1;return!0}e.equals=A;function y(U,M,L){let N=0,O=U.length-1;for(;N<=O;){const B=(N+O)/2|0,q=L(U[B],M);if(q<0)N=B+1;else if(q>0)O=B-1;else return B}return-(N+1)}e.binarySearch=y;function k(U,M){let L=0,N=U.length;if(N===0)return 0;for(;L<N;){const O=Math.floor((L+N)/2);M(U[O])?N=O:L=O+1}return L}e.findFirstInSorted=k;function D(U,M,L){if(U=U|0,U>=M.length)throw new TypeError("invalid index");let N=M[Math.floor(M.length*Math.random())],O=[],B=[],q=[];for(let Q of M){const he=L(Q,N);he<0?O.push(Q):he>0?B.push(Q):q.push(Q)}return U<O.length?D(U,O,L):U<O.length+q.length?q[0]:D(U-(O.length+q.length),B,L)}e.quickSelect=D;function P(U,M){const L=[];let N;for(const O of U.slice(0).sort(M))!N||M(N[0],O)!==0?(N=[O],L.push(N)):N.push(O);return L}e.groupBy=P;function s(U,M,L){const N=[];function O(Q,he,ve){if(!(he===0&&ve.length===0)){const Ie=N[N.length-1];Ie&&Ie.start+Ie.deleteCount===Q?(Ie.deleteCount+=he,Ie.toInsert.push(...ve)):N.push({start:Q,deleteCount:he,toInsert:ve})}}let B=0,q=0;for(;;){if(B===U.length){O(B,0,M.slice(q));break}if(q===M.length){O(B,U.length-B,[]);break}const Q=U[B],he=M[q],ve=L(Q,he);ve===0?(B+=1,q+=1):ve<0?(O(B,1,[]),B+=1):ve>0&&(O(B,0,[he]),q+=1)}return N}e.sortedDiff=s;function C(U,M,L){const N=s(U,M,L),O=[],B=[];for(const q of N)O.push(...U.slice(q.start,q.start+q.deleteCount)),B.push(...q.toInsert);return{removed:O,added:B}}e.delta=C;function f(U,M,L){if(L===0)return[];const N=U.slice(0,L).sort(M);return a(U,M,N,L,U.length),N}e.top=f;function h(U,M,L,N,O){return L===0?Promise.resolve([]):new Promise((B,q)=>{(async()=>{const Q=U.length,he=U.slice(0,L).sort(M);for(let ve=L,Ie=Math.min(L+N,Q);ve<Q;ve=Ie,Ie=Math.min(Ie+N,Q)){if(ve>L&&await new Promise(ke=>setTimeout(ke)),O&&O.isCancellationRequested)throw(0,b.canceled)();a(U,M,he,ve,Ie)}return he})().then(B,q)})}e.topAsync=h;function a(U,M,L,N,O){for(const B=L.length;N<O;N++){const q=U[N];if(M(q,L[B-1])<0){L.pop();const Q=k(L,he=>M(q,he)<0);L.splice(Q,0,q)}}}function u(U){return U.filter(M=>!!M)}e.coalesce=u;function E(U){let M=0;for(let L=0;L<U.length;L++)U[L]&&(U[M]=U[L],M+=1);U.length=M}e.coalesceInPlace=E;function v(U,M,L){U.splice(L,0,U.splice(M,1)[0])}e.move=v;function _(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=_;function g(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=g;function l(U,M){if(!M)return U.filter((N,O)=>U.indexOf(N)===O);const L=Object.create(null);return U.filter(N=>{const O=M(N);return L[O]?!1:(L[O]=!0,!0)})}e.distinct=l;function d(U){const M=new Set;return U.filter(L=>M.has(L)?!1:(M.add(L),!0))}e.distinctES6=d;function n(U){const M=Object.create(null);return L=>{const N=U(L);return M[N]?!1:(M[N]=!0,!0)}}e.uniqueFilter=n;function t(U,M){for(let L=U.length-1;L>=0;L--){const N=U[L];if(M(N))return L}return-1}e.lastIndex=t;function r(U,M){return U.length>0?U[0]:M}e.firstOrDefault=r;function i(U,M,L=(N,O)=>N===O){let N=0;for(let O=0,B=Math.min(U.length,M.length);O<B&&L(U[O],M[O]);O++)N++;return N}e.commonPrefixLength=i;function o(U){return[].concat(...U)}e.flatten=o;function c(U,M){let L=typeof M=="number"?U:0;typeof M=="number"?L=U:(L=0,M=U);const N=[];if(L<=M)for(let O=L;O<M;O++)N.push(O);else for(let O=L;O>M;O--)N.push(O);return N}e.range=c;function m(U,M,L){return U.reduce((N,O)=>(N[M(O)]=L?L(O):O,N),Object.create(null))}e.index=m;function S(U,M){return U.push(M),()=>p(U,M)}e.insert=S;function p(U,M){const L=U.indexOf(M);if(L>-1)return U.splice(L,1),M}e.remove=p;function w(U,M,L){const N=U.slice(0,M),O=U.slice(M);return N.concat(L,O)}e.arrayInsert=w;function R(U,M){let L;if(typeof M=="number"){let N=M;L=()=>{const O=Math.sin(N++)*179426549;return O-Math.floor(O)}}else L=Math.random;for(let N=U.length-1;N>0;N-=1){const O=Math.floor(L()*(N+1)),B=U[N];U[N]=U[O],U[O]=B}}e.shuffle=R;function F(U,M){const L=U.indexOf(M);L>-1&&(U.splice(L,1),U.unshift(M))}e.pushToStart=F;function z(U,M){const L=U.indexOf(M);L>-1&&(U.splice(L,1),U.push(M))}e.pushToEnd=z;function oe(U,M){return Array.isArray(U)?U.map(M):M(U)}e.mapArrayOrNot=oe;function j(U){return Array.isArray(U)?U:[U]}e.asArray=j;function W(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=W;function $(U,M){for(const L of U){const N=M(L);if(N!==void 0)return N}}e.mapFind=$}),define(me[70],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(I){const T=this;let A=!1,y;return function(){return A||(A=!0,y=I.apply(T,arguments)),y}}e.once=b}),define(me[71],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class b{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=b,e.defaultGenerator=new b("id#")}),define(me[54],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(I){function T(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}I.is=T;const A=Object.freeze([]);function y(){return A}I.empty=y;function*k(d){yield d}I.single=k;function D(d){return d||A}I.from=D;function P(d){return!d||d[Symbol.iterator]().next().done===!0}I.isEmpty=P;function s(d){return d[Symbol.iterator]().next().value}I.first=s;function C(d,n){for(const t of d)if(n(t))return!0;return!1}I.some=C;function f(d,n){for(const t of d)if(n(t))return t}I.find=f;function*h(d,n){for(const t of d)n(t)&&(yield t)}I.filter=h;function*a(d,n){for(const t of d)yield n(t)}I.map=a;function*u(...d){for(const n of d)for(const t of n)yield t}I.concat=u;function*E(d){for(const n of d)for(const t of n)yield t}I.concatNested=E;function v(d,n,t){let r=t;for(const i of d)r=n(r,i);return r}I.reduce=v;function*_(d,n,t=d.length){for(n<0&&(n+=d.length),t<0?t+=d.length:t>d.length&&(t=d.length);n<t;n++)yield d[n]}I.slice=_;function g(d,n=Number.POSITIVE_INFINITY){const t=[];if(n===0)return[t,d];const r=d[Symbol.iterator]();for(let i=0;i<n;i++){const o=r.next();if(o.done)return[t,I.empty()];t.push(o.value)}return[t,{[Symbol.iterator](){return r}}]}I.consume=g;function l(d,n,t=(r,i)=>r===i){const r=d[Symbol.iterator](),i=n[Symbol.iterator]();for(;;){const o=r.next(),c=i.next();if(o.done!==c.done)return!1;if(o.done)return!0;if(!t(o.value,c.value))return!1}}I.equals=l})(b=e.Iterable||(e.Iterable={}))}),define(me[55],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var I;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(n){n.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function y(n,t=!1){let r=0,i=n.length,o="",c=0,m=16,S=0;function p(W){let $=0,U=0;for(;$<W;){const M=n.charCodeAt(r);if(M>=48&&M<=57)U=U*16+M-48;else if(M>=65&&M<=70)U=U*16+M-65+10;else if(M>=97&&M<=102)U=U*16+M-97+10;else break;r++,$++}return $<W&&(U=-1),U}function w(W){r=W,o="",c=0,m=16,S=0}function R(){const W=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&P(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&P(n.charCodeAt(r)))for(r++;r<n.length&&P(n.charCodeAt(r));)r++;else return S=3,n.substring(W,r);let $=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&P(n.charCodeAt(r))){for(r++;r<n.length&&P(n.charCodeAt(r));)r++;$=r}else S=3;return n.substring(W,$)}function F(){let W="",$=r;for(;;){if(r>=i){W+=n.substring($,r),S=2;break}const U=n.charCodeAt(r);if(U===34){W+=n.substring($,r),r++;break}if(U===92){if(W+=n.substring($,r),r++,r>=i){S=2;break}switch(n.charCodeAt(r++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const L=p(4);L>=0?W+=String.fromCharCode(L):S=4;break;default:S=5}$=r;continue}if(U>=0&&U<=31)if(D(U)){W+=n.substring($,r),S=2;break}else S=6;r++}return W}function z(){if(o="",S=0,c=r,r>=i)return c=i,m=17;let W=n.charCodeAt(r);if(k(W)){do r++,o+=String.fromCharCode(W),W=n.charCodeAt(r);while(k(W));return m=15}if(D(W))return r++,o+=String.fromCharCode(W),W===13&&n.charCodeAt(r)===10&&(r++,o+=`
`),m=14;switch(W){case 123:return r++,m=1;case 125:return r++,m=2;case 91:return r++,m=3;case 93:return r++,m=4;case 58:return r++,m=6;case 44:return r++,m=5;case 34:return r++,o=F(),m=10;case 47:const $=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<i&&!D(n.charCodeAt(r));)r++;return o=n.substring($,r),m=12}if(n.charCodeAt(r+1)===42){r+=2;const U=i-1;let M=!1;for(;r<U;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,M=!0;break}r++}return M||(r++,S=1),o=n.substring($,r),m=13}return o+=String.fromCharCode(W),r++,m=16;case 45:if(o+=String.fromCharCode(W),r++,r===i||!P(n.charCodeAt(r)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=R(),m=11;default:for(;r<i&&oe(W);)r++,W=n.charCodeAt(r);if(c!==r){switch(o=n.substring(c,r),o){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return o+=String.fromCharCode(W),r++,m=16}}function oe(W){if(k(W)||D(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let W;do W=z();while(W>=12&&W<=15);return W}return{setPosition:w,getPosition:()=>r,scan:t?j:z,getToken:()=>m,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>S}}e.createScanner=y;function k(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function D(n){return n===10||n===13||n===8232||n===8233}function P(n){return n>=48&&n<=57}var s;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(s||(s={}));function C(n,t){const r=[],i=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function S(p,w,R,F){c.value=p,c.offset=w,c.length=R,c.type=F,c.colonOffset=void 0,o=c}try{g(n,{onObjectBegin:(p,w)=>{if(t<=p)throw i;o=void 0,m=t>p,r.push("")},onObjectProperty:(p,w,R)=>{if(t<w||(S(p,w,R,"property"),r[r.length-1]=p,t<=w+R))throw i},onObjectEnd:(p,w)=>{if(t<=p)throw i;o=void 0,r.pop()},onArrayBegin:(p,w)=>{if(t<=p)throw i;o=void 0,r.push(0)},onArrayEnd:(p,w)=>{if(t<=p)throw i;o=void 0,r.pop()},onLiteralValue:(p,w,R)=>{if(t<w||(S(p,w,R,d(p)),t<=w+R))throw i},onSeparator:(p,w,R)=>{if(t<=w)throw i;if(p===":"&&o&&o.type==="property")o.colonOffset=w,m=!1,o=void 0;else if(p===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(m=!0,r[r.length-1]=""),o=void 0}}})}catch(p){if(p!==i)throw p}return{path:r,previousNode:o,isAtPropertyKey:m,matches:p=>{let w=0;for(let R=0;w<p.length&&R<r.length;R++)if(p[w]===r[R]||p[w]==="*")w++;else if(p[w]!=="**")return!1;return w===p.length}}}e.getLocation=C;function f(n,t=[],r=A.DEFAULT){let i=null,o=[];const c=[];function m(p){Array.isArray(o)?o.push(p):i!==null&&(o[i]=p)}return g(n,{onObjectBegin:()=>{const p={};m(p),c.push(o),o=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const p=[];m(p),c.push(o),o=p,i=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:m,onError:(p,w,R)=>{t.push({error:p,offset:w,length:R})}},r),o[0]}e.parse=f;function h(n,t=[],r=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(p){i.type==="property"&&(i.length=p-i.offset,i=i.parent)}function c(p){return i.children.push(p),p}g(n,{onObjectBegin:p=>{i=c({type:"object",offset:p,length:-1,parent:i,children:[]})},onObjectProperty:(p,w,R)=>{i=c({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:p,offset:w,length:R,parent:i})},onObjectEnd:(p,w)=>{i.length=p+w-i.offset,i=i.parent,o(p+w)},onArrayBegin:(p,w)=>{i=c({type:"array",offset:p,length:-1,parent:i,children:[]})},onArrayEnd:(p,w)=>{i.length=p+w-i.offset,i=i.parent,o(p+w)},onLiteralValue:(p,w,R)=>{c({type:d(p),offset:w,length:R,parent:i,value:p}),o(w+R)},onSeparator:(p,w,R)=>{i.type==="property"&&(p===":"?i.colonOffset=w:p===","&&o(w))},onError:(p,w,R)=>{t.push({error:p,offset:w,length:R})}},r);const S=i.children[0];return S&&delete S.parent,S}e.parseTree=h;function a(n,t){if(!!n){let r=n;for(let i of t)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===i){r=c.children[1],o=!0;break}if(!o)return}else{const o=i;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}}e.findNodeAtLocation=a;function u(n){if(!n.parent||!n.parent.children)return[];const t=u(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;t.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&t.push(r)}return t}e.getNodePath=u;function E(n){switch(n.type){case"array":return n.children.map(E);case"object":const t=Object.create(null);for(let r of n.children){const i=r.children[1];i&&(t[r.children[0].value]=E(i))}return t;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=E;function v(n,t,r=!1){return t>=n.offset&&t<n.offset+n.length||r&&t===n.offset+n.length}e.contains=v;function _(n,t,r=!1){if(v(n,t,r)){const i=n.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=t;o++){const c=_(i[o],t,r);if(c)return c}return n}}e.findNodeAtOffset=_;function g(n,t,r=A.DEFAULT){const i=y(n,!1);function o(he){return he?()=>he(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(he){return he?ve=>he(ve,i.getTokenOffset(),i.getTokenLength()):()=>!0}const m=o(t.onObjectBegin),S=c(t.onObjectProperty),p=o(t.onObjectEnd),w=o(t.onArrayBegin),R=o(t.onArrayEnd),F=c(t.onLiteralValue),z=c(t.onSeparator),oe=o(t.onComment),j=c(t.onError),W=r&&r.disallowComments,$=r&&r.allowTrailingComma;function U(){for(;;){const he=i.scan();switch(i.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:W||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(he){case 12:case 13:W?M(10):oe();break;case 16:M(1);break;case 15:case 14:break;default:return he}}}function M(he,ve=[],Ie=[]){if(j(he),ve.length+Ie.length>0){let ke=i.getToken();for(;ke!==17;){if(ve.indexOf(ke)!==-1){U();break}else if(Ie.indexOf(ke)!==-1)break;ke=U()}}}function L(he){const ve=i.getTokenValue();return he?F(ve):S(ve),U(),!0}function N(){switch(i.getToken()){case 11:let he=0;try{he=JSON.parse(i.getTokenValue()),typeof he!="number"&&(M(2),he=0)}catch(ve){M(2)}F(he);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return U(),!0}function O(){return i.getToken()!==10?(M(3,[],[2,5]),!1):(L(!1),i.getToken()===6?(z(":"),U(),Q()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function B(){m(),U();let he=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(he||M(4,[],[]),z(","),U(),i.getToken()===2&&$)break}else he&&M(6,[],[]);O()||M(4,[],[2,5]),he=!0}return p(),i.getToken()!==2?M(7,[2],[]):U(),!0}function q(){w(),U();let he=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(he||M(4,[],[]),z(","),U(),i.getToken()===4&&$)break}else he&&M(6,[],[]);Q()||M(4,[],[4,5]),he=!0}return R(),i.getToken()!==4?M(8,[4],[]):U(),!0}function Q(){switch(i.getToken()){case 3:return q();case 1:return B();case 10:return L(!0);default:return N()}}return U(),i.getToken()===17?r.allowEmptyContent?!0:(M(4,[],[]),!1):Q()?(i.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=g;function l(n,t){let r=y(n),i=[],o,c=0,m;do switch(m=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:c!==m&&i.push(n.substring(c,m)),t!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,t)),c=r.getPosition();break}while(o!==17);return i.join("")}e.stripComments=l;function d(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=d}),define(me[132],ge([0,1,55]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(D,P,s){let C,f,h,a,u;if(P){for(a=P.offset,u=a+P.length,h=a;h>0&&!k(D,h-1);)h--;let c=u;for(;c<D.length&&!k(D,c);)c++;f=D.substring(h,c),C=A(f,s)}else f=D,C=0,h=0,a=0,u=D.length;const E=y(s,D);let v=!1,_=0,g;s.insertSpaces?g=T(" ",s.tabSize||4):g="	";const l=(0,b.createScanner)(f,!1);let d=!1;function n(){return E+T(g,C+_)}function t(){let c=l.scan();for(v=!1;c===15||c===14;)v=v||c===14,c=l.scan();return d=c===16||l.getTokenError()!==0,c}const r=[];function i(c,m,S){!d&&m<u&&S>a&&D.substring(m,S)!==c&&r.push({offset:m,length:S-m,content:c})}let o=t();if(o!==17){const c=l.getTokenOffset()+h,m=T(g,C);i(m,h,c)}for(;o!==17;){let c=l.getTokenOffset()+l.getTokenLength()+h,m=t(),S="";for(;!v&&(m===12||m===13);){const w=l.getTokenOffset()+h;i(" ",c,w),c=l.getTokenOffset()+l.getTokenLength()+h,S=m===12?n():"",m=t()}if(m===2)o!==1&&(_--,S=n());else if(m===4)o!==3&&(_--,S=n());else{switch(o){case 3:case 1:_++,S=n();break;case 5:case 12:S=n();break;case 13:v?S=n():S=" ";break;case 6:S=" ";break;case 10:if(m===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?S=" ":m!==5&&m!==17&&(d=!0);break;case 16:d=!0;break}v&&(m===12||m===13)&&(S=n())}const p=l.getTokenOffset()+h;i(S,c,p),o=m}return r}e.format=I;function T(D,P){let s="";for(let C=0;C<P;C++)s+=D;return s}function A(D,P){let s=0,C=0;const f=P.tabSize||4;for(;s<D.length;){const h=D.charAt(s);if(h===" ")C++;else if(h==="	")C+=f;else break;s++}return Math.floor(C/f)}function y(D,P){for(let s=0;s<P.length;s++){const C=P.charAt(s);if(C==="\r")return s+1<P.length&&P.charAt(s+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function k(D,P){return`\r
`.indexOf(D.charAt(P))!==-1}e.isEOL=k}),define(me[133],ge([0,1,55,132]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(P,s,C){return A(P,s,void 0,C)}e.removeProperty=T;function A(P,s,C,f,h){const a=s.slice(),u=[],E=(0,b.parseTree)(P,u);let v,_;for(;a.length>0&&(_=a.pop(),v=(0,b.findNodeAtLocation)(E,a),v===void 0&&C!==void 0);)typeof _=="string"?C={[_]:C}:C=[C];if(v)if(v.type==="object"&&typeof _=="string"&&Array.isArray(v.children)){const g=(0,b.findNodeAtLocation)(v,[_]);if(g!==void 0)if(C===void 0){if(!g.parent)throw new Error("Malformed AST");const l=v.children.indexOf(g.parent);let d,n=g.parent.offset+g.parent.length;if(l>0){const t=v.children[l-1];d=t.offset+t.length}else d=v.offset+1,v.children.length>1&&(n=v.children[1].offset);return y(P,{offset:d,length:n-d,content:""},f)}else return y(P,{offset:g.offset,length:g.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const l=`${JSON.stringify(_)}: ${JSON.stringify(C)}`,d=h?h(v.children.map(t=>t.children[0].value)):v.children.length;let n;if(d>0){const t=v.children[d-1];n={offset:t.offset+t.length,length:0,content:","+l}}else v.children.length===0?n={offset:v.offset+1,length:0,content:l}:n={offset:v.offset+1,length:0,content:l+","};return y(P,n,f)}}else if(v.type==="array"&&typeof _=="number"&&Array.isArray(v.children))if(C!==void 0){const g=`${JSON.stringify(C)}`;let l;if(v.children.length===0||_===0)l={offset:v.offset+1,length:0,content:v.children.length===0?g:g+","};else{const d=_===-1||_>v.children.length?v.children.length:_,n=v.children[d-1];l={offset:n.offset+n.length,length:0,content:","+g}}return y(P,l,f)}else{const g=_,l=v.children[g];let d;if(v.children.length===1)d={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===g){const n=v.children[g-1],t=n.offset+n.length,r=v.offset+v.length;d={offset:t,length:r-2-t,content:""}}else d={offset:l.offset,length:v.children[g+1].offset-l.offset,content:""};return y(P,d,f)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${v.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return y(P,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(C)},f)}}e.setProperty=A;function y(P,s,C){let f=k(P,s),h=s.offset,a=s.offset+s.content.length;if(s.length===0||s.content.length===0){for(;h>0&&!(0,I.isEOL)(f,h-1);)h--;for(;a<f.length&&!(0,I.isEOL)(f,a);)a++}const u=(0,I.format)(f,{offset:h,length:a-h},C);for(let v=u.length-1;v>=0;v--){const _=u[v];f=k(f,_),h=Math.min(h,_.offset),a=Math.max(a,_.offset+_.length),a+=_.content.length-_.length}const E=P.length-(f.length-a)-h;return[{offset:h,length:E,content:f.substring(h,a)}]}e.withFormatting=y;function k(P,s){return P.substring(0,s.offset)+s.content+P.substring(s.offset+s.length)}e.applyEdit=k;function D(P,s){let C=s.slice(0).sort((h,a)=>{const u=h.offset-a.offset;return u===0?h.length-a.length:u}),f=P.length;for(let h=C.length-1;h>=0;h--){let a=C[h];if(a.offset+a.length<=f)P=k(P,a);else throw new Error("Overlapping edit");f=a.offset}return P}e.applyEdits=D}),define(me[134],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new b(()=>T(this.getValue()))}}e.Lazy=b}),define(me[6],ge([0,1,70,54]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let A=null;function y(g){A=g}if(e.setDisposableTracker=y,T){const g="__is_disposable_tracked__";A=new class{trackDisposable(l){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[g]||console.log(d)},3e3)}markTracked(l){if(l&&l!==u.None)try{l[g]=!0}catch(d){}}}}function k(g){!A||A.markTracked(g)}function D(g){return A&&A.trackDisposable(g),g}e.trackDisposable=D;class P extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=P;function s(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.isDisposable=s;function C(g){if(I.Iterable.is(g)){let l=[];for(const d of g)if(d){k(d);try{d.dispose()}catch(n){l.push(n)}}if(l.length===1)throw l[0];if(l.length>1)throw new P(l);return Array.isArray(g)?[]:g}else if(g)return k(g),g.dispose(),g}e.dispose=C;function f(...g){return g.forEach(k),h(()=>C(g))}e.combinedDisposable=f;function h(g){const l=D({dispose:()=>{k(l),g()}});return l}e.toDisposable=h;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(k(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return k(l),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new a,D(this)}dispose(){k(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var d;this._isDisposed||l===this._value||((d=this._value)===null||d===void 0||d.dispose(),l&&k(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,k(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=E;class v{constructor(){this.references=new Map}acquire(l,...d){let n=this.references.get(l);n||(n={counter:0,object:this.createReferencedObject(l,...d)},this.references.set(l,n));const{object:t}=n,r=(0,b.once)(()=>{--n.counter==0&&(this.destroyReferencedObject(l,n.object),this.references.delete(l))});return n.counter++,{object:t,dispose:r}}}e.ReferenceCollection=v;class _{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=_}),define(me[56],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(A){this.element=A,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class I{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,y){const k=new b(A);if(this._first===b.Undefined)this._first=k,this._last=k;else if(y){const P=this._last;this._last=k,k.prev=P,P.next=k}else{const P=this._first;this._first=k,k.next=P,P.prev=k}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(k))}}shift(){if(this._first!==b.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==b.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==b.Undefined&&A.next!==b.Undefined){const y=A.prev;y.next=A.next,A.next.prev=y}else A.prev===b.Undefined&&A.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):A.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):A.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==b.Undefined;)yield A.element,A=A.next}}e.LinkedList=I}),function(G,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(G=typeof globalThis!="undefined"?globalThis:G||self,G.marked=e())}(this,function(){"use strict";function G(K,se){for(var fe=0;fe<se.length;fe++){var Z=se[fe];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(K,Z.key,Z)}}function e(K,se,fe){return se&&G(K.prototype,se),fe&&G(K,fe),K}function b(K,se){if(!!K){if(typeof K=="string")return I(K,se);var fe=Object.prototype.toString.call(K).slice(8,-1);if(fe==="Object"&&K.constructor&&(fe=K.constructor.name),fe==="Map"||fe==="Set")return Array.from(K);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return I(K,se)}}function I(K,se){(se==null||se>K.length)&&(se=K.length);for(var fe=0,Z=new Array(se);fe<se;fe++)Z[fe]=K[fe];return Z}function T(K,se){var fe;if(typeof Symbol=="undefined"||K[Symbol.iterator]==null){if(Array.isArray(K)||(fe=b(K))||se&&K&&typeof K.length=="number"){fe&&(K=fe);var Z=0;return function(){return Z>=K.length?{done:!0}:{done:!1,value:K[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return fe=K[Symbol.iterator](),fe.next.bind(fe)}function A(K){var se={exports:{}};return K(se,se.exports),se.exports}var y=A(function(K){function se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function fe(Z){K.exports.defaults=Z}K.exports={defaults:se(),getDefaults:se,changeDefaults:fe}}),k=/[&<>"']/,D=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,s=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(se){return C[se]};function h(K,se){if(se){if(k.test(K))return K.replace(D,f)}else if(P.test(K))return K.replace(s,f);return K}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(K){return K.replace(a,function(se,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var E=/(^|[^\[])\^/g;function v(K,se){K=K.source||K,se=se||"";var fe={replace:function(ne,ce){return ce=ce.source||ce,ce=ce.replace(E,"$1"),K=K.replace(ne,ce),fe},getRegex:function(){return new RegExp(K,se)}};return fe}var _=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(K,se,fe){if(K){var Z;try{Z=decodeURIComponent(u(fe)).replace(_,"").toLowerCase()}catch(ne){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}se&&!g.test(fe)&&(fe=i(se,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch(ne){return null}return fe}var d={},n=/^[^:]+:\/*[^/]*$/,t=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(K,se){d[" "+K]||(n.test(K)?d[" "+K]=K+"/":d[" "+K]=S(K,"/",!0)),K=d[" "+K];var fe=K.indexOf(":")===-1;return se.substring(0,2)==="//"?fe?se:K.replace(t,"$1")+se:se.charAt(0)==="/"?fe?se:K.replace(r,"$1")+se:K+se}var o={exec:function(){}};function c(K){for(var se=1,fe,Z;se<arguments.length;se++){fe=arguments[se];for(Z in fe)Object.prototype.hasOwnProperty.call(fe,Z)&&(K[Z]=fe[Z])}return K}function m(K,se){var fe=K.replace(/\|/g,function(ce,pe,Se){for(var qe=!1,Me=pe;--Me>=0&&Se[Me]==="\\";)qe=!qe;return qe?"|":" |"}),Z=fe.split(/ \|/),ne=0;if(Z.length>se)Z.splice(se);else for(;Z.length<se;)Z.push("");for(;ne<Z.length;ne++)Z[ne]=Z[ne].trim().replace(/\\\|/g,"|");return Z}function S(K,se,fe){var Z=K.length;if(Z===0)return"";for(var ne=0;ne<Z;){var ce=K.charAt(Z-ne-1);if(ce===se&&!fe)ne++;else if(ce!==se&&fe)ne++;else break}return K.substr(0,Z-ne)}function p(K,se){if(K.indexOf(se[1])===-1)return-1;for(var fe=K.length,Z=0,ne=0;ne<fe;ne++)if(K[ne]==="\\")ne++;else if(K[ne]===se[0])Z++;else if(K[ne]===se[1]&&(Z--,Z<0))return ne;return-1}function w(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(K,se){if(se<1)return"";for(var fe="";se>1;)se&1&&(fe+=K),se>>=1,K+=K;return fe+K}var F={escape:h,unescape:u,edit:v,cleanUrl:l,resolveUrl:i,noopTest:o,merge:c,splitCells:m,rtrim:S,findClosingBracket:p,checkSanitizeDeprecation:w,repeatString:R},z=y.defaults,oe=F.rtrim,j=F.splitCells,W=F.escape,$=F.findClosingBracket;function U(K,se,fe){var Z=se.href,ne=se.title?W(se.title):null,ce=K[1].replace(/\\([\[\]])/g,"$1");return K[0].charAt(0)!=="!"?{type:"link",raw:fe,href:Z,title:ne,text:ce}:{type:"image",raw:fe,href:Z,title:ne,text:W(ce)}}function M(K,se){var fe=K.match(/^(\s+)(?:```)/);if(fe===null)return se;var Z=fe[1];return se.split(`
`).map(function(ne){var ce=ne.match(/^\s+/);if(ce===null)return ne;var pe=ce[0];return pe.length>=Z.length?ne.slice(Z.length):ne}).join(`
`)}var L=function(){function K(fe){this.options=fe||z}var se=K.prototype;return se.space=function(Z){var ne=this.rules.block.newline.exec(Z);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},se.code=function(Z){var ne=this.rules.block.code.exec(Z);if(ne){var ce=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:oe(ce,`
`)}}},se.fences=function(Z){var ne=this.rules.block.fences.exec(Z);if(ne){var ce=ne[0],pe=M(ce,ne[3]||"");return{type:"code",raw:ce,lang:ne[2]?ne[2].trim():ne[2],text:pe}}},se.heading=function(Z){var ne=this.rules.block.heading.exec(Z);if(ne){var ce=ne[2].trim();if(/#$/.test(ce)){var pe=oe(ce,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(ce=pe.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:ce}}},se.nptable=function(Z){var ne=this.rules.block.nptable.exec(Z);if(ne){var ce={type:"table",header:j(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[],raw:ne[0]};if(ce.header.length===ce.align.length){var pe=ce.align.length,Se;for(Se=0;Se<pe;Se++)/^ *-+: *$/.test(ce.align[Se])?ce.align[Se]="right":/^ *:-+: *$/.test(ce.align[Se])?ce.align[Se]="center":/^ *:-+ *$/.test(ce.align[Se])?ce.align[Se]="left":ce.align[Se]=null;for(pe=ce.cells.length,Se=0;Se<pe;Se++)ce.cells[Se]=j(ce.cells[Se],ce.header.length);return ce}}},se.hr=function(Z){var ne=this.rules.block.hr.exec(Z);if(ne)return{type:"hr",raw:ne[0]}},se.blockquote=function(Z){var ne=this.rules.block.blockquote.exec(Z);if(ne){var ce=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],text:ce}}},se.list=function(Z){var ne=this.rules.block.list.exec(Z);if(ne){var ce=ne[0],pe=ne[2],Se=pe.length>1,qe={type:"list",raw:ce,ordered:Se,start:Se?+pe.slice(0,-1):"",loose:!1,items:[]},Me=ne[0].match(this.rules.block.item),He=!1,Qe,it,lt,Ze,nt,ht,_t,ue,De=Me.length;lt=this.rules.block.listItemStart.exec(Me[0]);for(var le=0;le<De;le++){if(Qe=Me[le],ce=Qe,le!==De-1){if(Ze=this.rules.block.listItemStart.exec(Me[le+1]),this.options.pedantic?Ze[1].length>lt[1].length:Ze[1].length>lt[0].length||Ze[1].length>3){Me.splice(le,2,Me[le]+`
`+Me[le+1]),le--,De--;continue}else(!this.options.pedantic||this.options.smartLists?Ze[2][Ze[2].length-1]!==pe[pe.length-1]:Se===(Ze[2].length===1))&&(nt=Me.slice(le+1).join(`
`),qe.raw=qe.raw.substring(0,qe.raw.length-nt.length),le=De-1);lt=Ze}it=Qe.length,Qe=Qe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Qe.indexOf(`
 `)&&(it-=Qe.length,Qe=this.options.pedantic?Qe.replace(/^ {1,4}/gm,""):Qe.replace(new RegExp("^ {1,"+it+"}","gm"),"")),ht=He||/\n\n(?!\s*$)/.test(Qe),le!==De-1&&(He=Qe.charAt(Qe.length-1)===`
`,ht||(ht=He)),ht&&(qe.loose=!0),this.options.gfm&&(_t=/^\[[ xX]\] /.test(Qe),ue=void 0,_t&&(ue=Qe[1]!==" ",Qe=Qe.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:ce,task:_t,checked:ue,loose:ht,text:Qe})}return qe}},se.html=function(Z){var ne=this.rules.block.html.exec(Z);if(ne)return{type:this.options.sanitize?"paragraph":"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):W(ne[0]):ne[0]}},se.def=function(Z){var ne=this.rules.block.def.exec(Z);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var ce=ne[1].toLowerCase().replace(/\s+/g," ");return{tag:ce,raw:ne[0],href:ne[2],title:ne[3]}}},se.table=function(Z){var ne=this.rules.block.table.exec(Z);if(ne){var ce={type:"table",header:j(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(ce.header.length===ce.align.length){ce.raw=ne[0];var pe=ce.align.length,Se;for(Se=0;Se<pe;Se++)/^ *-+: *$/.test(ce.align[Se])?ce.align[Se]="right":/^ *:-+: *$/.test(ce.align[Se])?ce.align[Se]="center":/^ *:-+ *$/.test(ce.align[Se])?ce.align[Se]="left":ce.align[Se]=null;for(pe=ce.cells.length,Se=0;Se<pe;Se++)ce.cells[Se]=j(ce.cells[Se].replace(/^ *\| *| *\| *$/g,""),ce.header.length);return ce}}},se.lheading=function(Z){var ne=this.rules.block.lheading.exec(Z);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1]}},se.paragraph=function(Z){var ne=this.rules.block.paragraph.exec(Z);if(ne)return{type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1]}},se.text=function(Z){var ne=this.rules.block.text.exec(Z);if(ne)return{type:"text",raw:ne[0],text:ne[0]}},se.escape=function(Z){var ne=this.rules.inline.escape.exec(Z);if(ne)return{type:"escape",raw:ne[0],text:W(ne[1])}},se.tag=function(Z,ne,ce){var pe=this.rules.inline.tag.exec(Z);if(pe)return!ne&&/^<a /i.test(pe[0])?ne=!0:ne&&/^<\/a>/i.test(pe[0])&&(ne=!1),!ce&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?ce=!0:ce&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(ce=!1),{type:this.options.sanitize?"text":"html",raw:pe[0],inLink:ne,inRawBlock:ce,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):W(pe[0]):pe[0]}},se.link=function(Z){var ne=this.rules.inline.link.exec(Z);if(ne){var ce=ne[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;var pe=oe(ce.slice(0,-1),"\\");if((ce.length-pe.length)%2==0)return}else{var Se=$(ne[2],"()");if(Se>-1){var qe=ne[0].indexOf("!")===0?5:4,Me=qe+ne[1].length+Se;ne[2]=ne[2].substring(0,Se),ne[0]=ne[0].substring(0,Me).trim(),ne[3]=""}}var He=ne[2],Qe="";if(this.options.pedantic){var it=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(He);it&&(He=it[1],Qe=it[3])}else Qe=ne[3]?ne[3].slice(1,-1):"";return He=He.trim(),/^</.test(He)&&(this.options.pedantic&&!/>$/.test(ce)?He=He.slice(1):He=He.slice(1,-1)),U(ne,{href:He&&He.replace(this.rules.inline._escapes,"$1"),title:Qe&&Qe.replace(this.rules.inline._escapes,"$1")},ne[0])}},se.reflink=function(Z,ne){var ce;if((ce=this.rules.inline.reflink.exec(Z))||(ce=this.rules.inline.nolink.exec(Z))){var pe=(ce[2]||ce[1]).replace(/\s+/g," ");if(pe=ne[pe.toLowerCase()],!pe||!pe.href){var Se=ce[0].charAt(0);return{type:"text",raw:Se,text:Se}}return U(ce,pe,ce[0])}},se.emStrong=function(Z,ne,ce){ce===void 0&&(ce="");var pe=this.rules.inline.emStrong.lDelim.exec(Z);if(!!pe&&!(pe[3]&&ce.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Se=pe[1]||pe[2]||"";if(!Se||Se&&(ce===""||this.rules.inline.punctuation.exec(ce))){var qe=pe[0].length-1,Me,He,Qe=qe,it=0,lt=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(lt.lastIndex=0,ne=ne.slice(-1*Z.length+qe);(pe=lt.exec(ne))!=null;)if(Me=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Me){if(He=Me.length,pe[3]||pe[4]){Qe+=He;continue}else if((pe[5]||pe[6])&&qe%3&&!((qe+He)%3)){it+=He;continue}if(Qe-=He,!(Qe>0)){if(Qe+it-He<=0&&!ne.slice(lt.lastIndex).match(lt)&&(He=Math.min(He,He+Qe+it)),Math.min(qe,He)%2)return{type:"em",raw:Z.slice(0,qe+pe.index+He+1),text:Z.slice(1,qe+pe.index+He)};if(Math.min(qe,He)%2==0)return{type:"strong",raw:Z.slice(0,qe+pe.index+He+1),text:Z.slice(2,qe+pe.index+He-1)}}}}}},se.codespan=function(Z){var ne=this.rules.inline.code.exec(Z);if(ne){var ce=ne[2].replace(/\n/g," "),pe=/[^ ]/.test(ce),Se=/^ /.test(ce)&&/ $/.test(ce);return pe&&Se&&(ce=ce.substring(1,ce.length-1)),ce=W(ce,!0),{type:"codespan",raw:ne[0],text:ce}}},se.br=function(Z){var ne=this.rules.inline.br.exec(Z);if(ne)return{type:"br",raw:ne[0]}},se.del=function(Z){var ne=this.rules.inline.del.exec(Z);if(ne)return{type:"del",raw:ne[0],text:ne[2]}},se.autolink=function(Z,ne){var ce=this.rules.inline.autolink.exec(Z);if(ce){var pe,Se;return ce[2]==="@"?(pe=W(this.options.mangle?ne(ce[1]):ce[1]),Se="mailto:"+pe):(pe=W(ce[1]),Se=pe),{type:"link",raw:ce[0],text:pe,href:Se,tokens:[{type:"text",raw:pe,text:pe}]}}},se.url=function(Z,ne){var ce;if(ce=this.rules.inline.url.exec(Z)){var pe,Se;if(ce[2]==="@")pe=W(this.options.mangle?ne(ce[0]):ce[0]),Se="mailto:"+pe;else{var qe;do qe=ce[0],ce[0]=this.rules.inline._backpedal.exec(ce[0])[0];while(qe!==ce[0]);pe=W(ce[0]),ce[1]==="www."?Se="http://"+pe:Se=pe}return{type:"link",raw:ce[0],text:pe,href:Se,tokens:[{type:"text",raw:pe,text:pe}]}}},se.inlineText=function(Z,ne,ce){var pe=this.rules.inline.text.exec(Z);if(pe){var Se;return ne?Se=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):W(pe[0]):pe[0]:Se=W(this.options.smartypants?ce(pe[0]):pe[0]),{type:"text",raw:pe[0],text:Se}}},K}(),N=F.noopTest,O=F.edit,B=F.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=O(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=O(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=O(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=O(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=O(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=O(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=O(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=B({},q),q.gfm=B({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=O(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=O(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=B({},q.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:O(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=O(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=O(q._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=O(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=O(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=O(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=O(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=O(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=O(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=O(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=O(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=B({},Q),Q.pedantic=B({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=B({},Q.normal,{escape:O(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=O(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=B({},Q.gfm,{br:O(Q.br).replace("{2,}","*").getRegex(),text:O(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var he={block:q,inline:Q},ve=y.defaults,Ie=he.block,ke=he.inline,Le=F.repeatString;function V(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(K){var se="",fe,Z,ne=K.length;for(fe=0;fe<ne;fe++)Z=K.charCodeAt(fe),Math.random()>.5&&(Z="x"+Z.toString(16)),se+="&#"+Z+";";return se}var ee=function(){function K(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ve,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var Z={block:Ie.normal,inline:ke.normal};this.options.pedantic?(Z.block=Ie.pedantic,Z.inline=ke.pedantic):this.options.gfm&&(Z.block=Ie.gfm,this.options.breaks?Z.inline=ke.breaks:Z.inline=ke.gfm),this.tokenizer.rules=Z}K.lex=function(Z,ne){var ce=new K(ne);return ce.lex(Z)},K.lexInline=function(Z,ne){var ce=new K(ne);return ce.inlineTokens(Z)};var se=K.prototype;return se.lex=function(Z){return Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens,!0),this.inline(this.tokens),this.tokens},se.blockTokens=function(Z,ne,ce){ne===void 0&&(ne=[]),ce===void 0&&(ce=!0),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var pe,Se,qe,Me;Z;){if(pe=this.tokenizer.space(Z)){Z=Z.substring(pe.raw.length),pe.type&&ne.push(pe);continue}if(pe=this.tokenizer.code(Z)){Z=Z.substring(pe.raw.length),Me=ne[ne.length-1],Me&&Me.type==="paragraph"?(Me.raw+=`
`+pe.raw,Me.text+=`
`+pe.text):ne.push(pe);continue}if(pe=this.tokenizer.fences(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.heading(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.nptable(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.hr(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.blockquote(Z)){Z=Z.substring(pe.raw.length),pe.tokens=this.blockTokens(pe.text,[],ce),ne.push(pe);continue}if(pe=this.tokenizer.list(Z)){for(Z=Z.substring(pe.raw.length),qe=pe.items.length,Se=0;Se<qe;Se++)pe.items[Se].tokens=this.blockTokens(pe.items[Se].text,[],!1);ne.push(pe);continue}if(pe=this.tokenizer.html(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(ce&&(pe=this.tokenizer.def(Z))){Z=Z.substring(pe.raw.length),this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.lheading(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(ce&&(pe=this.tokenizer.paragraph(Z))){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.text(Z)){Z=Z.substring(pe.raw.length),Me=ne[ne.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+pe.raw,Me.text+=`
`+pe.text):ne.push(pe);continue}if(Z){var He="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(He);break}else throw new Error(He)}}return ne},se.inline=function(Z){var ne,ce,pe,Se,qe,Me,He=Z.length;for(ne=0;ne<He;ne++)switch(Me=Z[ne],Me.type){case"paragraph":case"text":case"heading":{Me.tokens=[],this.inlineTokens(Me.text,Me.tokens);break}case"table":{for(Me.tokens={header:[],cells:[]},Se=Me.header.length,ce=0;ce<Se;ce++)Me.tokens.header[ce]=[],this.inlineTokens(Me.header[ce],Me.tokens.header[ce]);for(Se=Me.cells.length,ce=0;ce<Se;ce++)for(qe=Me.cells[ce],Me.tokens.cells[ce]=[],pe=0;pe<qe.length;pe++)Me.tokens.cells[ce][pe]=[],this.inlineTokens(qe[pe],Me.tokens.cells[ce][pe]);break}case"blockquote":{this.inline(Me.tokens);break}case"list":{for(Se=Me.items.length,ce=0;ce<Se;ce++)this.inline(Me.items[ce].tokens);break}}return Z},se.inlineTokens=function(Z,ne,ce,pe){ne===void 0&&(ne=[]),ce===void 0&&(ce=!1),pe===void 0&&(pe=!1);var Se,qe,Me=Z,He,Qe,it;if(this.tokens.links){var lt=Object.keys(this.tokens.links);if(lt.length>0)for(;(He=this.tokenizer.rules.inline.reflinkSearch.exec(Me))!=null;)lt.includes(He[0].slice(He[0].lastIndexOf("[")+1,-1))&&(Me=Me.slice(0,He.index)+"["+Le("a",He[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(He=this.tokenizer.rules.inline.blockSkip.exec(Me))!=null;)Me=Me.slice(0,He.index)+"["+Le("a",He[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(He=this.tokenizer.rules.inline.escapedEmSt.exec(Me))!=null;)Me=Me.slice(0,He.index)+"++"+Me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;){if(Qe||(it=""),Qe=!1,Se=this.tokenizer.escape(Z)){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(Se=this.tokenizer.tag(Z,ce,pe)){Z=Z.substring(Se.raw.length),ce=Se.inLink,pe=Se.inRawBlock;var Ze=ne[ne.length-1];Ze&&Se.type==="text"&&Ze.type==="text"?(Ze.raw+=Se.raw,Ze.text+=Se.text):ne.push(Se);continue}if(Se=this.tokenizer.link(Z)){Z=Z.substring(Se.raw.length),Se.type==="link"&&(Se.tokens=this.inlineTokens(Se.text,[],!0,pe)),ne.push(Se);continue}if(Se=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(Se.raw.length);var nt=ne[ne.length-1];Se.type==="link"?(Se.tokens=this.inlineTokens(Se.text,[],!0,pe),ne.push(Se)):nt&&Se.type==="text"&&nt.type==="text"?(nt.raw+=Se.raw,nt.text+=Se.text):ne.push(Se);continue}if(Se=this.tokenizer.emStrong(Z,Me,it)){Z=Z.substring(Se.raw.length),Se.tokens=this.inlineTokens(Se.text,[],ce,pe),ne.push(Se);continue}if(Se=this.tokenizer.codespan(Z)){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(Se=this.tokenizer.br(Z)){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(Se=this.tokenizer.del(Z)){Z=Z.substring(Se.raw.length),Se.tokens=this.inlineTokens(Se.text,[],ce,pe),ne.push(Se);continue}if(Se=this.tokenizer.autolink(Z,J)){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(!ce&&(Se=this.tokenizer.url(Z,J))){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(Se=this.tokenizer.inlineText(Z,pe,V)){Z=Z.substring(Se.raw.length),Se.raw.slice(-1)!=="_"&&(it=Se.raw.slice(-1)),Qe=!0,qe=ne[ne.length-1],qe&&qe.type==="text"?(qe.raw+=Se.raw,qe.text+=Se.text):ne.push(Se);continue}if(Z){var ht="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(ht);break}else throw new Error(ht)}}return ne},e(K,null,[{key:"rules",get:function(){return{block:Ie,inline:ke}}}]),K}(),ae=y.defaults,we=F.cleanUrl,Ce=F.escape,Oe=function(){function K(fe){this.options=fe||ae}var se=K.prototype;return se.code=function(Z,ne,ce){var pe=(ne||"").match(/\S*/)[0];if(this.options.highlight){var Se=this.options.highlight(Z,pe);Se!=null&&Se!==Z&&(ce=!0,Z=Se)}return Z=Z.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+Ce(pe,!0)+'">'+(ce?Z:Ce(Z,!0))+`</code></pre>
`:"<pre><code>"+(ce?Z:Ce(Z,!0))+`</code></pre>
`},se.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},se.html=function(Z){return Z},se.heading=function(Z,ne,ce,pe){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+pe.slug(ce)+'">'+Z+"</h"+ne+`>
`:"<h"+ne+">"+Z+"</h"+ne+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(Z,ne,ce){var pe=ne?"ol":"ul",Se=ne&&ce!==1?' start="'+ce+'"':"";return"<"+pe+Se+`>
`+Z+"</"+pe+`>
`},se.listitem=function(Z){return"<li>"+Z+`</li>
`},se.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(Z){return"<p>"+Z+`</p>
`},se.table=function(Z,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ne+`</table>
`},se.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},se.tablecell=function(Z,ne){var ce=ne.header?"th":"td",pe=ne.align?"<"+ce+' align="'+ne.align+'">':"<"+ce+">";return pe+Z+"</"+ce+`>
`},se.strong=function(Z){return"<strong>"+Z+"</strong>"},se.em=function(Z){return"<em>"+Z+"</em>"},se.codespan=function(Z){return"<code>"+Z+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(Z){return"<del>"+Z+"</del>"},se.link=function(Z,ne,ce){if(Z=we(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ce;var pe='<a href="'+Ce(Z)+'"';return ne&&(pe+=' title="'+ne+'"'),pe+=">"+ce+"</a>",pe},se.image=function(Z,ne,ce){if(Z=we(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ce;var pe='<img src="'+Z+'" alt="'+ce+'"';return ne&&(pe+=' title="'+ne+'"'),pe+=this.options.xhtml?"/>":">",pe},se.text=function(Z){return Z},K}(),be=function(){function K(){}var se=K.prototype;return se.strong=function(Z){return Z},se.em=function(Z){return Z},se.codespan=function(Z){return Z},se.del=function(Z){return Z},se.html=function(Z){return Z},se.text=function(Z){return Z},se.link=function(Z,ne,ce){return""+ce},se.image=function(Z,ne,ce){return""+ce},se.br=function(){return""},K}(),Pe=function(){function K(){this.seen={}}var se=K.prototype;return se.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(Z,ne){var ce=Z,pe=0;if(this.seen.hasOwnProperty(ce)){pe=this.seen[Z];do pe++,ce=Z+"-"+pe;while(this.seen.hasOwnProperty(ce))}return ne||(this.seen[Z]=pe,this.seen[ce]=0),ce},se.slug=function(Z,ne){ne===void 0&&(ne={});var ce=this.serialize(Z);return this.getNextSafeSlug(ce,ne.dryrun)},K}(),Re=y.defaults,We=F.unescape,Ee=function(){function K(fe){this.options=fe||Re,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new Pe}K.parse=function(Z,ne){var ce=new K(ne);return ce.parse(Z)},K.parseInline=function(Z,ne){var ce=new K(ne);return ce.parseInline(Z)};var se=K.prototype;return se.parse=function(Z,ne){ne===void 0&&(ne=!0);var ce="",pe,Se,qe,Me,He,Qe,it,lt,Ze,nt,ht,_t,ue,De,le,Y,Ne,Te,Je=Z.length;for(pe=0;pe<Je;pe++)switch(nt=Z[pe],nt.type){case"space":continue;case"hr":{ce+=this.renderer.hr();continue}case"heading":{ce+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,We(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{ce+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(lt="",it="",Me=nt.header.length,Se=0;Se<Me;Se++)it+=this.renderer.tablecell(this.parseInline(nt.tokens.header[Se]),{header:!0,align:nt.align[Se]});for(lt+=this.renderer.tablerow(it),Ze="",Me=nt.cells.length,Se=0;Se<Me;Se++){for(Qe=nt.tokens.cells[Se],it="",He=Qe.length,qe=0;qe<He;qe++)it+=this.renderer.tablecell(this.parseInline(Qe[qe]),{header:!1,align:nt.align[qe]});Ze+=this.renderer.tablerow(it)}ce+=this.renderer.table(lt,Ze);continue}case"blockquote":{Ze=this.parse(nt.tokens),ce+=this.renderer.blockquote(Ze);continue}case"list":{for(ht=nt.ordered,_t=nt.start,ue=nt.loose,Me=nt.items.length,Ze="",Se=0;Se<Me;Se++)le=nt.items[Se],Y=le.checked,Ne=le.task,De="",le.task&&(Te=this.renderer.checkbox(Y),ue?le.tokens.length>0&&le.tokens[0].type==="text"?(le.tokens[0].text=Te+" "+le.tokens[0].text,le.tokens[0].tokens&&le.tokens[0].tokens.length>0&&le.tokens[0].tokens[0].type==="text"&&(le.tokens[0].tokens[0].text=Te+" "+le.tokens[0].tokens[0].text)):le.tokens.unshift({type:"text",text:Te}):De+=Te),De+=this.parse(le.tokens,ue),Ze+=this.renderer.listitem(De,Ne,Y);ce+=this.renderer.list(Ze,ht,_t);continue}case"html":{ce+=this.renderer.html(nt.text);continue}case"paragraph":{ce+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(Ze=nt.tokens?this.parseInline(nt.tokens):nt.text;pe+1<Je&&Z[pe+1].type==="text";)nt=Z[++pe],Ze+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);ce+=ne?this.renderer.paragraph(Ze):Ze;continue}default:{var et='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return ce},se.parseInline=function(Z,ne){ne=ne||this.renderer;var ce="",pe,Se,qe=Z.length;for(pe=0;pe<qe;pe++)switch(Se=Z[pe],Se.type){case"escape":{ce+=ne.text(Se.text);break}case"html":{ce+=ne.html(Se.text);break}case"link":{ce+=ne.link(Se.href,Se.title,this.parseInline(Se.tokens,ne));break}case"image":{ce+=ne.image(Se.href,Se.title,Se.text);break}case"strong":{ce+=ne.strong(this.parseInline(Se.tokens,ne));break}case"em":{ce+=ne.em(this.parseInline(Se.tokens,ne));break}case"codespan":{ce+=ne.codespan(Se.text);break}case"br":{ce+=ne.br();break}case"del":{ce+=ne.del(this.parseInline(Se.tokens,ne));break}case"text":{ce+=ne.text(Se.text);break}default:{var Me='Token with "'+Se.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}return ce},K}(),Ke=F.merge,X=F.checkSanitizeDeprecation,ie=F.escape,_e=y.getDefaults,xe=y.changeDefaults,ze=y.defaults;function $e(K,se,fe){if(typeof K=="undefined"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof se=="function"&&(fe=se,se=null),se=Ke({},$e.defaults,se||{}),X(se),fe){var Z=se.highlight,ne;try{ne=ee.lex(K,se)}catch(qe){return fe(qe)}var ce=function(Me){var He;if(!Me)try{He=Ee.parse(ne,se)}catch(Qe){Me=Qe}return se.highlight=Z,Me?fe(Me):fe(null,He)};if(!Z||Z.length<3||(delete se.highlight,!ne.length))return ce();var pe=0;$e.walkTokens(ne,function(qe){qe.type==="code"&&(pe++,setTimeout(function(){Z(qe.text,qe.lang,function(Me,He){if(Me)return ce(Me);He!=null&&He!==qe.text&&(qe.text=He,qe.escaped=!0),pe--,pe===0&&ce()})},0))}),pe===0&&ce();return}try{var Se=ee.lex(K,se);return se.walkTokens&&$e.walkTokens(Se,se.walkTokens),Ee.parse(Se,se)}catch(qe){if(qe.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+ie(qe.message+"",!0)+"</pre>";throw qe}}$e.options=$e.setOptions=function(K){return Ke($e.defaults,K),xe($e.defaults),$e},$e.getDefaults=_e,$e.defaults=ze,$e.use=function(K){var se=Ke({},K);if(K.renderer&&function(){var Z=$e.defaults.renderer||new Oe,ne=function(Se){var qe=Z[Se];Z[Se]=function(){for(var Me=arguments.length,He=new Array(Me),Qe=0;Qe<Me;Qe++)He[Qe]=arguments[Qe];var it=K.renderer[Se].apply(Z,He);return it===!1&&(it=qe.apply(Z,He)),it}};for(var ce in K.renderer)ne(ce);se.renderer=Z}(),K.tokenizer&&function(){var Z=$e.defaults.tokenizer||new L,ne=function(Se){var qe=Z[Se];Z[Se]=function(){for(var Me=arguments.length,He=new Array(Me),Qe=0;Qe<Me;Qe++)He[Qe]=arguments[Qe];var it=K.tokenizer[Se].apply(Z,He);return it===!1&&(it=qe.apply(Z,He)),it}};for(var ce in K.tokenizer)ne(ce);se.tokenizer=Z}(),K.walkTokens){var fe=$e.defaults.walkTokens;se.walkTokens=function(Z){K.walkTokens(Z),fe&&fe(Z)}}$e.setOptions(se)},$e.walkTokens=function(K,se){for(var fe=T(K),Z;!(Z=fe()).done;){var ne=Z.value;switch(se(ne),ne.type){case"table":{for(var ce=T(ne.tokens.header),pe;!(pe=ce()).done;){var Se=pe.value;$e.walkTokens(Se,se)}for(var qe=T(ne.tokens.cells),Me;!(Me=qe()).done;)for(var He=Me.value,Qe=T(He),it;!(it=Qe()).done;){var lt=it.value;$e.walkTokens(lt,se)}break}case"list":{$e.walkTokens(ne.items,se);break}default:ne.tokens&&$e.walkTokens(ne.tokens,se)}}},$e.parseInline=function(K,se){if(typeof K=="undefined"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");se=Ke({},$e.defaults,se||{}),X(se);try{var fe=ee.lexInline(K,se);return se.walkTokens&&$e.walkTokens(fe,se.walkTokens),Ee.parseInline(fe,se)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+ie(Z.message+"",!0)+"</pre>";throw Z}},$e.Parser=Ee,$e.parser=Ee.parse,$e.Renderer=Oe,$e.TextRenderer=be,$e.Lexer=ee,$e.lexer=ee.lex,$e.Tokenizer=L,$e.Slugger=Pe,$e.parse=$e;var Ye=$e;return Ye}),define(me[72],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function b(y,k,D){return Math.min(Math.max(y,k),D)}e.clamp=b;function I(y,k){return(k+y%k)%k}e.rot=I;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class A{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function G(T){const A=[];typeof T=="number"&&A.push("code/timeOrigin",T);function y(D){A.push(D,Date.now())}function k(){const D=[];for(let P=0;P<A.length;P+=2)D.push({name:A[P],startTime:A[P+1]});return D}return{mark:y,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const y of performance.getEntriesByType("mark"))A.push({name:y.name,startTime:Math.round(T+y.startTime)});return A}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function b(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=b(I))})(),define(me[9],ge([0,1]),function(G,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let T=!1,A=!1,y=!1,k=!1,D=!1,P=!1,s=!1,C,f=I,h,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const E=typeof((b=u==null?void 0:u.versions)===null||b===void 0?void 0:b.electron)=="string"&&u.type==="renderer";if(e.isElectronSandboxed=E&&(u==null?void 0:u.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=u==null?void 0:u.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)a=navigator.userAgent,T=a.indexOf("Windows")>=0,A=a.indexOf("Macintosh")>=0,s=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=a.indexOf("Linux")>=0,P=!0,C=navigator.language,f=C;else if(typeof u=="object"){T=u.platform==="win32",A=u.platform==="darwin",y=u.platform==="linux",k=y&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,C=I,f=I;const i=u.env.VSCODE_NLS_CONFIG;if(i)try{const o=JSON.parse(i),c=o.availableLanguages["*"];C=o.locale,f=c||I,h=o._translationsConfigFile}catch(o){}D=!0}else console.error("Unable to resolve platform.");var v;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function _(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=_;let g=0;A?g=1:T?g=3:y&&(g=2),e.isWindows=T,e.isMacintosh=A,e.isLinux=y,e.isLinuxSnap=k,e.isNative=D,e.isWeb=P,e.isIOS=s,e.platform=g,e.userAgent=a,e.language=f;var l;(function(i){function o(){return e.language}i.value=o;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=c;function m(){return e.language==="en"}i.isDefault=m})(l=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let p=0,w=c.length;p<w;p++){const R=c[p];if(R.id===S.data.vscodeSetImmediateId){c.splice(p,1),R.callback();return}}});let m=0;return S=>{const p=++m;c.push({id:p,callback:S}),e.globals.postMessage({vscodeSetImmediateId:p},"*")}}if(typeof(u==null?void 0:u.nextTick)=="function")return u.nextTick.bind(u);const o=Promise.resolve();return c=>o.then(c)}();var d;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(d=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||s?2:T?1:3;let n=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,n=new Uint16Array(i.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=r}),define(me[36],ge([0,1,9]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof b.globals.vscode!="undefined"){const T=b.globals.vscode.process;I={get platform(){return T.platform},get env(){return T.env},cwd(){return T.cwd()},nextTick(A){return(0,b.setImmediate)(A)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(T){return process.nextTick(T)}}:I={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},nextTick(T){return(0,b.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(me[8],ge([0,1,36]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,T=97,A=90,y=122,k=46,D=47,P=92,s=58,C=63;class f extends Error{constructor(l,d,n){let t;typeof d=="string"&&d.indexOf("not ")===0?(t="must not be",d=d.replace(/^not /,"")):t="must be";const r=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${r} ${t} of type ${d}`;i+=`. Received type ${typeof n}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function h(g,l){if(typeof g!="string")throw new f(l,"string",g)}function a(g){return g===D||g===P}function u(g){return g===D}function E(g){return g>=I&&g<=A||g>=T&&g<=y}function v(g,l,d,n){let t="",r=0,i=-1,o=0,c=0;for(let m=0;m<=g.length;++m){if(m<g.length)c=g.charCodeAt(m);else{if(n(c))break;c=D}if(n(c)){if(!(i===m-1||o===1))if(o===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==k||t.charCodeAt(t.length-2)!==k){if(t.length>2){const S=t.lastIndexOf(d);S===-1?(t="",r=0):(t=t.slice(0,S),r=t.length-1-t.lastIndexOf(d)),i=m,o=0;continue}else if(t.length!==0){t="",r=0,i=m,o=0;continue}}l&&(t+=t.length>0?`${d}..`:"..",r=2)}else t.length>0?t+=`${d}${g.slice(i+1,m)}`:t=g.slice(i+1,m),r=m-i-1;i=m,o=0}else c===k&&o!==-1?++o:o=-1}return t}function _(g,l){if(l===null||typeof l!="object")throw new f("pathObject","Object",l);const d=l.dir||l.root,n=l.base||`${l.name||""}${l.ext||""}`;return d?d===l.root?`${d}${n}`:`${d}${g}${n}`:n}e.win32={resolve(...g){let l="",d="",n=!1;for(let t=g.length-1;t>=-1;t--){let r;if(t>=0){if(r=g[t],h(r,"path"),r.length===0)continue}else l.length===0?r=b.cwd():(r=b.env[`=${l}`]||b.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==l.toLowerCase()&&r.charCodeAt(2)===P)&&(r=`${l}\\`));const i=r.length;let o=0,c="",m=!1;const S=r.charCodeAt(0);if(i===1)a(S)&&(o=1,m=!0);else if(a(S))if(m=!0,a(r.charCodeAt(1))){let p=2,w=p;for(;p<i&&!a(r.charCodeAt(p));)p++;if(p<i&&p!==w){const R=r.slice(w,p);for(w=p;p<i&&a(r.charCodeAt(p));)p++;if(p<i&&p!==w){for(w=p;p<i&&!a(r.charCodeAt(p));)p++;(p===i||p!==w)&&(c=`\\\\${R}\\${r.slice(w,p)}`,o=p)}}}else o=1;else E(S)&&r.charCodeAt(1)===s&&(c=r.slice(0,2),o=2,i>2&&a(r.charCodeAt(2))&&(m=!0,o=3));if(c.length>0)if(l.length>0){if(c.toLowerCase()!==l.toLowerCase())continue}else l=c;if(n){if(l.length>0)break}else if(d=`${r.slice(o)}\\${d}`,n=m,m&&l.length>0)break}return d=v(d,!n,"\\",a),n?`${l}\\${d}`:`${l}${d}`||"."},normalize(g){h(g,"path");const l=g.length;if(l===0)return".";let d=0,n,t=!1;const r=g.charCodeAt(0);if(l===1)return u(r)?"\\":g;if(a(r))if(t=!0,a(g.charCodeAt(1))){let o=2,c=o;for(;o<l&&!a(g.charCodeAt(o));)o++;if(o<l&&o!==c){const m=g.slice(c,o);for(c=o;o<l&&a(g.charCodeAt(o));)o++;if(o<l&&o!==c){for(c=o;o<l&&!a(g.charCodeAt(o));)o++;if(o===l)return`\\\\${m}\\${g.slice(c)}\\`;o!==c&&(n=`\\\\${m}\\${g.slice(c,o)}`,d=o)}}}else d=1;else E(r)&&g.charCodeAt(1)===s&&(n=g.slice(0,2),d=2,l>2&&a(g.charCodeAt(2))&&(t=!0,d=3));let i=d<l?v(g.slice(d),!t,"\\",a):"";return i.length===0&&!t&&(i="."),i.length>0&&a(g.charCodeAt(l-1))&&(i+="\\"),n===void 0?t?`\\${i}`:i:t?`${n}\\${i}`:`${n}${i}`},isAbsolute(g){h(g,"path");const l=g.length;if(l===0)return!1;const d=g.charCodeAt(0);return a(d)||l>2&&E(d)&&g.charCodeAt(1)===s&&a(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let l,d;for(let r=0;r<g.length;++r){const i=g[r];h(i,"path"),i.length>0&&(l===void 0?l=d=i:l+=`\\${i}`)}if(l===void 0)return".";let n=!0,t=0;if(typeof d=="string"&&a(d.charCodeAt(0))){++t;const r=d.length;r>1&&a(d.charCodeAt(1))&&(++t,r>2&&(a(d.charCodeAt(2))?++t:n=!1))}if(n){for(;t<l.length&&a(l.charCodeAt(t));)t++;t>=2&&(l=`\\${l.slice(t)}`)}return e.win32.normalize(l)},relative(g,l){if(h(g,"from"),h(l,"to"),g===l)return"";const d=e.win32.resolve(g),n=e.win32.resolve(l);if(d===n||(g=d.toLowerCase(),l=n.toLowerCase(),g===l))return"";let t=0;for(;t<g.length&&g.charCodeAt(t)===P;)t++;let r=g.length;for(;r-1>t&&g.charCodeAt(r-1)===P;)r--;const i=r-t;let o=0;for(;o<l.length&&l.charCodeAt(o)===P;)o++;let c=l.length;for(;c-1>o&&l.charCodeAt(c-1)===P;)c--;const m=c-o,S=i<m?i:m;let p=-1,w=0;for(;w<S;w++){const F=g.charCodeAt(t+w);if(F!==l.charCodeAt(o+w))break;F===P&&(p=w)}if(w!==S){if(p===-1)return n}else{if(m>S){if(l.charCodeAt(o+w)===P)return n.slice(o+w+1);if(w===2)return n.slice(o+w)}i>S&&(g.charCodeAt(t+w)===P?p=w:w===2&&(p=3)),p===-1&&(p=0)}let R="";for(w=t+p+1;w<=r;++w)(w===r||g.charCodeAt(w)===P)&&(R+=R.length===0?"..":"\\..");return o+=p,R.length>0?`${R}${n.slice(o,c)}`:(n.charCodeAt(o)===P&&++o,n.slice(o,c))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const l=e.win32.resolve(g);if(l.length<=2)return g;if(l.charCodeAt(0)===P){if(l.charCodeAt(1)===P){const d=l.charCodeAt(2);if(d!==C&&d!==k)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(E(l.charCodeAt(0))&&l.charCodeAt(1)===s&&l.charCodeAt(2)===P)return`\\\\?\\${l}`;return g},dirname(g){h(g,"path");const l=g.length;if(l===0)return".";let d=-1,n=0;const t=g.charCodeAt(0);if(l===1)return a(t)?g:".";if(a(t)){if(d=n=1,a(g.charCodeAt(1))){let o=2,c=o;for(;o<l&&!a(g.charCodeAt(o));)o++;if(o<l&&o!==c){for(c=o;o<l&&a(g.charCodeAt(o));)o++;if(o<l&&o!==c){for(c=o;o<l&&!a(g.charCodeAt(o));)o++;if(o===l)return g;o!==c&&(d=n=o+1)}}}}else E(t)&&g.charCodeAt(1)===s&&(d=l>2&&a(g.charCodeAt(2))?3:2,n=d);let r=-1,i=!0;for(let o=l-1;o>=n;--o)if(a(g.charCodeAt(o))){if(!i){r=o;break}}else i=!1;if(r===-1){if(d===-1)return".";r=d}return g.slice(0,r)},basename(g,l){l!==void 0&&h(l,"ext"),h(g,"path");let d=0,n=-1,t=!0,r;if(g.length>=2&&E(g.charCodeAt(0))&&g.charCodeAt(1)===s&&(d=2),l!==void 0&&l.length>0&&l.length<=g.length){if(l===g)return"";let i=l.length-1,o=-1;for(r=g.length-1;r>=d;--r){const c=g.charCodeAt(r);if(a(c)){if(!t){d=r+1;break}}else o===-1&&(t=!1,o=r+1),i>=0&&(c===l.charCodeAt(i)?--i==-1&&(n=r):(i=-1,n=o))}return d===n?n=o:n===-1&&(n=g.length),g.slice(d,n)}for(r=g.length-1;r>=d;--r)if(a(g.charCodeAt(r))){if(!t){d=r+1;break}}else n===-1&&(t=!1,n=r+1);return n===-1?"":g.slice(d,n)},extname(g){h(g,"path");let l=0,d=-1,n=0,t=-1,r=!0,i=0;g.length>=2&&g.charCodeAt(1)===s&&E(g.charCodeAt(0))&&(l=n=2);for(let o=g.length-1;o>=l;--o){const c=g.charCodeAt(o);if(a(c)){if(!r){n=o+1;break}continue}t===-1&&(r=!1,t=o+1),c===k?d===-1?d=o:i!==1&&(i=1):d!==-1&&(i=-1)}return d===-1||t===-1||i===0||i===1&&d===t-1&&d===n+1?"":g.slice(d,t)},format:_.bind(null,"\\"),parse(g){h(g,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return l;const d=g.length;let n=0,t=g.charCodeAt(0);if(d===1)return a(t)?(l.root=l.dir=g,l):(l.base=l.name=g,l);if(a(t)){if(n=1,a(g.charCodeAt(1))){let p=2,w=p;for(;p<d&&!a(g.charCodeAt(p));)p++;if(p<d&&p!==w){for(w=p;p<d&&a(g.charCodeAt(p));)p++;if(p<d&&p!==w){for(w=p;p<d&&!a(g.charCodeAt(p));)p++;p===d?n=p:p!==w&&(n=p+1)}}}}else if(E(t)&&g.charCodeAt(1)===s){if(d<=2)return l.root=l.dir=g,l;if(n=2,a(g.charCodeAt(2))){if(d===3)return l.root=l.dir=g,l;n=3}}n>0&&(l.root=g.slice(0,n));let r=-1,i=n,o=-1,c=!0,m=g.length-1,S=0;for(;m>=n;--m){if(t=g.charCodeAt(m),a(t)){if(!c){i=m+1;break}continue}o===-1&&(c=!1,o=m+1),t===k?r===-1?r=m:S!==1&&(S=1):r!==-1&&(S=-1)}return o!==-1&&(r===-1||S===0||S===1&&r===o-1&&r===i+1?l.base=l.name=g.slice(i,o):(l.name=g.slice(i,r),l.base=g.slice(i,o),l.ext=g.slice(r,o))),i>0&&i!==n?l.dir=g.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let l="",d=!1;for(let n=g.length-1;n>=-1&&!d;n--){const t=n>=0?g[n]:b.cwd();h(t,"path"),t.length!==0&&(l=`${t}/${l}`,d=t.charCodeAt(0)===D)}return l=v(l,!d,"/",u),d?`/${l}`:l.length>0?l:"."},normalize(g){if(h(g,"path"),g.length===0)return".";const l=g.charCodeAt(0)===D,d=g.charCodeAt(g.length-1)===D;return g=v(g,!l,"/",u),g.length===0?l?"/":d?"./":".":(d&&(g+="/"),l?`/${g}`:g)},isAbsolute(g){return h(g,"path"),g.length>0&&g.charCodeAt(0)===D},join(...g){if(g.length===0)return".";let l;for(let d=0;d<g.length;++d){const n=g[d];h(n,"path"),n.length>0&&(l===void 0?l=n:l+=`/${n}`)}return l===void 0?".":e.posix.normalize(l)},relative(g,l){if(h(g,"from"),h(l,"to"),g===l||(g=e.posix.resolve(g),l=e.posix.resolve(l),g===l))return"";const d=1,n=g.length,t=n-d,r=1,i=l.length-r,o=t<i?t:i;let c=-1,m=0;for(;m<o;m++){const p=g.charCodeAt(d+m);if(p!==l.charCodeAt(r+m))break;p===D&&(c=m)}if(m===o)if(i>o){if(l.charCodeAt(r+m)===D)return l.slice(r+m+1);if(m===0)return l.slice(r+m)}else t>o&&(g.charCodeAt(d+m)===D?c=m:m===0&&(c=0));let S="";for(m=d+c+1;m<=n;++m)(m===n||g.charCodeAt(m)===D)&&(S+=S.length===0?"..":"/..");return`${S}${l.slice(r+c)}`},toNamespacedPath(g){return g},dirname(g){if(h(g,"path"),g.length===0)return".";const l=g.charCodeAt(0)===D;let d=-1,n=!0;for(let t=g.length-1;t>=1;--t)if(g.charCodeAt(t)===D){if(!n){d=t;break}}else n=!1;return d===-1?l?"/":".":l&&d===1?"//":g.slice(0,d)},basename(g,l){l!==void 0&&h(l,"ext"),h(g,"path");let d=0,n=-1,t=!0,r;if(l!==void 0&&l.length>0&&l.length<=g.length){if(l===g)return"";let i=l.length-1,o=-1;for(r=g.length-1;r>=0;--r){const c=g.charCodeAt(r);if(c===D){if(!t){d=r+1;break}}else o===-1&&(t=!1,o=r+1),i>=0&&(c===l.charCodeAt(i)?--i==-1&&(n=r):(i=-1,n=o))}return d===n?n=o:n===-1&&(n=g.length),g.slice(d,n)}for(r=g.length-1;r>=0;--r)if(g.charCodeAt(r)===D){if(!t){d=r+1;break}}else n===-1&&(t=!1,n=r+1);return n===-1?"":g.slice(d,n)},extname(g){h(g,"path");let l=-1,d=0,n=-1,t=!0,r=0;for(let i=g.length-1;i>=0;--i){const o=g.charCodeAt(i);if(o===D){if(!t){d=i+1;break}continue}n===-1&&(t=!1,n=i+1),o===k?l===-1?l=i:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||n===-1||r===0||r===1&&l===n-1&&l===d+1?"":g.slice(l,n)},format:_.bind(null,"/"),parse(g){h(g,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return l;const d=g.charCodeAt(0)===D;let n;d?(l.root="/",n=1):n=0;let t=-1,r=0,i=-1,o=!0,c=g.length-1,m=0;for(;c>=n;--c){const S=g.charCodeAt(c);if(S===D){if(!o){r=c+1;break}continue}i===-1&&(o=!1,i=c+1),S===k?t===-1?t=c:m!==1&&(m=1):t!==-1&&(m=-1)}if(i!==-1){const S=r===0&&d?1:r;t===-1||m===0||m===1&&t===i-1&&t===r+1?l.base=l.name=g.slice(S,i):(l.name=g.slice(S,t),l.base=g.slice(S,i),l.ext=g.slice(t,i))}return r>0?l.dir=g.slice(0,r-1):d&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[135],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var b;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(b=e.Source||(e.Source={}));var I;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(A,...y){const k=y.reduce((s,C)=>(s[C]=!0,s),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(s=>!k[s]).forEach(s=>{for(let C=0;C<D.length;C++)if(s.search(D[C])!==-1){delete A[s];break}})}e.sanitizeProcessEnvironment=T}),define(me[47],ge([0,1,9]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=b.globals.performance&&typeof b.globals.performance.now=="function";class T{constructor(y){this._highResolution=I&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new T(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=T}),define(me[3],ge([0,1,19,70,6,56,47]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(v){v.None=()=>T.Disposable.None;function _(j){return(W,$=null,U)=>{let M=!1,L;return L=j(N=>{if(!M)return L?L.dispose():M=!0,W.call($,N)},null,U),M&&L.dispose(),L}}v.once=_;function g(j,W){return i(($,U=null,M)=>j(L=>$.call(U,W(L)),null,M))}v.map=g;function l(j,W){return i(($,U=null,M)=>j(L=>{W(L),$.call(U,L)},null,M))}v.forEach=l;function d(j,W){return i(($,U=null,M)=>j(L=>W(L)&&$.call(U,L),null,M))}v.filter=d;function n(j){return j}v.signal=n;function t(...j){return(W,$=null,U)=>(0,T.combinedDisposable)(...j.map(M=>M(L=>W.call($,L),null,U)))}v.any=t;function r(j,W,$){let U=$;return g(j,M=>(U=W(U,M),U))}v.reduce=r;function i(j){let W;const $=new f({onFirstListenerAdd(){W=j($.fire,$)},onLastListenerRemove(){W.dispose()}});return $.event}v.snapshot=i;function o(j,W,$=100,U=!1,M){let L,N,O,B=0;const q=new f({leakWarningThreshold:M,onFirstListenerAdd(){L=j(Q=>{B++,N=W(N,Q),U&&!O&&(q.fire(N),N=void 0),clearTimeout(O),O=setTimeout(()=>{const he=N;N=void 0,O=void 0,(!U||B>1)&&q.fire(he),B=0},$)})},onLastListenerRemove(){L.dispose()}});return q.event}v.debounce=o;function c(j){const W=new Date().getTime();return g(_(j),$=>new Date().getTime()-W)}v.stopwatch=c;function m(j){let W=!0,$;return d(j,U=>{const M=W||U!==$;return W=!1,$=U,M})}v.latch=m;function S(j,W=!1,$=[]){let U=$.slice(),M=j(O=>{U?U.push(O):N.fire(O)});const L=()=>{U&&U.forEach(O=>N.fire(O)),U=null},N=new f({onFirstListenerAdd(){M||(M=j(O=>N.fire(O)))},onFirstListenerDidAdd(){U&&(W?setTimeout(L):L())},onLastListenerRemove(){M&&M.dispose(),M=null}});return N.event}v.buffer=S;class p{constructor(W){this.event=W}map(W){return new p(g(this.event,W))}forEach(W){return new p(l(this.event,W))}filter(W){return new p(d(this.event,W))}reduce(W,$){return new p(r(this.event,W,$))}latch(){return new p(m(this.event))}debounce(W,$=100,U=!1,M){return new p(o(this.event,W,$,U,M))}on(W,$,U){return this.event(W,$,U)}once(W,$,U){return _(this.event)(W,$,U)}}function w(j){return new p(j)}v.chain=w;function R(j,W,$=U=>U){const U=(...O)=>N.fire($(...O)),M=()=>j.on(W,U),L=()=>j.removeListener(W,U),N=new f({onFirstListenerAdd:M,onLastListenerRemove:L});return N.event}v.fromNodeEventEmitter=R;function F(j,W,$=U=>U){const U=(...O)=>N.fire($(...O)),M=()=>j.addEventListener(W,U),L=()=>j.removeEventListener(W,U),N=new f({onFirstListenerAdd:M,onLastListenerRemove:L});return N.event}v.fromDOMEventEmitter=F;function z(j){const W=new f;let $=!1;return j.then(void 0,()=>null).then(()=>{$?W.fire(void 0):setTimeout(()=>W.fire(void 0),0)}),$=!0,W.event}v.fromPromise=z;function oe(j){return new Promise(W=>_(j)(W))}v.toPromise=oe})(k=e.Event||(e.Event={}));class D{constructor(_){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${_}_${D._idPool++}`}start(_){this._stopWatch=new y.StopWatch(!0),this._listenerCount=_}stop(){if(this._stopWatch){const _=this._stopWatch.elapsed();this._elapsedOverall+=_,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${_.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let P=-1;function s(v){const _=P;return P=v,{dispose(){P=_}}}e.setGlobalLeakWarningThreshold=s;class C{constructor(_,g=Math.random().toString(18).slice(2,5)){this.customThreshold=_,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(_){let g=P;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),!(g<=0||_<g)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),d=this._stacks.get(l)||0;if(this._stacks.set(l,d+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let n,t=0;for(const[r,i]of this._stacks)(!n||t<i)&&(n=r,t=i);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${t}):`),console.warn(n)}return()=>{const n=this._stacks.get(l)||0;this._stacks.set(l,n-1)}}}}class f{constructor(_){var g;this._disposed=!1,this._options=_,this._leakageMon=P>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((g=this._options)===null||g===void 0?void 0:g._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(_,g,l)=>{var d;this._listeners||(this._listeners=new A.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(g?[_,g]:_);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,_,g);const r=(d=this._leakageMon)===null||d===void 0?void 0:d.check(this._listeners.size);let i;return i={dispose:()=>{r&&r(),i.dispose=f._noop,this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof T.DisposableStore?l.add(i):Array.isArray(l)&&l.push(i),i}),this._event}fire(_){var g,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let d of this._listeners)this._deliveryQueue.push([d,_]);for((g=this._perfMon)===null||g===void 0||g.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[d,n]=this._deliveryQueue.shift();try{typeof d=="function"?d.call(void 0,n):d[0].call(d[1],n)}catch(t){(0,b.onUnexpectedError)(t)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var _,g,l;(_=this._listeners)===null||_===void 0||_.clear(),(g=this._deliveryQueue)===null||g===void 0||g.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=f,f._noop=function(){};class h extends f{constructor(_){super(_);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=_==null?void 0:_.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const _=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(_))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(_){this._listeners&&(this._isPaused!==0?this._eventQueue.push(_):super.fire(_))}}e.PauseableEmitter=h;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(_){const g={event:_,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const l=()=>{this.hasListeners&&this.unhook(g);const d=this.events.indexOf(g);this.events.splice(d,1)};return(0,T.toDisposable)((0,I.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(_=>this.hook(_))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(_=>this.unhook(_))}hook(_){_.listener=_.event(g=>this.emitter.fire(g))}unhook(_){_.listener&&_.listener.dispose(),_.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class u{constructor(){this.buffers=[]}wrapEvent(_){return(g,l,d)=>_(n=>{const t=this.buffers[this.buffers.length-1];t?t.push(()=>g.call(l,n)):g.call(l,n)},void 0,d)}bufferEvents(_){const g=[];this.buffers.push(g);const l=_();return this.buffers.pop(),g.forEach(d=>d()),l}}e.EventBufferer=u;class E{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=T.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(_){this.inputEvent=_,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=_(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(k,D){const P=setTimeout(k.bind(D),0);return{dispose(){clearTimeout(P)}}});var T;(function(k){function D(P){return P===k.None||P===k.Cancelled||P instanceof A?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}k.isCancellationToken=D,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(T=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=T.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=y}),define(me[43],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new b.Emitter}add(C){const f=this._icons.get(C.id);f?C.description?f.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new I;e.iconRegistry=T;function A(s,C){return new k(s,C)}e.registerCodicon=A;function y(s){return s?s.replace(/\$\((.*?)\)/g,(C,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=y;class k{constructor(C,f,h){this.id=C,this.definition=f,this.description=h,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function D(s,C){const f=["codicon","codicon-"+s];return C&&f.push("codicon-modifier-"+C),f}e.getClassNamesArray=D;var P;(function(s){s.iconNameSegment="[A-Za-z0-9]+",s.iconNameExpression="[A-Za-z0-9\\-]+",s.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${s.iconNameExpression})(${s.iconModifierExpression})?$`);function f(u){if(u instanceof k)return["codicon","codicon-"+u.id];const E=C.exec(u.id);if(!E)return f(k.error);let[,v,_]=E;const g=["codicon","codicon-"+v];return _&&g.push("codicon-modifier-"+_.substr(1)),g}s.asClassNameArray=f;function h(u){return f(u).join(" ")}s.asClassName=h;function a(u){return"."+f(u).join(".")}s.asCSSSelector=a})(P=e.CSSIcon||(e.CSSIcon={})),function(s){s.add=new s("add",{fontCharacter:"\\ea60"}),s.plus=new s("plus",{fontCharacter:"\\ea60"}),s.gistNew=new s("gist-new",{fontCharacter:"\\ea60"}),s.repoCreate=new s("repo-create",{fontCharacter:"\\ea60"}),s.lightbulb=new s("lightbulb",{fontCharacter:"\\ea61"}),s.lightBulb=new s("light-bulb",{fontCharacter:"\\ea61"}),s.repo=new s("repo",{fontCharacter:"\\ea62"}),s.repoDelete=new s("repo-delete",{fontCharacter:"\\ea62"}),s.gistFork=new s("gist-fork",{fontCharacter:"\\ea63"}),s.repoForked=new s("repo-forked",{fontCharacter:"\\ea63"}),s.gitPullRequest=new s("git-pull-request",{fontCharacter:"\\ea64"}),s.gitPullRequestAbandoned=new s("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),s.recordKeys=new s("record-keys",{fontCharacter:"\\ea65"}),s.keyboard=new s("keyboard",{fontCharacter:"\\ea65"}),s.tag=new s("tag",{fontCharacter:"\\ea66"}),s.tagAdd=new s("tag-add",{fontCharacter:"\\ea66"}),s.tagRemove=new s("tag-remove",{fontCharacter:"\\ea66"}),s.person=new s("person",{fontCharacter:"\\ea67"}),s.personAdd=new s("person-add",{fontCharacter:"\\ea67"}),s.personFollow=new s("person-follow",{fontCharacter:"\\ea67"}),s.personOutline=new s("person-outline",{fontCharacter:"\\ea67"}),s.personFilled=new s("person-filled",{fontCharacter:"\\ea67"}),s.gitBranch=new s("git-branch",{fontCharacter:"\\ea68"}),s.gitBranchCreate=new s("git-branch-create",{fontCharacter:"\\ea68"}),s.gitBranchDelete=new s("git-branch-delete",{fontCharacter:"\\ea68"}),s.sourceControl=new s("source-control",{fontCharacter:"\\ea68"}),s.mirror=new s("mirror",{fontCharacter:"\\ea69"}),s.mirrorPublic=new s("mirror-public",{fontCharacter:"\\ea69"}),s.star=new s("star",{fontCharacter:"\\ea6a"}),s.starAdd=new s("star-add",{fontCharacter:"\\ea6a"}),s.starDelete=new s("star-delete",{fontCharacter:"\\ea6a"}),s.starEmpty=new s("star-empty",{fontCharacter:"\\ea6a"}),s.comment=new s("comment",{fontCharacter:"\\ea6b"}),s.commentAdd=new s("comment-add",{fontCharacter:"\\ea6b"}),s.alert=new s("alert",{fontCharacter:"\\ea6c"}),s.warning=new s("warning",{fontCharacter:"\\ea6c"}),s.search=new s("search",{fontCharacter:"\\ea6d"}),s.searchSave=new s("search-save",{fontCharacter:"\\ea6d"}),s.logOut=new s("log-out",{fontCharacter:"\\ea6e"}),s.signOut=new s("sign-out",{fontCharacter:"\\ea6e"}),s.logIn=new s("log-in",{fontCharacter:"\\ea6f"}),s.signIn=new s("sign-in",{fontCharacter:"\\ea6f"}),s.eye=new s("eye",{fontCharacter:"\\ea70"}),s.eyeUnwatch=new s("eye-unwatch",{fontCharacter:"\\ea70"}),s.eyeWatch=new s("eye-watch",{fontCharacter:"\\ea70"}),s.circleFilled=new s("circle-filled",{fontCharacter:"\\ea71"}),s.primitiveDot=new s("primitive-dot",{fontCharacter:"\\ea71"}),s.closeDirty=new s("close-dirty",{fontCharacter:"\\ea71"}),s.debugBreakpoint=new s("debug-breakpoint",{fontCharacter:"\\ea71"}),s.debugBreakpointDisabled=new s("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),s.debugHint=new s("debug-hint",{fontCharacter:"\\ea71"}),s.primitiveSquare=new s("primitive-square",{fontCharacter:"\\ea72"}),s.edit=new s("edit",{fontCharacter:"\\ea73"}),s.pencil=new s("pencil",{fontCharacter:"\\ea73"}),s.info=new s("info",{fontCharacter:"\\ea74"}),s.issueOpened=new s("issue-opened",{fontCharacter:"\\ea74"}),s.gistPrivate=new s("gist-private",{fontCharacter:"\\ea75"}),s.gitForkPrivate=new s("git-fork-private",{fontCharacter:"\\ea75"}),s.lock=new s("lock",{fontCharacter:"\\ea75"}),s.mirrorPrivate=new s("mirror-private",{fontCharacter:"\\ea75"}),s.close=new s("close",{fontCharacter:"\\ea76"}),s.removeClose=new s("remove-close",{fontCharacter:"\\ea76"}),s.x=new s("x",{fontCharacter:"\\ea76"}),s.repoSync=new s("repo-sync",{fontCharacter:"\\ea77"}),s.sync=new s("sync",{fontCharacter:"\\ea77"}),s.clone=new s("clone",{fontCharacter:"\\ea78"}),s.desktopDownload=new s("desktop-download",{fontCharacter:"\\ea78"}),s.beaker=new s("beaker",{fontCharacter:"\\ea79"}),s.microscope=new s("microscope",{fontCharacter:"\\ea79"}),s.vm=new s("vm",{fontCharacter:"\\ea7a"}),s.deviceDesktop=new s("device-desktop",{fontCharacter:"\\ea7a"}),s.file=new s("file",{fontCharacter:"\\ea7b"}),s.fileText=new s("file-text",{fontCharacter:"\\ea7b"}),s.more=new s("more",{fontCharacter:"\\ea7c"}),s.ellipsis=new s("ellipsis",{fontCharacter:"\\ea7c"}),s.kebabHorizontal=new s("kebab-horizontal",{fontCharacter:"\\ea7c"}),s.mailReply=new s("mail-reply",{fontCharacter:"\\ea7d"}),s.reply=new s("reply",{fontCharacter:"\\ea7d"}),s.organization=new s("organization",{fontCharacter:"\\ea7e"}),s.organizationFilled=new s("organization-filled",{fontCharacter:"\\ea7e"}),s.organizationOutline=new s("organization-outline",{fontCharacter:"\\ea7e"}),s.newFile=new s("new-file",{fontCharacter:"\\ea7f"}),s.fileAdd=new s("file-add",{fontCharacter:"\\ea7f"}),s.newFolder=new s("new-folder",{fontCharacter:"\\ea80"}),s.fileDirectoryCreate=new s("file-directory-create",{fontCharacter:"\\ea80"}),s.trash=new s("trash",{fontCharacter:"\\ea81"}),s.trashcan=new s("trashcan",{fontCharacter:"\\ea81"}),s.history=new s("history",{fontCharacter:"\\ea82"}),s.clock=new s("clock",{fontCharacter:"\\ea82"}),s.folder=new s("folder",{fontCharacter:"\\ea83"}),s.fileDirectory=new s("file-directory",{fontCharacter:"\\ea83"}),s.symbolFolder=new s("symbol-folder",{fontCharacter:"\\ea83"}),s.logoGithub=new s("logo-github",{fontCharacter:"\\ea84"}),s.markGithub=new s("mark-github",{fontCharacter:"\\ea84"}),s.github=new s("github",{fontCharacter:"\\ea84"}),s.terminal=new s("terminal",{fontCharacter:"\\ea85"}),s.console=new s("console",{fontCharacter:"\\ea85"}),s.repl=new s("repl",{fontCharacter:"\\ea85"}),s.zap=new s("zap",{fontCharacter:"\\ea86"}),s.symbolEvent=new s("symbol-event",{fontCharacter:"\\ea86"}),s.error=new s("error",{fontCharacter:"\\ea87"}),s.stop=new s("stop",{fontCharacter:"\\ea87"}),s.variable=new s("variable",{fontCharacter:"\\ea88"}),s.symbolVariable=new s("symbol-variable",{fontCharacter:"\\ea88"}),s.array=new s("array",{fontCharacter:"\\ea8a"}),s.symbolArray=new s("symbol-array",{fontCharacter:"\\ea8a"}),s.symbolModule=new s("symbol-module",{fontCharacter:"\\ea8b"}),s.symbolPackage=new s("symbol-package",{fontCharacter:"\\ea8b"}),s.symbolNamespace=new s("symbol-namespace",{fontCharacter:"\\ea8b"}),s.symbolObject=new s("symbol-object",{fontCharacter:"\\ea8b"}),s.symbolMethod=new s("symbol-method",{fontCharacter:"\\ea8c"}),s.symbolFunction=new s("symbol-function",{fontCharacter:"\\ea8c"}),s.symbolConstructor=new s("symbol-constructor",{fontCharacter:"\\ea8c"}),s.symbolBoolean=new s("symbol-boolean",{fontCharacter:"\\ea8f"}),s.symbolNull=new s("symbol-null",{fontCharacter:"\\ea8f"}),s.symbolNumeric=new s("symbol-numeric",{fontCharacter:"\\ea90"}),s.symbolNumber=new s("symbol-number",{fontCharacter:"\\ea90"}),s.symbolStructure=new s("symbol-structure",{fontCharacter:"\\ea91"}),s.symbolStruct=new s("symbol-struct",{fontCharacter:"\\ea91"}),s.symbolParameter=new s("symbol-parameter",{fontCharacter:"\\ea92"}),s.symbolTypeParameter=new s("symbol-type-parameter",{fontCharacter:"\\ea92"}),s.symbolKey=new s("symbol-key",{fontCharacter:"\\ea93"}),s.symbolText=new s("symbol-text",{fontCharacter:"\\ea93"}),s.symbolReference=new s("symbol-reference",{fontCharacter:"\\ea94"}),s.goToFile=new s("go-to-file",{fontCharacter:"\\ea94"}),s.symbolEnum=new s("symbol-enum",{fontCharacter:"\\ea95"}),s.symbolValue=new s("symbol-value",{fontCharacter:"\\ea95"}),s.symbolRuler=new s("symbol-ruler",{fontCharacter:"\\ea96"}),s.symbolUnit=new s("symbol-unit",{fontCharacter:"\\ea96"}),s.activateBreakpoints=new s("activate-breakpoints",{fontCharacter:"\\ea97"}),s.archive=new s("archive",{fontCharacter:"\\ea98"}),s.arrowBoth=new s("arrow-both",{fontCharacter:"\\ea99"}),s.arrowDown=new s("arrow-down",{fontCharacter:"\\ea9a"}),s.arrowLeft=new s("arrow-left",{fontCharacter:"\\ea9b"}),s.arrowRight=new s("arrow-right",{fontCharacter:"\\ea9c"}),s.arrowSmallDown=new s("arrow-small-down",{fontCharacter:"\\ea9d"}),s.arrowSmallLeft=new s("arrow-small-left",{fontCharacter:"\\ea9e"}),s.arrowSmallRight=new s("arrow-small-right",{fontCharacter:"\\ea9f"}),s.arrowSmallUp=new s("arrow-small-up",{fontCharacter:"\\eaa0"}),s.arrowUp=new s("arrow-up",{fontCharacter:"\\eaa1"}),s.bell=new s("bell",{fontCharacter:"\\eaa2"}),s.bold=new s("bold",{fontCharacter:"\\eaa3"}),s.book=new s("book",{fontCharacter:"\\eaa4"}),s.bookmark=new s("bookmark",{fontCharacter:"\\eaa5"}),s.debugBreakpointConditionalUnverified=new s("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),s.debugBreakpointConditional=new s("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),s.debugBreakpointConditionalDisabled=new s("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),s.debugBreakpointDataUnverified=new s("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),s.debugBreakpointData=new s("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),s.debugBreakpointDataDisabled=new s("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),s.debugBreakpointLogUnverified=new s("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),s.debugBreakpointLog=new s("debug-breakpoint-log",{fontCharacter:"\\eaab"}),s.debugBreakpointLogDisabled=new s("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),s.briefcase=new s("briefcase",{fontCharacter:"\\eaac"}),s.broadcast=new s("broadcast",{fontCharacter:"\\eaad"}),s.browser=new s("browser",{fontCharacter:"\\eaae"}),s.bug=new s("bug",{fontCharacter:"\\eaaf"}),s.calendar=new s("calendar",{fontCharacter:"\\eab0"}),s.caseSensitive=new s("case-sensitive",{fontCharacter:"\\eab1"}),s.check=new s("check",{fontCharacter:"\\eab2"}),s.checklist=new s("checklist",{fontCharacter:"\\eab3"}),s.chevronDown=new s("chevron-down",{fontCharacter:"\\eab4"}),s.chevronLeft=new s("chevron-left",{fontCharacter:"\\eab5"}),s.chevronRight=new s("chevron-right",{fontCharacter:"\\eab6"}),s.chevronUp=new s("chevron-up",{fontCharacter:"\\eab7"}),s.chromeClose=new s("chrome-close",{fontCharacter:"\\eab8"}),s.chromeMaximize=new s("chrome-maximize",{fontCharacter:"\\eab9"}),s.chromeMinimize=new s("chrome-minimize",{fontCharacter:"\\eaba"}),s.chromeRestore=new s("chrome-restore",{fontCharacter:"\\eabb"}),s.circleOutline=new s("circle-outline",{fontCharacter:"\\eabc"}),s.debugBreakpointUnverified=new s("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),s.circleSlash=new s("circle-slash",{fontCharacter:"\\eabd"}),s.circuitBoard=new s("circuit-board",{fontCharacter:"\\eabe"}),s.clearAll=new s("clear-all",{fontCharacter:"\\eabf"}),s.clippy=new s("clippy",{fontCharacter:"\\eac0"}),s.closeAll=new s("close-all",{fontCharacter:"\\eac1"}),s.cloudDownload=new s("cloud-download",{fontCharacter:"\\eac2"}),s.cloudUpload=new s("cloud-upload",{fontCharacter:"\\eac3"}),s.code=new s("code",{fontCharacter:"\\eac4"}),s.collapseAll=new s("collapse-all",{fontCharacter:"\\eac5"}),s.colorMode=new s("color-mode",{fontCharacter:"\\eac6"}),s.commentDiscussion=new s("comment-discussion",{fontCharacter:"\\eac7"}),s.compareChanges=new s("compare-changes",{fontCharacter:"\\eafd"}),s.creditCard=new s("credit-card",{fontCharacter:"\\eac9"}),s.dash=new s("dash",{fontCharacter:"\\eacc"}),s.dashboard=new s("dashboard",{fontCharacter:"\\eacd"}),s.database=new s("database",{fontCharacter:"\\eace"}),s.debugContinue=new s("debug-continue",{fontCharacter:"\\eacf"}),s.debugDisconnect=new s("debug-disconnect",{fontCharacter:"\\ead0"}),s.debugPause=new s("debug-pause",{fontCharacter:"\\ead1"}),s.debugRestart=new s("debug-restart",{fontCharacter:"\\ead2"}),s.debugStart=new s("debug-start",{fontCharacter:"\\ead3"}),s.debugStepInto=new s("debug-step-into",{fontCharacter:"\\ead4"}),s.debugStepOut=new s("debug-step-out",{fontCharacter:"\\ead5"}),s.debugStepOver=new s("debug-step-over",{fontCharacter:"\\ead6"}),s.debugStop=new s("debug-stop",{fontCharacter:"\\ead7"}),s.debug=new s("debug",{fontCharacter:"\\ead8"}),s.deviceCameraVideo=new s("device-camera-video",{fontCharacter:"\\ead9"}),s.deviceCamera=new s("device-camera",{fontCharacter:"\\eada"}),s.deviceMobile=new s("device-mobile",{fontCharacter:"\\eadb"}),s.diffAdded=new s("diff-added",{fontCharacter:"\\eadc"}),s.diffIgnored=new s("diff-ignored",{fontCharacter:"\\eadd"}),s.diffModified=new s("diff-modified",{fontCharacter:"\\eade"}),s.diffRemoved=new s("diff-removed",{fontCharacter:"\\eadf"}),s.diffRenamed=new s("diff-renamed",{fontCharacter:"\\eae0"}),s.diff=new s("diff",{fontCharacter:"\\eae1"}),s.discard=new s("discard",{fontCharacter:"\\eae2"}),s.editorLayout=new s("editor-layout",{fontCharacter:"\\eae3"}),s.emptyWindow=new s("empty-window",{fontCharacter:"\\eae4"}),s.exclude=new s("exclude",{fontCharacter:"\\eae5"}),s.extensions=new s("extensions",{fontCharacter:"\\eae6"}),s.eyeClosed=new s("eye-closed",{fontCharacter:"\\eae7"}),s.fileBinary=new s("file-binary",{fontCharacter:"\\eae8"}),s.fileCode=new s("file-code",{fontCharacter:"\\eae9"}),s.fileMedia=new s("file-media",{fontCharacter:"\\eaea"}),s.filePdf=new s("file-pdf",{fontCharacter:"\\eaeb"}),s.fileSubmodule=new s("file-submodule",{fontCharacter:"\\eaec"}),s.fileSymlinkDirectory=new s("file-symlink-directory",{fontCharacter:"\\eaed"}),s.fileSymlinkFile=new s("file-symlink-file",{fontCharacter:"\\eaee"}),s.fileZip=new s("file-zip",{fontCharacter:"\\eaef"}),s.files=new s("files",{fontCharacter:"\\eaf0"}),s.filter=new s("filter",{fontCharacter:"\\eaf1"}),s.flame=new s("flame",{fontCharacter:"\\eaf2"}),s.foldDown=new s("fold-down",{fontCharacter:"\\eaf3"}),s.foldUp=new s("fold-up",{fontCharacter:"\\eaf4"}),s.fold=new s("fold",{fontCharacter:"\\eaf5"}),s.folderActive=new s("folder-active",{fontCharacter:"\\eaf6"}),s.folderOpened=new s("folder-opened",{fontCharacter:"\\eaf7"}),s.gear=new s("gear",{fontCharacter:"\\eaf8"}),s.gift=new s("gift",{fontCharacter:"\\eaf9"}),s.gistSecret=new s("gist-secret",{fontCharacter:"\\eafa"}),s.gist=new s("gist",{fontCharacter:"\\eafb"}),s.gitCommit=new s("git-commit",{fontCharacter:"\\eafc"}),s.gitCompare=new s("git-compare",{fontCharacter:"\\eafd"}),s.gitMerge=new s("git-merge",{fontCharacter:"\\eafe"}),s.githubAction=new s("github-action",{fontCharacter:"\\eaff"}),s.githubAlt=new s("github-alt",{fontCharacter:"\\eb00"}),s.globe=new s("globe",{fontCharacter:"\\eb01"}),s.grabber=new s("grabber",{fontCharacter:"\\eb02"}),s.graph=new s("graph",{fontCharacter:"\\eb03"}),s.gripper=new s("gripper",{fontCharacter:"\\eb04"}),s.heart=new s("heart",{fontCharacter:"\\eb05"}),s.home=new s("home",{fontCharacter:"\\eb06"}),s.horizontalRule=new s("horizontal-rule",{fontCharacter:"\\eb07"}),s.hubot=new s("hubot",{fontCharacter:"\\eb08"}),s.inbox=new s("inbox",{fontCharacter:"\\eb09"}),s.issueClosed=new s("issue-closed",{fontCharacter:"\\eb0a"}),s.issueReopened=new s("issue-reopened",{fontCharacter:"\\eb0b"}),s.issues=new s("issues",{fontCharacter:"\\eb0c"}),s.italic=new s("italic",{fontCharacter:"\\eb0d"}),s.jersey=new s("jersey",{fontCharacter:"\\eb0e"}),s.json=new s("json",{fontCharacter:"\\eb0f"}),s.kebabVertical=new s("kebab-vertical",{fontCharacter:"\\eb10"}),s.key=new s("key",{fontCharacter:"\\eb11"}),s.law=new s("law",{fontCharacter:"\\eb12"}),s.lightbulbAutofix=new s("lightbulb-autofix",{fontCharacter:"\\eb13"}),s.linkExternal=new s("link-external",{fontCharacter:"\\eb14"}),s.link=new s("link",{fontCharacter:"\\eb15"}),s.listOrdered=new s("list-ordered",{fontCharacter:"\\eb16"}),s.listUnordered=new s("list-unordered",{fontCharacter:"\\eb17"}),s.liveShare=new s("live-share",{fontCharacter:"\\eb18"}),s.loading=new s("loading",{fontCharacter:"\\eb19"}),s.location=new s("location",{fontCharacter:"\\eb1a"}),s.mailRead=new s("mail-read",{fontCharacter:"\\eb1b"}),s.mail=new s("mail",{fontCharacter:"\\eb1c"}),s.markdown=new s("markdown",{fontCharacter:"\\eb1d"}),s.megaphone=new s("megaphone",{fontCharacter:"\\eb1e"}),s.mention=new s("mention",{fontCharacter:"\\eb1f"}),s.milestone=new s("milestone",{fontCharacter:"\\eb20"}),s.mortarBoard=new s("mortar-board",{fontCharacter:"\\eb21"}),s.move=new s("move",{fontCharacter:"\\eb22"}),s.multipleWindows=new s("multiple-windows",{fontCharacter:"\\eb23"}),s.mute=new s("mute",{fontCharacter:"\\eb24"}),s.noNewline=new s("no-newline",{fontCharacter:"\\eb25"}),s.note=new s("note",{fontCharacter:"\\eb26"}),s.octoface=new s("octoface",{fontCharacter:"\\eb27"}),s.openPreview=new s("open-preview",{fontCharacter:"\\eb28"}),s.package_=new s("package",{fontCharacter:"\\eb29"}),s.paintcan=new s("paintcan",{fontCharacter:"\\eb2a"}),s.pin=new s("pin",{fontCharacter:"\\eb2b"}),s.play=new s("play",{fontCharacter:"\\eb2c"}),s.run=new s("run",{fontCharacter:"\\eb2c"}),s.plug=new s("plug",{fontCharacter:"\\eb2d"}),s.preserveCase=new s("preserve-case",{fontCharacter:"\\eb2e"}),s.preview=new s("preview",{fontCharacter:"\\eb2f"}),s.project=new s("project",{fontCharacter:"\\eb30"}),s.pulse=new s("pulse",{fontCharacter:"\\eb31"}),s.question=new s("question",{fontCharacter:"\\eb32"}),s.quote=new s("quote",{fontCharacter:"\\eb33"}),s.radioTower=new s("radio-tower",{fontCharacter:"\\eb34"}),s.reactions=new s("reactions",{fontCharacter:"\\eb35"}),s.references=new s("references",{fontCharacter:"\\eb36"}),s.refresh=new s("refresh",{fontCharacter:"\\eb37"}),s.regex=new s("regex",{fontCharacter:"\\eb38"}),s.remoteExplorer=new s("remote-explorer",{fontCharacter:"\\eb39"}),s.remote=new s("remote",{fontCharacter:"\\eb3a"}),s.remove=new s("remove",{fontCharacter:"\\eb3b"}),s.replaceAll=new s("replace-all",{fontCharacter:"\\eb3c"}),s.replace=new s("replace",{fontCharacter:"\\eb3d"}),s.repoClone=new s("repo-clone",{fontCharacter:"\\eb3e"}),s.repoForcePush=new s("repo-force-push",{fontCharacter:"\\eb3f"}),s.repoPull=new s("repo-pull",{fontCharacter:"\\eb40"}),s.repoPush=new s("repo-push",{fontCharacter:"\\eb41"}),s.report=new s("report",{fontCharacter:"\\eb42"}),s.requestChanges=new s("request-changes",{fontCharacter:"\\eb43"}),s.rocket=new s("rocket",{fontCharacter:"\\eb44"}),s.rootFolderOpened=new s("root-folder-opened",{fontCharacter:"\\eb45"}),s.rootFolder=new s("root-folder",{fontCharacter:"\\eb46"}),s.rss=new s("rss",{fontCharacter:"\\eb47"}),s.ruby=new s("ruby",{fontCharacter:"\\eb48"}),s.saveAll=new s("save-all",{fontCharacter:"\\eb49"}),s.saveAs=new s("save-as",{fontCharacter:"\\eb4a"}),s.save=new s("save",{fontCharacter:"\\eb4b"}),s.screenFull=new s("screen-full",{fontCharacter:"\\eb4c"}),s.screenNormal=new s("screen-normal",{fontCharacter:"\\eb4d"}),s.searchStop=new s("search-stop",{fontCharacter:"\\eb4e"}),s.server=new s("server",{fontCharacter:"\\eb50"}),s.settingsGear=new s("settings-gear",{fontCharacter:"\\eb51"}),s.settings=new s("settings",{fontCharacter:"\\eb52"}),s.shield=new s("shield",{fontCharacter:"\\eb53"}),s.smiley=new s("smiley",{fontCharacter:"\\eb54"}),s.sortPrecedence=new s("sort-precedence",{fontCharacter:"\\eb55"}),s.splitHorizontal=new s("split-horizontal",{fontCharacter:"\\eb56"}),s.splitVertical=new s("split-vertical",{fontCharacter:"\\eb57"}),s.squirrel=new s("squirrel",{fontCharacter:"\\eb58"}),s.starFull=new s("star-full",{fontCharacter:"\\eb59"}),s.starHalf=new s("star-half",{fontCharacter:"\\eb5a"}),s.symbolClass=new s("symbol-class",{fontCharacter:"\\eb5b"}),s.symbolColor=new s("symbol-color",{fontCharacter:"\\eb5c"}),s.symbolConstant=new s("symbol-constant",{fontCharacter:"\\eb5d"}),s.symbolEnumMember=new s("symbol-enum-member",{fontCharacter:"\\eb5e"}),s.symbolField=new s("symbol-field",{fontCharacter:"\\eb5f"}),s.symbolFile=new s("symbol-file",{fontCharacter:"\\eb60"}),s.symbolInterface=new s("symbol-interface",{fontCharacter:"\\eb61"}),s.symbolKeyword=new s("symbol-keyword",{fontCharacter:"\\eb62"}),s.symbolMisc=new s("symbol-misc",{fontCharacter:"\\eb63"}),s.symbolOperator=new s("symbol-operator",{fontCharacter:"\\eb64"}),s.symbolProperty=new s("symbol-property",{fontCharacter:"\\eb65"}),s.wrench=new s("wrench",{fontCharacter:"\\eb65"}),s.wrenchSubaction=new s("wrench-subaction",{fontCharacter:"\\eb65"}),s.symbolSnippet=new s("symbol-snippet",{fontCharacter:"\\eb66"}),s.tasklist=new s("tasklist",{fontCharacter:"\\eb67"}),s.telescope=new s("telescope",{fontCharacter:"\\eb68"}),s.textSize=new s("text-size",{fontCharacter:"\\eb69"}),s.threeBars=new s("three-bars",{fontCharacter:"\\eb6a"}),s.thumbsdown=new s("thumbsdown",{fontCharacter:"\\eb6b"}),s.thumbsup=new s("thumbsup",{fontCharacter:"\\eb6c"}),s.tools=new s("tools",{fontCharacter:"\\eb6d"}),s.triangleDown=new s("triangle-down",{fontCharacter:"\\eb6e"}),s.triangleLeft=new s("triangle-left",{fontCharacter:"\\eb6f"}),s.triangleRight=new s("triangle-right",{fontCharacter:"\\eb70"}),s.triangleUp=new s("triangle-up",{fontCharacter:"\\eb71"}),s.twitter=new s("twitter",{fontCharacter:"\\eb72"}),s.unfold=new s("unfold",{fontCharacter:"\\eb73"}),s.unlock=new s("unlock",{fontCharacter:"\\eb74"}),s.unmute=new s("unmute",{fontCharacter:"\\eb75"}),s.unverified=new s("unverified",{fontCharacter:"\\eb76"}),s.verified=new s("verified",{fontCharacter:"\\eb77"}),s.versions=new s("versions",{fontCharacter:"\\eb78"}),s.vmActive=new s("vm-active",{fontCharacter:"\\eb79"}),s.vmOutline=new s("vm-outline",{fontCharacter:"\\eb7a"}),s.vmRunning=new s("vm-running",{fontCharacter:"\\eb7b"}),s.watch=new s("watch",{fontCharacter:"\\eb7c"}),s.whitespace=new s("whitespace",{fontCharacter:"\\eb7d"}),s.wholeWord=new s("whole-word",{fontCharacter:"\\eb7e"}),s.window=new s("window",{fontCharacter:"\\eb7f"}),s.wordWrap=new s("word-wrap",{fontCharacter:"\\eb80"}),s.zoomIn=new s("zoom-in",{fontCharacter:"\\eb81"}),s.zoomOut=new s("zoom-out",{fontCharacter:"\\eb82"}),s.listFilter=new s("list-filter",{fontCharacter:"\\eb83"}),s.listFlat=new s("list-flat",{fontCharacter:"\\eb84"}),s.listSelection=new s("list-selection",{fontCharacter:"\\eb85"}),s.selection=new s("selection",{fontCharacter:"\\eb85"}),s.listTree=new s("list-tree",{fontCharacter:"\\eb86"}),s.debugBreakpointFunctionUnverified=new s("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),s.debugBreakpointFunction=new s("debug-breakpoint-function",{fontCharacter:"\\eb88"}),s.debugBreakpointFunctionDisabled=new s("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),s.debugStackframeActive=new s("debug-stackframe-active",{fontCharacter:"\\eb89"}),s.debugStackframeDot=new s("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),s.debugStackframe=new s("debug-stackframe",{fontCharacter:"\\eb8b"}),s.debugStackframeFocused=new s("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),s.debugBreakpointUnsupported=new s("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),s.symbolString=new s("symbol-string",{fontCharacter:"\\eb8d"}),s.debugReverseContinue=new s("debug-reverse-continue",{fontCharacter:"\\eb8e"}),s.debugStepBack=new s("debug-step-back",{fontCharacter:"\\eb8f"}),s.debugRestartFrame=new s("debug-restart-frame",{fontCharacter:"\\eb90"}),s.callIncoming=new s("call-incoming",{fontCharacter:"\\eb92"}),s.callOutgoing=new s("call-outgoing",{fontCharacter:"\\eb93"}),s.menu=new s("menu",{fontCharacter:"\\eb94"}),s.expandAll=new s("expand-all",{fontCharacter:"\\eb95"}),s.feedback=new s("feedback",{fontCharacter:"\\eb96"}),s.groupByRefType=new s("group-by-ref-type",{fontCharacter:"\\eb97"}),s.ungroupByRefType=new s("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),s.account=new s("account",{fontCharacter:"\\eb99"}),s.bellDot=new s("bell-dot",{fontCharacter:"\\eb9a"}),s.debugConsole=new s("debug-console",{fontCharacter:"\\eb9b"}),s.library=new s("library",{fontCharacter:"\\eb9c"}),s.output=new s("output",{fontCharacter:"\\eb9d"}),s.runAll=new s("run-all",{fontCharacter:"\\eb9e"}),s.syncIgnored=new s("sync-ignored",{fontCharacter:"\\eb9f"}),s.pinned=new s("pinned",{fontCharacter:"\\eba0"}),s.githubInverted=new s("github-inverted",{fontCharacter:"\\eba1"}),s.debugAlt=new s("debug-alt",{fontCharacter:"\\eb91"}),s.serverProcess=new s("server-process",{fontCharacter:"\\eba2"}),s.serverEnvironment=new s("server-environment",{fontCharacter:"\\eba3"}),s.pass=new s("pass",{fontCharacter:"\\eba4"}),s.stopCircle=new s("stop-circle",{fontCharacter:"\\eba5"}),s.playCircle=new s("play-circle",{fontCharacter:"\\eba6"}),s.record=new s("record",{fontCharacter:"\\eba7"}),s.debugAltSmall=new s("debug-alt-small",{fontCharacter:"\\eba8"}),s.vmConnect=new s("vm-connect",{fontCharacter:"\\eba9"}),s.cloud=new s("cloud",{fontCharacter:"\\ebaa"}),s.merge=new s("merge",{fontCharacter:"\\ebab"}),s.exportIcon=new s("export",{fontCharacter:"\\ebac"}),s.graphLeft=new s("graph-left",{fontCharacter:"\\ebad"}),s.magnet=new s("magnet",{fontCharacter:"\\ebae"}),s.notebook=new s("notebook",{fontCharacter:"\\ebaf"}),s.redo=new s("redo",{fontCharacter:"\\ebb0"}),s.checkAll=new s("check-all",{fontCharacter:"\\ebb1"}),s.pinnedDirty=new s("pinned-dirty",{fontCharacter:"\\ebb2"}),s.passFilled=new s("pass-filled",{fontCharacter:"\\ebb3"}),s.circleLargeFilled=new s("circle-large-filled",{fontCharacter:"\\ebb4"}),s.circleLargeOutline=new s("circle-large-outline",{fontCharacter:"\\ebb5"}),s.combine=new s("combine",{fontCharacter:"\\ebb6"}),s.gather=new s("gather",{fontCharacter:"\\ebb6"}),s.table=new s("table",{fontCharacter:"\\ebb7"}),s.variableGroup=new s("variable-group",{fontCharacter:"\\ebb8"}),s.typeHierarchy=new s("type-hierarchy",{fontCharacter:"\\ebb9"}),s.typeHierarchySub=new s("type-hierarchy-sub",{fontCharacter:"\\ebba"}),s.typeHierarchySuper=new s("type-hierarchy-super",{fontCharacter:"\\ebbb"}),s.gitPullRequestCreate=new s("git-pull-request-create",{fontCharacter:"\\ebbc"}),s.runAbove=new s("run-above",{fontCharacter:"\\ebbd"}),s.runBelow=new s("run-below",{fontCharacter:"\\ebbe"}),s.notebookTemplate=new s("notebook-template",{fontCharacter:"\\ebbf"}),s.debugRerun=new s("debug-rerun",{fontCharacter:"\\ebc0"}),s.workspaceTrusted=new s("workspace-trusted",{fontCharacter:"\\ebc1"}),s.workspaceUntrusted=new s("workspace-untrusted",{fontCharacter:"\\ebc2"}),s.workspaceUnspecified=new s("workspace-unspecified",{fontCharacter:"\\ebc3"}),s.terminalCmd=new s("terminal-cmd",{fontCharacter:"\\ebc4"}),s.terminalDebian=new s("terminal-debian",{fontCharacter:"\\ebc5"}),s.terminalLinux=new s("terminal-linux",{fontCharacter:"\\ebc6"}),s.terminalPowershell=new s("terminal-powershell",{fontCharacter:"\\ebc7"}),s.terminalTmux=new s("terminal-tmux",{fontCharacter:"\\ebc8"}),s.terminalUbuntu=new s("terminal-ubuntu",{fontCharacter:"\\ebc9"}),s.dropDownButton=new s("drop-down-button",s.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(me[94],ge([0,1,19,6]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(g){const l=g;return l?[l.on,l.pause,l.resume,l.destroy].every(d=>typeof d=="function"):!1}e.isReadableStream=T;function A(g){const l=g;return l?T(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=A;function y(g,l){return new k(g,l)}e.newWriteableStream=y;class k{constructor(l,d){this.reducer=l,this.options=d,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var d;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((d=this.options)===null||d===void 0?void 0:d.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(d=>d(l))}emitError(l){this.listeners.error.length===0?(0,b.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(d=>d(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,d){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(d),this.resume();break;case"end":this.listeners.end.push(d),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(d),this.state.flowing&&this.flowErrors();break}}removeListener(l,d){if(!this.state.destroyed){let n;switch(l){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const t=n.indexOf(d);t>=0&&n.splice(t,1)}}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const d=[...this.pendingWritePromises];this.pendingWritePromises.length=0,d.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(g,l){const d=[];let n;for(;(n=g.read())!==null;)d.push(n);return l(d)}e.consumeReadable=D;function P(g,l,d){const n=[];let t;for(;(t=g.read())!==null&&n.length<d;)n.push(t);return t===null&&n.length>0?l(n):{read:()=>{if(n.length>0)return n.shift();if(typeof t!="undefined"){const r=t;return t=void 0,r}return g.read()}}}e.peekReadable=P;function s(g,l){return new Promise((d,n)=>{const t=[];C(g,{onData:r=>{l&&t.push(r)},onError:r=>{l?n(r):d(void 0)},onEnd:()=>{d(l?l(t):void 0)}})})}e.consumeStream=s;function C(g,l){g.on("error",d=>l.onError(d)),g.on("end",()=>l.onEnd()),g.on("data",d=>l.onData(d))}e.listenStream=C;function f(g,l){return new Promise((d,n)=>{const t=new I.DisposableStore,r=[],i=m=>{if(r.push(m),r.length>l)return t.dispose(),g.pause(),d({stream:g,buffer:r,ended:!1})},o=m=>n(m),c=()=>d({stream:g,buffer:r,ended:!0});t.add((0,I.toDisposable)(()=>g.removeListener("error",o))),g.on("error",o),t.add((0,I.toDisposable)(()=>g.removeListener("end",c))),g.on("end",c),t.add((0,I.toDisposable)(()=>g.removeListener("data",i))),g.on("data",i)})}e.peekStream=f;function h(g,l){const d=y(l);return d.end(g),d}e.toStream=h;function a(){const g=y(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=a;function u(g){let l=!1;return{read:()=>l?null:(l=!0,g)}}e.toReadable=u;function E(g,l,d){const n=y(d);return C(g,{onData:t=>n.write(l.data(t)),onError:t=>n.error(l.error?l.error(t):t),onEnd:()=>n.end()}),n}e.transform=E;function v(g,l,d){let n=!1;return{read:()=>{const t=l.read();return n?t:(n=!0,t!==null?d([g,t]):g)}}}e.prefixedReadable=v;function _(g,l,d){let n=!1;const t=y(d);return C(l,{onData:r=>n?t.write(r):(n=!0,t.write(d([g,r]))),onError:r=>t.error(r),onEnd:()=>{n||(n=!0,t.write(g)),t.end()}}),t}e.prefixedStream=_}),define(me[10],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function b(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=b;const I=/{(\d+)}/g;function T(K,...se){return se.length===0?K:K.replace(I,function(fe,Z){const ne=parseInt(Z,10);return isNaN(ne)||ne<0||ne>=se.length?fe:se[ne]})}e.format=T;function A(K){return K.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=A;function y(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function k(K,se){let fe=0;const Z=se.charCodeAt(0);for(let ne=K.length-1;ne>=0;ne--)K.charCodeAt(ne)===Z&&fe++;return fe}e.count=k;function D(K,se,fe="\u2026"){return K.length<=se?K:`${K.substr(0,se)}${fe}`}e.truncate=D;function P(K,se=" "){const fe=s(K,se);return C(fe,se)}e.trim=P;function s(K,se){if(!K||!se)return K;const fe=se.length;if(fe===0||K.length===0)return K;let Z=0;for(;K.indexOf(se,Z)===Z;)Z=Z+fe;return K.substring(Z)}e.ltrim=s;function C(K,se){if(!K||!se)return K;const fe=se.length,Z=K.length;if(fe===0||Z===0)return K;let ne=Z,ce=-1;for(;ce=K.lastIndexOf(se,ne-1),!(ce===-1||ce+fe!==ne);){if(ce===0)return"";ne=ce}return K.substring(0,ne)}e.rtrim=C;function f(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function h(K){return K.replace(/\*/g,"")}e.stripWildcards=h;function a(K,se,fe={}){if(!K)throw new Error("Cannot create regex from empty string");se||(K=y(K)),fe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Z="";return fe.global&&(Z+="g"),fe.matchCase||(Z+="i"),fe.multiline&&(Z+="m"),fe.unicode&&(Z+="u"),new RegExp(K,Z)}e.createRegExp=a;function u(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function E(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function v(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=v;function _(K){return K.split(/\r\n|\r|\n/)}e.splitLines=_;function g(K){for(let se=0,fe=K.length;se<fe;se++){const Z=K.charCodeAt(se);if(Z!==32&&Z!==9)return se}return-1}e.firstNonWhitespaceIndex=g;function l(K,se=0,fe=K.length){for(let Z=se;Z<fe;Z++){const ne=K.charCodeAt(Z);if(ne!==32&&ne!==9)return K.substring(se,Z)}return K.substring(se,fe)}e.getLeadingWhitespace=l;function d(K,se=K.length-1){for(let fe=se;fe>=0;fe--){const Z=K.charCodeAt(fe);if(Z!==32&&Z!==9)return fe}return-1}e.lastNonWhitespaceIndex=d;function n(K,se){return K<se?-1:K>se?1:0}e.compare=n;function t(K,se,fe=0,Z=K.length,ne=0,ce=se.length){for(;fe<Z&&ne<ce;fe++,ne++){let qe=K.charCodeAt(fe),Me=se.charCodeAt(ne);if(qe<Me)return-1;if(qe>Me)return 1}const pe=Z-fe,Se=ce-ne;return pe<Se?-1:pe>Se?1:0}e.compareSubstring=t;function r(K,se){return i(K,se,0,K.length,0,se.length)}e.compareIgnoreCase=r;function i(K,se,fe=0,Z=K.length,ne=0,ce=se.length){for(;fe<Z&&ne<ce;fe++,ne++){let qe=K.charCodeAt(fe),Me=se.charCodeAt(ne);if(qe!==Me){const He=qe-Me;if(!(He===32&&c(Me))&&!(He===-32&&c(qe)))return o(qe)&&o(Me)?He:t(K.toLowerCase(),se.toLowerCase(),fe,Z,ne,ce)}}const pe=Z-fe,Se=ce-ne;return pe<Se?-1:pe>Se?1:0}e.compareSubstringIgnoreCase=i;function o(K){return K>=97&&K<=122}e.isLowerAsciiLetter=o;function c(K){return K>=65&&K<=90}e.isUpperAsciiLetter=c;function m(K){return o(K)||c(K)}function S(K,se){return K.length===se.length&&p(K,se)}e.equalsIgnoreCase=S;function p(K,se,fe=K.length){for(let Z=0;Z<fe;Z++){const ne=K.charCodeAt(Z),ce=se.charCodeAt(Z);if(ne!==ce){if(m(ne)&&m(ce)){const pe=Math.abs(ne-ce);if(pe!==0&&pe!==32)return!1}else if(String.fromCharCode(ne).toLowerCase()!==String.fromCharCode(ce).toLowerCase())return!1}}return!0}function w(K,se){const fe=se.length;return se.length>K.length?!1:p(K,se,fe)}e.startsWithIgnoreCase=w;function R(K,se){let fe,Z=Math.min(K.length,se.length);for(fe=0;fe<Z;fe++)if(K.charCodeAt(fe)!==se.charCodeAt(fe))return fe;return Z}e.commonPrefixLength=R;function F(K,se){let fe,Z=Math.min(K.length,se.length);const ne=K.length-1,ce=se.length-1;for(fe=0;fe<Z;fe++)if(K.charCodeAt(ne-fe)!==se.charCodeAt(ce-fe))return fe;return Z}e.commonSuffixLength=F;function z(K){return 55296<=K&&K<=56319}e.isHighSurrogate=z;function oe(K){return 56320<=K&&K<=57343}e.isLowSurrogate=oe;function j(K,se){return(K-55296<<10)+(se-56320)+65536}e.computeCodePoint=j;function W(K,se,fe){const Z=K.charCodeAt(fe);if(z(Z)&&fe+1<se){const ne=K.charCodeAt(fe+1);if(oe(ne))return j(Z,ne)}return Z}e.getNextCodePoint=W;function $(K,se){const fe=K.charCodeAt(se-1);if(oe(fe)&&se>1){const Z=K.charCodeAt(se-2);if(z(Z))return j(Z,fe)}return fe}function U(K,se){const fe=$e.getInstance(),Z=se,ne=K.length,ce=W(K,ne,se);se+=ce>=65536?2:1;let pe=fe.getGraphemeBreakType(ce);for(;se<ne;){const Se=W(K,ne,se),qe=fe.getGraphemeBreakType(Se);if(xe(pe,qe))break;se+=Se>=65536?2:1,pe=qe}return se-Z}e.nextCharLength=U;function M(K,se){const fe=$e.getInstance(),Z=se,ne=$(K,se);se-=ne>=65536?2:1;let ce=fe.getGraphemeBreakType(ne);for(;se>0;){const pe=$(K,se),Se=fe.getGraphemeBreakType(pe);if(xe(Se,ce))break;se-=pe>=65536?2:1,ce=Se}return Z-se}e.prevCharLength=M;function L(K,se){const fe=$e.getInstance(),Z=K.length,ne=se,ce=W(K,Z,se),pe=fe.getGraphemeBreakType(ce);se+=ce>=65536?2:1;let Se=pe;for(;se<Z;){const Me=W(K,Z,se),He=fe.getGraphemeBreakType(Me);if(xe(Se,He))break;se+=Me>=65536?2:1,Se=He}const qe=se;for(se=ne,Se=pe;se>0;){const Me=$(K,se),He=fe.getGraphemeBreakType(Me);if(xe(He,Se))break;se-=Me>=65536?2:1,Se=He}return[se,qe]}function N(K,se){return se>0&&oe(K.charCodeAt(se))?L(K,se-1):L(K,se)}e.getCharContainingOffset=N;function O(K){const se=K.length;let fe=0,Z=0;for(;Z<se;){const pe=W(K,se,Z);Z+=pe>=65536?2:1,pe<128?fe+=1:pe<2048?fe+=2:pe<65536?fe+=3:fe+=4}const ne=new Uint8Array(fe);Z=0;let ce=0;for(;Z<se;){const pe=W(K,se,Z);Z+=pe>=65536?2:1,pe<128?ne[ce++]=pe:pe<2048?(ne[ce++]=192|(pe&1984)>>>6,ne[ce++]=128|(pe&63)>>>0):pe<65536?(ne[ce++]=224|(pe&61440)>>>12,ne[ce++]=128|(pe&4032)>>>6,ne[ce++]=128|(pe&63)>>>0):(ne[ce++]=240|(pe&1835008)>>>18,ne[ce++]=128|(pe&258048)>>>12,ne[ce++]=128|(pe&4032)>>>6,ne[ce++]=128|(pe&63)>>>0)}return ne}e.encodeUTF8=O;function B(K){const se=K.byteLength,fe=[];let Z=0;for(;Z<se;){const ne=K[Z];let ce;if(ne>=240&&Z+3<se?ce=(K[Z++]&7)<<18>>>0|(K[Z++]&63)<<12>>>0|(K[Z++]&63)<<6>>>0|(K[Z++]&63)<<0>>>0:ne>=224&&Z+2<se?ce=(K[Z++]&15)<<12>>>0|(K[Z++]&63)<<6>>>0|(K[Z++]&63)<<0>>>0:ne>=192&&Z+1<se?ce=(K[Z++]&31)<<6>>>0|(K[Z++]&63)<<0>>>0:ce=K[Z++],ce>=0&&ce<=55295||ce>=57344&&ce<=65535)fe.push(String.fromCharCode(ce));else if(ce>=65536&&ce<=1114111){const pe=ce-65536,Se=55296+((pe&1047552)>>>10),qe=56320+((pe&1023)>>>0);fe.push(String.fromCharCode(Se)),fe.push(String.fromCharCode(qe))}else fe.push(String.fromCharCode(65533))}return fe.join("")}e.decodeUTF8=B;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(K){return q.test(K)}e.containsRTL=Q;const he=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ve(K){return he.test(K)}e.containsEmoji=ve;const Ie=/^[\t\n\r\x20-\x7E]*$/;function ke(K){return Ie.test(K)}e.isBasicASCII=ke,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Le;function V(K){for(let se=0,fe=K.length;se<fe;se++)if(J(K.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=V;function J(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=J;function ee(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=ee;function ae(K,se){if(K.length<se)return K;const fe=/\b/g;let Z=0;for(;fe.test(K)&&!(K.length-fe.lastIndex<se);)Z=fe.lastIndex,fe.lastIndex+=1;return K.substring(Z).replace(/^\s/,"")}e.lcut=ae;const we=/\x1B\x5B[12]?K/g,Ce=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function be(K){return K&&(K=K.replace(we,""),K=K.replace(Ce,""),K=K.replace(Oe,"")),K}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Pe(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Pe;function Re(K){return Pe(K)?K.substr(1):K}e.stripUTF8BOM=Re;function We(K,se){if(!K||!se||K.length<se.length)return!1;const fe=se.length,Z=K.toLowerCase();let ne=0,ce=-1;for(;ne<fe;){const pe=Z.indexOf(se[ne],ce+1);if(pe<0)return!1;ce=pe,ne++}return!0}e.fuzzyContains=We;function Ee(K,se=!1){return K?(se&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Ee;function Ke(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ke;function X(K,se=1){if(se===0)return"";let fe=-1;do fe=K.indexOf(`
`,fe+1),se--;while(se>0&&fe>=0);return fe===-1?K:(K[fe-1]==="\r"&&fe--,K.substr(0,fe))}e.getNLines=X;function ie(K){const se=90-65+1;return K=K%(2*se),K<se?String.fromCharCode(97+K):String.fromCharCode(65+K-se)}e.singleLetterHash=ie;function _e(K){return $e.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=_e;function xe(K,se){return K===0?se!==5&&se!==7:K===2&&se===3?!1:K===4||K===2||K===3||se===4||se===2||se===3?!0:!(K===8&&(se===8||se===9||se===11||se===12)||(K===11||K===9)&&(se===9||se===10)||(K===12||K===10)&&se===10||se===5||se===13||se===7||K===1||K===13&&se===14||K===6&&se===6)}e.breakBetweenGraphemeBreakType=xe;var ze;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Ye()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const fe=this._data,Z=fe.length/3;let ne=1;for(;ne<=Z;)if(se<fe[3*ne])ne=2*ne;else if(se>fe[3*ne+1])ne=2*ne+1;else return fe[3*ne+2];return 0}}$e._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(me[22],ge([0,1,10,94]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let k,D;class P{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return T?new P(Buffer.allocUnsafe(m)):new P(new Uint8Array(m))}static wrap(m){return T&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new P(m)}static fromString(m,S){return!((S==null?void 0:S.dontUseNodeBuffer)||!1)&&T?new P(Buffer.from(m)):A?(k||(k=new TextEncoder),new P(k.encode(m))):new P(b.encodeUTF8(m))}static concat(m,S){if(typeof S=="undefined"){S=0;for(let R=0,F=m.length;R<F;R++)S+=m[R].byteLength}const p=P.alloc(S);let w=0;for(let R=0,F=m.length;R<F;R++){const z=m[R];p.set(z,w),w+=z.byteLength}return p}toString(){return T?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):b.decodeUTF8(this.buffer)}slice(m,S){return new P(this.buffer.subarray(m,S))}set(m,S){m instanceof P?this.buffer.set(m.buffer,S):this.buffer.set(m,S)}readUInt32BE(m){return f(this.buffer,m)}writeUInt32BE(m,S){h(this.buffer,m,S)}readUInt32LE(m){return a(this.buffer,m)}writeUInt32LE(m,S){u(this.buffer,m,S)}readUInt8(m){return E(this.buffer,m)}writeUInt8(m,S){v(this.buffer,m,S)}}e.VSBuffer=P;function s(c,m){return c[m+0]<<0>>>0|c[m+1]<<8>>>0}e.readUInt16LE=s;function C(c,m,S){c[S+0]=m&255,m=m>>>8,c[S+1]=m&255}e.writeUInt16LE=C;function f(c,m){return c[m]*2**24+c[m+1]*2**16+c[m+2]*2**8+c[m+3]}e.readUInt32BE=f;function h(c,m,S){c[S+3]=m,m=m>>>8,c[S+2]=m,m=m>>>8,c[S+1]=m,m=m>>>8,c[S]=m}e.writeUInt32BE=h;function a(c,m){return c[m+0]<<0>>>0|c[m+1]<<8>>>0|c[m+2]<<16>>>0|c[m+3]<<24>>>0}e.readUInt32LE=a;function u(c,m,S){c[S+0]=m&255,m=m>>>8,c[S+1]=m&255,m=m>>>8,c[S+2]=m&255,m=m>>>8,c[S+3]=m&255}e.writeUInt32LE=u;function E(c,m){return c[m]}e.readUInt8=E;function v(c,m,S){c[S]=m}e.writeUInt8=v;function _(c){return I.consumeReadable(c,m=>P.concat(m))}e.readableToBuffer=_;function g(c){return I.toReadable(c)}e.bufferToReadable=g;function l(c){return I.consumeStream(c,m=>P.concat(m))}e.streamToBuffer=l;async function d(c){return c.ended?P.concat(c.buffer):P.concat([...c.buffer,await l(c.stream)])}e.bufferedStreamToBuffer=d;function n(c){return I.toStream(c,m=>P.concat(m))}e.bufferToStream=n;function t(c){return I.transform(c,{data:m=>typeof m=="string"?P.fromString(m):P.wrap(m)},m=>P.concat(m))}e.streamToBufferReadableStream=t;function r(c){return I.newWriteableStream(m=>P.concat(m),c)}e.newWriteableBufferStream=r;function i(c,m){return I.prefixedReadable(c,m,S=>P.concat(S))}e.prefixedBufferReadable=i;function o(c,m){return I.prefixedStream(c,m,S=>P.concat(S))}e.prefixedBufferStream=o}),define(me[73],ge([0,1,10]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(v){return T(v,0)}e.hash=I;function T(v,_){switch(typeof v){case"object":return v===null?A(349,_):Array.isArray(v)?D(v,_):P(v,_);case"string":return k(v,_);case"boolean":return y(v,_);case"number":return A(v,_);case"undefined":return A(937,_);default:return A(617,_)}}e.doHash=T;function A(v,_){return(_<<5)-_+v|0}function y(v,_){return A(v?433:863,_)}function k(v,_){_=A(149417,_);for(let g=0,l=v.length;g<l;g++)_=A(v.charCodeAt(g),_);return _}e.stringHash=k;function D(v,_){return _=A(104579,_),v.reduce((g,l)=>T(l,g),_)}function P(v,_){return _=A(181387,_),Object.keys(v).sort().reduce((g,l)=>(g=k(l,g),T(v[l],g)),_)}class s{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=T(_,this._value),this._value}}e.Hasher=s;var C;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function f(v,_,g=32){const l=g-_,d=~((1<<l)-1);return(v<<_|(d&v)>>>l)>>>0}function h(v,_=0,g=v.byteLength,l=0){for(let d=0;d<g;d++)v[_+d]=l}function a(v,_,g="0"){for(;v.length<_;)v=g+v;return v}function u(v,_=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(g=>g.toString(16).padStart(2,"0")).join(""):a((v>>>0).toString(16),_/4)}e.toHexString=u;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const g=_.length;if(g!==0){const l=this._buff;let d=this._buffLen,n=this._leftoverHighSurrogate,t,r;for(n!==0?(t=n,r=-1,n=0):(t=_.charCodeAt(0),r=0);;){let i=t;if(b.isHighSurrogate(t))if(r+1<g){const o=_.charCodeAt(r+1);b.isLowSurrogate(o)?(r++,i=b.computeCodePoint(t,o)):i=65533}else{n=t;break}else b.isLowSurrogate(t)&&(i=65533);if(d=this._push(l,d,i),r++,r<g)t=_.charCodeAt(r);else break}this._buffLen=d,this._leftoverHighSurrogate=n}}_push(_,g,l){return l<128?_[g++]=l:l<2048?(_[g++]=192|(l&1984)>>>6,_[g++]=128|(l&63)>>>0):l<65536?(_[g++]=224|(l&61440)>>>12,_[g++]=128|(l&4032)>>>6,_[g++]=128|(l&63)>>>0):(_[g++]=240|(l&1835008)>>>18,_[g++]=128|(l&258048)>>>12,_[g++]=128|(l&4032)>>>6,_[g++]=128|(l&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=E._bigBlock32,g=this._buffDV;for(let m=0;m<64;m+=4)_.setUint32(m,g.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)_.setUint32(m,f(_.getUint32(m-12,!1)^_.getUint32(m-32,!1)^_.getUint32(m-56,!1)^_.getUint32(m-64,!1),1),!1);let l=this._h0,d=this._h1,n=this._h2,t=this._h3,r=this._h4,i,o,c;for(let m=0;m<80;m++)m<20?(i=d&n|~d&t,o=1518500249):m<40?(i=d^n^t,o=1859775393):m<60?(i=d&n|d&t|n&t,o=2400959708):(i=d^n^t,o=3395469782),c=f(l,5)+i+r+o+_.getUint32(m*4,!1)&4294967295,r=t,t=n,n=f(d,30),d=l,l=c;this._h0=this._h0+l&4294967295,this._h1=this._h1+d&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+t&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[57],ge([0,1,10]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(I||(I={})),function(T){const A="error",y="warning",k="warn",D="info";function P(s){return s?b.equalsIgnoreCase(A,s)?T.Error:b.equalsIgnoreCase(y,s)||b.equalsIgnoreCase(k,s)?T.Warning:b.equalsIgnoreCase(D,s)?T.Info:T.Ignore:T.Ignore}T.fromValue=P}(I||(I={})),e.default=I}),define(me[12],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(m){return Array.isArray(m)}e.isArray=b;function I(m){return typeof m=="string"}e.isString=I;function T(m){return Array.isArray(m)&&m.every(S=>I(S))}e.isStringArray=T;function A(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=A;function y(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=y;function k(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=k;function D(m){return m===!0||m===!1}e.isBoolean=D;function P(m){return typeof m=="undefined"}e.isUndefined=P;function s(m){return!C(m)}e.isDefined=s;function C(m){return P(m)||m===null}e.isUndefinedOrNull=C;function f(m,S){if(!m)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}e.assertType=f;function h(m){if(C(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=h;function a(...m){const S=[];for(let p=0;p<m.length;p++){const w=m[p];if(C(w))throw new Error(`Assertion Failed: argument at index ${p} is undefined or null`);S.push(w)}return S}e.assertAllDefined=a;const u=Object.prototype.hasOwnProperty;function E(m){if(!A(m))return!1;for(let S in m)if(u.call(m,S))return!1;return!0}e.isEmptyObject=E;function v(m){return typeof m=="function"}e.isFunction=v;function _(...m){return m.length>0&&m.every(v)}e.areFunctions=_;function g(m,S){const p=Math.min(m.length,S.length);for(let w=0;w<p;w++)l(m[w],S[w])}e.validateConstraints=g;function l(m,S){if(I(S)){if(typeof m!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(v(S)){try{if(m instanceof S)return}catch(p){}if(!C(m)&&m.constructor===S||S.length===1&&S.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function d(m){let S=[],p=Object.getPrototypeOf(m);for(;Object.prototype!==p;)S=S.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return S}e.getAllPropertyNames=d;function n(m){const S=[];for(const p of d(m))typeof m[p]=="function"&&S.push(p);return S}e.getAllMethodNames=n;function t(m,S){const p=R=>function(){const F=Array.prototype.slice.call(arguments,0);return S(R,F)};let w={};for(const R of m)w[R]=p(R);return w}e.createProxyObject=t;function r(m){return m===null?void 0:m}e.withNullAsUndefined=r;function i(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=i;function o(m){return class{constructor(){return new Proxy({},{get(S,p){if(S[p])return S[p];throw new Error(`Not Implemented: ${m}->${String(p)}`)}})}}}e.NotImplementedProxy=o;function c(m){throw new Error("Unreachable")}e.assertNever=c}),define(me[29],ge([0,1,9,10,8,12]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(t){return t===47||t===92}e.isPathSeparator=y;function k(t){return t.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=k;function D(t,r=T.posix.sep){if(!t)return"";const i=t.length,o=t.charCodeAt(0);if(y(o)){if(y(t.charCodeAt(1))&&!y(t.charCodeAt(2))){let m=3;const S=m;for(;m<i&&!y(t.charCodeAt(m));m++);if(S!==m&&!y(t.charCodeAt(m+1))){for(m+=1;m<i;m++)if(y(t.charCodeAt(m)))return t.slice(0,m+1).replace(/[\\/]/g,r)}}return r}else if(E(o)&&t.charCodeAt(1)===58)return y(t.charCodeAt(2))?t.slice(0,2)+r:t.slice(0,2);let c=t.indexOf("://");if(c!==-1){for(c+=3;c<i;c++)if(y(t.charCodeAt(c)))return t.slice(0,c+1)}return""}e.getRoot=D;function P(t){if(!b.isWindows||!t||t.length<5)return!1;let r=t.charCodeAt(0);if(r!==92||(r=t.charCodeAt(1),r!==92))return!1;let i=2;const o=i;for(;i<t.length&&(r=t.charCodeAt(i),r!==92);i++);return!(o===i||(r=t.charCodeAt(i+1),isNaN(r)||r===92))}e.isUNC=P;const s=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(t,r=b.isWindows){const i=r?s:C;return!(!t||t.length===0||/^\s+$/.test(t)||(i.lastIndex=0,i.test(t))||r&&f.test(t)||t==="."||t===".."||r&&t[t.length-1]==="."||r&&t.length!==t.trim().length||t.length>255)}e.isValidBasename=h;function a(t,r,i){const o=t===r;return!i||o?o:!t||!r?!1:(0,I.equalsIgnoreCase)(t,r)}e.isEqual=a;function u(t,r,i,o=T.sep){if(t===r)return!0;if(!t||!r||r.length>t.length)return!1;if(i){if(!(0,I.startsWithIgnoreCase)(t,r))return!1;if(r.length===t.length)return!0;let m=r.length;return r.charAt(r.length-1)===o&&m--,t.charAt(m)===o}return r.charAt(r.length-1)!==o&&(r+=o),t.indexOf(r)===0}e.isEqualOrParent=u;function E(t){return t>=65&&t<=90||t>=97&&t<=122}e.isWindowsDriveLetter=E;function v(t,r){return b.isWindows&&t.endsWith(":")&&(t+=T.sep),(0,T.isAbsolute)(t)||(t=(0,T.join)(r,t)),t=(0,T.normalize)(t),b.isWindows?(t=(0,I.rtrim)(t,T.sep),t.endsWith(":")&&(t+=T.sep)):(t=(0,I.rtrim)(t,T.sep),t||(t=T.sep)),t}e.sanitizeFilePath=v;function _(t){const r=(0,T.normalize)(t);return b.isWindows?t.length>3?!1:g(r)&&(t.length===2||r.charCodeAt(2)===92):r===T.posix.sep}e.isRootOrDriveLetter=_;function g(t){return b.isWindows?E(t.charCodeAt(0))&&t.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function l(t){return g(t)?t[0]:void 0}e.getDriveLetter=l;function d(t,r,i){return r.length>t.length?-1:t===r?0:(i&&(t=t.toLowerCase(),r=r.toLowerCase()),t.indexOf(r))}e.indexOfPath=d;function n(t){const r=t.split(":");let i,o,c;if(r.forEach(m=>{const S=Number(m);(0,A.isNumber)(S)?o===void 0?o=S:c===void 0&&(c=S):i=i?[i,m].join(":"):m}),!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:o!==void 0?o:void 0,column:c!==void 0?c:o!==void 0?1:void 0}}e.parseLineAndColumnAware=n}),define(me[23],ge([0,1,12]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const u=Array.isArray(a)?[]:{};return Object.keys(a).forEach(E=>{a[E]&&typeof a[E]=="object"?u[E]=I(a[E]):u[E]=a[E]}),u}e.deepClone=I;function T(a){if(!a||typeof a!="object")return a;const u=[a];for(;u.length>0;){const E=u.shift();Object.freeze(E);for(const v in E)if(A.call(E,v)){const _=E[v];typeof _=="object"&&!Object.isFrozen(_)&&u.push(_)}}return a}e.deepFreeze=T;const A=Object.prototype.hasOwnProperty;function y(a,u){return k(a,u,new Set)}e.cloneAndChange=y;function k(a,u,E){if((0,b.isUndefinedOrNull)(a))return a;const v=u(a);if(typeof v!="undefined")return v;if((0,b.isArray)(a)){const _=[];for(const g of a)_.push(k(g,u,E));return _}if((0,b.isObject)(a)){if(E.has(a))throw new Error("Cannot clone recursive data-structure");E.add(a);const _={};for(let g in a)A.call(a,g)&&(_[g]=k(a[g],u,E));return E.delete(a),_}return a}function D(a,u,E=!0){return(0,b.isObject)(a)?((0,b.isObject)(u)&&Object.keys(u).forEach(v=>{v in a?E&&((0,b.isObject)(a[v])&&(0,b.isObject)(u[v])?D(a[v],u[v],E):a[v]=u[v]):a[v]=u[v]}),a):u}e.mixin=D;function P(a,u){if(a===u)return!0;if(a==null||u===null||u===void 0||typeof a!=typeof u||typeof a!="object"||Array.isArray(a)!==Array.isArray(u))return!1;let E,v;if(Array.isArray(a)){if(a.length!==u.length)return!1;for(E=0;E<a.length;E++)if(!P(a[E],u[E]))return!1}else{const _=[];for(v in a)_.push(v);_.sort();const g=[];for(v in u)g.push(v);if(g.sort(),!P(_,g))return!1;for(E=0;E<_.length;E++)if(!P(a[_[E]],u[_[E]]))return!1}return!0}e.equals=P;function s(a){const u=new Set;return JSON.stringify(a,(E,v)=>{if((0,b.isObject)(v)||Array.isArray(v)){if(u.has(v))return"[Circular]";u.add(v)}return v})}e.safeStringify=s;function C(a,u,E){const v=u(a);return typeof v=="undefined"?E:v}e.getOrDefault=C;function f(a,u){const E=Object.create(null);return!a||!u||Object.keys(u).forEach(_=>{const g=a[_],l=u[_];P(g,l)||(E[_]=l)}),E}e.distinct=f;function h(a,u){const E=u.toLowerCase(),v=Object.keys(a).find(_=>_.toLowerCase()===E);return v?a[v]:a[u]}e.getCaseInsensitive=h}),define(me[95],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var b;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b=e.Constants||(e.Constants={}));function I(A){return A<0?0:A>255?255:A|0}e.toUint8=I;function T(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=T}),define(me[2],ge([0,1,9,8]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,A=/^\//,y=/^\/\//;function k(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!T.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!A.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(r,i){return!r&&!i?"file":r}function P(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const s="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(i,o,c,m,S,p=!1){typeof i=="object"?(this.scheme=i.scheme||s,this.authority=i.authority||s,this.path=i.path||s,this.query=i.query||s,this.fragment=i.fragment||s):(this.scheme=D(i,p),this.authority=o||s,this.path=P(this.scheme,c||s),this.query=m||s,this.fragment=S||s,k(this,p))}static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return g(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:c,path:m,query:S,fragment:p}=i;return o===void 0?o=this.scheme:o===null&&(o=s),c===void 0?c=this.authority:c===null&&(c=s),m===void 0?m=this.path:m===null&&(m=s),S===void 0?S=this.query:S===null&&(S=s),p===void 0?p=this.fragment:p===null&&(p=s),o===this.scheme&&c===this.authority&&m===this.path&&S===this.query&&p===this.fragment?this:new u(o,c,m,S,p)}static parse(i,o=!1){const c=f.exec(i);return c?new u(c[2]||s,t(c[4]||s),t(c[5]||s),t(c[7]||s),t(c[9]||s),o):new u(s,s,s,s,s)}static file(i){let o=s;if(b.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const c=i.indexOf(C,2);c===-1?(o=i.substring(2),i=C):(o=i.substring(2,c),i=i.substring(c)||C)}return new u("file",o,i,s,s)}static from(i){return new u(i.scheme,i.authority,i.path,i.query,i.fragment)}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return b.isWindows&&i.scheme==="file"?c=h.file(I.win32.join(g(i,!0),...o)).path:c=I.posix.join(i.path,...o),i.with({path:c})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const o=new u(i);return o._formatted=i.external,o._fsPath=i._sep===a?i.fsPath:null,o}}else return i}}e.URI=h;const a=b.isWindows?1:void 0;class u extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=a),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(r,i){let o,c=-1;for(let m=0;m<r.length;m++){const S=r.charCodeAt(m);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||i&&S===47)c!==-1&&(o+=encodeURIComponent(r.substring(c,m)),c=-1),o!==void 0&&(o+=r.charAt(m));else{o===void 0&&(o=r.substr(0,m));const p=E[S];p!==void 0?(c!==-1&&(o+=encodeURIComponent(r.substring(c,m)),c=-1),o+=p):c===-1&&(c=m)}}return c!==-1&&(o+=encodeURIComponent(r.substring(c))),o!==void 0?o:r}function _(r){let i;for(let o=0;o<r.length;o++){const c=r.charCodeAt(o);c===35||c===63?(i===void 0&&(i=r.substr(0,o)),i+=E[c]):i!==void 0&&(i+=r[o])}return i!==void 0?i:r}function g(r,i){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,b.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=g;function l(r,i){const o=i?_:v;let c="",{scheme:m,authority:S,path:p,query:w,fragment:R}=r;if(m&&(c+=m,c+=":"),(S||m==="file")&&(c+=C,c+=C),S){let F=S.indexOf("@");if(F!==-1){const z=S.substr(0,F);S=S.substr(F+1),F=z.indexOf(":"),F===-1?c+=o(z,!1):(c+=o(z.substr(0,F),!1),c+=":",c+=o(z.substr(F+1),!1)),c+="@"}S=S.toLowerCase(),F=S.indexOf(":"),F===-1?c+=o(S,!1):(c+=o(S.substr(0,F),!1),c+=S.substr(F))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const F=p.charCodeAt(1);F>=65&&F<=90&&(p=`/${String.fromCharCode(F+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const F=p.charCodeAt(0);F>=65&&F<=90&&(p=`${String.fromCharCode(F+32)}:${p.substr(2)}`)}c+=o(p,!0)}return w&&(c+="?",c+=o(w,!1)),R&&(c+="#",c+=i?R:v(R,!1)),c}function d(r){try{return decodeURIComponent(r)}catch(i){return r.length>3?r.substr(0,3)+d(r.substr(3)):r}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function t(r){return r.match(n)?r.replace(n,i=>d(i)):r}});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[24],ge([0,1,2,10]),function(G,e,b,I){"use strict";var T,A,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(n,t,r){let i=n.get(t);return i===void 0&&(i=r,n.set(t,i)),i}e.getOrSet=k;function D(n){const t=[];return n.forEach((r,i)=>{t.push(`${i} => ${r}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=D;function P(n){const t=[];return n.forEach(r=>{t.push(r)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=P;class s{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const r=t.charCodeAt(0),i=this._value.charCodeAt(this._pos);return r-i}value(){return this._value[this._pos]}}e.StringIterator=s;class C{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,I.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class f{constructor(t=!0,r=!0){this._splitOnBackslash=t,this._caseSensitive=r}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,I.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var h;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(h||(h={}));class a{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,I.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class u{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(t){this._iter=t}static forUris(t=()=>!1){return new E(new a(t))}static forPaths(){return new E(new f)}static forStrings(){return new E(new s)}static forConfigKeys(){return new E(new C)}clear(){this._root=void 0}set(t,r){const i=this._iter.reset(t);let o;for(this._root||(this._root=new u,this._root.segment=i.value()),o=this._root;;){const m=i.cmp(o.segment);if(m>0)o.left||(o.left=new u,o.left.segment=i.value()),o=o.left;else if(m<0)o.right||(o.right=new u,o.right.segment=i.value()),o=o.right;else if(i.hasNext())i.next(),o.mid||(o.mid=new u,o.mid.segment=i.value()),o=o.mid;else break}const c=o.value;return o.value=r,o.key=t,c}get(t){var r;return(r=this._getNode(t))===null||r===void 0?void 0:r.value}_getNode(t){const r=this._iter.reset(t);let i=this._root;for(;i;){const o=r.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else break}return i}has(t){const r=this._getNode(t);return!((r==null?void 0:r.value)===void 0&&(r==null?void 0:r.mid)===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,r){const i=this._iter.reset(t),o=[];let c=this._root;for(;c;){const m=i.cmp(c.segment);if(m>0)o.push([1,c]),c=c.left;else if(m<0)o.push([-1,c]),c=c.right;else if(i.hasNext())i.next(),o.push([0,c]),c=c.mid;else{for(r?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;o.length>0&&c.isEmpty();){let[S,p]=o.pop();switch(S){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}c=p}break}}}findSubstr(t){const r=this._iter.reset(t);let i=this._root,o;for(;i;){const c=r.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(r.hasNext())r.next(),o=i.value||o,i=i.mid;else break}return i&&i.value||o}findSuperstr(t){const r=this._iter.reset(t);let i=this._root;for(;i;){const o=r.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(t){for(const[r,i]of this)t(i,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){t&&(yield*this._entries(t.left),t.value&&(yield[t.key,t.value]),yield*this._entries(t.mid),yield*this._entries(t.right))}}e.TernarySearchTree=E;class v{constructor(t,r){this[T]="ResourceMap",t instanceof v?(this.map=new Map(t.map),this.toKey=r!=null?r:v.defaultToKey):(this.map=new Map,this.toKey=t!=null?t:v.defaultToKey)}set(t,r){return this.map.set(this.toKey(t),r),this}get(t){return this.map.get(this.toKey(t))}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,r){typeof r!="undefined"&&(t=t.bind(r));for(let[i,o]of this.map)t(o,b.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let t of this.map.keys())yield b.URI.parse(t)}*entries(){for(let t of this.map.entries())yield[b.URI.parse(t[0]),t[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let t of this.map)yield[b.URI.parse(t[0]),t[1]]}}e.ResourceMap=v,v.defaultToKey=n=>n.toString();var _;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(_=e.Touch||(e.Touch={}));class g{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var t;return(t=this._head)===null||t===void 0?void 0:t.value}get last(){var t;return(t=this._tail)===null||t===void 0?void 0:t.value}has(t){return this._map.has(t)}get(t,r=0){const i=this._map.get(t);if(!!i)return r!==0&&this.touch(i,r),i.value}set(t,r,i=0){let o=this._map.get(t);if(o)o.value=r,i!==0&&this.touch(o,i);else{switch(o={key:t,value:r,next:void 0,previous:void 0},i){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(t,o),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this._map.get(t);if(!!r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}}forEach(t,r){const i=this._state;let o=this._head;for(;o;){if(r?t.bind(r)(o.value,o.key,this):t(o.value,o.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const t=this,r=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const c={value:i.key,done:!1};return i=i.next,c}else return{value:void 0,done:!0}}};return o}values(){const t=this,r=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const c={value:i.value,done:!1};return i=i.next,c}else return{value:void 0,done:!0}}};return o}entries(){const t=this,r=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const c={value:[i.key,i.value],done:!1};return i=i.next,c}else return{value:void 0,done:!0}}};return o}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(!(t>=this.size)){if(t===0){this.clear();return}let r=this._head,i=this.size;for(;r&&i>t;)this._map.delete(r.key),r=r.next,i--;this._head=r,this._size=i,r&&(r.previous=void 0),this._state++}}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const r=t.next,i=t.previous;if(!r||!i)throw new Error("Invalid list");r.previous=i,i.next=r}t.next=void 0,t.previous=void 0,this._state++}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this._head)return;const i=t.next,o=t.previous;t===this._tail?(o.next=void 0,this._tail=o):(i.previous=o,o.next=i),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(r===2){if(t===this._tail)return;const i=t.next,o=t.previous;t===this._head?(i.previous=void 0,this._head=i):(i.previous=o,o.next=i),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((r,i)=>{t.push([i,r])}),t}fromJSON(t){this.clear();for(const[r,i]of t)this.set(r,i)}}e.LinkedMap=g;class l extends g{constructor(t,r=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class d{constructor(t){y.set(this,void 0),tt(this,y,t,"f")}get size(){return Ue(this,y,"f").size}forEach(t,r){Ue(this,y,"f").forEach(t,r)}get(t){return Ue(this,y,"f").get(t)}has(t){return Ue(this,y,"f").has(t)}entries(){return Ue(this,y,"f").entries()}keys(){return Ue(this,y,"f").keys()}values(){return Ue(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Ue(this,y,"f").entries()}}e.ReadonlyMapView=d}),define(me[96],ge([0,1,24,10]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...be){return function(Pe,Re){for(let We=0,Ee=be.length;We<Ee;We++){const Ke=be[We](Pe,Re);if(Ke)return Ke}return null}}e.or=T,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(be,Pe,Re){if(!Re||Re.length<Pe.length)return null;let We;return be?We=I.startsWithIgnoreCase(Re,Pe):We=Re.indexOf(Pe)===0,We?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function y(be,Pe){const Re=Pe.toLowerCase().indexOf(be.toLowerCase());return Re===-1?null:[{start:Re,end:Re+be.length}]}e.matchesContiguousSubString=y;function k(be,Pe){return D(be.toLowerCase(),Pe.toLowerCase(),0,0)}e.matchesSubString=k;function D(be,Pe,Re,We){if(Re===be.length)return[];if(We===Pe.length)return null;if(be[Re]===Pe[We]){let Ee=null;return(Ee=D(be,Pe,Re+1,We+1))?v({start:We,end:We+1},Ee):null}return D(be,Pe,Re,We+1)}function P(be){return 97<=be&&be<=122}function s(be){return 65<=be&&be<=90}e.isUpper=s;function C(be){return 48<=be&&be<=57}function f(be){return be===32||be===9||be===10||be===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(be=>h.add(be.charCodeAt(0)));function a(be){return f(be)||h.has(be)}function u(be,Pe){return be===Pe||a(be)&&a(Pe)}function E(be){return P(be)||s(be)||C(be)}function v(be,Pe){return Pe.length===0?Pe=[be]:be.end===Pe[0].start?Pe[0].start=be.start:Pe.unshift(be),Pe}function _(be,Pe){for(let Re=Pe;Re<be.length;Re++){const We=be.charCodeAt(Re);if(s(We)||C(We)||Re>0&&!E(be.charCodeAt(Re-1)))return Re}return be.length}function g(be,Pe,Re,We){if(Re===be.length)return[];if(We===Pe.length)return null;if(be[Re]!==Pe[We].toLowerCase())return null;{let Ee=null,Ke=We+1;for(Ee=g(be,Pe,Re+1,We+1);!Ee&&(Ke=_(Pe,Ke))<Pe.length;)Ee=g(be,Pe,Re+1,Ke),Ke++;return Ee===null?null:v({start:We,end:We+1},Ee)}}function l(be){let Pe=0,Re=0,We=0,Ee=0,Ke=0;for(let ze=0;ze<be.length;ze++)Ke=be.charCodeAt(ze),s(Ke)&&Pe++,P(Ke)&&Re++,E(Ke)&&We++,C(Ke)&&Ee++;const X=Pe/be.length,ie=Re/be.length,_e=We/be.length,xe=Ee/be.length;return{upperPercent:X,lowerPercent:ie,alphaPercent:_e,numericPercent:xe}}function d(be){const{upperPercent:Pe,lowerPercent:Re}=be;return Re===0&&Pe>.6}function n(be){const{upperPercent:Pe,lowerPercent:Re,alphaPercent:We,numericPercent:Ee}=be;return Re>.2&&Pe<.8&&We>.6&&Ee<.2}function t(be){let Pe=0,Re=0,We=0,Ee=0;for(let Ke=0;Ke<be.length;Ke++)We=be.charCodeAt(Ke),s(We)&&Pe++,P(We)&&Re++,f(We)&&Ee++;return(Pe===0||Re===0)&&Ee===0?be.length<=30:Pe<=5}function r(be,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!t(be)||Pe.length>60)return null;const Re=l(Pe);if(!n(Re)){if(!d(Re))return null;Pe=Pe.toLowerCase()}let We=null,Ee=0;for(be=be.toLowerCase();Ee<Pe.length&&(We=g(be,Pe,0,Ee))===null;)Ee=_(Pe,Ee+1);return We}e.matchesCamelCase=r;function i(be,Pe,Re=!1){if(!Pe||Pe.length===0)return null;let We=null,Ee=0;for(be=be.toLowerCase(),Pe=Pe.toLowerCase();Ee<Pe.length&&(We=o(be,Pe,0,Ee,Re))===null;)Ee=c(Pe,Ee+1);return We}e.matchesWords=i;function o(be,Pe,Re,We,Ee){if(Re===be.length)return[];if(We===Pe.length)return null;if(u(be.charCodeAt(Re),Pe.charCodeAt(We))){let Ke=null,X=We+1;if(Ke=o(be,Pe,Re+1,We+1,Ee),!Ee)for(;!Ke&&(X=c(Pe,X))<Pe.length;)Ke=o(be,Pe,Re+1,X,Ee),X++;return Ke===null?null:v({start:We,end:We+1},Ke)}else return null}function c(be,Pe){for(let Re=Pe;Re<be.length;Re++)if(a(be.charCodeAt(Re))||Re>0&&a(be.charCodeAt(Re-1)))return Re;return be.length}const m=T(e.matchesPrefix,r,y),S=T(e.matchesPrefix,r,k),p=new b.LRUCache(1e4);function w(be,Pe,Re=!1){if(typeof be!="string"||typeof Pe!="string")return null;let We=p.get(be);We||(We=new RegExp(I.convertSimple2RegExpPattern(be),"i"),p.set(be,We));const Ee=We.exec(Pe);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:Re?S(be,Pe):m(be,Pe)}e.matchesFuzzy=w;function R(be,Pe){const Re=V(be,be.toLowerCase(),0,Pe,Pe.toLowerCase(),0,!0);return Re?z(Re):null}e.matchesFuzzy2=R;function F(be,Pe,Re,We,Ee,Ke){const X=Math.min(13,be.length);for(;Re<X;Re++){const ie=V(be,Pe,Re,We,Ee,Ke,!1);if(ie)return ie}return[0,Ke]}e.anyScore=F;function z(be){if(typeof be=="undefined")return[];const Pe=[],Re=be[1];for(let We=be.length-1;We>1;We--){const Ee=be[We]+Re,Ke=Pe[Pe.length-1];Ke&&Ke.end===Ee?Ke.end=Ee+1:Pe.push({start:Ee,end:Ee+1})}return Pe}e.createMatches=z;const oe=128;function j(){const be=[],Pe=[];for(let Re=0;Re<=oe;Re++)Pe[Re]=0;for(let Re=0;Re<=oe;Re++)be.push(Pe.slice(0));return be}function W(be){const Pe=[];for(let Re=0;Re<=be;Re++)Pe[Re]=0;return Pe}const $=W(2*oe),U=W(2*oe),M=j(),L=j(),N=j(),O=!1;function B(be,Pe,Re,We,Ee){function Ke(ie,_e,xe=" "){for(;ie.length<_e;)ie=xe+ie;return ie}let X=` |   |${We.split("").map(ie=>Ke(ie,3)).join("|")}
`;for(let ie=0;ie<=Re;ie++)ie===0?X+=" |":X+=`${Pe[ie-1]}|`,X+=be[ie].slice(0,Ee+1).map(_e=>Ke(_e.toString(),3)).join("|")+`
`;return X}function q(be,Pe,Re,We){be=be.substr(Pe),Re=Re.substr(We),console.log(B(L,be,be.length,Re,Re.length)),console.log(B(N,be,be.length,Re,Re.length)),console.log(B(M,be,be.length,Re,Re.length))}function Q(be,Pe){if(Pe<0||Pe>=be.length)return!1;const Re=be.codePointAt(Pe);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Re)}}function he(be,Pe){if(Pe<0||Pe>=be.length)return!1;switch(be.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function ve(be,Pe,Re){return Pe[be]!==Re[be]}function Ie(be,Pe,Re,We,Ee,Ke,X=!1){for(;Pe<Re&&Ee<Ke;)be[Pe]===We[Ee]&&(X&&($[Pe]=Ee),Pe+=1),Ee+=1;return Pe===Re}e.isPatternInWord=Ie;var ke;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var Le;(function(be){be.Default=[-100,0];function Pe(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}be.isDefault=Pe})(Le=e.FuzzyScore||(e.FuzzyScore={}));function V(be,Pe,Re,We,Ee,Ke,X){const ie=be.length>oe?oe:be.length,_e=We.length>oe?oe:We.length;if(!(Re>=ie||Ke>=_e||ie-Re>_e-Ke)&&!!Ie(Pe,Re,ie,Ee,Ke,_e,!0)){J(ie,_e,Re,Ke,Pe,Ee);let xe=1,ze=1,$e=Re,Ye=Ke;const K=[!1];for(xe=1,$e=Re;$e<ie;xe++,$e++){const ce=$[$e],pe=U[$e],Se=$e+1<ie?U[$e+1]:_e;for(ze=ce-Ke+1,Ye=ce;Ye<Se;ze++,Ye++){let qe=Number.MIN_SAFE_INTEGER,Me=!1;Ye<=pe&&(qe=ee(be,Pe,$e,Re,We,Ee,Ye,_e,Ke,M[xe-1][ze-1]===0,K));let He=0;qe!==Number.MAX_SAFE_INTEGER&&(Me=!0,He=qe+L[xe-1][ze-1]);const Qe=Ye>ce,it=Qe?L[xe][ze-1]+(M[xe][ze-1]>0?-5:0):0,lt=Ye>ce+1&&M[xe][ze-1]>0,Ze=lt?L[xe][ze-2]+(M[xe][ze-2]>0?-5:0):0;if(lt&&(!Qe||Ze>=it)&&(!Me||Ze>=He))L[xe][ze]=Ze,N[xe][ze]=3,M[xe][ze]=0;else if(Qe&&(!Me||it>=He))L[xe][ze]=it,N[xe][ze]=2,M[xe][ze]=0;else if(Me)L[xe][ze]=He,N[xe][ze]=1,M[xe][ze]=M[xe-1][ze-1]+1;else throw new Error("not possible")}}if(O&&q(be,Re,We,Ke),!(!K[0]&&!X)){xe--,ze--;const se=[L[xe][ze],Ke];let fe=0,Z=0;for(;xe>=1;){let ce=ze;do{const pe=N[xe][ce];if(pe===3)ce=ce-2;else if(pe===2)ce=ce-1;else break}while(ce>=1);fe>1&&Pe[Re+xe-1]===Ee[Ke+ze-1]&&!ve(ce+Ke-1,We,Ee)&&fe+1>M[xe][ce]&&(ce=ze),ce===ze?fe++:fe=1,Z||(Z=ce),xe--,ze=ce-1,se.push(ze)}_e===ie&&(se[0]+=2);const ne=Z-ie;return se[0]-=ne,se}}}e.fuzzyScore=V;function J(be,Pe,Re,We,Ee,Ke){let X=be-1,ie=Pe-1;for(;X>=Re&&ie>=We;)Ee[X]===Ke[ie]&&(U[X]=ie,X--),ie--}function ee(be,Pe,Re,We,Ee,Ke,X,ie,_e,xe,ze){if(Pe[Re]!==Ke[X])return Number.MIN_SAFE_INTEGER;let $e=1,Ye=!1;return X===Re-We?$e=be[Re]===Ee[X]?7:5:ve(X,Ee,Ke)&&(X===0||!ve(X-1,Ee,Ke))?($e=be[Re]===Ee[X]?7:5,Ye=!0):Q(Ke,X)&&(X===0||!Q(Ke,X-1))?$e=5:(Q(Ke,X-1)||he(Ke,X-1))&&($e=5,Ye=!0),$e>1&&Re===We&&(ze[0]=!0),Ye||(Ye=ve(X,Ee,Ke)||Q(Ke,X-1)||he(Ke,X-1)),Re===We?X>_e&&($e-=Ye?3:5):xe?$e+=Ye?2:0:$e+=Ye?0:1,X+1===ie&&($e-=Ye?3:5),$e}function ae(be,Pe,Re,We,Ee,Ke,X){return Ce(be,Pe,Re,We,Ee,Ke,!0,X)}e.fuzzyScoreGracefulAggressive=ae;function we(be,Pe,Re,We,Ee,Ke,X){return Ce(be,Pe,Re,We,Ee,Ke,!1,X)}e.fuzzyScoreGraceful=we;function Ce(be,Pe,Re,We,Ee,Ke,X,ie){let _e=V(be,Pe,Re,We,Ee,Ke,ie);if(_e&&!X)return _e;if(be.length>=3){const xe=Math.min(7,be.length-1);for(let ze=Re+1;ze<xe;ze++){const $e=Oe(be,ze);if($e){const Ye=V($e,$e.toLowerCase(),Re,We,Ee,Ke,ie);Ye&&(Ye[0]-=3,(!_e||Ye[0]>_e[0])&&(_e=Ye))}}}return _e}function Oe(be,Pe){if(!(Pe+1>=be.length)){const Re=be[Pe],We=be[Pe+1];if(Re!==We)return be.slice(0,Pe)+We+Re+be.slice(Pe+2)}}}),define(me[136],ge([0,1,43,96,10]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${A.source}`,"g");function k(u){return u.replace(y,(E,v)=>v?E:`\\${E}`)}e.escapeIcons=k;const D=new RegExp(`\\\\${A.source}`,"g");function P(u){return u.replace(D,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=P;const s=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function C(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(s,(E,v,_,g)=>_?E:v||g||"")}e.stripIcons=C;function f(u){const E=u.indexOf(e.iconStartMarker);return E===-1?{text:u}:h(u,E)}e.parseLabelWithIcons=f;function h(u,E){const v=[];let _="";function g(c){if(c){_+=c;for(const m of c)v.push(n)}}let l=-1,d="",n=0,t,r,i=E;const o=u.length;for(g(u.substr(0,E));i<o;)t=u[i],r=u[i+1],t===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(l=i,g(d),d=e.iconStartMarker,i++):t===")"&&l!==-1?(n+=i-l+1,l=-1,d=""):l!==-1?/^[a-z0-9\-]$/i.test(t)?d+=t:(g(d),l=-1,d=""):g(t),i++;return g(d),{text:_,iconOffsets:v}}function a(u,E,v=!1){const{text:_,iconOffsets:g}=E;if(!g||g.length===0)return(0,I.matchesFuzzy)(u,_,v);const l=(0,T.ltrim)(_," "),d=_.length-l.length,n=(0,I.matchesFuzzy)(u,l,v);if(n)for(const t of n){const r=g[t.start+d]+d;t.start+=r,t.end+=r}return n}e.matchesFuzzyIconAware=a}),define(me[97],ge([0,1,15,136,19]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(u="",E=!1){var v,_;if(this.value=u,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1):(this.isTrusted=(v=E.isTrusted)!==null&&v!==void 0?v:void 0,this.supportThemeIcons=(_=E.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(u,E=0){return this.value+=C(this.supportThemeIcons?(0,I.escapeIcons)(u):u).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,E){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}}e.MarkdownString=y;function k(a){return D(a)?!a.value:Array.isArray(a)?a.every(k):!0}e.isEmptyMarkdownString=k;function D(a){return a instanceof y?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function P(a,u){return!a&&!u?!0:!a||!u?!1:Array.isArray(a)&&Array.isArray(u)?(0,b.equals)(a,u,s):D(a)&&D(u)?s(a,u):!1}e.markedStringsEquals=P;function s(a,u){return a===u?!0:!a||!u?!1:a.value===u.value&&a.isTrusted===u.isTrusted&&a.supportThemeIcons===u.supportThemeIcons}function C(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function f(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function h(a){const u=[],E=a.split("|").map(_=>_.trim());a=E[0];const v=E[1];if(v){const _=/height=(\d+)/.exec(v),g=/width=(\d+)/.exec(v),l=_?_[1]:"",d=g?g[1]:"",n=isFinite(parseInt(d)),t=isFinite(parseInt(l));n&&u.push(`width="${d}"`),t&&u.push(`height="${l}"`)}return{href:a,dimensions:u}}e.parseHrefAndDimensions=h}),define(me[58],ge([0,1,22,10,2]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(P){return JSON.stringify(P,k)}e.stringify=A;function y(P){let s=JSON.parse(P);return s=D(s),s}e.parse=y;function k(P,s){return s instanceof RegExp?{$mid:2,source:s.source,flags:(0,I.regExpFlags)(s)}:s}function D(P,s=0){if(!P||s>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return T.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof b.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let C=0;C<P.length;++C)P[C]=D(P[C],s+1);else for(const C in P)Object.hasOwnProperty.call(P,C)&&(P[C]=D(P[C],s+1))}return P}e.revive=D}),define(me[11],ge([0,1,2,9]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,s){this._hosts[D]=P,this._ports[D]=s}setConnectionToken(D,P){this._connectionTokens[D]=P}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let s=this._hosts[P];s&&s.indexOf(":")!==-1&&(s=`[${s}]`);const C=this._ports[P],f=this._connectionTokens[P];let h=`path=${encodeURIComponent(D.path)}`;return typeof f=="string"&&(h+=`&tkn=${encodeURIComponent(f)}`),b.URI.from({scheme:I.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${s}:${C}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new A;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,P,s){const C=this.toUri(D,P);return C.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(C):I.isNative&&(s||I.isPreferringBrowserCodeLoad)&&C.scheme===T.file?C.with({scheme:T.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(D,P){const s=this.toUri(D,P);return s.scheme===T.vscodeFileResource?s.with({scheme:T.file,authority:s.authority!==this.FALLBACK_AUTHORITY?s.authority:null,query:null,fragment:null}):s}toUri(D,P){return b.URI.isUri(D)?D:b.URI.parse(P.toUrl(D))}}e.FileAccess=new y}),define(me[74],ge([0,1,24]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const I=new b.LRUCache(1e4);function T(P){return D(P,"NFC",I)}e.normalizeNFC=T;const A=new b.LRUCache(1e4);function y(P){return D(P,"NFD",A)}e.normalizeNFD=y;const k=/[^\u0000-\u0080]/;function D(P,s,C){if(!e.canNormalize||!P)return P;const f=C.get(P);if(f)return f;let h;return k.test(P)?h=P.normalize(s):h=P,C.set(P,h),h}e.removeAccents=function(){if(e.canNormalize){const P=/[\u0300-\u036f]/g;return function(s){return y(s).replace(P,"")}}else return function(P){return P}}()}),define(me[25],ge([0,1,29,8,2,10,11,9]),function(G,e,b,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(h){return(0,T.uriToFsPath)(h,!0)}e.originalFSPath=D;class P{constructor(a){this._ignorePathCasing=a}compare(a,u,E=!1){return a===u?0:(0,A.compare)(this.getComparisonKey(a,E),this.getComparisonKey(u,E))}isEqual(a,u,E=!1){return a===u?!0:!a||!u?!1:this.getComparisonKey(a,E)===this.getComparisonKey(u,E)}getComparisonKey(a,u=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,u,E=!1){if(a.scheme===u.scheme){if(a.scheme===y.Schemas.file)return b.isEqualOrParent(D(a),D(u),this._ignorePathCasing(a))&&a.query===u.query&&(E||a.fragment===u.fragment);if((0,e.isEqualAuthority)(a.authority,u.authority))return b.isEqualOrParent(a.path,u.path,this._ignorePathCasing(a),"/")&&a.query===u.query&&(E||a.fragment===u.fragment)}return!1}joinPath(a,...u){return T.URI.joinPath(a,...u)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return I.posix.basename(a.path)}extname(a){return I.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let u;return a.scheme===y.Schemas.file?u=T.URI.file(I.dirname(D(a))).path:(u=I.posix.dirname(a.path),a.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),u="/")),a.with({path:u})}normalizePath(a){if(!a.path.length)return a;let u;return a.scheme===y.Schemas.file?u=T.URI.file(I.normalize(D(a))).path:u=I.posix.normalize(a.path),a.with({path:u})}relativePath(a,u){if(!(a.scheme!==u.scheme||!(0,e.isEqualAuthority)(a.authority,u.authority))){if(a.scheme===y.Schemas.file){const _=I.relative(D(a),D(u));return k.isWindows?b.toSlashes(_):_}let E=a.path||"/",v=u.path||"/";if(this._ignorePathCasing(a)){let _=0;for(const g=Math.min(E.length,v.length);_<g&&!(E.charCodeAt(_)!==v.charCodeAt(_)&&E.charAt(_).toLowerCase()!==v.charAt(_).toLowerCase());_++);E=v.substr(0,_)+E.substr(_)}return I.posix.relative(E,v)}}resolvePath(a,u){if(a.scheme===y.Schemas.file){const E=T.URI.file(I.resolve(D(a),u));return a.with({authority:E.authority,path:E.path})}return u.indexOf("/")===-1&&(u=b.toSlashes(u),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u)),a.with({path:I.posix.resolve(a.path,u)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,u){return a===u||(0,A.equalsIgnoreCase)(a,u)}hasTrailingPathSeparator(a,u=I.sep){if(a.scheme===y.Schemas.file){const E=D(a);return E.length>b.getRoot(E).length&&E[E.length-1]===u}else{const E=a.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,u=I.sep){return(0,e.hasTrailingPathSeparator)(a,u)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,u=I.sep){let E=!1;if(a.scheme===y.Schemas.file){const v=D(a);E=v!==void 0&&v.length===b.getRoot(v).length&&v[v.length-1]===u}else{u="/";const v=a.path;E=v.length===1&&v.charCodeAt(v.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(a,u)?a.with({path:a.path+"/"}):a}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(h=>h.scheme===y.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new P(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function s(h,a){const u=[];for(let E=0;E<h.length;E++){const v=a(h[E]);h.some((_,g)=>g===E?!1:(0,e.isEqualOrParent)(v,a(_)))||u.push(h[E])}return u}e.distinctParents=s;var C;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function a(u){const E=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(g=>{const[l,d]=g.split(":");l&&d&&E.set(l,d)});const _=u.path.substring(0,u.path.indexOf(";"));return _&&E.set(h.META_DATA_MIME,_),E}h.parseMetaData=a})(C=e.DataUri||(e.DataUri={}));function f(h,a,u){if(a){let E=h.path;return E&&E[0]!==I.posix.sep&&(E=I.posix.sep+E),h.with({scheme:u,authority:a,path:E})}return h.with({scheme:u})}e.toLocalResource=f}),define(me[16],ge([0,1,21,19,3,6,56,25]),function(G,e,b,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(L){return!!L&&typeof L.then=="function"}e.isThenable=D;function P(L){const N=new b.CancellationTokenSource,O=L(N.token),B=new Promise((q,Q)=>{N.token.onCancellationRequested(()=>{Q((0,I.canceled)())}),Promise.resolve(O).then(he=>{N.dispose(),q(he)},he=>{N.dispose(),Q(he)})});return new class{cancel(){N.cancel()}then(q,Q){return B.then(q,Q)}catch(q){return this.then(void 0,q)}finally(q){return B.finally(q)}}}e.createCancelablePromise=P;function s(L,N,O){return Promise.race([L,new Promise(B=>N.onCancellationRequested(()=>B(O)))])}e.raceCancellation=s;async function C(L){let N=-1;const O=L.map((q,Q)=>q.then(he=>(N=Q,he))),B=await Promise.race(O);return L.forEach((q,Q)=>{Q!==N&&q.cancel()}),B}e.raceCancellablePromises=C;function f(L,N,O){let B;const q=setTimeout(()=>{B==null||B(void 0),O==null||O()},N);return Promise.race([L.finally(()=>clearTimeout(q)),new Promise(Q=>B=Q)])}e.raceTimeout=f;function h(L){return new Promise((N,O)=>{const B=L();D(B)?B.then(N,O):N(B)})}e.asPromise=h;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(O,O).then(B)})}return new Promise((O,B)=>{this.queuedPromise.then(O,B)})}return this.activePromise=N(),new Promise((O,B)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,B(q)})})}}e.Throttler=a;class u{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=u;class E{constructor(){this.promiseMap=new Map}queue(N,O){var B;const Q=((B=this.promiseMap.get(N))!==null&&B!==void 0?B:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(N)===Q&&this.promiseMap.delete(N)});return this.promiseMap.set(N,Q),Q}}e.SequencerByKey=E;class v{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,O=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,q)=>{this.doResolve=B,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class _{constructor(N){this.delayer=new v(N),this.throttler=new a}trigger(N,O){return this.delayer.trigger(()=>this.throttler.queue(N),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class g{constructor(){this._isOpen=!1,this._promise=new Promise((N,O)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class l extends g{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function d(L,N){return N?new Promise((O,B)=>{const q=setTimeout(O,L);N.onCancellationRequested(()=>{clearTimeout(q),B((0,I.canceled)())})}):P(O=>d(L,O))}e.timeout=d;function n(L,N=0){const O=setTimeout(L,N);return(0,A.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=n;function t(L){return L.then(void 0,N=>{})}e.ignoreErrors=t;function r(L){const N=[];let O=0;const B=L.length;function q(){return O<B?L[O++]():null}function Q(he){he!=null&&N.push(he);const ve=q();return ve?ve.then(Q):Promise.resolve(N)}return Promise.resolve(null).then(Q)}e.sequence=r;function i(L,N=B=>!!B,O=null){let B=0;const q=L.length,Q=()=>{if(B>=q)return Promise.resolve(O);const he=L[B++];return Promise.resolve(he()).then(Ie=>N(Ie)?Promise.resolve(Ie):Q())};return Q()}e.first=i;function o(L,N=B=>!!B,O=null){if(L.length===0)return Promise.resolve(O);let B=L.length;const q=()=>{var Q,he;B=-1;for(const ve of L)(he=(Q=ve).cancel)===null||he===void 0||he.call(Q)};return new Promise((Q,he)=>{for(const ve of L)ve.then(Ie=>{--B>=0&&N(Ie)?(q(),Q(Ie)):B===0&&Q(O)}).catch(Ie=>{--B>=0&&(q(),he(Ie))})})}e.firstParallel=o;class c{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((O,B)=>{this.outstandingPromises.push({factory:N,c:O,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const O=N.factory();O.then(N.c,N.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class m extends c{constructor(){super(1)}}e.Queue=m;class S{constructor(){this.queues=new Map}queueFor(N,O=k.extUri){const B=O.getComparisonKey(N);let q=this.queues.get(B);return q||(q=new m,T.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(B)}),this.queues.set(B,q)),q}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=S;class p{constructor(N,O){this._token=-1,typeof N=="function"&&typeof O=="number"&&this.setIfNotSet(N,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},O)}setIfNotSet(N,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},O))}}e.TimeoutTimer=p;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setInterval(()=>{N()},O)}}e.IntervalTimer=w;class R{constructor(N,O){this.timeoutToken=-1,this.runner=N,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class F extends R{constructor(N,O){super(N,O);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const L=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const O=setTimeout(()=>N(L));let B=!1;return{dispose(){B||(B=!0,clearTimeout(O))}}}}else e.runWhenIdle=(L,N)=>{const O=requestIdleCallback(L,typeof N=="number"?{timeout:N}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(O))}}}}();class z{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function oe(L,N,O){let B;for(let q=0;q<O;q++)try{return await L()}catch(Q){B=Q,await d(N)}throw B}e.retry=oe;class j{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var N;(N=this._pending)===null||N===void 0||N.cancel()}setPending(N,O,B){return this._pending={taskId:N,cancel:()=>B==null?void 0:B(),promise:O},O.then(()=>this.donePending(N),()=>this.donePending(N)),O}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let O,B;const q=new Promise((Q,he)=>{O=Q,B=he});this._next={run:N,promise:q,promiseResolve:O,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=j;class W{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,O)=>{this.completeCallback=N,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(O=>{this.completeCallback(N),this.resolved=!0,O()})}error(N){return new Promise(O=>{this.errorCallback(N),this.rejected=!0,O()})}cancel(){new Promise(N=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=$;class U extends T.Emitter{async fireAsync(N,O,B){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,N]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[q,Q]=this._asyncDeliveryQueue.shift(),he=[],ve=Object.assign(Object.assign({},Q),{waitUntil:Ie=>{if(Object.isFrozen(he))throw new Error("waitUntil can NOT be called asynchronous");B&&(Ie=B(Ie,typeof q=="function"?q:q[0])),he.push(Ie)}});try{typeof q=="function"?q.call(void 0,ve):q[0].call(q[1],ve)}catch(Ie){(0,I.onUnexpectedError)(Ie);continue}Object.freeze(he),await M.settled(he).catch(Ie=>(0,I.onUnexpectedError)(Ie))}}}}e.AsyncEmitter=U;var M;(function(L){async function N(Q){return typeof Promise.allSettled=="function"?O(Q):B(Q)}L.allSettled=N;async function O(Q){return Promise.allSettled(Q)}async function B(Q){return Promise.all(Q.map(he=>he.then(ve=>({status:"fulfilled",value:ve}),ve=>({status:"rejected",reason:ve}))))}async function q(Q){let he;const ve=await Promise.all(Q.map(Ie=>Ie.then(ke=>ke,ke=>{he||(he=ke)})));if(typeof he!="undefined")throw he;return ve}L.settled=q})(M=e.Promises||(e.Promises={}))}),define(me[98],ge([0,1,8,16]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new I.IdleValue(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),A=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(l,d,n=!1){const t=l||"",r=d||"",i=T.value.collator.compare(t,r);return T.value.collatorIsNumeric&&i===0&&t!==r?t<r?-1:1:i}e.compareFileNames=k;function D(l,d){const n=A.value.collator;return l=l||"",d=d||"",u(n,l,d)}e.compareFileNamesDefault=D;function P(l,d,n=!1){n||(l=l&&l.toLowerCase(),d=d&&d.toLowerCase());const[t,r]=h(l),[i,o]=h(d);return t!==i?t<i?-1:1:r===o?0:r<o?-1:1}e.noIntlCompareFileNames=P;function s(l,d){const[n,t]=h(l),[r,i]=h(d);let o=T.value.collator.compare(t,i);if(o===0){if(T.value.collatorIsNumeric&&t!==i)return t<i?-1:1;if(o=T.value.collator.compare(n,r),T.value.collatorIsNumeric&&o===0&&n!==r)return n<r?-1:1}return o}e.compareFileExtensions=s;function C(l,d){l=l||"",d=d||"";const n=a(l),t=a(d),r=A.value.collator,i=y.value.collator;let o;return o=u(i,n,t),o!==0?o:u(r,l,d)}e.compareFileExtensionsDefault=C;const f=/^(.*?)(\.([^.]*))?$/;function h(l,d=!1){const n=l?f.exec(l):[];let t=[n&&n[1]||"",n&&n[3]||""];return d&&(!t[0]&&t[1]||t[0]&&t[0].charAt(0)===".")&&(t=[t[0]+"."+t[1],""]),t}function a(l){const d=l?f.exec(l):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function u(l,d,n){let t=l.compare(d,n);return t!==0?t:d.length!==n.length?d.length<n.length?-1:1:0}function E(l,d,n=!1){return n||(l=l&&l.toLowerCase(),d=d&&d.toLowerCase()),l===d?0:l<d?-1:1}function v(l,d,n=!1){const t=l.split(b.sep),r=d.split(b.sep),i=t.length-1,o=r.length-1;let c,m;for(let S=0;;S++){if(c=i===S,m=o===S,c&&m)return k(t[S],r[S],n);if(c)return-1;if(m)return 1;const p=E(t[S],r[S],n);if(p!==0)return p}}e.comparePaths=v;function _(l,d,n){const t=l.toLowerCase(),r=d.toLowerCase(),i=g(l,d,n);if(i)return i;const o=t.endsWith(n),c=r.endsWith(n);if(o!==c)return o?-1:1;const m=k(t,r);return m!==0?m:t.localeCompare(r)}e.compareAnything=_;function g(l,d,n){const t=l.toLowerCase(),r=d.toLowerCase(),i=t.startsWith(n),o=r.startsWith(n);if(i!==o)return i?-1:1;if(i&&o){if(t.length<r.length)return-1;if(t.length>r.length)return 1}return 0}e.compareByPrefix=g}),define(me[99],ge([0,1,98,96,8,9,10]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const k=0,D=[k,[]];function P(W,$,U,M){if(!W||!$)return D;const L=W.length,N=$.length;if(L<N)return D;const O=W.toLowerCase();return!M&&!O.includes(U)?D:s($,U,N,W,O,L)}e.scoreFuzzy=P;function s(W,$,U,M,L,N){const O=[],B=[];for(let ve=0;ve<U;ve++){const Ie=ve*N,ke=Ie-N,Le=ve>0,V=W[ve],J=$[ve];for(let ee=0;ee<N;ee++){const ae=ee>0,we=Ie+ee,Ce=we-1,Oe=ke+ee-1,be=ae?O[Ce]:0,Pe=Le&&ae?O[Oe]:0,Re=Le&&ae?B[Oe]:0;let We;!Pe&&Le?We=0:We=C(V,J,M,L,ee,Re),We&&Pe+We>=be?(B[we]=Re+1,O[we]=Pe+We):(B[we]=k,O[we]=be)}}const q=[];let Q=U-1,he=N-1;for(;Q>=0&&he>=0;){const ve=Q*N+he;B[ve]===k||(q.push(he),Q--),he--}return[O[U*N-1],q.reverse()]}function C(W,$,U,M,L,N){let O=0;if(!f($,M[L]))return O;if(O+=1,N>0&&(O+=N*5),W===U[L]&&(O+=1),L===0)O+=8;else{const B=h(U.charCodeAt(L-1));B?O+=B:(0,I.isUpper)(U.charCodeAt(L))&&(O+=2)}return O}function f(W,$){return W===$?!0:W==="/"||W==="\\"?$==="/"||$==="\\":!1}function h(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function u(W,$,U=0,M=0){const L=$;return L.values&&L.values.length>1?E(W,L.values,U,M):v(W,$,U,M)}e.scoreFuzzy2=u;function E(W,$,U,M){let L=0;const N=[];for(const O of $){const[B,q]=v(W,O,U,M);if(typeof B!="number")return a;L+=B,N.push(...q)}return[L,c(N)]}function v(W,$,U,M){const L=(0,I.fuzzyScore)($.original,$.originalLowercase,U,W,W.toLowerCase(),M,!0);return L?[L[0],(0,I.createMatches)(L)]:a}const _=Object.freeze({score:0}),g=1<<18,l=1<<17,d=1<<16;function n(W,$,U,M,L){if(!W||!$.normalized)return _;const N=M.getItemLabel(W);if(!N)return _;const O=M.getItemDescription(W);let B;O?B=`${N}${O}${$.normalized}${Array.isArray($.values)?$.values.length:""}${U}`:B=`${N}${$.normalized}${Array.isArray($.values)?$.values.length:""}${U}`;const q=L[B];if(q)return q;const Q=t(N,O,M.getItemPath(W),$,U);return L[B]=Q,Q}e.scoreItemFuzzy=n;function t(W,$,U,M,L){const N=!U||!M.containsPathSeparator;return U&&(A.isLinux?M.pathNormalized===U:(0,y.equalsIgnoreCase)(M.pathNormalized,U))?{score:g,labelMatch:[{start:0,end:W.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:M.values&&M.values.length>1?r(W,$,U,M.values,N,L):i(W,$,U,M,N,L)}function r(W,$,U,M,L,N){let O=0;const B=[],q=[];for(const Q of M){const{score:he,labelMatch:ve,descriptionMatch:Ie}=i(W,$,U,Q,L,N);if(he===k)return _;O+=he,ve&&B.push(...ve),Ie&&q.push(...Ie)}return{score:O,labelMatch:c(B),descriptionMatch:c(q)}}function i(W,$,U,M,L,N){if(L||!$){const[O,B]=P(W,M.normalized,M.normalizedLowercase,N);if(O){const q=(0,I.matchesPrefix)(M.normalized,W);let Q;return q?(Q=l,Q+=Math.round(M.normalized.length/W.length*100)):Q=d,{score:Q+O,labelMatch:q||o(B)}}}if($){let O=$;U&&(O=`${$}${T.sep}`);const B=O.length,q=`${O}${W}`,[Q,he]=P(q,M.normalized,M.normalizedLowercase,N);if(Q){const ve=o(he),Ie=[],ke=[];return ve.forEach(Le=>{Le.start<B&&Le.end>B?(Ie.push({start:0,end:Le.end-B}),ke.push({start:Le.start,end:B})):Le.start>=B?Ie.push({start:Le.start-B,end:Le.end-B}):ke.push(Le)}),{score:Q,labelMatch:Ie,descriptionMatch:ke}}}return _}function o(W){const $=[];if(!W)return $;let U;for(const M of W)U&&U.end===M?U.end+=1:(U={start:M,end:M+1},$.push(U));return $}function c(W){const $=W.sort((L,N)=>L.start-N.start),U=[];let M;for(const L of $)!M||!m(M,L)?(M=L,U.push(L)):(M.start=Math.min(M.start,L.start),M.end=Math.max(M.end,L.end));return U}function m(W,$){return!(W.end<$.start||$.end<W.start)}function S(W,$,U,M,L,N){const O=n(W,U,M,L,N),B=n($,U,M,L,N),q=O.score,Q=B.score;if((q===g||Q===g)&&q!==Q)return q===g?-1:1;if(q>d||Q>d){if(q!==Q)return q>Q?-1:1;if(q<l&&Q<l){const J=w(O.labelMatch,B.labelMatch);if(J!==0)return J}const Le=L.getItemLabel(W)||"",V=L.getItemLabel($)||"";if(Le.length!==V.length)return Le.length-V.length}if(q!==Q)return q>Q?-1:1;const he=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,ve=Array.isArray(B.labelMatch)&&B.labelMatch.length>0;if(he&&!ve)return-1;if(ve&&!he)return 1;const Ie=p(W,O,L),ke=p($,B,L);return Ie&&ke&&Ie!==ke?ke>Ie?-1:1:R(W,$,U,L)}e.compareItemsByFuzzyScore=S;function p(W,$,U){let M=-1,L=-1;if($.descriptionMatch&&$.descriptionMatch.length?M=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(M=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(L=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const N=U.getItemDescription(W);N&&(L+=N.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(L=$.descriptionMatch[$.descriptionMatch.length-1].end);return L-M}function w(W,$){if(!W&&!$||(!W||!W.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!W||!W.length)return 1;const U=W[0].start,L=W[W.length-1].end-U,N=$[0].start,B=$[$.length-1].end-N;return L===B?0:B<L?1:-1}function R(W,$,U,M){const L=M.getItemLabel(W)||"",N=M.getItemLabel($)||"",O=M.getItemDescription(W),B=M.getItemDescription($),q=L.length+(O?O.length:0),Q=N.length+(B?B.length:0);if(q!==Q)return q-Q;const he=M.getItemPath(W),ve=M.getItemPath($);return he&&ve&&he.length!==ve.length?he.length-ve.length:L!==N?(0,b.compareAnything)(L,N,U.normalized):O&&B&&O!==B?(0,b.compareAnything)(O,B,U.normalized):he&&ve&&he!==ve?(0,b.compareAnything)(he,ve,U.normalized):0}const F=" ";function z(W){typeof W!="string"&&(W="");const $=W.toLowerCase(),{pathNormalized:U,normalized:M,normalizedLowercase:L}=oe(W),N=U.indexOf(T.sep)>=0;let O;const B=W.split(F);if(B.length>1)for(const q of B){const{pathNormalized:Q,normalized:he,normalizedLowercase:ve}=oe(q);he&&(O||(O=[]),O.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:Q,normalized:he,normalizedLowercase:ve}))}return{original:W,originalLowercase:$,pathNormalized:U,normalized:M,normalizedLowercase:L,values:O,containsPathSeparator:N}}e.prepareQuery=z;function oe(W){let $;A.isWindows?$=W.replace(/\//g,T.sep):$=W.replace(/\\/g,T.sep);const U=(0,y.stripWildcards)($).replace(/\s/g,"");return{pathNormalized:$,normalized:U,normalizedLowercase:U.toLowerCase()}}function j(W){return Array.isArray(W)?z(W.map($=>$.original).join(F)):z(W.original)}e.pieceToQuery=j}),define(me[33],ge([0,1,10,29,8,24,16]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const D="**",P="/",s="[/\\\\]",C="[^/\\\\]",f=/\//g;function h(O){switch(O){case 0:return"";case 1:return`${C}*?`;default:return`(?:${s}|${C}+${s}|${s}${C}+)*?`}}function a(O,B){if(!O)return[];const q=[];let Q=!1,he=!1,ve="";for(const Ie of O){switch(Ie){case B:if(!Q&&!he){q.push(ve),ve="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":he=!0;break;case"]":he=!1;break}ve+=Ie}return ve&&q.push(ve),q}e.splitGlobAware=a;function u(O){if(!O)return"";let B="";const q=a(O,P);if(q.every(Q=>Q===D))B=".*";else{let Q=!1;q.forEach((he,ve)=>{if(he===D){Q||(B+=h(2),Q=!0);return}let Ie=!1,ke="",Le=!1,V="";for(const J of he){if(J!=="}"&&Ie){ke+=J;continue}if(Le&&(J!=="]"||!V)){let ee;J==="-"?ee=J:(J==="^"||J==="!")&&!V?ee="^":J===P?ee="":ee=b.escapeRegExpCharacters(J),V+=ee;continue}switch(J){case"{":Ie=!0;continue;case"[":Le=!0;continue;case"}":B+=`(?:${a(ke,",").map(we=>u(we)).join("|")})`,Ie=!1,ke="";break;case"]":B+="["+V+"]",Le=!1,V="";break;case"?":B+=C;continue;case"*":B+=h(1);continue;default:B+=b.escapeRegExpCharacters(J)}}ve<q.length-1&&(q[ve+1]!==D||ve+2<q.length)&&(B+=s),Q=!1})}return B}const E=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new A.LRUCache(1e4),t=function(){return!1},r=function(){return null};function i(O,B){if(!O)return r;let q;typeof O!="string"?q=O.pattern:q=O,q=q.trim();const Q=`${q}_${!!B.trimForExclusions}`;let he=n.get(Q);if(he)return o(he,O);let ve;if(E.test(q)){const Ie=q.substr(4);he=function(ke,Le){return typeof ke=="string"&&ke.endsWith(Ie)?q:null}}else(ve=v.exec(c(q,B)))?he=m(ve[1],q):(B.trimForExclusions?g:_).test(q)?he=S(q,B):(ve=l.exec(c(q,B)))?he=p(ve[1].substr(1),q,!0):(ve=d.exec(c(q,B)))?he=p(ve[1],q,!1):he=w(q);return n.set(Q,he),o(he,O)}function o(O,B){return typeof B=="string"?O:function(q,Q){return I.isEqualOrParent(q,B.base)?O(T.relative(B.base,q),Q):null}}function c(O,B){return B.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function m(O,B){const q=`/${O}`,Q=`\\${O}`,he=function(Ie,ke){return typeof Ie!="string"?null:ke?ke===O?B:null:Ie===O||Ie.endsWith(q)||Ie.endsWith(Q)?B:null},ve=[O];return he.basenames=ve,he.patterns=[B],he.allBasenames=ve,he}function S(O,B){const q=N(O.slice(1,-1).split(",").map(ke=>i(ke,B)).filter(ke=>ke!==r),O),Q=q.length;if(!Q)return r;if(Q===1)return q[0];const he=function(ke,Le){for(let V=0,J=q.length;V<J;V++)if(q[V](ke,Le))return O;return null},ve=q.find(ke=>!!ke.allBasenames);ve&&(he.allBasenames=ve.allBasenames);const Ie=q.reduce((ke,Le)=>Le.allPaths?ke.concat(Le.allPaths):ke,[]);return Ie.length&&(he.allPaths=Ie),he}function p(O,B,q){const Q=T.sep===T.posix.sep,he=Q?O:O.replace(f,T.sep),ve=T.sep+he,Ie=T.posix.sep+O,ke=q?function(Le,V){return typeof Le=="string"&&(Le===he||Le.endsWith(ve)||!Q&&(Le===O||Le.endsWith(Ie)))?B:null}:function(Le,V){return typeof Le=="string"&&(Le===he||!Q&&Le===O)?B:null};return ke.allPaths=[(q?"*/":"./")+O],ke}function w(O){try{const B=new RegExp(`^${u(O)}$`);return function(q){return B.lastIndex=0,typeof q=="string"&&B.test(q)?O:null}}catch(B){return r}}function R(O,B,q){return!O||typeof B!="string"?!1:F(O)(B,void 0,q)}e.match=R;function F(O,B={}){if(!O)return t;if(typeof O=="string"||W(O)){const q=i(O,B);if(q===r)return t;const Q=function(he,ve){return!!q(he,ve)};return q.allBasenames&&(Q.allBasenames=q.allBasenames),q.allPaths&&(Q.allPaths=q.allPaths),Q}return M(O,B)}e.parse=F;function z(O){if(!!O){let B;return q=>(B||(B=(O()||Promise.resolve([])).then(Q=>Q?j(Q):{})),B.then(Q=>!!Q[q]))}}e.hasSiblingPromiseFn=z;function oe(O){if(!!O){let B;return q=>{if(!B){const Q=O();B=Q?j(Q):{}}return!!B[q]}}}e.hasSiblingFn=oe;function j(O){const B={};for(const q of O)B[q]=!0;return B}function W(O){const B=O;return B&&typeof B.base=="string"&&typeof B.pattern=="string"}e.isRelativePattern=W;function $(O){return O.allBasenames||[]}e.getBasenameTerms=$;function U(O){return O.allPaths||[]}e.getPathTerms=U;function M(O,B){const q=N(Object.getOwnPropertyNames(O).map(ke=>L(ke,O[ke],B)).filter(ke=>ke!==r)),Q=q.length;if(!Q)return r;if(!q.some(ke=>!!ke.requiresSiblings)){if(Q===1)return q[0];const ke=function(J,ee){for(let ae=0,we=q.length;ae<we;ae++){const Ce=q[ae](J,ee);if(Ce)return Ce}return null},Le=q.find(J=>!!J.allBasenames);Le&&(ke.allBasenames=Le.allBasenames);const V=q.reduce((J,ee)=>ee.allPaths?J.concat(ee.allPaths):J,[]);return V.length&&(ke.allPaths=V),ke}const he=function(ke,Le,V){let J;for(let ee=0,ae=q.length;ee<ae;ee++){const we=q[ee];we.requiresSiblings&&V&&(Le||(Le=T.basename(ke)),J||(J=Le.substr(0,Le.length-T.extname(ke).length)));const Ce=we(ke,Le,J,V);if(Ce)return Ce}return null},ve=q.find(ke=>!!ke.allBasenames);ve&&(he.allBasenames=ve.allBasenames);const Ie=q.reduce((ke,Le)=>Le.allPaths?ke.concat(Le.allPaths):ke,[]);return Ie.length&&(he.allPaths=Ie),he}function L(O,B,q){if(B===!1)return r;const Q=i(O,q);if(Q===r)return r;if(typeof B=="boolean")return Q;if(B){const he=B.when;if(typeof he=="string"){const ve=(Ie,ke,Le,V)=>{if(!V||!Q(Ie,ke))return null;const J=he.replace("$(basename)",Le),ee=V(J);return(0,y.isThenable)(ee)?ee.then(ae=>ae?O:null):ee?O:null};return ve.requiresSiblings=!0,ve}}return Q}function N(O,B){const q=O.filter(ke=>!!ke.basenames);if(q.length<2)return O;const Q=q.reduce((ke,Le)=>{const V=Le.basenames;return V?ke.concat(V):ke},[]);let he;if(B){he=[];for(let ke=0,Le=Q.length;ke<Le;ke++)he.push(B)}else he=q.reduce((ke,Le)=>{const V=Le.patterns;return V?ke.concat(V):ke},[]);const ve=function(ke,Le){if(typeof ke!="string")return null;if(!Le){let J;for(J=ke.length;J>0;J--){const ee=ke.charCodeAt(J-1);if(ee===47||ee===92)break}Le=ke.substr(J)}const V=Q.indexOf(Le);return V!==-1?he[V]:null};ve.basenames=Q,ve.patterns=he,ve.allBasenames=Q;const Ie=O.filter(ke=>!ke.basenames);return Ie.push(ve),Ie}}),define(me[75],ge([0,1,2,8,10,11,9,25,29]),function(G,e,b,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,o,c){if(typeof i=="string"&&(i=b.URI.file(i)),c){const S=c.getWorkspaceFolder(i);if(S){const p=c.getWorkspace().folders.length>1;let w;if((0,k.isEqual)(S.uri,i)?w="":w=(0,k.relativePath)(S.uri,i),p){const R=S.name?S.name:(0,k.basename)(S.uri);w=w?R+" \u2022 "+w:R}return w}}if(i.scheme!==A.Schemas.file&&i.scheme!==A.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(i.fsPath))return(0,I.normalize)(C(i.fsPath));let m=(0,I.normalize)(i.fsPath);return!y.isWindows&&(o==null?void 0:o.userHome)&&(m=h(m,o.userHome.fsPath)),m}e.getPathLabel=P;function s(i){if(!!i){typeof i=="string"&&(i=b.URI.file(i));const o=(0,k.basename)(i)||(i.scheme===A.Schemas.file?i.fsPath:i.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(o)?C(o):o}}e.getBaseLabel=s;function C(i){return(0,D.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let f=Object.create(null);function h(i,o){if(y.isWindows||!i||!o)return i;let c=f.original===o?f.normalized:void 0;return c||(c=`${(0,T.rtrim)(o,I.posix.sep)}${I.posix.sep}`,f={original:o,normalized:c}),(y.isLinux?i.startsWith(c):(0,T.startsWithIgnoreCase)(i,c))&&(i=`~/${i.substr(c.length)}`),i}e.tildify=h;function a(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=a;const u="\u2026",E="\\\\",v="~";function _(i,o=I.sep){const c=new Array(i.length);let m=!1;for(let S=0;S<i.length;S++){let p=i[S];if(p===""){c[S]=`.${o}`;continue}if(!p){c[S]=p;continue}m=!0;let w="";p.indexOf(E)===0?(w=p.substr(0,p.indexOf(E)+E.length),p=p.substr(p.indexOf(E)+E.length)):p.indexOf(o)===0?(w=p.substr(0,p.indexOf(o)+o.length),p=p.substr(p.indexOf(o)+o.length)):p.indexOf(v)===0&&(w=p.substr(0,p.indexOf(v)+v.length),p=p.substr(p.indexOf(v)+v.length));const R=p.split(o);for(let F=1;m&&F<=R.length;F++)for(let z=R.length-F;m&&z>=0;z--){m=!1;let oe=R.slice(z,z+F).join(o);for(let j=0;!m&&j<i.length;j++)if(j!==S&&i[j]&&i[j].indexOf(oe)>-1){const W=z+F===R.length,$=z>0&&i[j].indexOf(o)>-1?o+oe:oe,U=i[j].endsWith($);m=!W||U}if(!m){let j="";(R[0].endsWith(":")||w!=="")&&(z===1&&(z=0,F++,oe=R[0]+o+oe),z>0&&(j=R[0]+o),j=w+j),z>0&&(j=j+u+o),j=j+oe,z+F<R.length&&(j=j+o+u),c[S]=j}}m&&(c[S]=p)}return c}e.shorten=_;var g;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function l(i,o=Object.create(null)){const c=[];let m=!1,S="";for(const p of i)if(p==="$"||m&&p==="{")S&&c.push({value:S,type:g.TEXT}),S="",m=!0;else if(p==="}"&&m){const w=o[S];if(typeof w=="string")w.length&&c.push({value:w,type:g.VARIABLE});else if(w){const R=c[c.length-1];(!R||R.type!==g.SEPARATOR)&&c.push({value:w.label,type:g.SEPARATOR})}S="",m=!1}else S+=p;return S&&!m&&c.push({value:S,type:g.TEXT}),c.filter((p,w)=>{if(p.type===g.SEPARATOR){const R=c[w-1],F=c[w+1];return[R,F].every(z=>z&&(z.type===g.VARIABLE||z.type===g.TEXT)&&z.value.length>0)}return!0}).map(p=>p.value).join("")}e.template=l;function d(i,o){return y.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=d;function n(i,o){return y.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):y.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function r(i){const o=i.indexOf("/")!==-1?I.posix:I.win32,c=o.basename(i),m=o.dirname(i);return c.length?{name:c,parentPath:m}:{name:m,parentPath:""}}e.splitName=r}),define(me[100],ge([0,1,2]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(s){return s.toJSON()}class T{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:I(b.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:I(b.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:b.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(s){return s}transformOutgoing(s){return s}transformOutgoingURI(s){return s}transformOutgoingScheme(s){return s}};function A(s,C,f){if(!s||f>200)return null;if(typeof s=="object"){if(s instanceof b.URI)return C.transformOutgoing(s);for(let h in s)if(Object.hasOwnProperty.call(s,h)){const a=A(s[h],C,f+1);a!==null&&(s[h]=a)}}return null}function y(s,C){const f=A(s,C,0);return f===null?s:f}e.transformOutgoingURIs=y;function k(s,C,f,h){if(!s||h>200)return null;if(typeof s=="object"){if(s.$mid===1)return f?b.URI.revive(C.transformIncoming(s)):C.transformIncoming(s);for(let a in s)if(Object.hasOwnProperty.call(s,a)){const u=k(s[a],C,f,h+1);u!==null&&(s[a]=u)}}return null}function D(s,C){const f=k(s,C,!1,0);return f===null?s:f}e.transformIncomingURIs=D;function P(s,C){const f=k(s,C,!0,0);return f===null?s:f}e.transformAndReviveIncomingURIs=P}),define(me[30],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(D){return b.test(D)}e.isUUID=I;const T=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function k(){y(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let D=0,P="";return P+=A[T[D++]],P+=A[T[D++]],P+=A[T[D++]],P+=A[T[D++]],P+="-",P+=A[T[D++]],P+=A[T[D++]],P+="-",P+=A[T[D++]],P+=A[T[D++]],P+="-",P+=A[T[D++]],P+=A[T[D++]],P+="-",P+=A[T[D++]],P+=A[T[D++]],P+=A[T[D++]],P+=A[T[D++]],P+=A[T[D++]],P+=A[T[D++]],P}e.generateUuid=k}),define(me[137],ge([0,1,101]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class I{constructor(A="utf8"){this.stringDecoder=new b.StringDecoder(A),this.remaining=null}write(A){const y=[],k=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(k.length<1)return y;let D=0,P,s=D;for(;s<k.length;)if(P=k.charCodeAt(s),P===13||P===10){if(y.push(k.substring(D,s)),s++,s<k.length){const C=P;P=k.charCodeAt(s),(C===13&&P===10||C===10&&P===13)&&s++}D=s}else s++;return this.remaining=D<k.length?k.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=I}),define(me[26],ge([0,1,37,48,8,16,9,29,30,74,25,2]),function(G,e,b,I,T,A,y,k,D,P,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var f;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function h($,U=f.UNLINK){if((0,k.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return U===f.UNLINK?u($):a($)}e.rimraf=h;async function a($){try{const U=(0,T.join)((0,I.tmpdir)(),(0,D.generateUuid)());try{await b.promises.rename($,U)}catch(M){return u($)}u(U).catch(M=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function u($){return b.promises.rmdir($,{recursive:!0,maxRetries:3})}function E($){if((0,k.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");b.rmdirSync($,{recursive:!0})}e.rimrafSync=E;async function v($,U){return l(await(U?_($):b.promises.readdir($)))}e.readdir=v;async function _($){try{return await b.promises.readdir($,{withFileTypes:!0})}catch(L){console.warn("[node.js fs] readdir with filetypes failed with error: ",L)}const U=[],M=await v($);for(const L of M){let N=!1,O=!1,B=!1;try{const q=await b.promises.lstat((0,T.join)($,L));N=q.isFile(),O=q.isDirectory(),B=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}U.push({name:L,isFile:()=>N,isDirectory:()=>O,isSymbolicLink:()=>B})}return U}function g($){return l(b.readdirSync($))}e.readdirSync=g;function l($){return $.map(U=>typeof U=="string"?y.isMacintosh?(0,P.normalizeNFC)(U):U:(U.name=y.isMacintosh?(0,P.normalizeNFC)(U.name):U.name,U))}async function d($){const U=await v($),M=[];for(const L of U)await t.existsDirectory((0,T.join)($,L))&&M.push(L);return M}e.readDirsInDir=d;function n($,U=1e3){return new Promise(M=>{let L=!1;const N=setInterval(()=>{L||(L=!0,b.access($,O=>{L=!1,O&&(clearInterval(N),M(void 0))}))},U)})}e.whenDeleted=n;var t;(function($){async function U(N){let O;try{if(O=await b.promises.lstat(N),!O.isSymbolicLink())return{stat:O}}catch(B){}try{return{stat:await b.promises.stat(N),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(y.isWindows&&B.code==="EACCES")try{return{stat:await b.promises.stat(await b.promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw q}throw B}}$.stat=U;async function M(N){try{const{stat:O,symbolicLink:B}=await $.stat(N);return O.isFile()&&(B==null?void 0:B.dangling)!==!0}catch(O){}return!1}$.existsFile=M;async function L(N){try{const{stat:O,symbolicLink:B}=await $.stat(N);return O.isDirectory()&&(B==null?void 0:B.dangling)!==!0}catch(O){}return!1}$.existsDirectory=L})(t=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new A.ResourceQueue;function i($,U,M){return r.queueFor(C.URI.file($),s.extUriBiasedIgnorePathCase).queue(()=>{const L=S(M);return new Promise((N,O)=>c($,U,L,B=>B?O(B):N()))})}e.writeFile=i;let o=!0;function c($,U,M,L){if(!o)return b.writeFile($,U,{mode:M.mode,flag:M.flag},L);b.open($,M.flag,M.mode,(N,O)=>{if(N)return L(N);b.writeFile(O,U,B=>{if(B)return b.close(O,()=>L(B));b.fdatasync(O,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),o=!1),b.close(O,Q=>L(Q))))})})}function m($,U,M){const L=S(M);if(!o)return b.writeFileSync($,U,{mode:L.mode,flag:L.flag});const N=b.openSync($,L.flag,L.mode);try{b.writeFileSync(N,U);try{b.fdatasyncSync(N)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),o=!1}}finally{b.closeSync(N)}}e.writeFileSync=m;function S($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function p($,U){if($!==U){async function M(L){try{const N=await b.promises.lstat(L);if(N.isDirectory()||N.isSymbolicLink())return;const O=await b.promises.open(L,"a");try{await O.utimes(N.atime,new Date)}finally{await O.close()}}catch(N){}}try{await b.promises.rename($,U),await M(U)}catch(L){if($.toLowerCase()!==U.toLowerCase()&&L.code==="EXDEV"||$.endsWith("."))await w($,U,{preserveSymlinks:!1}),await h($,f.MOVE),await M(U);else throw L}}}e.move=p;async function w($,U,M){return F($,U,{root:{source:$,target:U},options:M,handledSourcePaths:new Set})}e.copy=w;const R=511;async function F($,U,M){if(!M.handledSourcePaths.has($)){M.handledSourcePaths.add($);const{stat:L,symbolicLink:N}=await t.stat($);if(N){if(M.options.preserveSymlinks)try{return await j($,U,M)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(N.dangling)return}return L.isDirectory()?z($,U,L.mode&R,M):oe($,U,L.mode&R)}}async function z($,U,M,L){await b.promises.mkdir(U,{recursive:!0,mode:M});const N=await v($);for(const O of N)await F((0,T.join)($,O),(0,T.join)(U,O),L)}async function oe($,U,M){await b.promises.copyFile($,U),await b.promises.chmod(U,M)}async function j($,U,M){let L=await b.promises.readlink($);(0,k.isEqualOrParent)(L,M.root.source,!y.isLinux)&&(L=(0,T.join)(M.root.target,L.substr(M.root.source.length+1))),await b.promises.symlink(L,U)}async function W($){try{return await b.promises.access($),!0}catch(U){return!1}}e.exists=W}),define(me[102],ge([0,1,37,285,10,8,26]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(C){const f=(0,A.dirname)(C);if(C===f)return C;const h=((0,A.basename)(C)||C).toLowerCase();try{const u=(0,y.readdirSync)(f).filter(E=>E.toLowerCase()===h);if(u.length===1){const E=k(f);if(E)return(0,A.join)(E,u[0])}else if(u.length>1){const E=u.indexOf(h);if(E>=0){const v=k(f);if(v)return(0,A.join)(v,u[E])}}}catch(a){}return null}e.realcaseSync=k;async function D(C){try{return await(0,I.promisify)(b.realpath)(C)}catch(f){const h=s(C);return await b.promises.access(h,b.constants.R_OK),h}}e.realpath=D;function P(C){try{return b.realpathSync(C)}catch(f){const h=s(C);return b.accessSync(h,b.constants.R_OK),h}}e.realpathSync=P;function s(C){return(0,T.rtrim)((0,A.normalize)(C),A.sep)}});var wt=this&&this.__await||function(G){return this instanceof wt?(this.v=G,this):new wt(G)},Rn=this&&this.__asyncGenerator||function(G,e,b){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var I=b.apply(G,e||[]),T,A=[];return T={},y("next"),y("throw"),y("return"),T[Symbol.asyncIterator]=function(){return this},T;function y(f){I[f]&&(T[f]=function(h){return new Promise(function(a,u){A.push([f,h,a,u])>1||k(f,h)})})}function k(f,h){try{D(I[f](h))}catch(a){C(A[0][3],a)}}function D(f){f.value instanceof wt?Promise.resolve(f.value.v).then(P,s):C(A[0][2],f)}function P(f){k("next",f)}function s(f){k("throw",f)}function C(f,h){f(h),A.shift(),A.length&&k(A[0][0],A[0][1])}},fn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],b;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),b={},I("next"),I("throw"),I("return"),b[Symbol.asyncIterator]=function(){return this},b);function I(A){b[A]=G[A]&&function(y){return new Promise(function(k,D){y=G[A](y),T(k,D,y.done,y.value)})}}function T(A,y,k,D){Promise.resolve(D).then(function(P){A({value:P,done:k})},y)}};define(me[103],ge([0,1,26,48,8]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,y=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var D;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(D||(D={}));let P;switch(process.arch){case"ia32":case"x32":P=1;break;case"arm":case"arm64":P=2;break;default:P=0;break}let s;process.env.PROCESSOR_ARCHITEW6432?s=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?s=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?s=1:s=0;class C{constructor(d,n,t){this.exePath=d,this.displayName=n,this.knownToExist=t}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:l=!1}={}){return l?P===0?process.env["ProgramFiles(x86)"]||null:s===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:l=!1,findPreview:d=!1}={}){const n=f({useAlternateBitness:l});if(!n)return null;const t=T.join(n,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(t))return null;let r=-1,i=null;for(const m of await b.readdir(t)){let S=-1;if(d){const w=m.indexOf("-");if(w<0)continue;const R=m.substring(0,w);if(!A.test(R)||m.substring(w+1)!=="preview")continue;S=parseInt(R,10)}else{if(!A.test(m))continue;S=parseInt(m,10)}if(!(S<=r)){const p=T.join(t,m,"pwsh.exe");!await b.SymlinkSupport.existsFile(p)||(i=p,r=S)}}if(!i)return null;const o=n.includes("x86")?" (x86)":"",c=d?" Preview":"";return new C(i,`PowerShell${c}${o}`,!0)}async function a({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const d=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(d))return null;const{pwshMsixDirRegex:n,pwshMsixName:t}=l?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:y,pwshMsixName:"PowerShell (Store)"};for(const r of await b.readdir(d))if(n.test(r)){const i=T.join(d,r,"pwsh.exe");return new C(i,t)}return null}function u(){const l=T.join(I.homedir(),".dotnet","tools","pwsh.exe");return new C(l,".NET Core PowerShell Global Tool")}function E(){const l=T.join(process.env.windir,P===1&&s!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(l,"Windows PowerShell",!0)}function v(){return Rn(this,arguments,function*(){let d=yield wt(h());d&&(yield yield wt(d)),d=yield wt(h({useAlternateBitness:!0})),d&&(yield yield wt(d)),d=yield wt(a()),d&&(yield yield wt(d)),d=u(),d&&(yield yield wt(d)),d=yield wt(h({findPreview:!0})),d&&(yield yield wt(d)),d=yield wt(a({findPreview:!0})),d&&(yield yield wt(d)),d=yield wt(h({useAlternateBitness:!0,findPreview:!0})),d&&(yield yield wt(d)),d=E(),d&&(yield yield wt(d))})}function _(){return Rn(this,arguments,function*(){var d,n;try{for(var t=fn(v()),r;r=yield wt(t.next()),!r.done;){const i=r.value;(yield wt(i.exists()))&&(yield yield wt(i))}}catch(i){d={error:i}}finally{try{r&&!r.done&&(n=t.return)&&(yield wt(n.call(t)))}finally{if(d)throw d.error}}})}e.enumeratePowerShellInstallations=_;async function g(){var l,d;try{for(var n=fn(_()),t;t=await n.next(),!t.done;)return t.value}catch(r){l={error:r}}finally{try{t&&!t.done&&(d=n.return)&&await d.call(n)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=g}),define(me[104],ge([0,1,3,6,16,21,19,22,15,12,58,10]),function(G,e,b,I,T,A,y,k,D,P,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(L){L[L.Promise=100]="Promise",L[L.PromiseCancel=101]="PromiseCancel",L[L.EventListen=102]="EventListen",L[L.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function h(L){switch(L){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(L){L[L.Initialize=200]="Initialize",L[L.PromiseSuccess=201]="PromiseSuccess",L[L.PromiseError=202]="PromiseError",L[L.PromiseErrorObj=203]="PromiseErrorObj",L[L.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function u(L){switch(L){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(L){L[L.Uninitialized=0]="Uninitialized",L[L.Idle=1]="Idle"})(E||(E={}));class v{constructor(N){this.buffer=N,this.pos=0}read(N){const O=this.buffer.slice(this.pos,this.pos+N);return this.pos+=O.byteLength,O}}class _{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var g;(function(L){L[L.Undefined=0]="Undefined",L[L.String=1]="String",L[L.Buffer=2]="Buffer",L[L.VSBuffer=3]="VSBuffer",L[L.Array=4]="Array",L[L.Object=5]="Object"})(g||(g={}));function l(L){const N=k.VSBuffer.alloc(4);return N.writeUInt32BE(L,0),N}function d(L){return L.read(4).readUInt32BE(0)}function n(L){const N=k.VSBuffer.alloc(1);return N.writeUInt8(L,0),N}const t={Undefined:n(g.Undefined),String:n(g.String),Buffer:n(g.Buffer),VSBuffer:n(g.VSBuffer),Array:n(g.Array),Object:n(g.Object)},r=typeof Buffer!="undefined";function i(L,N){if(typeof N=="undefined")L.write(t.Undefined);else if(typeof N=="string"){const O=k.VSBuffer.fromString(N);L.write(t.String),L.write(l(O.byteLength)),L.write(O)}else if(r&&Buffer.isBuffer(N)){const O=k.VSBuffer.wrap(N);L.write(t.Buffer),L.write(l(O.byteLength)),L.write(O)}else if(N instanceof k.VSBuffer)L.write(t.VSBuffer),L.write(l(N.byteLength)),L.write(N);else if(Array.isArray(N)){L.write(t.Array),L.write(l(N.length));for(const O of N)i(L,O)}else{const O=k.VSBuffer.fromString(JSON.stringify(N));L.write(t.Object),L.write(l(O.byteLength)),L.write(O)}}function o(L){switch(L.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return L.read(d(L)).toString();case g.Buffer:return L.read(d(L)).buffer;case g.VSBuffer:return L.read(d(L));case g.Array:{const O=d(L),B=[];for(let q=0;q<O;q++)B.push(o(L));return B}case g.Object:return JSON.parse(L.read(d(L)).toString())}}class c{constructor(N,O,B=null,q=1e3){this.protocol=N,this.ctx=O,this.logger=B,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(N,O){this.channels.set(N,O),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const O=this.send([N.type]);this.logger&&this.logger.logOutgoing(O,0,1,u(N.type));return}case 201:case 202:case 204:case 203:{const O=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(O,N.id,1,u(N.type),N.data);return}}}send(N,O=void 0){const B=new _;return i(B,N),i(B,O),this.sendBuffer(B.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onRawMessage(N){const O=new v(N),B=o(O),q=o(O),Q=B[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],1,`${h(Q)}: ${B[2]}.${B[3]}`,q),this.onPromise({type:Q,id:B[1],channelName:B[2],name:B[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],1,`${h(Q)}: ${B[2]}.${B[3]}`,q),this.onEventListen({type:Q,id:B[1],channelName:B[2],name:B[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:B[1]})}}onPromise(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const B=new A.CancellationTokenSource;let q;try{q=O.call(this.ctx,N.name,N.arg,B.token)}catch(ve){q=Promise.reject(ve)}const Q=N.id;q.then(ve=>{this.sendResponse({id:Q,data:ve,type:201}),this.activeRequests.delete(N.id)},ve=>{ve instanceof Error?this.sendResponse({id:Q,data:{message:ve.message,name:ve.name,stack:ve.stack?ve.stack.split?ve.stack.split(`
`):ve.stack:void 0},type:202}):this.sendResponse({id:Q,data:ve,type:203}),this.activeRequests.delete(N.id)});const he=(0,I.toDisposable)(()=>B.cancel());this.activeRequests.set(N.id,he)}onEventListen(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const B=N.id,Q=O.listen(this.ctx,N.name,N.arg)(he=>this.sendResponse({id:B,data:he,type:204}));this.activeRequests.set(N.id,Q)}disposeActiveRequest(N){const O=this.activeRequests.get(N.id);O&&(O.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let O=this.pendingRequests.get(N.channelName);O||(O=[],this.pendingRequests.set(N.channelName,O));const B=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:N,timeoutTimer:B})}flushPendingRequests(N){const O=this.pendingRequests.get(N);if(O){for(const B of O)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var m;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(N,O=null){this.protocol=N,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=O}getChannel(N){const O=this;return{call(B,q,Q){return O.isDisposed?Promise.reject(y.canceled()):O.requestPromise(N,B,q,Q)},listen(B,q){return O.isDisposed?Promise.reject(y.canceled()):O.requestEvent(N,B,q)}}}requestPromise(N,O,B,q=A.CancellationToken.None){const Q=this.lastRequestId++,ve={id:Q,type:100,channelName:N,name:O,arg:B};if(q.isCancellationRequested)return Promise.reject(y.canceled());let Ie;return new Promise((Le,V)=>{if(q.isCancellationRequested)return V(y.canceled());const J=()=>{const Ce=Oe=>{switch(Oe.type){case 201:this.handlers.delete(Q),Le(Oe.data);break;case 202:this.handlers.delete(Q);const be=new Error(Oe.data.message);be.stack=Oe.data.stack,be.name=Oe.data.name,V(be);break;case 203:this.handlers.delete(Q),V(Oe.data);break}};this.handlers.set(Q,Ce),this.sendRequest(ve)};let ee=null;this.state===E.Idle?J():(ee=(0,T.createCancelablePromise)(Ce=>this.whenInitialized()),ee.then(()=>{ee=null,J()}));const ae=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:Q,type:101}),V(y.canceled())},we=q.onCancellationRequested(ae);Ie=(0,I.combinedDisposable)((0,I.toDisposable)(ae),we),this.activeRequests.add(Ie)}).finally(()=>{this.activeRequests.delete(Ie)})}requestEvent(N,O,B){const q=this.lastRequestId++,he={id:q,type:102,channelName:N,name:O,arg:B};let ve=null;const Ie=new b.Emitter({onFirstListenerAdd:()=>{ve=(0,T.createCancelablePromise)(Le=>this.whenInitialized()),ve.then(()=>{ve=null,this.activeRequests.add(Ie),this.sendRequest(he)})},onLastListenerRemove:()=>{ve?(ve.cancel(),ve=null):(this.activeRequests.delete(Ie),this.sendRequest({id:q,type:103}))}}),ke=Le=>Ie.fire(Le.data);return this.handlers.set(q,ke),Ie.event}sendRequest(N){switch(N.type){case 100:case 102:{const O=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(O,N.id,0,`${h(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const O=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(O,N.id,0,h(N.type));return}}}send(N,O=void 0){const B=new _;return i(B,N),i(B,O),this.sendBuffer(B.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onBuffer(N){const O=new v(N),B=o(O),q=o(O),Q=B[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,u(Q)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],0,u(Q),q),this.onResponse({type:B[0],id:B[1],data:q})}}onResponse(N){if(N.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(N.id);O&&O(N)}whenInitialized(){return this.state===E.Idle?Promise.resolve():b.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelClient=S;class p{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:O,onDidClientDisconnect:B})=>{b.Event.once(O.onMessage)(Q=>{const he=new v(Q),ve=o(he),Ie=new c(O,ve),ke=new S(O);this.channels.forEach((V,J)=>Ie.registerChannel(J,V));const Le={channelServer:Ie,channelClient:ke,ctx:ve};this._connections.add(Le),this._onDidAddConnection.fire(Le),B(()=>{Ie.dispose(),ke.dispose(),this._connections.delete(Le),this._onDidRemoveConnection.fire(Le)})})})}get connections(){const N=[];return this._connections.forEach(O=>N.push(O)),N}getChannel(N,O){const B=this;return{call(q,Q,he){let ve;if((0,P.isFunction)(O)){let ke=(0,D.getRandomElement)(B.connections.filter(O));ve=ke?Promise.resolve(ke):b.Event.toPromise(b.Event.filter(B.onDidAddConnection,O))}else ve=O.routeCall(B,q,Q);const Ie=ve.then(ke=>ke.channelClient.getChannel(N));return R(Ie).call(q,Q,he)},listen(q,Q){if((0,P.isFunction)(O))return B.getMulticastEvent(N,O,q,Q);const he=O.routeEvent(B,q,Q).then(ve=>ve.channelClient.getChannel(N));return R(he).listen(q,Q)}}}getMulticastEvent(N,O,B,q){const Q=this;let he=new I.DisposableStore;const ve=new b.Emitter({onFirstListenerAdd:()=>{he=new I.DisposableStore;const Ie=new b.EventMultiplexer,ke=new Map,Le=J=>{const ae=J.channelClient.getChannel(N).listen(B,q),we=Ie.add(ae);ke.set(J,we)},V=J=>{const ee=ke.get(J);!ee||(ee.dispose(),ke.delete(J))};Q.connections.filter(O).forEach(Le),b.Event.filter(Q.onDidAddConnection,O)(Le,void 0,he),Q.onDidRemoveConnection(V,void 0,he),Ie.event(ve.fire,ve,he),he.add(Ie)},onLastListenerRemove:()=>{he.dispose()}});return ve.event}registerChannel(N,O){this.channels.set(N,O),this._connections.forEach(B=>{B.channelServer.registerChannel(N,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=p;class w{constructor(N,O,B=null){const q=new _;i(q,O),N.send(q.buffer),this.channelClient=new S(N,B),this.channelServer=new c(N,O,B)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,O){this.channelServer.registerChannel(N,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=w;function R(L){return{call(N,O,B){return L.then(q=>q.call(N,O,B))},listen(N,O){const B=new b.Relay;return L.then(q=>B.input=q.listen(N,O)),B.event}}}e.getDelayedChannel=R;function F(L){let N=!1;return{call(O,B,q){return N?L.call(O,B,q):(0,T.timeout)(0).then(()=>N=!0).then(()=>L.call(O,B,q))},listen(O,B){if(N)return L.listen(O,B);const q=new b.Relay;return(0,T.timeout)(0).then(()=>N=!0).then(()=>q.input=L.listen(O,B)),q.event}}}e.getNextTickChannel=F;class z{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const O of N.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await b.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=z;var oe;(function(L){function N(q,Q){const he=q,ve=Q&&Q.disableMarshalling,Ie=new Map;for(const ke in he)B(ke)&&Ie.set(ke,b.Event.buffer(he[ke],!0));return new class{listen(ke,Le){const V=Ie.get(Le);if(V)return V;throw new Error(`Event not found: ${Le}`)}call(ke,Le,V){const J=he[Le];if(typeof J=="function"){if(!ve&&Array.isArray(V))for(let ee=0;ee<V.length;ee++)V[ee]=(0,s.revive)(V[ee]);return J.apply(he,V)}throw new Error(`Method not found: ${Le}`)}}}L.fromService=N;function O(q,Q){const he=Q&&Q.disableMarshalling;return new Proxy({},{get(ve,Ie){var ke;if(typeof Ie=="string")return((ke=Q==null?void 0:Q.properties)===null||ke===void 0?void 0:ke.has(Ie))?Q.properties.get(Ie):B(Ie)?q.listen(Ie):async function(...Le){let V;Q&&!(0,P.isUndefinedOrNull)(Q.context)?V=[Q.context,...Le]:V=Le;const J=await q.call(Ie,V);return he?J:(0,s.revive)(J)};throw new Error(`Property not found: ${String(Ie)}`)}})}L.toService=O;function B(q){return q[0]==="o"&&q[1]==="n"&&C.isUpperAsciiLetter(q.charCodeAt(2))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(L){if(Array.isArray(L))return L;if(L&&typeof L=="object"&&typeof L.toString=="function"){let N=L.toString();if(N!=="[object Object]")return N}return L}function $(L){return Array.isArray(L)?L.map(W):W(L)}function U(L,N,O,B,q,Q,he){he=$(he);const ve=j[q],Ie=ve[B%ve.length];let ke=[`%c[${L}]%c[${String(N).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${Ie}`];/\($/.test(Q)?(ke=ke.concat(he),ke.push(")")):ke.push(he),console.log.apply(console,ke)}e.logWithColors=U;class M{constructor(N,O){this._outgoingPrefix=N,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,O,B,q,Q){this._totalOutgoing+=N,U(this._outgoingPrefix,this._totalOutgoing,N,O,B,q,Q)}logIncoming(N,O,B,q,Q){this._totalIncoming+=N,U(this._incomingPrefix,this._totalIncoming,N,O,B,q,Q)}}e.IPCLogger=M}),define(me[105],ge([0,1,3,104,6,22,9,36]),function(G,e,b,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function P(){return D||(D=A.VSBuffer.alloc(0)),D}class s{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,i){if(r===0)return P();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const S=this._chunks[0];return i&&(this._chunks.shift(),this._totalLength-=r),S}if(this._chunks[0].byteLength>r){const S=this._chunks[0].slice(0,r);return i&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),S}let o=A.VSBuffer.alloc(r),c=0,m=0;for(;r>0;){const S=this._chunks[m];if(S.byteLength>r){const p=S.slice(0,r);o.set(p,c),c+=r,i&&(this._chunks[m]=S.slice(r),this._totalLength-=r),r-=r}else o.set(S,c),c+=S.byteLength,i?(this._chunks.shift(),this._totalLength-=S.byteLength):m++,r-=S.byteLength}return o}}e.ChunkStream=s;var C;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.KeepAlive=4]="KeepAlive",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var f;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",t[t.KeepAliveTime=5e3]="KeepAliveTime",t[t.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(r,i,o,c){this.type=r,this.id=i,this.ack=o,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends T.Disposable{constructor(r){super();this._onMessage=this._register(new b.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new s,this._register(this._socket.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const i=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=i.readUInt32BE(9),this._state.messageType=i.readUInt8(0),this._state.id=i.readUInt32BE(1),this._state.ack=i.readUInt32BE(5);else{const o=this._state.messageType,c=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(o,c,m,i)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(!this._isDisposed){r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=A.VSBuffer.alloc(13);i.writeUInt8(r.type,0),i.writeUInt32BE(r.id,1),i.writeUInt32BE(r.ack,5),i.writeUInt32BE(r.data.byteLength,9),this._writeSoon(i,r.data)}}_bufferAdd(r,i){const o=this._totalLength===0;return this._data.push(r,i),this._totalLength+=r.byteLength+i.byteLength,o}_bufferTake(){const r=A.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,i){this._bufferAdd(r,i)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends T.Disposable{constructor(r){super();this._onMessage=new b.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(i=>{i.type===1&&this._onMessage.fire(i.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new h(1,0,0,r))}}e.Protocol=E;class v extends I.IPCClient{constructor(r,i,o=null){super(r,i,o);this.protocol=r}static fromSocket(r,i){return new v(new E(r),i)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=v;class _{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new b.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,k.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=_;class g{constructor(r){this.data=r,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],i=0,o=this._first;for(;o;)r[i++]=o.data,o=o.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const i=new g(r);if(!this._first){this._first=i,this._last=i;return}this._last.next=i,this._last=i}}class d{constructor(){this.lastRuns=[];const r=Date.now();for(let i=0;i<d._HISTORY_LENGTH;i++)this.lastRuns[i]=r-1e3*i;setInterval(()=>{for(let i=d._HISTORY_LENGTH;i>=1;i--)this.lastRuns[i]=this.lastRuns[i-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return d._INSTANCE||(d._INSTANCE=new d),d._INSTANCE}load(){const r=Date.now(),i=(1+d._HISTORY_LENGTH)*1e3;let o=0;for(let c=0;c<d._HISTORY_LENGTH;c++)r-this.lastRuns[c]<=i&&o++;return 1-o/d._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}d._HISTORY_LENGTH=10,d._INSTANCE=null;class n{constructor(r,i=null){this._loadEstimator=d.getInstance(),this._onControlMessage=new _,this.onControlMessage=this._onControlMessage.event,this._onMessage=new _,this.onMessage=this._onMessage.event,this._onDidDispose=new _,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new _,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new _,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),i&&this._socketReader.acceptChunk(i),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new h(5,0,0,P());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const i=new h(4,0,0,P());this._socketWriter.write(i),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,i){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(i)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let i=0,o=r.length;i<o;i++)this._socketWriter.write(r[i]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const i=this._outgoingUnackMsg.peek();if(i&&i.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const i=Date.now();i-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=i,this._socketWriter.write(new h(6,0,0,P())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const i=this._outgoingUnackMsg.toArray();for(let o=0,c=i.length;o<c;o++)this._socketWriter.write(i[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const i=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new h(1,i,this._incomingAckId,r);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(r){const i=new h(2,0,0,r);this._socketWriter.write(i)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const r=this._outgoingUnackMsg.peek(),i=Date.now()-r.writtenTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-i,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const r=new h(3,0,this._incomingAckId,P());this._socketWriter.write(r)}}}e.PersistentProtocol=n}),define(me[106],ge([0,1,95]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(k){let D=(0,b.toUint8)(k);this._defaultValue=D,this._asciiMap=I._createAsciiMap(D),this._map=new Map}static _createAsciiMap(k){let D=new Uint8Array(256);for(let P=0;P<256;P++)D[P]=k;return D}set(k,D){let P=(0,b.toUint8)(D);k>=0&&k<256?this._asciiMap[k]=P:this._map.set(k,P)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=I;var T;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(T||(T={}));class A{constructor(){this._actual=new I(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=A}),define(me[138],ge([0,1,106]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends b.CharacterClassifier{constructor(k){super(0);for(let D=0,P=k.length;D<P;D++)this.set(k.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function A(y){let k={};return D=>(k.hasOwnProperty(D)||(k[D]=y(D)),k[D])}e.getMapForWordSeparators=A(y=>new T(y))}),define(me[49],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(T,A){this.lineNumber=T,this.column=A}with(T=this.lineNumber,A=this.column){return T===this.lineNumber&&A===this.column?this:new b(T,A)}delta(T=0,A=0){return this.with(this.lineNumber+T,this.column+A)}equals(T){return b.equals(this,T)}static equals(T,A){return!T&&!A?!0:!!T&&!!A&&T.lineNumber===A.lineNumber&&T.column===A.column}isBefore(T){return b.isBefore(this,T)}static isBefore(T,A){return T.lineNumber<A.lineNumber?!0:A.lineNumber<T.lineNumber?!1:T.column<A.column}isBeforeOrEqual(T){return b.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,A){return T.lineNumber<A.lineNumber?!0:A.lineNumber<T.lineNumber?!1:T.column<=A.column}static compare(T,A){let y=T.lineNumber|0,k=A.lineNumber|0;if(y===k){let D=T.column|0,P=A.column|0;return D-P}return y-k}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new b(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=b}),define(me[44],ge([0,1,49]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(A,y,k,D){A>k||A===k&&y>D?(this.startLineNumber=k,this.startColumn=D,this.endLineNumber=A,this.endColumn=y):(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=k,this.endColumn=D)}isEmpty(){return I.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return I.containsPosition(this,A)}static containsPosition(A,y){return!(y.lineNumber<A.startLineNumber||y.lineNumber>A.endLineNumber||y.lineNumber===A.startLineNumber&&y.column<A.startColumn||y.lineNumber===A.endLineNumber&&y.column>A.endColumn)}containsRange(A){return I.containsRange(this,A)}static containsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>A.endColumn)}strictContainsRange(A){return I.strictContainsRange(this,A)}static strictContainsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<=A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>=A.endColumn)}plusRange(A){return I.plusRange(this,A)}static plusRange(A,y){let k,D,P,s;return y.startLineNumber<A.startLineNumber?(k=y.startLineNumber,D=y.startColumn):y.startLineNumber===A.startLineNumber?(k=y.startLineNumber,D=Math.min(y.startColumn,A.startColumn)):(k=A.startLineNumber,D=A.startColumn),y.endLineNumber>A.endLineNumber?(P=y.endLineNumber,s=y.endColumn):y.endLineNumber===A.endLineNumber?(P=y.endLineNumber,s=Math.max(y.endColumn,A.endColumn)):(P=A.endLineNumber,s=A.endColumn),new I(k,D,P,s)}intersectRanges(A){return I.intersectRanges(this,A)}static intersectRanges(A,y){let k=A.startLineNumber,D=A.startColumn,P=A.endLineNumber,s=A.endColumn,C=y.startLineNumber,f=y.startColumn,h=y.endLineNumber,a=y.endColumn;return k<C?(k=C,D=f):k===C&&(D=Math.max(D,f)),P>h?(P=h,s=a):P===h&&(s=Math.min(s,a)),k>P||k===P&&D>s?null:new I(k,D,P,s)}equalsRange(A){return I.equalsRange(this,A)}static equalsRange(A,y){return!!A&&!!y&&A.startLineNumber===y.startLineNumber&&A.startColumn===y.startColumn&&A.endLineNumber===y.endLineNumber&&A.endColumn===y.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(A){return new b.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(A){return new b.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,y){return new I(this.startLineNumber,this.startColumn,A,y)}setStartPosition(A,y){return new I(A,y,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(A){return new I(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,y=A){return new I(A.lineNumber,A.column,y.lineNumber,y.column)}static lift(A){return A?new I(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn)}static areIntersecting(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,y){if(A&&y){const P=A.startLineNumber|0,s=y.startLineNumber|0;if(P===s){const C=A.startColumn|0,f=y.startColumn|0;if(C===f){const h=A.endLineNumber|0,a=y.endLineNumber|0;if(h===a){const u=A.endColumn|0,E=y.endColumn|0;return u-E}return h-a}return C-f}return P-s}return(A?1:0)-(y?1:0)}static compareRangesUsingEnds(A,y){return A.endLineNumber===y.endLineNumber?A.endColumn===y.endColumn?A.startLineNumber===y.startLineNumber?A.startColumn-y.startColumn:A.startLineNumber-y.startLineNumber:A.endColumn-y.endColumn:A.endLineNumber-y.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=I}),define(me[139],ge([0,1,49,44]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class A extends I.Range{constructor(k,D,P,s){super(k,D,P,s);this.selectionStartLineNumber=k,this.selectionStartColumn=D,this.positionLineNumber=P,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return A.selectionsEqual(this,k)}static selectionsEqual(k,D){return k.selectionStartLineNumber===D.selectionStartLineNumber&&k.selectionStartColumn===D.selectionStartColumn&&k.positionLineNumber===D.positionLineNumber&&k.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,D){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,k,D):new A(k,D,this.startLineNumber,this.startColumn)}getPosition(){return new b.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,D){return this.getDirection()===0?new A(k,D,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,k,D)}static fromPositions(k,D=k){return new A(k.lineNumber,k.column,D.lineNumber,D.column)}static liftSelection(k){return new A(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,D){if(k&&!D||!k&&D)return!1;if(!k&&!D)return!0;if(k.length!==D.length)return!1;for(let P=0,s=k.length;P<s;P++)if(!this.selectionsEqual(k[P],D[P]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,D,P,s,C){return C===0?new A(k,D,P,s):new A(P,s,k,D)}}e.Selection=A}),define(me[107],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var b;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(b=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class D{constructor(a,u){this.range=a,this.matches=u}}e.FindMatch=D;var P;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var s;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(s=e.ModelConstants||(e.ModelConstants={}));class C{constructor(a,u,E,v,_,g){this.identifier=a,this.range=u,this.text=E,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=_,this._isTracked=g}}e.ValidAnnotatedEditOperation=C;class f{constructor(a,u,E){this.reverseEdits=a,this.changes=u,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=f}),define(me[140],ge([0,1,10,138,49,44,107]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class D{constructor(g,l,d,n){this.searchString=g,this.isRegex=l,this.matchCase=d,this.wordSeparators=n}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=P(this.searchString):g=this.searchString.indexOf(`
`)>=0;let l=null;try{l=b.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch(n){return null}if(!l)return null;let d=!this.isRegex&&!g;return d&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(d=this.matchCase),new s(l,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,d?this.searchString:null)}}e.SearchParams=D;function P(_){if(!_||_.length===0)return!1;for(let g=0,l=_.length;g<l;g++)if(_.charCodeAt(g)===92){if(g++,g>=l)break;const n=_.charCodeAt(g);if(n===110||n===114||n===87||n===119)return!0}return!1}e.isMultilineRegexSource=P;class s{constructor(g,l,d){this.regex=g,this.wordSeparators=l,this.simpleSearch=d}}e.SearchData=s;function C(_,g,l){if(!l)return new y.FindMatch(_,null);let d=[];for(let n=0,t=g.length;n<t;n++)d[n]=g[n];return new y.FindMatch(_,d)}e.createFindMatch=C;class f{constructor(g){let l=[],d=0;for(let n=0,t=g.length;n<t;n++)g.charCodeAt(n)===10&&(l[d++]=n);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(g){const l=this._lineFeedsOffsets;let d=0,n=l.length-1;if(n===-1||g<=l[0])return 0;for(;d<n;){const t=d+((n-d)/2>>0);l[t]>=g?n=t-1:l[t+1]>=g?(d=t,n=t):d=t+1}return d+1}}class h{static findMatches(g,l,d,n,t){const r=l.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(g,d,new v(r.wordSeparators,r.regex),n,t):this._doFindMatchesLineByLine(g,d,r,n,t):[]}static _getMultilineMatchRange(g,l,d,n,t,r){let i,o=0;n?(o=n.findLineFeedCountBeforeOffset(t),i=l+t+o):i=l+t;let c;if(n){let w=n.findLineFeedCountBeforeOffset(t+r.length)-o;c=i+r.length+w}else c=i+r.length;const m=g.getPositionAt(i),S=g.getPositionAt(c);return new A.Range(m.lineNumber,m.column,S.lineNumber,S.column)}static _doFindMatchesMultiline(g,l,d,n,t){const r=g.getOffsetAt(l.getStartPosition()),i=g.getValueInRange(l,1),o=g.getEOL()===`\r
`?new f(i):null,c=[];let m=0,S;for(d.reset(0);S=d.next(i);)if(c[m++]=C(this._getMultilineMatchRange(g,r,i,o,S.index,S[0]),S,n),m>=t)return c;return c}static _doFindMatchesLineByLine(g,l,d,n,t){const r=[];let i=0;if(l.startLineNumber===l.endLineNumber){const c=g.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return i=this._findMatchesInLine(d,c,l.startLineNumber,l.startColumn-1,i,r,n,t),r}const o=g.getLineContent(l.startLineNumber).substring(l.startColumn-1);i=this._findMatchesInLine(d,o,l.startLineNumber,l.startColumn-1,i,r,n,t);for(let c=l.startLineNumber+1;c<l.endLineNumber&&i<t;c++)i=this._findMatchesInLine(d,g.getLineContent(c),c,0,i,r,n,t);if(i<t){const c=g.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);i=this._findMatchesInLine(d,c,l.endLineNumber,0,i,r,n,t)}return r}static _findMatchesInLine(g,l,d,n,t,r,i,o){const c=g.wordSeparators;if(!i&&g.simpleSearch){const p=g.simpleSearch,w=p.length,R=l.length;let F=-w;for(;(F=l.indexOf(p,F+w))!==-1;)if((!c||E(c,l,R,F,w))&&(r[t++]=new y.FindMatch(new A.Range(d,F+1+n,d,F+1+w+n),null),t>=o))return t;return t}const m=new v(g.wordSeparators,g.regex);let S;m.reset(0);do if(S=m.next(l),S&&(r[t++]=C(new A.Range(d,S.index+1+n,d,S.index+1+S[0].length+n),S,i),t>=o))return t;while(S);return t}static findNextMatch(g,l,d,n){const t=l.parseSearchRequest();if(!t)return null;const r=new v(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindNextMatchMultiline(g,d,r,n):this._doFindNextMatchLineByLine(g,d,r,n)}static _doFindNextMatchMultiline(g,l,d,n){const t=new T.Position(l.lineNumber,1),r=g.getOffsetAt(t),i=g.getLineCount(),o=g.getValueInRange(new A.Range(t.lineNumber,t.column,i,g.getLineMaxColumn(i)),1),c=g.getEOL()===`\r
`?new f(o):null;d.reset(l.column-1);let m=d.next(o);return m?C(this._getMultilineMatchRange(g,r,o,c,m.index,m[0]),m,n):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(g,new T.Position(1,1),d,n):null}static _doFindNextMatchLineByLine(g,l,d,n){const t=g.getLineCount(),r=l.lineNumber,i=g.getLineContent(r),o=this._findFirstMatchInLine(d,i,r,l.column,n);if(o)return o;for(let c=1;c<=t;c++){const m=(r+c-1)%t,S=g.getLineContent(m+1),p=this._findFirstMatchInLine(d,S,m+1,1,n);if(p)return p}return null}static _findFirstMatchInLine(g,l,d,n,t){g.reset(n-1);const r=g.next(l);return r?C(new A.Range(d,r.index+1,d,r.index+1+r[0].length),r,t):null}static findPreviousMatch(g,l,d,n){const t=l.parseSearchRequest();if(!t)return null;const r=new v(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindPreviousMatchMultiline(g,d,r,n):this._doFindPreviousMatchLineByLine(g,d,r,n)}static _doFindPreviousMatchMultiline(g,l,d,n){const t=this._doFindMatchesMultiline(g,new A.Range(1,1,l.lineNumber,l.column),d,n,10*k);if(t.length>0)return t[t.length-1];const r=g.getLineCount();return l.lineNumber!==r||l.column!==g.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(g,new T.Position(r,g.getLineMaxColumn(r)),d,n):null}static _doFindPreviousMatchLineByLine(g,l,d,n){const t=g.getLineCount(),r=l.lineNumber,i=g.getLineContent(r).substring(0,l.column-1),o=this._findLastMatchInLine(d,i,r,n);if(o)return o;for(let c=1;c<=t;c++){const m=(t+r-c-1)%t,S=g.getLineContent(m+1),p=this._findLastMatchInLine(d,S,m+1,n);if(p)return p}return null}static _findLastMatchInLine(g,l,d,n){let t=null,r;for(g.reset(0);r=g.next(l);)t=C(new A.Range(d,r.index+1,d,r.index+1+r[0].length),r,n);return t}}e.TextModelSearch=h;function a(_,g,l,d,n){if(d===0)return!0;const t=g.charCodeAt(d-1);if(_.get(t)!==0||t===13||t===10)return!0;if(n>0){const r=g.charCodeAt(d);if(_.get(r)!==0)return!0}return!1}function u(_,g,l,d,n){if(d+n===l)return!0;const t=g.charCodeAt(d+n);if(_.get(t)!==0||t===13||t===10)return!0;if(n>0){const r=g.charCodeAt(d+n-1);if(_.get(r)!==0)return!0}return!1}function E(_,g,l,d,n){return a(_,g,l,d,n)&&u(_,g,l,d,n)}e.isValidMatch=E;class v{constructor(g,l){this._wordSeparators=g,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(g){this._searchRegex.lastIndex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(g){const l=g.length;let d;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(d=this._searchRegex.exec(g),!d))return null;const n=d.index,t=d[0].length;if(n===this._prevMatchStartIndex&&t===this._prevMatchLength){if(t===0){b.getNextCodePoint(g,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=n,this._prevMatchLength=t,!this._wordSeparators||E(this._wordSeparators,g,l,n,t))return d}while(d);return null}}e.Searcher=v}),define(me[108],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function b(k=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)k.indexOf(P)>=0||(D+="\\"+P);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=b();function I(k){let D=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)D=k;else{let P="g";k.ignoreCase&&(P+="i"),k.multiline&&(P+="m"),k.unicode&&(P+="u"),D=new RegExp(k.source,P)}return D.lastIndex=0,D}e.ensureValidWordDefinition=I;const T={maxLen:1e3,windowSize:15,timeBudget:150};function A(k,D,P,s,C=T){if(P.length>C.maxLen){let E=k-C.maxLen/2;return E<0?E=0:s+=E,P=P.substring(E,k+C.maxLen/2),A(k,D,P,s,C)}const f=Date.now(),h=k-1-s;let a=-1,u=null;for(let E=1;!(Date.now()-f>=C.timeBudget);E++){const v=h-C.windowSize*E;D.lastIndex=Math.max(0,v);const _=y(D,P,h,a);if(!_&&u||(u=_,v<=0))break;a=v}if(u){let E={word:u[0],startColumn:s+1+u.index,endColumn:s+1+u.index+u[0].length};return D.lastIndex=0,E}return null}e.getWordAtText=A;function y(k,D,P,s){let C;for(;C=k.exec(D);){const f=C.index||0;if(f<=P&&k.lastIndex>=P)return C;if(s>0&&f>s)return null}return null}}),define(me[141],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var b;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(b=e.IndentAction||(e.IndentAction={}));class I{constructor(k){if(this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let D=0,P=k.notIn.length;D<P;D++)switch(k.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=I;class T{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of k)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=T;function A(y,k,D){y.has(k)?y.get(k).push(D):y.set(k,[D])}}),define(me[76],ge([0,1,33,8]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(A,y,k,D){if(Array.isArray(A)){let P=0;for(const s of A){const C=T(s,y,k,D);if(C===10)return C;C>P&&(P=C)}return P}else{if(typeof A=="string")return D?A==="*"?5:A===k?10:0:0;if(A){const{language:P,pattern:s,scheme:C,hasAccessToAllModels:f}=A;if(!D&&!f)return 0;let h=0;if(C)if(C===y.scheme)h=10;else if(C==="*")h=5;else return 0;if(P)if(P===k)h=10;else if(P==="*")h=Math.max(h,5);else return 0;if(s){let a;if(typeof s=="string"?a=s:a=Object.assign(Object.assign({},s),{base:(0,I.normalize)(s.base)}),a===y.fsPath||(0,b.match)(a,y.fsPath))h=10;else return 0}return h}else return 0}}e.score=T}),define(me[142],ge([0,1,106]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class T{constructor(a,u,E){const v=new Uint8Array(a*u);for(let _=0,g=a*u;_<g;_++)v[_]=E;this._data=v,this.rows=a,this.cols=u}get(a,u){return this._data[a*this.cols+u]}set(a,u,E){this._data[a*this.cols+u]=E}}e.Uint8Matrix=T;class A{constructor(a){let u=0,E=0;for(let _=0,g=a.length;_<g;_++){let[l,d,n]=a[_];d>u&&(u=d),l>E&&(E=l),n>E&&(E=n)}u++,E++;let v=new T(E,u,0);for(let _=0,g=a.length;_<g;_++){let[l,d,n]=a[_];v.set(l,d,n)}this._states=v,this._maxCharCode=u}nextState(a,u){return u<0||u>=this._maxCharCode?0:this._states.get(a,u)}}e.StateMachine=A;let y=null;function k(){return y===null&&(y=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let P=null;function s(){if(P===null){P=new b.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<h.length;u++)P.set(h.charCodeAt(u),1);const a=".,;";for(let u=0;u<a.length;u++)P.set(a.charCodeAt(u),2)}return P}class C{static _createLink(a,u,E,v,_){let g=_-1;do{const l=u.charCodeAt(g);if(a.get(l)!==2)break;g--}while(g>v);if(v>0){const l=u.charCodeAt(v-1),d=u.charCodeAt(g);(l===40&&d===41||l===91&&d===93||l===123&&d===125)&&g--}return{range:{startLineNumber:E,startColumn:v+1,endLineNumber:E,endColumn:g+2},url:u.substring(v,g+1)}}static computeLinks(a,u=k()){const E=s();let v=[];for(let _=1,g=a.getLineCount();_<=g;_++){const l=a.getLineContent(_),d=l.length;let n=0,t=0,r=0,i=1,o=!1,c=!1,m=!1,S=!1;for(;n<d;){let p=!1;const w=l.charCodeAt(n);if(i===13){let R;switch(w){case 40:o=!0,R=0;break;case 41:R=o?0:1;break;case 91:m=!0,c=!0,R=0;break;case 93:m=!1,R=c?0:1;break;case 123:S=!0,R=0;break;case 125:R=S?0:1;break;case 39:R=r===34||r===96?0:1;break;case 34:R=r===39||r===96?0:1;break;case 96:R=r===39||r===34?0:1;break;case 42:R=r===42?1:0;break;case 124:R=r===124?1:0;break;case 32:R=m?0:1;break;default:R=E.get(w)}R===1&&(v.push(C._createLink(E,l,_,t,n)),p=!0)}else if(i===12){let R;w===91?(c=!0,R=0):R=E.get(w),R===1?p=!0:i=13}else i=u.nextState(i,w),i===0&&(p=!0);p&&(i=1,o=!1,c=!1,S=!1,t=n+1,r=w),n++}i===13&&v.push(C._createLink(E,l,_,t,d))}return v}}e.LinkComputer=C;function f(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:C.computeLinks(h)}e.computeLinks=f}),define(me[143],ge([0,1,3,6]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,k){return this._map.set(y,k),this.fire([y]),(0,I.toDisposable)(()=>{this._map.get(y)===k&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,k){let D=null,P=!1;return this._promises.set(y,k.then(s=>{this._promises.delete(y),!(P||!s)&&(D=this.register(y,s))})),(0,I.toDisposable)(()=>{P=!0,D&&D.dispose()})}getPromise(y){const k=this.get(y);if(k)return Promise.resolve(k);const D=this._promises.get(y);return D?D.then(P=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(me[109],ge([0,1,22,9]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(T||(T={}));function A(C){for(let f=0,h=C.length;f<h;f+=4){const a=C[f+0],u=C[f+1],E=C[f+2],v=C[f+3];C[f+0]=v,C[f+1]=E,C[f+2]=u,C[f+3]=a}}function y(C){const f=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return I.isLittleEndian()||A(f),b.VSBuffer.wrap(f)}function k(C){const f=C.buffer;if(I.isLittleEndian()||A(f),f.byteOffset%4==0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const h=new Uint8Array(f.byteLength);return h.set(f),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function D(C){const f=new Uint32Array(P(C));let h=0;if(f[h++]=C.id,C.type==="full")f[h++]=1,f[h++]=C.data.length,f.set(C.data,h),h+=C.data.length;else{f[h++]=2,f[h++]=C.deltas.length;for(const a of C.deltas)f[h++]=a.start,f[h++]=a.deleteCount,a.data?(f[h++]=a.data.length,f.set(a.data,h),h+=a.data.length):f[h++]=0}return y(f)}e.encodeSemanticTokensDto=D;function P(C){let f=0;if(f+=1+1,C.type==="full")f+=1+C.data.length;else{f+=1,f+=(1+1+1)*C.deltas.length;for(const h of C.deltas)h.data&&(f+=h.data.length)}return f}function s(C){const f=k(C);let h=0;const a=f[h++];if(f[h++]===1){const _=f[h++],g=f.subarray(h,h+_);return h+=_,{id:a,type:"full",data:g}}const E=f[h++];let v=[];for(let _=0;_<E;_++){const g=f[h++],l=f[h++],d=f[h++];let n;d>0&&(n=f.subarray(h,h+d),h+=d),v[_]={start:g,deleteCount:l,data:n}}return{id:a,type:"delta",deltas:v}}e.decodeSemanticTokensDto=s}),define(me[110],ge([0,1,95]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(y,k){this.index=y,this.remainder=k}}e.PrefixSumIndexOfResult=I;class T{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,k){y=(0,b.toUint32)(y);const D=this.values,P=this.prefixSum,s=k.length;return s===0?!1:(this.values=new Uint32Array(D.length+s),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+s),this.values.set(k,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,k){return y=(0,b.toUint32)(y),k=(0,b.toUint32)(k),this.values[y]===k?!1:(this.values[y]=k,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,k){y=(0,b.toUint32)(y),k=(0,b.toUint32)(k);const D=this.values,P=this.prefixSum;if(y>=D.length)return!1;let s=D.length-y;return k>=s&&(k=s),k===0?!1:(this.values=new Uint32Array(D.length-k),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+k),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,b.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),y>=this.values.length&&(y=this.values.length-1);for(let D=k;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let k=0,D=this.values.length-1,P=0,s=0,C=0;for(;k<=D;)if(P=k+(D-k)/2|0,s=this.prefixSum[P],C=s-this.values[P],y<C)D=P-1;else if(y>=s)k=P+1;else break;return new I(P,y-C)}}e.PrefixSumComputer=T}),define(me[144],ge([0,1,10,49,110]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(k,D,P,s){this._uri=k,this._lines=D,this._eol=P,this._versionId=s,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const D=k.changes;for(const P of D)this._acceptDeleteRange(P.range),this._acceptInsertText(new I.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,D=this._lines.length,P=new Uint32Array(D);for(let s=0;s<D;s++)P[s]=this._lines[s].length+k;this._lineStarts=new T.PrefixSumComputer(P)}}_setLineText(k,D){this._lines[k]=D,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,D){if(D.length!==0){let P=(0,b.splitLines)(D);if(P.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}P[P.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]);let s=new Uint32Array(P.length-1);for(let C=1;C<P.length;C++)this._lines.splice(k.lineNumber+C-1,0,P[C]),s[C-1]=P[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,s)}}}e.MirrorTextModel=A}),define(me[145],ge([17,18]),function(G,e){return G.create("vs/base/common/date",e)}),define(me[146],ge([0,1,145]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,T=I*60,A=T*24,y=A*7,k=A*30,D=A*365;function P(C,f){typeof C!="number"&&(C=C.getTime());const h=Math.round((new Date().getTime()-C)/1e3);if(h<-30)return(0,b.localize)(0,null,P(new Date().getTime()+h*1e3,!1));if(h<30)return(0,b.localize)(1,null);let a;return h<I?(a=h,f?a===1?(0,b.localize)(2,null,a):(0,b.localize)(3,null,a):a===1?(0,b.localize)(4,null,a):(0,b.localize)(5,null,a)):h<T?(a=Math.floor(h/I),f?a===1?(0,b.localize)(6,null,a):(0,b.localize)(7,null,a):a===1?(0,b.localize)(8,null,a):(0,b.localize)(9,null,a)):h<A?(a=Math.floor(h/T),f?a===1?(0,b.localize)(10,null,a):(0,b.localize)(11,null,a):a===1?(0,b.localize)(12,null,a):(0,b.localize)(13,null,a)):h<y?(a=Math.floor(h/A),f?a===1?(0,b.localize)(14,null,a):(0,b.localize)(15,null,a):a===1?(0,b.localize)(16,null,a):(0,b.localize)(17,null,a)):h<k?(a=Math.floor(h/y),f?a===1?(0,b.localize)(18,null,a):(0,b.localize)(19,null,a):a===1?(0,b.localize)(20,null,a):(0,b.localize)(21,null,a)):h<D?(a=Math.floor(h/k),f?a===1?(0,b.localize)(22,null,a):(0,b.localize)(23,null,a):a===1?(0,b.localize)(24,null,a):(0,b.localize)(25,null,a)):(a=Math.floor(h/D),f?a===1?(0,b.localize)(26,null,a):(0,b.localize)(27,null,a):a===1?(0,b.localize)(28,null,a):(0,b.localize)(29,null,a))}e.fromNow=P;function s(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=s}),define(me[147],ge([17,18]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(me[59],ge([0,1,147,12,15]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(P,s){return s&&(P.stack||P.stacktrace)?b.localize(0,null,k(P),y(P.stack)||y(P.stacktrace)):k(P)}function y(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?b.localize(1,null,P.message):P.message||b.localize(2,null)}function D(P=null,s=!1){if(!P)return b.localize(3,null);if(Array.isArray(P)){const C=T.coalesce(P),f=D(C[0],s);return C.length>1?b.localize(4,null,f,C.length):f}if(I.isString(P))return P;if(P.detail){const C=P.detail;if(C.error)return A(C.error,s);if(C.exception)return A(C.exception,s)}return P.stack?A(P,s):P.message?P.message:b.localize(5,null)}e.toErrorMessage=D}),define(me[148],ge([17,18]),function(G,e){return G.create("vs/base/node/processes",e)}),define(me[77],ge([0,1,8,37,26,38,148,36,12,23,29,9,137,11]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function a(d){switch(d){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(d,n){if(C.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};n&&(t.cwd=n);const r=A.execFile("taskkill",["/T","/F","/PID",d.pid.toString()],t);return new Promise(i=>{r.once("error",o=>{i({success:!1,error:o})}),r.once("exit",(o,c)=>{i(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?a(t.status):1})}else if(C.isLinux||C.isMacintosh)try{const t=h.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(r=>{A.execFile(t,[d.pid.toString()],{encoding:"utf8",shell:!0},(i,o,c)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else d.kill("SIGKILL");return Promise.resolve({success:!0})}function E(d=k.env){return d.comspec||"cmd.exe"}e.getWindowsShell=E;class v{constructor(n,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=n,this.args=t,this.shell=r,this.options=i;else{const o=n;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(k.env).forEach(c=>{o[c]=k.env[c]}),Object.keys(this.options.env).forEach(c=>{o[c]=this.options.env[c]}),this.options.env=o}}getSanitizedCommand(){let n=this.cmd.toLowerCase();const t=n.lastIndexOf(b.sep);return t!==-1&&(n=n.substring(t+1)),v.WellKnowCommands[n]?n:"other"}start(n){return C.isWindows&&(this.options&&this.options.cwd&&s.isUNC(this.options.cwd)||!this.options&&s.isUNC(k.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(t=>{let r,i;const o=new Promise((c,m)=>{r=c,i=m});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=A.exec(c,this.options,(m,S,p)=>{this.childProcess=null;const w=m;w&&w.killed?i({killed:this.terminateRequested,stdout:S.toString(),stderr:p.toString()}):this.handleExec(r,n,m,S,p)})}else{let c=null;const m=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,r,n,i);const p={terminated:this.terminateRequested};D.isNumber(S)&&(p.cmdCode=S),r(p)};if(this.shell&&C.isWindows){const S=P.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let p=!1,w=!1;const R=[];let F=this.ensureQuotes(this.cmd);R.push(F.value),p=F.quoted,this.args&&this.args.forEach(oe=>{F=this.ensureQuotes(oe),R.push(F.value),w=w&&F.quoted});const z=["/s","/c"];p?w?z.push('"'+R.join(" ")+'"'):R.length>1?z.push('"'+R[0]+'" '+R.slice(1).join(" ")):z.push('"'+R[0]+'"'):z.push(R.join(" ")),c=A.spawn(E(),z,S)}else this.cmd&&(c=A.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(D.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",S=>{this.childProcess=null,i({terminated:this.terminateRequested,error:S})}),c.pid&&(this.childProcess.on("close",m),this.handleSpawn(c,r,n,i,!0)))}return o})}handleClose(n,t,r,i){}ensureQuotes(n){return v.regexp.test(n)?{value:'"'+n+'"',quoted:!0}:{value:n,quoted:n.length>0&&n[0]==='"'&&n[n.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(n=>n.pid,n=>-1):new Promise(n=>{this.pidResolve=n})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(n=>(this.terminateRequested=!0,u(n,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),n=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(n=>{if(!this.shell||!C.isWindows)return n(!1);const t=A.spawn(E(),["/s","/c"]);t.on("error",r=>n(!0)),t.on("exit",r=>n(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class _ extends v{constructor(n,t,r,i){super(n,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(n,t,r,i,o){[i,o].forEach((c,m)=>{const S=new f.LineDecoder;S.write(c).forEach(R=>{t({line:R,source:m===0?0:1})});const w=S.end();w&&t({line:w,source:m===0?0:1})}),n({terminated:this.terminateRequested,error:r})}handleSpawn(n,t,r,i,o){const c=new f.LineDecoder,m=new f.LineDecoder;n.stdout.on("data",S=>{c.write(S).forEach(w=>r({line:w,source:0}))}),n.stderr.on("data",S=>{m.write(S).forEach(w=>r({line:w,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=m}handleClose(n,t,r,i){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&r({line:o,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&r({line:c,source:1})}}e.LineProcess=_;function g(d){let n=[],t=!1;const r=function(i){if(t){n.push(i);return}(!d.send(i,c=>{if(c&&console.error(c),t=!1,n.length>0){const m=n.slice(0);n=[],m.forEach(S=>r(S))}})||C.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=g;var l;(function(d){async function n(t,r,i){if(b.isAbsolute(t))return t;if(r===void 0&&(r=k.cwd()),b.dirname(t)!=="."||(i===void 0&&D.isString(k.env.PATH)&&(i=k.env.PATH.split(b.delimiter)),i===void 0||i.length===0))return b.join(r,t);async function c(m){return await T.exists(m)?!(await I.promises.stat(m)).isDirectory():!1}for(let m of i){let S;if(b.isAbsolute(m)?S=b.join(m,t):S=b.join(r,m,t),await c(S))return S;let p=S+".com";if(await c(p)||(p=S+".exe",await c(p)))return p}return b.join(r,t)}d.findExecutable=n})(l=e.win32||(e.win32={}))}),define(me[149],ge([0,1,48,9,103,77]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function y(h,a){return h===1?I.isWindows?C():A.getWindowsShell(a):P(h,a)}e.getSystemShell=y;function k(h,a){return h===1?I.isWindows?f(a):A.getWindowsShell(a):P(h,a)}e.getSystemShellSync=k;let D=null;function P(h,a){if(I.isLinux&&h===2||I.isMacintosh&&h===3)return"/bin/bash";if(!D){let u;if(I.isWindows)u="/bin/bash";else{if(u=a.SHELL,!u)try{u=(0,b.userInfo)().shell}catch(E){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}D=u}return D}let s=null;async function C(){return s||(s=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),s}function f(h){if(s)return s;const a=I.isWindows&&parseFloat((0,b.release)())>=10,u=h.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${h.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?E:A.getWindowsShell(h)}}),define(me[150],ge([17,18]),function(G,e){return G.create("vs/editor/common/config/editorOptions",e)}),define(me[151],ge([0,1,150,9,108]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=y;class k{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,_e){this._values[ie]=_e}}e.ValidatedEditorOptions=k;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class P{constructor(ie,_e,xe,ze){this.id=ie,this.name=_e,this.defaultValue=xe,this.schema=ze}compute(ie,_e,xe){return xe}}class s{constructor(ie,_e=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(ie){return this.defaultValue}}class C{constructor(ie,_e,xe,ze){this.id=ie,this.name=_e,this.defaultValue=xe,this.schema=ze}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,_e,xe){return xe}}function f(X,ie){return typeof X=="undefined"?ie:X==="false"?!1:Boolean(X)}e.boolean=f;class h extends C{constructor(ie,_e,xe,ze=void 0){typeof ze!="undefined"&&(ze.type="boolean",ze.default=xe),super(ie,_e,xe,ze)}validate(ie){return f(ie,this.defaultValue)}}class a extends C{constructor(ie,_e,xe,ze,$e,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=xe,Ye.minimum=ze,Ye.maximum=$e),super(ie,_e,xe,Ye),this.minimum=ze,this.maximum=$e}static clampedInt(ie,_e,xe,ze){if(typeof ie=="undefined")return _e;let $e=parseInt(ie,10);return isNaN($e)?_e:($e=Math.max(xe,$e),$e=Math.min(ze,$e),$e|0)}validate(ie){return a.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class u extends C{constructor(ie,_e,xe,ze,$e){typeof $e!="undefined"&&($e.type="number",$e.default=xe),super(ie,_e,xe,$e),this.validationFn=ze}static clamp(ie,_e,xe){return ie<_e?_e:ie>xe?xe:ie}static float(ie,_e){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return _e;const xe=parseFloat(ie);return isNaN(xe)?_e:xe}validate(ie){return this.validationFn(u.float(ie,this.defaultValue))}}class E extends C{static string(ie,_e){return typeof ie!="string"?_e:ie}constructor(ie,_e,xe,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.default=xe),super(ie,_e,xe,ze)}validate(ie){return E.string(ie,this.defaultValue)}}function v(X,ie,_e){return typeof X!="string"||_e.indexOf(X)===-1?ie:X}e.stringSet=v;class _ extends C{constructor(ie,_e,xe,ze,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=ze,$e.default=xe),super(ie,_e,xe,$e),this._allowedValues=ze}validate(ie){return v(ie,this.defaultValue,this._allowedValues)}}class g extends P{constructor(ie,_e,xe,ze,$e,Ye,K=void 0){typeof K!="undefined"&&(K.type="string",K.enum=$e,K.default=ze),super(ie,_e,xe,K),this._allowedValues=$e,this._convert=Ye}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function l(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",description:b.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,_e,xe){return xe===0?ie.accessibilitySupport:xe}}class n extends P{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertSpace:f(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var t;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(t=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(X){switch(X){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function c(X){switch(X){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class m extends s{constructor(){super(123,[62,31])}compute(ie,_e,xe){const ze=["monaco-editor"];return _e.get(31)&&ze.push(_e.get(31)),ie.extraEditorClassName&&ze.push(ie.extraEditorClassName),_e.get(62)==="default"?ze.push("mouse-default"):_e.get(62)==="copy"&&ze.push("mouse-copy"),_e.get(97)&&ze.push("showUnused"),_e.get(121)&&ze.push("showDeprecated"),ze.join(" ")}}class S extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ie,_e,xe){return xe&&ie.emptySelectionClipboard}}class p extends P{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:b.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[b.localize(9,null),b.localize(10,null),b.localize(11,null)],description:b.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:b.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:b.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:b.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{cursorMoveOnType:f(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:f(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":v(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(_e.loop,this.defaultValue.loop)}}}class w extends P{constructor(){super(41,"fontLigatures",w.OFF,{anyOf:[{type:"boolean",description:b.localize(16,null)},{type:"string",description:b.localize(17,null)}],description:b.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?w.OFF:ie==="true"?w.ON:ie:Boolean(ie)?w.ON:w.OFF}}e.EditorFontLigatures=w,w.OFF='"liga" off, "calt" off',w.ON='"liga" on, "calt" on';class R extends s{constructor(){super(40)}compute(ie,_e,xe){return ie.fontInfo}}class F extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(19,null)})}validate(ie){let _e=u.float(ie,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(_e,6,100)}compute(ie,_e,xe){return ie.fontInfo.fontSize}}class z extends P{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:b.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(a.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class oe extends P{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[b.localize(22,null),b.localize(23,null),b.localize(24,null)]};super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:b.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:b.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:b.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:b.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:b.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,description:b.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,description:b.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,description:b.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,description:b.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,description:b.localize(35,null)}})}validate(ie){var _e,xe,ze,$e,Ye;if(!ie||typeof ie!="object")return this.defaultValue;const K=ie;return{multiple:v(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=K.multipleDefinitions)!==null&&_e!==void 0?_e:v(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(xe=K.multipleTypeDefinitions)!==null&&xe!==void 0?xe:v(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(ze=K.multipleDeclarations)!==null&&ze!==void 0?ze:v(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=K.multipleImplementations)!==null&&$e!==void 0?$e:v(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ye=K.multipleReferences)!==null&&Ye!==void 0?Ye:v(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends P{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:b.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:b.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:b.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),delay:a.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:f(_e.sticky,this.defaultValue.sticky)}}}var W;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(W=e.RenderMinimap||(e.RenderMinimap={}));class $ extends s{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(ie,_e,xe){return $.computeLayout(_e,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const _e=ie.height/ie.lineHeight,xe=ie.scrollBeyondLastLine?_e-1:0,ze=(ie.viewLineCount+xe)/(ie.pixelRatio*ie.height),$e=Math.floor(ie.viewLineCount/ze);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:xe,desiredRatio:ze,minimapLineCount:$e}}static _computeMinimapLayout(ie,_e){const xe=ie.outerWidth,ze=ie.outerHeight,$e=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Ye=_e.stableMinimapLayoutInput,K=Ye&&ie.outerHeight===Ye.outerHeight&&ie.lineHeight===Ye.lineHeight&&ie.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Ye.pixelRatio&&ie.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&ie.minimap.enabled===Ye.minimap.enabled&&ie.minimap.side===Ye.minimap.side&&ie.minimap.size===Ye.minimap.size&&ie.minimap.showSlider===Ye.minimap.showSlider&&ie.minimap.renderCharacters===Ye.minimap.renderCharacters&&ie.minimap.maxColumn===Ye.minimap.maxColumn&&ie.minimap.scale===Ye.minimap.scale&&ie.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&ie.isViewportWrapping===Ye.isViewportWrapping,se=ie.lineHeight,fe=ie.typicalHalfwidthCharacterWidth,Z=ie.scrollBeyondLastLine,ne=ie.minimap.renderCharacters;let ce=$e>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const pe=ie.minimap.maxColumn,Se=ie.minimap.size,qe=ie.minimap.side,Me=ie.verticalScrollbarWidth,He=ie.viewLineCount,Qe=ie.remainingWidth,it=ie.isViewportWrapping,lt=ne?2:3;let Ze=Math.floor($e*ze);const nt=Ze/$e;let ht=!1,_t=!1,ue=lt*ce,De=ce/$e,le=1;if(Se==="fill"||Se==="fit"){const{typicalViewportLineCount:rt,extraLinesBeyondLastLine:Ge,desiredRatio:ft,minimapLineCount:at}=$.computeContainedMinimapLineCount({viewLineCount:He,scrollBeyondLastLine:Z,height:ze,lineHeight:se,pixelRatio:$e});if(He/at>1)ht=!0,_t=!0,ce=1,ue=1,De=ce/$e;else{let pt=!1,St=ce+1;if(Se==="fit"){const Ct=Math.ceil((He+Ge)*ue);it&&K&&Qe<=_e.stableFitRemainingWidth?(pt=!0,St=_e.stableFitMaxMinimapScale):(pt=Ct>Ze,it&&pt?(_e.stableMinimapLayoutInput=ie,_e.stableFitRemainingWidth=Qe):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(Se==="fill"||pt){ht=!0;const Ct=ce;ue=Math.min(se*$e,Math.max(1,Math.floor(1/ft))),ce=Math.min(St,Math.max(1,Math.floor(ue/lt))),ce>Ct&&(le=Math.min(2,ce/Ct)),De=ce/$e/le,Ze=Math.ceil(Math.max(rt,He+Ge)*ue),it&&pt&&(_e.stableFitMaxMinimapScale=ce)}}}const Y=Math.floor(pe*De),Ne=Math.min(Y,Math.max(0,Math.floor((Qe-Me-2)*De/(fe+De)))+e.MINIMAP_GUTTER_WIDTH);let Te=Math.floor($e*Ne);const Je=Te/$e;Te=Math.floor(Te*le);const et=ne?1:2,ut=qe==="left"?0:xe-Ne-Me;return{renderMinimap:et,minimapLeft:ut,minimapWidth:Ne,minimapHeightIsEditorHeight:ht,minimapIsSampling:_t,minimapScale:ce,minimapLineHeight:ue,minimapCanvasInnerWidth:Te,minimapCanvasInnerHeight:Ze,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:nt}}static computeLayout(ie,_e){const xe=_e.outerWidth|0,ze=_e.outerHeight|0,$e=_e.lineHeight|0,Ye=_e.lineNumbersDigitCount|0,K=_e.typicalHalfwidthCharacterWidth,se=_e.maxDigitWidth,fe=_e.pixelRatio,Z=_e.viewLineCount,ne=ie.get(118),ce=ne==="inherit"?ie.get(117):ne,pe=ce==="inherit"?ie.get(113):ce,Se=ie.get(116),qe=ie.get(2),Me=_e.isDominatedByLongLines,He=ie.get(46),Qe=ie.get(56).renderType!==0,it=ie.get(57),lt=ie.get(91),Ze=ie.get(61),nt=ie.get(89),ht=nt.verticalScrollbarSize,_t=nt.verticalHasArrows,ue=nt.arrowSize,De=nt.horizontalScrollbarSize,le=ie.get(54),Y=ie.get(35);let Ne;if(typeof le=="string"&&/^\d+(\.\d+)?ch$/.test(le)){const At=parseFloat(le.substr(0,le.length-2));Ne=a.clampedInt(At*K,0,0,1e3)}else Ne=a.clampedInt(le,0,0,1e3);Y&&(Ne+=16);let Te=0;if(Qe){const At=Math.max(Ye,it);Te=Math.round(At*se)}let Je=0;He&&(Je=$e);let et=0,ut=et+Je,rt=ut+Te,Ge=rt+Ne;const ft=xe-Je-Te-Ne;let at=!1,vt=!1,pt=-1;qe!==2&&(ce==="inherit"&&Me?(at=!0,vt=!0):pe==="on"||pe==="bounded"?vt=!0:pe==="wordWrapColumn"&&(pt=Se));const St=$._computeMinimapLayout({outerWidth:xe,outerHeight:ze,lineHeight:$e,typicalHalfwidthCharacterWidth:K,pixelRatio:fe,scrollBeyondLastLine:lt,minimap:Ze,verticalScrollbarWidth:ht,viewLineCount:Z,remainingWidth:ft,isViewportWrapping:vt},_e.memory||new D);St.renderMinimap!==0&&St.minimapLeft===0&&(et+=St.minimapWidth,ut+=St.minimapWidth,rt+=St.minimapWidth,Ge+=St.minimapWidth);const Ct=ft-St.minimapWidth,It=Math.max(1,Math.floor((Ct-ht-2)/K)),bt=_t?ue:0;return vt&&(pt=Math.max(1,It),pe==="bounded"&&(pt=Math.min(pt,Se))),{width:xe,height:ze,glyphMarginLeft:et,glyphMarginWidth:Je,lineNumbersLeft:ut,lineNumbersWidth:Te,decorationsLeft:rt,decorationsWidth:Ne,contentLeft:Ge,contentWidth:Ct,minimap:St,viewportColumn:It,isWordWrapMinified:at,isViewportWrapping:vt,wrappingColumn:pt,verticalScrollbarWidth:ht,horizontalScrollbarHeight:De,overviewRuler:{top:bt,width:ht,height:ze-2*bt,right:0}}}}e.EditorLayoutInfoComputer=$;class U extends P{constructor(){const ie={enabled:!0};super(53,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:b.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:f(ie.enabled,this.defaultValue.enabled)}}}class M extends P{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",ie,{"editor.inlineHints.enabled":{type:"boolean",default:ie.enabled,description:b.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:ie.fontSize,description:b.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:ie.fontFamily,description:b.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class L extends a{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:b.localize(43,null)})}compute(ie,_e,xe){return ie.fontInfo.lineHeight}}class N extends P{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:b.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(45,null),b.localize(46,null),b.localize(47,null)],default:ie.size,description:b.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:b.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:b.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:b.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:b.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),size:v(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(_e.side,this.defaultValue.side,["right","left"]),showSlider:v(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(_e.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(_e.scale,1,1,3),maxColumn:a.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(X){return X==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class B extends P{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{top:a.clampedInt(_e.top,0,0,1e3),bottom:a.clampedInt(_e.bottom,0,0,1e3)}}}class q extends P{constructor(){const ie={enabled:!0,cycle:!1};super(72,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:b.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:b.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:f(_e.enabled,this.defaultValue.enabled),cycle:f(_e.cycle,this.defaultValue.cycle)}}}class Q extends s{constructor(){super(124)}compute(ie,_e,xe){return ie.pixelRatio}}class he extends P{constructor(){const ie={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:b.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:b.localize(59,null)},other:{type:"boolean",default:ie.other,description:b.localize(60,null)}}}],default:ie,description:b.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const _e=ie,xe={other:f(_e.other,this.defaultValue.other),comments:f(_e.comments,this.defaultValue.comments),strings:f(_e.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var ve;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ie extends P{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(62,null),b.localize(63,null),b.localize(64,null),b.localize(65,null)],default:"on",description:b.localize(66,null)})}validate(ie){let _e=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(_e=4,xe=ie):ie==="interval"?_e=3:ie==="relative"?_e=2:ie==="on"?_e=1:_e=0),{renderType:_e,renderFn:xe}}}function ke(X){const ie=X.get(84);return ie==="editable"?X.get(77):ie!=="on"}e.filterValidationDecorations=ke;class Le extends P{constructor(){const ie=[],_e={type:"number",description:b.localize(67,null)};super(88,"rulers",ie,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:b.localize(68,null),format:"color-hex"}}}]},default:ie,description:b.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let _e=[];for(let xe of ie)if(typeof xe=="number")_e.push({column:a.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const ze=xe;_e.push({column:a.clampedInt(ze.column,0,0,1e4),color:ze.color})}return _e.sort((xe,ze)=>xe.column-ze.column),_e}return this.defaultValue}}function V(X,ie){if(typeof X!="string")return ie;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class J extends P{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie,xe=a.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=a.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:V(_e.vertical,this.defaultValue.vertical),horizontal:V(_e.horizontal,this.defaultValue.horizontal),useShadows:f(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:a.clampedInt(_e.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:a.clampedInt(_e.verticalSliderSize,ze,0,1e3),scrollByPage:f(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends P{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(70,null),b.localize(71,null)],default:ie.insertMode,description:b.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:b.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:b.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:b.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:b.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:b.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:b.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:b.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(109,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertMode:v(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:f(_e.showIcons,this.defaultValue.showIcons),showStatusBar:f(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:f(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(_e.showMethods,this.defaultValue.showMethods),showFunctions:f(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:f(_e.showConstructors,this.defaultValue.showConstructors),showFields:f(_e.showFields,this.defaultValue.showFields),showVariables:f(_e.showVariables,this.defaultValue.showVariables),showClasses:f(_e.showClasses,this.defaultValue.showClasses),showStructs:f(_e.showStructs,this.defaultValue.showStructs),showInterfaces:f(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:f(_e.showModules,this.defaultValue.showModules),showProperties:f(_e.showProperties,this.defaultValue.showProperties),showEvents:f(_e.showEvents,this.defaultValue.showEvents),showOperators:f(_e.showOperators,this.defaultValue.showOperators),showUnits:f(_e.showUnits,this.defaultValue.showUnits),showValues:f(_e.showValues,this.defaultValue.showValues),showConstants:f(_e.showConstants,this.defaultValue.showConstants),showEnums:f(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:f(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(_e.showKeywords,this.defaultValue.showKeywords),showWords:f(_e.showWords,this.defaultValue.showWords),showColors:f(_e.showColors,this.defaultValue.showColors),showFiles:f(_e.showFiles,this.defaultValue.showFiles),showReferences:f(_e.showReferences,this.defaultValue.showReferences),showFolders:f(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:f(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(_e.showSnippets,this.defaultValue.showSnippets),showUsers:f(_e.showUsers,this.defaultValue.showUsers),showIssues:f(_e.showIssues,this.defaultValue.showIssues)}}}class ae extends P{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(110,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class we extends s{constructor(){super(125,[77])}compute(ie,_e,xe){return _e.get(77)?!0:ie.tabFocusMode}}var Ce;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Ce=e.WrappingIndent||(e.WrappingIndent={}));function Oe(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class be extends s{constructor(){super(127,[126])}compute(ie,_e,xe){const ze=_e.get(126);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}const Pe="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Re:I.isLinux?We:Pe,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(X){return e.editorOptionsRegistry[X.id]=X,X}var Ke;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=39]="fontFamily",X[X.fontInfo=40]="fontInfo",X[X.fontLigatures=41]="fontLigatures",X[X.fontSize=42]="fontSize",X[X.fontWeight=43]="fontWeight",X[X.formatOnPaste=44]="formatOnPaste",X[X.formatOnType=45]="formatOnType",X[X.glyphMargin=46]="glyphMargin",X[X.gotoLocation=47]="gotoLocation",X[X.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",X[X.hover=50]="hover",X[X.inDiffEditor=51]="inDiffEditor",X[X.letterSpacing=52]="letterSpacing",X[X.lightbulb=53]="lightbulb",X[X.lineDecorationsWidth=54]="lineDecorationsWidth",X[X.lineHeight=55]="lineHeight",X[X.lineNumbers=56]="lineNumbers",X[X.lineNumbersMinChars=57]="lineNumbersMinChars",X[X.linkedEditing=58]="linkedEditing",X[X.links=59]="links",X[X.matchBrackets=60]="matchBrackets",X[X.minimap=61]="minimap",X[X.mouseStyle=62]="mouseStyle",X[X.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=64]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",X[X.multiCursorModifier=66]="multiCursorModifier",X[X.multiCursorPaste=67]="multiCursorPaste",X[X.occurrencesHighlight=68]="occurrencesHighlight",X[X.overviewRulerBorder=69]="overviewRulerBorder",X[X.overviewRulerLanes=70]="overviewRulerLanes",X[X.padding=71]="padding",X[X.parameterHints=72]="parameterHints",X[X.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",X[X.quickSuggestions=75]="quickSuggestions",X[X.quickSuggestionsDelay=76]="quickSuggestionsDelay",X[X.readOnly=77]="readOnly",X[X.renameOnType=78]="renameOnType",X[X.renderControlCharacters=79]="renderControlCharacters",X[X.renderIndentGuides=80]="renderIndentGuides",X[X.renderFinalNewline=81]="renderFinalNewline",X[X.renderLineHighlight=82]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=84]="renderValidationDecorations",X[X.renderWhitespace=85]="renderWhitespace",X[X.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",X[X.roundedSelection=87]="roundedSelection",X[X.rulers=88]="rulers",X[X.scrollbar=89]="scrollbar",X[X.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=91]="scrollBeyondLastLine",X[X.scrollPredominantAxis=92]="scrollPredominantAxis",X[X.selectionClipboard=93]="selectionClipboard",X[X.selectionHighlight=94]="selectionHighlight",X[X.selectOnLineNumbers=95]="selectOnLineNumbers",X[X.showFoldingControls=96]="showFoldingControls",X[X.showUnused=97]="showUnused",X[X.snippetSuggestions=98]="snippetSuggestions",X[X.smartSelect=99]="smartSelect",X[X.smoothScrolling=100]="smoothScrolling",X[X.stickyTabStops=101]="stickyTabStops",X[X.stopRenderingLineAfter=102]="stopRenderingLineAfter",X[X.suggest=103]="suggest",X[X.suggestFontSize=104]="suggestFontSize",X[X.suggestLineHeight=105]="suggestLineHeight",X[X.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",X[X.suggestSelection=107]="suggestSelection",X[X.tabCompletion=108]="tabCompletion",X[X.tabIndex=109]="tabIndex",X[X.unusualLineTerminators=110]="unusualLineTerminators",X[X.useTabStops=111]="useTabStops",X[X.wordSeparators=112]="wordSeparators",X[X.wordWrap=113]="wordWrap",X[X.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=116]="wordWrapColumn",X[X.wordWrapOverride1=117]="wordWrapOverride1",X[X.wordWrapOverride2=118]="wordWrapOverride2",X[X.wrappingIndent=119]="wrappingIndent",X[X.wrappingStrategy=120]="wrappingStrategy",X[X.showDeprecated=121]="showDeprecated",X[X.inlineHints=122]="inlineHints",X[X.editorClassName=123]="editorClassName",X[X.pixelRatio=124]="pixelRatio",X[X.tabFocusMode=125]="tabFocusMode",X[X.layoutInfo=126]="layoutInfo",X[X.wrappingInfo=127]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(111,null)})),acceptSuggestionOnEnter:Ee(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(112,null),""],markdownDescription:b.localize(113,null)})),accessibilitySupport:Ee(new d),accessibilityPageSize:Ee(new a(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(114,null)})),ariaLabel:Ee(new E(4,"ariaLabel",b.localize(115,null))),autoClosingBrackets:Ee(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(116,null),b.localize(117,null),""],description:b.localize(118,null)})),autoClosingDelete:Ee(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(119,null),""],description:b.localize(120,null)})),autoClosingOvertype:Ee(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(121,null),""],description:b.localize(122,null)})),autoClosingQuotes:Ee(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(123,null),b.localize(124,null),""],description:b.localize(125,null)})),autoIndent:Ee(new g(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[b.localize(126,null),b.localize(127,null),b.localize(128,null),b.localize(129,null),b.localize(130,null)],description:b.localize(131,null)})),automaticLayout:Ee(new h(10,"automaticLayout",!1)),autoSurround:Ee(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(132,null),b.localize(133,null),b.localize(134,null),""],description:b.localize(135,null)})),stickyTabStops:Ee(new h(101,"stickyTabStops",!1,{description:b.localize(136,null)})),codeLens:Ee(new h(12,"codeLens",!0,{description:b.localize(137,null)})),codeLensFontFamily:Ee(new E(13,"codeLensFontFamily","",{description:b.localize(138,null)})),codeLensFontSize:Ee(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:b.localize(139,null)})),colorDecorators:Ee(new h(15,"colorDecorators",!0,{description:b.localize(140,null)})),columnSelection:Ee(new h(16,"columnSelection",!1,{description:b.localize(141,null)})),comments:Ee(new n),contextmenu:Ee(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new h(19,"copyWithSyntaxHighlighting",!0,{description:b.localize(142,null)})),cursorBlinking:Ee(new g(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:b.localize(143,null)})),cursorSmoothCaretAnimation:Ee(new h(21,"cursorSmoothCaretAnimation",!1,{description:b.localize(144,null)})),cursorStyle:Ee(new g(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:b.localize(145,null)})),cursorSurroundingLines:Ee(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(146,null)})),cursorSurroundingLinesStyle:Ee(new _(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(147,null),b.localize(148,null)],description:b.localize(149,null)})),cursorWidth:Ee(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(150,null)})),disableLayerHinting:Ee(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new h(28,"domReadOnly",!1)),dragAndDrop:Ee(new h(29,"dragAndDrop",!0,{description:b.localize(151,null)})),emptySelectionClipboard:Ee(new S),extraEditorClassName:Ee(new E(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new u(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:b.localize(152,null)})),find:Ee(new p),fixedOverflowWidgets:Ee(new h(34,"fixedOverflowWidgets",!1)),folding:Ee(new h(35,"folding",!0,{description:b.localize(153,null)})),foldingStrategy:Ee(new _(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(154,null),b.localize(155,null)],description:b.localize(156,null)})),foldingHighlight:Ee(new h(37,"foldingHighlight",!0,{description:b.localize(157,null)})),unfoldOnClickAfterEndOfLine:Ee(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(158,null)})),fontFamily:Ee(new E(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(159,null)})),fontInfo:Ee(new R),fontLigatures2:Ee(new w),fontSize:Ee(new F),fontWeight:Ee(new z),formatOnPaste:Ee(new h(44,"formatOnPaste",!1,{description:b.localize(160,null)})),formatOnType:Ee(new h(45,"formatOnType",!1,{description:b.localize(161,null)})),glyphMargin:Ee(new h(46,"glyphMargin",!0,{description:b.localize(162,null)})),gotoLocation:Ee(new oe),hideCursorInOverviewRuler:Ee(new h(48,"hideCursorInOverviewRuler",!1,{description:b.localize(163,null)})),highlightActiveIndentGuide:Ee(new h(49,"highlightActiveIndentGuide",!0,{description:b.localize(164,null)})),hover:Ee(new j),inDiffEditor:Ee(new h(51,"inDiffEditor",!1)),letterSpacing:Ee(new u(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>u.clamp(X,-5,20),{description:b.localize(165,null)})),lightbulb:Ee(new U),lineDecorationsWidth:Ee(new C(54,"lineDecorationsWidth",10)),lineHeight:Ee(new L),lineNumbers:Ee(new Ie),lineNumbersMinChars:Ee(new a(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new h(58,"linkedEditing",!1,{description:b.localize(166,null)})),links:Ee(new h(59,"links",!0,{description:b.localize(167,null)})),matchBrackets:Ee(new _(60,"matchBrackets","always",["always","near","never"],{description:b.localize(168,null)})),minimap:Ee(new N),mouseStyle:Ee(new _(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new u(63,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:b.localize(169,null)})),mouseWheelZoom:Ee(new h(64,"mouseWheelZoom",!1,{markdownDescription:b.localize(170,null)})),multiCursorMergeOverlapping:Ee(new h(65,"multiCursorMergeOverlapping",!0,{description:b.localize(171,null)})),multiCursorModifier:Ee(new g(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[b.localize(172,null),b.localize(173,null)],markdownDescription:b.localize(174,null)})),multiCursorPaste:Ee(new _(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(175,null),b.localize(176,null)],markdownDescription:b.localize(177,null)})),occurrencesHighlight:Ee(new h(68,"occurrencesHighlight",!0,{description:b.localize(178,null)})),overviewRulerBorder:Ee(new h(69,"overviewRulerBorder",!0,{description:b.localize(179,null)})),overviewRulerLanes:Ee(new a(70,"overviewRulerLanes",3,0,3)),padding:Ee(new B),parameterHints:Ee(new q),peekWidgetDefaultFocus:Ee(new _(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(180,null),b.localize(181,null)],description:b.localize(182,null)})),definitionLinkOpensInPeek:Ee(new h(74,"definitionLinkOpensInPeek",!1,{description:b.localize(183,null)})),quickSuggestions:Ee(new he),quickSuggestionsDelay:Ee(new a(76,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(184,null)})),readOnly:Ee(new h(77,"readOnly",!1)),renameOnType:Ee(new h(78,"renameOnType",!1,{description:b.localize(185,null),markdownDeprecationMessage:b.localize(186,null)})),renderControlCharacters:Ee(new h(79,"renderControlCharacters",!1,{description:b.localize(187,null)})),renderIndentGuides:Ee(new h(80,"renderIndentGuides",!0,{description:b.localize(188,null)})),renderFinalNewline:Ee(new h(81,"renderFinalNewline",!0,{description:b.localize(189,null)})),renderLineHighlight:Ee(new _(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(190,null)],description:b.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Ee(new h(83,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(192,null)})),renderValidationDecorations:Ee(new _(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new _(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(193,null),b.localize(194,null),b.localize(195,null),""],description:b.localize(196,null)})),revealHorizontalRightPadding:Ee(new a(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new h(87,"roundedSelection",!0,{description:b.localize(197,null)})),rulers:Ee(new Le),scrollbar:Ee(new J),scrollBeyondLastColumn:Ee(new a(90,"scrollBeyondLastColumn",5,0,1073741824,{description:b.localize(198,null)})),scrollBeyondLastLine:Ee(new h(91,"scrollBeyondLastLine",!0,{description:b.localize(199,null)})),scrollPredominantAxis:Ee(new h(92,"scrollPredominantAxis",!0,{description:b.localize(200,null)})),selectionClipboard:Ee(new h(93,"selectionClipboard",!0,{description:b.localize(201,null),included:I.isLinux})),selectionHighlight:Ee(new h(94,"selectionHighlight",!0,{description:b.localize(202,null)})),selectOnLineNumbers:Ee(new h(95,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new _(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[b.localize(203,null),b.localize(204,null)],description:b.localize(205,null)})),showUnused:Ee(new h(97,"showUnused",!0,{description:b.localize(206,null)})),showDeprecated:Ee(new h(121,"showDeprecated",!0,{description:b.localize(207,null)})),inlineHints:Ee(new M),snippetSuggestions:Ee(new _(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(208,null),b.localize(209,null),b.localize(210,null),b.localize(211,null)],description:b.localize(212,null)})),smartSelect:Ee(new ae),smoothScrolling:Ee(new h(100,"smoothScrolling",!1,{description:b.localize(213,null)})),stopRenderingLineAfter:Ee(new a(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new ee),suggestFontSize:Ee(new a(104,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(214,null)})),suggestLineHeight:Ee(new a(105,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(215,null)})),suggestOnTriggerCharacters:Ee(new h(106,"suggestOnTriggerCharacters",!0,{description:b.localize(216,null)})),suggestSelection:Ee(new _(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(217,null),b.localize(218,null),b.localize(219,null)],description:b.localize(220,null)})),tabCompletion:Ee(new _(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null)],description:b.localize(224,null)})),tabIndex:Ee(new a(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new _(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(225,null),b.localize(226,null),b.localize(227,null)],description:b.localize(228,null)})),useTabStops:Ee(new h(111,"useTabStops",!0,{description:b.localize(229,null)})),wordSeparators:Ee(new E(112,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:b.localize(230,null)})),wordWrap:Ee(new _(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(231,null),b.localize(232,null),b.localize(233,null),b.localize(234,null)],description:b.localize(235,null)})),wordWrapBreakAfterCharacters:Ee(new E(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new E(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new a(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(236,null)})),wordWrapOverride1:Ee(new _(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new _(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new g(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[b.localize(237,null),b.localize(238,null),b.localize(239,null),b.localize(240,null)],description:b.localize(241,null)})),wrappingStrategy:Ee(new _(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[b.localize(242,null),b.localize(243,null)],description:b.localize(244,null)})),editorClassName:Ee(new m),pixelRatio:Ee(new Q),tabFocusMode:Ee(new we),layoutInfo:Ee(new $),wrappingInfo:Ee(new be)}}),define(me[152],ge([17,18]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[153],ge([17,18]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[154],ge([17,18]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[155],ge([17,18]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(me[156],ge([17,18]),function(G,e){return G.create("vs/platform/markers/common/markers",e)}),define(me[157],ge([17,18]),function(G,e){return G.create("vs/platform/theme/common/iconRegistry",e)}),define(me[158],ge([17,18]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(me[159],ge([17,18]),function(G,e){return G.create("vs/workbench/api/common/extHost.api.impl",e)}),define(me[160],ge([17,18]),function(G,e){return G.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[161],ge([17,18]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(me[162],ge([17,18]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[163],ge([17,18]),function(G,e){return G.create("vs/workbench/api/common/extHostProgress",e)}),define(me[164],ge([17,18]),function(G,e){return G.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[165],ge([17,18]),function(G,e){return G.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[166],ge([17,18]),function(G,e){return G.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[167],ge([17,18]),function(G,e){return G.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[168],ge([17,18]),function(G,e){return G.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[169],ge([17,18]),function(G,e){return G.create("vs/workbench/common/views",e)}),define(me[170],ge([17,18]),function(G,e){return G.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[171],ge([17,18]),function(G,e){return G.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[172],ge([17,18]),function(G,e){return G.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(me[173],ge([17,18]),function(G,e){return G.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[174],ge([17,18]),function(G,e){return G.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[175],ge([17,18]),function(G,e){return G.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[176],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var b;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(b=e.EditorActivation||(e.EditorActivation={}));var I;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var T;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[177],ge([0,1,154]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function T(C){return C=C.trim(),C==="*"||I.test(C)}e.isValidVersionStr=T;function A(C){if(!T(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=C.match(I);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=A;function y(C){if(!C)return null;let f=C.majorBase,h=C.majorMustEqual,a=C.minorBase,u=C.minorMustEqual,E=C.patchBase,v=C.patchMustEqual;return C.hasCaret&&(f===0||(u=!1),v=!1),{majorBase:f,majorMustEqual:h,minorBase:a,minorMustEqual:u,patchBase:E,patchMustEqual:v,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=y;function k(C,f){let h;typeof C=="string"?h=y(A(C)):h=C;let a;if(typeof f=="string"?a=y(A(f)):a=f,!h||!a)return!1;let u=h.majorBase,E=h.minorBase,v=h.patchBase,_=a.majorBase,g=a.minorBase,l=a.patchBase,d=a.majorMustEqual,n=a.minorMustEqual,t=a.patchMustEqual;return a.isMinimum?u>_?!0:u<_?!1:E>g?!0:E<g?!1:v>=l:(u===1&&_===0&&(!d||!n||!t)&&(_=1,g=0,l=0,d=!0,n=!1,t=!1),u<_?!1:u>_?!d:E<g?!1:E>g?!n:v<l?!1:v>l?!t:!0)}e.isValidVersion=k;function D(C,f,h){return f.isBuiltin||typeof f.main=="undefined"?!0:s(C,f.engines.vscode,h)}e.isValidExtensionVersion=D;function P(C,f){return C==="*"||s(f,C)}e.isEngineValid=P;function s(C,f,h=[]){let a=y(A(f));if(!a)return h.push(b.localize(0,null,f)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return h.push(b.localize(1,null,f)),!1}else if(!a.majorMustEqual)return h.push(b.localize(2,null,f)),!1;return k(C,a)?!0:(h.push(b.localize(3,null,C,f)),!1)}e.isVersionValid=s}),define(me[111],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class b{constructor(A,y=[],k=!1){this.ctor=A,this.staticArguments=y,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=b;const I=(T,...A)=>new b(T,A);e.createSyncDescriptor=I}),define(me[78],ge([0,1,111]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function T(y,k,D){k instanceof b.SyncDescriptor||(k=new b.SyncDescriptor(k,[],D)),I.push([y,k])}e.registerSingleton=T;function A(){return I}e.getSingletonServiceDescriptors=A}),define(me[178],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=b;class I{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let y of this._nodes.values())y.outgoing.size===0&&A.push(y);return A}insertEdge(A,y){const k=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(y);k.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(A),k)}removeNode(A){const y=this._hashFn(A);this._nodes.delete(y);for(let k of this._nodes.values())k.outgoing.delete(y),k.incoming.delete(y)}lookupOrInsertNode(A){const y=this._hashFn(A);let k=this._nodes.get(y);return k||(k=new b(A),this._nodes.set(y,k)),k}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[y,k]of this._nodes)A.push(`${y}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,y]of this._nodes){const k=new Set([A]),D=this._findCycle(y,k);if(D)return D}}_findCycle(A,y){for(let[k,D]of A.outgoing){if(y.has(k))return[...y,k].join(" -> ");y.add(k);const P=this._findCycle(D,y);if(P)return P;y.delete(k)}}}e.Graph=I}),define(me[4],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function D(P){return P[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=D})(b=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function I(k,D,P,s){D[b.DI_TARGET]===D?D[b.DI_DEPENDENCIES].push({id:k,index:P,optional:s}):(D[b.DI_DEPENDENCIES]=[{id:k,index:P,optional:s}],D[b.DI_TARGET]=D)}function T(k){if(b.serviceIds.has(k))return b.serviceIds.get(k);const D=function(P,s,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(D,P,C,!1)};return D.toString=()=>k,b.serviceIds.set(k,D),D}e.createDecorator=T;function A(k){return k}e.refineServiceDecorator=A;function y(k){return function(D,P,s){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(k,D,s,!0)}}e.optional=y}),define(me[179],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,b.createDecorator)("modelService");function I(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(me[180],ge([0,1,3,73,6,24,72,76,179]),function(G,e,b,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(f){return typeof f=="string"?!1:Array.isArray(f)?f.every(P):!!f.exclusive}class s{constructor(){this._clock=0,this._entries=[],this._onDidChange=new b.Emitter}get onDidChange(){return this._onDidChange.event}register(h,a){let u={selector:h,provider:a,_score:-1,_time:this._clock++};return this._entries.push(u),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(u){let E=this._entries.indexOf(u);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),u=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const a=[];for(let u of this._entries)u._score>0&&a.push(u.provider);return a}ordered(h){const a=[];return this._orderedForEach(h,u=>a.push(u.provider)),a}orderedGroups(h){const a=[];let u,E;return this._orderedForEach(h,v=>{u&&E===v._score?u.push(v.provider):(E=v._score,u=[v.provider],a.push(u))}),a}_orderedForEach(h,a){if(!!h){this._updateScores(h);for(const u of this._entries)u._score>0&&a(u)}}_updateScores(h){let a={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let u of this._entries)if(u._score=(0,k.score)(u.selector,h.uri,h.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(h)),P(u.selector)&&u._score>0){for(let E of this._entries)E._score=0;u._score=1e3;break}this._entries.sort(s._compareByScoreAndTime)}}static _compareByScoreAndTime(h,a){return h._score<a._score?1:h._score>a._score?-1:h._time<a._time?1:h._time>a._time?-1:0}}e.LanguageFeatureRegistry=s;class C{constructor(h,a,u=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=a,this.max=u,this._cache=new A.LRUCache(50,.7)}_key(h){return h.id+(0,I.hash)(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const a=this._key(h),u=this._cache.get(a);return this._clamp(u==null?void 0:u.value)}update(h,a){const u=this._key(h);let E=this._cache.get(u);return E||(E=new y.MovingAverage,this._cache.set(u,E)),E.update(a),this.get(h)}}e.LanguageFeatureRequestDelays=C}),define(me[79],ge([0,1,2,44,180,143,43]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class D{constructor(w,R){this.language=w,this.id=R}}e.LanguageIdentifier=D;var P;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var s;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(s=e.ColorId||(e.ColorId={}));var C;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var f;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",p[p.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(f=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(w){return(w&255)>>>0}static getTokenType(w){return(w&1792)>>>8}static getFontStyle(w){return(w&14336)>>>11}static getForeground(w){return(w&8372224)>>>14}static getBackground(w){return(w&4286578688)>>>23}static getClassNameFromMetadata(w){let R=this.getForeground(w),F="mtk"+R,z=this.getFontStyle(w);return z&1&&(F+=" mtki"),z&2&&(F+=" mtkb"),z&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(w,R){const F=this.getForeground(w),z=this.getFontStyle(w);let oe=`color: ${R[F]};`;return z&1&&(oe+="font-style: italic;"),z&2&&(oe+="font-weight: bold;"),z&4&&(oe+="text-decoration: underline;"),oe}}e.TokenMetadata=h;var a;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let p=Object.create(null);return p[0]="symbol-method",p[1]="symbol-function",p[2]="symbol-constructor",p[3]="symbol-field",p[4]="symbol-variable",p[5]="symbol-class",p[6]="symbol-struct",p[7]="symbol-interface",p[8]="symbol-module",p[9]="symbol-property",p[10]="symbol-event",p[11]="symbol-operator",p[12]="symbol-unit",p[13]="symbol-value",p[14]="symbol-constant",p[15]="symbol-enum",p[16]="symbol-enum-member",p[17]="symbol-keyword",p[27]="symbol-snippet",p[18]="symbol-text",p[19]="symbol-color",p[20]="symbol-file",p[21]="symbol-reference",p[22]="symbol-customcolor",p[23]="symbol-folder",p[24]="symbol-type-parameter",p[25]="account",p[26]="issues",function(w){const R=p[w];let F=R&&y.iconRegistry.get(R);return F||(console.info("No codicon found for CompletionItemKind "+w),F=y.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let p=Object.create(null);return p.method=0,p.function=1,p.constructor=2,p.field=3,p.variable=4,p.class=5,p.struct=6,p.interface=7,p.module=8,p.property=9,p.event=10,p.operator=11,p.unit=12,p.value=13,p.constant=14,p.enum=15,p["enum-member"]=16,p.enumMember=16,p.keyword=17,p.snippet=27,p.text=18,p.color=19,p.file=20,p.reference=21,p.customcolor=22,p.folder=23,p["type-parameter"]=24,p.typeParameter=24,p.account=25,p.issue=26,function(w,R){let F=p[w];return typeof F=="undefined"&&!R&&(F=9),F}}();var u;(function(p){p[p.Deprecated=1]="Deprecated"})(u=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var v;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(_=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function d(p){return p&&b.URI.isUri(p.uri)&&I.Range.isIRange(p.range)&&(I.Range.isIRange(p.originSelectionRange)||I.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=d;var n;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var t;(function(p){p[p.Deprecated=1]="Deprecated"})(t=e.SymbolTag||(e.SymbolTag={}));var r;(function(p){const w=new Map;w.set("file",0),w.set("module",1),w.set("namespace",2),w.set("package",3),w.set("class",4),w.set("method",5),w.set("property",6),w.set("field",7),w.set("constructor",8),w.set("enum",9),w.set("interface",10),w.set("function",11),w.set("variable",12),w.set("constant",13),w.set("string",14),w.set("number",15),w.set("boolean",16),w.set("array",17),w.set("object",18),w.set("key",19),w.set("null",20),w.set("enum-member",21),w.set("struct",22),w.set("event",23),w.set("operator",24),w.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function F(j){return w.get(j)}p.fromString=F;function z(j){return R.get(j)}p.toString=z;function oe(j,W){const $=R.get(j);let U=$&&y.iconRegistry.get("symbol-"+$);return U||(console.info("No codicon found for SymbolKind "+j),U=y.Codicon.symbolProperty),`${W?"inline":"block"} ${U.classNames}`}p.toCssClassName=oe})(r=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(w){this.value=w}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var o;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var m;(function(p){p[p.Other=0]="Other",p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(m=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var S;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(S=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[181],ge([0,1,6,12,4,3,56,54]),function(G,e,b,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,P){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!P)throw new Error("invalid command");return this.registerCommand({id:D,handler:P})}if(D.description){const a=[];for(let E of D.description.args)a.push(E.constraint);const u=D.handler;D.handler=function(E,...v){return(0,I.validateConstraints)(v,a),u(E,...v)}}const{id:s}=D;let C=this._commands.get(s);C||(C=new y.LinkedList,this._commands.set(s,C));let f=C.unshift(D),h=(0,b.toDisposable)(()=>{f();const a=this._commands.get(s);(a==null?void 0:a.isEmpty())&&this._commands.delete(s)});return this._onDidRegisterCommand.fire(s),h}registerCommandAlias(D,P){return e.CommandsRegistry.registerCommand(D,(s,...C)=>s.get(e.ICommandService).executeCommand(P,...C))}getCommand(D){const P=this._commands.get(D);if(!(!P||P.isEmpty()))return k.Iterable.first(P)}getCommands(){const D=new Map;for(const P of this._commands.keys()){const s=this.getCommand(P);s&&D.set(P,s)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>b.Disposable.None,onDidExecuteCommand:()=>b.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(me[80],ge([0,1,10,4,9]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=T.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",T.isMacintosh),y.set("isLinux",T.isLinux),y.set("isWindows",T.isWindows),y.set("isWeb",T.isWeb),y.set("isMacNative",T.isMacintosh&&!T.isWeb),y.set("isEdge",A.indexOf("Edg/")>=0),y.set("isFirefox",A.indexOf("Firefox")>=0),y.set("isChrome",A.indexOf("Chrome")>=0),y.set("isSafari",A.indexOf("Safari")>=0),y.set("isIPad",A.indexOf("iPad")>=0);const k=Object.prototype.hasOwnProperty;var D;(function(p){p[p.False=0]="False",p[p.True=1]="True",p[p.Defined=2]="Defined",p[p.Not=3]="Not",p[p.Equals=4]="Equals",p[p.NotEquals=5]="NotEquals",p[p.And=6]="And",p[p.Regex=7]="Regex",p[p.NotRegex=8]="NotRegex",p[p.Or=9]="Or",p[p.In=10]="In",p[p.NotIn=11]="NotIn",p[p.Greater=12]="Greater",p[p.GreaterEquals=13]="GreaterEquals",p[p.Smaller=14]="Smaller",p[p.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return C.INSTANCE}static true(){return f.INSTANCE}static has(w){return h.create(w)}static equals(w,R){return a.create(w,R)}static notEquals(w,R){return v.create(w,R)}static regex(w,R){return t.create(w,R)}static in(w,R){return u.create(w,R)}static not(w){return _.create(w)}static and(...w){return i.create(w)}static or(...w){return o.create(w)}static greater(w,R){return g.create(w,R)}static less(w,R){return d.create(w,R)}static deserialize(w,R=!1){if(!!w)return this._deserializeOrExpression(w,R)}static _deserializeOrExpression(w,R){let F=w.split("||");return o.create(F.map(z=>this._deserializeAndExpression(z,R)))}static _deserializeAndExpression(w,R){let F=w.split("&&");return i.create(F.map(z=>this._deserializeOne(z,R)))}static _deserializeOne(w,R){if(w=w.trim(),w.indexOf("!=")>=0){let F=w.split("!=");return v.create(F[0].trim(),this._deserializeValue(F[1],R))}if(w.indexOf("==")>=0){let F=w.split("==");return a.create(F[0].trim(),this._deserializeValue(F[1],R))}if(w.indexOf("=~")>=0){let F=w.split("=~");return t.create(F[0].trim(),this._deserializeRegexValue(F[1],R))}if(w.indexOf(" in ")>=0){let F=w.split(" in ");return u.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const F=w.split(">=");return l.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const F=w.split(">");return g.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const F=w.split("<=");return n.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const F=w.split("<");return d.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(w)?_.create(w.substr(1).trim()):h.create(w)}static _deserializeValue(w,R){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let F=/^'([^']*)'$/.exec(w);return F?F[1].trim():w}static _deserializeRegexValue(w,R){if((0,b.isFalsyOrWhitespace)(w)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=w.indexOf("/"),z=w.lastIndexOf("/");if(F===z||F<0){if(R)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let oe=w.slice(F+1,z),j=w[z+1]==="i"?"i":"";try{return new RegExp(oe,j)}catch(W){if(R)throw new Error(`bad regexp-value '${w}', parse error: ${W}`);return console.warn(`bad regexp-value '${w}', parse error: ${W}`),null}}}e.ContextKeyExpr=P;function s(p,w){return p.cmp(w)}class C{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class f{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class h{constructor(w){this.key=w,this.type=2}static create(w){const R=y.get(w);return typeof R=="boolean"?R?f.INSTANCE:C.INSTANCE:new h(w)}cmp(w){return w.type!==this.type?this.type-w.type:m(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return _.create(this.key)}}e.ContextKeyDefinedExpr=h;class a{constructor(w,R){this.key=w,this.value=R,this.type=4}static create(w,R){if(typeof R=="boolean")return R?h.create(w):_.create(w);const F=y.get(w);return typeof F=="boolean"?R===(F?"true":"false")?f.INSTANCE:C.INSTANCE:new a(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:S(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class u{constructor(w,R){this.key=w,this.valueKey=R,this.type=10}static create(w,R){return new u(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:S(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const R=w.getValue(this.valueKey),F=w.getValue(this.key);return Array.isArray(R)?R.indexOf(F)>=0:typeof F=="string"&&typeof R=="object"&&R!==null?k.call(R,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=u;class E{constructor(w){this._actual=w,this.type=11}static create(w){return new E(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new E(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class v{constructor(w,R){this.key=w,this.value=R,this.type=5}static create(w,R){if(typeof R=="boolean")return R?_.create(w):h.create(w);const F=y.get(w);return typeof F=="boolean"?R===(F?"true":"false")?C.INSTANCE:f.INSTANCE:new v(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:S(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=v;class _{constructor(w){this.key=w,this.type=3}static create(w){const R=y.get(w);return typeof R=="boolean"?R?C.INSTANCE:f.INSTANCE:new _(w)}cmp(w){return w.type!==this.type?this.type-w.type:m(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=_;class g{constructor(w,R){this.key=w,this.value=R,this.type=12}static create(w,R){return new g(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:S(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return n.create(this.key,this.value)}}e.ContextKeyGreaterExpr=g;class l{constructor(w,R){this.key=w,this.value=R,this.type=13}static create(w,R){return new l(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:S(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class d{constructor(w,R){this.key=w,this.value=R,this.type=14}static create(w,R){return new d(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:S(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=d;class n{constructor(w,R){this.key=w,this.value=R,this.type=15}static create(w,R){return new n(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:S(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(w,R){this.key=w,this.regexp=R,this.type=7}static create(w,R){return new t(w,R)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const R=this.regexp?this.regexp.source:"",F=w.regexp?w.regexp.source:"";return R<F?-1:R>F?1:0}equals(w){if(w.type===this.type){const R=this.regexp?this.regexp.source:"",F=w.regexp?w.regexp.source:"";return this.key===w.key&&R===F}return!1}evaluate(w){let R=w.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=t;class r{constructor(w){this._actual=w,this.type=8}static create(w){return new r(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new r(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class i{constructor(w){this.expr=w,this.type=6}static create(w){return i._normalizeArr(w)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const z=s(this.expr[R],w.expr[R]);if(z!==0)return z}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(w.expr[R]))return!1;return!0}return!1}evaluate(w){for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].evaluate(w))return!1;return!0}static _normalizeArr(w){const R=[];let F=!1;for(const z of w)if(!!z){if(z.type===1){F=!0;continue}if(z.type===0)return C.INSTANCE;if(z.type===6){R.push(...z.expr);continue}R.push(z)}if(R.length===0&&F)return f.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(s);R.length>1;){const z=R[R.length-1];if(z.type!==9)break;R.pop();const oe=R.pop(),j=o.create(z.expr.map(W=>i.create([W,oe])));j&&(R.push(j),R.sort(s))}return R.length===1?R[0]:new i(R)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let R of this.expr)w.push(...R.keys());return w}map(w){return new i(this.expr.map(R=>R.map(w)))}negate(){let w=[];for(let R of this.expr)w.push(R.negate());return o.create(w)}}e.ContextKeyAndExpr=i;class o{constructor(w){this.expr=w,this.type=9}static create(w){const R=o._normalizeArr(w);if(R.length!==0)return R.length===1?R[0]:new o(R)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const z=s(this.expr[R],w.expr[R]);if(z!==0)return z}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(w.expr[R]))return!1;return!0}return!1}evaluate(w){for(let R=0,F=this.expr.length;R<F;R++)if(this.expr[R].evaluate(w))return!0;return!1}static _normalizeArr(w){let R=[],F=!1;if(w){for(let z=0,oe=w.length;z<oe;z++){const j=w[z];if(!!j){if(j.type===0){F=!0;continue}if(j.type===1)return[f.INSTANCE];if(j.type===9){R=R.concat(j.expr);continue}R.push(j)}}if(R.length===0&&F)return[C.INSTANCE];R.sort(s)}return R}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let R of this.expr)w.push(...R.keys());return w}map(w){return new o(this.expr.map(R=>R.map(w)))}negate(){let w=[];for(let F of this.expr)w.push(F.negate());const R=F=>F.type===9?F.expr:[F];for(;w.length>1;){const F=w.shift(),z=w.shift(),oe=[];for(const j of R(F))for(const W of R(z))oe.push(P.and(j,W));w.unshift(P.or(...oe))}return w[0]}}e.ContextKeyOrExpr=o;class c extends h{constructor(w,R,F){super(w);this._defaultValue=R,typeof F=="object"?c._info.push(Object.assign(Object.assign({},F),{key:w})):F!==!0&&c._info.push({key:w,description:F,type:R!=null?typeof R:void 0})}static all(){return c._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return P.not(this.key)}isEqualTo(w){return P.equals(this.key,w)}notEqualsTo(w){return P.notEquals(this.key,w)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(p,w){return p<w?-1:p>w?1:0}function S(p,w,R,F){return p<R?-1:p>R?1:w<F?-1:w>F?1:0}}),define(me[182],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(me[183],ge([0,1,153,4,11]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function A(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=A;var y;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var k;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(k=e.SortOrder||(e.SortOrder={}));var D;(function(C){C.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var P;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(P=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class s extends Error{constructor(f,h){super(f);this.code=h}}e.ExtensionManagementError=s,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,b.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,b.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(me[28],ge([0,1,10,4]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(P){P[P.System=0]="System",P[P.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class y{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,C){if(typeof s=="undefined"||s===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof s=="string"||typeof C=="string"){let f=typeof s=="string"?s:s.value,h=typeof C=="string"?C:C.value;return b.equalsIgnoreCase(f,h)}return s._lower===C._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.ExtensionIdentifier=y;function k(P){return P.contributes&&P.contributes.localizations?P.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function D(P){return P.contributes&&P.contributes.authentication?P.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[184],ge([0,1,10,28]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(h,a){return h.uuid&&a.uuid?h.uuid===a.uuid:h.id===a.id?!0:(0,b.compareIgnoreCase)(h.id,a.id)===0}e.areSameExtensions=T;class A{constructor(a,u){this.version=u,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof A?T(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=A;function y(h,a){return`${h}.${a}`}e.getExtensionId=y;function k(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function D(h,a){return k(y(h,a))}e.getGalleryExtensionId=D;function P(h,a){const u=[],E=v=>{for(const _ of u)if(_.some(g=>T(a(g),a(v))))return _;return null};for(const v of h){const _=E(v);_?_.push(v):u.push([v])}return u}e.groupByExtension=P;function s(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=s;function C(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function f(h){const a=new Set;for(const u of h)u.malicious&&a.add(u.id.id);return a}e.getMaliciousExtensionsSet=f}),define(me[45],ge([0,1,155,8,2,4,10,12,24]),function(G,e,b,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function P(j){return j.create===!0}e.isFileOpenForWriteOptions=P;var s;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(s=e.FileType||(e.FileType={}));var C;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=f;function h(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=h;function a(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function u(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=u;var E;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(W,$){super(W);this.code=$}}e.FileSystemProviderError=v;function _(j,W){const $=new v(j.toString(),W);return l($,W),$}e.createFileSystemProviderError=_;function g(j){return j||_((0,b.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=g;function l(j,W){return j.name=W?`${W} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=l;function d(j){if(!j)return E.Unknown;if(j instanceof v)return j.code;const W=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!W)return E.Unknown;switch(W[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=d;function n(j){if(j instanceof m)return j.fileOperationResult;switch(d(j)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var t;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class r{constructor(W,$,U){this.resource=W,this.operation=$,this.target=U}isOperation(W){return this.operation===W}}e.FileOperationEvent=r;var i;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(i=e.FileChangeType||(e.FileChangeType={}));class o{constructor(W,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=W;for(const U of W)switch(U.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(U.resource,U);break}}contains(W,...$){return this.doContains(W,{includeChildren:!1},...$)}affects(W,...$){return this.doContains(W,{includeChildren:!0},...$)}doContains(W,$,...U){var M,L,N,O,B,q;if(!W)return!1;const Q=U.length>0;return!!((!Q||U.includes(1))&&(((M=this.added)===null||M===void 0?void 0:M.get(W))||$.includeChildren&&((L=this.added)===null||L===void 0?void 0:L.findSuperstr(W)))||(!Q||U.includes(0))&&(((N=this.updated)===null||N===void 0?void 0:N.get(W))||$.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(W)))||(!Q||U.includes(2))&&(((B=this.deleted)===null||B===void 0?void 0:B.findSubstr(W))||$.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(W))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(W){const $=[],U=W===1?this.added:W===0?this.updated:this.deleted;if(U)for(const[,M]of U)$.push(M);return $}filter(W){return new o(this.changes.filter($=>W($)),this.ignorePathCasing)}}e.FileChangesEvent=o;function c(j,W,$){return!j||!W||j===W||W.length>j.length?!1:(W.charAt(W.length-1)!==I.sep&&(W+=I.sep),$?(0,y.startsWithIgnoreCase)(j,W):j.indexOf(W)===0)}e.isParent=c;class m extends Error{constructor(W,$,U){super(W);this.fileOperationResult=$,this.options=U}static isFileOperationError(W){return W instanceof Error&&!(0,k.isUndefinedOrNull)(W.fileOperationResult)}}e.FileOperationError=m;var S;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(S=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var p;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(p=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function w(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=w;async function R(j,W){if(!W.canHandleResource(T.URI.from({scheme:j.scheme})))return new Promise($=>{const U=W.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===j.scheme&&M.added&&(U.dispose(),$())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(W){return(0,k.isNumber)(W)||(W=0),W<F.KB?(0,b.localize)(1,null,W.toFixed(0)):W<F.MB?(0,b.localize)(2,null,(W/F.KB).toFixed(2)):W<F.GB?(0,b.localize)(3,null,(W/F.MB).toFixed(2)):W<F.TB?(0,b.localize)(4,null,(W/F.GB).toFixed(2)):(0,b.localize)(5,null,(W/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var z;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function oe(j){return{maxFileSize:j===0?300*F.MB:16*F.GB,maxHeapSize:j===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=oe}),define(me[81],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...T){this._entries=new Map;for(let[A,y]of T)this.set(A,y)}set(T,A){const y=this._entries.get(T);return this._entries.set(T,A),y}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=b}),define(me[185],ge([0,1,19,178,111,4,81,16]),function(G,e,b,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(a){var u;super("cyclic dependency between services");this.message=(u=a.findCycleSlow())!==null&&u!==void 0?u:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class s{constructor(a=new y.ServiceCollection,u=!1,E){this._activeInstantiations=new Set,this._services=a,this._strict=u,this._parent=E,this._services.set(A.IInstantiationService,this)}createChild(a){return new s(a,this._strict,this)}invokeFunction(a,...u){let E=f.traceInvocation(a),v=!1;try{return a({get:(g,l)=>{if(v)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(g,E);if(!d&&l!==A.optional)throw new Error(`[invokeFunction] unknown service '${g}'`);return d}},...u)}finally{v=!0,E.stop()}}createInstance(a,...u){let E,v;return a instanceof T.SyncDescriptor?(E=f.traceCreation(a.ctor),v=this._createInstance(a.ctor,a.staticArguments.concat(u),E)):(E=f.traceCreation(a),v=this._createInstance(a,u,E)),E.stop(),v}_createInstance(a,u=[],E){let v=A._util.getServiceDependencies(a).sort((l,d)=>l.index-d.index),_=[];for(const l of v){let d=this._getOrCreateServiceInstance(l.id,E);if(!d&&this._strict&&!l.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${l.id}.`);_.push(d)}let g=v.length>0?v[0].index:u.length;if(u.length!==g){console.warn(`[createInstance] First service dependency of ${a.name} at position ${g+1} conflicts with ${u.length} static arguments`);let l=g-u.length;l>0?u=u.concat(new Array(l)):u=u.slice(0,g)}return new a(...[...u,..._])}_setServiceInstance(a,u){if(this._services.get(a)instanceof T.SyncDescriptor)this._services.set(a,u);else if(this._parent)this._parent._setServiceInstance(a,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let u=this._services.get(a);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):u}_getOrCreateServiceInstance(a,u){let E=this._getServiceInstanceOrDescriptor(a);return E instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,E,u.branch(a,!0)):(u.branch(a,!1),E)}_safeCreateAndCacheServiceInstance(a,u,E){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,u,E)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,u,E){const v=new I.Graph(l=>l.id.toString());let _=0;const g=[{id:a,desc:u,_trace:E}];for(;g.length;){const l=g.pop();if(v.lookupOrInsertNode(l),_++>1e3)throw new P(v);for(let d of A._util.getServiceDependencies(l.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(d.id);if(!n&&!d.optional&&console.warn(`[createInstance] ${a} depends on ${d.id} which is NOT registered.`),n instanceof T.SyncDescriptor){const t={id:d.id,desc:n,_trace:l._trace.branch(d.id,!0)};v.insertEdge(l,t),g.push(t)}}}for(;;){const l=v.roots();if(l.length===0){if(!v.isEmpty())throw new P(v);break}for(const{data:d}of l){if(this._getServiceInstanceOrDescriptor(d.id)instanceof T.SyncDescriptor){const t=this._createServiceInstanceWithOwner(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this._setServiceInstance(d.id,t)}v.removeNode(d)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,u,E=[],v,_){if(this._services.get(a)instanceof T.SyncDescriptor)return this._createServiceInstance(u,E,v,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,u,E,v,_);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(a,u=[],E,v){if(E){const _=new k.IdleValue(()=>this._createInstance(a,u,v));return new Proxy(Object.create(null),{get(g,l){if(l in g)return g[l];let d=_.value,n=d[l];return typeof n!="function"||(n=n.bind(d),g[l]=n),n},set(g,l,d){return _.value[l]=d,!0}})}else return this._createInstance(a,u,v)}}e.InstantiationService=s;var C;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(C||(C={}));class f{constructor(a,u){this.type=a,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new f(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(a){return D?new f(0,a.name):f._None}branch(a,u){let E=new f(2,a.toString());return this._dep.push([a,u,E]),E}stop(){let a=Date.now()-this._start;f._totals+=a;let u=!1;function E(_,g){let l=[],d=new Array(_+1).join("	");for(const[n,t,r]of g._dep)if(t&&r){u=!0,l.push(`${d}CREATES -> ${n}`);let i=E(_+1,r);i&&l.push(i)}else l.push(`${d}uses -> ${n}`);return l.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(a>2||u)&&console.log(v.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(me[13],ge([0,1,4,6,9,3,59]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function k(){return new Date().toISOString()}var D;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class P extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class s extends P{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([n,...t]))}debug(n,...t){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([n,...t]))}info(n,...t){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([n,...t]))}warn(n,...t){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([n,...t]))}error(n,...t){if(this.checkLogLevel(D.Error))if(n instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=n.stack,this.log(D.Error,this.format(r))}else this.log(D.Error,this.format([n,...t]))}critical(n,...t){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([n,...t]))}flush(){}format(n){let t="";for(let r=0;r<n.length;r++){let i=n[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(o){}t+=(r>0?" ":"")+i}return t}}e.AbstractMessageLogger=s;class C extends P{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!T.isWindows}trace(n,...t){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}debug(n,...t){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}info(n,...t){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,n,...t):console.log(`[main ${k()}]`,n,...t))}warn(n,...t){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,n,...t):console.warn(`[main ${k()}]`,n,...t))}error(n,...t){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}critical(n,...t){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,n,...t):console.error(`[main ${k()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class f extends P{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=f;class h extends P{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,y.toErrorMessage)(n,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class a extends P{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const r of this.logServices)r.trace(n,...t)}debug(n,...t){for(const r of this.logServices)r.debug(n,...t)}info(n,...t){for(const r of this.logServices)r.info(n,...t)}warn(n,...t){for(const r of this.logServices)r.warn(n,...t)}error(n,...t){for(const r of this.logServices)r.error(n,...t)}critical(n,...t){for(const r of this.logServices)r.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=a;class u extends I.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=u;class E extends I.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}createLogger(n,t){let r=this.loggers.get(n.toString());return r||(r=this.doCreateLogger(n,(t==null?void 0:t.always)?D.Trace:this.logLevel,t),this.loggers.set(n.toString(),r),(t==null?void 0:t.always)||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class v{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(n){}getLevel(){return D.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=v;function _(d){if(d.verbose)return D.Trace;if(typeof d.logLevel=="string"){const n=g(d.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function g(d){switch(d){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=g;function l(d){switch(d){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=l}),define(me[112],ge([0,1,13,45]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function T(D,P,s,C){try{const f=await new Promise((h,a)=>{G(["spdlog"],h,a)});return f.setAsyncMode(8192,500),f.createRotatingLoggerAsync(D,P,s,C)}catch(f){console.error(f)}return null}function A(D,P,s,C){return G.__$__nodeRequire("spdlog").createRotatingLogger(D,P,s,C)}e.createRotatingLogger=A;function y(D,P,s){switch(P){case b.LogLevel.Trace:D.trace(s);break;case b.LogLevel.Debug:D.debug(s);break;case b.LogLevel.Info:D.info(s);break;case b.LogLevel.Warning:D.warn(s);break;case b.LogLevel.Error:D.error(s);break;case b.LogLevel.Critical:D.critical(s);break;default:throw new Error("Invalid log level")}}class k extends b.AbstractMessageLogger{constructor(P,s,C,f){super();this.name=P,this.filepath=s,this.rotating=C,this.buffer=[],this.setLevel(f),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(h=>{this._logger&&this._logger.setLevel(h)}))}_createSpdLogLogger(){const P=this.rotating?6:1,s=30/P*I.ByteSize.MB;return T(this.name,this.filepath,s,P).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:f,message:h}of this.buffer)y(this._logger,f,h);this.buffer=[]}})}log(P,s){this._logger?y(this._logger,P,s):this.getLevel()<=P&&this.buffer.push({level:P,message:s})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(me[113],ge([0,1,4,156,57]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(a,u){return u-a}D.compare=P;const s=Object.create(null);s[D.Error]=(0,I.localize)(0,null),s[D.Warning]=(0,I.localize)(1,null),s[D.Info]=(0,I.localize)(2,null);function C(a){return s[a]||""}D.toString=C;function f(a){switch(a){case T.default.Error:return D.Error;case T.default.Warning:return D.Warning;case T.default.Info:return D.Info;case T.default.Ignore:return D.Hint}}D.fromSeverity=f;function h(a){switch(a){case D.Error:return T.default.Error;case D.Warning:return T.default.Warning;case D.Info:return T.default.Info;case D.Hint:return T.default.Ignore}}D.toSeverity=h}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(D){const P="";function s(f){return C(f,!0)}D.makeKey=s;function C(f,h){let a=[P];return f.source?a.push(f.source.replace("\xA6","\\\xA6")):a.push(P),f.code?typeof f.code=="string"?a.push(f.code.replace("\xA6","\\\xA6")):a.push(f.code.value.replace("\xA6","\\\xA6")):a.push(P),f.severity!==void 0&&f.severity!==null?a.push(y.toString(f.severity)):a.push(P),f.message&&h?a.push(f.message.replace("\xA6","\\\xA6")):a.push(P),f.startLineNumber!==void 0&&f.startLineNumber!==null?a.push(f.startLineNumber.toString()):a.push(P),f.startColumn!==void 0&&f.startColumn!==null?a.push(f.startColumn.toString()):a.push(P),f.endLineNumber!==void 0&&f.endLineNumber!==null?a.push(f.endLineNumber.toString()):a.push(P),f.endColumn!==void 0&&f.endColumn!==null?a.push(f.endColumn.toString()):a.push(P),a.push(P),a.join("\xA6")}D.makeKeyOptionalMessage=C})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(me[186],ge([0,1,57,4,3]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=b.default,e.INotificationService=(0,I.createDecorator)("notificationService");var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new D,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(s){}updateMessage(s){}updateActions(s){}close(){}}e.NoOpNotification=k;class D{infinite(){}done(){}total(s){}worked(s){}}e.NoOpProgress=D}),define(me[187],ge([0,1,11,9,36,25]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof I.globals.vscode!="undefined"){const k=I.globals.vscode.context.configuration();if(k)y=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const k=(0,A.dirname)(b.FileAccess.asFileUri("",G));y=G.__$__nodeRequire((0,A.joinPath)(k,"product.json").fsPath);const D=G.__$__nodeRequire((0,A.joinPath)(k,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.56.0-dev",nameShort:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var je=this&&this.__decorate||function(G,e,b,I){var T=arguments.length,A=T<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,b):I,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,b,I);else for(var k=G.length-1;k>=0;k--)(y=G[k])&&(A=(T<3?y(A):T>3?y(e,b,A):y(e,b))||A);return T>3&&A&&Object.defineProperty(e,b,A),A},Be=this&&this.__param||function(G,e){return function(b,I){e(b,I,G)}};define(me[114],ge([0,1,4,21,6,16]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,b.createDecorator)("progressService");var y;(function(s){s[s.Explorer=1]="Explorer",s[s.Scm=3]="Scm",s[s.Extensions=5]="Extensions",s[s.Window=10]="Window",s[s.Notification=15]="Notification",s[s.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let D=class extends T.Disposable{constructor(C,f){super();this.deferred=new A.DeferredPromise,f.withProgress(C,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};D=je([Be(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends T.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(C){this.stop();const f=++this.currentOperationId,h=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{f===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:f,token:h.token,stop:()=>this.doStop(f),isCurrent:()=>this.currentOperationId===f}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,b.createDecorator)("editorProgressService")}),define(me[40],ge([0,1,12,52]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(y,k){I.ok(b.isString(y)),I.ok(b.isObject(k)),I.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,k)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new T}),define(me[115],ge([0,1,40,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[T(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new A;b.Registry.add(e.Extensions.JSONContribution,y)}),define(me[82],ge([0,1,152,3,40,12,115]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=T.Registry.as(y.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,_=!0){this.registerConfigurations([v],_)}registerConfigurations(v,_=!0){const g=[];v.forEach(l=>{g.push(...this.validateAndRegisterProperties(l,_,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(v){const _=[],g=l=>{if(l.properties)for(const d in l.properties)_.push(d),delete this.configurationProperties[d],this.removeFromSchema(d,l.properties[d]);l.allOf&&l.allOf.forEach(d=>g(d))};for(const l of v){g(l);const d=this.configurationContributors.indexOf(l);d!==-1&&this.configurationContributors.splice(d,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}registerDefaultConfigurations(v){const _=[],g=[];for(const l of v)for(const d in l)if(_.push(d),e.OVERRIDE_PROPERTY_PATTERN.test(d)){this.defaultValues[d]=Object.assign(Object.assign({},this.defaultValues[d]||{}),l[d]);const n={type:"object",default:this.defaultValues[d],description:b.localize(1,null,d),$ref:e.resourceLanguageSettingsSchemaId};g.push(C(d)),this.configurationProperties[d]=n,this.defaultLanguageConfigurationOverridesNode.properties[d]=n}else{this.defaultValues[d]=l[d];const n=this.configurationProperties[d];n&&(this.updatePropertyDefaultValue(d,n),this.updateSchema(d,n))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterDefaultConfigurations(v){const _=[];for(const g of v)for(const l in g)if(_.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const d=this.configurationProperties[l];d&&(this.updatePropertyDefaultValue(l,d),this.updateSchema(l,d))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const _ of v)this.overrideIdentifiers.add(_);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,_=!0,g,l=3){var d;l=A.isUndefinedOrNull(v.scope)?l:v.scope;let n=[],t=v.properties;if(t)for(let i in t){if(_&&a(i)){delete t[i];continue}const o=t[i];if(this.updatePropertyDefaultValue(i,o),e.OVERRIDE_PROPERTY_PATTERN.test(i)?o.scope=void 0:(o.scope=A.isUndefinedOrNull(o.scope)?l:o.scope,o.requireTrust=A.isUndefinedOrNull(o.requireTrust)?!!((d=g==null?void 0:g.requireTrustForConfigurations)===null||d===void 0?void 0:d.includes(i)):o.requireTrust),t[i].hasOwnProperty("included")&&!t[i].included){this.excludedConfigurationProperties[i]=t[i],delete t[i];continue}else this.configurationProperties[i]=t[i];!t[i].deprecationMessage&&t[i].markdownDeprecationMessage&&(t[i].deprecationMessage=t[i].markdownDeprecationMessage),n.push(i)}let r=v.allOf;if(r)for(let i of r)n.push(...this.validateAndRegisterProperties(i,_,g,l));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const _=g=>{let l=g.properties;if(l)for(const n in l)this.updateSchema(n,l[n]);let d=g.allOf;d&&d.forEach(_)};_(v)}updateSchema(v,_){switch(e.allSettings.properties[v]=_,_.scope){case 1:e.applicationSettings.properties[v]=_;break;case 2:e.machineSettings.properties[v]=_;break;case 6:e.machineOverridableSettings.properties[v]=_;break;case 3:e.windowSettings.properties[v]=_;break;case 4:e.resourceSettings.properties[v]=_;break;case 5:e.resourceSettings.properties[v]=_,this.resourceLanguageSettingsSchema.properties[v]=_;break}}removeFromSchema(v,_){switch(delete e.allSettings.properties[v],_.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const _=`[${v}]`,g={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(_,g),e.allSettings.properties[_]=g,e.applicationSettings.properties[_]=g,e.machineSettings.properties[_]=g,e.machineOverridableSettings.properties[_]=g,e.windowSettings.properties[_]=g,e.resourceSettings.properties[_]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,_){let g=this.defaultValues[v];A.isUndefined(g)&&(g=_.default),A.isUndefined(g)&&(g=f(_.type)),_.default=g}}const s="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(s);function C(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=C;function f(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const h=new P;T.Registry.add(e.Extensions.Configuration,h);function a(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?b.localize(5,null,E):h.getConfigurationProperties()[E]!==void 0?b.localize(6,null,E):null:b.localize(4,null)}e.validateProperty=a;function u(){const E=[],v=h.getConfigurationProperties();for(const _ of Object.keys(v))E.push([_,v[_].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=u}),define(me[83],ge([0,1,23,12,2,40,4,82]),function(G,e,b,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.isConfigurationOverrides=D;var P;(function(t){t[t.USER=1]="USER",t[t.USER_LOCAL=2]="USER_LOCAL",t[t.USER_REMOTE=3]="USER_REMOTE",t[t.WORKSPACE=4]="WORKSPACE",t[t.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",t[t.DEFAULT=6]="DEFAULT",t[t.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function s(t){switch(t){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=s;function C(t,r){const i=r?t?r.keys.filter(R=>t.keys.indexOf(R)===-1):[...r.keys]:[],o=t?r?t.keys.filter(R=>r.keys.indexOf(R)===-1):[...t.keys]:[],c=[];if(r&&t){for(const R of t.keys)if(r.keys.indexOf(R)!==-1){const F=v(t.contents,R),z=v(r.contents,R);b.equals(F,z)||c.push(R)}}const m=[],S=R=>{const F={};for(const z of R)for(const oe of z.identifiers)F[d(oe)]=z;return F},p=r?S(r.overrides):{},w=t?S(t.overrides):{};if(Object.keys(p).length)for(const R of i){const F=p[R];F&&m.push([(0,k.overrideIdentifierFromKey)(R),F.keys])}if(Object.keys(w).length)for(const R of o){const F=w[R];F&&m.push([(0,k.overrideIdentifierFromKey)(R),F.keys])}if(Object.keys(p).length&&Object.keys(w).length)for(const R of c){const F=w[R],z=p[R];if(F&&z){const oe=C({contents:F.contents,keys:F.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});m.push([(0,k.overrideIdentifierFromKey)(R),[...oe.added,...oe.removed,...oe.updated]])}}return{added:i,removed:o,updated:c,overrides:m}}e.compare=C;function f(t,r){const i=[];for(const o of Object.keys(t))if(k.OVERRIDE_PROPERTY_PATTERN.test(o)){const c={};for(const m in t[o])c[m]=t[o][m];i.push({identifiers:[(0,k.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(c),contents:h(c,r)})}return i}e.toOverrides=f;function h(t,r){const i=Object.create(null);for(let o in t)a(i,o,t[o],r);return i}e.toValuesTree=h;function a(t,r,i,o){const c=r.split("."),m=c.pop();let S=t;for(let p=0;p<c.length;p++){let w=c[p],R=S[w];switch(typeof R){case"undefined":R=S[w]=Object.create(null);break;case"object":break;default:o(`Ignoring ${r} as ${c.slice(0,p+1).join(".")} is ${JSON.stringify(R)}`);return}S=R}if(typeof S=="object"&&S!==null)try{S[m]=i}catch(p){o(`Ignoring ${r} as ${c.join(".")} is ${JSON.stringify(S)}`)}else o(`Ignoring ${r} as ${c.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=a;function u(t,r){const i=r.split(".");E(t,i)}e.removeFromValueTree=u;function E(t,r){const i=r.shift();if(r.length===0){delete t[i];return}if(Object.keys(t).indexOf(i)!==-1){const o=t[i];typeof o=="object"&&!Array.isArray(o)&&(E(o,r),Object.keys(o).length===0&&delete t[i])}}function v(t,r,i){function o(S,p){let w=S;for(const R of p){if(typeof w!="object"||w===null)return;w=w[R]}return w}const c=r.split("."),m=o(t,c);return typeof m=="undefined"?i:m}e.getConfigurationValue=v;function _(t,r,i){Object.keys(r).forEach(o=>{o!=="__proto__"&&(o in t?I.isObject(t[o])&&I.isObject(r[o])?_(t[o],r[o],i):i&&(t[o]=r[o]):t[o]=r[o])})}e.merge=_;function g(){const t=A.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(t)}e.getConfigurationKeys=g;function l(){const t=Object.create(null),r=A.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let i in r){let o=r[i].default;a(t,i,o,c=>console.error(`Conflict in default settings: ${c}`))}return t}e.getDefaultValues=l;function d(t){return`[${t}]`}e.keyFromOverrideIdentifier=d;function n(t,r,i){const o=t.inspect(r),c=t.inspect(i);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:o.defaultValue}e.getMigratedSettingValue=n}),define(me[188],ge([0,1,55,24,15,12,23,2,82,83,40,6,3]),function(G,e,b,I,T,A,y,k,D,P,s,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(n={},t=[],r=[]){this._contents=n,this._keys=t,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,P.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const r=this.getContentsForOverrideIdentifer(t);return r?n?(0,P.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){for(const t of this.overrides)if(t.identifiers.indexOf(n)!==-1)return t.keys;return[]}override(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const i of T.distinct([...Object.keys(this.contents),...Object.keys(t)])){let o=this.contents[i],c=t[i];c&&(typeof o=="object"&&typeof c=="object"?(o=y.deepClone(o),this.mergeContents(o,c)):o=c),r[i]=o}return new h(r,this.keys,this.overrides)}merge(...n){const t=y.deepClone(this.contents),r=y.deepClone(this.overrides),i=[...this.keys];for(const o of n){this.mergeContents(t,o.contents);for(const c of o.overrides){const[m]=r.filter(S=>T.equals(S.identifiers,c.identifiers));m?this.mergeContents(m.contents,c.contents):r.push(y.deepClone(c))}for(const c of o.keys)i.indexOf(c)===-1&&i.push(c)}return new h(t,i,r)}freeze(){return this.isFrozen=!0,this}mergeContents(n,t){for(const r of Object.keys(t)){if(r in n&&A.isObject(n[r])&&A.isObject(t[r])){this.mergeContents(n[r],t[r]);continue}n[r]=y.deepClone(t[r])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?y.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const t of this.overrides)if(t.identifiers.indexOf(n)!==-1)return t.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,P.addToValueTree)(this.contents,n,t,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,P.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let r=0;r<t;r++)n.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=h;class a extends h{constructor(){const n=(0,P.getDefaultValues)(),t=(0,P.getConfigurationKeys)(),r=[];for(const i of Object.keys(n))D.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[(0,D.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(n[i]),contents:(0,P.toValuesTree)(n[i],o=>console.error(`Conflict in default settings file: ${o}`))});super(n,t,r)}}e.DefaultConfigurationModel=a;class u{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!A.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:r,keys:i,overrides:o,untrusted:c}=this.doParseRaw(n,t);this._configurationModel=new h(r,i,o),this._untrustedConfigurations=c||[]}doParseContent(n){let t={},r=null,i=[],o=[],c=[];function m(p){Array.isArray(i)?i.push(p):r&&(i[r]=p)}let S={onObjectBegin:()=>{let p={};m(p),o.push(i),i=p,r=null},onObjectProperty:p=>{r=p},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{let p=[];m(p),o.push(i),i=p,r=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:m,onError:(p,w,R)=>{c.push({error:p,offset:w,length:R})}};if(n)try{b.visit(n,S),t=i[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return t}doParseRaw(n,t){const r=s.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),i=this.filter(n,r,!0,t);n=i.raw;const o=(0,P.toValuesTree)(n,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),c=Object.keys(n),m=(0,P.toOverrides)(n,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:o,keys:c,overrides:m,untrusted:i.untrusted}}filter(n,t,r,i){if(!(i==null?void 0:i.scopes)&&!(i==null?void 0:i.isUntrusted))return{raw:n,untrusted:[]};const o={},c=[];for(let m in n)if(D.OVERRIDE_PROPERTY_PATTERN.test(m)&&r){const S=this.filter(n[m],t,!1,i);o[m]=S.raw,c.push(...S.untrusted)}else{const S=t[m],p=S?typeof S.scope!="undefined"?S.scope:3:void 0;(p===void 0||i.scopes===void 0||i.scopes.includes(p))&&(i.isUntrusted&&(S==null?void 0:S.requireTrust)?c.push(m):o[m]=n[m])}return{raw:o,untrusted:c}}}e.ConfigurationModelParser=u;class E extends C.Disposable{constructor(n,t,r,i){super();this.userSettingsResource=n,this.scopes=t,this.fileService=i,this._onDidChange=this._register(new f.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(f.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=E;class v{constructor(n,t,r=new h,i=new h,o=new I.ResourceMap,c=new h,m=new I.ResourceMap,S=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=o,this._memoryConfiguration=c,this._memoryConfigurationByResource=m,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(n,t,r){return this.getConsolidateConfigurationModel(t,r).getValue(n)}updateValue(n,t,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new h,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,t===void 0?i.removeValue(n):i.setValue(n,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,r){const i=this.getConsolidateConfigurationModel(t,r),o=this.getFolderConfigurationModelForResource(t.resource,r),c=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,m=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),S=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),p=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),w=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),R=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,F=o?t.overrideIdentifier?o.freeze().override(t.overrideIdentifier).getValue(n):o.freeze().getValue(n):void 0,z=t.overrideIdentifier?c.override(t.overrideIdentifier).getValue(n):c.getValue(n),oe=i.getValue(n),j=T.distinct(T.flatten(i.overrides.map(W=>W.identifiers))).filter(W=>i.getOverrideValue(n,W)!==void 0);return{defaultValue:m,userValue:S,userLocalValue:p,userRemoteValue:w,workspaceValue:R,workspaceFolderValue:F,memoryValue:z,value:oe,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:w!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:o==null?void 0:o.freeze().getValue(n),override:t.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:c.getValue(n),override:t.overrideIdentifier?c.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const r=t.filter(i=>D.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const o=(0,D.overrideIdentifierFromKey)(i),c=this._defaultConfiguration.getKeysForOverrideIdentifier(o),m=n.getKeysForOverrideIdentifier(o),S=[...m.filter(p=>c.indexOf(p)===-1),...c.filter(p=>m.indexOf(p)===-1),...c.filter(p=>!y.equals(this._defaultConfiguration.override(o).getValue(p),n.override(o).getValue(p)))];return[o,S]});return this.updateDefaultConfiguration(n),{keys:t,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:i,overrides:o}=(0,P.compare)(this.localUserConfiguration,n),c=[...t,...r,...i];return c.length&&this.updateLocalUserConfiguration(n),{keys:c,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:i,overrides:o}=(0,P.compare)(this.remoteUserConfiguration,n);let c=[...t,...r,...i];return c.length&&this.updateRemoteUserConfiguration(n),{keys:c,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:i,overrides:o}=(0,P.compare)(this.workspaceConfiguration,n);let c=[...t,...r,...i];return c.length&&this.updateWorkspaceConfiguration(n),{keys:c,overrides:o}}compareAndUpdateFolderConfiguration(n,t){const r=this.folderConfigurations.get(n),{added:i,updated:o,removed:c,overrides:m}=(0,P.compare)(r,t);let S=[...i,...o,...c];return(S.length||!r)&&this.updateFolderConfiguration(n,t),{keys:S,overrides:m}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:i,removed:o,overrides:c}=(0,P.compare)(t,void 0);return{keys:[...r,...i,...o],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let r=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?r.override(n.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:n},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const i=t.getFolder(n);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const o=this._memoryConfigurationByResource.get(n);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(n);i?(t=r.merge(i),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=r}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:r,overrides:i,keys:o}=this._folderConfigurations.get(t);return n.push([t,{contents:r,overrides:i,keys:o}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(i=>t.add(i))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.user),i=this.parseConfigurationModel(n.workspace),o=n.folders.reduce((c,m)=>(c.set(k.URI.revive(m[0]),this.parseConfigurationModel(m[1])),c),new I.ResourceMap);return new v(t,r,new h,i,o,new h,new I.ResourceMap,!1)}static parseConfigurationModel(n){return new h(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=v;function _(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const n=new Set,t=new Map;for(const i of d)i.keys.forEach(o=>n.add(o)),i.overrides.forEach(([o,c])=>{const m=(0,I.getOrSet)(t,o,new Set);c.forEach(S=>m.add(S))});const r=[];return t.forEach((i,o)=>r.push([o,[...i.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=_;class g{constructor(n,t,r,i){this.change=n,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const o=new Set;n.keys.forEach(m=>o.add(m)),n.overrides.forEach(([,m])=>m.forEach(S=>o.add(S))),this.affectedKeys=[...o.values()];const c=new h;this.affectedKeys.forEach(m=>c.setValue(m,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){var r;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const i=this.previousConfiguration?this.previousConfiguration.getValue(n,t,(r=this.previous)===null||r===void 0?void 0:r.workspace):void 0,o=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!y.equals(i,o)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let r=(0,P.toValuesTree)({[t]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(n=n[i],!n)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=g;class l extends g{constructor(n,t,r,i){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=l}),define(me[84],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,b.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(I=e.RemoteTrustOption||(e.RemoteTrustOption={}));var T;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(k,D=T.Unknown,P){super(k);this._message=k,this._code=D,this._detail=P,this.isHandled=D===T.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(k){return k instanceof A&&k._code===T.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof A&&k._code===T.NoResolverFound}static isHandled(k){return k instanceof A&&k.isHandled}}e.RemoteAuthorityResolverError=A}),define(me[116],ge([0,1,11]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function I(D){return D.scheme===b.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=I;function T(D){if(!!D){const P=D.indexOf("+");return P<0?D:D.substr(0,P)}}e.getRemoteName=T;function A(D){return D.scheme!==b.Schemas.file&&D.scheme!==b.Schemas.vscodeRemote}function y(D){if(D.folders.length)return D.folders.every(P=>A(P.uri))?D.folders[0].uri:void 0;if(D.configuration&&A(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function k(D){var P;return(P=y(D))===null||P===void 0?void 0:P.scheme}e.getVirtualWorkspaceScheme=k}),define(me[189],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class b{vsda(){return new Promise((T,A)=>G(["vsda"],T,A))}async sign(T){try{const A=await this.vsda(),y=new A.signer;if(y)return y.sign(T)}catch(A){}return T}}e.SignService=b}),define(me[190],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class b{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,A,y=5){let k;return k=A(D=>{const P=typeof D=="string"?D:D.data;let s=this._terminalBufferMap.get(T);if(s){s.data.push(P);return}const C=setTimeout(()=>this.flushBuffer(T),y);s={data:[P],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(T),k.dispose()}},this._terminalBufferMap.set(T,s)}),k}stopBuffering(T){const A=this._terminalBufferMap.get(T);A&&A.dispose()}flushBuffer(T){const A=this._terminalBufferMap.get(T);A&&(this._terminalBufferMap.delete(T),this._callback(T,A.data.join("")))}}e.TerminalDataBufferer=b}),define(me[191],ge([0,1,48,8,36,26,12,23,9]),function(G,e,b,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function P(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(b.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=P;async function s(C,f,h,a=T.env,u=A.exists){if(I.isAbsolute(C))return await u(C)?C:void 0;if(f===void 0&&(f=T.cwd()),I.dirname(C)!=="."){const g=I.join(f,C);return await u(g)?g:void 0}const v=(0,k.getCaseInsensitive)(a,"PATH");if(h===void 0&&(0,y.isString)(v)&&(h=v.split(I.delimiter)),h===void 0||h.length===0){const g=I.join(f,C);return await u(g)?g:void 0}for(let g of h){let l;if(I.isAbsolute(g)?l=I.join(g,C):l=I.join(f,g,C),await u(l))return l;if(D.isWindows){let d=l+".com";if(await u(d)||(d=l+".exe",await u(d)))return d}}const _=I.join(f,C);return await u(_)?_:void 0}e.findExecutable=s}),define(me[192],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var b;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(b=e.ColorScheme||(e.ColorScheme={}))}),define(me[193],ge([0,1,4,6,40,3,192,43]),function(G,e,b,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,b.createDecorator)("themeService");var D;(function(E){function v(_){return _&&typeof _=="object"&&typeof _.id=="string"}E.isThemeColor=v})(D=e.ThemeColor||(e.ThemeColor={}));function P(E){return{id:E}}e.themeColorFromId=P;var s;(function(E){function v(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||D.isThemeColor(n.color))}E.isThemeIcon=v;const _=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function g(n){const t=_.exec(n);if(!!t){let[,r]=t;return{id:r}}}E.fromString=g;function l(n,t){let r=n.id;const i=r.lastIndexOf("~");return i!==-1&&(r=r.substring(0,i)),t&&(r=`${r}~${t}`),{id:r}}E.modify=l;function d(n,t){var r,i;return n.id===t.id&&((r=n.color)===null||r===void 0?void 0:r.id)===((i=t.color)===null||i===void 0?void 0:i.id)}E.isEqual=d,E.asClassNameArray=k.CSSIcon.asClassNameArray,E.asClassName=k.CSSIcon.asClassName,E.asCSSSelector=k.CSSIcon.asCSSSelector})(s=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function C(E){switch(E){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,I.toDisposable)(()=>{const _=this.themingParticipants.indexOf(v);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new f;T.Registry.add(e.Extensions.ThemingContribution,h);function a(E){return h.onColorThemeChange(E)}e.registerThemingParticipant=a;class u extends I.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,_){let g=this.theme.getColor(v);return g&&_&&(g=_(g,this.theme)),g?g.toString():null}}e.Themable=u}),define(me[194],ge([0,1,40,193,3,157,115,16,43]),function(G,e,b,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(v,_,g,l){const d=this.iconsById[v];if(d){if(g&&!d.description){d.description=g,this.iconSchema.properties[v].markdownDescription=`${g} $(${v})`;const r=this.iconReferenceSchema.enum.indexOf(v);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=g),this._onDidChange.fire()}return d}let n={id:v,description:g,defaults:_,deprecationMessage:l};this.iconsById[v]=n;let t={$ref:"#/definitions/icons"};return l&&(t.deprecationMessage=l),g&&(t.markdownDescription=`${g}: $(${v})`),this.iconSchema.properties[v]=t,this.iconReferenceSchema.enum.push(v),this.iconReferenceSchema.enumDescriptions.push(g||""),this._onDidChange.fire(),{id:v}}deregisterIcon(v){delete this.iconsById[v],delete this.iconSchema.properties[v];const _=this.iconReferenceSchema.enum.indexOf(v);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(v=>this.iconsById[v])}getIcon(v){return this.iconsById[v]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(v,_){const g=this.iconFontsById[v];if(g)return g;let l={id:v,definition:_};return this.iconFontsById[v]=l,this._onDidChange.fire(),l}deregisterIconFont(v){delete this.iconFontsById[v]}getIconFonts(){return Object.keys(this.iconFontsById).map(v=>this.iconFontsById[v])}getIconFont(v){return this.iconFontsById[v]}toString(){const v=(d,n)=>d.id.localeCompare(n.id),_=d=>{for(;I.ThemeIcon.isThemeIcon(d.defaults);)d=this.iconsById[d.defaults.id];return`codicon codicon-${d?d.id:""}`};let g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(d=>this.iconsById[d]);for(const d of l.filter(n=>!!n.description).sort(v))g.push(`|<i class="${_(d)}"></i>|${d.id}|${I.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const d of l.filter(n=>!I.ThemeIcon.isThemeIcon(n.defaults)).sort(v))g.push(`|<i class="${_(d)}"></i>|${d.id}|`);return g.join(`
`)}}const s=new P;b.Registry.add(e.Extensions.IconContribution,s);function C(E,v,_,g){return s.registerIcon(E,v,_,g)}e.registerIcon=C;function f(){return s}e.getIconRegistry=f;function h(){for(const E of D.iconRegistry.all)s.registerIcon(E.id,E.definition,E.description);D.iconRegistry.onDidRegister(E=>s.registerIcon(E.id,E.definition,E.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let a=b.Registry.as(y.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,s.getIconSchema());const u=new k.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);s.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.widgetClose=C("widget-close",D.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",D.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",D.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=I.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(me[60],ge([0,1,2,25,4,24]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var y;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function k(f){const h=f;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=k;function D(f){const h=f;return!!(h&&typeof h=="object"&&b.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(h,a,u,E){this._id=h,this._configuration=u,this._ignorePathCasing=E,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class s{constructor(h,a){this.raw=a,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,I.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=s;function C(f){return new s({uri:f,index:0,name:(0,I.basenameOrAuthority)(f)},{uri:f.toString()})}e.toWorkspaceFolder=C}),define(me[117],ge([0,1,4,158,60,2,9,8,25,133,55,11,75,29,116]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const u=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E($){return(typeof $=="string"?(0,k.extname)($):(0,D.extname)($))===u}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function v($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function _($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=_;function g($){return $.hasOwnProperty("fileUri")}e.isRecentFile=g;function l($){const U=$;return typeof(U==null?void 0:U.id)=="string"&&A.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=l;function d($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=d;function n($){const U=$;return typeof(U==null?void 0:U.id)=="string"&&A.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=n;function t($){const U=$;if(U==null?void 0:U.uri)return{id:U.id,uri:A.URI.revive(U.uri)};const M=$;if(M==null?void 0:M.configPath)return{id:M.id,configPath:A.URI.revive(M.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=t;function r($,U){return D.extUriBiasedIgnorePathCase.isEqualOrParent($,U.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function i($){return o($)||c($)}e.isStoredWorkspaceFolder=i;function o($){const U=$;return typeof(U==null?void 0:U.path)=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=o;function c($){const U=$;return typeof(U==null?void 0:U.uri)=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=c;function m($,U,M,L,N=!y.isWindows,O){if($.scheme!==L.scheme)return{name:M,uri:$.toString(!0)};let B=U?void 0:O.relativePath(L,$);if(B!==void 0)B.length===0?B=".":y.isWindows&&$.scheme===C.Schemas.file&&!N&&(B=B.replace(/\//g,"\\"));else if($.scheme===C.Schemas.file)B=$.fsPath,y.isWindows&&(B=(0,f.normalizeDriveLetter)(B),N&&(B=(0,h.toSlashes)(B)));else{if(!O.isEqualAuthority($.authority,L.authority))return{name:M,uri:$.toString(!0)};B=$.path}return{name:M,path:B}}e.getStoredWorkspaceFolder=m;function S($,U,M){let L=[],N=new Set;const O=M.dirname(U);for(let B of $){let q=null;if(o(B))B.path&&(q=M.resolvePath(O,B.path));else if(c(B))try{q=A.URI.parse(B.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(Q){console.warn(Q)}if(q){let Q=M.getComparisonKey(q);if(!N.has(Q)){N.add(Q);const he=B.name||M.basenameOrAuthority(q);L.push(new T.WorkspaceFolder({uri:q,name:he,index:L.length},B))}}}return L}e.toWorkspaceFolders=S;function p($,U,M,L,N){let O=w(U,$);const B=N.dirname(U),q=N.dirname(L),Q=[],he=R(O.folders);for(const Le of O.folders){const V=o(Le)?N.resolvePath(B,Le.path):A.URI.parse(Le.uri);let J;M?J=!1:J=!o(Le)||(0,k.isAbsolute)(Le.path),Q.push(m(V,J,Le.name,q,he,N))}const ve={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Ie=P.setProperty($,["folders"],Q,ve);let ke=P.applyEdits($,Ie);return O.remoteAuthority===(0,a.getRemoteAuthority)(L)&&(ke=P.applyEdits(ke,P.removeProperty(ke,["remoteAuthority"],ve))),ke}e.rewriteWorkspaceFileForNewLocation=p;function w($,U){let M=s.parse(U);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter(L=>i(L));else throw new Error(`${$} looks like an invalid workspace file.`);return M}function R($){return y.isWindows?$.some(U=>o(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function F($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function z($){return typeof $.folderUri=="string"}function oe($){return typeof $.fileUri=="string"}function j($,U){const M={workspaces:[],files:[]};if($){const L=function(O,B){for(let q=0;q<O.length;q++)try{B(O[q],q)}catch(Q){U.warn(`Error restoring recent entry ${JSON.stringify(O[q])}: ${Q.toString()}. Skip entry.`)}},N=$;if(Array.isArray(N.entries))L(N.entries,O=>{const B=O.label,q=O.remoteAuthority;F(O)?M.workspaces.push({label:B,remoteAuthority:q,workspace:{id:O.workspace.id,configPath:A.URI.parse(O.workspace.configPath)}}):z(O)?M.workspaces.push({label:B,remoteAuthority:q,folderUri:A.URI.parse(O.folderUri)}):oe(O)&&M.files.push({label:B,remoteAuthority:q,fileUri:A.URI.parse(O.fileUri)})});else{const O=$;Array.isArray(O.workspaces3)&&L(O.workspaces3,(B,q)=>{const Q=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[q]||void 0;typeof B=="object"&&typeof B.id=="string"&&typeof B.configURIPath=="string"?M.workspaces.push({label:Q,workspace:{id:B.id,configPath:A.URI.parse(B.configURIPath)}}):typeof B=="string"&&M.workspaces.push({label:Q,folderUri:A.URI.parse(B)})}),Array.isArray(O.files2)&&L(O.files2,(B,q)=>{const Q=Array.isArray(O.fileLabels)&&O.fileLabels[q]||void 0;typeof B=="string"&&M.files.push({label:Q,fileUri:A.URI.parse(B)})})}}return M}e.restoreRecentlyOpened=j;function W($){const U={entries:[]};for(const M of $.workspaces)_(M)?U.entries.push({folderUri:M.folderUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority}):U.entries.push({workspace:{id:M.workspace.id,configPath:M.workspace.configPath.toString()},label:M.label,remoteAuthority:M.remoteAuthority});for(const M of $.files)U.entries.push({fileUri:M.fileUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority});return U}e.toStoreData=W}),define(me[85],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class b{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const A=this._idPool++;return this._data.set(A,T),this.logDebugInfo(),A}get(T,A){return this._data.has(T)?this._data.get(T)[A]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!b.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=b,b.enableDebugLogging=!1}),define(me[195],ge([0,1,2,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(k=>({name:k.name,group:k.group,resource:b.URI.revive(k.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(me[61],ge([0,1,11,4]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(b.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,k){k===null?this._providerInfo.delete(y):this._providerInfo.set(y,k)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,b.createDecorator)("IExtHostInitDataService")}),define(me[196],ge([0,1,16]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(y,k,D){this._deferredPromises=new Map,this._id=y,this._shared=k,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new b.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const s of P.values())s.complete()}catch(s){for(const C of P.values())C.error(s)}})()},0)}get whenReady(){return this._init}get(y,k){let D=this._value[y];return typeof D=="undefined"&&(D=k),D}update(y,k){this._value[y]=k;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const P=new b.DeferredPromise;return this._deferredPromises.set(y,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class T extends I{constructor(y,k){super(y.identifier.value,!0,k);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=T}),define(me[14],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class I{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=I});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[197],ge([0,1,28,3]),function(G,e,b,I){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(k,D){T.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=b.ExtensionIdentifier.toKey(k.identifier),tt(this,T,D,"f"),Ue(this,T,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(k){return Ue(this,T,"f").get(this._id,k)}store(k,D){return Ue(this,T,"f").store(this._id,k,D)}delete(k){return Ue(this,T,"f").delete(this._id,k)}}e.ExtensionSecrets=A,T=new WeakMap}),define(me[118],ge([0,1,4,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,b.createDecorator)("IExtHostTelemetry")}),define(me[86],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var I;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(I=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const T=new WeakMap,A=y=>{let k=T.get(y);return k||(k={children:new Map,bus:new b.Emitter},T.set(y,k)),k};e.getPrivateApiFor=A}),define(me[50],ge([0,1,4,3,14]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(k){function D(s){return{remoteAddress:s.remoteAddress,localAddress:s.localAddress,public:!!s.public}}k.fromApiTunnel=D;function P(s){return{remoteAddress:{host:s.tunnelRemoteHost,port:s.tunnelRemotePort},localAddress:s.localAddress,public:s.public}}k.fromServiceTunnel=P})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,b.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,P){return{dispose:()=>{}}}async $providePortAttributes(D,P,s,C,f){return[]}async $forwardPort(D,P){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=je([Be(0,T.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)},Vt=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(b[I[T]]=G[I[T]]);return b};define(me[7],ge([0,1,15,19,97,24,12,2,30,45,84,86]),function(G,e,b,I,T,A,y,k,D,P,s,C){"use strict";var f,h,a,u,E,v,_,g,l,d,n,t,r,i,o,c;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function m(H){function x(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf(x,H),Object.setPrototypeOf(x.prototype,H.prototype),x}let S=a=class{constructor(x){f.set(this,void 0),tt(this,f,x,"f")}static from(...x){let re=x;return new a(function(){if(re){for(const ye of re)ye&&typeof ye.dispose=="function"&&ye.dispose();re=void 0}})}dispose(){typeof Ue(this,f,"f")=="function"&&(Ue(this,f,"f").call(this),tt(this,f,void 0,"f"))}};f=new WeakMap,S=a=je([m],S),e.Disposable=S;let p=u=class{constructor(x,re){if(x<0)throw(0,I.illegalArgument)("line must be non-negative");if(re<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=x,this._character=re}static Min(...x){if(x.length===0)throw new TypeError;let re=x[0];for(let ye=1;ye<x.length;ye++){const Ve=x[ye];Ve.isBefore(re)&&(re=Ve)}return re}static Max(...x){if(x.length===0)throw new TypeError;let re=x[0];for(let ye=1;ye<x.length;ye++){const Ve=x[ye];Ve.isAfter(re)&&(re=Ve)}return re}static isPosition(x){if(!x)return!1;if(x instanceof u)return!0;let{line:re,character:ye}=x;return typeof re=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,re=0){if(x===null||re===null)throw(0,I.illegalArgument)();let ye;return typeof x=="undefined"?ye=0:typeof x=="number"?ye=x:(ye=typeof x.lineDelta=="number"?x.lineDelta:0,re=typeof x.characterDelta=="number"?x.characterDelta:0),ye===0&&re===0?this:new u(this.line+ye,this.character+re)}with(x,re=this.character){if(x===null||re===null)throw(0,I.illegalArgument)();let ye;return typeof x=="undefined"?ye=this.line:typeof x=="number"?ye=x:(ye=typeof x.line=="number"?x.line:this.line,re=typeof x.character=="number"?x.character:this.character),ye===this.line&&re===this.character?this:new u(ye,re)}toJSON(){return{line:this.line,character:this.character}}};p=u=je([m],p),e.Position=p;let w=E=class{constructor(x,re,ye,Ve){let Xe,ot;if(typeof x=="number"&&typeof re=="number"&&typeof ye=="number"&&typeof Ve=="number"?(Xe=new p(x,re),ot=new p(ye,Ve)):x instanceof p&&re instanceof p&&(Xe=x,ot=re),!Xe||!ot)throw new Error("Invalid arguments");Xe.isBefore(ot)?(this._start=Xe,this._end=ot):(this._start=ot,this._end=Xe)}static isRange(x){return x instanceof E?!0:x?p.isPosition(x.start)&&p.isPosition(x.end):!1}get start(){return this._start}get end(){return this._end}contains(x){return x instanceof E?this.contains(x._start)&&this.contains(x._end):x instanceof p?!(x.isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const re=p.Max(x.start,this._start),ye=p.Min(x.end,this._end);if(!re.isAfter(ye))return new E(re,ye)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const re=p.Min(x.start,this._start),ye=p.Max(x.end,this.end);return new E(re,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,re=this.end){if(x===null||re===null)throw(0,I.illegalArgument)();let ye;return x?p.isPosition(x)?ye=x:(ye=x.start||this.start,re=x.end||this.end):ye=this.start,ye.isEqual(this._start)&&re.isEqual(this.end)?this:new E(ye,re)}toJSON(){return[this.start,this.end]}};w=E=je([m],w),e.Range=w;let R=v=class extends w{constructor(x,re,ye,Ve){let Xe,ot;if(typeof x=="number"&&typeof re=="number"&&typeof ye=="number"&&typeof Ve=="number"?(Xe=new p(x,re),ot=new p(ye,Ve)):x instanceof p&&re instanceof p&&(Xe=x,ot=re),!Xe||!ot)throw new Error("Invalid arguments");super(Xe,ot);this._anchor=Xe,this._active=ot}static isSelection(x){return x instanceof v?!0:x?w.isRange(x)&&p.isPosition(x.anchor)&&p.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};R=v=je([m],R),e.Selection=R;class F{constructor(x,re,ye){if(typeof x!="string"||x.length===0)throw(0,I.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,I.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,I.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(re),this.connectionToken=ye}}e.ResolvedAuthority=F;class z extends Error{constructor(x,re=s.RemoteAuthorityResolverErrorCode.Unknown,ye){super(x);this._message=x,this._code=re,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(x,re){return new z(x,s.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(x){return new z(x,s.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var oe;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(oe=e.EndOfLine||(e.EndOfLine={}));var j;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=_=class{constructor(x,re){this._range=x,this._newText=re}static isTextEdit(x){return x instanceof _?!0:x?w.isRange(x)&&typeof x.newText=="string":!1}static replace(x,re){return new _(x,re)}static insert(x,re){return _.replace(new w(x,x),re)}static delete(x){return _.replace(x,"")}static setEndOfLine(x){const re=new _(new w(new p(0,0),new p(0,0)),"");return re.newEol=x,re}get range(){return this._range}set range(x){if(x&&!w.isRange(x))throw(0,I.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,I.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,I.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=_=je([m],W),e.TextEdit=W;var $;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellOutput=4]="CellOutput",H[H.CellReplace=5]="CellReplace",H[H.CellOutputItem=6]="CellOutputItem"})($=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,re,ye,Ve){this._edits.push({_type:1,from:x,to:re,options:ye,metadata:Ve})}createFile(x,re,ye){this._edits.push({_type:1,from:void 0,to:x,options:re,metadata:ye})}deleteFile(x,re,ye){this._edits.push({_type:1,from:x,to:void 0,options:re,metadata:ye})}replaceNotebookMetadata(x,re,ye){this._edits.push({_type:3,metadata:ye,uri:x,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(x,re,ye,Ve,Xe){let ot,dt,Et=[],Dt;if(xt.isNotebookRange(re)&&Lt.isNotebookCellDataArray(ye)&&!Lt.isNotebookCellDataArray(Ve)?(ot=re.start,dt=re.end,Et=ye,Dt=Ve):typeof re=="number"&&typeof ye=="number"&&Lt.isNotebookCellDataArray(Ve)&&(ot=re,dt=ye,Et=Ve,Dt=Xe),ot===void 0||dt===void 0)throw new Error("Invalid arguments");(ot!==dt||Et.length>0)&&this._edits.push({_type:5,uri:x,index:ot,count:dt-ot,cells:Et,metadata:Dt})}replaceNotebookCellOutput(x,re,ye,Ve){this._editNotebookCellOutput(x,re,!1,ye,Ve)}appendNotebookCellOutput(x,re,ye,Ve){this._editNotebookCellOutput(x,re,!0,ye,Ve)}replaceNotebookCellOutputItems(x,re,ye,Ve,Xe){this._editNotebookCellOutputItems(x,re,ye,!1,Ve,Xe)}appendNotebookCellOutputItems(x,re,ye,Ve,Xe){this._editNotebookCellOutputItems(x,re,ye,!0,Ve,Xe)}_editNotebookCellOutputItems(x,re,ye,Ve,Xe,ot){this._edits.push({_type:6,metadata:ot,uri:x,index:re,outputId:ye,append:Ve,newOutputItems:Xe})}_editNotebookCellOutput(x,re,ye,Ve,Xe){this._edits.push({_type:4,metadata:Xe,uri:x,index:re,append:ye,newOutputs:Ve,newMetadata:void 0})}replaceNotebookCellMetadata(x,re,ye,Ve){this._edits.push({_type:3,metadata:Ve,uri:x,edit:{editType:11,index:re,metadata:ye}})}replace(x,re,ye,Ve){this._edits.push({_type:2,uri:x,edit:new W(re,ye),metadata:Ve})}insert(x,re,ye,Ve){this.replace(x,new w(re,re),ye,Ve)}delete(x,re,ye){this.replace(x,re,"",ye)}has(x){return this._edits.some(re=>re._type===2&&re.uri.toString()===x.toString())}set(x,re){if(re)for(const ye of re)ye&&this._edits.push({_type:2,uri:x,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const Ve=this._edits[ye];Ve._type===2&&Ve.uri.toString()===x.toString()&&(this._edits[ye]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get(x){const re=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===x.toString()&&re.push(ye.edit);return re}entries(){const x=new A.ResourceMap;for(let re of this._edits)if(re._type===2){let ye=x.get(re.uri);ye||(ye=[re.uri,[]],x.set(re.uri,ye)),ye[1].push(re.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=je([m],U),e.WorkspaceEdit=U;let M=g=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof g?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=g._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,re=this._tabstop++){if(typeof x=="function"){const ye=new g;ye._tabstop=this._tabstop,x(ye),this._tabstop=ye._tabstop,x=ye.value}else x=g._escape(x);return this.value+="${",this.value+=re,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,re=this._tabstop++){const ye=x.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(x,re){if(typeof re=="function"){const ye=new g;ye._tabstop=this._tabstop,re(ye),this._tabstop=ye._tabstop,re=ye.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,re&&(this.value+=":",this.value+=re),this.value+="}",this}};M=g=je([m],M),e.SnippetString=M;var L;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(L=e.DiagnosticTag||(e.DiagnosticTag={}));var N;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(N=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let O=l=class{constructor(x,re){if(this.uri=x,re)if(re instanceof w)this.range=re;else if(re instanceof p)this.range=new w(re,re);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof l?!0:x?w.isRange(x.range)&&k.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};O=l=je([m],O),e.Location=O;let B=class{constructor(x,re){this.location=x,this.message=re}static is(x){return x?typeof x.message=="string"&&x.location&&w.isRange(x.location.range)&&k.URI.isUri(x.location.uri):!1}static isEqual(x,re){return x===re?!0:!x||!re?!1:x.message===re.message&&x.location.range.isEqual(re.location.range)&&x.location.uri.toString()===re.location.uri.toString()}};B=je([m],B),e.DiagnosticRelatedInformation=B;let q=class{constructor(x,re,ye=N.Error){if(!w.isRange(x))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=x,this.message=re,this.severity=ye}toJSON(){return{severity:N[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,re){return x===re?!0:!x||!re?!1:x.message===re.message&&x.severity===re.severity&&x.code===re.code&&x.severity===re.severity&&x.source===re.source&&x.range.isEqual(re.range)&&(0,b.equals)(x.tags,re.tags)&&(0,b.equals)(x.relatedInformation,re.relatedInformation,B.isEqual)}};q=je([m],q),e.Diagnostic=q;let Q=class{constructor(x,re){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:(0,T.isMarkdownString)(x)?this.contents=[x]:this.contents=[x],this.range=re}};Q=je([m],Q),e.Hover=Q;var he;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(he=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ve=class{constructor(x,re=he.Text){this.range=x,this.kind=re}toJSON(){return{range:this.range,kind:he[this.kind]}}};ve=je([m],ve),e.DocumentHighlight=ve;var Ie;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(Ie=e.SymbolKind||(e.SymbolKind={}));var ke;(function(H){H[H.Deprecated=1]="Deprecated"})(ke=e.SymbolTag||(e.SymbolTag={}));let Le=d=class{constructor(x,re,ye,Ve,Xe){this.name=x,this.kind=re,this.containerName=Xe,typeof ye=="string"&&(this.containerName=ye),Ve instanceof O?this.location=Ve:ye instanceof w&&(this.location=new O(Ve,ye)),d.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ie[this.kind],location:this.location,containerName:this.containerName}}};Le=d=je([m],Le),e.SymbolInformation=Le;let V=n=class{constructor(x,re,ye,Ve,Xe){this.name=x,this.detail=re,this.kind=ye,this.range=Ve,this.selectionRange=Xe,this.children=[],n.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(n.validate)}};V=n=je([m],V),e.DocumentSymbol=V;var J;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(J=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ee=class{constructor(x,re){this.title=x,this.kind=re}};ee=je([m],ee),e.CodeAction=ee;let ae=t=class{constructor(x){this.value=x}append(x){return new t(this.value?this.value+t.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+t.sep)}};ae.sep=".",ae=t=je([m],ae),e.CodeActionKind=ae,ae.Empty=new ae(""),ae.QuickFix=ae.Empty.append("quickfix"),ae.Refactor=ae.Empty.append("refactor"),ae.RefactorExtract=ae.Refactor.append("extract"),ae.RefactorInline=ae.Refactor.append("inline"),ae.RefactorRewrite=ae.Refactor.append("rewrite"),ae.Source=ae.Empty.append("source"),ae.SourceOrganizeImports=ae.Source.append("organizeImports"),ae.SourceFixAll=ae.Source.append("fixAll");let we=class{constructor(x,re){if(this.range=x,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};we=je([m],we),e.SelectionRange=we;class Ce{constructor(x,re,ye,Ve,Xe,ot){this.kind=x,this.name=re,this.detail=ye,this.uri=Ve,this.range=Xe,this.selectionRange=ot}}e.CallHierarchyItem=Ce;class Oe{constructor(x,re){this.fromRanges=re,this.from=x}}e.CallHierarchyIncomingCall=Oe;class be{constructor(x,re){this.fromRanges=re,this.to=x}}e.CallHierarchyOutgoingCall=be;let Pe=class{constructor(x,re){this.range=x,this.command=re}get isResolved(){return!!this.command}};Pe=je([m],Pe),e.CodeLens=Pe;let Re=r=class{constructor(x,re=!1){h.set(this,void 0),tt(this,h,new T.MarkdownString(x,{supportThemeIcons:re}),"f")}static isMarkdownString(x){return x instanceof r?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return Ue(this,h,"f").value}set value(x){Ue(this,h,"f").value=x}get isTrusted(){return Ue(this,h,"f").isTrusted}set isTrusted(x){Ue(this,h,"f").isTrusted=x}get supportThemeIcons(){return Ue(this,h,"f").supportThemeIcons}appendText(x){return Ue(this,h,"f").appendText(x),this}appendMarkdown(x){return Ue(this,h,"f").appendMarkdown(x),this}appendCodeblock(x,re){return Ue(this,h,"f").appendCodeblock(re!=null?re:"",x),this}};h=new WeakMap,Re=r=je([m],Re),e.MarkdownString=Re;let We=class{constructor(x,re){this.label=x,this.documentation=re}};We=je([m],We),e.ParameterInformation=We;let Ee=class{constructor(x,re){this.label=x,this.documentation=re,this.parameters=[]}};Ee=je([m],Ee),e.SignatureInformation=Ee;let Ke=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ke=je([m],Ke),e.SignatureHelp=Ke;var X;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ie;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(ie=e.InlineHintKind||(e.InlineHintKind={}));let _e=class{constructor(x,re,ye){this.text=x,this.range=re,this.kind=ye}};_e=je([m],_e),e.InlineHint=_e;var xe;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var $e;(function(H){H[H.Deprecated=1]="Deprecated"})($e=e.CompletionItemTag||(e.CompletionItemTag={}));let Ye=class{constructor(x,re){this.label=x,this.kind=re}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&ze[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ye=je([m],Ye),e.CompletionItem=Ye;let K=class{constructor(x=[],re=!1){this.items=x,this.isIncomplete=re}};K=je([m],K),e.CompletionList=K;var se;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(se=e.ViewColumn||(e.ViewColumn={}));var fe;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(fe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Z;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(Z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ne;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(ne=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ce;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pe;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Se;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Se=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function x(re){switch(re){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=x}(pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let qe=class{constructor(x,re){if(re&&!k.URI.isUri(re))throw(0,I.illegalArgument)("target");if(!w.isRange(x)||x.isEmpty)throw(0,I.illegalArgument)("range");this.range=x,this.target=re}};qe=je([m],qe),e.DocumentLink=qe;let Me=class{constructor(x,re,ye,Ve){this.red=x,this.green=re,this.blue=ye,this.alpha=Ve}};Me=je([m],Me),e.Color=Me;let He=class{constructor(x,re){if(re&&!(re instanceof Me))throw(0,I.illegalArgument)("color");if(!w.isRange(x)||x.isEmpty)throw(0,I.illegalArgument)("range");this.range=x,this.color=re}};He=je([m],He),e.ColorInformation=He;let Qe=class{constructor(x){if(!x||typeof x!="string")throw(0,I.illegalArgument)("label");this.label=x}};Qe=je([m],Qe),e.ColorPresentation=Qe;var it;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(it=e.ColorFormat||(e.ColorFormat={}));var lt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ze;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Ze=e.TaskRevealKind||(e.TaskRevealKind={}));var nt;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(nt=e.TaskPanelKind||(e.TaskPanelKind={}));let ht=i=class{constructor(x,re){if(typeof x!="string"||typeof re!="string")throw(0,I.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return i.Clean;case"build":return i.Build;case"rebuild":return i.Rebuild;case"test":return i.Test;default:return}}get id(){return this._id}};ht.Clean=new i("clean","Clean"),ht.Build=new i("build","Build"),ht.Rebuild=new i("rebuild","Rebuild"),ht.Test=new i("test","Test"),ht=i=je([m],ht),e.TaskGroup=ht;function _t(H){let x="";for(let re=0;re<H.length;re++)x+=H[re].replace(/,/g,",,")+",";return x}let ue=class{constructor(x,re,ye){if(typeof x!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=x,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=ye):this._options=re)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,I.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let re of this._args)x.push(re);return _t(x)}};ue=je([m],ue),e.ProcessExecution=ue;let De=class{constructor(x,re,ye){if(this._args=[],Array.isArray(re)){if(!x)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,I.illegalArgument)("command");this._command=x,this._args=re,this._options=ye}else{if(typeof x!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=x,this._options=re}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,I.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)x.push(typeof re=="string"?re:re.value);return _t(x)}};De=je([m],De),e.ShellExecution=De;var le;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(le=e.ShellQuoting||(e.ShellQuoting={}));var Y;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Y=e.TaskScope||(e.TaskScope={}));class Ne{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,D.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=Ne;let Te=o=class{constructor(x,re,ye,Ve,Xe,ot){this.__deprecated=!1,this._definition=this.definition=x;let dt;typeof re=="string"?(this._name=this.name=re,this._source=this.source=ye,this.execution=Ve,dt=Xe,this.__deprecated=!0):re===Y.Global||re===Y.Workspace?(this.target=re,this._name=this.name=ye,this._source=this.source=Ve,this.execution=Xe,dt=ot):(this.target=re,this._name=this.name=ye,this._source=this.source=Ve,this.execution=Xe,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ue?this._definition={type:o.ProcessType,id:this._execution.computeId()}:this._execution instanceof De?this._definition={type:o.ShellType,id:this._execution.computeId()}:this._execution instanceof Ne?this._definition={type:o.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:o.EmptyType,id:(0,D.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const re=this._definition.type;(o.EmptyType===re||o.ProcessType===re||o.ShellType===re||o.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};Te.ExtensionCallbackType="customExecution",Te.ProcessType="process",Te.ShellType="shell",Te.EmptyType="$empty",Te=o=je([m],Te),e.Task=Te;var Je;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Je=e.ProgressLocation||(e.ProgressLocation={}));let et=class{constructor(x,re=ut.None){this.collapsibleState=re,k.URI.isUri(x)?this.resourceUri=x:this.label=x}};et=je([m],et),e.TreeItem=et;var ut;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let rt=class{constructor(x,re){this.id=x,this.color=re}};rt=je([m],rt),e.ThemeIcon=rt,rt.File=new rt("file"),rt.Folder=new rt("folder");let Ge=class{constructor(x){this.id=x}};Ge=je([m],Ge),e.ThemeColor=Ge;var ft;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let at=class{constructor(x,re){if(typeof x!="string"&&(!x||!k.URI.isUri(x)&&!k.URI.isUri(x.uri)))throw(0,I.illegalArgument)("base");if(typeof re!="string")throw(0,I.illegalArgument)("pattern");typeof x=="string"?(this.baseFolder=k.URI.file(x),this.base=x):k.URI.isUri(x)?(this.baseFolder=x,this.base=x.fsPath):(this.baseFolder=x.uri,this.base=x.uri.fsPath),this.pattern=re}};at=je([m],at),e.RelativePattern=at;let vt=class{constructor(x,re,ye,Ve){this.enabled=typeof x=="boolean"?x:!0,typeof re=="string"&&(this.condition=re),typeof ye=="string"&&(this.hitCondition=ye),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,D.generateUuid)()),this._id}};vt=je([m],vt),e.Breakpoint=vt;let pt=class extends vt{constructor(x,re,ye,Ve,Xe){super(re,ye,Ve,Xe);if(x===null)throw(0,I.illegalArgument)("location");this.location=x}};pt=je([m],pt),e.SourceBreakpoint=pt;let St=class extends vt{constructor(x,re,ye,Ve,Xe){super(re,ye,Ve,Xe);this.functionName=x}};St=je([m],St),e.FunctionBreakpoint=St;let Ct=class extends vt{constructor(x,re,ye,Ve,Xe,ot,dt){super(Ve,Xe,ot,dt);if(!re)throw(0,I.illegalArgument)("dataId");this.label=x,this.dataId=re,this.canPersist=ye}};Ct=je([m],Ct),e.DataBreakpoint=Ct;let It=class{constructor(x,re,ye){this.command=x,this.args=re||[],this.options=ye}};It=je([m],It),e.DebugAdapterExecutable=It;let bt=class{constructor(x,re){this.port=x,this.host=re}};bt=je([m],bt),e.DebugAdapterServer=bt;let At=class{constructor(x){this.path=x}};At=je([m],At),e.DebugAdapterNamedPipeServer=At;let Yt=class{constructor(x){this.implementation=x}};Yt=je([m],Yt),e.DebugAdapterInlineImplementation=Yt;let mt=class{constructor(x,re){this.range=x,this.expression=re}};mt=je([m],mt),e.EvaluatableExpression=mt;let Jt=class{constructor(x,re){this.range=x,this.text=re}};Jt=je([m],Jt),e.InlineValueText=Jt;let yt=class{constructor(x,re,ye=!0){this.range=x,this.variableName=re,this.caseSensitiveLookup=ye}};yt=je([m],yt),e.InlineValueVariableLookup=yt;let jt=class{constructor(x,re){this.range=x,this.expression=re}};jt=je([m],jt),e.InlineValueEvaluatableExpression=jt;let Zt=class{constructor(x,re){this.frameId=x,this.stoppedLocation=re}};Zt=je([m],Zt),e.InlineValueContext=Zt;var qt;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let ct=c=class extends Error{constructor(x,re=P.FileSystemProviderErrorCode.Unknown,ye){var Ve;super(k.URI.isUri(x)?x.toString(!0):x);this.code=(Ve=ye==null?void 0:ye.name)!==null&&Ve!==void 0?Ve:"Unknown",(0,P.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,c.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(x){return new c(x,P.FileSystemProviderErrorCode.FileExists,c.FileExists)}static FileNotFound(x){return new c(x,P.FileSystemProviderErrorCode.FileNotFound,c.FileNotFound)}static FileNotADirectory(x){return new c(x,P.FileSystemProviderErrorCode.FileNotADirectory,c.FileNotADirectory)}static FileIsADirectory(x){return new c(x,P.FileSystemProviderErrorCode.FileIsADirectory,c.FileIsADirectory)}static NoPermissions(x){return new c(x,P.FileSystemProviderErrorCode.NoPermissions,c.NoPermissions)}static Unavailable(x){return new c(x,P.FileSystemProviderErrorCode.Unavailable,c.Unavailable)}};ct=c=je([m],ct),e.FileSystemError=ct;let en=class{constructor(x,re,ye){this.start=x,this.end=re,this.kind=ye}};en=je([m],en),e.FoldingRange=en;var Tt;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ut;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Ut=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mn;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(mn=e.CommentMode||(e.CommentMode={}));class _n{constructor(x,re=[]){this.tokenTypes=x,this.tokenModifiers=re}}e.SemanticTokensLegend=_n;function gn(H){return typeof H=="undefined"||(0,y.isStringArray)(H)}class tn{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let re=0,ye=x.tokenTypes.length;re<ye;re++)this._tokenTypeStrToInt.set(x.tokenTypes[re],re);for(let re=0,ye=x.tokenModifiers.length;re<ye;re++)this._tokenModifierStrToInt.set(x.tokenModifiers[re],re)}}push(x,re,ye,Ve,Xe){if(typeof x=="number"&&typeof re=="number"&&typeof ye=="number"&&typeof Ve=="number"&&(typeof Xe=="number"||typeof Xe=="undefined"))return typeof Xe=="undefined"&&(Xe=0),this._pushEncoded(x,re,ye,Ve,Xe);if(w.isRange(x)&&typeof re=="string"&&gn(ye))return this._push(x,re,ye);throw(0,I.illegalArgument)()}_push(x,re,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ve=x.start.line,Xe=x.start.character,ot=x.end.character-x.start.character,dt=this._tokenTypeStrToInt.get(re);let Et=0;if(ye)for(const Dt of ye){if(!this._tokenModifierStrToInt.has(Dt))throw new Error("`tokenModifier` is not in the provided legend");const kt=this._tokenModifierStrToInt.get(Dt);Et|=1<<kt>>>0}this._pushEncoded(Ve,Xe,ot,dt,Et)}_pushEncoded(x,re,ye,Ve,Xe){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Et=this._data.length/5|0;let Dt=0,kt=0;for(let Pt=0;Pt<Et;Pt++){let Ft=this._data[5*Pt],dn=this._data[5*Pt+1];Ft===0?(Ft=Dt,dn+=kt):Ft+=Dt,this._data[5*Pt]=Ft,this._data[5*Pt+1]=dn,Dt=Ft,kt=dn}}let ot=x,dt=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=Xe,this._prevLine=x,this._prevChar=re}static _sortAndDeltaEncode(x){let re=[];const ye=x.length/5|0;for(let dt=0;dt<ye;dt++)re[dt]=dt;re.sort((dt,Et)=>{const Dt=x[5*dt],kt=x[5*Et];if(Dt===kt){const Pt=x[5*dt+1],Ft=x[5*Et+1];return Pt-Ft}return Dt-kt});const Ve=new Uint32Array(x.length);let Xe=0,ot=0;for(let dt=0;dt<ye;dt++){const Et=5*re[dt],Dt=x[Et+0],kt=x[Et+1],Pt=x[Et+2],Ft=x[Et+3],dn=x[Et+4],Ln=Dt-Xe,Un=Ln===0?kt-ot:kt,hn=5*dt;Ve[hn+0]=Ln,Ve[hn+1]=Un,Ve[hn+2]=Pt,Ve[hn+3]=Ft,Ve[hn+4]=dn,Xe=Dt,ot=kt}return Ve}build(x){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),x):new Kt(tn._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=tn;class Kt{constructor(x,re){this.resultId=re,this.data=x}}e.SemanticTokens=Kt;class Ot{constructor(x,re,ye){this.start=x,this.deleteCount=re,this.data=ye}}e.SemanticTokensEdit=Ot;class En{constructor(x,re){this.resultId=re,this.edits=x}}e.SemanticTokensEdits=En;var nn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(nn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var rn;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(rn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new rt("arrow-left")},Gt=je([m],Gt),e.QuickInputButtons=Gt;var Sn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Sn=e.ExtensionKind||(e.ExtensionKind={}));class Rt{constructor(x,re,ye){this.badge=x,this.tooltip=re,this.color=ye}static validate(x){if(x.badge&&x.badge.length!==1&&x.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Rt;let sn=class{constructor(x){this.kind=x}};sn=je([m],sn),e.ColorTheme=sn;var yn;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(yn=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{constructor(x,re){if(x<0)throw(0,I.illegalArgument)("start must be positive");if(re<0)throw(0,I.illegalArgument)("end must be positive");x<=re?(this._start=x,this._end=re):(this._start=re,this._end=x)}static isNotebookRange(x){return x instanceof xt?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let re=this._start,ye=this._end;return x.start!==void 0&&(re=x.start),x.end!==void 0&&(ye=x.end),re===this._start&&ye===this._end?this:new xt(re,ye)}}e.NotebookRange=xt;class on{constructor(x,re){typeof x=="object"?Object.assign(this,x):(this.inputCollapsed=x,this.outputCollapsed=re)}with(x){let{inputCollapsed:re,outputCollapsed:ye,custom:Ve}=x,Xe=Vt(x,["inputCollapsed","outputCollapsed","custom"]);return re===void 0?re=this.inputCollapsed:re===null&&(re=void 0),ye===void 0?ye=this.outputCollapsed:ye===null&&(ye=void 0),Ve===void 0?Ve=this.custom:Ve===null&&(Ve=void 0),re===this.inputCollapsed&&ye===this.outputCollapsed&&Ve===this.custom&&Object.keys(Xe).length===0?this:new on(Object.assign({inputCollapsed:re,outputCollapsed:ye,custom:Ve},Xe))}}e.NotebookCellMetadata=on;class Nt{constructor(x=!0,re={}){var ye,Ve;typeof x=="object"?(Object.assign(this,x),this.trusted=(ye=x.trusted)!==null&&ye!==void 0?ye:!0,this.custom=(Ve=x.custom)!==null&&Ve!==void 0?Ve:{}):(this.trusted=x,this.custom=re)}with(x){let{custom:re,trusted:ye}=x,Ve=Vt(x,["custom","trusted"]);return re===void 0?re=this.custom:re===null&&(re=void 0),ye===void 0?ye=this.trusted:ye===null&&(ye=void 0),re===this.custom&&ye===this.trusted&&Object.keys(Ve).length===0?this:new Nt(Object.assign({trusted:ye,custom:re},Ve))}}e.NotebookDocumentMetadata=Nt;class Lt{constructor(x,re,ye,Ve,Xe,ot){this.kind=x,this.source=re,this.language=ye,this.outputs=Ve!=null?Ve:[],this.metadata=Xe,this.latestExecutionSummary=ot}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(re=>Lt.isNotebookCellData(re))}static isNotebookCellData(x){return!0}}e.NotebookCellData=Lt;class pn{constructor(x,re){this.cells=x,this.metadata=re!=null?re:new Nt}}e.NotebookData=pn;class Bt{constructor(x,re,ye){this.mime=x,this.value=re,this.metadata=ye}static isNotebookCellOutputItem(x){return x instanceof Bt}}e.NotebookCellOutputItem=Bt;class Fe{constructor(x,re,ye){this.outputs=x,typeof re=="string"?(this.id=re,this.metadata=ye):(this.id=(0,D.generateUuid)(),this.metadata=re!=null?re:ye)}}e.NotebookCellOutput=Fe;var an;(function(H){H[H.Markdown=1]="Markdown",H[H.Code=2]="Code"})(an=e.NotebookCellKind||(e.NotebookCellKind={}));var ln;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(ln=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(gt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Dn;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Dn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Cn{constructor(x,re,ye,Ve,Xe,ot){this.text=x,this.alignment=re,this.command=ye,this.tooltip=Ve,this.priority=Xe,this.accessibilityInformation=ot}}e.NotebookCellStatusBarItem=Cn;let Qt=class{constructor(x,re){this.label=x,this.timestamp=re}};Qt=je([m],Qt),e.TimelineItem=Qt;var vn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(vn=e.ExtensionMode||(e.ExtensionMode={}));var kn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(kn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(Pn=e.StandardTokenType||(e.StandardTokenType={}));class In{constructor(x,re){this.ranges=x,this.wordPattern=re}}e.LinkedEditingRanges=In;var An;(function(H){H[H.Unset=0]="Unset",H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(An=e.TestResultState||(e.TestResultState={}));var cn;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(cn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var wn;(function(H){H[H.Pending=0]="Pending",H[H.Resolved=1]="Resolved"})(wn=e.TestItemStatus||(e.TestItemStatus={}));const Wt=(H,x,re,ye)=>{let Ve=re;return{enumerable:!0,configurable:!1,get(){return Ve},set(Xe){ye(Ve,Xe)||(Ve=Xe,H.bus.fire([3,x,Xe]))}}},Xt=(H,x)=>H===x,Tn=(H,x)=>H===x?!0:!H||!x?!1:H.isEqual(x);class un{constructor(x,re,ye,Ve){this.label=re,this.data=Ve;const Xe=(0,C.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:x,enumerable:!0,writable:!1},uri:{value:ye,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>Xe.parent},children:{value:new A.ReadonlyMapView(Xe.children),enumerable:!0,writable:!1},range:Wt(Xe,"range",void 0,Tn),description:Wt(Xe,"description",void 0,Xt),runnable:Wt(Xe,"runnable",!0,Xt),debuggable:Wt(Xe,"debuggable",!0,Xt),status:Wt(Xe,"status",wn.Resolved,Xt)})}invalidate(){(0,C.getPrivateApiFor)(this).bus.fire([2])}dispose(){const x=(0,C.getPrivateApiFor)(this);x.parent&&(0,C.getPrivateApiFor)(x.parent).children.delete(this.id),x.bus.fire([1])}addChild(x){if(!(x instanceof un))throw new Error("Test child must be created through vscode.test.createTestItem()");const re=(0,C.getPrivateApiFor)(this);if(re.children.has(x.id))throw new Error(`Attempted to insert a duplicate test item ID ${x.id}`);re.children.set(x.id,x),re.bus.fire([0,x])}}e.TestItemImpl=un;class te{constructor(x){this.message=x,this.severity=cn.Error}static diff(x,re,ye){const Ve=new te(x);return Ve.expectedOutput=re,Ve.actualOutput=ye,Ve}}e.TestMessage=te;var de;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(de=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ae;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Ae=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var st;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore"})(st=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(me[119],ge([0,1,52,11,10,144,108,7,15]),function(G,e,b,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function s(a,u){u?P.set(a,u):P.delete(a)}e.setWordDefinitionFor=s;function C(a){return P.get(a)}e.getWordDefinitionFor=C;class f extends A.MirrorTextModel{constructor(u,E,v,_,g,l,d,n){super(E,v,_,g);this._proxy=u,this._languageId=l,this._isDirty=d,this._notebook=n,this._isDisposed=!1}dispose(){(0,b.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,D.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===I.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(E){return E?u._getTextInRange(E):u.getText()},get eol(){return u._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(E){return u._lineAt(E)},offsetAt(E){return u._offsetAt(E)},positionAt(E){return u._positionAt(E)},validateRange(E){return u._validateRange(E)},validatePosition(E){return u._validatePosition(E)},getWordRangeAtPosition(E,v){return u._getWordRangeAtPosition(E,v)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,b.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,b.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const E=this._validateRange(u);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const v=this._eol,_=E.start.line,g=E.end.line,l=[];l.push(this._lines[_].substring(E.start.character));for(let d=_+1;d<g;d++)l.push(this._lines[d]);return l.push(this._lines[g].substring(0,E.end.character)),l.join(v)}_lineAt(u){let E;if(u instanceof k.Position?E=u.line:typeof u=="number"&&(E=u),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new h(E,this._lines[E],E===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(u),v=this._lines[E.index].length;return new k.Position(E.index,Math.min(E.remainder,v))}_validateRange(u){if(!(u instanceof k.Range))throw new Error("Invalid argument");const E=this._validatePosition(u.start),v=this._validatePosition(u.end);return E===u.start&&v===u.end?u:new k.Range(E.line,E.character,v.line,v.character)}_validatePosition(u){if(!(u instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:E,character:v}=u,_=!1;if(E<0)E=0,v=0,_=!0;else if(E>=this._lines.length)E=this._lines.length-1,v=this._lines[E].length,_=!0;else{const g=this._lines[E].length;v<0?(v=0,_=!0):v>g&&(v=g,_=!0)}return _?new k.Position(E,v):u}_getWordRangeAtPosition(u,E){const v=this._validatePosition(u);if(!E)E=C(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const _=(0,y.getWordAtText)(v.character+1,(0,y.ensureValidWordDefinition)(E),this._lines[v.line],0);if(_)return new k.Range(v.line,_.startColumn-1,v.line,_.endColumn-1)}}e.ExtHostDocumentData=f;class h{constructor(u,E,v){this._line=u,this._text=E,this._isLastLine=v}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(me[198],ge([0,1,7,3,110,6,76,24,2,30]),function(G,e,b,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class s{constructor(f,h,a,u){this._notebook=a,this._selector=u,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(v=>{const _=this._cellUris.get(v.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=v=>{v===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(f.onDidChangeNotebookCells(v=>E(v.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const f=[],h=[];for(const a of this._notebook.getCells())a.kind===b.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),f.push(a.document.getText().length+1),h.push(a.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(f)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(f){var h,a;if(!f){let g="";for(const l of this._cells)g+=l.document.getText()+`
`;return g=g.slice(0,-1),g}if(f.isEmpty)return"";const u=this.locationAt(f.start),E=this.locationAt(f.end),v=this._cells[(h=this._cellUris.get(u.uri))!==null&&h!==void 0?h:-1],_=this._cells[(a=this._cellUris.get(E.uri))!==null&&a!==void 0?a:-1];if(!v||!_)return"";if(v===_)return v.document.getText(new b.Range(u.range.start,E.range.end));{const g=v.document.getText(new b.Range(u.range.start,new b.Position(v.document.lineCount,0))),l=_.document.getText(new b.Range(new b.Position(0,0),E.range.end));return g+`
`+l}}offsetAt(f){const h=this._cellLines.getIndexOf(f.line),a=this._cellLengths.getAccumulatedValue(h.index-1),u=this._cells[h.index].document.offsetAt(f.with(h.remainder));return a+u}positionAt(f){if(typeof f=="number"){const a=this._cellLengths.getIndexOf(f),u=this._cellLines.getAccumulatedValue(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(u)}const h=this._cellUris.get(f.uri);if(h!==void 0){const a=this._cellLines.getAccumulatedValue(h-1);return new b.Position(a+f.range.start.line,f.range.start.character)}return new b.Position(0,0)}locationAt(f){b.Range.isRange(f)||(f=new b.Range(f,f));const h=this._cellLines.getIndexOf(f.start.line);let a=h;f.isEmpty||(a=this._cellLines.getIndexOf(f.end.line));const u=new b.Position(h.remainder,f.start.character),E=new b.Position(a.remainder,f.end.character),v=new b.Range(u,E),_=this._cells[h.index];return new b.Location(_.document.uri,_.document.validateRange(v))}contains(f){return this._cellUris.has(f)}validateRange(f){const h=this.validatePosition(f.start),a=this.validatePosition(f.end);return f.with(h,a)}validatePosition(f){const h=this._cellLines.getIndexOf(f.line),a=new b.Position(h.remainder,f.character),u=this._cells[h.index].document.validatePosition(a),E=this._cellLines.getAccumulatedValue(h.index-1);return new b.Position(E+u.line,u.character)}}e.ExtHostNotebookConcatDocument=s}),define(me[199],ge([0,1,7,14,3]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(k){this._actual=new b.ColorTheme(b.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let D=k==="light"?b.ColorThemeKind.Light:k==="dark"?b.ColorThemeKind.Dark:b.ColorThemeKind.HighContrast;this._actual=new b.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=je([Be(0,I.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(me[62],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,b.createDecorator)("IURITransformerService");class I{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=I}),define(me[200],ge([0,1,22]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function T(k,D){if(D){const P=new I,s=(h,a)=>{if(a instanceof ArrayBuffer){const u=P.add(a);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(a)){const u=A(a);if(u){const E=P.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:u,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},C=JSON.stringify(k,s),f=P.buffers.map(h=>{const a=new Uint8Array(h);return b.VSBuffer.wrap(a)});return{message:C,buffers:f}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=T;function A(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(k,D){const P=D.map(f=>{const h=new ArrayBuffer(f.byteLength);return new Uint8Array(h).set(f.buffer),h}),s=D.length?(f,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const a=h,{index:u}=a,E=P[u];if(a.view)switch(a.view.type){case 1:return new Int8Array(E,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return h}:void 0;return{message:JSON.parse(k,s),arrayBuffers:P}}e.deserializeWebviewMessage=y}),define(me[87],ge([0,1,2]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(A,y,k){const D=A.webviewResourceRoot.replace("{{resource}}",k.scheme+T(k)).replace("{{uuid}}",y);return b.URI.parse(D)}e.asWebviewUri=I;function T(A){return A.toString().replace(/^\S+?:/,"")}}),define(me[201],ge([0,1,3,6,87,30]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,P,s){this._proxy=D,this._editors=P,this._initData=s,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(P.onDidChangeVisibleTextEditors(()=>{const C=P.getVisibleTextEditors();for(const f of this._insets.values())C.indexOf(f.editor)<0&&f.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,P,s,C,f){let h;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===D){h=l;break}if(!h)throw new Error("not a visible editor");const a=this,u=this._handlePool++,E=new b.Emitter,v=new b.Emitter,_=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,T.asWebviewUri)(a._initData,this._uuid,l)}get cspSource(){return a._initData.webviewCspSource}set options(l){this._options=l,a._proxy.$setOptions(u,l)}get options(){return this._options}set html(l){this._html=l,a._proxy.$setHtml(u,l)}get html(){return this._html}get onDidReceiveMessage(){return E.event}postMessage(l){return a._proxy.$postMessage(u,l)}},g=new class{constructor(){this.editor=D,this.line=P,this.height=s,this.webview=_,this.onDidDispose=v.event}dispose(){a._insets.has(u)&&(a._insets.delete(u),a._proxy.$disposeEditorInset(u),v.fire(),v.dispose(),E.dispose())}};return this._proxy.$createEditorInset(u,h.id,h.value.document.uri,P+1,s,C||{},f.identifier,f.extensionLocation),this._insets.set(u,{editor:D,inset:g,onDidReceiveMessage:E}),g}$onDidDispose(D){const P=this._insets.get(D);P&&P.inset.dispose()}$onDidReceiveMessage(D,P){const s=this._insets.get(D);s&&s.onDidReceiveMessage.fire(P)}}e.ExtHostEditorInsets=y}),define(me[202],ge([0,1,3,80,169,4,6,24,40,15,53,23,43,194]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",f.Codicon.window,(0,T.localize)(0,null));var a;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel"})(u=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(o){switch(o){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function v(o){return`viewContainer.${o}.enabled`}e.getEnabledViewContainerContextKey=v;class _ extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new b.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new b.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(c,m,S){var p;const w=this.get(c.id);if(w)return w;const R=c;return R.openCommandActionDescriptor=(S==null?void 0:S.donotRegisterOpenCommand)?void 0:(p=R.openCommandActionDescriptor)!==null&&p!==void 0?p:{id:R.id},(0,k.getOrSet)(this.viewContainers,m,[]).push(R),(S==null?void 0:S.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:m}),R}deregisterViewContainer(c){for(const m of this.viewContainers.keys()){const S=this.viewContainers.get(m),p=S==null?void 0:S.indexOf(c);if(p!==-1){S==null||S.splice(p,1),S.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:m});return}}}get(c){return this.all.filter(m=>m.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(S=>(S==null?void 0:S.id)===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===c)}}D.Registry.add(a.ViewContainersRegistry,new _);var g;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(g=e.ViewContentGroups||(e.ViewContentGroups={}));function l(o,c){var m,S,p,w;const R=(m=o.group)!==null&&m!==void 0?m:g.More,F=(S=c.group)!==null&&S!==void 0?S:g.More;return R!==F?R.localeCompare(F):((p=o.order)!==null&&p!==void 0?p:5)-((w=c.order)!==null&&w!==void 0?w:5)}class d extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new b.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new b.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new b.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new b.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new s.SetMap}registerViews(c,m){this.registerViews2([{views:c,viewContainer:m}])}registerViews2(c){c.forEach(({views:m,viewContainer:S})=>this.addViews(m,S)),this._onViewsRegistered.fire(c)}deregisterViews(c,m){const S=this.removeViews(c,m);S.length&&this._onViewsDeregistered.fire({views:S,viewContainer:m})}moveViews(c,m){for(const S of this._views.keys())if(S!==m){const p=this.removeViews(c,S);p.length&&(this.addViews(p,m),this._onDidChangeContainer.fire({views:p,from:S,to:m}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const m of this._viewContainers){const S=(this._views.get(m)||[]).filter(p=>p.id===c)[0];if(S)return S}return null}getViewContainer(c){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(p=>p.id===c)[0])return m;return null}registerViewWelcomeContent(c,m){return this._viewWelcomeContents.add(c,m),this._onDidChangeViewWelcomeContent.fire(c),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,m),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,m){const S=new Map;for(const[p,w]of m)this._viewWelcomeContents.add(c,w),S.set(p,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,w),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),S}getViewWelcomeContent(c){const m=[];return this._viewWelcomeContents.forEach(c,S=>m.push(S)),m.sort(l)}addViews(c,m){let S=this._views.get(m);S||(S=[],this._views.set(m,S),this._viewContainers.push(m));for(const p of c){if(this.getView(p.id)!==null)throw new Error((0,T.localize)(1,null,p.id));S.push(p)}}removeViews(c,m){const S=this._views.get(m);if(!S)return[];const p=[],w=[];for(const R of S)c.includes(R)?p.push(R):w.push(R);return p.length&&(w.length?this._views.set(m,w):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),p}}D.Registry.add(a.ViewsRegistry,new d),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,T.localize)(2,null));function n(o){return`view.${o}.visible`}e.getVisbileViewContextKey=n,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var t;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(t=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(c,m){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,c),this._hasResolve=!!m,this.resolve=async S=>{var p,w;if(m&&!this.resolved){const R=await m(S);R&&(this.tooltip=(p=this.tooltip)!==null&&p!==void 0?p:R.tooltip,this.command=(w=this.command)!==null&&w!==void 0?w:R.command)}S.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i}),define(me[203],ge([0,1,2,181,117,13,182,202]),function(G,e,b,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(u){return(E,...v)=>u(E.get(I.ICommandService),...v)}class P{static execute(E,v){const _={forceReuseWindow:v&&v.reuseWindow,remoteAuthority:v&&v.remoteAuthority};return E.executeCommand("_files.newWindow",_)}}e.NewWindowAPICommand=P,P.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:P.ID,handler:D(P.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(u,E){return u.get(T.IWorkspacesService).removeRecentlyOpened([E])});class s{static execute(E,v){return typeof v=="string"?v=v.match(/^[^:/?#]+:\/\//)?b.URI.parse(v):b.URI.file(v):v=b.URI.revive(v),E.executeCommand("_workbench.removeFromRecentlyOpened",v)}}e.RemoveFromRecentlyOpenedAPICommand=s,s.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(s.ID,D(s.execute));class C{static execute(E,v){const _=typeof v=="string"?{extensionId:v}:v;return E.executeCommand("workbench.action.openIssueReporter",_)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(u,E){const v=u.get(T.IWorkspacesService);let _;const g=E.uri,l=E.label,d=E.remoteAuthority;return E.type==="workspace"?_={workspace:await v.getWorkspaceIdentifier(g),label:l,remoteAuthority:d}:E.type==="folder"?_={folderUri:g,label:l,remoteAuthority:d}:_={fileUri:g,label:l,remoteAuthority:d},v.addRecentlyOpened([_])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(u){return u.get(T.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(u,E){const v=u.get(A.ILogService),_=u.get(y.IEnvironmentService);_.isExtensionDevelopment&&!!_.extensionTestsLocationURI&&v.setLevel(E)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(u){return u.get(A.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(u,E){const v=u.get(k.IViewDescriptorService),_=v.getViewContainerById(E.destinationId);if(!!_){for(const g of E.viewIds){const l=v.getViewDescriptorById(g);(l==null?void 0:l.canMoveView)&&v.moveViewsToContainer([l],_,k.ViewVisibilityState.Default)}await u.get(k.IViewsService).openViewContainer(_.id,!0)}});class f{static execute(E,v){return!Array.isArray(v==null?void 0:v.viewIds)||typeof(v==null?void 0:v.destinationId)!="string"?Promise.reject("Invalid arguments"):E.executeCommand("_workbench.action.moveViews",v)}}e.MoveViewsAPICommand=f,f.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:f.ID,handler:D(f.execute),description:{description:"Move Views",args:[]}});class h{static execute(E,v){return E.executeCommand("_workbench.open",v)}}h.ID="vscode.open",I.CommandsRegistry.registerCommand(h.ID,D(h.execute));class a{static execute(E,v,_,g,l){return E.executeCommand("_workbench.diff",[v,_,g])}}a.ID="vscode.diff",I.CommandsRegistry.registerCommand(a.ID,D(a.execute))}),define(me[120],ge([0,1,3,16,170]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new b.Emitter,this._onExit=new b.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,D,P,s){const C={command:k};if(D&&Object.keys(D).length>0&&(C.arguments=D),this.internalSend("request",C),typeof s=="number"){const f=setTimeout(()=>{clearTimeout(f);const h=this.pendingRequests.get(C.seq);if(h){this.pendingRequests.delete(C.seq);const a={type:"response",seq:0,request_seq:C.seq,success:!1,command:k,message:(0,T.localize)(0,null,s,k)};h(a)}},s)}return P&&this.pendingRequests.set(C.seq,P),C.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,D){return k.type!=="event"||D.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,I.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const D=k,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}internalSend(k,D){D.type=k,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((D,P)=>k.set(P,D)),await(0,I.timeout)(500),k.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(me[204],ge([0,1,10,2,8,23,11]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function D(t,r,i){return t.replace(k,function(o,c){return r&&c.length>0&&c[0]!=="_"?o:i&&i.hasOwnProperty(c)?i[c]:o})}e.formatPII=D;function P(t){const r={};for(const i of Object.keys(t))i.startsWith("!")||(r[i]=t[i]);return r}e.filterExceptionsFromTelemetry=P;function s(t){return t.configuration.request==="attach"&&!C(t)}e.isSessionAttach=s;function C(t){let r=t.configuration.type;if(!!r)return r==="vslsShare"&&(r=t.configuration.adapterProxy.configuration.type),(0,b.equalsIgnoreCase)(r,"extensionhost")||(0,b.equalsIgnoreCase)(r,"pwa-extensionhost")?t:t.parentSession?C(t.parentSession):void 0}e.getExtensionHostDebugSession=C;function f(t){return t.type&&(t.label||t.program||t.runtime)}e.isDebuggerMainContribution=f;function h(t,r,i){let o,c=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,S=null;for(;S=m.exec(t);){let p=S.index+1,w=p+S[0].length;if(p<=r&&w>=i){o=S[0],c=p;break}}if(o){let p=/\w+/g,w=null;for(;(w=p.exec(o))&&!(w.index+1+c+w[0].length>=i););w&&(o=o.substring(0,p.lastIndex))}return o?{start:c,end:c+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(t){return!!(t&&t.match(a))}e.isUri=u;function E(t){if(typeof t.path=="string"&&!(typeof t.sourceReference=="number"&&t.sourceReference>0)){if(u(t.path))return I.URI.parse(t.path);if((0,T.isAbsolute)(t.path))return I.URI.file(t.path)}return t.path}function v(t){if(typeof t.path=="object"){const r=I.URI.revive(t.path);if(r)return r.scheme===y.Schemas.file?r.fsPath:r.toString()}return t.path}function _(t,r){const i=r?E:v,o=(0,A.deepClone)(t);return l(o,(c,m)=>{c&&m&&(m.path=i(m))}),o}e.convertToDAPaths=_;function g(t,r){const i=r?E:v,o=(0,A.deepClone)(t);return l(o,(c,m)=>{!c&&m&&(m.path=i(m))}),o}e.convertToVSCPaths=g;function l(t,r){switch(t.type){case"event":const i=t;switch(i.event){case"output":r(!1,i.body.source);break;case"loadedSource":r(!1,i.body.source);break;case"breakpoint":r(!1,i.body.breakpoint.source);break;default:break}break;case"request":const o=t;switch(o.command){case"setBreakpoints":r(!0,o.arguments.source);break;case"breakpointLocations":r(!0,o.arguments.source);break;case"source":r(!0,o.arguments.source);break;case"gotoTargets":r(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(m=>r(!1,m));break;default:break}break;case"response":const c=t;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(m=>r(!1,m.source));break;case"loadedSources":c.body.sources.forEach(m=>r(!1,m));break;case"scopes":c.body.scopes.forEach(m=>r(!1,m.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(m=>r(!1,m.source));break;case"setBreakpoints":c.body.breakpoints.forEach(m=>r(!1,m.source));break;default:break}break}}function d(t){return t.filter(r=>{var i;return!((i=r.presentation)===null||i===void 0?void 0:i.hidden)}).sort((r,i)=>r.presentation?i.presentation?r.presentation.group?i.presentation.group?r.presentation.group!==i.presentation.group?r.presentation.group.localeCompare(i.presentation.group):n(r.presentation.order,i.presentation.order):-1:i.presentation.group?1:n(r.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=d;function n(t,r){return typeof t!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:t-r}}),define(me[205],ge([0,1,26,38,171,121,8,10,23,9,183,120]),function(G,e,b,I,T,A,y,k,D,P,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class f extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,g){this.outputStream=g,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",l=>this.handleData(l))}sendMessage(_){if(this.outputStream){const g=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${f.TWO_CRLF}${g}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const g=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(l){this._onError.fire(new Error((l.message||l)+`
`+g))}continue}}else{const g=this.rawData.indexOf(f.TWO_CRLF);if(g!==-1){const d=this.rawData.toString("utf8",0,g).split(f.HEADER_LINESEPARATOR);for(const n of d){const t=n.split(f.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(g+f.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=f,f.TWO_CRLF=`\r
\r
`,f.HEADER_LINESEPARATOR=/\r?\n/,f.HEADER_FIELDSEPARATOR=/: */;class h extends f{startSession(){return new Promise((_,g)=>{let l=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),l=!0}),this.socket.on("close",()=>{l?this._onError.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.socket.on("error",d=>{l?this._onError.fire(d):g(d)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=h;class a extends h{constructor(_){super();this.adapterServer=_}createConnection(_){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=a;class u extends h{constructor(_){super();this.adapterServer=_}createConnection(_){return A.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=u;class E extends f{constructor(_,g,l){super();this.adapterExecutable=_,this.debugType=g,this.outputService=l}async startSession(){const _=this.adapterExecutable.command,g=this.adapterExecutable.args,l=this.adapterExecutable.options||{};try{if(_)if(y.isAbsolute(_)){if(!await(0,b.exists)(_))throw new Error(T.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(T.localize(1,null,this.debugType));let d=process.env;if(l.env&&Object.keys(l.env).length>0&&(d=D.mixin(D.deepClone(process.env),l.env)),_==="node")if(Array.isArray(g)&&g.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:d,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};l.cwd&&(r.cwd=l.cwd);const i=I.fork(g[0],g.slice(1),r);if(!i.pid)throw new Error(T.localize(2,null,g[0]));this.serverProcess=i}else throw new Error(T.localize(3,null));else{const t={env:d};l.cwd&&(t.cwd=l.cwd),this.serverProcess=I.spawn(_,g,t)}this.serverProcess.on("error",t=>{this._onError.fire(t)}),this.serverProcess.on("exit",(t,r)=>{this._onExit.fire(t)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",t=>{this._onError.fire(t)}),this.serverProcess.stdin.on("error",t=>{this._onError.fire(t)});const n=this.outputService;if(n){const t=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const i=n.getChannel(s.ExtensionsChannelId);i&&i.append(t(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(d){this._onError.fire(d)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((_,g)=>{const l=I.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(d,n,t){if(d)return g(d)});l.on("exit",_),l.on("error",g)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,g){if(!!_){const l=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?l.runtime=y.join(g,_.runtime):l.runtime=_.runtime),_.runtimeArgs&&(l.runtimeArgs=_.runtimeArgs),_.program&&(y.isAbsolute(_.program)?l.program=_.program:l.program=y.join(g,_.program)),_.args&&(l.args=_.args);const d=_;return d.win&&(l.win=E.extract(d.win,g)),d.winx86&&(l.winx86=E.extract(d.winx86,g)),d.windows&&(l.windows=E.extract(d.windows,g)),d.osx&&(l.osx=E.extract(d.osx,g)),d.linux&&(l.linux=E.extract(d.linux,g)),l}}static platformAdapterExecutable(_,g){let l=Object.create(null);g=g.toLowerCase();for(const o of _)if(o.contributes){const c=o.contributes.debuggers;c&&c.length>0&&c.filter(m=>typeof m.type=="string"&&k.equalsIgnoreCase(m.type,g)).forEach(m=>{const S=E.extract(m,o.extensionLocation.fsPath);l=D.mixin(l,S,o.isBuiltin)})}let d;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?d=l.winx86||l.win||l.windows:P.isWindows?d=l.win||l.windows:P.isMacintosh?d=l.osx:P.isLinux&&(d=l.linux),d=d||l;let n=d.program||l.program;const t=d.args||l.args;let r=d.runtime||l.runtime;const i=d.runtimeArgs||l.runtimeArgs;if(r)return{type:"executable",command:r,args:(i||[]).concat(typeof n=="string"?[n]:[]).concat(t||[])};if(n)return{type:"executable",command:n,args:t||[]}}}e.ExecutableDebugAdapter=E}),define(me[206],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(me[207],ge([0,1,38,8,77,172,26,9,83,4,206,11]),function(G,e,b,I,T,A,y,k,D,P,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const f=A.localize(0,null);let h=class $t{constructor(g){this._configurationService=g}openTerminal(g){if(this._configurationService){const l=this._configurationService.getValue();this.spawnTerminal(b,l,T.getWindowsShell(),g)}}runInTerminal(g,l,d,n,t){const r=t.windowsExec||$t.getDefaultTerminalWindows();return new Promise((i,o)=>{const c=`"${l} - ${f}"`,m=`""${d.join('" "')}" & pause"`,S=["/c","start",c,"/wait",r,"/c",m],p=Object.assign({},process.env,n);Object.keys(p).filter(F=>p[F]===null).forEach(F=>delete p[F]);const w={cwd:l,env:p,windowsVerbatimArguments:!0};b.spawn($t.CMD,S,w).on("error",F=>{o(E(F))}),i(void 0)})}spawnTerminal(g,l,d,n){const r=l.terminal.external.windowsExec||$t.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const i=I.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return g.spawn(r,n?[n]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return r.indexOf(" ")>=0&&o.push('""'),o.push(r),(i==="wt"||i==="wt.exe")&&o.push("-d ."),new Promise((c,m)=>{const S=n?{cwd:n}:void 0,p=g.spawn(d,o,S);p.on("error",m),p.on("exit",()=>c())})}static getDefaultTerminalWindows(){if(!$t._DEFAULT_TERMINAL_WINDOWS){const g=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");$t._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${g?"Sysnative":"System32"}\\cmd.exe`}return $t._DEFAULT_TERMINAL_WINDOWS}};h.CMD="cmd.exe",h=je([Be(0,(0,P.optional)(D.IConfigurationService))],h),e.WindowsExternalTerminalService=h;let a=class Fn{constructor(g){this._configurationService=g}openTerminal(g){if(this._configurationService){const l=this._configurationService.getValue();this.spawnTerminal(b,l,g)}}runInTerminal(g,l,d,n,t){const r=t.osxExec||s.DEFAULT_TERMINAL_OSX;return new Promise((i,o)=>{if(r===s.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const c=r===s.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",S=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,G).fsPath,"-t",g||f,"-w",l];for(let R of d)S.push("-a"),S.push(R);if(n)for(let R in n){const F=n[R];F===null?(S.push("-u"),S.push(R)):(S.push("-e"),S.push(`${R}=${F}`))}let p="";const w=b.spawn(Fn.OSASCRIPT,S);w.on("error",R=>{o(E(R))}),w.stderr.on("data",R=>{p+=R.toString()}),w.on("exit",R=>{if(R===0)i(void 0);else if(p){const F=p.split(`
`,1);o(new Error(F[0]))}else o(new Error(A.localize(1,null,c,R)))})}else o(new Error(A.localize(2,null,r)))})}spawnTerminal(g,l,d){const t=l.terminal.external.osxExec||s.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const o=["-a",t];d&&o.push(d);const c=g.spawn("/usr/bin/open",o);c.on("error",i),c.on("exit",()=>r())})}};a.OSASCRIPT="/usr/bin/osascript",a=je([Be(0,(0,P.optional)(D.IConfigurationService))],a),e.MacExternalTerminalService=a;let u=class Ht{constructor(g){this._configurationService=g}openTerminal(g){if(this._configurationService){const l=this._configurationService.getValue();this.spawnTerminal(b,l,g)}}runInTerminal(g,l,d,n,t){const r=t.linuxExec?Promise.resolve(t.linuxExec):Ht.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{let c=[];r.then(m=>{m.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const S=`${v(d)}; echo; read -p "${Ht.WAIT_MESSAGE}" -n1;`;c.push(`''${S}''`);const p=Object.assign({},process.env,n);Object.keys(p).filter(z=>p[z]===null).forEach(z=>delete p[z]);const w={cwd:l,env:p};let R="";const F=b.spawn(m,c,w);F.on("error",z=>{o(E(z))}),F.stderr.on("data",z=>{R+=z.toString()}),F.on("exit",z=>{if(z===0)i(void 0);else if(R){const oe=R.split(`
`,1);o(new Error(oe[0]))}else o(new Error(A.localize(4,null,m,z)))})})})}spawnTerminal(g,l,d){const n=l.terminal.external,t=n.linuxExec?Promise.resolve(n.linuxExec):Ht.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{t.then(o=>{const c=d?{cwd:d}:void 0,m=g.spawn(o,[],c);m.on("error",i),m.on("exit",()=>r())})})}static async getDefaultTerminalLinuxReady(){return Ht._DEFAULT_TERMINAL_LINUX_READY||(Ht._DEFAULT_TERMINAL_LINUX_READY=new Promise(async g=>{k.isLinux?await y.exists("/etc/debian_version")?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm"):g("xterm")})),Ht._DEFAULT_TERMINAL_LINUX_READY}};u.WAIT_MESSAGE=A.localize(3,null),u=je([Be(0,(0,P.optional)(D.IConfigurationService))],u),e.LinuxExternalTerminalService=u;function E(_){return"errno"in _&&_.errno==="ENOENT"&&"path"in _&&typeof _.path=="string"?new Error(A.localize(5,null,_.path)):_}function v(_){let g="";for(let l of _)l.indexOf(" ")>=0?g+='"'+l+'"':g+=l,g+=" ";return g}}),define(me[208],ge([0,1,38,9,207,29]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let y;function k(f,h){if(!y)if(I.isWindows)y=new T.WindowsExternalTerminalService(void 0);else if(I.isMacintosh)y=new T.MacExternalTerminalService(void 0);else if(I.isLinux)y=new T.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const a=h.getConfiguration("terminal");return y.runInTerminal(f.title,f.cwd,f.args,f.env||{},a.external||{})}e.runInExternalTerminal=k;function D(f,h){return new Promise((a,u)=>{let E="";const v=b.spawn(f,h);v.pid&&v.stdout.on("data",_=>{E+=_.toString()}),v.on("error",_=>{u(_)}),v.on("close",_=>{a(E)})})}function P(f){return f?I.isWindows?D("wmic",["process","get","ParentProcessId"]).then(h=>h.split(`\r
`).some(u=>parseInt(u)===f),h=>!0):D("/usr/bin/pgrep",["-lP",String(f)]).then(h=>{const a=h.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},h=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var s;(function(f){f[f.cmd=0]="cmd",f[f.powershell=1]="powershell",f[f.bash=2]="bash"})(s||(s={}));function C(f,h,a,u){f=f.trim().toLowerCase();let E;f.indexOf("powershell")>=0||f.indexOf("pwsh")>=0?E=1:f.indexOf("cmd.exe")>=0?E=0:f.indexOf("bash")>=0?E=2:I.isWindows?E=0:E=2;let v,_=" ";switch(E){case 1:if(v=l=>(l=l.replace(/\'/g,"''"),l.length>0&&l.charAt(l.length-1)==="\\"?`'${l}\\'`:`'${l}'`),a){const l=(0,A.getDriveLetter)(a);l&&(_+=`${l}:; `),_+=`cd ${v(a)}; `}if(u)for(let l in u){const d=u[l];d===null?_+=`Remove-Item env:${l}; `:_+=`\${env:${l}}='${d}'; `}if(h.length>0){const l=v(h.shift());_+=l[0]==="'"?`& ${l} `:`${l} `;for(let d of h)_+=`${v(d)} `}break;case 0:if(v=l=>(l=l.replace(/\"/g,'""'),l.indexOf(" ")>=0||l.indexOf('"')>=0||l.length===0?`"${l}"`:l),a){const l=(0,A.getDriveLetter)(a);l&&(_+=`${l}: && `),_+=`cd ${v(a)} && `}if(u){_+='cmd /C "';for(let l in u){let d=u[l];d===null?_+=`set "${l}=" && `:(d=d.replace(/[\^\&\|\<\>]/g,n=>`^${n}`),_+=`set "${l}=${d}" && `)}}for(let l of h)_+=`${v(l)} `;u&&(_+='"');break;case 2:v=l=>(l=l.replace(/(["'\\\$])/g,"\\$1"),l.indexOf(" ")>=0||l.indexOf(";")>=0||l.length===0?`"${l}"`:l);const g=l=>/[^\w@%\/+=,.:^-]/.test(l)?`'${l.replace(/'/g,"'\\''")}'`:l;if(a&&(_+=`cd ${v(a)} ; `),u){_+="/usr/bin/env";for(let l in u){const d=u[l];d===null?_+=` -u ${g(l)}`:_+=` ${g(`${l}=${d}`)}`}_+=" "}for(let l of h)_+=`${v(l)} `;break}return _}e.prepareCommand=C}),define(me[88],ge([0,1,33,11,8,9,80]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(F){F[F.Markdown=1]="Markdown",F[F.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var P;(function(F){F[F.Idle=1]="Idle",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(P=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var s;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(s=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.CellClearOutput=3]="CellClearOutput",F[F.CellsClearOutput=4]="CellsClearOutput",F[F.ChangeLanguage=5]="ChangeLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.Unknown=12]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var f;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(f=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.OutputsSplice=6]="OutputsSplice",F[F.Move=7]="Move",F[F.Unknown=8]="Unknown",F[F.CellContent=9]="CellContent",F[F.OutputItems=10]="OutputItems",F[F.PartialMetadata=11]="PartialMetadata"})(h=e.CellEditType||(e.CellEditType={}));function a(F){const z=u.parse(F);return z?z.notebook.toString():F.toString()}e.getCellUndoRedoComparisonKey=a;var u;(function(F){F.scheme=I.Schemas.vscodeNotebookCell;const z=/^ch(\d{7,})/;function oe(U,M){return U.with({scheme:F.scheme,fragment:`ch${M.toString().padStart(7,"0")}${U.scheme!==I.Schemas.file?U.scheme:""}`})}F.generate=oe;function j(U){if(U.scheme===F.scheme){const M=z.exec(U.fragment);if(!!M)return{handle:Number(M[1]),notebook:U.with({scheme:U.fragment.substr(M[0].length)||I.Schemas.file,fragment:null})}}}F.parse=j;function W(U,M){return U.with({scheme:I.Schemas.vscodeNotebookCellMetadata,fragment:`ch${M.toString().padStart(7,"0")}${U.scheme!==I.Schemas.file?U.scheme:""}`})}F.generateCellMetadataUri=W;function $(U){if(U.scheme===I.Schemas.vscodeNotebookCellMetadata){const M=z.exec(U.fragment);if(!!M)return{handle:Number(M[1]),notebook:U.with({scheme:U.fragment.substr(M[0].length)||I.Schemas.file,fragment:null})}}}F.parseCellMetadataUri=$})(u=e.CellUri||(e.CellUri={}));const E=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function v(F){var z,oe;return(oe=(z=E.get(F))===null||z===void 0?void 0:z.alwaysSecure)!==null&&oe!==void 0?oe:!1}e.mimeTypeIsAlwaysSecure=v;function _(F){var z,oe;return(oe=(z=E.get(F))===null||z===void 0?void 0:z.supportedByCore)!==null&&oe!==void 0?oe:!1}e.mimeTypeSupportedByCore=_;function g(F){var z,oe;return(oe=(z=E.get(F))===null||z===void 0?void 0:z.mergeable)!==null&&oe!==void 0?oe:!1}e.mimeTypeIsMergeable=g;function l(F,z){return A.isWindows&&(F=F.replace(/\//g,"\\"),z=z.replace(/\//g,"\\")),b.match(F,z)}function d(F,z,oe){let j=0;for(let W=0;W<z.length;W++){if(l(z[W],F))return j;j++}for(let W=0;W<oe.length;W++){if(l(oe[W],F))return j;j++}return j}function n(F,z,oe){return F.sort((j,W)=>d(j,z,oe)-d(W,z,oe))}e.sortMimeTypes=n;function t(F,z,oe,j=(W,$)=>W===$){const W=[];function $(L,N,O){if(!(N===0&&O.length===0)){const B=W[W.length-1];B&&B.start+B.deleteCount===L?(B.deleteCount+=N,B.toInsert.push(...O)):W.push({start:L,deleteCount:N,toInsert:O})}}let U=0,M=0;for(;;){if(U===F.length){$(U,0,z.slice(M));break}if(M===z.length){$(U,F.length-U,[]);break}const L=F[U],N=z[M];if(j(L,N)){U+=1,M+=1;continue}oe(N)?($(U,1,[]),U+=1):($(U,0,[N]),M+=1)}return W}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(F){F.default="default",F.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i(F){const z=F;return!!((typeof z.include=="string"||b.isRelativePattern(z.include))&&(typeof z.exclude=="string"||b.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=i;function o(F,z,oe){if(Array.isArray(F.viewType)&&F.viewType.indexOf(z)>=0||F.viewType===z)return!0;if(F.filenamePattern){let j=i(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,W=i(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(b.match(j,(0,T.basename)(oe.fsPath).toLowerCase()))return!(W&&b.match(W,(0,T.basename)(oe.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class c{constructor(z){this.textModel=z}getElements(){const z=new Int32Array(this.textModel.cells.length);for(let oe=0;oe<this.textModel.cells.length;oe++)z[oe]=this.textModel.cells[oe].getHashValue();return z}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var m;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function S(F){F.sort((oe,j)=>oe-j);const z=F.shift();return z===void 0?[]:F.reduce(function(oe,j){return j<=oe[0][1]?oe[0][1]=j+1:oe.unshift([j,j+1]),oe},[[z,z+1]]).reverse().map(oe=>({start:oe[0],end:oe[1]}))}e.cellIndexesToRanges=S;function p(F){return F.reduce((oe,j)=>{for(let W=j.start;W<j.end;W++)oe.push(W);return oe},[])}e.cellRangesToIndexes=p;function w(F){const z=F.sort((j,W)=>j.start-W.start),oe=z[0];return oe?z.reduce((j,W)=>{const $=j[j.length-1];return $.end>=W.start?$.end=Math.max($.end,W.end):j.push(W),j},[oe]):[]}e.reduceRanges=w;function R(F,z){return z.start>=F.start&&z.end<=F.end}e.cellRangeContains=R}),define(me[209],ge([0,1,174,4,80]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,b.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,b.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,b.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[210],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=b;function I(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=I}),define(me[211],ge([0,1,8,135,9]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function A(d,n){if(!!n)if(T.isWindows)for(const t in n){let r=t;for(const o in d)if(t.toLowerCase()===o.toLowerCase()){r=o;break}const i=n[t];i!==void 0&&y(d,r,i)}else Object.keys(n).forEach(t=>{const r=n[t];r!==void 0&&y(d,t,r)})}e.mergeEnvironments=A;function y(d,n,t){typeof t=="string"?d[n]=t:delete d[n]}function k(d,n,t,r){d.TERM_PROGRAM="vscode",n&&(d.TERM_PROGRAM_VERSION=n),s(d,r)&&(d.LANG=C(t)),d.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=k;function D(d,n){if(!!n)for(const t of Object.keys(n)){const r=n[t];r&&(d[t]=r)}}function P(d,n){return Object.keys(n).forEach(t=>{const r=n[t];if(typeof r=="string")try{n[t]=d(r)}catch(i){n[t]=r}}),n}function s(d,n){if(n==="on")return!0;if(n==="auto"){const t=d.LANG;return!t||t.search(/\.UTF\-8$/)===-1&&t.search(/\.utf8$/)===-1&&t.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=s;function C(d){const n=d?d.split("-"):[],t=n.length;if(t===0)return"en_US.UTF-8";if(t===1){const r={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in r&&n.push(r[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}e.getLangEnvVariable=C;function f(d,n,t,r,i,o){if(d.cwd){const m=typeof d.cwd=="object"?d.cwd.fsPath:d.cwd,S=h(m,t);return a(S||m)}let c;return!d.ignoreConfigurationCwd&&i&&(t&&(i=h(i,t,o)),i&&(b.isAbsolute(i)?c=i:r&&(c=b.join(r.fsPath,i)))),c||(c=r?r.fsPath:n||""),a(c)}e.getCwd=f;function h(d,n,t){if(n)try{return n(d)}catch(r){t==null||t.error("Could not resolve terminal cwd",r);return}return d}function a(d){return T.OS===1&&d&&d[1]===":"?d[0].toUpperCase()+d.substr(1):d}function u(d){let n=d;n.indexOf("\\")!==0&&(n=n.replace(/\\/g,"\\\\"));const t=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return n=n.replace(t,""),`'${n}'`}e.escapeNonWindowsPath=u;function E(d,n){if(!!n)return t=>n.resolve(d,t)}e.createVariableResolver=E;function v(d,n,t,r,i,o,c,m=T.platform){let S;c&&(S=g(d,"automationShell",m)),S||(S=g(d,"shell",m));let p=S||n;if(m===3&&!t&&r){const w=b.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();p&&p.toLowerCase().indexOf(w)===0&&(p=b.join(r,"System32",p.substr(w.length+1)))}if(p&&m===3&&(p=p.replace(/\//g,"\\")),i)try{p=i(p)}catch(w){o.error("Could not resolve shell",w)}return p}e.getDefaultShell=v;function _(d,n,t,r,i=T.platform){if(n&&g(d,"automationShell",i))return[];const o=i===3?"windows":i===1?"osx":"linux";let c=d(`terminal.integrated.shellArgs.${o}`);if(!c)return[];if(typeof c=="string"&&i===3)return t?t(c):c;if(t){const m=[];for(const S of c)try{m.push(t(S))}catch(p){r.error(`Could not resolve terminal.integrated.shellArgs.${o}`,p),m.push(S)}c=m}return c}e.getDefaultShellArgs=_;function g(d,n,t=T.platform){return d(`terminal.integrated.${n}.${t===3?"windows":t===1?"osx":"linux"}`)}function l(d,n,t,r,i,o){let c={};if(d.strictEnv)D(c,d.env);else{D(c,o);const m=Object.assign({},n);t&&(m&&P(t,m),d.env&&P(t,d.env)),(0,I.sanitizeProcessEnvironment)(c,"VSCODE_IPC_HOOK_CLI"),A(c,m),A(c,d.env),k(c,r,T.locale,i)}return c}e.createTerminalEnvironment=l});var fn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],b;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),b={},I("next"),I("throw"),I("return"),b[Symbol.asyncIterator]=function(){return this},b);function I(A){b[A]=G[A]&&function(y){return new Promise(function(k,D){y=G[A](y),T(k,D,y.done,y.value)})}}function T(A,y,k,D){Promise.resolve(D).then(function(P){A({value:P,done:k})},y)}};define(me[212],ge([0,1,37,8,103,191,38,26,43,9]),function(G,e,b,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let s;function C(l,d,n,t,r,i,o){return d=d||{existsFile:k.SymlinkSupport.existsFile,readFile:b.promises.readFile},P.isWindows?f(l,d,n,t==null?void 0:t.useWslProfiles,t==null?void 0:t.profiles.windows,r,i):v(d,n,l,P.isMacintosh?t==null?void 0:t.profiles.osx:t==null?void 0:t.profiles.linux,o,r,i)}e.detectAvailableProfiles=C;async function f(l,d,n,t,r,i,o){const c=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${process.env.windir}\\${c?"Sysnative":"System32"}`;let S=!1;(0,A.getWindowsBuildNumber)()>=16299&&(S=!0),await a();const p=new Map;l||(p.set("PowerShell",{source:"PowerShell",icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),p.set("Windows PowerShell",{path:`${m}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),p.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),p.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),p.set("Command Prompt",{path:`${m}\\cmd.exe`,icon:D.Codicon.terminalCmd.id,isAutoDetected:!0})),_(r,p);const w=await h(p.entries(),d,n,i,o);if(!l||l&&t)try{const R=await E(`${m}\\${S?"wsl.exe":"bash.exe"}`,t);R&&w.push(...R)}catch(R){n==null||n.info("WSL is not installed, so could not detect WSL profiles")}return w}async function h(l,d,n,t,r){const i=[];for(const[o,c]of l)if(c!==null){let m,S,p;if("source"in c){const F=s==null?void 0:s.get(c.source);if(!F)continue;m=F.paths,S=c.args||F.args,p=c.icon||F.icon}else m=Array.isArray(c.path)?c.path:[c.path],S=P.isWindows||Array.isArray(c.args)?c.args:void 0,p=c.icon;const w=m.slice();for(let F=0;F<w.length;F++)w[F]=await(t==null?void 0:t.resolveAsync(r,w[F]))||w[F];const R=await g(o,w,d,S,c.env,c.overrideName,c.isAutoDetected,n);R?(R.isAutoDetected=c.isAutoDetected,R.icon=p,i.push(R)):n==null||n.trace("profile not validated",o,m)}return i}async function a(){s||(s=new Map,s.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),s.set("PowerShell",{profileName:"PowerShell",paths:await u(),icon:"terminal-powershell"}))}async function u(){var l,d;const n=[];try{for(var t=fn((0,T.enumeratePowerShellInstallations)()),r;r=await t.next(),!r.done;){const i=r.value;n.push(i.exePath)}}catch(i){l={error:i}}finally{try{r&&!r.done&&(d=t.return)&&await d.call(t)}finally{if(l)throw l.error}}return n}async function E(l,d){const n=[];if(d){const t=await new Promise((r,i)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le"},(o,c)=>{if(o)return i("Problem occurred when getting wsl distros");r(c)})});if(t){const r=new RegExp(/[\r?\n]/),i=t.split(r).filter(o=>o.trim().length>0&&o!=="");for(let o of i)if(o!==""&&!o.startsWith("docker-desktop")){const c={profileName:`${o} (WSL)`,path:l,args:["-d",`${o}`]};o.includes("Ubuntu")?c.icon="terminal-ubuntu":o.includes("Debian")?c.icon="terminal-debian":c.icon="terminal-linux",n.push(c)}return n}}return[]}async function v(l,d,n,t,r,i,o){const c=new Map;if(!n){const m=await l.readFile("/etc/shells","utf8"),S=r||m.split(`
`).filter(w=>w.trim().indexOf("#")!==0&&w.trim().length>0),p=new Map;for(const w of S){let R=(0,I.basename)(w),F=p.get(R)||0;F++,F>1&&(R=`${R} (${F})`),p.set(R,F),c.set(R,{path:w,isAutoDetected:!0})}}return _(t,c),await h(c.entries(),l,d,i,o)}function _(l,d){if(!!l)for(const[n,t]of Object.entries(l))t===null||!("path"in t)&&!("source"in t)?d.delete(n):d.set(n,t)}async function g(l,d,n,t,r,i,o,c){if(d.length===0)return Promise.resolve(void 0);const m=d.shift();if(m==="")return g(l,d,n,t,r,i,o);const S={profileName:l,path:m,args:t,env:r,overrideName:i,isAutoDetected:o};if((0,I.basename)(m)===m){const w=process.env.PATH?process.env.PATH.split(I.delimiter):void 0;return await(0,A.findExecutable)(m,void 0,w,void 0,n.existsFile)?S:g(l,d,n,t)}return await n.existsFile((0,I.normalize)(m))?S:g(l,d,n,t,r,i,o)}}),define(me[122],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var b;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(D,P)=>{P.expand!==void 0&&(D.expand=P.expand),P.item!==void 0&&Object.assign(D.item,P.item)};e.applyTestItemUpdate=I;var T;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.DeltaRootsComplete=3]="DeltaRootsComplete",D[D.Retire=4]="Retire"})(T=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(D,P)=>`${D}:${P.toString()}`;e.getTestSubscriptionKey=A;class y{add(P){}update(P){}remove(P,s){}complete(){}}e.IncrementalChangeCollector=y;class k{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(P){const s=this.createChangeCollector();for(const C of P)switch(C[0]){case 0:{const f=C[1];if(f.parent){if(this.items.has(f.parent)){const h=this.items.get(f.parent);h.children.add(f.item.extId);const a=this.createItem(f,h);this.items.set(f.item.extId,a),s.add(a)}}else{this.roots.add(f.item.extId);const h=this.createItem(f);this.items.set(f.item.extId,h),s.add(h)}f.expand===2&&this.updateBusyControllers(1);break}case 1:{const f=C[1],h=this.items.get(f.extId);if(!h)break;(0,e.applyTestItemUpdate)(h,f),s.update(h),f.expand!==void 0&&h.expand===2&&f.expand!==2&&this.updateBusyControllers(-1);break}case 2:{const f=this.items.get(C[1]);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f.item.extId);const h=[[C[1]]];for(;h.length;)for(const a of h.pop()){const u=this.items.get(a);u&&(h.push(u.children),this.items.delete(a),s.remove(u,u!==f),u.expand===2&&this.updateBusyControllers(-1))}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}s.complete()}retireTest(P){}updateBusyControllers(P){this.busyControllerCount+=P}updatePendingRoots(P){this.pendingRootCount+=P}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=k}),define(me[213],ge([0,1,8,36,12,23,9,75,175]),function(G,e,b,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(C,f,h,a){if(this._contributedVariables=new Map,this._context=C,this._labelService=f,h)if(y.isWindows){const u=Object.create(null);this._envVariables=u,Object.keys(h).forEach(E=>{u[E.toLowerCase()]=h[E]})}else this._envVariables=h}resolveWithEnvironment(C,f,h){return this.recursiveResolve(C,f?f.uri:void 0,h)}async resolveAsync(C,f){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,f)}resolve(C,f){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,f)}resolveAnyBase(C,f,h,a){const u=A.deepClone(f);return y.isWindows&&u.windows?Object.keys(u.windows).forEach(E=>u[E]=u.windows[E]):y.isMacintosh&&u.osx?Object.keys(u.osx).forEach(E=>u[E]=u.osx[E]):y.isLinux&&u.linux&&Object.keys(u.linux).forEach(E=>u[E]=u.linux[E]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(this._envVariables,C?C.uri:void 0,u,h,a)}resolveAny(C,f,h){return this.resolveAnyBase(C,f,h)}async resolveAnyAsync(C,f,h){return this.resolveAnyBase(C,f,h)}resolveAnyMap(C,f,h){const a=new Map;return{newConfig:this.resolveAnyBase(C,f,h,a),resolvedVariables:a}}resolveWithInteractionReplace(C,f,h,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,f,h,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,f){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,f)}recursiveResolve(C,f,h,a,u){if(T.isString(h))return this.resolveString(C,f,h,a,u);if(T.isArray(h))return h.map(E=>this.recursiveResolve(C,f,E,a,u));if(T.isObject(h)){let E=Object.create(null);return Object.keys(h).forEach(v=>{const _=this.resolveString(C,f,v,a,u);E[_]=this.recursiveResolve(C,f,h[v],a,u)}),E}return h}resolveString(C,f,h,a,u){return h.replace(P.VARIABLE_REGEXP,(v,_)=>{if(_.includes(P.VARIABLE_LHS))return v;let g=this.evaluateSingleVariable(C,v,_,f,a);return u&&u.set(_,g),g})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,f,h,a,u){let E;const v=h.split(":");v.length>1&&(h=v[0],E=v[1]);const _=()=>{const d=this._context.getFilePath();if(d)return d;throw new Error((0,D.localize)(0,null,f))},g=()=>{const d=_();if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new Error((0,D.localize)(1,null,f,b.basename(d)))},l=()=>{if(E){const d=this._context.getFolderUri(E);if(d)return d;throw new Error((0,D.localize)(2,null,f,E))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,f)):new Error((0,D.localize)(4,null,f))};switch(h){case"env":if(E){if(C){const d=C[y.isWindows?E.toLowerCase():E];if(T.isString(d))return d}return""}throw new Error((0,D.localize)(5,null,f));case"config":if(E){const d=this._context.getConfigurationValue(a,E);if(T.isUndefinedOrNull(d))throw new Error((0,D.localize)(6,null,f,E));if(T.isObject(d))throw new Error((0,D.localize)(7,null,f,E));return d}throw new Error((0,D.localize)(8,null,f));case"command":return this.resolveFromMap(f,E,u,"command");case"input":return this.resolveFromMap(f,E,u,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return a||E?(0,k.normalizeDriveLetter)(this.fsPath(l())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(l()));case"lineNumber":const d=this._context.getLineNumber();if(d)return d;throw new Error((0,D.localize)(9,null,f));case"selectedText":const n=this._context.getSelectedText();if(n)return n;throw new Error((0,D.localize)(10,null,f));case"file":return _();case"fileWorkspaceFolder":return g();case"relativeFile":return a||E?b.relative(this.fsPath(l()),_()):_();case"relativeFileDirname":const t=b.dirname(_());if(a||E){const c=b.relative(this.fsPath(l()),t);return c.length===0?".":c}return t;case"fileDirname":return b.dirname(_());case"fileExtname":return b.extname(_());case"fileBasename":return b.basename(_());case"fileBasenameNoExtension":const r=b.basename(_());return r.slice(0,r.length-b.extname(r).length);case"fileDirnameBasename":return b.basename(b.dirname(_()));case"execPath":const i=this._context.getExecPath();return i||f;case"execInstallFolder":const o=this._context.getAppRoot();return o||f;case"pathSeparator":return b.sep;default:try{const c=E?`${h}:${E}`:h;return this.resolveFromMap(f,c,u,void 0)}catch(c){return f}}}}resolveFromMap(C,f,h,a){if(f&&h){const u=a===void 0?h[f]:h[a+":"+f];if(typeof u=="string")return u;throw new Error((0,D.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[214],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var I;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var T;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var y;(function(f){f[f.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var k;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(k=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(f){f[f.GROUP_ACTIVE=0]="GROUP_ACTIVE",f[f.GROUP_INDEX=1]="GROUP_INDEX",f[f.EDITOR_OPEN=2]="EDITOR_OPEN",f[f.EDITOR_CLOSE=3]="EDITOR_CLOSE",f[f.EDITOR_MOVE=4]="EDITOR_MOVE",f[f.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",f[f.EDITOR_LABEL=6]="EDITOR_LABEL",f[f.EDITOR_PIN=7]="EDITOR_PIN",f[f.EDITOR_STICKY=8]="EDITOR_STICKY",f[f.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var s;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(s=e.OpenEditorContext||(e.OpenEditorContext={}));function C(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(me[215],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(me[20],ge([0,1,15,97,286,58,23,12,2,44,79,176,113,88,215,7]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(ue){function De(Y){const{selectionStartLineNumber:Ne,selectionStartColumn:Te,positionLineNumber:Je,positionColumn:et}=Y,ut=new u.Position(Ne-1,Te-1),rt=new u.Position(Je-1,et-1);return new u.Selection(ut,rt)}ue.to=De;function le(Y){const{anchor:Ne,active:Te}=Y;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}ue.from=le})(E=e.Selection||(e.Selection={}));var v;(function(ue){function De(Y){if(!!Y){const{start:Ne,end:Te}=Y;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}ue.from=De;function le(Y){if(!!Y){const{startLineNumber:Ne,startColumn:Te,endLineNumber:Je,endColumn:et}=Y;return new u.Range(Ne-1,Te-1,Je-1,et-1)}}ue.to=le})(v=e.Range||(e.Range={}));var _;(function(ue){function De(le){switch(le){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 4:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}ue.to=De})(_=e.TokenType||(e.TokenType={}));var g;(function(ue){function De(Y){return new u.Position(Y.lineNumber-1,Y.column-1)}ue.to=De;function le(Y){return{lineNumber:Y.line+1,column:Y.character+1}}ue.from=le})(g=e.Position||(e.Position={}));var l;(function(ue){function De(Y){switch(Y){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}ue.from=De;function le(Y){switch(Y){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}ue.to=le})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var d;(function(ue){function De(Y){let Ne;return Y.code&&((0,k.isString)(Y.code)||(0,k.isNumber)(Y.code)?Ne=String(Y.code):Ne={value:String(Y.code.value),target:Y.code.target}),Object.assign(Object.assign({},v.from(Y.range)),{message:Y.message,source:Y.source,code:Ne,severity:t.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(n.from),tags:Array.isArray(Y.tags)?(0,b.coalesce)(Y.tags.map(l.from)):void 0})}ue.from=De;function le(Y){var Ne;const Te=new u.Diagnostic(v.to(Y),Y.message,t.to(Y.severity));return Te.source=Y.source,Te.code=(0,k.isString)(Y.code)?Y.code:(Ne=Y.code)===null||Ne===void 0?void 0:Ne.value,Te.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(n.to),Te.tags=Y.tags&&(0,b.coalesce)(Y.tags.map(l.to)),Te}ue.to=le})(d=e.Diagnostic||(e.Diagnostic={}));var n;(function(ue){function De(Y){return Object.assign(Object.assign({},v.from(Y.location.range)),{message:Y.message,resource:Y.location.uri})}ue.from=De;function le(Y){return new u.DiagnosticRelatedInformation(new u.Location(Y.resource,v.to(Y)),Y.message)}ue.to=le})(n=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var t;(function(ue){function De(Y){switch(Y){case u.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}ue.from=De;function le(Y){switch(Y){case f.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}ue.to=le})(t=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var r;(function(ue){function De(Y){return typeof Y=="number"&&Y>=u.ViewColumn.One?Y-1:Y===u.ViewColumn.Beside?a.SIDE_GROUP:a.ACTIVE_GROUP}ue.from=De;function le(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=le})(r=e.ViewColumn||(e.ViewColumn={}));function i(ue){return typeof ue.range!="undefined"}function o(ue){return ue.length===0?!0:!!i(ue[0])}e.isDecorationOptionsArr=o;var c;(function(ue){function De(et){return et.map(ue.from)}ue.fromMany=De;function le(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function Y(et){let ut;if(le(et)){const{language:at,value:vt}=et;ut={value:"```"+at+`
`+vt+"\n```\n"}}else u.MarkdownString.isMarkdownString(et)?ut={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ut={value:et}:ut={value:""};const rt=Object.create(null);ut.uris=rt;const Ge=at=>{try{let vt=D.URI.parse(at,!0);vt=vt.with({query:Ne(vt.query,rt)}),rt[at]=vt}catch(vt){}return""},ft=new T.Renderer;return ft.link=Ge,ft.image=at=>Ge(I.parseHrefAndDimensions(at).href),T(ut.value,{renderer:ft}),ut}ue.from=Y;function Ne(et,ut){if(!et)return et;let rt;try{rt=(0,A.parse)(et)}catch(ft){}if(!rt)return et;let Ge=!1;return rt=(0,y.cloneAndChange)(rt,ft=>{if(D.URI.isUri(ft)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[at]=ft,Ge=!0,at}else return}),Ge?JSON.stringify(rt):et}function Te(et){const ut=new u.MarkdownString(et.value,et.supportThemeIcons);return ut.isTrusted=et.isTrusted,ut}ue.to=Te;function Je(et){if(!!et)return typeof et=="string"?et:ue.from(et)}ue.fromStrict=Je})(c=e.MarkdownString||(e.MarkdownString={}));function m(ue){return o(ue)?ue.map(De=>({range:v.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?c.fromMany(De.hoverMessage):De.hoverMessage?c.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ue.map(De=>({range:v.from(De)}))}e.fromRangeOrRangeWithMessage=m;function S(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?D.URI.file(ue):ue}e.pathOrURIToURI=S;var p;(function(ue){function De(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?S(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ue.from=De})(p=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var w;(function(ue){function De(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?S(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?p.from(le.before):void 0,after:le.after?p.from(le.after):void 0}}ue.from=De})(w=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(ue){function De(le){if(typeof le=="undefined")return le;switch(le){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=De})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(ue){function De(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?R.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?w.from(le.light):void 0,dark:le.dark?w.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?S(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?p.from(le.before):void 0,after:le.after?p.from(le.after):void 0}}ue.from=De})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(ue){function De(Y){return{text:Y.newText,eol:Y.newEol&&ie.from(Y.newEol),range:v.from(Y.range)}}ue.from=De;function le(Y){const Ne=new u.TextEdit(v.to(Y.range),Y.text);return Ne.newEol=typeof Y.eol=="undefined"?void 0:ie.to(Y.eol),Ne}ue.to=le})(z=e.TextEdit||(e.TextEdit={}));var oe;(function(ue){function De(Y,Ne,Te){var Je,et,ut;const rt={edits:[]};if(Y instanceof u.WorkspaceEdit)for(let Ge of Y._allEntries())if(Ge._type===1)rt.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const ft=Ne==null?void 0:Ne.getDocument(Ge.uri);rt.edits.push({_type:2,resource:Ge.uri,edit:z.from(Ge.edit),modelVersionId:ft==null?void 0:ft.version,metadata:Ge.metadata})}else Ge._type===3?rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:(Je=Te==null?void 0:Te.lookupNotebookDocument(Ge.uri))===null||Je===void 0?void 0:Je.notebookDocument.version}):Ge._type===4?(Ge.newOutputs&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:2,index:Ge.index,append:Ge.append,outputs:Ge.newOutputs.map(qe.from)}}),Ge.newMetadata&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:11,index:Ge.index,metadata:Ge.newMetadata}})):Ge._type===5?rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:(et=Te==null?void 0:Te.lookupNotebookDocument(Ge.uri))===null||et===void 0?void 0:et.notebookDocument.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(pe.from)}}):Ge._type===6&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:10,outputId:Ge.outputId,items:((ut=Ge.newOutputItems)===null||ut===void 0?void 0:ut.map(Se.from))||[],append:Ge.append}});return rt}ue.from=De;function le(Y){const Ne=new u.WorkspaceEdit;for(const Te of Y.edits)Te.edit?Ne.replace(D.URI.revive(Te.resource),v.to(Te.edit.range),Te.edit.text):Ne.renameFile(D.URI.revive(Te.oldUri),D.URI.revive(Te.newUri),Te.options);return Ne}ue.to=le})(oe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(ue){const De=Object.create(null);De[u.SymbolKind.File]=0,De[u.SymbolKind.Module]=1,De[u.SymbolKind.Namespace]=2,De[u.SymbolKind.Package]=3,De[u.SymbolKind.Class]=4,De[u.SymbolKind.Method]=5,De[u.SymbolKind.Property]=6,De[u.SymbolKind.Field]=7,De[u.SymbolKind.Constructor]=8,De[u.SymbolKind.Enum]=9,De[u.SymbolKind.Interface]=10,De[u.SymbolKind.Function]=11,De[u.SymbolKind.Variable]=12,De[u.SymbolKind.Constant]=13,De[u.SymbolKind.String]=14,De[u.SymbolKind.Number]=15,De[u.SymbolKind.Boolean]=16,De[u.SymbolKind.Array]=17,De[u.SymbolKind.Object]=18,De[u.SymbolKind.Key]=19,De[u.SymbolKind.Null]=20,De[u.SymbolKind.EnumMember]=21,De[u.SymbolKind.Struct]=22,De[u.SymbolKind.Event]=23,De[u.SymbolKind.Operator]=24,De[u.SymbolKind.TypeParameter]=25;function le(Ne){return typeof De[Ne]=="number"?De[Ne]:6}ue.from=le;function Y(Ne){for(const Te in De)if(De[Te]===Ne)return Number(Te);return u.SymbolKind.Property}ue.to=Y})(j=e.SymbolKind||(e.SymbolKind={}));var W;(function(ue){function De(Y){switch(Y){case u.SymbolTag.Deprecated:return 1}}ue.from=De;function le(Y){switch(Y){case 1:return u.SymbolTag.Deprecated}}ue.to=le})(W=e.SymbolTag||(e.SymbolTag={}));var $;(function(ue){function De(Y){return{name:Y.name,kind:j.from(Y.kind),tags:Y.tags&&Y.tags.map(W.from),containerName:Y.containerName,location:O.from(Y.location)}}ue.from=De;function le(Y){const Ne=new u.SymbolInformation(Y.name,j.to(Y.kind),Y.containerName,O.to(Y.location));return Ne.tags=Y.tags&&Y.tags.map(W.to),Ne}ue.to=le})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(ue){function De(Y){var Ne,Te;const Je={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:v.from(Y.range),selectionRange:v.from(Y.selectionRange),kind:j.from(Y.kind),tags:(Te=(Ne=Y.tags)===null||Ne===void 0?void 0:Ne.map(W.from))!==null&&Te!==void 0?Te:[]};return Y.children&&(Je.children=Y.children.map(De)),Je}ue.from=De;function le(Y){const Ne=new u.DocumentSymbol(Y.name,Y.detail,j.to(Y.kind),v.to(Y.range),v.to(Y.selectionRange));return(0,b.isNonEmptyArray)(Y.tags)&&(Ne.tags=Y.tags.map(W.to)),Y.children&&(Ne.children=Y.children.map(le)),Ne}ue.to=le})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(ue){function De(le){const Y=new u.CallHierarchyItem(j.to(le.kind),le.name,le.detail||"",D.URI.revive(le.uri),v.to(le.range),v.to(le.selectionRange));return Y._sessionId=le._sessionId,Y._itemId=le._itemId,Y}ue.to=De})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var L;(function(ue){function De(le){return new u.CallHierarchyIncomingCall(M.to(le.from),le.fromRanges.map(Y=>v.to(Y)))}ue.to=De})(L=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var N;(function(ue){function De(le){return new u.CallHierarchyOutgoingCall(M.to(le.to),le.fromRanges.map(Y=>v.to(Y)))}ue.to=De})(N=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(ue){function De(Y){return{range:Y.range&&v.from(Y.range),uri:Y.uri}}ue.from=De;function le(Y){return new u.Location(D.URI.revive(Y.uri),v.to(Y.range))}ue.to=le})(O=e.location||(e.location={}));var B;(function(ue){function De(Y){const Ne=Y,Te=Y;return{originSelectionRange:Ne.originSelectionRange?v.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Te.uri,range:v.from(Ne.targetRange?Ne.targetRange:Te.range),targetSelectionRange:Ne.targetSelectionRange?v.from(Ne.targetSelectionRange):void 0}}ue.from=De;function le(Y){return{targetUri:D.URI.revive(Y.uri),targetRange:v.to(Y.range),targetSelectionRange:Y.targetSelectionRange?v.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?v.to(Y.originSelectionRange):void 0}}ue.to=le})(B=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(ue){function De(Y){return{range:v.from(Y.range),contents:c.fromMany(Y.contents)}}ue.from=De;function le(Y){return new u.Hover(Y.contents.map(c.to),v.to(Y.range))}ue.to=le})(q=e.Hover||(e.Hover={}));var Q;(function(ue){function De(Y){return{range:v.from(Y.range),expression:Y.expression}}ue.from=De;function le(Y){return new u.EvaluatableExpression(v.to(Y.range),Y.expression)}ue.to=le})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var he;(function(ue){function De(Y){if(Y instanceof u.InlineValueText)return{type:"text",range:v.from(Y.range),text:Y.text};if(Y instanceof u.InlineValueVariableLookup)return{type:"variable",range:v.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:v.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=De;function le(Y){switch(Y.type){case"text":return{range:v.to(Y.range),text:Y.text};case"variable":return{range:v.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:v.to(Y.range),expression:Y.expression}}}ue.to=le})(he=e.InlineValue||(e.InlineValue={}));var ve;(function(ue){function De(Y){return{frameId:Y.frameId,stoppedLocation:v.from(Y.stoppedLocation)}}ue.from=De;function le(Y){return new u.InlineValueContext(Y.frameId,v.to(Y.stoppedLocation))}ue.to=le})(ve=e.InlineValueContext||(e.InlineValueContext={}));var Ie;(function(ue){function De(Y){return{range:v.from(Y.range),kind:Y.kind}}ue.from=De;function le(Y){return new u.DocumentHighlight(v.to(Y.range),Y.kind)}ue.to=le})(Ie=e.DocumentHighlight||(e.DocumentHighlight={}));var ke;(function(ue){function De(le){switch(le){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}ue.to=De})(ke=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(ue){function De(le){return{triggerKind:ke.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ue.to=De})(Le=e.CompletionContext||(e.CompletionContext={}));var V;(function(ue){function De(Y){switch(Y){case u.CompletionItemTag.Deprecated:return 1}}ue.from=De;function le(Y){switch(Y){case 1:return u.CompletionItemTag.Deprecated}}ue.to=le})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var J;(function(ue){const De=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function le(Te){var Je;return(Je=De.get(Te))!==null&&Je!==void 0?Je:9}ue.from=le;const Y=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Ne(Te){var Je;return(Je=Y.get(Te))!==null&&Je!==void 0?Je:u.CompletionItemKind.Property}ue.to=Ne})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ue){function De(le,Y){var Ne;const Te=new u.CompletionItem(typeof le.label=="string"?le.label:le.label.name);return typeof le.label!="string"&&(Te.label2=le.label),Te.insertText=le.insertText,Te.kind=J.to(le.kind),Te.tags=(Ne=le.tags)===null||Ne===void 0?void 0:Ne.map(V.to),Te.detail=le.detail,Te.documentation=I.isMarkdownString(le.documentation)?c.to(le.documentation):le.documentation,Te.sortText=le.sortText,Te.filterText=le.filterText,Te.preselect=le.preselect,Te.commitCharacters=le.commitCharacters,P.Range.isIRange(le.range)?Te.range=v.to(le.range):typeof le.range=="object"&&(Te.range={inserting:v.to(le.range.insert),replacing:v.to(le.range.replace)}),Te.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?Te.insertText=new u.SnippetString(le.insertText):(Te.insertText=le.insertText,Te.textEdit=Te.range instanceof u.Range?new u.TextEdit(Te.range,Te.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Te.additionalTextEdits=le.additionalTextEdits.map(Je=>z.to(Je))),Te.command=Y&&le.command?Y.fromInternal(le.command):void 0,Te}ue.to=De})(ee=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ue){function De(Y){return{label:Y.label,documentation:Y.documentation?c.fromStrict(Y.documentation):void 0}}ue.from=De;function le(Y){return{label:Y.label,documentation:I.isMarkdownString(Y.documentation)?c.to(Y.documentation):Y.documentation}}ue.to=le})(ae=e.ParameterInformation||(e.ParameterInformation={}));var we;(function(ue){function De(Y){return{label:Y.label,documentation:Y.documentation?c.fromStrict(Y.documentation):void 0,parameters:Array.isArray(Y.parameters)?Y.parameters.map(ae.from):[],activeParameter:Y.activeParameter}}ue.from=De;function le(Y){return{label:Y.label,documentation:I.isMarkdownString(Y.documentation)?c.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(ae.to):[],activeParameter:Y.activeParameter}}ue.to=le})(we=e.SignatureInformation||(e.SignatureInformation={}));var Ce;(function(ue){function De(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(we.from):[]}}ue.from=De;function le(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(we.to):[]}}ue.to=le})(Ce=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(ue){function De(Y){var Ne;return{text:Y.text,range:v.from(Y.range),kind:be.from((Ne=Y.kind)!==null&&Ne!==void 0?Ne:u.InlineHintKind.Other),description:Y.description&&c.fromStrict(Y.description),whitespaceBefore:Y.whitespaceBefore,whitespaceAfter:Y.whitespaceAfter}}ue.from=De;function le(Y){const Ne=new u.InlineHint(Y.text,v.to(Y.range),be.to(Y.kind));return Ne.whitespaceAfter=Y.whitespaceAfter,Ne.whitespaceBefore=Y.whitespaceBefore,Ne.description=I.isMarkdownString(Y.description)?c.to(Y.description):Y.description,Ne}ue.to=le})(Oe=e.InlineHint||(e.InlineHint={}));var be;(function(ue){function De(Y){return Y}ue.from=De;function le(Y){return Y}ue.to=le})(be=e.InlineHintKind||(e.InlineHintKind={}));var Pe;(function(ue){function De(Y){return{range:v.from(Y.range),url:Y.target,tooltip:Y.tooltip}}ue.from=De;function le(Y){let Ne;if(Y.url)try{Ne=typeof Y.url=="string"?D.URI.parse(Y.url,!0):D.URI.revive(Y.url)}catch(Te){}return new u.DocumentLink(v.to(Y.range),Ne)}ue.to=le})(Pe=e.DocumentLink||(e.DocumentLink={}));var Re;(function(ue){function De(Y){const Ne=new u.ColorPresentation(Y.label);return Y.textEdit&&(Ne.textEdit=z.to(Y.textEdit)),Y.additionalTextEdits&&(Ne.additionalTextEdits=Y.additionalTextEdits.map(Te=>z.to(Te))),Ne}ue.to=De;function le(Y){return{label:Y.label,textEdit:Y.textEdit?z.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Ne=>z.from(Ne)):void 0}}ue.from=le})(Re=e.ColorPresentation||(e.ColorPresentation={}));var We;(function(ue){function De(Y){return new u.Color(Y[0],Y[1],Y[2],Y[3])}ue.to=De;function le(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}ue.from=le})(We=e.Color||(e.Color={}));var Ee;(function(ue){function De(Y){return{range:v.from(Y.range)}}ue.from=De;function le(Y){return new u.SelectionRange(v.to(Y.range))}ue.to=le})(Ee=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(ue){function De(le){switch(le){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}ue.to=De})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(ue){function De(Y){switch(Y){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=De;function le(Y){switch(Y){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}ue.to=le})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ie;(function(ue){function De(Y){if(Y===u.EndOfLine.CRLF)return 1;if(Y===u.EndOfLine.LF)return 0}ue.from=De;function le(Y){if(Y===1)return u.EndOfLine.CRLF;if(Y===0)return u.EndOfLine.LF}ue.to=le})(ie=e.EndOfLine||(e.EndOfLine={}));var _e;(function(ue){function De(le){if(typeof le=="object")return le.viewId;switch(le){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=De})(_e=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(ue){function De(le){const Y={start:le.start+1,end:le.end+1};return le.kind&&(Y.kind=ze.from(le.kind)),Y}ue.from=De})(xe=e.FoldingRange||(e.FoldingRange={}));var ze;(function(ue){function De(le){if(le)switch(le){case u.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}ue.from=De})(ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(ue){function De(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?v.from(le.selection):void 0,override:typeof le.override=="boolean"?C.EditorOverride.DISABLED:void 0}}ue.from=De})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(ue){function De(Y){return Y instanceof u.RelativePattern||typeof Y=="string"?Y:le(Y)?new u.RelativePattern(Y.base,Y.pattern):Y}ue.from=De;function le(Y){const Ne=Y;return Ne&&typeof Ne.base=="string"&&typeof Ne.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var K;(function(ue){function De(le){if(le){if(Array.isArray(le))return le.map(De);if(typeof le=="string")return le;{const Y=le;return{language:Y.language,scheme:Y.scheme,pattern:typeof Y.pattern=="undefined"?void 0:Ye.from(Y.pattern),exclusive:Y.exclusive}}}else return}ue.from=De})(K=e.LanguageSelector||(e.LanguageSelector={}));var se;(function(ue){function De(Y){return{start:Y.start,end:Y.end}}ue.from=De;function le(Y){return new u.NotebookRange(Y.start,Y.end)}ue.to=le})(se=e.NotebookRange||(e.NotebookRange={}));var fe;(function(ue){function De(le){return new u.NotebookCellMetadata().with(Object.assign(Object.assign({},le),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}ue.to=De})(fe=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var Z;(function(ue){function De(Y){return Y}ue.from=De;function le(Y){return new u.NotebookDocumentMetadata().with(Y)}ue.to=le})(Z=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ne;(function(ue){function De(Y){return{startTime:Y.runStartTime,endTime:Y.runEndTime,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}ue.to=De;function le(Y){return{lastRunSuccess:Y.success,runStartTime:Y.startTime,runEndTime:Y.endTime,executionOrder:Y.executionOrder}}ue.from=le})(ne=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ce;(function(ue){function De(Y){switch(Y){case u.NotebookCellKind.Markdown:return h.CellKind.Markdown;case u.NotebookCellKind.Code:default:return h.CellKind.Code}}ue.from=De;function le(Y){switch(Y){case h.CellKind.Markdown:return u.NotebookCellKind.Markdown;case h.CellKind.Code:default:return u.NotebookCellKind.Code}}ue.to=le})(ce=e.NotebookCellKind||(e.NotebookCellKind={}));var pe;(function(ue){function De(Y){var Ne;return{cellKind:ce.from(Y.kind),language:Y.language,source:Y.source,metadata:Object.assign(Object.assign({},Y.metadata),ne.from((Ne=Y.latestExecutionSummary)!==null&&Ne!==void 0?Ne:{})),outputs:Y.outputs?Y.outputs.map(qe.from):[]}}ue.from=De;function le(Y){return new u.NotebookCellData(ce.to(Y.cellKind),Y.source,Y.language,Y.outputs?Y.outputs.map(qe.to):void 0,Y.metadata?fe.to(Y.metadata):void 0)}ue.to=le})(pe=e.NotebookCellData||(e.NotebookCellData={}));var Se;(function(ue){function De(Y){return{mime:Y.mime,value:Y.value,metadata:Y.metadata}}ue.from=De;function le(Y){return new u.NotebookCellOutputItem(Y.mime,Y.value,Y.metadata)}ue.to=le})(Se=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var qe;(function(ue){function De(Y){return{outputId:Y.id,outputs:Y.outputs.map(Se.from),metadata:Y.metadata}}ue.from=De;function le(Y){const Ne=Y.outputs.map(Se.to);return new u.NotebookCellOutput(Ne,Y.outputId,Y.metadata)}ue.to=le})(qe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Me;(function(ue){function De(Te){if(Te!=null){if(Te instanceof u.RelativePattern||typeof Te=="string")return Te;if(Ne(Te))return new u.RelativePattern(Te.base,Te.pattern);if(Y(Te))return{include:Ye.from(Te.include)||void 0,exclude:Ye.from(Te.exclude)||void 0}}}ue.from=De;function le(Te){return typeof Te=="string"?Te:Ne(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}ue.to=le;function Y(Te){const Je=Te,et=Ye.from(Je.include);if(!(et&&et instanceof u.RelativePattern||typeof et=="string"))return!1;const ut=Ye.from(Je.exclude);return!!(ut&&ut instanceof u.RelativePattern||typeof ut=="string")}function Ne(Te){const Je=Te;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Me=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var He;(function(ue){function De(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?p.from(le.top):void 0}}ue.from=De})(He=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Qe;(function(ue){function De(le,Y,Ne){const Te=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Te,Ne),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ue.from=De})(Qe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var it;(function(ue){function De(le){var Y,Ne,Te;return{transientOutputs:(Y=le==null?void 0:le.transientOutputs)!==null&&Y!==void 0?Y:!1,transientCellMetadata:Object.assign(Object.assign({},(Ne=le==null?void 0:le.transientCellMetadata)!==null&&Ne!==void 0?Ne:le==null?void 0:le.transientMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Te=le==null?void 0:le.transientDocumentMetadata)!==null&&Te!==void 0?Te:{}}}ue.from=De})(it=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var lt;(function(ue){function De(Y){var Ne;return{uri:Y.uri,provides:typeof Y.provides=="string"?[Y.provides]:(Ne=Y.provides)!==null&&Ne!==void 0?Ne:[]}}ue.from=De;function le(Y){return{uri:D.URI.revive(Y.uri),provides:Y.provides}}ue.to=le})(lt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var Ze;(function(ue){function De(Y){return{message:c.fromStrict(Y.message)||"",severity:Y.severity,expectedOutput:Y.expectedOutput,actualOutput:Y.actualOutput,location:Y.location?O.from(Y.location):void 0}}ue.from=De;function le(Y){const Ne=new u.TestMessage(typeof Y.message=="string"?Y.message:c.to(Y.message));return Ne.severity=Y.severity,Ne.actualOutput=Y.actualOutput,Ne.expectedOutput=Y.expectedOutput,Ne}ue.to=le})(Ze=e.TestMessage||(e.TestMessage={}));var nt;(function(ue){function De(Te){var Je,et;return{extId:Te.id,label:Te.label,uri:Te.uri,range:v.from(Te.range),debuggable:(Je=Te.debuggable)!==null&&Je!==void 0?Je:!1,description:Te.description,runnable:(et=Te.runnable)!==null&&et!==void 0?et:!0}}ue.from=De;function le(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:v.from(Te.range),debuggable:!1,description:Te.description,runnable:!0}}ue.fromResultSnapshot=le;function Y(Te){return{id:Te.extId,label:Te.label,uri:D.URI.revive(Te.uri),range:v.to(Te.range),addChild:()=>{},dispose:()=>{},status:u.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description,runnable:Te.runnable}}ue.toPlain=Y;function Ne(Te){const Je=new u.TestItemImpl(Te.extId,Te.label,D.URI.revive(Te.uri),void 0);return Je.range=v.to(Te.range),Je.debuggable=Te.debuggable,Je.description=Te.description,Je.runnable=Te.runnable,Je}ue.to=Ne})(nt=e.TestItem||(e.TestItem={}));var ht;(function(ue){const De=(Y,Ne)=>Object.assign(Object.assign({},nt.toPlain(Y.item)),{taskStates:Y.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(Ze.to)})),children:Y.children.map(Te=>Ne.get(Te)).filter(k.isDefined).map(Te=>De(Te,Ne))});function le(Y){const Ne=[],Te=new Map;for(const Je of Y.items)Te.set(Je.item.extId,Je),Je.direct&&Ne.push(Je);return{completedAt:Y.completedAt,results:Ne.map(Je=>De(Je,Te))}}ue.to=le})(ht=e.TestResults||(e.TestResults={}));var _t;(function(ue){function De(le){switch(le){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}ue.to=De})(_t=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(me[216],ge([0,1,2,19,7,20,56]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(P,s,C,f={timeout:1500,errors:3}){this._logService=P,this._documents=s,this._mainThreadBulkEdits=C,this._thresholds=f,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(s,C,f)=>{const a={dispose:this._callbacks.push([s,C,P])};return Array.isArray(f)&&f.push(a),a}}async $participateInSave(P,s){const C=b.URI.revive(P);let f=!1;const h=setTimeout(()=>f=!0,this._thresholds.timeout),a=[];try{for(let u of[...this._callbacks]){if(f)break;const E=this._documents.getDocument(C),v=await this._deliverEventAsyncAndBlameBadListeners(u,{document:E,reason:A.TextDocumentSaveReason.to(s)});a.push(v)}}finally{clearTimeout(h)}return a}_deliverEventAsyncAndBlameBadListeners([P,s,C],f){const h=this._badListeners.get(P);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,P,s,f).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const u=this._badListeners.get(P);this._badListeners.set(P,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,s,C,f){const h=[],a=Date.now(),{document:u,reason:E}=f,{version:v}=u,_=Object.freeze({document:u,reason:E,waitUntil(g){if(Object.isFrozen(h))throw(0,I.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(g))}});try{s.apply(C,[_])}catch(g){return Promise.reject(g)}return Object.freeze(h),new Promise((g,l)=>{const d=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(d),g(n)}).catch(n=>{clearTimeout(d),l(n)})}).then(g=>{const l={edits:[]};for(const d of g)if(Array.isArray(d)&&d.every(n=>n instanceof T.TextEdit))for(const{newText:n,newEol:t,range:r}of d)l.edits.push({_type:2,resource:u.uri,edit:{range:r&&A.Range.from(r),text:n,eol:t&&A.EndOfLine.from(t)}});if(l.edits.length!==0)return v===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(me[217],ge([0,1,3,16,33,2,20,7]),function(G,e,b,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(C,f,h,a,u){this._onDidCreate=new b.Emitter,this._onDidChange=new b.Emitter,this._onDidDelete=new b.Emitter,this._config=0,h&&(this._config+=1),a&&(this._config+=2),u&&(this._config+=4);const E=(0,T.parse)(f),v=C(_=>{if(!h)for(let g of _.created){const l=A.URI.revive(g);E(l.fsPath)&&this._onDidCreate.fire(l)}if(!a)for(let g of _.changed){const l=A.URI.revive(g);E(l.fsPath)&&this._onDidChange.fire(l)}if(!u)for(let g of _.deleted){const l=A.URI.revive(g);E(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(C,f,h){this._logService=f,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new b.Emitter,this._onDidRenameFile=new b.Emitter,this._onDidCreateFile=new b.Emitter,this._onDidDeleteFile=new b.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,f,h,a){return new D(this._onFileSystemEvent.event,C,f,h,a)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,f){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:f.map(h=>({oldUri:A.URI.revive(h.source),newUri:A.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:f.map(h=>A.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:f.map(h=>A.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,f){return(h,a,u)=>{const E=function(_){h.call(a,_)};return E.extension=C,f.event(E,void 0,u)}}async $onWillRunFileOperation(C,f,h,a){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:f.map(u=>({oldUri:A.URI.revive(u.source),newUri:A.URI.revive(u.target)}))},h,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:f.map(u=>A.URI.revive(u.target))},h,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:f.map(u=>A.URI.revive(u.target))},h,a)}}async _fireWillEvent(C,f,h,a){const u=new Set,E=[];if(await C.fireAsync(f,a,async(_,g)=>{var l;const d=Date.now(),n=await Promise.resolve(_);n instanceof k.WorkspaceEdit&&(E.push(n),u.add((l=g.extension.displayName)!==null&&l!==void 0?l:g.extension.identifier.value)),Date.now()-d>h&&this._logService.warn("SLOW file-participant",g.extension.identifier)}),!a.isCancellationRequested&&E.length!==0){const v={edits:[]};for(let _ of E){let{edits:g}=y.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(g)}return{edit:v,extensionNames:Array.from(u)}}}}e.ExtHostFileSystemEventService=P}),define(me[218],ge([0,1,11,23,2,20,7,88]),function(G,e,b,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(f,h,a,u){this.start=f,this.deletedCount=h,this.deletedItems=a,this.items=u}static asApiEvents(f){return f.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(a=>a.cell)}))}}class P{constructor(f,h,a){var u;this._notebook=f,this._extHostDocument=h,this._cellData=a,this.handle=a.handle,this.uri=T.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(u=a.metadata)!==null&&u!==void 0?u:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(f,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:f}}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const f=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return f._notebook.getCellIndex(f)},notebook:f._notebook.notebookDocument,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get outputs(){return f._outputs.slice(0)},get metadata(){return f._metadata},get latestExecutionSummary(){return f._previousResult}})}return this._cell}setOutputs(f){this._outputs=f.map(A.NotebookCellOutput.to)}setOutputItems(f,h,a){const u=a.map(A.NotebookCellOutputItem.to),E=this._outputs.find(v=>v.id===f);E&&(h||(E.outputs.length=0),E.outputs.push(...u))}setMetadata(f){this._internalMetadata=f,this._metadata=A.NotebookCellMetadata.to(f),this._previousResult=A.NotebookCellPreviousExecutionResult.to(f)}}e.ExtHostCell=P;class s{constructor(f,h,a,u,E,v,_){this._proxy=f,this._textDocumentsAndEditors=h,this._textDocuments=a,this._emitter=u,this._viewType=E,this._metadata=v,this.uri=_,this.handle=s._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get notebookDocument(){if(!this._notebook){const f=this;this._notebook={get uri(){return f.uri},get version(){return f._versionId},get viewType(){return f._viewType},get isDirty(){return f._isDirty},get isUntitled(){return f.uri.scheme===b.Schemas.untitled},get isClosed(){return f._disposed},get metadata(){return f._metadata},get cellCount(){return f._cells.length},cellAt(h){return h=f._validateIndex(h),f._cells[h].cell},getCells(h){return(h?f._getCells(h):f._cells).map(u=>u.cell)},save(){return f._save()}}}return this._notebook}updateBackup(f){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=f}disposeBackup(){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(f){f.metadata&&(this._metadata=this._metadata.with(f.metadata))}acceptModelChanged(f,h){this._versionId=f.versionId,this._isDirty=h;for(const a of f.rawEvents)a.kind===k.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(a.changes,!0),a.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===k.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===k.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(a.index,a.metadata)}_validateIndex(f){return f<0?0:f>=this._cells.length?this._cells.length-1:f}_validateRange(f){return f.start<0&&(f=f.with({start:0})),f.end>this._cells.length&&(f=f.with({end:this._cells.length})),f}_getCells(f){f=this._validateRange(f);const h=[];for(let a=f.start;a<f.end;a++)h.push(this._cells[a]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(f,h){if(!this._disposed){const a=[],u=[],E=[];f.reverse().forEach(v=>{const g=v[2].map(n=>{const t=new P(this,this._textDocumentsAndEditors,n);return h||u.push(P.asModelAddData(this.notebookDocument,n)),t}),l=new D(v[0],v[1],[],g),d=this._cells.splice(v[0],v[1],...g);for(let n of d)E.push(n.uri),l.deletedItems.push(n.cell);a.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:E}),h||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.notebookDocument,changes:D.asApiEvents(a)}))}}_moveCell(f,h){const a=this._cells.splice(f,1);this._cells.splice(h,0,...a);const u=[new D(f,1,a.map(E=>E.cell),[]),new D(h,0,[],a)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.notebookDocument,changes:D.asApiEvents(u)}))}_setCellOutputs(f,h){const a=this._cells[f];a.setOutputs(h),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.notebookDocument,cells:[a.cell]}))}_setCellOutputItems(f,h,a,u){const E=this._cells[f];E.setOutputItems(h,a,u),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.notebookDocument,cells:[E.cell]}))}_changeCellLanguage(f,h){const a=this._cells[f];a.cell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(a.uri,h)}_changeCellMetadata(f,h){var a;const u=this._cells[f],E=u.internalMetadata,v=u.cell.metadata;u.setMetadata(h);const _=u.cell.metadata;if((0,I.equals)(v,_)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.notebookDocument,cell:u.cell})),E.runState!==h.runState){const g=(a=h.runState)!==null&&a!==void 0?a:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.notebookDocument,cell:u.cell,executionState:g}))}}getCellFromIndex(f){return this._cells[f]}getCell(f){return this._cells.find(h=>h.handle===f)}getCellIndex(f){return this._cells.indexOf(f)}}e.ExtHostNotebookDocument=s,s._handlePool=0}),define(me[219],ge([0,1,7,20]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(k){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=k}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(k){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:k})}replaceCellMetadata(k,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:k,metadata:D})}replaceCellOutput(k,D){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:k,outputs:D.map(P=>I.NotebookCellOutput.from(P))})}replaceCells(k,D,P){this._throwIfFinalized(),!(k===D&&P.length===0)&&this._collectedEdits.push({editType:1,index:k,count:D-k,cells:P.map(I.NotebookCellData.from)})}}class A{constructor(k,D,P,s,C,f){this.id=k,this._proxy=D,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=C,this._visibleRanges=s,this._viewColumn=f}get apiEditor(){if(!this._editor){const k=this;this._editor={get document(){return k.notebookData.notebookDocument},get selections(){return k._selections},get visibleRanges(){return k._visibleRanges},revealRange(D,P){k._proxy.$tryRevealRange(k.id,I.NotebookRange.from(D),P!=null?P:b.NotebookEditorRevealType.Default)},get viewColumn(){return k._viewColumn},edit(D){const P=new T(this.document.version);return D(P),k._applyEdit(P.finalize())},setDecorations(D,P){return k.setDecorations(D,P)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(k){this._visible=k}_acceptVisibleRanges(k){this._visibleRanges=k}_acceptSelections(k){this._selections=k}_acceptViewColumn(k){this._viewColumn=k}_applyEdit(k){if(k.cellEdits.length===0)return Promise.resolve(!0);const D=[];let P=-1;for(let s=0;s<k.cellEdits.length;s++){if(P<0){D.push(k.cellEdits[s]),P++;continue}const f=D[P],h=k.cellEdits[s];if(f.editType===1&&h.editType===1&&f.index===h.index){f.cells.push(...k.cellEdits[s].cells),f.count+=k.cellEdits[s].count;continue}D.push(k.cellEdits[s]),P++}return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,D)}setDecorations(k,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(k.key)))return D.isEmpty?this._hasDecorationsForKey.delete(k.key):this._hasDecorationsForKey.add(k.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(D),k.key)}}e.ExtHostNotebookEditor=A}),define(me[220],ge([0,1,20,114,163,21,69]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,f,h){const a=this._handles++,{title:u,location:E,cancellable:v}=f,_={label:(0,T.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(a,{location:b.ProgressLocation.from(E),title:u,source:_,cancellable:v},C),this._withProgress(a,h,!!v)}_withProgress(C,f,h){let a;h&&(a=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,a));const u=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),a&&a.dispose()};let E;try{E=f(new P(this._proxy,C),h&&a?a.token:A.CancellationToken.None)}catch(v){throw u(C),v}return E.then(v=>u(C),v=>u(C)),E}$acceptProgressCanceled(C){const f=this._mapHandleToCancellationSource.get(C);f&&(f.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=k;function D(s,C){return s.message=C.message,typeof C.increment=="number"&&(typeof s.increment=="number"?s.increment+=C.increment:s.increment=C.increment),s}class P extends I.Progress{constructor(C,f){super(h=>this.throttledReport(h));this._proxy=C,this._handle=f}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}je([(0,y.throttle)(100,(s,C)=>D(s,C),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(me[123],ge([0,1,52,19,71,20,7]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(f,h){const a=k._Keys.nextId();f.$registerTextEditorDecorationType(a,A.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:a,dispose(){f.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=k,k._Keys=new T.IdGenerator("TextEditorDecorationType");class D{constructor(f,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=f,this._documentVersionId=f.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(f,h){this._throwIfFinalized();let a=null;if(f instanceof y.Position)a=new y.Range(f,f);else if(f instanceof y.Range)a=f;else throw new Error("Unrecognized location");this._pushEdit(a,h,!1)}insert(f,h){this._throwIfFinalized(),this._pushEdit(new y.Range(f,f),h,!0)}delete(f){this._throwIfFinalized();let h=null;if(f instanceof y.Range)h=f;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(f,h,a){const u=this._document.validateRange(f);this._collectedEdits.push({range:u,text:h,forceMoveMarkers:a})}setEndOfLine(f){if(this._throwIfFinalized(),f!==y.EndOfLine.LF&&f!==y.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=f}}e.TextEditorEdit=D;class P{constructor(f,h,a,u){this._proxy=f,this._id=h,this._accept(a),this._logService=u;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(v){E._setTabSize(v)},get insertSpaces(){return E._insertSpaces},set insertSpaces(v){E._setInsertSpaces(v)},get cursorStyle(){return E._cursorStyle},set cursorStyle(v){E._setCursorStyle(v)},get lineNumbers(){return E._lineNumbers},set lineNumbers(v){E._setLineNumbers(v)}}}_accept(f){this._tabSize=f.tabSize,this._insertSpaces=f.insertSpaces,this._cursorStyle=f.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(f.lineNumbers)}_validateTabSize(f){if(f==="auto")return"auto";if(typeof f=="number"){const h=Math.floor(f);return h>0?h:null}if(typeof f=="string"){const h=parseInt(f,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(f){const h=this._validateTabSize(f);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(f){return f==="auto"?"auto":f==="false"?!1:Boolean(f)}_setInsertSpaces(f){const h=this._validateInsertSpaces(f);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(f){this._cursorStyle!==f&&(this._cursorStyle=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:f})))}_setLineNumbers(f){this._lineNumbers!==f&&(this._lineNumbers=f,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(f)})))}assign(f){const h={};let a=!1;if(typeof f.tabSize!="undefined"){const u=this._validateTabSize(f.tabSize);u==="auto"?(a=!0,h.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,a=!0,h.tabSize=u)}if(typeof f.insertSpaces!="undefined"){const u=this._validateInsertSpaces(f.insertSpaces);u==="auto"?(a=!0,h.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,a=!0,h.insertSpaces=u)}typeof f.cursorStyle!="undefined"&&this._cursorStyle!==f.cursorStyle&&(this._cursorStyle=f.cursorStyle,a=!0,h.cursorStyle=f.cursorStyle),typeof f.lineNumbers!="undefined"&&this._lineNumbers!==f.lineNumbers&&(this._lineNumbers=f.lineNumbers,a=!0,h.lineNumbers=A.TextEditorLineNumbersStyle.from(f.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(f){f.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=P;class s{constructor(f,h,a,u,E,v,_,g){this.id=f,this._proxy=h,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new P(this._proxy,this.id,v,a),this._visibleRanges=_,this._viewColumn=g;const l=this;this.value=Object.freeze({get document(){return u.getValue()},set document(d){throw(0,I.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(d){if(!(d instanceof y.Selection))throw(0,I.illegalArgument)("selection");l._selections=[d],l._trySetSelection()},get selections(){return l._selections},set selections(d){if(!Array.isArray(d)||d.some(n=>!(n instanceof y.Selection)))throw(0,I.illegalArgument)("selections");l._selections=d,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(d){throw(0,I.readonly)("visibleRanges")},get options(){return l._options.value},set options(d){l._disposed||l._options.assign(d)},get viewColumn(){return l._viewColumn},set viewColumn(d){throw(0,I.readonly)("viewColumn")},edit(d,n={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const t=new D(u.getValue(),n);return d(t),l._applyEdit(t)},insertSnippet(d,n,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=l._selections.map(i=>A.Range.from(i));else if(n instanceof y.Position){const{lineNumber:i,column:o}=A.Position.from(n);r=[{startLineNumber:i,startColumn:o,endLineNumber:i,endColumn:o}]}else if(n instanceof y.Range)r=[A.Range.from(n)];else{r=[];for(const i of n)if(i instanceof y.Range)r.push(A.Range.from(i));else{const{lineNumber:o,column:c}=A.Position.from(i);r.push({startLineNumber:o,startColumn:c,endLineNumber:o,endColumn:c})}}return h.$tryInsertSnippet(f,d.value,r,t)},setDecorations(d,n){const t=n.length===0;t&&!l._hasDecorationsForKey.has(d.key)||(t?l._hasDecorationsForKey.delete(d.key):l._hasDecorationsForKey.add(d.key),l._runOnProxy(()=>{if(A.isDecorationOptionsArr(n))return h.$trySetDecorations(f,d.key,A.fromRangeOrRangeWithMessage(n));{const r=new Array(4*n.length);for(let i=0,o=n.length;i<o;i++){const c=n[i];r[4*i]=c.start.line+1,r[4*i+1]=c.start.character+1,r[4*i+2]=c.end.line+1,r[4*i+3]=c.end.character+1}return h.$trySetDecorationsFast(f,d.key,r)}}))},revealRange(d,n){l._runOnProxy(()=>h.$tryRevealRange(f,A.Range.from(d),n||y.TextEditorRevealType.Default))},show(d){h.$tryShowEditor(f,A.ViewColumn.from(d))},hide(){h.$tryHideEditor(f)}})}dispose(){(0,b.ok)(!this._disposed),this._disposed=!0}_acceptOptions(f){(0,b.ok)(!this._disposed),this._options._accept(f)}_acceptVisibleRanges(f){(0,b.ok)(!this._disposed),this._visibleRanges=f}_acceptViewColumn(f){(0,b.ok)(!this._disposed),this._viewColumn=f}_acceptSelections(f){(0,b.ok)(!this._disposed),this._selections=f}async _trySetSelection(){const f=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,f)),this.value}_applyEdit(f){const h=f.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const a=h.edits.map(E=>E.range);a.sort((E,v)=>E.end.line===v.end.line?E.end.character===v.end.character?E.start.line===v.start.line?E.start.character-v.start.character:E.start.line-v.start.line:E.end.character-v.end.character:E.end.line-v.end.line);for(let E=0,v=a.length-1;E<v;E++){const _=a[E].end;if(a[E+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=h.edits.map(E=>({range:A.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,u,{setEndOfLine:typeof h.setEndOfLine=="number"?A.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(f){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=s}),define(me[221],ge([0,1,166,25,2,3,6,16,7,12,15,20,21]),function(G,e,b,I,T,A,y,k,D,P,s,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(E,v){if((0,P.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let _;return Array.isArray(E.highlights)&&(_=E.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),_=_.length?_:void 0),{label:E.label,highlights:_}}}class a{constructor(v,_,g){this._proxy=v,this.commands=_,this.logService=g,this.treeViews=new Map;function l(d){return d&&d.$treeViewId&&d.$treeItemHandle}_.registerArgumentProcessor({processArgument:d=>l(d)?this.convertArgument(d):Array.isArray(d)&&d.length>0?d.map(n=>l(n)?this.convertArgument(n):n):d})}registerTreeDataProvider(v,_,g){const l=this.createTreeView(v,{treeDataProvider:_},g);return{dispose:()=>l.dispose()}}createTreeView(v,_,g){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=this._proxy.$registerTreeViewDataProvider(v,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany}),d=this.createExtHostTreeView(v,_,g);return{get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get message(){return d.message},set message(n){d.message=n},get title(){return d.title},set title(n){d.title=n},get description(){return d.description},set description(n){d.description=n},reveal:(n,t)=>d.reveal(n,t),dispose:async()=>{await l,this.treeViews.delete(v),d.dispose()}}}$getChildren(v,_){const g=this.treeViews.get(v);return g?g.getChildren(_):Promise.reject(new Error((0,b.localize)(0,null,v)))}async $hasResolve(v){const _=this.treeViews.get(v);if(!_)throw new Error((0,b.localize)(1,null,v));return _.hasResolve}$resolve(v,_,g){const l=this.treeViews.get(v);if(!l)throw new Error((0,b.localize)(2,null,v));return l.resolveTreeItem(_,g)}$setExpanded(v,_,g){const l=this.treeViews.get(v);if(!l)throw new Error((0,b.localize)(3,null,v));l.setExpanded(_,g)}$setSelection(v,_){const g=this.treeViews.get(v);if(!g)throw new Error((0,b.localize)(4,null,v));g.setSelection(_)}$setVisible(v,_){const g=this.treeViews.get(v);if(!g)throw new Error((0,b.localize)(5,null,v));g.setVisible(_)}createExtHostTreeView(v,_,g){const l=new u(v,_,this._proxy,this.commands.converter,this.logService,g);return this.treeViews.set(v,l),l}convertArgument(v){const _=this.treeViews.get(v.$treeViewId);return _?_.getExtensionElement(v.$treeItemHandle):null}}e.ExtHostTreeViews=a;class u extends y.Disposable{constructor(v,_,g,l,d,n){super();if(this.viewId=v,this.proxy=g,this.commands=l,this.logService=d,this.extension=n,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,n.contributes&&n.contributes.views)for(const i in n.contributes.views)for(const o of n.contributes.views[i])o.id===v&&(this._title=o.name);this.dataProvider=_.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let t,r;this._register(A.Event.debounce(this._onDidChangeData.event,(i,o)=>(i||(i={message:!1,elements:[]}),o.element!==!1&&(t||(t=new Promise(c=>r=c),this.refreshPromise=this.refreshPromise.then(()=>t)),i.elements.push(o.element)),o.message&&(i.message=!0),i),200,!0)(({message:i,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=r;return t=null,this.refresh(o).then(()=>c())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(v=>this.getExtensionElement(v)).filter(v=>!(0,P.isUndefinedOrNull)(v))}getChildren(v){const _=v?this.getExtensionElement(v):void 0;if(v&&!_)return this.logService.error(`No tree item with id '${v}' found.`),Promise.resolve([]);const g=this.getChildrenNodes(v);return(g?Promise.resolve(g):this.fetchChildrenNodes(_)).then(l=>l.map(d=>d.item))}getExtensionElement(v){return this.elements.get(v)}reveal(v,_){_=_||{select:!0,focus:!1};const g=(0,P.isUndefinedOrNull)(_.select)?!0:_.select,l=(0,P.isUndefinedOrNull)(_.focus)?!1:_.focus,d=(0,P.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.refreshPromise.then(()=>this.resolveUnknownParentChain(v)).then(n=>this.resolveTreeNode(v,n[n.length-1]).then(t=>this.proxy.$reveal(this.viewId,{item:t.item,parentChain:n.map(r=>r.item)},{select:g,focus:l,expand:d})),n=>this.logService.error(n)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:l,expand:d})}get message(){return this._message}set message(v){this._message=v,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(v){this._title=v,this.proxy.$setTitle(this.viewId,v,this._description)}get description(){return this._description}set description(v){this._description=v,this.proxy.$setTitle(this.viewId,this._title,v)}setExpanded(v,_){const g=this.getExtensionElement(v);g&&(_?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelection(v){(0,s.equals)(this._selectedHandles,v)||(this._selectedHandles=v,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(v){v!==this._visible&&(this._visible=v,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(v,_){var g;if(!!this.dataProvider.resolveTreeItem){const l=this.elements.get(v);if(l){const d=this.nodes.get(l);if(d){const n=(g=await this.dataProvider.resolveTreeItem(d.extensionItem,l,_))!==null&&g!==void 0?g:d.extensionItem;return d.item.tooltip=this.getTooltip(n.tooltip),d.item.command=this.getCommand(d.disposableStore,n.command),d.item}}}}resolveUnknownParentChain(v){return this.resolveParent(v).then(_=>_?this.resolveUnknownParentChain(_).then(g=>this.resolveTreeNode(_,g[g.length-1]).then(l=>(g.push(l),g))):Promise.resolve([]))}resolveParent(v){const _=this.nodes.get(v);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(v))}resolveTreeNode(v,_){const g=this.nodes.get(v);return g?Promise.resolve(g):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(l=>this.createHandle(v,l,_,!0)).then(l=>this.getChildren(_?_.item.handle:void 0).then(()=>{const d=this.getExtensionElement(l);if(d){const n=this.nodes.get(d);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(v){if(v){let _;if(typeof v=="string"){const g=this.getExtensionElement(v);_=g?this.nodes.get(g):void 0}else _=v;return _&&_.children||null}return this.roots}async fetchChildrenNodes(v){this.clearChildren(v);const _=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=v?this.nodes.get(v):void 0,l=await this.dataProvider.getChildren(v);if(_.token.isCancellationRequested)return[];const d=await Promise.all((0,s.coalesce)(l||[]).map(async n=>{const t=await this.dataProvider.getTreeItem(n);return t&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(n,t,g):null}));return _.token.isCancellationRequested?[]:(0,s.coalesce)(d)}finally{_.dispose()}}refresh(v){if(v.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(v);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(v){const _=new Set,g=v.map(d=>this.nodes.get(d));for(const d of g)if(d&&!_.has(d.item.handle)){let n=d;for(;n&&n.parent&&g.findIndex(t=>n&&n.parent&&t&&t.item.handle===n.parent.item.handle)===-1;){const t=this.elements.get(n.parent.item.handle);n=t?this.nodes.get(t):void 0}n&&!n.parent&&_.add(d.item.handle)}const l=[];return _.forEach(d=>{const n=this.elements.get(d);if(n){const t=this.nodes.get(n);t&&(!t.parent||!_.has(t.parent.item.handle))&&l.push(d)}}),l}refreshHandles(v){const _={};return Promise.all(v.map(g=>this.refreshNode(g).then(l=>{l&&(_[g]=l.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(v){const _=this.getExtensionElement(v);if(_){const g=this.nodes.get(_);if(g)return this.clearChildren(_),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(l=>{if(l){const d=this.createTreeNode(_,l,g.parent);return this.updateNodeCache(_,d,g,g.parent),g.dispose(),d}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(v,_,g){const l=this.createTreeNode(v,_,g);if(_.id&&this.elements.has(l.item.handle))throw new Error((0,b.localize)(6,null,_.id));return this.addNodeToCache(v,l),this.addNodeToParentCache(l,g),l}getTooltip(v){return D.MarkdownString.isMarkdownString(v)?C.MarkdownString.from(v):v}getCommand(v,_){return _?this.commands.toInternal(_,v):void 0}createTreeNode(v,_,g){const l=new y.DisposableStore,d=this.createHandle(v,_,g),n=this.getLightIconPath(_);return{item:{handle:d,parentHandle:g?g.item.handle:void 0,label:h(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(l,_.command),contextValue:_.contextValue,icon:n,iconDark:this.getDarkIconPath(_)||n,themeIcon:this.getThemeIcon(_),collapsibleState:(0,P.isUndefinedOrNull)(_.collapsibleState)?D.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:g,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(v){return v.iconPath instanceof D.ThemeIcon?v.iconPath:void 0}createHandle(v,{id:_,label:g,resourceUri:l},d,n){if(_)return`${u.ID_HANDLE_PREFIX}/${_}`;const t=h(g,this.extension),r=d?d.item.handle:u.LABEL_HANDLE_PREFIX;let i=t?t.label:l?(0,I.basename)(l):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const o=this.nodes.has(v)?this.nodes.get(v).item.handle:void 0,c=this.getChildrenNodes(d)||[];let m,S=0;do{if(m=`${r}/${S}:${i}`,n||!this.elements.has(m)||o===m)break;S++}while(S<=c.length);return m}getLightIconPath(v){if(v.iconPath&&!(v.iconPath instanceof D.ThemeIcon))return typeof v.iconPath=="string"||T.URI.isUri(v.iconPath)?this.getIconPath(v.iconPath):this.getIconPath(v.iconPath.light)}getDarkIconPath(v){if(v.iconPath&&!(v.iconPath instanceof D.ThemeIcon)&&v.iconPath.dark)return this.getIconPath(v.iconPath.dark)}getIconPath(v){return T.URI.isUri(v)?v:T.URI.file(v)}addNodeToCache(v,_){this.elements.set(_.item.handle,v),this.nodes.set(v,_)}updateNodeCache(v,_,g,l){this.elements.delete(_.item.handle),this.nodes.delete(v),_.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(v,_);const d=this.getChildrenNodes(l)||[],n=d.filter(t=>t.item.handle===g.item.handle)[0];n&&d.splice(d.indexOf(n),1,_)}addNodeToParentCache(v,_){_?(_.children||(_.children=[]),_.children.push(v)):(this.roots||(this.roots=[]),this.roots.push(v))}clearChildren(v){if(v){const _=this.nodes.get(v);if(_){if(_.children)for(const g of _.children){const l=this.elements.get(g.item.handle);l&&this.clear(l)}_.children=void 0}}else this.clearAll()}clear(v){const _=this.nodes.get(v);if(_){if(_.children)for(const g of _.children){const l=this.elements.get(g.item.handle);l&&this.clear(l)}this.nodes.delete(v),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(v=>v.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}u.LABEL_HANDLE_PREFIX="0",u.ID_HANDLE_PREFIX="1"}),define(me[222],ge([0,1,15,16,21,12,86,20,7,122]),function(G,e,b,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class s{constructor(){this.testIdsToInternal=new Map}getTestById(E,v){if(v!==void 0){const _=this.testIdsToInternal.get(v),g=_==null?void 0:_.get(E);if(g)return[_,g]}return(0,b.mapFind)(this.testIdsToInternal.values(),_=>{const g=_.get(E);return g&&[_,g]})}createForHierarchy(E=()=>{}){return new a(this.createIdMap(f++),E)}createIdMap(E){const v=new h(E);return this.testIdsToInternal.set(v.id,v),{object:v,dispose:()=>this.testIdsToInternal.delete(v.id)}}}e.OwnedTestCollection=s;var C;(function(u){u[u.Disconnected=0]="Disconnected",u[u.IsChild=1]="IsChild",u[u.IsParent=2]="IsParent",u[u.IsSame=3]="IsSame"})(C=e.TestPosition||(e.TestPosition={}));let f=0;class h{constructor(E){this.id=E,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(E){if(this.map.has(E.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${E.item.extId}`);this.map.set(E.item.extId,E),E.parent||this._roots.add(E)}has(E){return this.map.has(E)}delete(E){const v=this.map.get(E);return v?(this.map.delete(E),this._roots.delete(v),!0):!1}get(E){return this.map.get(E)}comparePositions(E,v){const _=typeof E=="string"?this.map.get(E):E,g=typeof v=="string"?this.map.get(v):v;if(!_||!g)return 0;if(_===g)return 3;for(let l=this.map.get(g.parent);l;l=this.map.get(l.parent))if(l===_)return 1;for(let l=this.map.get(_.parent);l;l=this.map.get(l.parent))if(l===g)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=h;class a{constructor(E,v){this.testIdToInternal=E,this.publishDiff=v,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(E,v){this.addItem(E,v,null)}getTestByReference(E){return this.testItemToInternal.get(E)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const v=this.diff[this.diff.length-1];if(v&&E[0]===1){if(v[0]===1&&v[1].extId===E[1].extId){(0,P.applyTestItemUpdate)(v[1],E[1]);return}if(v[0]===0&&v[1].item.extId===E[1].extId){(0,P.applyTestItemUpdate)(v[1],E[1]);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,v){var _;const g=this.testIdToInternal.object.get(E);if(!!g){if((g.expandLevels===void 0||v>g.expandLevels)&&(g.expandLevels=v),g.expand===1){const l=this.refreshChildren(g);return l.isSettled?this.expandChildren(g,v-1):l.p.then(()=>this.expandChildren(g,v-1))}else if(g.expand===3)return((_=g.initialExpand)===null||_===void 0?void 0:_.isSettled)===!1?g.initialExpand.p.then(()=>this.expandChildren(g,v-1)):this.expandChildren(g,v-1)}}dispose(){var E;for(const v of this.testItemToInternal.values())(E=v.discoverCts)===null||E===void 0||E.dispose(!0),(0,y.getPrivateApiFor)(v.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(E,v){const _=E==null?void 0:E.actual.id;switch(v[0]){case 2:this.pushDiff([4,_]);break;case 1:this.removeItem(E);break;case 0:this.addItem(v[1],E.src.controller,E);break;case 3:const[g,l,d]=v;switch(l){case"status":this.updateExpandability(E);break;case"range":this.pushDiff([1,{extId:_,item:{range:k.Range.from(d)}}]);break;default:this.pushDiff([1,{extId:_,item:{[l]:d}}]);break}break;default:(0,A.assertNever)(v[0])}}addItem(E,v,_){if(!(E instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${E.id} did not`);if(this.testItemToInternal.has(E))throw new Error(`Attempted to add a single TestItem ${E.id} multiple times to the tree`);if(this.testIdToInternal.object.has(E.id))throw new Error(`Attempted to insert a duplicate test item ID ${E.id}`);const g=_?_.item.extId:null,l=E.resolveHandler?1:0,d=_==null?void 0:_.expandLevels,n={controller:v,tree:this.testIdToInternal.object.id},t={actual:E,parent:g,item:k.TestItem.from(E),expandLevels:d?d-1:void 0,expand:0,src:n};this.testIdToInternal.object.add(t),this.testItemToInternal.set(E,t),this.pushDiff([0,{parent:g,src:n,expand:l,item:t.item}]);const r=(0,y.getPrivateApiFor)(E);r.parent=_==null?void 0:_.actual,r.bus.event(this.onTestItemEvent.bind(this,t)),this.updateExpandability(t);for(const i of r.children.values())this.testItemToInternal.has(i)||this.addItem(i,v,t)}updateExpandability(E){var v;let _;E.actual.resolveHandler?E.actual.status===D.TestItemStatus.Pending?_=E.discoverCts?2:1:((v=E.initialExpand)===null||v===void 0||v.complete(),_=3):_=0,_!==E.expand&&(E.expand=_,this.pushDiff([1,{extId:E.actual.id,expand:_}]),_===1&&E.expandLevels!==void 0&&this.refreshChildren(E))}expandChildren(E,v){if(!(v<0)){const _=[...E.actual.children.values()].map(g=>this.expand(g.id,v)).filter(I.isThenable);if(_.length)return Promise.all(_).then(()=>{})}}refreshChildren(E){if(E.discoverCts&&E.discoverCts.dispose(!0),!E.actual.resolveHandler){const v=new I.DeferredPromise;return v.complete(),v}return E.expand=2,E.discoverCts=new T.CancellationTokenSource,this.pushExpandStateUpdate(E),E.initialExpand=new I.DeferredPromise,E.actual.resolveHandler(E.discoverCts.token),E.initialExpand}pushExpandStateUpdate(E){this.pushDiff([1,{extId:E.actual.id,expand:E.expand}])}removeItem(E){var v;this.pushDiff([2,E.actual.id]);const _=[E];for(;_.length;){const g=_.pop();if(!!g){(v=g.discoverCts)===null||v===void 0||v.dispose(!0),this.testIdToInternal.object.delete(g.item.extId),this.testItemToInternal.delete(g.actual);for(const l of g.actual.children.values())_.push(this.testIdToInternal.object.get(l.id))}}}flushDiff(){const E=this.collectDiff();E.length&&this.publishDiff(E)}}e.SingleUseTestCollection=a}),define(me[223],ge([0,1,28,3,8]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(s){this.removedDueToLooping=s}}e.DeltaExtensionsResult=A;class y{constructor(s){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=s,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const s of this._extensionDescriptions){if(this._extensionsMap.has(b.ExtensionIdentifier.toKey(s.identifier))){console.error("Extension `"+s.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(b.ExtensionIdentifier.toKey(s.identifier),s),this._extensionsArr.push(s),Array.isArray(s.activationEvents))for(let C of s.activationEvents)C==="onUri"&&(C=`onUri:${b.ExtensionIdentifier.toKey(s.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(s)}}keepOnly(s){const C=new Set;s.forEach(f=>C.add(b.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>C.has(b.ExtensionIdentifier.toKey(f.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(s,C){s.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(s));const f=y._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(f.map(h=>h.identifier)),C.length>0){const h=new Set;C.forEach(a=>h.add(b.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!h.has(b.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(f)}static _findLoopingExtensions(s){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,v){this.addNode(E),this.addNode(v),this._arcs.has(E)?this._arcs.get(E).push(v):this._arcs.set(E,[v])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,v){const _=C.getArcs(E);for(let g=0;g<_.length;g++)if(!v.has(_[g]))return!1;return!0}getNodes(){return this._nodesArr}};let f=new Map;for(let E of s){const v=b.ExtensionIdentifier.toKey(E.identifier);if(f.set(v,E),E.extensionDependencies)for(let _ of E.extensionDependencies){const g=b.ExtensionIdentifier.toKey(_);C.addArc(v,g)}}let h=new Set;C.getNodes().filter(E=>C.getArcs(E).length===0).forEach(E=>h.add(E));let a=C.getNodes().filter(E=>!h.has(E)),u;do{u=!1;for(let E=0;E<a.length;E++){const v=a[E];C.hasOnlyGoodArcs(v,h)&&(a.splice(E,1),E--,h.add(v),u=!0)}}while(u);return a.map(E=>f.get(E))}containsActivationEvent(s){return this._activationMap.has(s)}containsExtension(s){return this._extensionsMap.has(b.ExtensionIdentifier.toKey(s))}getExtensionDescriptionsForActivationEvent(s){const C=this._activationMap.get(s);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(s){const C=this._extensionsMap.get(b.ExtensionIdentifier.toKey(s));return C||void 0}}e.ExtensionDescriptionRegistry=y;var k;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(k||(k={}));function D(P,s){const C=P.isBuiltin?0:P.isUnderDevelopment?2:1,f=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(C!==f)return C-f;const h=T.posix.basename(P.extensionLocation.path),a=T.posix.basename(s.extensionLocation.path);return h<a?-1:h>a?1:0}}),define(me[224],ge([0,1,22]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function A(k){const D=b.VSBuffer.alloc(1);switch(k){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function y(k,D){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(me[41],ge([0,1,3,2,4,28,184]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class k{constructor(_){this.dependency=_}}e.MissingDependencyError=k;var D;(function(v){v[v.LocalProcess=0]="LocalProcess",v[v.LocalWebWorker=1]="LocalWebWorker",v[v.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class P{constructor(_,g,l,d){this.codeLoadingTime=_,this.activateCallTime=g,this.activateResolvedTime=l,this.activationReason=d}}e.ActivationTimes=P;class s{constructor(_,g){this.description=_,this.value=g}}e.ExtensionPointContribution=s,e.ExtensionHostLogFileName="exthost";var C;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function f(v){v.enableProposedApi||h(v)}e.checkProposedApiEnabled=f;function h(v){throw new Error(`[${v.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`)}e.throwProposedApiError=h;function a(v){return{type:v.isBuiltin?0:1,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation}}e.toExtension=a;function u(v){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(v.identifier.id),isBuiltin:v.type===0,isUserBuiltin:v.type===1&&v.isBuiltin,isUnderDevelopment:!1,extensionLocation:v.location},v.manifest),{uuid:v.identifier.uuid})}e.toExtensionDescription=u;class E{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None}activateByEvent(_){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(_){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(_,g){}_activateById(_,g){return Promise.resolve()}_onWillActivateExtension(_){}_onDidActivateExtension(_,g,l,d,n){}_onExtensionRuntimeError(_,g){}_onExtensionHostExit(_){}}e.NullExtensionService=E}),define(me[225],ge([0,1,161,28,41,13]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class k{constructor(u,E,v,_){this.startup=u,this.codeLoadingTime=E,this.activateCallTime=v,this.activateResolvedTime=_}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class D{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,E){return u===-1||E===-1?-1:E-u}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class P{constructor(u,E,v,_,g,l){this.activationFailed=u,this.activationFailedError=E,this.activationTimes=v,this.module=_,this.exports=g,this.subscriptions=l}}e.ActivatedExtension=P;class s extends P{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=s;class C extends P{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class f extends P{constructor(u){super(!0,u,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=f;let h=class{constructor(u,E,v,_,g){this._logService=g,this._registry=u,this._resolvedExtensionsSet=new Set,E.forEach(l=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,v.forEach(l=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(l),l)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const E=I.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(E)}getActivatedExtension(u){const E=I.ExtensionIdentifier.toKey(u),v=this._activatedExtensions.get(E);if(!v)throw new Error("Extension `"+u.value+"` is not known or not activated");return v}activateByEvent(u,E){if(this._alreadyActivatedEvents[u])return y;const v=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(v.map(_=>({id:_.identifier,reason:{startup:E,extensionId:_.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,E){const v=this._registry.getExtensionDescription(u);if(!v)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:v.identifier,reason:E}])}_handleActivateRequest(u,E,v){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(u.id))){E[I.ExtensionIdentifier.toKey(u.id)]=u;return}const _=this._registry.getExtensionDescription(u.id);if(!_){this._host.onExtensionActivationError(u.id,new T.MissingDependencyError(u.id.value));const d=new Error(`Unknown dependency '${u.id.value}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(u.id),new f(d));return}const g=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let l=!0;for(let d=0,n=g.length;d<n;d++){const t=g[d];if(!this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(t))){const r=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(t));if(!(r&&!r.activationFailed)){if(r&&r.activationFailed){this._host.onExtensionActivationError(_.identifier,b.localize(0,null,_.displayName||_.identifier.value,t));const c=new Error(`Dependency ${t} failed to activate`);c.detail=r.activationFailedError,this._activatedExtensions.set(I.ExtensionIdentifier.toKey(_.identifier),new f(c));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(t))){l=!1,E[I.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(t)),reason:u.reason};continue}const i=this._registry.getExtensionDescription(t);if(i){l=!1,E[I.ExtensionIdentifier.toKey(t)]={id:i.identifier,reason:u.reason};continue}this._host.onExtensionActivationError(_.identifier,new T.MissingDependencyError(t));const o=new Error(`Unknown dependency '${t}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(_.identifier),new f(o));return}}}l?E[I.ExtensionIdentifier.toKey(_.identifier)]=u:v.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(g=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(g.id))),u.length===0))return Promise.resolve(void 0);const E=Object.create(null),v=[];for(let g=0,l=u.length;g<l;g++)this._handleActivateRequest(u[g],E,v);for(let g=0,l=v.length;g<l;g++){const d=I.ExtensionIdentifier.toKey(v[g].id);E[d]&&delete E[d]}const _=Object.keys(E).map(g=>E[g]);return v.length===0?Promise.all(_.map(g=>this._activateExtension(g.id,g.reason))).then(g=>{}):this._activateExtensions(_).then(g=>this._activateExtensions(v))}_activateExtension(u,E){const v=I.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const _=this._activatingExtensions.get(v);if(_)return _;const g=this._host.actualActivateExtension(u,E).then(void 0,l=>(this._host.onExtensionActivationError(u,b.localize(1,null,u.value,l.message)),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(l),new f(l))).then(l=>{this._activatedExtensions.set(v,l),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,g),g}};h=je([Be(4,A.ILogService)],h),e.ExtensionsActivator=h}),define(me[226],ge([0,1,13,41,27,11,112]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends b.LogService{constructor(P){if(P.logFile.scheme!==A.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(I.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};k=je([Be(0,T.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(me[227],ge([0,1,19]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,y)=>{this._actualOk=A,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,b.onUnexpectedError)(A))}then(A,y){return this._ensureActual().then(A,y)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=I}),define(me[124],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(D,P){this.isMain=D,this.sid=P,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const I=[];function T(k){const D=new b(!0,k);return I[D.nid]=D,D}e.createMainContextProxyIdentifier=T;function A(k){const D=new b(!1,k);return I[D.nid]=D,D}e.createExtHostContextProxyIdentifier=A;function y(k){return I[k].sid}e.getStringIdentifierForProxy=y}),define(me[5],ge([0,1,2,124,58]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var y;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(l){l[l.Markdown=1]="Markdown",l[l.Code=2]="Code"})(P=e.CellKind||(e.CellKind={}));var s;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(s=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var f;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(f=e.CandidatePortSource||(e.CandidatePortSource={}));var h;(function(l){l.name="$ident";function d(t,r){return Object.defineProperty(t,l.name,{value:r,enumerable:!0}),t}l.mixin=d;function n(t){return t[l.name]}l.of=n})(h=e.ObjectIdentifier||(e.ObjectIdentifier={}));class a{static mixin(d){return d._id=a._n++,d}}e.IdObject=a,a._n=0;var u;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function _(l){if(l&&l.edits)for(const d of l.edits)typeof d.resource=="object"?d.resource=b.URI.revive(d.resource):(d.newUri=b.URI.revive(d.newUri),d.oldUri=b.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,T.revive)(d.metadata));return l}e.reviveWorkspaceEditDto=_;var g;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(g=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[89],ge([0,1,5,3,4]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(k){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(b.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,D){return this._proxy.$getPassword(k,D)}store(k,D,P){return this._proxy.$setPassword(k,D,P)}delete(k,D){return this._proxy.$deletePassword(k,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(me[63],ge([0,1,4,13,5,14]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,b.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(T.MainContext.MainThreadTelemetry)}report(D,P,s){const C=this.getUsageKey(D,P);this._reportedUsages.has(C)||(this._reportedUsages.add(C),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${s}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};y=je([Be(0,A.IExtHostRpcService),Be(1,I.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(k,D,P){}})}),define(me[228],ge([0,1,3,5,7,28]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new b.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new b.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,P,s,C={}){const f=A.ExtensionIdentifier.toKey(D.identifier),h=this._inFlightRequests.get(f)||[],a=s.sort().join(" ");let u=h.find(E=>E.scopes===a);if(u)return u.result;{const E=this._getSession(D,f,P,s,C);u={scopes:a,result:E},h.push(u),this._inFlightRequests.set(f,h);try{await E}finally{const v=h.findIndex(_=>_.scopes===a);v>-1&&(h.splice(v),this._inFlightRequests.set(f,h))}return E}}async _getSession(D,P,s,C,f={}){await this._proxy.$ensureProvider(s);const h=D.displayName||D.name;return this._proxy.$getSession(s,C,P,h,f)}async removeSession(D,P){const s=this._authenticationProviders.get(D);return s?s.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,s,C){var f;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:s,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===D)||this._providers.push({id:D,label:P});const h=s.onDidChangeSessions(a=>{var u,E,v;this._proxy.$sendDidChangeSessions(D,{added:(u=a.added)!==null&&u!==void 0?u:[],changed:(E=a.changed)!==null&&E!==void 0?E:[],removed:(v=a.removed)!==null&&v!==void 0?v:[]})});return this._proxy.$registerAuthenticationProvider(D,P,(f=C==null?void 0:C.supportsMultipleAccounts)!==null&&f!==void 0?f:!1),new T.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(D);const a=this._providers.findIndex(u=>u.id===D);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,P){return D.forEach(s=>{this._providers.some(C=>C.id===s.id)||this._providers.push(s)}),P.forEach(s=>{const C=this._providers.findIndex(f=>f.id===s.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:P}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(me[229],ge([0,1,5,14,20]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(k,D){this._extHostDocumentsAndEditors=D,this._proxy=k.getProxy(b.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const D=T.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=je([Be(0,I.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(me[230],ge([0,1,5]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(A){const y=A.getProxy(b.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(k){return y.$writeText(k)}})}}e.ExtHostClipboard=I}),define(me[51],ge([0,1,12,7,20,23,5,15,13,58,44,49,2,6,4,14]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(n,t){this._commands=new Map,this._apiCommands=new Map,this._proxy=n.getProxy(y.MainContext.MainThreadCommands),this._logService=t,this.converter=new v(this,r=>{const i=this._apiCommands.get(r);return(i==null?void 0:i.result)===g.Void?i:void 0},t),this._argumentProcessors=[{processArgument(r){return(0,P.revive)(r)}},{processArgument(r){return(0,A.cloneAndChange)(r,function(i){if(s.Range.isIRange(i))return T.Range.to(i);if(C.Position.isIPosition(i))return T.Position.to(i);if(s.Range.isIRange(i.range)&&f.URI.isUri(i.uri))return T.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(n){this._argumentProcessors.push(n)}registerApiCommand(n){const t=this.registerCommand(!1,n.id,async(...r)=>{const i=n.args.map((c,m)=>{if(!c.validate(r[m]))throw new Error(`Invalid argument '${c.name}' when running '${n.id}', received: ${r[m]}`);return c.convert(r[m])}),o=await this.executeCommand(n.internalId,...i);return n.result.convert(o,r,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this._apiCommands.set(n.id,n),new I.Disposable(()=>{t.dispose(),this._apiCommands.delete(n.id)})}registerCommand(n,t,r,i,o){if(this._logService.trace("ExtHostCommands#registerCommand",t),!t.trim().length)throw new Error("invalid id");if(this._commands.has(t))throw new Error(`command '${t}' already exists`);return this._commands.set(t,{callback:r,thisArg:i,description:o}),n&&this._proxy.$registerCommand(t),new I.Disposable(()=>{this._commands.delete(t)&&n&&this._proxy.$unregisterCommand(t)})}executeCommand(n,...t){return this._logService.trace("ExtHostCommands#executeCommand",n),this._doExecuteCommand(n,t,!0)}async _doExecuteCommand(n,t,r){if(this._commands.has(n))return this._executeContributedCommand(n,t);{const i=(0,A.cloneAndChange)(t,function(o){if(o instanceof I.Position)return T.Position.from(o);if(o instanceof I.Range)return T.Range.from(o);if(o instanceof I.Location)return T.location.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(n,i,r);return(0,P.revive)(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(n,t,!1);throw o}}}async _executeContributedCommand(n,t){const r=this._commands.get(n);if(!r)throw new Error("Unknown command");let{callback:i,thisArg:o,description:c}=r;if(c)for(let m=0;m<c.args.length;m++)try{(0,b.validateConstraint)(t[m],c.args[m].constraint)}catch(S){throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${c.args[m].name}' - ${c.args[m].description}`)}try{return await i.apply(o,t)}catch(m){if(n===this.converter.delegatingCommandId){const S=this.converter.getActualCommand(...t);S&&(n=S.command)}throw this._logService.error(m,n),new Error(`Running the contributed command: '${n}' failed.`)}}$executeContributedCommand(n,...t){return this._logService.trace("ExtHostCommands#$executeContributedCommand",n),this._commands.has(n)?(t=t.map(r=>this._argumentProcessors.reduce((i,o)=>o.processArgument(i),r)),this._executeContributedCommand(n,t)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this._logService.trace("ExtHostCommands#getCommands",n),this._proxy.$getCommands().then(t=>(n&&(t=t.filter(r=>r[0]!=="_")),t))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(let[t,r]of this._commands){let{description:i}=r;i&&(n[t]=i)}return Promise.resolve(n)}};E=je([Be(0,u.IExtHostRpcService),Be(1,D.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class v{constructor(n,t,r){this._commands=n,this._lookupApiCommand=t,this._logService=r,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(n,t){if(!!n){const r={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return r;const i=this._lookupApiCommand(n.command);if(i)r.id=i.internalId,r.arguments=i.args.map((o,c)=>o.convert(n.arguments&&n.arguments[c]));else if((0,k.isNonEmptyArray)(n.arguments)){const o=++this._cachIdPool;this._cache.set(o,n),t.add((0,h.toDisposable)(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),r.$ident=o,r.id=this.delegatingCommandId,r.arguments=[o],this._logService.trace("CommandsConverter#CREATE",n.command,o)}return r}}fromInternal(n){const t=y.ObjectIdentifier.of(n);return typeof t=="number"?this._cache.get(t):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this._cache.get(n[0])}_executeConvertedCommand(...n){const t=this.getActualCommand(...n);return this._logService.trace("CommandsConverter#EXECUTE",n[0],t?t.command:"MISSING"),t?this._commands.executeCommand(t.command,...t.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class _{constructor(n,t,r,i){this.name=n,this.description=t,this.validate=r,this.convert=i}optional(){return new _(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,t){return new _(n!=null?n:this.name,t!=null?t:this.description,this.validate,this.convert)}}e.ApiCommandArgument=_,_.Uri=new _("uri","Uri of a text document",d=>f.URI.isUri(d),d=>d),_.Position=new _("position","A position in a text document",d=>I.Position.isPosition(d),T.Position.from),_.Range=new _("range","A range in a text document",d=>I.Range.isRange(d),T.Range.from),_.Selection=new _("selection","A selection in a text document",d=>I.Selection.isSelection(d),T.Selection.from),_.Number=new _("number","",d=>typeof d=="number",d=>d),_.String=new _("string","",d=>typeof d=="string",d=>d),_.CallHierarchyItem=new _("item","A call hierarchy item",d=>d instanceof I.CallHierarchyItem,T.CallHierarchyItem.to);class g{constructor(n,t){this.description=n,this.convert=t}}e.ApiCommandResult=g,g.Void=new g("no result",d=>d);class l{constructor(n,t,r,i,o){this.id=n,this.internalId=t,this.description=r,this.args=i,this.result=o}}e.ApiCommand=l}),define(me[231],ge([0,1,6,20,7,79,51,203,15,109]),function(G,e,b,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const s=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",f(I.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,u)=>{if(!(0,D.isFalsyOrEmpty)(a)){class E extends T.SymbolInformation{static to(_){const g=new E(_.name,I.SymbolKind.to(_.kind),_.containerName||"",new T.Location(u[0],I.Range.to(_.range)));return g.detail=_.detail,g.range=g.location.range,g.selectionRange=I.Range.to(_.selectionRange),g.children=_.children?_.children.map(E.to):[],g}}return a.map(E.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",f(I.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",f(I.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",f(I.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(u=>T.Position.isPosition(u)),a=>a.map(I.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(u=>{let E;for(const v of u.reverse())E=new T.SelectionRange(I.Range.to(v),E);return E}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const u=[];if(Array.isArray(a))for(let E of a)u.push(...E[1].map(I.WorkspaceSymbol.to));return u})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return I.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(I.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new T.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const u=(0,P.decodeSemanticTokensDto)(a);if(u.type==="full")return new T.SemanticTokens(u.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new T.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const u=(0,P.decodeSemanticTokensDto)(a);if(u.type==="full")return new T.SemanticTokens(u.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,u,E)=>{if(!a)return new T.CompletionList([]);const v=a.suggestions.map(_=>I.CompletionItem.to(_,E));return new T.CompletionList(v,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return I.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,u,E)=>f(v=>new T.CodeLens(I.Range.to(v.range),v.command&&E.fromInternal(v.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>T.Range.isRange(a),a=>T.Selection.isSelection(a)?I.Selection.from(a):I.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,u,E)=>f(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return E.fromInternal(v.command)}else{const _=new T.CodeAction(v.title,v.kind?new T.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=I.WorkspaceEdit.to(v.edit)),v.command&&(_.command=E.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(u=>new T.ColorInformation(I.Range.to(u.range),I.Color.to(u.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof T.Color,I.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:I.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(I.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineHint objects",a=>a.map(I.InlineHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",f(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientMetadata:a.options.transientCellMetadata,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(u=>I.NotebookExclusiveDocumentPattern.to(u))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(I.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void)];class C{constructor(u){this._disposables=new b.DisposableStore,this._commands=u}static register(u){return s.forEach(u.registerApiCommand,u),new C(u).registerCommands()}registerCommands(){const u=E=>(...v)=>E(this._commands,...v);this._register(k.RemoveFromRecentlyOpenedAPICommand.ID,u(k.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:E=>typeof E=="string"}]}),this._register(k.OpenIssueReporter.ID,u(k.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:E=>typeof E=="string"||typeof E=="object"&&typeof E.extensionId=="string"}]})}_register(u,E,v){const _=this._commands.registerCommand(!1,u,E,this,v);this._disposables.add(_)}}e.ExtHostApiCommands=C;function f(a){return u=>{if(Array.isArray(u))return u.map(a)}}function h(a){if(!!Array.isArray(a)){const u=[];for(const E of a)A.isLocationLink(E)?u.push(I.DefinitionLink.to(E)):u.push(I.location.to(E));return u}}}),define(me[232],ge([0,1,16,69,3,6,2,79,28,20,7,5]),function(G,e,b,I,T,A,y,k,D,P,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class f{constructor(l,d,n){this._documents=n,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=l.getProxy(C.MainContext.MainThreadComments),d.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const r=this._commentControllers.get(t.handle);return r||t}else if(t&&t.$mid===7){const r=this._commentControllers.get(t.commentControlHandle);if(!r)return t;const i=r.getCommentThread(t.commentThreadHandle);return i||t}else if(t&&t.$mid===8){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const i=r.getCommentThread(t.thread.commentThreadHandle);return i?{thread:i,text:t.text}:t}else if(t&&t.$mid===9){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const i=r.getCommentThread(t.thread.commentThreadHandle);if(!i)return t;let o=t.commentUniqueId,c=i.getCommentByUniqueId(o);return c||t}else if(t&&t.$mid===10){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const i=r.getCommentThread(t.thread.commentThreadHandle);if(!i)return t;let o=t.text,c=t.commentUniqueId,m=i.getCommentByUniqueId(c);return m?(m.body=o,m):t}return t}})}createCommentController(l,d,n){const t=f.handlePool++,r=new a(l,t,this._proxy,d,n);this._commentControllers.set(r.handle,r);const i=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(l.identifier))||[];return i.push(r),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(l.identifier),i),r}$createCommentThreadTemplate(l,d,n){const t=this._commentControllers.get(l);!t||t.$createCommentThreadTemplate(d,n)}async $updateCommentThreadTemplate(l,d,n){const t=this._commentControllers.get(l);!t||t.$updateCommentThreadTemplate(d,n)}$deleteCommentThread(l,d){const n=this._commentControllers.get(l);n&&n.$deleteCommentThread(d)}$provideCommentingRanges(l,d,n){const t=this._commentControllers.get(l);if(!t||!t.commentingRangeProvider)return Promise.resolve(void 0);const r=this._documents.getDocument(y.URI.revive(d));return(0,b.asPromise)(()=>t.commentingRangeProvider.provideCommentingRanges(r,n)).then(i=>i?i.map(o=>P.Range.from(o)):void 0)}$toggleReaction(l,d,n,t,r){const i=this._commentControllers.get(l);return!i||!i.reactionHandler?Promise.resolve(void 0):(0,b.asPromise)(()=>{const o=i.getCommentThread(d);if(o){const c=o.getCommentByUniqueId(t.uniqueIdInThread);if(i!==void 0&&c&&i.reactionHandler)return i.reactionHandler(c,v(r))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=f,f.handlePool=0;class h{constructor(l,d,n,t,r,i,o){this._proxy=l,this._commentController=d,this._id=n,this._uri=t,this._range=r,this._comments=i,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${d.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,P.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=i}set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){l.isEqual(this._range)||(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const l=n=>Object.prototype.hasOwnProperty.call(this.modifications,n),d={};l("range")&&(d.range=P.Range.from(this._range)),l("label")&&(d.label=this.label),l("contextValue")&&(d.contextValue=this.contextValue),l("comments")&&(d.comments=this._comments.map(n=>u(this,this._commentController,n,this._commentsMap))),l("collapsibleState")&&(d.collapseState=_(this._collapseState)),l("canReply")&&(d.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,d)}}getCommentByUniqueId(l){for(let d of this._commentsMap){let n=d[0],t=d[1];if(l===t)return n}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,je([(0,I.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class a{constructor(l,d,n,t,r){this._extension=l,this._handle=d,this._proxy=n,this._id=t,this._label=r,this._threads=new Map,this._proxy.$registerCommentController(this.handle,t,r)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(l,d,n,t){if(typeof l=="string"){const r=new h(this._proxy,this,l,d,n,t,this._extension.identifier);return this._threads.set(r.handle,r),r}else{const r=new h(this._proxy,this,void 0,l,d,n,this._extension.identifier);return this._threads.set(r.handle,r),r}}$createCommentThreadTemplate(l,d){const n=new h(this._proxy,this,void 0,y.URI.revive(l),P.Range.to(d),[],this._extension.identifier);return n.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(n.handle,n),n}$updateCommentThreadTemplate(l,d){let n=this._threads.get(l);n&&(n.range=P.Range.to(d))}$deleteCommentThread(l){let d=this._threads.get(l);d&&d.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function u(g,l,d,n){let t=n.get(d);t||(t=++g.commentHandle,n.set(d,t));const r=d.author&&d.author.iconPath?d.author.iconPath.toString():void 0;return{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:t,body:P.MarkdownString.from(d.body),userName:d.author.name,userIconPath:r,label:d.label,commentReactions:d.reactions?d.reactions.map(i=>E(i)):void 0}}function E(g){return{label:g.label,iconPath:g.iconPath?P.pathOrURIToURI(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted}}function v(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?y.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1}}function _(g){if(g!==void 0)switch(g){case s.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case s.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}}),define(me[125],ge([0,1,2,5,7,4,14,13,15,10,8]),function(G,e,b,I,T,A,y,k,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class bn{constructor(h,a){this._logService=a,this._provider=new Map,this._proxy=h.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,a){const u=bn._handlePool++;this._provider.set(u,{provider:h,extensionId:a}),this._proxy.$registerDecorationProvider(u,a.value);const E=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(v=>{if(!v){this._proxy.$onDidChange(u,null);return}let _=(0,D.asArray)(v);if(_.length<=bn._maxEventSize){this._proxy.$onDidChange(u,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,_.length);const g=_.map(n=>({uri:n,rank:(0,P.count)(n.path,"/")})),l=(0,D.groupBy)(g,(n,t)=>n.rank-t.rank||(0,P.compare)(n.uri.path,t.uri.path));let d=[];e:for(let n of l){let t;for(let r of n){let i=(0,s.dirname)(r.uri.path);if(t!==i&&(t=i,d.push(r.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(u,d)});return new T.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(h,a,u){if(!this._provider.has(h))return Object.create(null);const E=Object.create(null),{provider:v,extensionId:_}=this._provider.get(h);return await Promise.all(a.map(async g=>{try{const{uri:l,id:d}=g,n=await Promise.resolve(v.provideFileDecoration(b.URI.revive(l),u));if(!n)return;try{T.FileDecoration.validate(n),E[d]=[n.propagate,n.tooltip,n.badge,n.color]}catch(t){this._logService.warn(`INVALID decoration from extension '${_.value}': ${t}`)}}catch(l){this._logService.error(l)}})),E}};C._handlePool=0,C._maxEventSize=250,C=je([Be(0,y.IExtHostRpcService),Be(1,k.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(me[233],ge([0,1,160,113,2,5,7,20,3,13,24]),function(G,e,b,I,T,A,y,k,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(a,u,E,v,_){this._name=a,this._owner=u,this._maxDiagnosticsPerFile=E,this._proxy=v,this._onDidChangeDiagnostics=_,this._isDisposed=!1,this._data=new s.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,u){if(!a){this.clear();return}this._checkDisposed();let E=[];if(T.URI.isUri(a)){if(!u){this.delete(a);return}this._data.set(a,u.slice()),E=[a]}else if(Array.isArray(a)){E=[];let _;a=[...a].sort(C._compareIndexedTuplesByUri);for(const g of a){const[l,d]=g;if((!_||l.toString()!==_.toString())&&(_&&this._data.get(_).length===0&&this._data.delete(_),_=l,E.push(l),this._data.set(l,[])),d){const n=this._data.get(l);n&&n.push(...d)}else{const n=this._data.get(l);n&&(n.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!!this._proxy){const v=[];for(let _ of E){let g=[];const l=this._data.get(_);if(l)if(l.length>this._maxDiagnosticsPerFile){g=[];const d=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(let t of l)if(t.severity===d[n]&&g.push(k.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;g.push({severity:I.MarkerSeverity.Info,message:(0,b.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=l.map(d=>k.Diagnostic.from(d));v.push([_,g])}this._proxy.$changeMany(this._owner,v)}}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,u){this._checkDisposed();for(let E of this._data.keys())a.apply(u,[E,this.get(E),this])}get(a){this._checkDisposed();const u=this._data.get(a);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,u){return a[0].toString()<u[0].toString()?-1:a[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=C;let f=class zt{constructor(a,u){this._logService=u,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,zt._debouncer,50),zt._mapper),this._proxy=a.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(a,u){return a?a.concat(u):u}static _mapper(a){const u=[],E=new Set;for(const v of a)typeof v=="string"?E.has(v)||(E.add(v),u.push(T.URI.parse(v))):E.has(v.toString())||(E.add(v.toString()),u.push(v));return Object.freeze(u),{uris:u}}createDiagnosticCollection(a,u){const{_collections:E,_proxy:v,_onDidChangeDiagnostics:_,_logService:g}=this,l=new class{$changeMany(t,r){v.$changeMany(t,r),g.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,t,r.length===0?"CLEARING":r)}$clear(t){v.$clear(t),g.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,t)}dispose(){v.dispose()}};let d;if(!u)u="_generated_diagnostic_collection_name_#"+zt._idPool++,d=u;else if(!E.has(u))d=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do d=u+zt._idPool++;while(E.has(d))}return new class extends C{constructor(){super(u,d,zt._maxDiagnosticsPerFile,l,_);E.set(d,this)}dispose(){super.dispose(),E.delete(d)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const u=new Map,E=[];for(const v of this._collections.values())v.forEach((_,g)=>{let l=u.get(_.toString());typeof l=="undefined"&&(l=E.length,u.set(_.toString(),l),E.push([_,[]])),E[l][1]=E[l][1].concat(...g)});return E}}_getDiagnostics(a){let u=[];for(let E of this._collections.values())E.has(a)&&(u=u.concat(E.get(a)));return u}$acceptMarkersChange(a){if(!this._mirrorCollection){const u="_generated_mirror",E=new C(u,u,zt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(u,E),this._mirrorCollection=E}for(const[u,E]of a)this._mirrorCollection.set(T.URI.revive(u),E.map(k.Diagnostic.to))}};f._idPool=0,f._maxDiagnosticsPerFile=1e3,f=je([Be(1,P.ILogService)],f),e.ExtHostDiagnostics=f}),define(me[234],ge([0,1,2,5]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(y){this._proxy=y.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(k=>k?k.map(D=>b.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(k=>k?b.URI.revive(k):void 0)}}e.ExtHostDialogs=T}),define(me[235],ge([0,1,19,2,7,5,11,21,10]),function(G,e,b,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(C,f,h){this._documentsAndEditors=f,this._logService=h,this._documentContentProviders=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,f){if(Object.keys(y.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const h=P._handlePool++;this._documentContentProviders.set(h,f),this._proxy.$registerTextContentProvider(h,C);let a;return typeof f.onDidChange=="function"&&(a=f.onDidChange(u=>{if(u.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(h,u).then(E=>{if(!(!E&&typeof E!="string")){const v=this._documentsAndEditors.getDocument(u);if(!!v){const _=(0,D.splitLines)(E);if(!v.equalLines(_))return this._proxy.$onVirtualDocumentChange(u,E)}}},b.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(C,f){const h=this._documentContentProviders.get(C);return h?Promise.resolve(h.provideTextDocumentContent(I.URI.revive(f),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(me[236],ge([0,1,3,6,2,5,119,20,12,23]),function(G,e,b,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class s{constructor(f,h){this._onDidAddDocument=new b.Emitter,this._onDidRemoveDocument=new b.Emitter,this._onDidChangeDocument=new b.Emitter,this._onDidSaveDocument=new b.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const u of a)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const u of a)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!!f){const h=this._documentsAndEditors.getDocument(f);if(h)return h}}getDocument(f){const h=this.getDocumentData(f);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${f}'`);return h.document}ensureDocumentData(f){const h=this._documentsAndEditors.getDocument(f);if(h)return Promise.resolve(h);let a=this._documentLoader.get(f.toString());return a||(a=this._proxy.$tryOpenDocument(f).then(u=>{this._documentLoader.delete(f.toString());const E=T.URI.revive(u);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(E))},u=>(this._documentLoader.delete(f.toString()),Promise.reject(u))),this._documentLoader.set(f.toString(),a)),a}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(h=>T.URI.revive(h))}$acceptModelModeChanged(f,h){const a=T.URI.revive(f),u=this._documentsAndEditors.getDocument(a);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(h),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(f){const h=T.URI.revive(f),a=this._documentsAndEditors.getDocument(h);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(f,h){const a=T.URI.revive(f),u=this._documentsAndEditors.getDocument(a);if(!u)throw new Error("unknown document");u._acceptIsDirty(h),this._onDidChangeDocument.fire({document:u.document,contentChanges:[]})}$acceptModelChanged(f,h,a){const u=T.URI.revive(f),E=this._documentsAndEditors.getDocument(u);if(!E)throw new Error("unknown document");E._acceptIsDirty(a),E.onEvents(h),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:E.document,contentChanges:h.changes.map(v=>({range:k.Range.to(v.range),rangeOffset:v.rangeOffset,rangeLength:v.rangeLength,text:v.text}))}))}setWordDefinitionFor(f,h){(0,y.setWordDefinitionFor)(f,h)}}e.ExtHostDocuments=s}),define(me[39],ge([0,1,52,3,6,2,4,5,119,14,123,20,13,24,11,54,134]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class v{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(l,d){this._extHostRpc=l,this._logService=d,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const d=[],n=[],t=[];if(l.removedDocuments)for(const r of l.removedDocuments){const i=A.URI.revive(r),o=this._documents.get(i);(o==null?void 0:o.unref())&&(this._documents.delete(i),d.push(o.value))}if(l.addedDocuments)for(const r of l.addedDocuments){const i=A.URI.revive(r.uri);let o=this._documents.get(i);if(o&&i.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${i} already exists!'`);o||(o=new v(new D.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(i,o),n.push(o.value)),o.ref()}if(l.removedEditors)for(const r of l.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&t.push(i)}if(l.addedEditors)for(const r of l.addedEditors){const i=A.URI.revive(r.documentUri);b.ok(this._documents.has(i),`document '${i}' does not exist`),b.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const o=this._documents.get(i).value,c=new s.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>o.document),r.selections.map(C.Selection.to),r.options,r.visibleRanges.map(m=>C.Range.to(m)),typeof r.editorPosition=="number"?C.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,c)}l.newActiveEditor!==void 0&&(b.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,T.dispose)(d),(0,T.dispose)(t),l.removedDocuments&&this._onDidRemoveDocuments.fire(d),l.addedDocuments&&this._onDidAddDocuments.fire(n),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){var d;return(d=this._documents.get(l))===null||d===void 0?void 0:d.value}allDocuments(){return u.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!!this._activeEditorId){const d=this._editors.get(this._activeEditorId);return l?d:d==null?void 0:d.value}}allEditors(){return[...this._editors.values()]}};_=je([Be(0,P.IExtHostRpcService),Be(1,f.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[237],ge([0,1,2,5,6,7,20,142,10,22]),function(G,e,b,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class s{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const a=this._schemes.indexOf(h);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),a=[];let u,E,v=14,_=14;for(const g of h){let l=u?(0,D.commonPrefixLength)(u,g):0;for(l===0?E=1:E=_;l<g.length;l++)l+1===g.length?(v=_,_=9):_+=1,a.push([E,g.toUpperCase().charCodeAt(l),_]),a.push([E,g.toLowerCase().charCodeAt(l),_]),E=_;u=g,_=v}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new k.StateMachine(a)}}provideDocumentLinks(h){this._initStateMachine();const a=[],u=k.LinkComputer.computeLinks({getLineContent(E){return h.lineAt(E-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const E of u){const v=y.DocumentLink.to(E);v.target&&a.push(v)}return a}}class C{constructor(h,a){this._extHostLanguageFeatures=a,this._linkProvider=new s,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,a,u,E={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const v=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(v,u);let _=2;E.isCaseSensitive&&(_+=1024),E.isReadonly&&(_+=2048),typeof u.copy=="function"&&(_+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(_+=4),this._proxy.$registerFileSystemProvider(v,a,_).catch(l=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${a}`),console.error(l)});const g=u.onDidChangeFile(l=>{const d=[];for(const n of l){let{uri:t,type:r}=n;if(t.scheme===a){let i;switch(r){case A.FileChangeType.Changed:i=0;break;case A.FileChangeType.Created:i=1;break;case A.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:t,type:i})}}this._proxy.$onFileSystemChange(v,d)});return(0,T.toDisposable)(()=>{g.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(h){const{type:a,ctime:u,mtime:E,size:v}=h;return{type:a,ctime:u,mtime:E,size:v}}$stat(h,a){return Promise.resolve(this._getFsProvider(h).stat(b.URI.revive(a))).then(C._asIStat)}$readdir(h,a){return Promise.resolve(this._getFsProvider(h).readDirectory(b.URI.revive(a)))}$readFile(h,a){return Promise.resolve(this._getFsProvider(h).readFile(b.URI.revive(a))).then(u=>P.VSBuffer.wrap(u))}$writeFile(h,a,u,E){return Promise.resolve(this._getFsProvider(h).writeFile(b.URI.revive(a),u.buffer,E))}$delete(h,a,u){return Promise.resolve(this._getFsProvider(h).delete(b.URI.revive(a),u))}$rename(h,a,u,E){return Promise.resolve(this._getFsProvider(h).rename(b.URI.revive(a),b.URI.revive(u),E))}$copy(h,a,u,E){const v=this._getFsProvider(h);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(b.URI.revive(a),b.URI.revive(u),E))}$mkdir(h,a){return Promise.resolve(this._getFsProvider(h).createDirectory(b.URI.revive(a)))}$watch(h,a,u,E){const v=this._getFsProvider(h).watch(b.URI.revive(u),E);this._watches.set(a,v)}$unwatch(h,a){const u=this._watches.get(a);u&&(u.dispose(),this._watches.delete(a))}$open(h,a,u){const E=this._getFsProvider(h);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(b.URI.revive(a),u))}$close(h,a){const u=this._getFsProvider(h);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(a))}$read(h,a,u,E){const v=this._getFsProvider(h);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const _=P.VSBuffer.alloc(E);return Promise.resolve(v.read(a,u,_.buffer,0,E)).then(g=>_.slice(0,g))}$write(h,a,u,E){const v=this._getFsProvider(h);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(a,u,E.buffer,0,E.byteLength))}_getFsProvider(h){const a=this._fsProvider.get(h);if(!a){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return a}}e.ExtHostFileSystem=C}),define(me[90],ge([0,1,5,45,7,22,4,14,61]),function(G,e,b,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Mt{constructor(C,f){const h=C.getProxy(b.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return h.$stat(a).catch(Mt._handleError)},readDirectory(a){return h.$readdir(a).catch(Mt._handleError)},createDirectory(a){return h.$mkdir(a).catch(Mt._handleError)},async readFile(a){return h.$readFile(a).then(u=>u.buffer).catch(Mt._handleError)},writeFile(a,u){return h.$writeFile(a,A.VSBuffer.wrap(u)).catch(Mt._handleError)},delete(a,u){return h.$delete(a,Object.assign({recursive:!1,useTrash:!1},u)).catch(Mt._handleError)},rename(a,u,E){return h.$rename(a,u,Object.assign({overwrite:!1},E)).catch(Mt._handleError)},copy(a,u,E){return h.$copy(a,u,Object.assign({overwrite:!1},E)).catch(Mt._handleError)},isWritableFileSystem(a){const u=f.getCapabilities(a);if(typeof u=="number")return!(u&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new T.FileSystemError(String(C));if(C.name==="ENOPRO")throw T.FileSystemError.Unavailable(C.message);switch(C.name){case I.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(C.message);case I.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(C.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(C.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(C.message);case I.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(C.message);case I.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(C.message);default:throw new T.FileSystemError(C.message,C.name)}}};P=je([Be(0,k.IExtHostRpcService),Be(1,D.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(me[238],ge([0,1,6,5]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(y){this._handlePool=0,this._proxy=y.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,y),(0,b.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=T}),define(me[239],ge([0,1,2,23,20,7,16,5,10,44,15,12,139,6,109,71,85,47,19]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class g{constructor(V,J){this._documents=V,this._provider=J}provideDocumentSymbols(V,J){const ee=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ee,J)).then(ae=>{if(!(0,s.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(T.DocumentSymbol.from):g._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(V){var J;V=V.slice(0).sort((we,Ce)=>{let Oe=we.location.range.start.compareTo(Ce.location.range.start);return Oe===0&&(Oe=Ce.location.range.end.compareTo(we.location.range.end)),Oe});const ee=[],ae=[];for(const we of V){const Ce={name:we.name||"!!MISSING: name!!",kind:T.SymbolKind.from(we.kind),tags:((J=we.tags)===null||J===void 0?void 0:J.map(T.SymbolTag.from))||[],detail:"",containerName:we.containerName,range:T.Range.from(we.location.range),selectionRange:T.Range.from(we.location.range),children:[]};for(;;){if(ae.length===0){ae.push(Ce),ee.push(Ce);break}const Oe=ae[ae.length-1];if(P.Range.containsRange(Oe.range,Ce.range)&&!P.Range.equalsRange(Oe.range,Ce.range)){Oe.children&&Oe.children.push(Ce),ae.push(Ce);break}ae.pop()}}return ee}}class l{constructor(V,J,ee){this._documents=V,this._commands=J,this._provider=ee,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,J){const ee=this._documents.getDocument(V),ae=await this._provider.provideCodeLenses(ee,J);if(!(!ae||J.isCancellationRequested)){const we=this._cache.add(ae),Ce=new h.DisposableStore;this._disposables.set(we,Ce);const Oe={cacheId:we,lenses:[]};for(let be=0;be<ae.length;be++)Oe.lenses.push({cacheId:[we,be],range:T.Range.from(ae[be].range),command:this._commands.toInternal(ae[be].command,Ce)});return Oe}}async resolveCodeLens(V,J){var ee;const ae=V.cacheId&&this._cache.get(...V.cacheId);if(!!ae){let we;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?we=ae:we=await this._provider.resolveCodeLens(ae,J),we||(we=ae),!J.isCancellationRequested){const Ce=V.cacheId&&this._disposables.get(V.cacheId[0]);if(!!Ce)return V.command=this._commands.toInternal((ee=we.command)!==null&&ee!==void 0?ee:l._badCmd,Ce),V}}}releaseCodeLenses(V){var J;(J=this._disposables.get(V))===null||J===void 0||J.dispose(),this._disposables.delete(V),this._cache.delete(V)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function d(Le){return Array.isArray(Le)?Le.map(T.DefinitionLink.from):Le?[T.DefinitionLink.from(Le)]:[]}class n{constructor(V,J){this._documents=V,this._provider=J}provideDefinition(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideDefinition(ae,we,ee)).then(d)}}class t{constructor(V,J){this._documents=V,this._provider=J}provideDeclaration(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideDeclaration(ae,we,ee)).then(d)}}class r{constructor(V,J){this._documents=V,this._provider=J}provideImplementation(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideImplementation(ae,we,ee)).then(d)}}class i{constructor(V,J){this._documents=V,this._provider=J}provideTypeDefinition(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(ae,we,ee)).then(d)}}class o{constructor(V,J){this._documents=V,this._provider=J}provideHover(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideHover(ae,we,ee)).then(Ce=>{if(!(!Ce||(0,s.isFalsyOrEmpty)(Ce.contents)))return Ce.range||(Ce.range=ae.getWordRangeAtPosition(we)),Ce.range||(Ce.range=new A.Range(we,we)),T.Hover.from(Ce)})}}class c{constructor(V,J){this._documents=V,this._provider=J}provideEvaluatableExpression(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,we,ee)).then(Ce=>{if(Ce)return T.EvaluatableExpression.from(Ce)})}}class m{constructor(V,J){this._documents=V,this._provider=J}provideInlineValues(V,J,ee,ae){const we=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideInlineValues(we,T.Range.to(J),T.InlineValueContext.to(ee),ae)).then(Ce=>{if(Array.isArray(Ce))return Ce.map(Oe=>T.InlineValue.from(Oe))})}}class S{constructor(V,J){this._documents=V,this._provider=J}provideDocumentHighlights(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(ae,we,ee)).then(Ce=>{if(Array.isArray(Ce))return Ce.map(T.DocumentHighlight.from)})}}class p{constructor(V,J){this._documents=V,this._provider=J}provideLinkedEditingRanges(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,we,ee)).then(Ce=>{if(Ce&&Array.isArray(Ce.ranges))return{ranges:(0,s.coalesce)(Ce.ranges.map(T.Range.from)),wordPattern:Ce.wordPattern}})}}class w{constructor(V,J){this._documents=V,this._provider=J}provideReferences(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=T.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideReferences(we,Ce,ee,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.location.from)})}}class R{constructor(V,J,ee,ae,we,Ce,Oe){this._documents=V,this._commands=J,this._diagnostics=ee,this._provider=ae,this._logService=we,this._extension=Ce,this._apiDeprecation=Oe,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=f.Selection.isISelection(J)?T.Selection.to(J):T.Range.to(J),Oe=[];for(const Pe of this._diagnostics.getDiagnostics(V))if(Ce.intersection(Pe.range)&&Oe.push(Pe)>R._maxCodeActionsPerFile)break;const be={diagnostics:Oe,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:T.CodeActionTriggerKind.to(ee.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(we,Ce,be,ae)).then(Pe=>{var Re;if(!(!(0,s.isNonEmptyArray)(Pe)||ae.isCancellationRequested)){const We=this._cache.add(Pe),Ee=new h.DisposableStore;this._disposables.set(We,Ee);const Ke=[];for(let X=0;X<Pe.length;X++){const ie=Pe[X];!ie||(R._isCommand(ie)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:ie.title,command:this._commands.toInternal(ie,Ee)})):(be.only&&(ie.kind?be.only.contains(ie.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[We,X],title:ie.title,command:ie.command&&this._commands.toInternal(ie.command,Ee),diagnostics:ie.diagnostics&&ie.diagnostics.map(T.Diagnostic.from),edit:ie.edit&&T.WorkspaceEdit.from(ie.edit),kind:ie.kind&&ie.kind.value,isPreferred:ie.isPreferred,disabled:(Re=ie.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:We,actions:Ke}}})}async resolveCodeAction(V,J){var ee;const[ae,we]=V,Ce=this._cache.get(ae,we);if(!(!Ce||R._isCommand(Ce))&&!!this._provider.resolveCodeAction){const Oe=(ee=await this._provider.resolveCodeAction(Ce,J))!==null&&ee!==void 0?ee:Ce;return(Oe==null?void 0:Oe.edit)?T.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(V){var J;(J=this._disposables.get(V))===null||J===void 0||J.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}R._maxCodeActionsPerFile=1e3;class F{constructor(V,J){this._documents=V,this._provider=J}provideDocumentFormattingEdits(V,J,ee){const ae=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,J,ee)).then(we=>{if(Array.isArray(we))return we.map(T.TextEdit.from)})}}class z{constructor(V,J){this._documents=V,this._provider=J}provideDocumentRangeFormattingEdits(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=T.Range.to(J);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(we,Ce,ee,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.TextEdit.from)})}}class oe{constructor(V,J){this._documents=V,this._provider=J,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(V,J,ee,ae,we){const Ce=this._documents.getDocument(V),Oe=T.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Ce,Oe,ee,ae,we)).then(be=>{if(Array.isArray(be))return be.map(T.TextEdit.from)})}}class j{constructor(V,J){this._provider=V,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(V,J){const ee=k.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(V,J)).then(ae=>{if((0,s.isNonEmptyArray)(ae)){for(const we of ae)if(!!we){if(!we.name){this._logService.warn("INVALID SymbolInformation, lacks name",we);continue}const Ce=k.IdObject.mixin(T.WorkspaceSymbol.from(we));this._symbolCache.set(Ce._id,we),ee.symbols.push(Ce)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(V,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return V;const ee=this._symbolCache.get(V._id);if(ee){const ae=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,J));return ae&&(0,I.mixin)(V,T.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(V){const J=this._resultCache.get(V);if(J){for(let[ee,ae]=J;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(V)}}}class W{constructor(V,J,ee){this._documents=V,this._provider=J,this._logService=ee}static supportsResolving(V){return typeof V.prepareRename=="function"}provideRenameEdits(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=T.Position.to(J);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(we,Ce,ee,ae)).then(Oe=>{if(!!Oe)return T.WorkspaceEdit.from(Oe)},Oe=>{const be=W._asMessage(Oe);return be?{rejectReason:be,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(V,J,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,y.asPromise)(()=>this._provider.prepareRename(ae,we,ee)).then(Ce=>{let Oe,be;if(A.Range.isRange(Ce)?(Oe=Ce,be=ae.getText(Ce)):(0,C.isObject)(Ce)&&(Oe=Ce.range,be=Ce.placeholder),!!Oe){if(Oe.start.line>we.line||Oe.end.line<we.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Oe),text:be}}},Ce=>{const Oe=W._asMessage(Ce);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(Ce)})}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ${constructor(V,J){this.resultId=V,this.tokens=J}}class U{constructor(V,J){this._documents=V,this._provider=J,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(V,J,ee){const ae=this._documents.getDocument(V),we=J!==0?this._previousResults.get(J):null;return(0,y.asPromise)(()=>we&&typeof we.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,we.resultId,ee):this._provider.provideDocumentSemanticTokens(ae,ee)).then(Ce=>(we&&this._previousResults.delete(J),Ce?(Ce=U._fixProvidedSemanticTokens(Ce),this._send(U._convertToEdits(we,Ce),Ce)):null))}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return U._isSemanticTokens(V)?U._isCorrectSemanticTokens(V)?V:new A.SemanticTokens(new Uint32Array(V.data),V.resultId):U._isSemanticTokensEdits(V)?U._isCorrectSemanticTokensEdits(V)?V:new A.SemanticTokensEdits(V.edits.map(J=>new A.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const J of V.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,J){if(!U._isSemanticTokens(J)||!V||!V.tokens)return J;const ee=V.tokens,ae=ee.length,we=J.data,Ce=we.length;let Oe=0;const be=Math.min(ae,Ce);for(;Oe<be&&ee[Oe]===we[Oe];)Oe++;if(Oe===ae&&Oe===Ce)return new A.SemanticTokensEdits([],J.resultId);let Pe=0;const Re=be-Oe;for(;Pe<Re&&ee[ae-Pe-1]===we[Ce-Pe-1];)Pe++;return new A.SemanticTokensEdits([{start:Oe,deleteCount:ae-Oe-Pe,data:we.subarray(Oe,Ce-Pe)}],J.resultId)}_send(V,J){if(U._isSemanticTokens(V)){const ee=this._nextResultId++;return this._previousResults.set(ee,new $(V.resultId,V.data)),(0,a.encodeSemanticTokensDto)({id:ee,type:"full",data:V.data})}if(U._isSemanticTokensEdits(V)){const ee=this._nextResultId++;return U._isSemanticTokens(J)?this._previousResults.set(ee,new $(J.resultId,J.data)):this._previousResults.set(ee,new $(V.resultId)),(0,a.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(V.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class M{constructor(V,J){this._documents=V,this._provider=J}provideDocumentRangeSemanticTokens(V,J,ee){const ae=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,T.Range.to(J),ee)).then(we=>we?this._send(we):null)}_send(V){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:V.data})}}e.DocumentRangeSemanticTokensAdapter=M;class L{constructor(V,J,ee,ae,we){this._documents=V,this._commands=J,this._provider=ee,this._apiDeprecation=ae,this._extension=we,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}async provideCompletionItems(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=T.Position.to(J),Oe=we.getWordRangeAtPosition(Ce)||new A.Range(Ce,Ce),be=Oe.with({end:Ce}),Pe=new v.StopWatch(!0),Re=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(we,Ce,ae,T.CompletionContext.to(ee)));if(!!Re&&!ae.isCancellationRequested){const We=Array.isArray(Re)?new A.CompletionList(Re):Re,Ee=L.supportsResolving(this._provider)?this._cache.add(We.items):this._cache.add([]),Ke=new h.DisposableStore;this._disposables.set(Ee,Ke);const X=[],ie={x:Ee,b:X,a:{replace:T.Range.from(Oe),insert:T.Range.from(be)},c:We.isIncomplete||void 0,d:Pe.elapsed()};for(let _e=0;_e<We.items.length;_e++){const xe=We.items[_e],ze=this._convertCompletionItem(xe,[Ee,_e],be,Oe);X.push(ze)}return ie}}async resolveCompletionItem(V,J){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...V);if(!!ee){const ae=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ee,J));if(!!ae)return this._convertCompletionItem(ae,V)}}}releaseCompletionItems(V){var J;(J=this._disposables.get(V))===null||J===void 0||J.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,J,ee,ae){var we;const Ce=this._disposables.get(J[0]);if(!Ce)throw Error("DisposableStore is missing...");const Oe={x:J,a:(we=V.label)!==null&&we!==void 0?we:"",o:V.label2,b:V.kind!==void 0?T.CompletionItemKind.from(V.kind):void 0,n:V.tags&&V.tags.map(T.CompletionItemTag.from),c:V.detail,d:typeof V.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters,l:V.additionalTextEdits&&V.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(V.command,Ce)};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=V.textEdit.newText):typeof V.insertText=="string"?Oe.h=V.insertText:V.insertText instanceof A.SnippetString&&(Oe.h=V.insertText.value,Oe.i|=4);let be;return V.textEdit?be=V.textEdit.range:V.range&&(be=V.range),A.Range.isRange(be)?Oe.j=T.Range.from(be):be&&(!(ee==null?void 0:ee.isEqual(be.inserting))||!(ae==null?void 0:ae.isEqual(be.replacing)))&&(Oe.j={insert:T.Range.from(be.inserting),replace:T.Range.from(be.replacing)}),Oe}}class N{constructor(V,J){this._documents=V,this._provider=J,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=T.Position.to(J),Oe=this.reviveContext(ee);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(we,Ce,ae,Oe)).then(be=>{if(be){const Pe=this._cache.add([be]);return Object.assign(Object.assign({},T.SignatureHelp.from(be)),{id:Pe})}})}reviveContext(V){let J;if(V.activeSignatureHelp){const ee=T.SignatureHelp.to(V.activeSignatureHelp),ae=this._cache.get(V.activeSignatureHelp.id,0);ae?(J=ae,J.activeSignature=ee.activeSignature,J.activeParameter=ee.activeParameter):J=ee}return Object.assign(Object.assign({},V),{activeSignatureHelp:J})}releaseSignatureHelp(V){this._cache.delete(V)}}class O{constructor(V,J){this._documents=V,this._provider=J}provideInlineHints(V,J,ee){const ae=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideInlineHints(ae,T.Range.to(J),ee)).then(we=>we?{hints:we.map(T.InlineHint.from)}:void 0)}}class B{constructor(V,J){this._documents=V,this._provider=J,this._cache=new E.Cache("DocumentLink")}provideLinks(V,J){const ee=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ee,J)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(T.DocumentLink.from)};{const we=this._cache.add(ae),Ce={links:[],id:we};for(let Oe=0;Oe<ae.length;Oe++){const be=T.DocumentLink.from(ae[Oe]);be.cacheId=[we,Oe],Ce.links.push(be)}return Ce}}})}resolveLink(V,J){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...V);return ee?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ee,J)).then(ae=>ae&&T.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(V){this._cache.delete(V)}}class q{constructor(V,J){this._documents=V,this._provider=J}provideColors(V,J){const ee=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ee,J)).then(ae=>Array.isArray(ae)?ae.map(Ce=>({color:T.Color.from(Ce.color),range:T.Range.from(Ce.range)})):[])}provideColorPresentations(V,J,ee){const ae=this._documents.getDocument(V),we=T.Range.to(J.range),Ce=T.Color.to(J.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(Ce,{document:ae,range:we},ee)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(T.ColorPresentation.from)})}}class Q{constructor(V,J){this._documents=V,this._provider=J}provideFoldingRanges(V,J,ee){const ae=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(ae,J,ee)).then(we=>{if(!!Array.isArray(we))return we.map(T.FoldingRange.from)})}}class he{constructor(V,J,ee){this._documents=V,this._provider=J,this._logService=ee}provideSelectionRanges(V,J,ee){const ae=this._documents.getDocument(V),we=J.map(T.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(ae,we,ee)).then(Ce=>{if(!(0,s.isNonEmptyArray)(Ce))return[];if(Ce.length!==we.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let be=0;be<we.length;be++){const Pe=[];Oe.push(Pe);let Re=we[be],We=Ce[be];for(;;){if(!We.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(T.SelectionRange.from(We)),!We.parent)break;Re=We.range,We=We.parent}}return Oe})}}class ve{constructor(V,J){this._documents=V,this._provider=J,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J),Ce=await this._provider.prepareCallHierarchy(ae,we,ee);if(!!Ce){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(Ce)?Ce.map(be=>this._cacheAndConvertItem(Oe,be)):[this._cacheAndConvertItem(Oe,Ce)]}}async provideCallsTo(V,J,ee){const ae=this._itemFromCache(V,J);if(!ae)throw new Error("missing call hierarchy item");const we=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!we)return we.map(Ce=>({from:this._cacheAndConvertItem(V,Ce.from),fromRanges:Ce.fromRanges.map(Oe=>T.Range.from(Oe))}))}async provideCallsFrom(V,J,ee){const ae=this._itemFromCache(V,J);if(!ae)throw new Error("missing call hierarchy item");const we=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!we)return we.map(Ce=>({to:this._cacheAndConvertItem(V,Ce.to),fromRanges:Ce.fromRanges.map(Oe=>T.Range.from(Oe))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,J){var ee;const ae=this._cache.get(V),we={_sessionId:V,_itemId:ae.size.toString(36),name:J.name,detail:J.detail,kind:T.SymbolKind.from(J.kind),uri:J.uri,range:T.Range.from(J.range),selectionRange:T.Range.from(J.selectionRange),tags:(ee=J.tags)===null||ee===void 0?void 0:ee.map(T.SymbolTag.from)};return ae.set(we._itemId,J),we}_itemFromCache(V,J){const ee=this._cache.get(V);return ee==null?void 0:ee.get(J)}}class Ie{constructor(V,J){this.adapter=V,this.extension=J}}class ke{constructor(V,J,ee,ae,we,Ce,Oe){this._adapter=new Map,this._uriTransformer=J,this._proxy=V.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=we,this._logService=Ce,this._apiDeprecation=Oe}_transformDocumentSelector(V){return(0,s.coalesce)((0,s.asArray)(V).map(J=>this._doTransformDocumentSelector(J)))}_doTransformDocumentSelector(V){if(typeof V=="string")return{$serialized:!0,language:V};if(V)return{$serialized:!0,language:V.language,scheme:this._transformScheme(V.scheme),pattern:typeof V.pattern=="undefined"?void 0:T.GlobPattern.from(V.pattern),exclusive:V.exclusive}}_transformScheme(V){return this._uriTransformer&&typeof V=="string"?this._uriTransformer.transformOutgoingScheme(V):V}_createDisposable(V){return new A.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return ke._handlePool++}_withAdapter(V,J,ee,ae,we=!1){const Ce=this._adapter.get(V);if(!Ce)return Promise.resolve(ae);if(Ce.adapter instanceof J){let Oe;Ce.extension&&(Oe=Date.now(),this._logService.trace(`[${Ce.extension.identifier.value}] INVOKE provider '${J.name}'`));const be=ee(Ce.adapter,Ce.extension),Pe=Ce.extension;return Pe&&Promise.resolve(be).then(()=>this._logService.trace(`[${Pe.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Re=>{we&&Re instanceof _.CancellationError||(this._logService.error(`[${Pe.identifier.value}] provider FAILED`),this._logService.error(Re))}),be}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(V,J){const ee=this._nextHandle();return this._adapter.set(ee,new Ie(V,J)),ee}static _extLabel(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,J,ee,ae){const we=this._addNewAdapter(new g(this._documents,ee),V),Ce=ae&&ae.label||ke._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(we,this._transformDocumentSelector(J),Ce),this._createDisposable(we)}$provideDocumentSymbols(V,J,ee){return this._withAdapter(V,g,ae=>ae.provideDocumentSymbols(b.URI.revive(J),ee),void 0)}registerCodeLensProvider(V,J,ee){const ae=this._nextHandle(),we=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ie(new l(this._documents,this._commands.converter,ee),V)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(J),we);let Ce=this._createDisposable(ae);if(we!==void 0){const Oe=ee.onDidChangeCodeLenses(be=>this._proxy.$emitCodeLensEvent(we));Ce=A.Disposable.from(Ce,Oe)}return Ce}$provideCodeLenses(V,J,ee){return this._withAdapter(V,l,ae=>ae.provideCodeLenses(b.URI.revive(J),ee),void 0)}$resolveCodeLens(V,J,ee){return this._withAdapter(V,l,ae=>ae.resolveCodeLens(J,ee),void 0)}$releaseCodeLenses(V,J){this._withAdapter(V,l,ee=>Promise.resolve(ee.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(V,J,ee){const ae=this._addNewAdapter(new n(this._documents,ee),V);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDefinition(V,J,ee,ae){return this._withAdapter(V,n,we=>we.provideDefinition(b.URI.revive(J),ee,ae),[])}registerDeclarationProvider(V,J,ee){const ae=this._addNewAdapter(new t(this._documents,ee),V);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDeclaration(V,J,ee,ae){return this._withAdapter(V,t,we=>we.provideDeclaration(b.URI.revive(J),ee,ae),[])}registerImplementationProvider(V,J,ee){const ae=this._addNewAdapter(new r(this._documents,ee),V);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideImplementation(V,J,ee,ae){return this._withAdapter(V,r,we=>we.provideImplementation(b.URI.revive(J),ee,ae),[])}registerTypeDefinitionProvider(V,J,ee){const ae=this._addNewAdapter(new i(this._documents,ee),V);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideTypeDefinition(V,J,ee,ae){return this._withAdapter(V,i,we=>we.provideTypeDefinition(b.URI.revive(J),ee,ae),[])}registerHoverProvider(V,J,ee,ae){const we=this._addNewAdapter(new o(this._documents,ee),V);return this._proxy.$registerHoverProvider(we,this._transformDocumentSelector(J)),this._createDisposable(we)}$provideHover(V,J,ee,ae){return this._withAdapter(V,o,we=>we.provideHover(b.URI.revive(J),ee,ae),void 0)}registerEvaluatableExpressionProvider(V,J,ee,ae){const we=this._addNewAdapter(new c(this._documents,ee),V);return this._proxy.$registerEvaluatableExpressionProvider(we,this._transformDocumentSelector(J)),this._createDisposable(we)}$provideEvaluatableExpression(V,J,ee,ae){return this._withAdapter(V,c,we=>we.provideEvaluatableExpression(b.URI.revive(J),ee,ae),void 0)}registerInlineValuesProvider(V,J,ee,ae){const we=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ce=this._addNewAdapter(new m(this._documents,ee),V);this._proxy.$registerInlineValuesProvider(Ce,this._transformDocumentSelector(J),we);let Oe=this._createDisposable(Ce);if(we!==void 0){const be=ee.onDidChangeInlineValues(Pe=>this._proxy.$emitInlineValuesEvent(we));Oe=A.Disposable.from(Oe,be)}return Oe}$provideInlineValues(V,J,ee,ae,we){return this._withAdapter(V,m,Ce=>Ce.provideInlineValues(b.URI.revive(J),ee,ae,we),void 0)}registerDocumentHighlightProvider(V,J,ee){const ae=this._addNewAdapter(new S(this._documents,ee),V);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentHighlights(V,J,ee,ae){return this._withAdapter(V,S,we=>we.provideDocumentHighlights(b.URI.revive(J),ee,ae),void 0)}registerLinkedEditingRangeProvider(V,J,ee){const ae=this._addNewAdapter(new p(this._documents,ee),V);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideLinkedEditingRanges(V,J,ee,ae){return this._withAdapter(V,p,async we=>{const Ce=await we.provideLinkedEditingRanges(b.URI.revive(J),ee,ae);if(Ce)return{ranges:Ce.ranges,wordPattern:Ce.wordPattern?ke._serializeRegExp(Ce.wordPattern):void 0}},void 0)}registerReferenceProvider(V,J,ee){const ae=this._addNewAdapter(new w(this._documents,ee),V);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideReferences(V,J,ee,ae,we){return this._withAdapter(V,w,Ce=>Ce.provideReferences(b.URI.revive(J),ee,ae,we),void 0)}registerCodeActionProvider(V,J,ee,ae){var we,Ce;const Oe=new h.DisposableStore,be=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerQuickFixSupport(be,this._transformDocumentSelector(J),{providedKinds:(we=ae==null?void 0:ae.providedCodeActionKinds)===null||we===void 0?void 0:we.map(Pe=>Pe.value),documentation:(Ce=ae==null?void 0:ae.documentation)===null||Ce===void 0?void 0:Ce.map(Pe=>({kind:Pe.kind.value,command:this._commands.converter.toInternal(Pe.command,Oe)}))},ke._extLabel(V),Boolean(ee.resolveCodeAction)),Oe.add(this._createDisposable(be)),Oe}$provideCodeActions(V,J,ee,ae,we){return this._withAdapter(V,R,Ce=>Ce.provideCodeActions(b.URI.revive(J),ee,ae,we),void 0)}$resolveCodeAction(V,J,ee){return this._withAdapter(V,R,ae=>ae.resolveCodeAction(J,ee),void 0)}$releaseCodeActions(V,J){this._withAdapter(V,R,ee=>Promise.resolve(ee.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(V,J,ee){const ae=this._addNewAdapter(new F(this._documents,ee),V);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(J),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(V,J,ee,ae){return this._withAdapter(V,F,we=>we.provideDocumentFormattingEdits(b.URI.revive(J),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(V,J,ee){const ae=this._addNewAdapter(new z(this._documents,ee),V);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(J),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(V,J,ee,ae,we){return this._withAdapter(V,z,Ce=>Ce.provideDocumentRangeFormattingEdits(b.URI.revive(J),ee,ae,we),void 0)}registerOnTypeFormattingEditProvider(V,J,ee,ae){const we=this._addNewAdapter(new oe(this._documents,ee),V);return this._proxy.$registerOnTypeFormattingSupport(we,this._transformDocumentSelector(J),ae,V.identifier),this._createDisposable(we)}$provideOnTypeFormattingEdits(V,J,ee,ae,we,Ce){return this._withAdapter(V,oe,Oe=>Oe.provideOnTypeFormattingEdits(b.URI.revive(J),ee,ae,we,Ce),void 0)}registerWorkspaceSymbolProvider(V,J){const ee=this._addNewAdapter(new j(J,this._logService),V);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(V,J,ee){return this._withAdapter(V,j,ae=>ae.provideWorkspaceSymbols(J,ee),{symbols:[]})}$resolveWorkspaceSymbol(V,J,ee){return this._withAdapter(V,j,ae=>ae.resolveWorkspaceSymbol(J,ee),void 0)}$releaseWorkspaceSymbols(V,J){this._withAdapter(V,j,ee=>ee.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(V,J,ee){const ae=this._addNewAdapter(new W(this._documents,ee,this._logService),V);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(J),W.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(V,J,ee,ae,we){return this._withAdapter(V,W,Ce=>Ce.provideRenameEdits(b.URI.revive(J),ee,ae,we),void 0)}$resolveRenameLocation(V,J,ee,ae){return this._withAdapter(V,W,we=>we.resolveRenameLocation(b.URI.revive(J),ee,ae),void 0)}registerDocumentSemanticTokensProvider(V,J,ee,ae){const we=this._nextHandle(),Ce=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(we,new Ie(new U(this._documents,ee),V)),this._proxy.$registerDocumentSemanticTokensProvider(we,this._transformDocumentSelector(J),ae,Ce);let Oe=this._createDisposable(we);if(Ce){const be=ee.onDidChangeSemanticTokens(Pe=>this._proxy.$emitDocumentSemanticTokensEvent(Ce));Oe=A.Disposable.from(Oe,be)}return Oe}$provideDocumentSemanticTokens(V,J,ee,ae){return this._withAdapter(V,U,we=>we.provideDocumentSemanticTokens(b.URI.revive(J),ee,ae),null,!0)}$releaseDocumentSemanticTokens(V,J){this._withAdapter(V,U,ee=>ee.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(V,J,ee,ae){const we=this._addNewAdapter(new M(this._documents,ee),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(we,this._transformDocumentSelector(J),ae),this._createDisposable(we)}$provideDocumentRangeSemanticTokens(V,J,ee,ae){return this._withAdapter(V,M,we=>we.provideDocumentRangeSemanticTokens(b.URI.revive(J),ee,ae),null,!0)}registerCompletionItemProvider(V,J,ee,ae){const we=this._addNewAdapter(new L(this._documents,this._commands.converter,ee,this._apiDeprecation,V),V);return this._proxy.$registerSuggestSupport(we,this._transformDocumentSelector(J),ae,L.supportsResolving(ee),`${V.identifier.value}(${ae.join("")})`),this._createDisposable(we)}$provideCompletionItems(V,J,ee,ae,we){return this._withAdapter(V,L,Ce=>Ce.provideCompletionItems(b.URI.revive(J),ee,ae,we),void 0)}$resolveCompletionItem(V,J,ee){return this._withAdapter(V,L,ae=>ae.resolveCompletionItem(J,ee),void 0)}$releaseCompletionItems(V,J){this._withAdapter(V,L,ee=>ee.releaseCompletionItems(J),void 0)}registerSignatureHelpProvider(V,J,ee,ae){const we=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,Ce=this._addNewAdapter(new N(this._documents,ee),V);return this._proxy.$registerSignatureHelpProvider(Ce,this._transformDocumentSelector(J),we),this._createDisposable(Ce)}$provideSignatureHelp(V,J,ee,ae,we){return this._withAdapter(V,N,Ce=>Ce.provideSignatureHelp(b.URI.revive(J),ee,ae,we),void 0)}$releaseSignatureHelp(V,J){this._withAdapter(V,N,ee=>ee.releaseSignatureHelp(J),void 0)}registerInlineHintsProvider(V,J,ee){const ae=typeof ee.onDidChangeInlineHints=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new O(this._documents,ee),V);this._proxy.$registerInlineHintsProvider(we,this._transformDocumentSelector(J),ae);let Ce=this._createDisposable(we);if(ae!==void 0){const Oe=ee.onDidChangeInlineHints(be=>this._proxy.$emitInlineHintsEvent(ae));Ce=A.Disposable.from(Ce,Oe)}return Ce}$provideInlineHints(V,J,ee,ae){return this._withAdapter(V,O,we=>we.provideInlineHints(b.URI.revive(J),ee,ae),void 0)}registerDocumentLinkProvider(V,J,ee){const ae=this._addNewAdapter(new B(this._documents,ee),V);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(J),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(V,J,ee){return this._withAdapter(V,B,ae=>ae.provideLinks(b.URI.revive(J),ee),void 0)}$resolveDocumentLink(V,J,ee){return this._withAdapter(V,B,ae=>ae.resolveLink(J,ee),void 0)}$releaseDocumentLinks(V,J){this._withAdapter(V,B,ee=>ee.releaseLinks(J),void 0)}registerColorProvider(V,J,ee){const ae=this._addNewAdapter(new q(this._documents,ee),V);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentColors(V,J,ee){return this._withAdapter(V,q,ae=>ae.provideColors(b.URI.revive(J),ee),[])}$provideColorPresentations(V,J,ee,ae){return this._withAdapter(V,q,we=>we.provideColorPresentations(b.URI.revive(J),ee,ae),void 0)}registerFoldingRangeProvider(V,J,ee){const ae=this._nextHandle(),we=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ie(new Q(this._documents,ee),V)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(J),we);let Ce=this._createDisposable(ae);if(we!==void 0){const Oe=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(we));Ce=A.Disposable.from(Ce,Oe)}return Ce}$provideFoldingRanges(V,J,ee,ae){return this._withAdapter(V,Q,we=>we.provideFoldingRanges(b.URI.revive(J),ee,ae),void 0)}registerSelectionRangeProvider(V,J,ee){const ae=this._addNewAdapter(new he(this._documents,ee,this._logService),V);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideSelectionRanges(V,J,ee,ae){return this._withAdapter(V,he,we=>we.provideSelectionRanges(b.URI.revive(J),ee,ae),[])}registerCallHierarchyProvider(V,J,ee){const ae=this._addNewAdapter(new ve(this._documents,ee),V);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$prepareCallHierarchy(V,J,ee,ae){return this._withAdapter(V,ve,we=>Promise.resolve(we.prepareSession(b.URI.revive(J),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(V,J,ee,ae){return this._withAdapter(V,ve,we=>we.provideCallsTo(J,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(V,J,ee,ae){return this._withAdapter(V,ve,we=>we.provideCallsFrom(J,ee,ae),void 0)}$releaseCallHierarchy(V,J){this._withAdapter(V,ve,ee=>Promise.resolve(ee.releaseSession(J)),void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:(0,D.regExpFlags)(V)}}static _serializeIndentationRule(V){return{decreaseIndentPattern:ke._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:ke._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?ke._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?ke._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:ke._serializeRegExp(V.beforeText),afterText:V.afterText?ke._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?ke._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(ke._serializeOnEnterRule)}setLanguageConfiguration(V,J,ee){let{wordPattern:ae}=ee;if(ae&&(0,D.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(J,ae):this._documents.setWordDefinitionFor(J,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const we=this._nextHandle(),Ce={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?ke._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?ke._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?ke._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(we,J,Ce),this._createDisposable(we)}$setWordDefinitions(V){for(const J of V)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=ke,ke._handlePool=0}),define(me[240],ge([0,1,5,20,7]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(k,D){this._proxy=k.getProxy(b.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,D){await this._proxy.$changeLanguage(k,D);const P=this._documents.getDocumentData(k);if(!P)throw new Error(`document '${k.toString}' NOT found`);return P.document}async tokenAtPosition(k,D){var P;const s=k.version,C=I.Position.from(D),f=await this._proxy.$tokensAtPosition(k.uri,C),h={type:T.StandardTokenType.Other,range:(P=k.getWordRangeAtPosition(D))!==null&&P!==void 0?P:new T.Range(D.line,D.character,D.line,D.character)};if(!f)return h;const a={range:I.Range.to(f.range),type:I.TokenType.to(f.type)};return!a.range.contains(D)||s!==k.version?h:a}}e.ExtHostLanguages=A}),define(me[241],ge([0,1,5,13,41]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(k){return k&&k.title}let y=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(b.MainContext.MainThreadMessageService)}showMessage(D,P,s,C,f){const h={extension:D};let a;typeof C=="string"||A(C)?a=[C,...f]:(h.modal=C&&C.modal,h.useCustom=C&&C.useCustom,a=f),h.useCustom&&(0,T.checkProposedApiEnabled)(D);const u=[];for(let E=0;E<a.length;E++){const v=a[E];if(typeof v=="string")u.push({title:v,handle:E,isCloseAffordance:!1});else if(typeof v=="object"){let{title:_,isCloseAffordance:g}=v;u.push({title:_,isCloseAffordance:!!g,handle:E})}else this._logService.warn("Invalid message item:",v)}return this._proxy.$showMessage(P,s,h,u).then(E=>{if(typeof E=="number")return a[E]})}};y=je([Be(1,I.ILogService)],y),e.ExtHostMessageService=y}),define(me[242],ge([0,1,21,3,6,2,5,20,7,88,24,218,219,71,12,22,73,85]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class _{constructor(t,r){const i=_._Keys.nextId();t.$registerNotebookEditorDecorationType(i,k.NotebookDecorationRenderOptions.from(r)),this.value={key:i,dispose(){t.$removeNotebookEditorDecorationType(i)}}}}e.NotebookEditorDecorationType=_,_._Keys=new h.IdGenerator("NotebookEditorDecorationType");class g{constructor(t,r,i,o,c,m){this._textDocumentsAndEditors=i,this._textDocuments=o,this.logService=c,this._extensionStoragePaths=m,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new s.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new I.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new I.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new I.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new I.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new I.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new I.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new I.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new s.ResourceMap,this._statusBarCache=new v.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=t.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=t.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=t.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:S=>{var p;if(S&&S.$mid===12){const w=(p=S.notebookEditor)===null||p===void 0?void 0:p.notebookUri,R=S.cell.handle,F=this._documents.get(w),z=F==null?void 0:F.getCell(R);if(z)return z.cell}return S}})}get activeNotebookEditor(){var t;return(t=this._activeNotebookEditor)===null||t===void 0?void 0:t.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(t=>t.apiEditor)}getEditorById(t){return this._editors.get(t)}getIdByEditor(t){for(const[r,i]of this._editors)if(i.apiEditor===t)return r}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(t){return this._documents.get(t)}_getNotebookDocument(t){const r=this._documents.get(t);if(!r)throw new Error(`NO notebook document for '${t}'`);return r}_getProviderData(t){const r=this._notebookContentProviders.get(t);if(!r)throw new Error(`NO provider for '${t}'`);return r}registerNotebookContentProvider(t,r,i,o){var c,m,S;if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);this._notebookContentProviders.set(r,{extension:t,provider:i});let p;i.onDidChangeNotebookContentOptions&&(p=i.onDidChangeNotebookContentOptions(()=>{const F=k.NotebookDocumentContentOptions.from(i.options);this._notebookProxy.$updateNotebookProviderOptions(r,F)}));const w=(c=o==null?void 0:o.viewOptions)===null||c===void 0?void 0:c.filenamePattern.map(F=>k.NotebookExclusiveDocumentPattern.from(F)).filter(F=>F!==void 0);((m=o==null?void 0:o.viewOptions)===null||m===void 0?void 0:m.filenamePattern)&&!w&&console.warn(`Notebook content provider view options file name pattern is invalid ${(S=o==null?void 0:o.viewOptions)===null||S===void 0?void 0:S.filenamePattern}`);const R=k.NotebookDocumentContentOptions.from(o);return this._notebookProxy.$registerNotebookProvider({id:t.identifier,location:t.extensionLocation,description:t.description},r,{transientOutputs:R.transientOutputs,transientCellMetadata:R.transientCellMetadata,transientDocumentMetadata:R.transientDocumentMetadata,viewOptions:(o==null?void 0:o.viewOptions)&&w?{displayName:o.viewOptions.displayName,filenamePattern:w,exclusive:o.viewOptions.exclusive||!1}:void 0}),new D.Disposable(()=>{p==null||p.dispose(),this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}registerNotebookCellStatusBarItemProvider(t,r,i){const o=g._notebookStatusBarItemProviderHandlePool++,c=typeof i.onDidChangeCellStatusBarItems=="function"?g._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(o,i),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(o,c,r);let m;return c!==void 0&&(m=i.onDidChangeCellStatusBarItems(S=>this._notebookProxy.$emitCellStatusBarEvent(c))),new D.Disposable(()=>{this._notebookStatusBarItemProviders.delete(o),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(o,c),m&&m.dispose()})}createNotebookEditorDecorationType(t){return new _(this._notebookEditorsProxy,t).value}async openNotebookDocument(t){const r=this._documents.get(t);if(r)return r.notebookDocument;const i=await this._notebookDocumentsProxy.$tryOpenDocument(t),o=this._documents.get(A.URI.revive(i));return(0,a.assertIsDefined)(o==null?void 0:o.notebookDocument)}async showNotebookDocument(t,r){var i;A.URI.isUri(t)&&(t=await this.openNotebookDocument(t));let o;typeof r=="object"?o={position:k.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(k.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:o={preserveFocus:!1};const c=await this._notebookEditorsProxy.$tryShowNotebookDocument(t.uri,t.viewType,o),m=c&&((i=this._editors.get(c))===null||i===void 0?void 0:i.apiEditor);if(m)return m;throw c?new Error(`Could NOT open editor for "${t.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.toString()}".`)}async $provideNotebookCellStatusBarItems(t,r,i,o){var c;const m=this._notebookStatusBarItemProviders.get(t),S=A.URI.revive(r),p=this._documents.get(S);if(!(!p||!m)){const w=p.getCellFromIndex(i);if(!!w){const R=await m.provideCellStatusBarItems(w.cell,o);if(!!R){const F=new T.DisposableStore,z=this._statusBarCache.add([F]),oe=(c=R&&R.map(j=>k.NotebookStatusBarItem.from(j,this._commandsConverter,F)))!==null&&c!==void 0?c:void 0;return{cacheId:z,items:oe}}}}}$releaseNotebookCellStatusBarItems(t){this._statusBarCache.delete(t)}registerNotebookSerializer(t,r,i,o){const c=this._handlePool++;this._notebookSerializer.set(c,i);const m=k.NotebookDocumentContentOptions.from(o);return this._notebookProxy.$registerNotebookSerializer(c,{id:t.identifier,location:t.extensionLocation,description:t.description},r,m),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(c)})}async $dataToNotebook(t,r,i){const o=this._notebookSerializer.get(t);if(!o)throw new Error("NO serializer found");const c=await o.deserializeNotebook(r.buffer,i);return{metadata:k.NotebookDocumentMetadata.from(c.metadata),cells:c.cells.map(k.NotebookCellData.from)}}async $notebookToData(t,r,i){const o=this._notebookSerializer.get(t);if(!o)throw new Error("NO serializer found");const c=await o.serializeNotebook({metadata:k.NotebookDocumentMetadata.to(r.metadata),cells:r.cells.map(k.NotebookCellData.to)},i);return u.VSBuffer.wrap(c)}cancelOneNotebookCellExecution(t){const r=this._activeExecutions.get(t.uri);r==null||r.cancel()}async $openNotebook(t,r,i,o,c){const{provider:m}=this._getProviderData(t),S=await m.openNotebook(A.URI.revive(r),{backupId:i,untitledDocumentData:o==null?void 0:o.buffer},c);return{metadata:k.NotebookDocumentMetadata.from(S.metadata),cells:S.cells.map(k.NotebookCellData.from)}}async $saveNotebook(t,r,i){const o=this._getNotebookDocument(A.URI.revive(r)),{provider:c}=this._getProviderData(t);return await c.saveNotebook(o.notebookDocument,i),!0}async $saveNotebookAs(t,r,i,o){const c=this._getNotebookDocument(A.URI.revive(r)),{provider:m}=this._getProviderData(t);return await m.saveNotebookAs(A.URI.revive(i),c.notebookDocument,o),!0}async $backupNotebook(t,r,i){var o;const c=this._getNotebookDocument(A.URI.revive(r)),m=this._getProviderData(t),S=(o=this._extensionStoragePaths.workspaceValue(m.extension))!==null&&o!==void 0?o:this._extensionStoragePaths.globalValue(m.extension),p=String((0,E.hash)([c.uri.toString(),this._backupIdPool++])),w=A.URI.joinPath(S,p),R=await m.provider.backupNotebook(c.notebookDocument,{destination:w},i);return c.updateBackup(R),R.id}$acceptModelChanged(t,r,i){this._getNotebookDocument(A.URI.revive(t)).acceptModelChanged(r,i)}$acceptDirtyStateChanged(t,r){const i=this._getNotebookDocument(A.URI.revive(t));i.acceptModelChanged({rawEvents:[],versionId:i.notebookDocument.version},r)}$acceptModelSaved(t){const r=this._getNotebookDocument(A.URI.revive(t));this._onDidSaveNotebookDocument.fire(r.notebookDocument)}$acceptEditorPropertiesChanged(t,r){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",t,r);const i=this._editors.get(t);if(!i)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);r.visibleRanges&&i._acceptVisibleRanges(r.visibleRanges.ranges.map(k.NotebookRange.to)),r.selections&&i._acceptSelections(r.selections.selections.map(k.NotebookRange.to)),r.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:i.apiEditor,visibleRanges:i.apiEditor.visibleRanges}),r.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:i.apiEditor,selections:i.apiEditor.selections}))}$acceptEditorViewColumns(t){for(const r in t){const i=this._editors.get(r);if(!i)throw new Error(`unknown text editor: ${r}. known editors: ${[...this._editors.keys()]} `);i._acceptViewColumn(k.ViewColumn.to(t[r]))}}$acceptDocumentPropertiesChanged(t,r){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",t.path,r);const i=this._getNotebookDocument(A.URI.revive(t));i.acceptDocumentPropertiesChanged(r),r.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:i.notebookDocument})}_createExtHostEditor(t,r,i){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const o=new f.ExtHostNotebookEditor(r,this._notebookEditorsProxy,t,i.visibleRanges.map(k.NotebookRange.to),i.selections.map(k.NotebookRange.to),typeof i.viewColumn=="number"?k.ViewColumn.to(i.viewColumn):void 0);this._editors.set(r,o)}$acceptDocumentAndEditorsDelta(t){var r,i,o;if(t.removedDocuments)for(const m of t.removedDocuments){const S=A.URI.revive(m),p=this._documents.get(S);p&&(p.dispose(),this._documents.delete(S),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:p.notebookDocument.getCells().map(w=>w.document.uri)}),this._onDidCloseNotebookDocument.fire(p.notebookDocument));for(const w of this._editors.values())w.notebookData.uri.toString()===S.toString()&&this._editors.delete(w.id)}if(t.addedDocuments){const m=[];for(const S of t.addedDocuments){const p=A.URI.revive(S.uri),w=S.viewType;if(this._documents.has(p))throw new Error(`adding EXISTING notebook ${p} `);const R=this,F=new C.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(z){R._onDidChangeNotebookCells.fire(z)},emitCellOutputsChange(z){R._onDidChangeCellOutputs.fire(z)},emitCellMetadataChange(z){R._onDidChangeCellMetadata.fire(z)},emitCellExecutionStateChange(z){R._onDidChangeCellExecutionState.fire(z)}},w,S.metadata?k.NotebookDocumentMetadata.to(S.metadata):new D.NotebookDocumentMetadata,p);F.acceptModelChanged({versionId:S.versionId,rawEvents:[{kind:P.NotebookCellsChangeType.Initialize,changes:[[0,0,S.cells]]}]},!1),m.push(...S.cells.map(z=>C.ExtHostCell.asModelAddData(F.notebookDocument,z))),(r=this._documents.get(p))===null||r===void 0||r.dispose(),this._documents.set(p,F),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this._onDidOpenNotebookDocument.fire(F.notebookDocument)}}if(t.addedEditors)for(const m of t.addedEditors){if(this._editors.has(m.id))return;const S=A.URI.revive(m.documentUri),p=this._documents.get(S);p&&this._createExtHostEditor(p,m.id,m)}const c=[];if(t.removedEditors)for(const m of t.removedEditors){const S=this._editors.get(m);S&&(this._editors.delete(m),((i=this._activeNotebookEditor)===null||i===void 0?void 0:i.id)===S.id&&(this._activeNotebookEditor=void 0),c.push(S))}if(t.visibleEditors){this._visibleNotebookEditors=t.visibleEditors.map(S=>this._editors.get(S)).filter(S=>!!S);const m=new Set;this._visibleNotebookEditors.forEach(S=>m.add(S.id));for(const S of this._editors.values()){const p=m.has(S.id);S._acceptVisibility(p)}this._visibleNotebookEditors=[...this._editors.values()].map(S=>S).filter(S=>S.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}t.newActiveEditor===null?this._activeNotebookEditor=void 0:t.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(t.newActiveEditor)),t.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((o=this._activeNotebookEditor)===null||o===void 0?void 0:o.apiEditor)}createNotebookCellExecution(t,r,i){const o=this.lookupNotebookDocument(t);if(!o)throw new Error(`Invalid uri: ${t} `);const c=o.getCellFromIndex(r);if(!c)throw new Error(`Invalid cell index: ${t}, ${r} `);if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const m=new d(t,o,c,this._notebookDocumentsProxy);this._activeExecutions.set(c.uri,m);const S=m.onDidChangeState(()=>{m.state===l.Resolved&&(m.dispose(),S.dispose(),this._activeExecutions.delete(c.uri))});return m.asApiObject()}}e.ExtHostNotebookController=g,g._notebookStatusBarItemProviderHandlePool=0;var l;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(l||(l={}));class d extends T.Disposable{constructor(t,r,i,o){super();this._uri=t,this._document=r,this._cell=i,this._proxy=o,this._onDidChangeState=new I.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._executionOrder=i.internalMetadata.executionOrder,this.mixinMetadata({runState:D.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(t){return this._proxy.$applyEdits(this._uri,t,!1)}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){const r=[{editType:11,handle:this._cell.handle,metadata:t}];this.applyEdits(r)}cellIndexToHandle(t){const r=typeof t=="number"?this._document.getCellFromIndex(t):this._cell;if(!!r)return r.handle}asApiObject(){const t=this;return Object.freeze({get document(){return t._document.notebookDocument},get cell(){return t._cell.cell},get executionOrder(){return t._executionOrder},set executionOrder(r){t._executionOrder=r,t.mixinMetadata({executionOrder:r})},start(r){if(t._state===l.Resolved||t._state===l.Started)throw new Error("Cannot call start again");t._state=l.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:D.NotebookCellExecutionState.Executing,runStartTime:r==null?void 0:r.startTime})},end(r){var i,o;if(t._state===l.Resolved)throw new Error("Cannot call resolve twice");t._state=l.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:D.NotebookCellExecutionState.Idle,lastRunSuccess:(i=r==null?void 0:r.success)!==null&&i!==void 0?i:null,runEndTime:(o=r==null?void 0:r.endTime)!==null&&o!==void 0?o:null})},clearOutput(r){return t.verifyStateForOutput(),this.replaceOutput([],r)},async appendOutput(r,i){t.verifyStateForOutput();const o=t.cellIndexToHandle(i);if(typeof o=="number")return r=Array.isArray(r)?r:[r],t.applyEdits([{editType:2,handle:o,append:!0,outputs:r.map(k.NotebookCellOutput.from)}])},async replaceOutput(r,i){t.verifyStateForOutput();const o=t.cellIndexToHandle(i);if(typeof o=="number")return r=Array.isArray(r)?r:[r],t.applyEdits([{editType:2,handle:o,outputs:r.map(k.NotebookCellOutput.from)}])},async appendOutputItems(r,i){return t.verifyStateForOutput(),r=Array.isArray(r)?r:[r],t.applyEdits([{editType:10,append:!0,items:r.map(k.NotebookCellOutputItem.from),outputId:i}])},async replaceOutputItems(r,i){return t.verifyStateForOutput(),r=Array.isArray(r)?r:[r],t.applyEdits([{editType:10,items:r.map(k.NotebookCellOutputItem.from),outputId:i}])},token:t._tokenSource.token})}}}),define(me[243],ge([0,1,3,6,5,2,20,15,87]),function(G,e,b,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class P{constructor(C,f,h){this._initData=f,this._extHostNotebook=h,this._kernelData=new Map,this._handlePool=0,this._proxy=C.getProxy(T.MainContext.MainThreadNotebookKernels)}createNotebookController(C,f,h,a,u,E){for(let w of this._kernelData.values())if(w.controller.id===f)throw new Error(`notebook controller with id '${f}' ALREADY exist`);const v=this._handlePool++,_=this,g=["plaintext"],l=()=>console.warn(`NO execute handler from notebook controller '${i.id}' of extension: '${C.identifier}'`);let d=!1;const n=new I.DisposableStore,t=new b.Emitter,r=new b.Emitter,i={id:f,selector:h,extensionId:C.identifier,extensionLocation:C.extensionLocation,label:a||C.identifier.value,supportedLanguages:g,preloads:E?E.map(y.NotebookKernelPreload.from):[]};let o=u!=null?u:l,c;this._proxy.$addKernel(v,i).catch(w=>{console.log(w),d=!0});let m=0;const S=()=>{if(!d){const w=++m;Promise.resolve().then(()=>{w===m&&this._proxy.$updateKernel(v,i)})}},p={get id(){return i.id},get selector(){return i.selector},onDidChangeNotebookAssociation:t.event,get label(){return i.label},set label(w){var R;i.label=(R=w!=null?w:C.displayName)!==null&&R!==void 0?R:C.name,S()},get detail(){var w;return(w=i.detail)!==null&&w!==void 0?w:""},set detail(w){i.detail=w,S()},get description(){var w;return(w=i.description)!==null&&w!==void 0?w:""},set description(w){i.description=w,S()},get isPreferred(){var w;return(w=i.isPreferred)!==null&&w!==void 0?w:!1},set isPreferred(w){i.isPreferred=w,S()},get supportedLanguages(){return i.supportedLanguages},set supportedLanguages(w){i.supportedLanguages=(0,k.isNonEmptyArray)(w)?w:g,S()},get hasExecutionOrder(){var w;return(w=i.hasExecutionOrder)!==null&&w!==void 0?w:!1},set hasExecutionOrder(w){i.hasExecutionOrder=w,S()},get preloads(){return i.preloads?i.preloads.map(y.NotebookKernelPreload.to):[]},get executeHandler(){return o},set executeHandler(w){o=w!=null?w:l},get interruptHandler(){return c},set interruptHandler(w){c=w,i.supportsInterrupt=Boolean(w),S()},createNotebookCellExecutionTask(w){if(d)throw new Error("notebook controller is DISPOSED");return _._extHostNotebook.createNotebookCellExecution(w.notebook.uri,w.index,i.id)},dispose:()=>{d||(d=!0,this._kernelData.delete(v),n.dispose(),t.dispose(),r.dispose(),this._proxy.$removeKernel(v))},onDidReceiveMessage:r.event,postMessage(w,R){return _._proxy.$postMessage(v,R&&_._extHostNotebook.getIdByEditor(R),w)},asWebviewUri(w){return(0,D.asWebviewUri)(_._initData.environment,String(v),w)}};return this._kernelData.set(v,{extensionId:C.identifier,controller:p,onDidChangeSelection:t,onDidReceiveMessage:r}),p}$acceptSelection(C,f,h){const a=this._kernelData.get(C);a&&a.onDidChangeSelection.fire({selected:h,notebook:this._extHostNotebook.lookupNotebookDocument(A.URI.revive(f)).notebookDocument})}async $executeCells(C,f,h){const a=this._kernelData.get(C);if(!!a){const u=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(f));if(!u)throw new Error("MISSING notebook");const E=[];for(let v of h){const _=u.getCell(v);_&&E.push(_.cell)}try{await a.controller.executeHandler.call(a.controller,E,a.controller)}catch(v){console.error(v)}}}async $cancelCells(C,f,h){const a=this._kernelData.get(C);if(!!a){const u=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(f));if(!u)throw new Error("MISSING notebook");a.controller.interruptHandler&&await a.controller.interruptHandler.call(a.controller);for(let E of h){const v=u.getCell(E);v&&this._extHostNotebook.cancelOneNotebookCellExecution(v)}}}$acceptRendererMessage(C,f,h){const a=this._kernelData.get(C);if(!!a){const u=this._extHostNotebook.getEditorById(f);if(!u)throw new Error(`send message for UNKNOWN editor: ${f}`);a.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:h}))}}}e.ExtHostNotebookKernels=P}),define(me[64],ge([0,1,5,3,6,22,4,14]),function(G,e,b,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends T.Disposable{constructor(a,u,E,v){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=v,this._id=v.$register(this.name,u,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?A.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(u=>this._proxy.$clear(u,a))}show(a,u){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof a=="boolean"?a:u)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class P extends D{constructor(a,u){super(a,!1,void 0,u)}append(a){super.append(a),this._id.then(u=>this._proxy.$append(u,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class s extends D{constructor(a,u,E){super(a,!0,u,E)}append(a){throw new Error("Not supported")}}class C{constructor(a,u){this.name=a,this._channel=u}append(a){this._channel.then(u=>u.append(a))}appendLine(a){this._channel.then(u=>u.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,u){this._channel.then(E=>E.show(a,u))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=C;let f=class{constructor(a){this._proxy=a.getProxy(b.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new P(a,this._proxy)}createOutputChannelFromLogFile(a,u){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new s(a,u,this._proxy)}};f=je([Be(0,k.IExtHostRpcService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(me[244],ge([0,1,16,21,3,6,5,2,7,19,15,57]),function(G,e,b,I,T,A,y,k,D,P,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(h,a,u){const E=h.getProxy(y.MainContext.MainThreadQuickOpen);class v{constructor(i,o){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=o}showQuickPick(i,o,c,m=I.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(i),p=++this._instances,w=E.$show(p,{title:c==null?void 0:c.title,placeHolder:c==null?void 0:c.placeHolder,matchOnDescription:c==null?void 0:c.matchOnDescription,matchOnDetail:c==null?void 0:c.matchOnDetail,ignoreFocusLost:c==null?void 0:c.ignoreFocusOut,canPickMany:c==null?void 0:c.canPickMany},m),R={},F=w.then(()=>R);return Promise.race([F,S]).then(z=>{if(z!==R)return S.then(oe=>{const j=[];for(let W=0;W<oe.length;W++){const $=oe[W];let U,M,L,N,O;typeof $=="string"?U=$:(U=$.label,M=$.description,L=$.detail,N=$.picked,O=$.alwaysShow),j.push({label:U,description:M,handle:W,detail:L,picked:N,alwaysShow:O})}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{c.onDidSelectItem(oe[W])}),E.$setItems(p,j),w.then(W=>{if(typeof W=="number")return oe[W];if(Array.isArray(W))return W.map($=>oe[$])})})}).then(void 0,z=>{if(!(0,P.isPromiseCanceledError)(z))return E.$setError(p,z),Promise.reject(z)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,o=I.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,E.$input(i,typeof this._validateInput=="function",o).then(void 0,c=>{if(!(0,P.isPromiseCanceledError)(c))return Promise.reject(c)})}$validateInput(i){return this._validateInput?(0,b.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,o=I.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!!c){const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(S=>S.uri.toString()===c.uri.toString())}}createQuickPick(i,o){const c=new n(i,o,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(i){const o=new t(i,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(i,o){const c=this._sessions.get(i);c&&c._fireDidChangeValue(o)}$onDidAccept(i){const o=this._sessions.get(i);o&&o._fireDidAccept()}$onDidChangeActive(i,o){const c=this._sessions.get(i);c instanceof n&&c._fireDidChangeActive(o)}$onDidChangeSelection(i,o){const c=this._sessions.get(i);c instanceof n&&c._fireDidChangeSelection(o)}$onDidTriggerButton(i,o){const c=this._sessions.get(i);c&&c._fireDidTriggerButton(o)}$onDidHide(i){const o=this._sessions.get(i);o&&o._fireDidHide()}}class _{constructor(i,o){this._extensionId=i,this._onDidDispose=o,this._id=n._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((o,c)=>{const m=o===D.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(m,o)}),this.update({buttons:i.map((o,c)=>({iconPath:g(o.iconPath),tooltip:o.tooltip,handle:o===D.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const o=this._handlesToButtons.get(i);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(i){if(!this._disposed){for(const o of Object.keys(i)){const c=i[o];this._pendingUpdate[o]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function g(r){if(r instanceof D.ThemeIcon)return{id:r.id};const i=d(r),o=l(r);return{dark:typeof i=="string"?k.URI.file(i):i,light:typeof o=="string"?k.URI.file(o):o}}function l(r){return typeof r=="object"&&"light"in r?r.light:r}function d(r){return typeof r=="object"&&"dark"in r?r.dark:r}class n extends _{constructor(i,o,c){super(i,c);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((o,c)=>{this._handlesToItems.set(c,o),this._itemsToHandles.set(o,c)}),this.update({items:i.map((o,c)=>({label:o.label,description:o.description,handle:c,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(i){const o=(0,s.coalesce)(i.map(c=>this._handlesToItems.get(c)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(i){const o=(0,s.coalesce)(i.map(c=>this._handlesToItems.get(c)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class t extends _{constructor(i,o){super(i,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?C.default.Error:C.default.Ignore})}}return new v(a,u)}e.createExtHostQuickOpen=f}),define(me[245],ge([0,1,2,3,69,6,16,5,15,98,13,28,41]),function(G,e,b,I,T,A,y,k,D,P,s,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(i){if(i)return typeof i.iconPath=="string"?b.URI.file(i.iconPath):i.iconPath}function a(i,o){if(!i.iconPath&&!o.iconPath)return 0;if(i.iconPath){if(!o.iconPath)return 1}else return-1;const c=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath,m=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return(0,P.comparePaths)(c,m)}function u(i,o){let c=0;if(i.strikeThrough!==o.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==o.faded)return i.faded?1:-1;if(i.tooltip!==o.tooltip)return(i.tooltip||"").localeCompare(o.tooltip||"");if(c=a(i,o),c!==0)return c;if(i.light&&o.light)c=a(i.light,o.light);else{if(i.light)return 1;if(o.light)return-1}if(c!==0)return c;if(i.dark&&o.dark)c=a(i.dark,o.dark);else{if(i.dark)return 1;if(o.dark)return-1}return c}function E(i,o){if(i.command!==o.command)return i.command<o.command?-1:1;if(i.title!==o.title)return i.title<o.title?-1:1;if(i.tooltip!==o.tooltip){if(i.tooltip!==void 0&&o.tooltip!==void 0)return i.tooltip<o.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(i.arguments===o.arguments)return 0;if(i.arguments)if(o.arguments){if(i.arguments.length!==o.arguments.length)return i.arguments.length-o.arguments.length}else return 1;else return-1;for(let c=0;c<i.arguments.length;c++){const m=i.arguments[c],S=o.arguments[c];if(m!==S)return m<S?-1:1}return 0}function v(i,o){let c=(0,P.comparePaths)(i.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(c!==0)return c;if(i.command&&o.command)c=E(i.command,o.command);else{if(i.command)return 1;if(o.command)return-1}if(c!==0)return c;if(i.decorations&&o.decorations)c=u(i.decorations,o.decorations);else{if(i.decorations)return 1;if(o.decorations)return-1}return c}function _(i,o){for(let c=0;c<i.length;c++)if(i[c]!==o[c])return!1;return!0}function g(i,o){return i.command===o.command&&i.title===o.title&&i.tooltip===o.tooltip&&(i.arguments&&o.arguments?_(i.arguments,o.arguments):i.arguments===o.arguments)}function l(i,o){return(0,D.equals)(i,o,g)}class d{constructor(o,c,m){this._extension=o,this._proxy=c,this._sourceControlHandle=m,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(o){if((0,f.checkProposedApiEnabled)(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){(0,f.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,c){(0,f.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,c)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=d;class n{constructor(o,c,m,S,p){this._proxy=o,this._commands=c,this._sourceControlHandle=m,this._id=S,this._label=p,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,c){const m=this._resourceStatesCommandsMap.get(o);return m?(0,y.asPromise)(()=>this._commands.executeCommand(m.command,...m.arguments||[],c)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const c=[...this._resourceStates].sort(v),S=(0,D.sortedDiff)(this._resourceSnapshot,c,v).map(R=>{const F=R.toInsert.map(z=>{const oe=this._resourceHandlePool++;this._resourceStatesMap.set(oe,z);const j=z.resourceUri,W=h(z.decorations),$=z.decorations&&h(z.decorations.light)||W,U=z.decorations&&h(z.decorations.dark)||W,M=[];let L;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const he=new A.DisposableStore;L=this._commands.converter.toInternal(z.command,he),this._resourceStatesDisposablesMap.set(oe,he)}else this._resourceStatesCommandsMap.set(oe,z.command);$&&M.push($),U&&U.toString()!==($==null?void 0:$.toString())&&M.push(U);const N=z.decorations&&z.decorations.tooltip||"",O=z.decorations&&!!z.decorations.strikeThrough,B=z.decorations&&!!z.decorations.faded,q=z.contextValue||"";return{rawResource:[oe,j,M,N,O,B,q,L],handle:oe}});return{start:R.start,deleteCount:R.deleteCount,toInsert:F}}),p=S.map(({start:R,deleteCount:F,toInsert:z})=>[R,F,z.map(oe=>oe.rawResource)]),w=S.reverse();for(const{start:R,deleteCount:F,toInsert:z}of w){const oe=z.map(W=>W.handle),j=this._handlesSnapshot.splice(R,F,...oe);for(const W of j)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),(o=this._resourceStatesDisposablesMap.get(W))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=c,p}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(o,c,m,S,p,w){this._proxy=c,this._commands=m,this._id=S,this._label=p,this._rootUri=w,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new d(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,S,p,w)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=o;const c=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:c})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(!(this._statusBarCommands&&o&&l(this._statusBarCommands,o))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=o;const c=(o||[]).map(m=>this._commands.converter.toInternal(m,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:c})}}get selected(){return this._selected}createResourceGroup(o,c){const m=new n(this._proxy,this._commands,this.handle,o,c),S=I.Event.once(m.onDidDispose)(()=>this.createdResourceGroups.delete(m));return this.createdResourceGroups.set(m,S),this.eventuallyAddResourceGroups(),m}eventuallyAddResourceGroups(){const o=[],c=[];for(const[m,S]of this.createdResourceGroups){S.dispose();const p=m.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(m),this.eventuallyUpdateResourceStates()});I.Event.once(m.onDidDispose)(()=>{this.updatedResourceGroups.delete(m),p.dispose(),this._groups.delete(m.handle),this._proxy.$unregisterGroup(this.handle,m.handle)}),o.push([m.handle,m.id,m.label,m.features]);const w=m._takeResourceStateSnapshot();w.length>0&&c.push([m.handle,w]),this._groups.set(m.handle,m)}this._proxy.$registerGroups(this.handle,o,c),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(c=>{const m=c._takeResourceStateSnapshot();m.length!==0&&o.push([c.handle,m])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,je([(0,T.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),je([(0,T.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let r=class Mn{constructor(o,c,m){this._commands=c,this.logService=m,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=o.getProxy(k.MainContext.MainThreadSCM),this._telemetry=o.getProxy(k.MainContext.MainThreadTelemetry),c.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===3){const p=this._sourceControls.get(S.sourceControlHandle);if(!p)return S;const w=p.getResourceGroup(S.groupHandle);return w?w.getResourceState(S.handle):S}else if(S&&S.$mid===4){const p=this._sourceControls.get(S.sourceControlHandle);return p?p.getResourceGroup(S.groupHandle):S}else if(S&&S.$mid===5){const p=this._sourceControls.get(S.handle);return p||S}return S}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,c,m,S){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,c,m,S),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const p=Mn._handlePool++,w=new t(o,this._proxy,this._commands,c,m,S);this._sourceControls.set(p,w);const R=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(o.identifier))||[];return R.push(w),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(o.identifier),R),w}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const c=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(o.identifier)),m=c&&c[c.length-1];return m&&m.inputBox}$provideOriginalResource(o,c,m){const S=b.URI.revive(c);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,S.toString());const p=this._sourceControls.get(o);return!p||!p.quickDiffProvider||!p.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>p.quickDiffProvider.provideOriginalResource(S,m)).then(w=>w||null)}$onInputBoxValueChange(o,c){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const m=this._sourceControls.get(o);return m&&m.inputBox.$onInputBoxValueChange(c),Promise.resolve(void 0)}$executeResourceCommand(o,c,m,S){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,c,m);const p=this._sourceControls.get(o);if(!p)return Promise.resolve(void 0);const w=p.getResourceGroup(c);return w?w.$executeResourceCommand(m,S):Promise.resolve(void 0)}$validateInput(o,c,m){this.logService.trace("ExtHostSCM#$validateInput",o);const S=this._sourceControls.get(o);return!S||!S.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>S.inputBox.validateInput(c,m)).then(p=>p?Promise.resolve([p.message,p.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var c,m;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((c=this._sourceControls.get(o))===null||c===void 0||c.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((m=this._sourceControls.get(this._selectedSourceControlHandle))===null||m===void 0||m.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};r._handlePool=0,r=je([Be(2,s.ILogService)],r),e.ExtHostSCM=r});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[246],ge([0,1,7,5,164,6]),function(G,e,b,I,T,A){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(f,h,a,u,E=b.StatusBarAlignment.Left,v,_){y.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,tt(this,y,f,"f"),tt(this,k,h,"f"),this._id=D.ID_GEN++,this._statusId=a,this._statusName=u,this._alignment=E,this._priority=v,this._accessibilityInformation=_}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var f;return(f=this._command)===null||f===void 0?void 0:f.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!D.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){var h;((h=this._command)===null||h===void 0?void 0:h.fromApi)!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Ue(this,k,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Ue(this,k,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var f;this._timeoutHandle=void 0;let h=this._color;this._backgroundColor&&(h=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(f=this._command)===null||f===void 0?void 0:f.internal,h,this._backgroundColor,this._alignment===b.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,k=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new b.ThemeColor("statusBarItem.errorForeground")]]);class P{constructor(f){this._messages=[],this._item=f.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),b.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const h={message:f};return this._messages.unshift(h),this._update(),new b.Disposable(()=>{const a=this._messages.indexOf(h);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class s{constructor(f,h){this._proxy=f.getProxy(I.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new P(this)}createStatusBarEntry(f,h,a,u,E){return new D(this._proxy,this._commands,f,h,a,u,E)}setStatusBarMessage(f,h){const a=this._statusMessage.setMessage(f);let u;return typeof h=="number"?u=setTimeout(()=>a.dispose(),h):typeof h!="undefined"&&h.then(()=>a.dispose(),()=>a.dispose()),new b.Disposable(()=>{a.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=s}),define(me[91],ge([0,1,5,3,4]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(k){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(b.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,D){this._proxy.$registerExtensionStorageKeysToSync(k,D)}getValue(k,D,P){return this._proxy.$getValue(k,D).then(s=>s||P)}setValue(k,D,P){return this._proxy.$setValue(k,D,P)}$acceptValue(k,D,P){this._onDidChangeStorage.fire({shared:k,key:D,value:P})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(me[92],ge([0,1,4,27,13,90,2]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,b.createDecorator)("IExtensionStoragePaths");let k=class{constructor(P,s,C){var f;this._logService=s,this._extHostFileSystem=C,this._workspace=(f=P.workspace)!==null&&f!==void 0?f:void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var P;if(!this._workspace)return Promise.resolve(void 0);const s=this._workspace.id,C=y.URI.joinPath(this._environment.workspaceStorageHome,s);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(f){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(P=y.URI.revive(this._workspace.configuration))===null||P===void 0?void 0:P.toString(),name:this._workspace.name},void 0,2))),C}catch(f){this._logService.error("[ExtHostStorage]",f);return}}workspaceValue(P){if(this._value)return y.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return y.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}};k=je([Be(0,I.IExtHostInitDataService),Be(1,T.ILogService),Be(2,A.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(me[34],ge([0,1,3,5,4,2,14,6,7,165,19,210,21,30,190]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class u{constructor(n,t,r,i){this._proxy=n,this._id=t,this._creationOptions=r,this._name=i,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(c=>this._pidPromiseComplete=c);const o=this;this.value={get name(){return o._name||""},get processId(){return o._pidPromise},get creationOptions(){return o._creationOptions},get exitStatus(){return o._exitStatus},sendText(c,m=!0){o._checkDisposed(),o._proxy.$sendText(o._id,c,m)},show(c){o._checkDisposed(),o._proxy.$show(o._id,c)},hide(){o._checkDisposed(),o._proxy.$hide(o._id)},dispose(){o._disposed||(o._disposed=!0,o._proxy.$dispose(o._id))},get dimensions(){if(!(o._cols===void 0||o._rows===void 0))return{columns:o._cols,rows:o._rows}}}}async create(n,t,r,i,o,c,m,S,p,w,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:n,shellArgs:t,cwd:r,env:i,icon:o,initialText:c,waitOnExit:m,strictEnv:S,hideFromUser:p,isFeatureTerminal:w,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitCode(n){this._exitStatus=Object.freeze({code:n})}setDimensions(n,t){return n===this._cols&&t===this._rows||n===0||t===0?!1:(this._cols=n,this._rows=t,!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(t=>{t!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=u;class E{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new b.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new b.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new b.Emitter,this._onProcessTitleChanged=new b.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new b.Emitter,this._onProcessShellTypeChanged=new b.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput&&this._pty.handleInput(n)}resize(n,t){this._pty.setDimensions&&this._pty.setDimensions({columns:n,rows:t})}async processBinary(n){}acknowledgeDataEvent(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(t=>this._onProcessData.fire(t)),this._pty.onDidClose&&this._pty.onDidClose((t=void 0)=>{this._onProcessExit.fire(t===void 0?void 0:t)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(t=>this._onProcessOverrideDimensions.fire(t&&{cols:t.columns,rows:t.rows})),this._pty.open(n||void 0),this._pty.setDimensions&&n&&this._pty.setDimensions(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let v=1,_=class extends k.Disposable{constructor(n,t){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new b.Emitter,this._onDidOpenTerminal=new b.Emitter,this._onDidChangeActiveTerminal=new b.Emitter,this._onDidChangeTerminalDimensions=new b.Emitter,this._proxy=t.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new b.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[r,i]of this._terminalProcesses)i.shutdown(!0)}})}get activeTerminal(){var n;return(n=this._activeTerminal)===null||n===void 0?void 0:n.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(n){const t=new u(this._proxy,(0,h.generateUuid)(),n,n.name),r=new E(n.pty);return t.createExtensionTerminal().then(i=>{const o=this._setupExtHostProcessListeners(i,r);this._terminalProcessDisposables[i]=o}),this._terminals.push(t),t.value}attachPtyToTerminal(n,t){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const i=new E(t),o=this._setupExtHostProcessListeners(n,i);this._terminalProcessDisposables[n]=o}async $acceptActiveTerminalChanged(n){const t=this._activeTerminal;if(n===null){this._activeTerminal=void 0,t!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const r=this._getTerminalById(n);r&&(this._activeTerminal=r,t!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,t){const r=this._getTerminalById(n);r&&this._onDidWriteTerminalData.fire({terminal:r.value,data:t})}async $acceptTerminalDimensions(n,t,r){const i=this._getTerminalById(n);i&&i.setDimensions(t,r)&&this._onDidChangeTerminalDimensions.fire({terminal:i.value,dimensions:i.value.dimensions})}async $acceptTerminalMaximumDimensions(n,t,r){var i;(i=this._terminalProcesses.get(n))===null||i===void 0||i.resize(t,r)}async $acceptTerminalTitleChange(n,t){const r=this._getTerminalById(n);r&&(r.name=t)}async $acceptTerminalClosed(n,t){const r=this._getTerminalObjectIndexById(this._terminals,n);if(r!==null){const i=this._terminals.splice(r,1)[0];i.setExitCode(t),this._onDidCloseTerminal.fire(i.value)}}$acceptTerminalOpened(n,t,r,i){if(t){const m=this._getTerminalObjectIndexById(this._terminals,t);if(m!==null){this._terminals[m]._id=n,this._onDidOpenTerminal.fire(this.terminals[m]),this._terminals[m].isOpen=!0;return}}const o={name:i.name,shellPath:i.executable,shellArgs:i.args,cwd:typeof i.cwd=="string"?i.cwd:A.URI.revive(i.cwd),env:i.env,hideFromUser:i.hideFromUser},c=new u(this._proxy,n,o,r);this._terminals.push(c),this._onDidOpenTerminal.fire(c.value),c.isOpen=!0}async $acceptTerminalProcessId(n,t){const r=this._getTerminalById(n);r&&r._setProcessId(t)}async $startExtensionTerminal(n,t){const r=this._getTerminalById(n);if(!r)return{message:(0,P.localize)(0,null,n)};r.isOpen||await new Promise(o=>{const c=this.onDidOpenTerminal(async m=>{m===r.value&&(c.dispose(),o())})});const i=this._terminalProcesses.get(n);i?i.startSendingEvents(t):this._extensionTerminalAwaitingStart[n]={initialDimensions:t}}_setupExtHostProcessListeners(n,t){const r=new k.DisposableStore;r.add(t.onProcessReady(o=>this._proxy.$sendProcessReady(n,o.pid,o.cwd))),r.add(t.onProcessTitleChanged(o=>this._proxy.$sendProcessTitle(n,o))),this._bufferer.startBuffering(n,t.onProcessData),r.add(t.onProcessExit(o=>this._onProcessExit(n,o))),t.onProcessOverrideDimensions&&r.add(t.onProcessOverrideDimensions(o=>this._proxy.$sendOverrideDimensions(n,o))),this._terminalProcesses.set(n,t);const i=this._extensionTerminalAwaitingStart[n];return i&&t instanceof E&&(t.startSendingEvents(i.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),r}$acceptProcessAckDataEvent(n,t){var r;(r=this._terminalProcesses.get(n))===null||r===void 0||r.acknowledgeDataEvent(t)}$acceptProcessInput(n,t){var r;(r=this._terminalProcesses.get(n))===null||r===void 0||r.input(t)}$acceptProcessResize(n,t,r){var i;try{(i=this._terminalProcesses.get(n))===null||i===void 0||i.resize(t,r)}catch(o){if(o.code!=="EPIPE"&&o.code!=="ERR_IPC_CHANNEL_CLOSED")throw o}}$acceptProcessShutdown(n,t){var r;(r=this._terminalProcesses.get(n))===null||r===void 0||r.shutdown(t)}$acceptProcessRequestInitialCwd(n){var t;(t=this._terminalProcesses.get(n))===null||t===void 0||t.getInitialCwd().then(r=>this._proxy.$sendProcessInitialCwd(n,r))}$acceptProcessRequestCwd(n){var t;(t=this._terminalProcesses.get(n))===null||t===void 0||t.getCwd().then(r=>this._proxy.$sendProcessCwd(n,r))}$acceptProcessRequestLatency(n){return n}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(n,t){const r=this._getTerminalById(n);if(!r)return[];this._terminalLinkCache.delete(n);const i=this._terminalLinkCancellationSource.get(n);i&&i.dispose(!0);const o=new f.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,o);const c=[],m={terminal:r.value,line:t},S=[];for(const R of this._linkProviders)S.push(new Promise(async F=>{o.token.onCancellationRequested(()=>F({provider:R,links:[]}));const z=await R.provideTerminalLinks(m,o.token)||[];o.token.isCancellationRequested||F({provider:R,links:z})}));const p=await Promise.all(S);if(o.token.isCancellationRequested)return[];const w=new Map;for(const R of p)R&&R.links.length>0&&c.push(...R.links.map(F=>{const z={id:v++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return w.set(z.id,{provider:R.provider,link:F}),z}));return this._terminalLinkCache.set(n,w),c}$activateLink(n,t){var r;const i=(r=this._terminalLinkCache.get(n))===null||r===void 0?void 0:r.get(t);!i||i.provider.handleTerminalLink(i.link)}_onProcessExit(n,t){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const r=this._terminalProcessDisposables[n];r&&(r.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,t)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,t){const r=this._getTerminalObjectIndexById(n,t);return r!==null?n[r]:null}_getTerminalObjectIndexById(n,t){let r=null;return n.some((i,o)=>i._id===t?(r=o,!0):!1),r}getEnvironmentVariableCollection(n){let t=this._environmentVariableCollections.get(n.identifier.value);return t||(t=new g,this._setEnvironmentVariableCollection(n.identifier.value,t)),t}_syncEnvironmentVariableCollection(n,t){const r=(0,C.serializeEnvironmentVariableCollection)(t.map);this._proxy.$setEnvironmentVariableCollection(n,t.persistent,r.length===0?void 0:r)}$initEnvironmentVariableCollections(n){n.forEach(t=>{const r=t[0],i=new g(t[1]);this._setEnvironmentVariableCollection(r,i)})}_setEnvironmentVariableCollection(n,t){this._environmentVariableCollections.set(n,t),t.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,t)})}};_=je([Be(1,y.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class g{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new b.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,t){this._setIfDiffers(n,{value:t,type:D.EnvironmentVariableMutatorType.Replace})}append(n,t){this._setIfDiffers(n,{value:t,type:D.EnvironmentVariableMutatorType.Append})}prepend(n,t){this._setIfDiffers(n,{value:t,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,t){const r=this.map.get(n);(!r||r.value!==t.value||r.type!==t.type)&&(this.map.set(n,t),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,t){this.map.forEach((r,i)=>n.call(t,i,r,this))}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=g;let l=class extends _{constructor(n){super(!1,n)}createTerminal(n,t,r){throw new s.NotSupportedError}createTerminalFromOptions(n){throw new s.NotSupportedError}getDefaultShell(n,t){throw new s.NotSupportedError}getDefaultShellArgs(n,t){throw new s.NotSupportedError}$getAvailableProfiles(n){throw new s.NotSupportedError}async $getDefaultShellAndArgs(n){throw new s.NotSupportedError}};l=je([Be(0,y.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l}),define(me[247],ge([0,1,3,15,5,123,20,7]),function(G,e,b,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(s,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new b.Emitter,this._onDidChangeTextEditorOptions=new b.Emitter,this._onDidChangeTextEditorVisibleRanges=new b.Emitter,this._onDidChangeTextEditorViewColumn=new b.Emitter,this._onDidChangeActiveTextEditor=new b.Emitter,this._onDidChangeVisibleTextEditors=new b.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=s.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(f=>this._onDidChangeVisibleTextEditors.fire(f)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(f=>this._onDidChangeActiveTextEditor.fire(f))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(s){const C=this._extHostDocumentsAndEditors.allEditors();return s?C:C.map(f=>f.value)}async showTextDocument(s,C,f){let h;typeof C=="number"?h={position:y.ViewColumn.from(C),preserveFocus:f}:typeof C=="object"?h={position:y.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?y.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:h={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(s.uri,h),u=a&&this._extHostDocumentsAndEditors.getEditor(a);if(u)return u.value;throw a?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}createTextEditorDecorationType(s){return new A.TextEditorDecorationType(this._proxy,s).value}$acceptEditorPropertiesChanged(s,C){const f=this._extHostDocumentsAndEditors.getEditor(s);if(!f)throw new Error("unknown text editor");if(C.options&&f._acceptOptions(C.options),C.selections){const h=C.selections.selections.map(y.Selection.to);f._acceptSelections(h)}if(C.visibleRanges){const h=I.coalesce(C.visibleRanges.map(y.Range.to));f._acceptVisibleRanges(h)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:f.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const h=k.TextEditorSelectionChangeKind.fromValue(C.selections.source),a=C.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:f.value,selections:a,kind:h})}if(C.visibleRanges){const h=I.coalesce(C.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:f.value,visibleRanges:h})}}$acceptEditorPositionData(s){for(const C in s){const f=this._extHostDocumentsAndEditors.getEditor(C);if(!f)throw new Error("Unknown text editor");const h=y.ViewColumn.to(s[C]);f.value.viewColumn!==h&&(f._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:f.value,viewColumn:h}))}}getDiffInformation(s){return Promise.resolve(this._proxy.$getDiffInformation(s))}}e.ExtHostEditors=D});var Vt=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(b[I[T]]=G[I[T]]);return b};define(me[248],ge([0,1,2,4,5,6,7]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class k{constructor(s,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=s.getProxy(T.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:f=>{var h,a;if(f&&f.$mid===11){const u=f.uri===void 0?void 0:b.URI.revive(f.uri);return(a=(h=this._itemsBySourceAndUriMap.get(f.source))===null||h===void 0?void 0:h.get(D(u)))===null||a===void 0?void 0:a.get(f.handle)}return f}})}async $getTimeline(s,C,f,h,a){const u=this._providers.get(s);return u==null?void 0:u.provideTimeline(b.URI.revive(C),f,h,a)}registerTimelineProvider(s,C,f,h){const a=new A.DisposableStore,u=this.convertTimelineItem(C.id,h,a).bind(this);let E;C.onDidChange&&(E=C.onDidChange(_=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},_),{id:C.id})),this));const v=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:s,onDidChange:void 0,async provideTimeline(_,g,l,d){var n;(d==null?void 0:d.resetCache)&&(a.clear(),(n=v.get(C.id))===null||n===void 0||n.clear());const t=await C.provideTimeline(_,g,l);if(t!=null){const r=u(_,d);return Object.assign(Object.assign({},t),{source:C.id,items:t.items.map(r)})}},dispose(){var _;for(const g of v.values())(_=g.get(C.id))===null||_===void 0||_.clear();E==null||E.dispose(),a.dispose()}}))}convertTimelineItem(s,C,f){return(h,a)=>{let u;if(a==null?void 0:a.cacheResults){let E=this._itemsBySourceAndUriMap.get(s);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(s,E));const v=D(h);u=E.get(v),u===void 0&&(u=new Map,E.set(v,u))}return E=>{var v,_;const{iconPath:g}=E,l=Vt(E,["iconPath"]),d=`${s}|${(v=E.id)!==null&&v!==void 0?v:E.timestamp}`;u==null||u.set(d,E);let n,t,r;return E.iconPath&&(g instanceof y.ThemeIcon?r={id:g.id}:b.URI.isUri(g)?(n=g,t=g):{light:n,dark:t}=g),Object.assign(Object.assign({},l),{id:(_=l.id)!==null&&_!==void 0?_:void 0,handle:d,source:s,command:E.command?C.toInternal(E.command,f):void 0,icon:n,iconDark:t,themeIcon:r,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(s){if(this._providers.get(s.id))throw new Error(`Timeline Provider ${s.id} already exists.`);return this._proxy.$registerTimelineProvider({id:s.id,label:s.label,scheme:s.scheme}),this._providers.set(s.id,s),(0,A.toDisposable)(()=>{var f;for(const h of this._itemsBySourceAndUriMap.values())(f=h.get(s.id))===null||f===void 0||f.clear();this._providers.delete(s.id),this._proxy.$unregisterTimelineProvider(s.id),s.dispose()})}}e.ExtHostTimeline=k;function D(P){return P==null?void 0:P.toString()}}),define(me[249],ge([0,1,6,11,2,5]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,s,C){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const f=C.schemes.find(h=>!y.supportedSchemes.has(h));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,s),this._proxy.$registerUriOpener(P,C.schemes,D,C.label),(0,b.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,s){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener with id: ${D}`);const f=T.URI.revive(P);return C.canOpenExternalUri(f,s)}async $openUri(D,P,s){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener id: '${D}'`);return C.openExternalUri(T.URI.revive(P.resolvedUri),{sourceUri:T.URI.revive(P.sourceUri)},s)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(me[250],ge([0,1,5,2,6,19,28]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(b.MainContext.MainThreadUrls)}registerUriHandler(P,s){if(this.handles.has(y.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const C=k.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(P)),this.handlers.set(C,s),this._proxy.$registerUriHandler(C,P),(0,T.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(P)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(P,s){const C=this.handlers.get(P);if(!C)return Promise.resolve(void 0);try{C.handleUri(I.URI.revive(s))}catch(f){(0,A.onUnexpectedError)(f)}return Promise.resolve(void 0)}async createAppUri(P){return I.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=k,k.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[65],ge([0,1,22,3,2,177,200,87,5]),function(G,e,b,I,T,A,y,k,D){"use strict";var P,s,C,f,h,a,u,E,v,_,g,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(p,w,R,F,z,oe,j){P.set(this,void 0),s.set(this,void 0),C.set(this,void 0),f.set(this,void 0),h.set(this,void 0),a.set(this,void 0),u.set(this,""),E.set(this,void 0),v.set(this,!1),_.set(this,!1),g.set(this,!1),this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new I.Emitter),this._onDidDispose=Ue(this,l,"f").event,tt(this,P,p,"f"),tt(this,s,w,"f"),tt(this,E,R,"f"),tt(this,f,F,"f"),tt(this,h,z,"f"),tt(this,a,oe,"f"),tt(this,g,n(oe),"f"),tt(this,C,j,"f")}dispose(){tt(this,v,!0,"f"),Ue(this,l,"f").fire(),Ue(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return tt(this,_,!0,"f"),(0,k.asWebviewUri)(Ue(this,f,"f"),Ue(this,P,"f"),p)}get cspSource(){return Ue(this,f,"f").webviewCspSource.replace("{{uuid}}",Ue(this,P,"f"))}get html(){return this.assertNotDisposed(),Ue(this,u,"f")}set html(p){this.assertNotDisposed(),Ue(this,u,"f")!==p&&(tt(this,u,p,"f"),!Ue(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(tt(this,_,!0,"f"),Ue(this,C,"f").report("Webview vscode-resource: uris",Ue(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,s,"f").$setHtml(Ue(this,P,"f"),p))}get options(){return this.assertNotDisposed(),Ue(this,E,"f")}set options(p){this.assertNotDisposed(),Ue(this,s,"f").$setOptions(Ue(this,P,"f"),o(Ue(this,a,"f"),Ue(this,h,"f"),p)),tt(this,E,p,"f")}async postMessage(p){if(Ue(this,v,"f"))return!1;const w=t(p,{serializeBuffersForPostMessage:Ue(this,g,"f")});return Ue(this,s,"f").$postMessage(Ue(this,P,"f"),w.message,...w.buffers)}assertNotDisposed(){if(Ue(this,v,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=d,P=new WeakMap,s=new WeakMap,C=new WeakMap,f=new WeakMap,h=new WeakMap,a=new WeakMap,u=new WeakMap,E=new WeakMap,v=new WeakMap,_=new WeakMap,g=new WeakMap,l=new WeakMap;function n(S){if(!S.enableProposedApi)return!1;try{const p=(0,A.normalizeVersion)((0,A.parseVersion)(S.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=56}catch(p){return!1}}e.shouldSerializeBuffersForPostMessage=n;function t(S,p){if(p.serializeBuffersForPostMessage){const w=[],R=(z,oe)=>{if(oe&&oe instanceof ArrayBuffer){let j=w.findIndex(W=>W.original===oe);if(j===-1){const W=new Uint8Array(oe),$=b.VSBuffer.wrap(W);j=w.length,w.push({original:oe,vsBuffer:$})}return{$$vscode_array_buffer_reference$$:!0,index:j}}return oe};return{message:JSON.stringify(S,R),buffers:w.map(z=>z.vsBuffer)}}else return{message:JSON.stringify(S),buffers:[]}}e.serializeMessage=t;class r{constructor(p,w,R,F,z){this.initData=w,this.workspace=R,this._logService=F,this._deprecationService=z,this._webviews=new Map,this._webviewProxy=p.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(p,w,...R){const F=this.getWebview(p);if(F){const{message:z}=(0,y.deserializeWebviewMessage)(w,R);F._onMessageEmitter.fire(z)}}$onMissingCsp(p,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,w,R){const F=new d(p,this._webviewProxy,c(w),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(p,F),F._onDidDispose(()=>{this._webviews.delete(p)}),F}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=r;function i(S){return{id:S.identifier,location:S.extensionLocation}}e.toExtensionData=i;function o(S,p,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||m(S,p)}}e.serializeWebviewOptions=o;function c(S){var p;return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,portMapping:S.portMapping,localResourceRoots:(p=S.localResourceRoots)===null||p===void 0?void 0:p.map(w=>T.URI.from(w))}}e.reviveOptions=c;function m(S,p){return[...((p==null?void 0:p.getWorkspaceFolders())||[]).map(w=>w.uri),S.extensionLocation]}}),define(me[251],ge([0,1,21,73,6,11,25,2,20,65,85,5,7]),function(G,e,b,I,T,A,y,k,D,P,s,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(n,t){this.document=n,this._storagePath=t,this._backupCounter=1,this._edits=new s.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,t){await this.getEdit(n).undo(),t||this.disposeBackup()}async redo(n,t){await this.getEdit(n).redo(),t||this.disposeBackup()}disposeEdits(n){for(const t of n)this._edits.delete(t)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=l(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,n)}updateBackup(n){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=n}disposeBackup(){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=void 0}getEdit(n){const t=this._edits.get(n,0);if(!t)throw new Error("No edit found");return t}}class a{constructor(){this._documents=new Map}get(n,t){return this._documents.get(this.key(n,t))}add(n,t,r){const i=this.key(n,t.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${n} resource:${t.uri}`);const o=new h(t,r);return this._documents.set(i,o),o}delete(n,t){const r=this.key(n,t.uri);this._documents.delete(r)}key(n,t){return`${n}@@@${t}`}}var u;(function(d){d[d.Text=0]="Text",d[d.Custom=1]="Custom"})(u||(u={}));class E{constructor(){this._providers=new Map}addTextProvider(n,t,r){return this.add(0,n,t,r)}addCustomProvider(n,t,r){return this.add(1,n,t,r)}get(n){return this._providers.get(n)}add(n,t,r,i){if(this._providers.has(t))throw new Error(`Provider for viewType:${t} already registered`);return this._providers.set(t,{type:n,extension:r,provider:i}),new f.Disposable(()=>this._providers.delete(t))}}class v{constructor(n,t,r,i,o){this._extHostDocuments=t,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=o,this._editorProviders=new E,this._documents=new a,this._proxy=n.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,t,r,i){const o=new T.DisposableStore;return _(r)?(o.add(this._editorProviders.addTextProvider(t,n,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(n),t,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(n))):(o.add(this._editorProviders.addCustomProvider(t,n,r)),this.supportEditing(r)&&o.add(r.onDidChangeCustomDocument(c=>{const m=this.getCustomDocumentEntry(t,c.document.uri);if(g(c)){const S=m.addEdit(c);this._proxy.$onDidEdit(c.document.uri,t,S,c.label)}else this._proxy.$onContentChange(c.document.uri,t)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(n),t,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(n))),f.Disposable.from(o,new f.Disposable(()=>{this._proxy.$unregisterEditorProvider(t)}))}async $createCustomDocument(n,t,r,i,o){var c;const m=this._editorProviders.get(t);if(!m)throw new Error(`No provider found for '${t}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${t}'`);const S=k.URI.revive(n),p=await m.provider.openCustomDocument(S,{backupId:r,untitledDocumentData:i==null?void 0:i.buffer},o);let w;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(w=(c=this._extensionStoragePaths.workspaceValue(m.extension))!==null&&c!==void 0?c:this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(t,p,w),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(n,t){const r=this._editorProviders.get(t);if(!r)throw new Error(`No provider found for '${t}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${t}'`);const i=k.URI.revive(n),{document:o}=this.getCustomDocumentEntry(t,i);this._documents.delete(t,o),o.dispose()}async $resolveWebviewEditor(n,t,r,i,o,c){const m=this._editorProviders.get(r);if(!m)throw new Error(`No provider found for '${r}'`);const S=D.ViewColumn.to(o),p=this._extHostWebview.createNewWebview(t,i.webviewOptions,m.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(t,r,i.title,S,i.panelOptions,p),R=k.URI.revive(n);switch(m.type){case 1:{const{document:F}=this.getCustomDocumentEntry(r,R);return m.provider.resolveCustomEditor(F,w,c)}case 0:{const F=this._extHostDocuments.getDocument(R);return m.provider.resolveCustomTextEditor(F,w,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,t,r){this.getCustomDocumentEntry(t,n).disposeEdits(r)}async $onMoveCustomEditor(n,t,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const o=this._extHostWebviewPanels.getWebviewPanel(n);if(!o)throw new Error("No webview found");const c=k.URI.revive(t),m=this._extHostDocuments.getDocument(c);await i.provider.moveCustomTextEditor(m,o,b.CancellationToken.None)}async $undo(n,t,r,i){return this.getCustomDocumentEntry(t,n).undo(r,i)}async $redo(n,t,r,i){return this.getCustomDocumentEntry(t,n).redo(r,i)}async $revert(n,t,r){const i=this.getCustomDocumentEntry(t,n);await this.getCustomEditorProvider(t).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(n,t,r){const i=this.getCustomDocumentEntry(t,n);await this.getCustomEditorProvider(t).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(n,t,r,i){const o=this.getCustomDocumentEntry(t,n);return this.getCustomEditorProvider(t).saveCustomDocumentAs(o.document,k.URI.revive(r),i)}async $backup(n,t,r){const i=this.getCustomDocumentEntry(t,n),c=await this.getCustomEditorProvider(t).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(c),c.id}getCustomDocumentEntry(n,t){const r=this._documents.get(n,k.URI.revive(t));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(n){const t=this._editorProviders.get(n),r=t==null?void 0:t.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(n){return!!n.onDidChangeCustomDocument}}e.ExtHostCustomEditors=v;function _(d){return typeof d.resolveCustomTextEditor=="function"}function g(d){return typeof d.undo=="function"&&typeof d.redo=="function"}function l(d){const n=d.scheme===A.Schemas.file||d.scheme===A.Schemas.untitled?d.fsPath:d.toString();return(0,I.hash)(n)+""}});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[252],ge([0,1,3,6,2,30,20,65,5,7]),function(G,e,b,I,T,A,y,k,D,P){"use strict";var s,C,f,h,a,u,E,v,_,g,l,d,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class t extends I.Disposable{constructor(c,m,S,p,w,R,F){super();s.set(this,void 0),C.set(this,void 0),f.set(this,void 0),h.set(this,void 0),a.set(this,void 0),u.set(this,void 0),E.set(this,void 0),v.set(this,void 0),_.set(this,!0),g.set(this,!0),l.set(this,!1),d.set(this,this._register(new b.Emitter)),this.onDidDispose=Ue(this,d,"f").event,n.set(this,this._register(new b.Emitter)),this.onDidChangeViewState=Ue(this,n,"f").event,tt(this,s,c,"f"),tt(this,C,m,"f"),tt(this,f,S,"f"),tt(this,a,R,"f"),tt(this,v,w,"f"),tt(this,u,p,"f"),tt(this,h,F,"f")}dispose(){Ue(this,l,"f")||(tt(this,l,!0,"f"),Ue(this,d,"f").fire(),Ue(this,C,"f").$disposeWebview(Ue(this,s,"f")),Ue(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,h,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,f,"f")}get title(){return this.assertNotDisposed(),Ue(this,u,"f")}set title(c){this.assertNotDisposed(),Ue(this,u,"f")!==c&&(tt(this,u,c,"f"),Ue(this,C,"f").$setTitle(Ue(this,s,"f"),c))}get iconPath(){return this.assertNotDisposed(),Ue(this,E,"f")}set iconPath(c){this.assertNotDisposed(),Ue(this,E,"f")!==c&&(tt(this,E,c,"f"),Ue(this,C,"f").$setIconPath(Ue(this,s,"f"),T.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Ue(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,v,"f")=="number"&&Ue(this,v,"f")<0))return Ue(this,v,"f")}get active(){return this.assertNotDisposed(),Ue(this,g,"f")}get visible(){return this.assertNotDisposed(),Ue(this,_,"f")}_updateViewState(c){Ue(this,l,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(tt(this,g,c.active,"f"),tt(this,_,c.visible,"f"),tt(this,v,c.viewColumn,"f"),Ue(this,n,"f").fire({webviewPanel:this}))}reveal(c,m){this.assertNotDisposed(),Ue(this,C,"f").$reveal(Ue(this,s,"f"),{viewColumn:c?y.ViewColumn.from(c):void 0,preserveFocus:!!m})}assertNotDisposed(){if(Ue(this,l,"f"))throw new Error("Webview is disposed")}}s=new WeakMap,C=new WeakMap,f=new WeakMap,h=new WeakMap,a=new WeakMap,u=new WeakMap,E=new WeakMap,v=new WeakMap,_=new WeakMap,g=new WeakMap,l=new WeakMap,d=new WeakMap,n=new WeakMap;class r{constructor(c,m,S){this.webviews=m,this.workspace=S,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(c,m,S,p,w={}){const R=typeof p=="object"?p.viewColumn:p,F={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof p=="object"&&!!p.preserveFocus},z=(0,k.shouldSerializeBuffersForPostMessage)(c),oe=r.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(c),oe,m,{title:S,panelOptions:i(w),webviewOptions:(0,k.serializeWebviewOptions)(c,this.workspace,w),serializeBuffersForPostMessage:z},F);const j=this.webviews.createNewWebview(oe,w,c);return this.createNewWebviewPanel(oe,m,S,R,w,j)}$onDidChangeWebviewPanelViewStates(c){const m=Object.keys(c);m.sort((S,p)=>{const w=c[S],R=c[p];return w.active?1:R.active?-1:+w.visible-+R.visible});for(const S of m){const p=this.getWebviewPanel(S);if(!!p){const w=c[S];p._updateViewState({active:w.active,visible:w.visible,viewColumn:y.ViewColumn.to(w.position)})}}}async $onDidDisposeWebviewPanel(c){const m=this.getWebviewPanel(c);m==null||m.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,m,S){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:S,extension:c}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(c)}),new P.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(c,m,S,p){const w=this._serializers.get(m);if(!w)throw new Error(`No serializer found for '${m}'`);const{serializer:R,extension:F}=w,z=this.webviews.createNewWebview(c,S.webviewOptions,F),oe=this.createNewWebviewPanel(c,m,S.title,p,S.panelOptions,z);await R.deserializeWebviewPanel(oe,S.state)}createNewWebviewPanel(c,m,S,p,w,R){const F=new t(c,this._proxy,m,S,p,w,R);return this._webviewPanels.set(c,F),F}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=r;function i(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[253],ge([0,1,3,6,65,5,7]),function(G,e,b,I,T,A,y){"use strict";var k,D,P,s,C,f,h,a,u,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends I.Disposable{constructor(l,d,n,t,r,i){super();k.set(this,void 0),D.set(this,void 0),P.set(this,void 0),s.set(this,void 0),C.set(this,!1),f.set(this,void 0),h.set(this,void 0),a.set(this,void 0),u.set(this,this._register(new b.Emitter)),this.onDidChangeVisibility=Ue(this,u,"f").event,E.set(this,this._register(new b.Emitter)),this.onDidDispose=Ue(this,E,"f").event,tt(this,P,n,"f"),tt(this,h,t,"f"),tt(this,k,l,"f"),tt(this,D,d,"f"),tt(this,s,r,"f"),tt(this,f,i,"f")}dispose(){Ue(this,C,"f")||(tt(this,C,!0,"f"),Ue(this,E,"f").fire(),Ue(this,s,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,h,"f")}set title(l){this.assertNotDisposed(),Ue(this,h,"f")!==l&&(tt(this,h,l,"f"),Ue(this,D,"f").$setWebviewViewTitle(Ue(this,k,"f"),l))}get description(){return this.assertNotDisposed(),Ue(this,a,"f")}set description(l){this.assertNotDisposed(),Ue(this,a,"f")!==l&&(tt(this,a,l,"f"),Ue(this,D,"f").$setWebviewViewDescription(Ue(this,k,"f"),l))}get visible(){return Ue(this,f,"f")}get webview(){return Ue(this,s,"f")}get viewType(){return Ue(this,P,"f")}_setVisible(l){l===Ue(this,f,"f")||Ue(this,C,"f")||(tt(this,f,l,"f"),Ue(this,u,"f").fire())}show(l){this.assertNotDisposed(),Ue(this,D,"f").$show(Ue(this,k,"f"),!!l)}assertNotDisposed(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,D=new WeakMap,P=new WeakMap,s=new WeakMap,C=new WeakMap,f=new WeakMap,h=new WeakMap,a=new WeakMap,u=new WeakMap,E=new WeakMap;class _{constructor(l,d){this._extHostWebview=d,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,d,n,t){if(this._viewProviders.has(d))throw new Error(`View provider for '${d}' already registered`);return this._viewProviders.set(d,{provider:n,extension:l}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(l),d,{retainContextWhenHidden:t==null?void 0:t.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(d),this._proxy.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(l,d,n,t,r){const i=this._viewProviders.get(d);if(!i)throw new Error(`No view provider found for '${d}'`);const{provider:o,extension:c}=i,m=this._extHostWebview.createNewWebview(l,{},c),S=new v(l,this._proxy,d,n,m,!0);this._webviewViews.set(l,S),await o.resolveWebviewView(S,{state:t},r)}async $onDidChangeWebviewViewVisibility(l,d){this.getWebviewView(l)._setVisible(d)}async $disposeWebviewView(l){const d=this.getWebviewView(l);this._webviewViews.delete(l),d.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const d=this._webviewViews.get(l);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=_}),define(me[126],ge([0,1,3,5,2,11,10,4,14]),function(G,e,b,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class On{constructor(C){this._onDidChangeWindowState=new b.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=On.InitialState,this._proxy=C.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(f=>this.$onDidChangeWindowFocus(f))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,f){let h;if(typeof C=="string"){h=C;try{C=T.URI.parse(C)}catch(a){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,y.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,h,f)}async asExternalUri(C,f){if((0,y.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const h=await this._proxy.$asExternalUri(C,f);return T.URI.from(h)}};P.InitialState={focused:!0},P=je([Be(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(me[254],ge([0,1,8,48,30,51,6,5,2,14]),function(G,e,b,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let s=class extends y.Disposable{constructor(f,h){super();const a=f.getProxy(k.MainContext.MainThreadDownloadService);h.registerCommand(!1,"_workbench.downloadResource",async u=>{const E=D.URI.file((0,b.join)((0,I.tmpdir)(),(0,T.generateUuid)()));return await a.$download(u,E),E})}};s=je([Be(0,P.IExtHostRpcService),Be(1,A.IExtHostCommands)],s),e.ExtHostDownloadService=s}),define(me[255],ge([0,1,2,8,146,26,37,64,27,14,6,13,112,45]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class a{constructor(_,g){this.file=g,this.appender=(0,f.createRotatingLogger)(_,g,30*h.ByteSize.MB,1),this.appender.clearFormatters()}append(_){this.appender.critical(_)}flush(){this.appender.flush()}}class u extends k.AbstractExtHostOutputChannel{constructor(_,g,l){super(_,!1,b.URI.file(g.file),l);this._appender=g}append(_){super.append(_),this._appender.append(_),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(_,g){this._appender.flush(),super.show(_,g)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=u;let E=class extends k.ExtHostOutputService{constructor(_,g,l){super(_);this.logService=g,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new s.MutableDisposable,this._logsLocation=l.logsLocation}$setVisibleChannel(_){if(_){const g=this._channels.get(_);g&&(this._visibleChannelDisposable.value=g.onDidAppend(()=>g.update()))}}createOutputChannel(_){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const g=this._doCreateOutChannel(_);return g.then(l=>l._id.then(d=>this._channels.set(d,l))),new k.LazyOutputChannel(_,g)}async _doCreateOutChannel(_){try{const g=(0,I.join)(this._logsLocation.fsPath,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await A.SymlinkSupport.existsDirectory(g)||await y.promises.mkdir(g,{recursive:!0});const d=`${this._namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}`,n=b.URI.file((0,I.join)(g,`${d}.log`)),t=new a(d,n.fsPath);return new u(_,t,this._proxy)}catch(g){return this.logService.error(g),new k.ExtHostPushOutputChannel(_,this._proxy)}}};E=je([Be(0,P.IExtHostRpcService),Be(1,C.ILogService),Be(2,D.IExtHostInitDataService)],E),e.ExtHostOutputService2=E}),define(me[256],ge([0,1,5,14,6,27,2,38,25,37,26,7,9,50,3,72,13]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v{constructor(m,S,p){this.remoteAddress=m,this.localAddress=S,this._dispose=p,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function _(c){const m=c.trim().split(`
`),S=[];return m.forEach(w=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(w);R&&R.length>=3&&S.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),S.reduce((w,R)=>(w[R.socket]=R,w),{})}e.getSockets=_;function g(...c){const m=[].concat(...c.map(d));return[...new Map(m.filter(S=>S.st==="0A").map(S=>{const p=S.local_address.split(":");return{socket:parseInt(S.inode,10),ip:l(p[0]),port:parseInt(p[1],16)}}).map(S=>[S.ip+":"+S.port,S])).values()]}e.loadListeningPorts=g;function l(c){let m="";if(c.length===8)for(let S=c.length-2;S>=0;S-=2)m+=parseInt(c.substr(S,2),16),S!==0&&(m+=".");else for(let S=c.length-4;S>=0;S-=4)m+=parseInt(c.substr(S,4),16).toString(16),S!==0&&(m+=":");return m}e.parseIpAddress=l;function d(c){const m=c.trim().split(`
`),S=m.shift().trim().split(/\s+/).filter(w=>w!=="rx_queue"&&w!=="tm->when");return m.map(w=>w.trim().split(/\s+/).reduce((R,F,z)=>(R[S[z]||z]=F,R),{}))}e.loadConnectionTable=d;function n(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function t(c){const m=c.trim().split(`
`),S=[];return m.forEach(p=>{const w=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(p);w&&w.length>=4&&S.push({pid:parseInt(w[1],10),ppid:parseInt(w[2]),cmd:w[3]})}),S}e.getRootProcesses=t;async function r(c,m,S){const p=S.reduce((R,F)=>(R[F.pid]=F,R),{}),w=[];return c.forEach(({socket:R,ip:F,port:z})=>{var oe;const j=m[R]?m[R].pid:void 0,W=j?(oe=p[j])===null||oe===void 0?void 0:oe.cmd:void 0;j&&W&&!n(W)&&w.push({host:F,port:z,detail:W,pid:j})}),w}e.findPorts=r;function i(c,m,S){const p=new Map,w=t(m);for(const R of c){const F=S.get(R.port);if(F){p.set(R.port,F);continue}const z=w.find(oe=>oe.cmd.includes(`${R.port}`));if(z){let oe=z,j;do j=w.find(W=>W.ppid===oe.pid),j&&(oe=j);while(j);p.set(R.port,{host:R.ip,port:R.port,pid:oe.pid,detail:oe.cmd,ppid:oe.ppid})}else p.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return p}e.tryFindRootPorts=i;let o=class extends T.Disposable{constructor(m,S,p){super();this.logService=p,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new a.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(b.MainContext.MainThreadTunnelService),f.isLinux&&S.remote.isRemote&&S.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,S){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${S.remoteAddress.port}.`);const p=await this._proxy.$openTunnel(S,m.displayName);if(p){const w=new v(p.remoteAddress,p.localAddress,()=>this._proxy.$closeTunnel(p.remoteAddress));return this._register(w),w}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,S){const p=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(p,{selector:m,provider:S}),this._proxy.$registerPortsAttributesProvider(m,p),new C.Disposable(()=>{this._portAttributesProviders.delete(p),this._proxy.$unregisterPortsAttributesProvider(p)})}async $providePortAttributes(m,S,p,w,R){const F=[];for(const oe of m){const j=this._portAttributesProviders.get(oe);if(!j)return[];F.push(...await Promise.all(S.map(async W=>j.provider.providePortAttributes(W,p,w,R))))}const z=F.filter(oe=>!!oe);return z.length>0?z.map(oe=>({autoForwardAction:oe.autoForwardAction,port:oe.port})):[]}async $registerCandidateFinder(m){if(!(m&&this._candidateFindingEnabled)){this._candidateFindingEnabled=m;let S=new u.MovingAverage,p;for(;this._candidateFindingEnabled;){const w=new Date().getTime(),R=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(z=>z.port).join(", ")}`);const F=new Date().getTime()-w;S.update(F),(!p||JSON.stringify(p)!==JSON.stringify(R))&&(p=R,await this._proxy.$onFoundNewCandidates(p)),await new Promise(z=>setTimeout(()=>z(),this.calculateDelay(S.value)))}}}async setTunnelExtensionFunctions(m){var S;return m?(m.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,await this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,await this._proxy.$setTunnelProvider((S=m.tunnelFeatures)!==null&&S!==void 0?S:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,S){if(this._extensionTunnels.has(m.host)){const p=this._extensionTunnels.get(m.host);p.has(m.port)&&(S&&p.get(m.port).disposeListener.dispose(),await p.get(m.port).tunnel.dispose(),p.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,S){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const p=this._forwardPortProvider(m,S);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),p!==void 0){const w=await p;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const R=this._register(w.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(w.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:w,disposeListener:R}),h.TunnelDto.fromApiTunnel(w)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(p){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const S=await Promise.all(m.map(w=>{var R;return this._showCandidatePort(w.host,w.port,(R=w.detail)!==null&&R!==void 0?R:"")})),p=m.filter((w,R)=>S[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(w=>w.port).join(", ")} to ${p.map(w=>w.port).join(", ")}`),p}async findCandidatePorts(){let m="",S="";try{m=await P.promises.readFile("/proc/net/tcp","utf8"),S=await P.promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const p=g(m,S),w=await new Promise(U=>{(0,k.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(M,L,N)=>{U(L)})}),R=_(w),F=await s.readdir("/proc"),z=[];for(let U of F)try{const M=Number(U),L=D.joinPath(y.URI.file("/proc"),U);if((await P.promises.stat(L.fsPath)).isDirectory()&&!isNaN(M)){const O=await P.promises.readlink(D.joinPath(L,"cwd").fsPath),B=await P.promises.readFile(D.joinPath(L,"cmdline").fsPath,"utf8");z.push({pid:M,cwd:O,cmd:B})}}catch(M){}const oe=[],j=p.filter(U=>{const M=R[U.socket];return M||oe.push(U),M}),W=r(j,R,z);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${oe.length}`),oe.length>0){const U=await new Promise(M=>{(0,k.exec)("ps -F -A -l | grep root",(L,N,O)=>{M(N)})});this._foundRootPorts=i(oe,U,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return W.then(U=>$?U.concat($):U)}};o=je([Be(0,I.IExtHostRpcService),Be(1,A.IExtHostInitDataService),Be(2,E.ILogService)],o),e.ExtHostTunnelService=o}),define(me[257],ge([0,1,16,21,19,3,6,100,227,124,22]),function(G,e,b,I,T,A,y,k,D,P,s){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function f(i,o){try{return JSON.stringify(i,o)}catch(c){return"null"}}function h(i,o){return JSON.stringify(i,o)}function a(i){return i?(o,c)=>c&&c.$mid===1?i.transformOutgoing(c):c:null}var u;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const v=()=>{},_=Symbol.for("rpcProtocol"),g=Symbol.for("rpcProxy");class l extends y.Disposable{constructor(o,c=null,m=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=c,this._uriTransformer=m,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let S=0,p=P.ProxyIdentifier.count;S<p;S++)this._locals[S]=null,this._proxies[S]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new b.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(S=>this._receiveOneMessage(S))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?(0,k.transformIncomingURIs)(o,this._uriTransformer):o}getProxy(o){const{nid:c,sid:m}=o;return this._proxies[c]||(this._proxies[c]=this._createProxy(c,m)),this._proxies[c]}_createProxy(o,c){let m={get:(S,p)=>(typeof p=="string"&&!S[p]&&p.charCodeAt(0)===36&&(S[p]=(...w)=>this._remoteCall(o,p,w)),p===g?c:S[p])};return new Proxy(Object.create(null),m)}set(o,c){return this._locals[o.nid]=c,c}assertRegistered(o){for(let c=0,m=o.length;c<m;c++){const S=o[c];if(!this._locals[S.nid])throw new Error(`Missing actor ${S.sid} (isMain: ${S.isMain})`)}}_receiveOneMessage(o){if(!this._isDisposed){const c=o.byteLength,m=d.read(o,0),S=m.readUInt8(),p=m.readUInt32();switch(S){case 1:case 2:{let{rpcId:w,method:R,args:F}=n.deserializeRequestJSONArgs(m);this._uriTransformer&&(F=(0,k.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(c,p,w,R,F,S===2);break}case 3:case 4:{let{rpcId:w,method:R,args:F}=n.deserializeRequestMixedArgs(m);this._uriTransformer&&(F=(0,k.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(c,p,w,R,F,S===4);break}case 5:{this._logger&&this._logger.logIncoming(c,p,0,"ack"),this._onDidReceiveAcknowledge(p);break}case 6:{this._receiveCancel(c,p);break}case 7:{this._receiveReply(c,p,void 0);break}case 9:{let w=n.deserializeReplyOKJSON(m);this._uriTransformer&&(w=(0,k.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReply(c,p,w);break}case 8:{let w=n.deserializeReplyOKVSBuffer(m);this._receiveReply(c,p,w);break}case 10:{let w=n.deserializeReplyErrError(m);this._uriTransformer&&(w=(0,k.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReplyErr(c,p,w);break}case 11:{this._receiveReplyErr(c,p,void 0);break}default:console.error("received unexpected message"),console.error(o)}}}_receiveRequest(o,c,m,S,p,w){this._logger&&this._logger.logIncoming(o,c,1,`receiveRequest ${(0,P.getStringIdentifierForProxy)(m)}.${S}(`,p);const R=String(c);let F,z;if(w){const j=new I.CancellationTokenSource;p.push(j.token),F=this._invokeHandler(m,S,p),z=()=>j.cancel()}else F=this._invokeHandler(m,S,p),z=v;this._cancelInvokedHandlers[R]=z;const oe=n.serializeAcknowledged(c);this._logger&&this._logger.logOutgoing(oe.byteLength,c,1,"ack"),this._protocol.send(oe),F.then(j=>{delete this._cancelInvokedHandlers[R];const W=n.serializeReplyOK(c,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(W.byteLength,c,1,"reply:",j),this._protocol.send(W)},j=>{delete this._cancelInvokedHandlers[R];const W=n.serializeReplyErr(c,j);this._logger&&this._logger.logOutgoing(W.byteLength,c,1,"replyErr:",j),this._protocol.send(W)})}_receiveCancel(o,c){this._logger&&this._logger.logIncoming(o,c,1,"receiveCancel");const m=String(c);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(o,c,m){this._logger&&this._logger.logIncoming(o,c,0,"receiveReply:",m);const S=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(S)){const p=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S],p.resolveOk(m)}}_receiveReplyErr(o,c,m){this._logger&&this._logger.logIncoming(o,c,0,"receiveReplyErr:",m);const S=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(S)){const p=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S];let w;m&&(m.$isError?(w=new Error,w.name=m.name,w.message=m.message,w.stack=m.stack):w=m),p.resolveErr(w)}}_invokeHandler(o,c,m){try{return Promise.resolve(this._doInvokeHandler(o,c,m))}catch(S){return Promise.reject(S)}}_doInvokeHandler(o,c,m){const S=this._locals[o];if(!S)throw new Error("Unknown actor "+(0,P.getStringIdentifierForProxy)(o));let p=S[c];if(typeof p!="function")throw new Error("Unknown method "+c+" on actor "+(0,P.getStringIdentifierForProxy)(o));return p.apply(S,m)}_remoteCall(o,c,m){if(this._isDisposed)return Promise.reject(T.canceled());let S=null;if(m.length>0&&I.CancellationToken.isCancellationToken(m[m.length-1])&&(S=m.pop()),S&&S.isCancellationRequested)return Promise.reject(T.canceled());const p=n.serializeRequestArguments(m,this._uriReplacer),w=++this._lastMessageId,R=String(w),F=new D.LazyPromise;S&&S.onCancellationRequested(()=>{const oe=n.serializeCancel(w);this._logger&&this._logger.logOutgoing(oe.byteLength,w,0,"cancel"),this._protocol.send(n.serializeCancel(w))}),this._pendingRPCReplies[R]=F,this._onWillSendRequest(w);const z=n.serializeRequest(w,o,c,p,!!S);return this._logger&&this._logger.logOutgoing(z.byteLength,w,0,`request: ${(0,P.getStringIdentifierForProxy)(o)}.${c}(`,m),this._protocol.send(z),F}}e.RPCProtocol=l,C=_,l.UNRESPONSIVE_TIME=3*1e3;class d{constructor(o,c){this._buff=o,this._offset=c}static alloc(o,c,m){let S=new d(s.VSBuffer.alloc(m+1+4),0);return S.writeUInt8(o),S.writeUInt32(c),S}static read(o,c){return new d(o,c)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const c=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,c}static sizeMixedArray(o,c){let m=0;m+=1;for(let S=0,p=o.length;S<p;S++){const w=o[S],R=c[S];switch(m+=1,R){case 1:m+=this.sizeLongString(w);break;case 2:m+=this.sizeVSBuffer(w);break;case 3:break}}return m}writeMixedArray(o,c){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let m=0,S=o.length;m<S;m++){const p=o[m];switch(c[m]){case 1:this.writeUInt8(1),this.writeLongString(p);break;case 2:this.writeUInt8(2),this.writeVSBuffer(p);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let c=new Array(o);for(let m=0;m<o;m++)switch(this.readUInt8()){case 1:c[m]=this.readLongString();break;case 2:c[m]=this.readVSBuffer();break;case 3:c[m]=void 0;break}return c}}class n{static _arrayContainsBufferOrUndefined(o){for(let c=0,m=o.length;c<m;c++)if(o[c]instanceof s.VSBuffer||typeof o[c]=="undefined")return!0;return!1}static serializeRequestArguments(o,c){if(this._arrayContainsBufferOrUndefined(o)){let m=[],S=[];for(let p=0,w=o.length;p<w;p++){const R=o[p];R instanceof s.VSBuffer?(m[p]=R,S[p]=2):typeof R=="undefined"?(m[p]=s.VSBuffer.alloc(0),S[p]=3):(m[p]=s.VSBuffer.fromString(h(R,c)),S[p]=1)}return{type:"mixed",args:m,argsType:S}}return{type:"simple",args:h(o,c)}}static serializeRequest(o,c,m,S,p){return S.type==="mixed"?this._requestMixedArgs(o,c,m,S.args,S.argsType,p):this._requestJSONArgs(o,c,m,S.args,p)}static _requestJSONArgs(o,c,m,S,p){const w=s.VSBuffer.fromString(m),R=s.VSBuffer.fromString(S);let F=0;F+=d.sizeUInt8(),F+=d.sizeShortString(w),F+=d.sizeLongString(R);let z=d.alloc(p?2:1,o,F);return z.writeUInt8(c),z.writeShortString(w),z.writeLongString(R),z.buffer}static deserializeRequestJSONArgs(o){const c=o.readUInt8(),m=o.readShortString(),S=o.readLongString();return{rpcId:c,method:m,args:JSON.parse(S)}}static _requestMixedArgs(o,c,m,S,p,w){const R=s.VSBuffer.fromString(m);let F=0;F+=d.sizeUInt8(),F+=d.sizeShortString(R),F+=d.sizeMixedArray(S,p);let z=d.alloc(w?4:3,o,F);return z.writeUInt8(c),z.writeShortString(R),z.writeMixedArray(S,p),z.buffer}static deserializeRequestMixedArgs(o){const c=o.readUInt8(),m=o.readShortString(),S=o.readMixedArray(),p=new Array(S.length);for(let w=0,R=S.length;w<R;w++){const F=S[w];typeof F=="string"?p[w]=JSON.parse(F):p[w]=F}return{rpcId:c,method:m,args:p}}static serializeAcknowledged(o){return d.alloc(5,o,0).buffer}static serializeCancel(o){return d.alloc(6,o,0).buffer}static serializeReplyOK(o,c,m){return typeof c=="undefined"?this._serializeReplyOKEmpty(o):c instanceof s.VSBuffer?this._serializeReplyOKVSBuffer(o,c):this._serializeReplyOKJSON(o,f(c,m))}static _serializeReplyOKEmpty(o){return d.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,c){let m=0;m+=d.sizeVSBuffer(c);let S=d.alloc(8,o,m);return S.writeVSBuffer(c),S.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,c){const m=s.VSBuffer.fromString(c);let S=0;S+=d.sizeLongString(m);let p=d.alloc(9,o,S);return p.writeLongString(m),p.buffer}static deserializeReplyOKJSON(o){const c=o.readLongString();return JSON.parse(c)}static serializeReplyErr(o,c){return c?this._serializeReplyErrEror(o,c):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,c){const m=s.VSBuffer.fromString(f(T.transformErrorForSerialization(c),null));let S=0;S+=d.sizeLongString(m);let p=d.alloc(10,o,S);return p.writeLongString(m),p.buffer}static deserializeReplyErrError(o){const c=o.readLongString();return JSON.parse(c)}static _serializeReplyErrEmpty(o){return d.alloc(11,o,0).buffer}}var t;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(t||(t={}));var r;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(r||(r={}))}),define(me[258],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(me[259],ge([0,1,11,8,9,2,4,258]),function(G,e,b,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(s,C){this.localUserHome=s,this.remoteAgentService=C,this.resolveOS=(async()=>{const f=await this.remoteAgentService.getEnvironment();return(f==null?void 0:f.os)||T.OS})(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(f==null?void 0:f.userHome)||s})()}async userHome(s){return(s==null?void 0:s.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(s=>s===1?I.win32:I.posix)}async fileURI(s){let C="";if(await this.resolveOS===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const h=s.indexOf("/",2);h===-1?(C=s.substring(2),s="/"):(C=s.substring(2,h),s=s.substring(h)||"/")}return A.URI.from({scheme:b.Schemas.file,authority:C,path:s,query:"",fragment:""})}};D=je([Be(1,k.IRemoteAgentService)],D),e.AbstractPathService=D}),define(me[31],ge([0,1,15,33,23,29,10,4,8,19]),function(G,e,b,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const s="\u27EA ",C=" characters skipped \u27EB",f=(s.length+C.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var h;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var a;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(a=e.QueryType||(e.QueryType={}));function u(U){return!!U.preview}e.resultIsMatch=u;function E(U){return!!U.resource}e.isFileMatch=E;function v(U){return!!U.message}e.isProgressMessage=v;var _;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(_=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(M){this.resource=M,this.results=[]}}e.FileMatch=g;class l{constructor(M,L,N){this.ranges=L;const O=Array.isArray(L)?L:[L];if(N&&N.matchLines===1&&d(O)){M=(0,y.getNLines)(M,N.matchLines);let B="",q=0,Q=0;const he=Math.floor(N.charsPerLine/5),ve=[];for(const Ie of O){const ke=Math.max(Ie.startColumn-he,0),Le=Ie.startColumn+N.charsPerLine;if(ke>Q+he+f){const V=s+(ke-Q)+C;B+=V+M.slice(ke,Le),q+=ke-(Q+V.length)}else B+=M.slice(Q,Le);ve.push(new t(0,Ie.startColumn-q,Ie.endColumn-q)),Q=Le}this.preview={text:B,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const B=Array.isArray(L)?L[0].startLineNumber:L.startLineNumber;this.preview={text:M,matches:(0,b.mapArrayOrNot)(L,q=>new n(q.startLineNumber-B,q.startColumn,q.endLineNumber-B,q.endColumn))}}}}e.TextSearchMatch=l;function d(U){const M=U[0].startLineNumber;for(const L of U)if(L.startLineNumber!==M||L.endLineNumber!==M)return!1;return!0}class n{constructor(M,L,N,O){this.startLineNumber=M,this.startColumn=L,this.endLineNumber=N,this.endColumn=O}}e.SearchRange=n;class t extends n{constructor(M,L,N){super(M,L,M,N)}}e.OneLineRange=t;var r;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function i(U,M=!0){const L=U&&U.files&&U.files.exclude,N=M&&U&&U.search&&U.search.exclude;if(!(!L&&!N)){if(!L||!N)return L||N;let O=Object.create(null);return O=T.mixin(O,T.deepClone(L)),O=T.mixin(O,T.deepClone(N),!0),O}}e.getExcludes=i;function o(U,M){return U.excludePattern&&I.match(U.excludePattern,M)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&I.match(U.includePattern,M)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(L=>{const N=L.folder.fsPath;if(A.isEqualOrParent(M,N)){const O=D.relative(N,M);return!L.includePattern||!!I.match(L.includePattern,O)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var c;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(c=e.SearchErrorCode||(e.SearchErrorCode={}));class m extends Error{constructor(M,L){super(M);this.code=L}}e.SearchError=m;function S(U){const M=U.message;if((0,P.isPromiseCanceledError)(U))return new m(M,c.canceled);try{const L=JSON.parse(M);return new m(L.message,L.code)}catch(L){return new m(M,c.other)}}e.deserializeSearchError=S;function p(U){const M={message:U.message,code:U.code};return new Error(JSON.stringify(M))}e.serializeSearchError=p;function w(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=w;function R(U){return U.type==="success"}e.isSerializedSearchSuccess=R;function F(U){return!!U.path}e.isSerializedFileMatch=F;function z(U,M){const L=U.searchPath?U.searchPath:U.relativePath;return(0,y.fuzzyContains)(L,M)}e.isFilePatternMatch=z;class oe{constructor(M){this.path=M,this.results=[]}addMatch(M){this.results.push(M)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=oe;function j(U,M){const L=Object.assign(Object.assign({},U||{}),M||{});return Object.keys(L).filter(N=>{const O=L[N];return typeof O=="boolean"&&O})}e.resolvePatternsForProvider=j;class W{constructor(M,L){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},M.excludePattern||{}),L.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let N=M.includePattern;L.includePattern&&(N?N=Object.assign(Object.assign({},N),L.includePattern):N=L.includePattern),N&&(this._parsedIncludeExpression=I.parse(N))}includedInQuerySync(M,L,N){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(M,L,N)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(M,L,N))}includedInQuery(M,L,N){return Promise.resolve(this._parsedExcludeExpression(M,L,N)).then(B=>!!B).then(B=>B?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(M,L,N)).then(q=>!!q):Promise.resolve(!0)).then(B=>B)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=W;function $(U){for(const M in U)if(typeof U[M]!="boolean")return!0;return!1}}),define(me[32],ge([0,1,15,16,21,3,24,11,72,25,10,12,2,167,4,13,186,60,61,27,14,7,31,5]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E,v,_,g,l,d,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(R,F,z){return new P.ExtUri(oe=>m(oe,z)).isEqual(R,F)}function i(R,F,z){return r(R.uri,F.uri,z)?0:(0,s.compare)(R.uri.toString(),F.uri.toString())}function o(R,F,z){return R.index!==F.index?R.index<F.index?-1:1:r(R.uri,F.uri,z)?(0,s.compare)(R.name,F.name):(0,s.compare)(R.uri.toString(),F.uri.toString())}function c(R,F,z,oe){const j=R.slice(0).sort(($,U)=>z($,U,oe)),W=F.slice(0).sort(($,U)=>z($,U,oe));return(0,b.delta)(j,W,($,U)=>z($,U,oe))}function m(R,F){const z=F.getCapabilities(R.scheme);return!(z&&z&1024)}class S extends v.Workspace{constructor(F,z,oe,j,W,$){super(F,oe.map(U=>new v.WorkspaceFolder(U)),j,$);this._name=z,this._isUntitled=W,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris($),oe.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(F,z,oe,j){if(!F)return{workspace:null,added:[],removed:[]};const{id:W,name:$,folders:U,configuration:M,isUntitled:L}=F,N=[],O=z;z?U.forEach((he,ve)=>{const Ie=f.URI.revive(he.uri),ke=S._findFolder(oe||z,Ie,j);ke?(ke.name=he.name,ke.index=he.index,N.push(ke)):N.push({uri:Ie,name:he.name,index:ve})}):N.push(...U.map(({uri:he,name:ve,index:Ie})=>({uri:f.URI.revive(he),name:ve,index:Ie}))),N.sort((he,ve)=>he.index<ve.index?-1:1);const B=new S(W,$,N,M?f.URI.revive(M):null,!!L,he=>m(he,j)),{added:q,removed:Q}=c(O?O.workspaceFolders:[],B.workspaceFolders,i,j);return{workspace:B,added:q,removed:Q}}static _findFolder(F,z,oe){for(let j=0;j<F.folders.length;j++){const W=F.workspaceFolders[j];if(r(W.uri,z,oe))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,z){return z&&this._structure.get(F)&&(F=(0,P.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let p=class{constructor(F,z,oe,j){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidReceieveWorkspaceTrust=new A.Emitter,this.onDidReceiveWorkspaceTrust=this._onDidReceieveWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=j,this._extHostFileSystemInfo=oe,this._requestIdProvider=new D.Counter,this._barrier=new I.Barrier,this._proxy=F.getProxy(t.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(t.MainContext.MainThreadMessageService);const W=z.workspace;this._confirmedWorkspace=W?new S(W.id,W.name,[],W.configuration?f.URI.revive(W.configuration):null,!!W.isUntitled,$=>m($,oe)):void 0}$initializeWorkspace(F,z){this._trusted=z,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?f.URI.from({scheme:k.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,z,oe,...j){const W=[];if(Array.isArray(j)&&j.forEach(N=>{f.URI.isUri(N.uri)&&!W.some(O=>r(O.uri,N.uri,this._extHostFileSystemInfo))&&W.push({uri:N.uri,name:N.name||(0,P.basenameOrAuthority)(N.uri)})}),this._unconfirmedWorkspace||[z,oe].some(N=>typeof N!="number"||N<0)||oe===0&&W.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+oe>$.length)return!1;const U=$.slice(0);U.splice(z,oe,...W.map(N=>({uri:N.uri,name:N.name||(0,P.basenameOrAuthority)(N.uri),index:void 0})));for(let N=0;N<U.length;N++){const O=U[N];if(U.some((B,q)=>q!==N&&r(O.uri,B.uri,this._extHostFileSystemInfo)))return!1}U.forEach((N,O)=>N.index=O);const{added:M,removed:L}=c($,U,o,this._extHostFileSystemInfo);if(M.length===0&&L.length===0)return!1;if(this._proxy){const N=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(N,z,oe,W).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,h.localize)(0,null,N,O.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(F,z){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,z)}async getWorkspaceFolder2(F,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,z)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!!this._actualWorkspace){const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}}getRelativePath(F,z){let oe,j="";if(typeof F=="string"?(oe=f.URI.file(F),j=F):typeof F!="undefined"&&(oe=F,j=F.fsPath),!oe)return j;const W=this.getWorkspaceFolder(oe,!0);if(!W)return j;typeof z=="undefined"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let $=(0,P.relativePath)(W.uri,oe);return z&&W.name&&($=`${W.name}/${$}`),$}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:z,added:oe,removed:j}=S.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:oe,removed:j}))}findFiles(F,z,oe,j,W=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let $;if(z===null?$=!1:z&&(typeof z=="string"?$=z:$=z.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:M}=w(F);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)(M),(0,C.withUndefinedAsNull)($),(0,C.withUndefinedAsNull)(oe),W).then(L=>Array.isArray(L)?L.map(N=>f.URI.revive(N)):[])}async findTextInFiles(F,z,oe,j,W=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),U=typeof z.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:M,folder:L}=w(z.include),N=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,O={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:U,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:M,excludePattern:N},B=!1;if(this._activeSearchCallbacks[$]=q=>{if(!B){const Q=f.URI.revive(q.resource);q.results.forEach(he=>{(0,n.resultIsMatch)(he)?oe({uri:Q,preview:{text:he.preview.text,matches:(0,b.mapArrayOrNot)(he.preview.matches,ve=>new d.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,b.mapArrayOrNot)(he.ranges,ve=>new d.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):oe({uri:Q,text:he.text,lineNumber:he.lineNumber})})}},W.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(F,(0,C.withUndefinedAsNull)(L),O,$,W);return delete this._activeSearchCallbacks[$],q||{}}catch(q){throw delete this._activeSearchCallbacks[$],q}}$handleTextSearchResult(F,z){this._activeSearchCallbacks[z]&&this._activeSearchCallbacks[z](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){const z=this._proxy.$requestWorkspaceTrust(F);return(F==null?void 0:F.modal)?z:Promise.resolve(this._trusted)}$onDidReceiveWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidReceieveWorkspaceTrust.fire())}};p=je([Be(0,l.IExtHostRpcService),Be(1,g.IExtHostInitDataService),Be(2,_.IExtHostFileSystemInfo),Be(3,u.ILogService)],p),e.ExtHostWorkspace=p,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function w(R){let F,z;return R&&(typeof R=="string"?F=R:(F=R.pattern,z=R.baseFolder||f.URI.file(R.base))),{includePattern:F,folder:z}}}),define(me[35],ge([0,1,23,3,32,5,7,188,82,12,16,4,14,13,2]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(t,r){if(r){const i=r.split(".");let o=t;for(let c=0;o&&c<i.length;c++)o=o[i[c]];return o}}function E(t){return t instanceof a.URI}function v(t){return t&&t.uri instanceof a.URI&&t.languageId&&typeof t.languageId=="string"}function _(t){return t&&!t.uri&&t.languageId&&typeof t.languageId=="string"}function g(t){return t&&t.uri instanceof a.URI&&(!t.name||typeof t.name=="string")&&(!t.index||typeof t.index=="number")}function l(t){if(E(t))return{resource:t};if(v(t))return{resource:t.uri,overrideIdentifier:t.languageId};if(_(t))return{overrideIdentifier:t.languageId};if(g(t))return{resource:t.uri};if(t===null)return{resource:null}}let d=class{constructor(r,i,o){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=o,this._barrier=new s.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new n(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(r,i))}};d=je([Be(0,f.IExtHostRpcService),Be(1,T.IExtHostWorkspace),Be(2,h.ILogService)],d),e.ExtHostConfiguration=d;class n{constructor(r,i,o,c){this._onDidChangeConfiguration=new I.Emitter,this._proxy=r,this._logService=c,this._extHostWorkspace=i,this._configuration=k.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,o))}getConfiguration(r,i,o){const c=l(i)||{},m=this._toReadonlyValue(r?u(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,c,o==null?void 0:o.identifier);function S(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const p={has(w){return typeof u(m,w)!="undefined"},get:(w,R)=>{this._validateConfigurationAccess(r?`${r}.${w}`:w,c,o==null?void 0:o.identifier);let F=u(m,w);if(typeof F=="undefined")F=R;else{let z;const oe=(j,W)=>{let $;const U=()=>{z=z||(0,b.deepClone)(m),$=$||u(z,W)};return(0,P.isObject)(j)?new Proxy(j,{get:(M,L)=>{if(typeof L=="string"&&L.toLowerCase()==="tojson")return U(),()=>$;if(z)return $=$||u(z,W),$[L];const N=M[L];return typeof L=="string"?oe(N,`${W}.${L}`):N},set:(M,L,N)=>(U(),$&&($[L]=N),!0),deleteProperty:(M,L)=>(U(),$&&delete $[L],!0),defineProperty:(M,L,N)=>(U(),$&&Object.defineProperty($,L,N),!0)}):j};F=oe(F,w)}return F},update:(w,R,F,z)=>{w=r?`${r}.${w}`:w;const oe=S(F);return R!==void 0?this._proxy.$updateConfigurationOption(oe,w,R,c,z):this._proxy.$removeConfigurationOption(oe,w,c,z)},inspect:w=>{var R,F,z,oe,j,W,$,U;w=r?`${r}.${w}`:w;const M=(0,b.deepClone)(this._configuration.inspect(w,c,this._extHostWorkspace.workspace));if(M)return{key:w,defaultValue:(R=M.default)===null||R===void 0?void 0:R.value,globalValue:(F=M.user)===null||F===void 0?void 0:F.value,workspaceValue:(z=M.workspace)===null||z===void 0?void 0:z.value,workspaceFolderValue:(oe=M.workspaceFolder)===null||oe===void 0?void 0:oe.value,defaultLanguageValue:(j=M.default)===null||j===void 0?void 0:j.override,globalLanguageValue:(W=M.user)===null||W===void 0?void 0:W.override,workspaceLanguageValue:($=M.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(U=M.workspaceFolder)===null||U===void 0?void 0:U.override,languageIds:M.overrideIdentifiers}}};return typeof m=="object"&&(0,b.mixin)(p,m,!1),Object.freeze(p)}_toReadonlyValue(r){const i=o=>(0,P.isObject)(o)?new Proxy(o,{get:(c,m)=>i(c[m]),set:(c,m,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(c,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(c,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return i(r)}_validateConfigurationAccess(r,i,o){const c=D.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),m=o?`[${o.value}] `:"";if(c===4){typeof(i==null?void 0:i.resource)=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){(i==null?void 0:i.resource)&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const o=new k.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,m)=>o.affectsConfiguration(c,l(m))})}_toMap(r){return r.reduce((i,o)=>(i.set(o[0],o[1]),i),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[66],ge([0,1,2,16,3,5,7,32,39,35,21,34,14,27,4,11,9,13,63,209,19]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E,v,_,g,l){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var n;(function(j){function W(U){if(U!=null)return U}j.from=W;function $(U){if(U!=null)return U}j.to=$})(n=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var t;(function(j){function W(U){if(U!=null)return U}j.from=W;function $(U){if(U!=null)return U}j.to=$})(t=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(j){function W(U){if(U!=null)return U}j.from=W;function $(U){if(U!=null)return U}j.to=$})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(j){function W(M){if(M){const L=M;return L&&!!L.process}else return!1}j.is=W;function $(M){if(M!=null){const L={process:M.process,args:M.args};return M.options&&(L.options=r.from(M.options)),L}}j.from=$;function U(M){if(M!=null)return new y.ProcessExecution(M.process,M.args,M.options)}j.to=U})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(j){function W(U){if(U!=null)return U}j.from=W;function $(U){if(U!=null)return U}j.to=$})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(j){function W(M){if(M){const L=M;return L&&(!!L.commandLine||!!L.command)}else return!1}j.is=W;function $(M){if(M!=null){const L={};return M.commandLine!==void 0?L.commandLine=M.commandLine:(L.command=M.command,L.args=M.args),M.options&&(L.options=o.from(M.options)),L}}j.from=$;function U(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new y.ShellExecution(M.commandLine,M.options):new y.ShellExecution(M.command,M.args?M.args:[],M.options)}j.to=U})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(j){function W(M){if(M){let L=M;return L&&L.customExecution==="customExecution"}else return!1}j.is=W;function $(M){return{customExecution:"customExecution"}}j.from=$;function U(M,L){return L.get(M)}j.to=U})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var S;(function(j){function W($,U){let M;return $.scope!==void 0&&typeof $.scope!="number"?M=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===y.TaskScope.Workspace&&U&&U.workspaceFile?M=U.workspaceFile:M=g.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:M}}j.from=W})(S=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(j){function W(M,L){if(M==null)return[];const N=[];for(let O of M){const B=$(O,L);B&&N.push(B)}return N}j.fromMany=W;function $(M,L){if(M!=null){let N;M.execution instanceof y.ProcessExecution?N=i.from(M.execution):M.execution instanceof y.ShellExecution?N=c.from(M.execution):M.execution&&M.execution instanceof y.CustomExecution&&(N=m.from(M.execution));const O=n.from(M.definition);let B;if(M.scope?typeof M.scope=="number"?B=M.scope:B=M.scope.uri:B=y.TaskScope.Workspace,!(!O||!B)){const q=M.group?M.group.id:void 0;return{_id:M._id,definition:O,name:M.name,source:{extensionId:L.identifier.value,label:M.source,scope:B},execution:N,isBackground:M.isBackground,group:q,presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}}}j.from=$;async function U(M,L,N){if(M!=null){let O;i.is(M.execution)?O=i.to(M.execution):c.is(M.execution)?O=c.to(M.execution):m.is(M.execution)&&(O=m.to(M._id,N));const B=n.to(M.definition);let q;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?q=M.source.scope:q=await L.resolveWorkspaceFolder(b.URI.revive(M.source.scope)):q=y.TaskScope.Workspace),!(!B||!q)){const Q=new y.Task(B,q,M.name,M.source.label,O,M.problemMatchers);return M.isBackground!==void 0&&(Q.isBackground=M.isBackground),M.group!==void 0&&(Q.group=y.TaskGroup.from(M.group)),M.presentationOptions&&(Q.presentationOptions=t.to(M.presentationOptions)),M._id&&(Q._id=M._id),M.detail&&(Q.detail=M.detail),Q}}}j.to=U})(p=e.TaskDTO||(e.TaskDTO={}));var w;(function(j){function W(U){return U}j.from=W;function $(U){if(!!U)return Object.assign(Object.create(null),U)}j.to=$})(w=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(W,$,U){this._id=$,this._task=U,d.set(this,void 0),tt(this,d,W,"f")}get task(){return this._task}terminate(){Ue(this,d,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}d=new WeakMap;var F;(function(j){function W($){return{id:$._id,task:void 0}}j.from=W})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let z=class{constructor(W,$,U,M,L,N,O,B){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=W.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=M,this._configurationService=L,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=B,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,$,U){if(!U)return new y.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:$,provider:U,extension:W}),this._proxy.$registerTaskProvider(M,$),new y.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(W,$){this._proxy.$registerTaskSystem(W,$)}fetchTasks(W){return this._proxy.$fetchTasks(w.from(W)).then(async $=>{const U=[];for(let M of $){const L=await p.to(M,this._workspaceProvider,this._providedCustomExecutions2);L&&U.push(L)}return U})}get taskExecutions(){const W=[];return this._taskExecutions.forEach($=>W.push($)),W}terminateTask(W){if(!(W instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,$,U){const M=this._providedCustomExecutions2.get(W.id);if(M){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,M),this._terminalService.attachPtyToTerminal($,await M.callback(U))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const $=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const $=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:$,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const $=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:W.exitCode})}$provideTasks(W,$){const U=this._handlers.get(W);if(!U)return Promise.reject(new Error("no handler found"));const M=[],L=(0,I.asPromise)(()=>U.provider.provideTasks(s.CancellationToken.None)).then(N=>this.provideTasksInternal($,M,U,N));return new Promise(N=>{L.then(O=>{Promise.all(M).then(()=>{N(O)})})})}async $resolveTask(W,$){const U=this._handlers.get(W);if(!U)return Promise.reject(new Error("no handler found"));if($.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${U.type}].`);const M=await p.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const L=await U.provider.resolveTask(M,s.CancellationToken.None);if(!!L){this.checkDeprecation(L,U);const N=p.from(L,U.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(L.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(N.execution)&&await this.addCustomExecution(N,L,!0),await this.resolveTaskInternal(N)}}nextHandle(){return this._handleCounter++}async addCustomExecution(W,$,U){const M=await this._proxy.$createTaskId(W);!U&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,$.execution)}async getTaskExecution(W,$){if(typeof W=="string"){const L=this._taskExecutionPromises.get(W);if(!L)throw new Error("Unexpected: The specified task is missing an execution");return L}let U=this._taskExecutionPromises.get(W.id);if(U)return U;const M=new Promise(async(L,N)=>{const O=$||await p.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);O?L(new R(this,W.id,O)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,M),M.then(L=>(this._taskExecutions.set(W.id,L),L),L=>Promise.reject(L))}checkDeprecation(W,$){W._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let U=this._notProvidedCustomExecutions.values(),M=U.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=U.next()}};z=je([Be(0,f.IExtHostRpcService),Be(1,h.IExtHostInitDataService),Be(2,k.IExtHostWorkspace),Be(3,D.IExtHostDocumentsAndEditors),Be(4,P.IExtHostConfiguration),Be(5,C.IExtHostTerminalService),Be(6,v.ILogService),Be(7,_.IExtHostApiDeprecationService)],z),e.ExtHostTaskBase=z;let oe=class extends z{constructor(W,$,U,M,L,N,O,B){super(W,$,U,M,L,N,O,B);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(W,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const U=p.from($,W);if(U===void 0)throw new Error("Task is not valid");if(m.is(U.execution))await this.addCustomExecution(U,$,!1);else throw new l.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),$);return this._proxy.$executeTask(U).catch(L=>{throw new Error(L)}),M}provideTasksInternal(W,$,U,M){const L=[];if(M)for(let N of M){this.checkDeprecation(N,U),(!N.definition||!W[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const O=p.from(N,U.extension);O&&m.is(O.execution)?(L.push(O),$.push(this.addCustomExecution(O,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:L,extension:U.extension}}async resolveTaskInternal(W){if(m.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,$){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(W,$,U){}};oe=je([Be(0,f.IExtHostRpcService),Be(1,h.IExtHostInitDataService),Be(2,k.IExtHostWorkspace),Be(3,D.IExtHostDocumentsAndEditors),Be(4,P.IExtHostConfiguration),Be(5,C.IExtHostTerminalService),Be(6,v.ILogService),Be(7,_.IExtHostApiDeprecationService)],oe),e.WorkerExtHostTask=oe,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)},Vt=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(b[I[T]]=G[I[T]]);return b};define(me[260],ge([0,1,15,16,22,21,3,70,54,6,23,12,2,30,5,39,14,86,20,7,32,222,122]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E,v,_,g,l,d,n){"use strict";var t,r,i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const c=(U,M)=>`${U}:${M.toString()}`;let m=class{constructor(M,L,N){this.documents=L,this.workspace=N,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new d.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(a.MainContext.MainThreadTesting),this.runQueue=new S(this.proxy),this.workspaceObservers=new W(this.proxy),this.textDocumentObservers=new $(this.proxy,L)}registerTestController(M,L){const N=(0,h.generateUuid)();this.controllers.set(N,{instance:L,extensionId:M}),this.proxy.$registerTestController(N);const O=[...this.testControllers.keys()];return setTimeout(()=>{var B;for(const q of O)(B=this.testControllers.get(q))===null||B===void 0||B.subscribeFn(N,L)},0),new g.Disposable(()=>{this.controllers.delete(N),this.proxy.$unregisterTestController(N)})}createTextDocumentTestObserver(M){return this.textDocumentObservers.checkout(M.uri)}createWorkspaceTestObserver(M){return this.workspaceObservers.checkout(M.uri)}async runTests(M,L=A.CancellationToken.None){const N=O=>O.map(this.getInternalTestForReference,this).filter(C.isDefined).map(B=>({src:B.src,testId:B.item.extId}));await this.proxy.$runTests({exclude:M.exclude?N(M.exclude).map(O=>O.testId):void 0,tests:N(M.tests),debug:M.debug},L)}createTestRunTask(M,L,N,O=!0){return this.runQueue.createTestRunTask(M,L,N,O)}$publishTestResults(M){this.results=Object.freeze(M.map(L=>(0,s.deepFreeze)(_.TestResults.to(L))).concat(this.results).sort((L,N)=>N.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(M,L){const N=f.URI.revive(L),O=c(M,N);if(!this.testControllers.has(O)){const B=new A.CancellationTokenSource;let q;if(M===1){let Ie=this.documents.getDocument(N);if(!Ie){const ke=new P.DisposableStore;Ie=await new Promise(Le=>{ke.add((0,I.disposableTimeout)(()=>Le(void 0),5e3)),ke.add(this.documents.onDidAddDocuments(V=>{const J=V.find(ee=>ee.document.uri.toString()===N.toString());J&&Le(J)}))}).finally(()=>ke.dispose())}if(Ie){const ke=await this.workspace.getWorkspaceFolder2(N,!1);q=Le=>Le.createDocumentTestRoot?Le.createDocumentTestRoot(Ie.document,B.token):(0,e.createDefaultDocumentTestRoot)(Le,Ie.document,ke,B.token)}}else{const Ie=await this.workspace.getWorkspaceFolder2(N,!1);Ie&&(q=ke=>ke.createWorkspaceTestRoot(Ie,B.token))}if(!!q){const Q=async(Ie,ke)=>{try{const Le=await q(ke);Le&&ve.addRoot(Le,Ie)}catch(Le){console.error(Le)}},he=new P.DisposableStore,ve=he.add(this.ownedTests.createForHierarchy(Ie=>this.proxy.$publishDiff(M,L,Ie)));he.add((0,P.toDisposable)(()=>B.dispose(!0)));for(const[Ie,ke]of this.controllers)Q(Ie,ke.instance);ve.pushDiff([3,-1]),this.testControllers.set(O,{store:he,collection:ve,subscribeFn:Q})}}}async $expandTest(M,L){const N=(0,b.mapFind)(this.testControllers.values(),O=>O.collection.treeId===M.src.tree?O:void 0);await(N==null?void 0:N.collection.expand(M.testId,L<0?Infinity:L)),this.flushCollectionDiffs()}$unsubscribeFromTests(M,L){var N;const O=f.URI.revive(L),B=c(M,O);(N=this.testControllers.get(B))===null||N===void 0||N.store.dispose(),this.testControllers.delete(B)}$acceptDiff(M,L,N){M===1?this.textDocumentObservers.acceptDiff(f.URI.revive(L),N):this.workspaceObservers.acceptDiff(f.URI.revive(L),N)}async $runTestsForProvider(M,L){const N=this.controllers.get(M.tests[0].src.controller);if(!!N){const O=M.tests.map(({testId:Q,src:he})=>this.ownedTests.getTestById(Q,he==null?void 0:he.tree)).filter(C.isDefined).map(([Q,he])=>he),B=M.excludeExtIds.map(Q=>this.ownedTests.getTestById(Q)).filter(C.isDefined).filter(([Q,he])=>O.some(ve=>Q.comparePositions(ve,he)===1));if(!!O.length){const q={tests:O.map(Q=>F.unwrap(Q.actual)),exclude:B.map(([,Q])=>F.unwrap(Q.actual)),debug:M.debug};await this.runQueue.enqueueRun({dto:p.fromInternal(M),token:L,extensionId:N.extensionId,req:q,doRun:()=>N.instance.runTests(q,L)})}}}$lookupTest(M){const L=this.ownedTests.getTestById(M.testId);if(!L)return Promise.resolve(void 0);const N=L[1],{actual:O,discoverCts:B,expandLevels:q}=N,Q=Vt(N,["actual","discoverCts","expandLevels"]);return Promise.resolve(Q)}flushCollectionDiffs(){for(const{collection:M}of this.testControllers.values())M.flushDiff()}getInternalTestForReference(M){var L,N;return(N=(L=this.workspaceObservers.getMirroredTestDataByReference(M))!==null&&L!==void 0?L:(0,b.mapFind)(this.testControllers.values(),O=>O.collection.getTestByReference(M)))!==null&&N!==void 0?N:this.textDocumentObservers.getMirroredTestDataByReference(M)}};m=je([Be(0,E.IExtHostRpcService),Be(1,u.IExtHostDocumentsAndEditors),Be(2,l.IExtHostWorkspace)],m),e.ExtHostTesting=m;class S{constructor(M){this.proxy=M,this.state=new Map}enqueueRun(M){let L=this.state.get(M.extensionId);L||(L={queue:[],current:void 0},this.state.set(M.extensionId,L));const N=new I.DeferredPromise,O=()=>{const B=[],q=new Set;L.current={publicReq:M.req,factory:Q=>{const he=new w(Q,M.dto,q,this.proxy);return B.push(he),M.token.onCancellationRequested(()=>he.end()),he}},this.invokeRunner(M.extensionId,M.dto.id,M.doRun,B).finally(()=>N.complete())};return L.queue.push(O),L.queue.length===1&&O(),N.p}createTestRunTask(M,L,N,O){var B,q;const Q=this.state.get(M);if((Q==null?void 0:Q.current.publicReq)===L)return Q.current.factory(N);const he=p.fromPublic(L),ve=new w(N,he,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:L.debug,exclude:(q=(B=L.exclude)===null||B===void 0?void 0:B.map(Ie=>Ie.id))!==null&&q!==void 0?q:[],id:he.id,tests:L.tests.map(Ie=>Ie.id),persist:O}),ve.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(he.id)),ve}invokeRunner(M,L,N,O){try{const B=N();return(0,I.isThenable)(B)?B.then(()=>this.handleInvokeResult(M,L,O,void 0)).catch(q=>this.handleInvokeResult(M,L,O,q)):this.handleInvokeResult(M,L,O,void 0)}catch(B){return this.handleInvokeResult(M,L,O,B)}}async handleInvokeResult(M,L,N,O){const B=this.state.get(M);!B||(B.queue.shift(),B.queue.length>0?B.queue[0]():this.state.delete(M),await Promise.all(N.map(q=>q.onEnd.wait())))}}class p{constructor(M,L,N){this.id=M,this.include=L,this.exclude=N}static fromPublic(M){var L,N;return new p((0,h.generateUuid)(),new Set(M.tests.map(O=>O.id)),new Set((N=(L=M.exclude)===null||L===void 0?void 0:L.map(O=>O.id))!==null&&N!==void 0?N:D.Iterable.empty()))}static fromInternal(M){return new p(M.runId,new Set(M.tests.map(L=>L.testId)),new Set(M.excludeExtIds))}isIncluded(M){for(let L=M;L;L=L.parent){if(this.include.has(L.id))return!0;if(this.exclude.has(L.id))return!1}return!0}}class w{constructor(M,L,N,O){this.name=M,t.set(this,void 0),r.set(this,void 0),i.set(this,(0,h.generateUuid)()),o.set(this,void 0),this.onEnd=new I.Barrier,tt(this,t,O,"f"),tt(this,r,L,"f"),tt(this,o,N,"f"),O.$startedTestRunTask(L.id,{id:Ue(this,i,"f"),name:M,running:!0})}setState(M,L,N){Ue(this,r,"f").isIncluded(M)&&(this.ensureTestIsKnown(M),Ue(this,t,"f").$updateTestStateInRun(Ue(this,r,"f").id,Ue(this,i,"f"),M.id,L,N))}appendMessage(M,L){Ue(this,r,"f").isIncluded(M)&&(this.ensureTestIsKnown(M),Ue(this,t,"f").$appendTestMessageInRun(Ue(this,r,"f").id,Ue(this,i,"f"),M.id,_.TestMessage.from(L)))}appendOutput(M){Ue(this,t,"f").$appendOutputToRun(Ue(this,r,"f").id,Ue(this,i,"f"),T.VSBuffer.fromString(M))}end(){Ue(this,t,"f").$finishedTestRunTask(Ue(this,r,"f").id,Ue(this,i,"f")),this.onEnd.open()}ensureTestIsKnown(M){const L=Ue(this,o,"f");if(!L.has(M.id)){const N=[];for(;N.unshift(_.TestItem.from(M)),!(L.has(M.id)||(L.add(M.id),!M.parent));)M=M.parent;Ue(this,t,"f").$addTestsToRun(Ue(this,r,"f").id,N)}}}t=new WeakMap,r=new WeakMap,i=new WeakMap,o=new WeakMap;const R=async(U,M,L,N)=>{if(!!L){const O=await U.createWorkspaceTestRoot(L,N);if(!!O)return N.onCancellationRequested(()=>{F.removeFilter(M)}),F.getWrapperForTestItem(O,M)}};e.createDefaultDocumentTestRoot=R;class F extends g.TestItemImpl{constructor(M,L,N){super(M.id,M.label,M.uri,void 0);if(this.actual=M,this.filterDocument=L,this.actualParent=N,!(M instanceof g.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${M.id} did not`);this.debuggable=M.debuggable,this.runnable=M.runnable,this.description=M.description,this.error=M.error,this.status=M.status,this.resolveHandler=M.resolveHandler;const O=(0,v.getPrivateApiFor)(this);(0,v.getPrivateApiFor)(M).bus.event(q=>{switch(q[0]){case 3:this[q[1]]=q[2];break;case 0:const Q=F.getWrapperForTestItem(q[1],this.filterDocument,this);(0,v.getPrivateApiFor)(Q).parent=M,Q.refreshMatch();break;default:O.bus.fire(q)}})}static removeFilter(M){this.wrapperMap.delete(M)}static getWrapperForTestItem(M,L,N){let O=this.wrapperMap.get(L);if(O==null?void 0:O.has(M))return O.get(M);O||(O=new WeakMap,this.wrapperMap.set(L,O));const B=new F(M,L,N);return O.set(M,B),B}static unwrap(M){return M instanceof F?M.actual:M}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var M;const L=this._cachedMatchesFilter;for(const O of this.actual.children.values()){const B=F.getWrapperForTestItem(O,this.filterDocument,this);B.hasNodeMatchingFilter?this.children.has(B.id)||this.addChild(B):B.dispose()}const N=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=N,N!==L&&((M=this.actualParent)===null||M===void 0||M.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,v.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,v.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=F,F.wrapperMap=new WeakMap;class z extends n.IncrementalChangeCollector{constructor(M){super();this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(M){this.added.add(M)}update(M){Object.assign(M.revived,_.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}if(this.updated.delete(M),M.parent&&this.alreadyRemoved.has(M.parent)){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:L,removed:N}=this;return{get added(){return[...M].map(O=>O.revived)},get updated(){return[...L].map(O=>O.revived)},get removed(){return[...N].map(O=>O.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class oe extends n.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(M){let L=[];for(const N of M){const O=this.items.get(N);O&&L.push(O.revived)}return L}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,L){return Object.assign(Object.assign({},M),{revived:_.TestItem.toPlain(M.item),depth:L?L.depth+1:0,children:new Set})}createChangeCollector(){return new z(this.changeEmitter)}}e.MirroredTestCollection=oe;class j{constructor(){this.resources=new Map}checkout(M){var L,N;const O=M.toString(),B=(L=this.resources.get(O))!==null&&L!==void 0?L:this.createObserverData(M);return(N=B.pendingDeletion)===null||N===void 0||N.dispose(),B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return B.tests.rootTestItems},dispose:(0,k.once)(()=>{--B.observers||(B.pendingDeletion=this.eventuallyDispose(M))})}}getMirroredTestDataByReference(M){for(const{tests:L}of this.resources.values()){const N=L.getMirroredTestDataByReference(M);if(N)return N}}eventuallyDispose(M){return(0,I.disposableTimeout)(()=>this.unlisten(M),10*1e3)}createObserverData(M){const L=new oe,N=this.listen(M,B=>L.apply(B)),O={observers:0,tests:L,listener:N};return this.resources.set(M.toString(),O),O}unlisten(M){var L;const N=M.toString(),O=this.resources.get(N);O&&(O.observers=-1,(L=O.pendingDeletion)===null||L===void 0||L.dispose(),O.listener.dispose(),this.resources.delete(N))}}class W extends j{constructor(M){super();this.proxy=M,this.diffListeners=new Map}acceptDiff(M,L){var N;(N=this.diffListeners.get(M.toString()))===null||N===void 0||N(L)}listen(M,L){this.proxy.$subscribeToDiffs(0,M);const N=M.toString();return this.diffListeners.set(N,L),new g.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,M),this.diffListeners.delete(N)})}}class $ extends j{constructor(M,L){super();this.proxy=M,this.documents=L,this.diffListeners=new Map}acceptDiff(M,L){var N;(N=this.diffListeners.get(M.toString()))===null||N===void 0||N(L)}listen(M,L){if(!this.documents.getDocument(M))return new g.Disposable(()=>{});const O=M.toString();return this.diffListeners.set(O,L),this.proxy.$subscribeToDiffs(1,M),new g.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,M),this.diffListeners.delete(O)})}}}),define(me[261],ge([0,1,15,53,33,75,24,11,8,25,10,12,2,140,173,83,60,214,259,31]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E,v,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(S,p,w,R){this.configurationService=S,this.workspaceContextService=p,this.editorGroupsService=w,this.pathService=R}text(S,p,w={}){S=this.getContentPattern(S,w);const R=this.configurationService.getValue(),F=p&&p.some(oe=>!this.configurationService.getValue({resource:oe}).search.useRipgrep),z=this.commonQuery(p==null?void 0:p.map(E.toWorkspaceFolder),w);return Object.assign(Object.assign({},z),{type:2,contentPattern:S,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:R.search.usePCRE2||F||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles})}getContentPattern(S,p){const w=this.configurationService.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},S),{wordSeparators:w.editor.wordSeparators});return this.isCaseSensitive(S,p)&&(R.isCaseSensitive=!0),this.isMultiline(S)&&(R.isMultiline=!0),R}file(S,p={}){const w=this.commonQuery(S,p);return Object.assign(Object.assign({},w),{type:1,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey})}handleIncludeExclude(S,p){return S?(S=Array.isArray(S)?S.map(i):i(S),p?this.parseSearchPaths(S):{pattern:n(...Array.isArray(S)?S:[S])}):{}}commonQuery(S=[],p={}){const w=this.handleIncludeExclude(p.includePattern,p.expandPatterns),R=this.handleIncludeExclude(p.excludePattern,p.expandPatterns),F=S.length>1,z=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,p,R)):S.map(W=>this.getFolderQueryForRoot(W,p,R,F))).filter(W=>!!W),oe={_reason:p._reason,folderQueries:z,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:R.pattern,includePattern:w.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const $=b.coalesce(b.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(L=>L.resource)))).filter(M=>(0,g.pathIncludedInQuery)(oe,M.fsPath)),U=this.commonQueryFromFileList($);return Object.assign(Object.assign({},oe),U)}const j=p.extraFileResources&&p.extraFileResources.filter(W=>(0,g.pathIncludedInQuery)(oe,W.fsPath));return oe.extraFileResources=j&&j.length?j:void 0,oe}commonQueryFromFileList(S){const p=[],w=new y.ResourceMap,R={};let F=!1;return S.forEach(z=>{var oe,j;if(z.scheme!==k.Schemas.walkThrough)if((0,P.isAbsolutePath)(z)){const $=(j=(oe=this.workspaceContextService.getWorkspaceFolder(z))===null||oe===void 0?void 0:oe.uri)!==null&&j!==void 0?j:z.with({path:D.dirname(z.fsPath)});let U=w.get($);U||(F=!0,U={folder:$,includePattern:{}},p.push(U),w.set($,U));const M=D.relative($.fsPath,z.fsPath);(0,C.assertIsDefined)(U.includePattern)[M.replace(/\\/g,"/")]=!0}else z.fsPath&&(F=!0,R[z.fsPath]=!0)}),{folderQueries:p,includePattern:R,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(S,p){if(p.isSmartCase){if(S.isRegExp){if(s.containsUppercaseCharacter(S.pattern,!0))return!0}else if(s.containsUppercaseCharacter(S.pattern))return!0}return!!S.isCaseSensitive}isMultiline(S){return S.isMultiline||S.isRegExp&&(0,h.isMultilineRegexSource)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const p=U=>D.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),R=(Array.isArray(S)?S:t(S)).map(U=>{const M=this.pathService.resolvedUserHome;return M?(0,A.untildify)(U,M.scheme===k.Schemas.file?M.fsPath:M.path):U}),F=I.groupBy(R,U=>p(U)?"searchPaths":"exprSegments"),z=(F.exprSegments||[]).map(U=>s.rtrim(U,"/")).map(U=>s.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),r(U))),oe={},j=this.expandSearchPathPatterns(F.searchPaths||[]);j&&j.length&&(oe.searchPaths=j);const W=b.flatten(z),$=n(...W);return $&&(oe.pattern=$),oe}getExcludesForFolder(S,p){return p.disregardExcludeSettings?void 0:(0,g.getExcludes)(S,!p.disregardSearchExcludeSettings)}expandSearchPathPatterns(S){if(!S||!S.length)return[];const p=b.flatten(S.map(R=>{let{pathPortion:F,globPortion:z}=d(R);z&&(z=o(z));const oe=this.expandOneSearchPath(F);return b.flatten(oe.map(j=>this.resolveOneSearchPathPattern(j,z)))})),w=new Map;return p.forEach(R=>{const F=R.searchPath.toString(),z=w.get(F);z?R.pattern&&(z.pattern=z.pattern||{},z.pattern[R.pattern]=!0):w.set(F,{searchPath:R.searchPath,pattern:R.pattern?n(R.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(S){if(D.isAbsolute(S)){const p=this.workspaceContextService.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==k.Schemas.file?[{searchPath:p[0].uri.with({path:S})}]:[{searchPath:f.URI.file(D.normalize(S))}]}if(this.workspaceContextService.getWorkbenchState()===2){const p=this.workspaceContextService.getWorkspace().folders[0].uri;if(S=i(S),S.startsWith("../")||S===".."){const R=D.posix.resolve(p.path,S);return[{searchPath:p.with({path:R})}]}const w=o(S);return[{searchPath:p,pattern:w}]}else{if(S==="./"||S===".\\")return[];{const p=S.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(p){const w=p[1],R=this.workspaceContextService.getWorkspace().folders.filter(F=>F.name===w);if(R.length)return R.map(F=>{const z=p[2];return{searchPath:F.uri,pattern:z&&o(z)}});{const F=a.localize(0,null,w);throw new Error(F)}}}}return[]}resolveOneSearchPathPattern(S,p){const w=S.pattern&&p?`${S.pattern}/${p}`:S.pattern||p,R=[{searchPath:S.searchPath,pattern:w}];return w&&!w.endsWith("**")&&R.push({searchPath:S.searchPath,pattern:w+"/**"}),R}getFolderQueryForSearchPath(S,p,w){const R=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(S.searchPath),p,w,!1);return R?Object.assign(Object.assign({},R),{includePattern:S.pattern}):null}getFolderQueryForRoot(S,p,w,R){let F;const z=f.URI.isUri(S)?S:S.uri;if(w.searchPaths){const U=w.searchPaths.filter(M=>(0,P.isEqual)(M.searchPath,z))[0];if(U&&!U.pattern)return null;U&&(F=U.pattern)}const oe=this.configurationService.getValue({resource:z}),j=this.getExcludesForFolder(oe,p),W=Object.assign(Object.assign({},j||{}),F||{}),$=f.URI.isUri(S)?(0,P.basename)(S):S.name;return{folder:z,folderName:R?$:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:oe.files&&oe.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!oe.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!oe.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!oe.search.followSymlinks}}};l=je([Be(0,u.IConfigurationService),Be(1,E.IWorkspaceContextService),Be(2,v.IEditorGroupsService),Be(3,_.IPathService)],l),e.QueryBuilder=l;function d(m){const S=m.match(/[\*\{\}\(\)\[\]\?]/);if(S){const p=S.index,w=m.substr(0,p).match(/[/|\\][^/\\]*$/);if(w){let R=m.substr(0,w.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:m.substr((w.index||0)+1)}}}return{pathPortion:m}}function n(...m){return m.length?m.reduce((S,p)=>(S[p]=!0,S),Object.create(null)):void 0}function t(m){return T.splitGlobAware(m,",").map(S=>S.trim()).filter(S=>!!S.length)}function r(m){return[`**/${m}/**`,`**/${m}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function i(m){return m.replace(/\\/g,"/")}function o(m){return i(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(m,S){m=b.distinct(m,R=>R.toString());const p=[],w=S.getWorkspace();return m&&m.forEach(R=>{let F;if(S.getWorkbenchState()===2)F=(0,P.relativePath)(w.folders[0].uri,R),F&&F!=="."&&(F="./"+F);else{const z=S.getWorkspaceFolder(R);if(z){const oe=z.name;if(w.folders.filter(W=>W.name===oe).length===1){const W=(0,P.relativePath)(z.uri,R);W===""?F=`./${z.name}`:F=`./${z.name}/${W}`}else F=R.fsPath}}F&&p.push(F)}),p}e.resolveResourcesForSearchIncludes=c}),define(me[262],ge([0,1,25,2,21,19,4,261,31,60]),function(G,e,b,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const s=7e3;function C(u,E){const v=E.activationEvents;if(!v)return Promise.resolve(void 0);const _=[],g=[];for(const i of v)if(/^workspaceContains:/.test(i)){const o=i.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||u.forceUsingSearch?g.push(o):_.push(o)}if(_.length===0&&g.length===0)return Promise.resolve(void 0);let l;const d=new Promise((i,o)=>{l=i}),n=i=>l({activationEvent:i}),t=Promise.all(_.map(i=>f(u,i,n))).then(()=>{}),r=h(u,E.identifier,g,n);return Promise.all([t,r]).then(()=>{l(void 0)}),d}e.checkActivateWorkspaceContainsExtension=C;async function f(u,E,v){for(const _ of u.folders)if(await u.exists(b.joinPath(I.URI.revive(_),E))){v(`workspaceContains:${E}`);return}}async function h(u,E,v,_){if(v.length===0)return Promise.resolve(void 0);const g=new T.CancellationTokenSource,l=u.checkExists(u.folders,v,g.token),d=setTimeout(async()=>{g.cancel(),_(`workspaceContainsTimeout:${v.join(",")}`)},s);let n=!1;try{n=await l}catch(t){A.isPromiseCanceledError(t)||A.onUnexpectedError(t)}g.dispose(),clearTimeout(d),n&&_(`workspaceContains:${v.join(",")}`)}function a(u,E,v,_){const g=u.get(y.IInstantiationService),l=u.get(D.ISearchService),n=g.createInstance(k.QueryBuilder).file(E.map(t=>(0,P.toWorkspaceFolder)(I.URI.revive(t))),{_reason:"checkExists",includePattern:v,exists:!0});return l.fileSearch(n,_).then(t=>!!t.limitHit,t=>A.isPromiseCanceledError(t)?!1:Promise.reject(t))}e.checkGlobFileExists=a});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[42],ge([0,1,162,8,67,25,16,6,24,2,13,5,35,225,91,32,41,223,19,28,11,22,196,7,84,4,27,92,14,81,50,34,3,262,89,197]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E,v,_,g,l,d,n,t,r,i,o,c,m,S,p,w,R,F,z,oe){"use strict";var j,W,$;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let U=class Nn extends k.Disposable{constructor(O,B,q,Q,he,ve,Ie,ke,Le,V){super();this._onDidChangeRemoteConnectionData=this._register(new R.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=B,this._extHostContext=q,this._initData=Ie,this._extHostWorkspace=Q,this._extHostConfiguration=he,this._logService=ve,this._extHostTunnelService=Le,this._extHostTerminalService=V,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new v.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new z.ExtHostSecretState(this._extHostContext),this._storagePath=ke,this._instaService=O.createChild(new S.ServiceCollection([a.IExtHostStorage,this._storage],[z.IExtHostSecretState,this._secretState]));const J=new Set;this._initData.hostExtensions.forEach(ee=>J.add(g.ExtensionIdentifier.toKey(ee))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ee,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,ae)},actualActivateExtension:async(ee,ae)=>{if(J.has(g.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,ae),new h.HostExtension;const we=this._registry.getExtensionDescription(ee);return this._activateExtension(we,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){_.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this._deactivate(he))}catch(B){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,B){return this._activator.activateByEvent(O,B)}_activateById(O,B){return this._activator.activateById(O,B)}activateByIdWithErrors(O,B){return this._activateById(O,B).then(()=>{const q=this._activator.getActivatedExtension(O);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=D.TernarySearchTree.forPaths(),B=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(Q=>O.set(P.URI.file(Q).fsPath,q))});this._extensionPathIndex=Promise.all(B).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let B=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return B;const q=this._activator.getActivatedExtension(O);if(!q)return B;try{typeof q.module.deactivate=="function"&&(B=Promise.resolve(q.module.deactivate()).then(void 0,Q=>Promise.resolve(void 0)))}catch(Q){}try{(0,k.dispose)(q.subscriptions)}catch(Q){}return B}async _activateExtension(O,B){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,B).then(q=>{const Q=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,Q.codeLoadingTime,Q.activateCallTime,Q.activateResolvedTime,B),this._logExtensionActivationTimes(O,B,"success",Q),q},q=>{throw this._logExtensionActivationTimes(O,B,"failure"),q})}_logExtensionActivationTimes(O,B,q,Q){const he=M(O,B);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},he),Q||{}),{outcome:q}))}_doActivateExtension(O,B){const q=M(O,B);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const Q=this._getEntryPoint(O);if(!Q)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(B)}`),this._logService.flush();const he=new h.ExtensionActivationTimesBuilder(B.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,A.joinPath)(O.extensionLocation,Q),he),this._loadExtensionContext(O)]).then(ve=>(T.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Nn._callActivate(this._logService,O.identifier,ve[0],ve[1],he))).then(ve=>(T.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),ve))}_loadExtensionContext(O){const B=new n.ExtensionGlobalMemento(O,this._storage),q=new n.ExtensionMemento(O.identifier.value,!1,this._storage),Q=new oe.ExtensionSecrets(O,this._secretState),he=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ve=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([B.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Ie=this;let ke;return Object.freeze({globalState:B,workspaceState:q,secrets:Q,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Le){return I.join(O.extensionLocation.fsPath,Le)},get storagePath(){var Le;return(Le=Ie._storagePath.workspaceValue(O))===null||Le===void 0?void 0:Le.fsPath},get globalStoragePath(){return Ie._storagePath.globalValue(O).fsPath},get logPath(){return I.join(Ie._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return P.URI.joinPath(Ie._initData.logsLocation,O.identifier.value)},get storageUri(){return Ie._storagePath.workspaceValue(O)},get globalStorageUri(){return Ie._storagePath.globalValue(O)},get extensionMode(){return he},get extension(){return ke===void 0&&(ke=new L(Ie,O.identifier,O,ve)),ke},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(O),Ie.extensionRuntime},get environmentVariableCollection(){return Ie._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,B,q,Q,he){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,B,q,Q,he).then(ve=>new h.ActivatedExtension(!1,null,he.build(),q,ve,Q.subscriptions))}static _callActivateOptional(O,B,q,Q,he){if(typeof q.activate=="function")try{he.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${B.value}`);const ve=typeof global=="object"?global:self,Ie=q.activate.apply(ve,[Q]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(Ie).then(ke=>(he.activateResolveStop(),ke))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}_activateOneStartupFinished(O,B){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:B}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const B of O.activationEvents)B==="onStartupFinished"&&this._activateOneStartupFinished(O,B)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,he=>{this._logService.error(he)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(he=>this._handleWorkspaceContainsEagerExtensions(he.added)));const B=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(B),Q=Promise.all([O,q]).then(()=>{});return Promise.race([Q,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Q}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(B=>this._handleWorkspaceContainsEagerExtension(O,B))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,B){if(!this.isActivated(B.identifier)){const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Q={folders:O.map(ve=>ve.uri),forceUsingSearch:q,exists:ve=>this._hostUtils.exists(ve.fsPath),checkExists:(ve,Ie,ke)=>this._mainThreadWorkspaceProxy.$checkExists(ve,Ie,ke)},he=await(0,F.checkActivateWorkspaceContainsExtension)(Q,B);if(!!he)return this._activateById(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:he.activationEvent}).then(void 0,ve=>this._logService.error(ve))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:B}=this._initData.environment;if(!O||!B||B.scheme!==l.Schemas.file)throw new Error(b.localize(0,null));const q=(0,A.originalFSPath)(B),Q=await this._loadCommonJSModule(null,B,new h.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(b.localize(1,null,q));return new Promise((he,ve)=>{const Ie=(Le,V)=>{Le?ve(Le):he(typeof V=="number"&&V>0?1:0)},ke=Q.run(q,Ie);ke&&ke.then&&ke.then(()=>{he(0)}).catch(Le=>{ve(Le.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,B){return this._resolvers[O]=B,(0,k.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,B){const q=O.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const Q=O.substr(0,q);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Q}`,!1);const he=this._resolvers[Q];if(!he)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Q}.`,detail:void 0}};try{T.mark(`code/extHost/willResolveAuthority/${Q}`);const ve=await he.resolve(O,{resolveAttempt:B});T.mark(`code/extHost/didResolveAuthorityOK/${Q}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(he));const Ie={authority:O,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},ke={extensionHostEnv:ve.extensionHostEnv,trust:ve.trust};return{type:"ok",value:{authority:Ie,options:ke,tunnelInformation:{environmentTunnels:ve.environmentTunnels}}}}catch(ve){if(T.mark(`code/extHost/didResolveAuthorityError/${Q}`),ve instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,B){return B===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(O,!1))}async $activate(O,B){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,B),!0):!1}async $deltaExtensions(O,B){O.forEach(Q=>Q.extensionLocation=P.URI.revive(Q.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(B.map(async Q=>{const he=this._registry.getExtensionDescription(Q);if(!!he){const ve=await this._hostUtils.realpath(he.extensionLocation.fsPath);q.delete(P.URI.file(ve).fsPath)}})),await Promise.all(O.map(async Q=>{const he=await this._hostUtils.realpath(Q.extensionLocation.fsPath);q.set(P.URI.file(he).fsPath,Q)})),this._registry.deltaExtensions(O,B),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let B=d.VSBuffer.alloc(O),q=Math.random()%256;for(let Q=0;Q<O;Q++)B.writeUInt8(q,Q);return B}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};U=je([Be(0,i.IInstantiationService),Be(1,e.IHostUtils),Be(2,m.IExtHostRpcService),Be(3,u.IExtHostWorkspace),Be(4,f.IExtHostConfiguration),Be(5,s.ILogService),Be(6,o.IExtHostInitDataService),Be(7,c.IExtensionStoragePaths),Be(8,p.IExtHostTunnelService),Be(9,w.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function M(N,O){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class L{constructor(O,B,q,Q){j.set(this,void 0),W.set(this,void 0),$.set(this,void 0),tt(this,j,O,"f"),tt(this,W,B,"f"),tt(this,$,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=I.normalize((0,A.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=Q}get isActive(){return Ue(this,j,"f").isActivated(Ue(this,$,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,j,"f").getExtensionExports(Ue(this,$,"f"))}activate(){return Ue(this,j,"f").activateByIdWithErrors(Ue(this,$,"f"),{startup:!1,extensionId:Ue(this,W,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=L,j=new WeakMap,W=new WeakMap,$=new WeakMap}),define(me[46],ge([0,1,8,2,3,16,5,7,120,32,42,39,213,35,204,14,4,12,36]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let g=class{constructor(c,m,S,p,w){this._workspaceService=m,this._extensionService=S,this._editorsService=p,this._configurationService=w,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=c.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new d(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(F=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,m){const S=c;if(typeof S.sourceReference=="number"&&S.sourceReference>0){let p=`debug:${encodeURIComponent(S.path||"")}`,w="?";return m&&(p+=`${w}session=${encodeURIComponent(m.id)}`,w="&"),p+=`${w}ref=${S.sourceReference}`,I.URI.parse(p)}else{if(S.path)return I.URI.file(S.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const m=[];for(const S of c.getAllExtensionDescriptions())if(S.contributes){const p=S.contributes.debuggers;if(p&&p.length>0)for(const w of p)(0,a.isDebuggerMainContribution)(w)&&m.push(w.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(m=>c.push(m)),c}addBreakpoints(c){this.startBreakpoints();const m=c.filter(w=>{const R=w.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,w),!0)});this.fireBreakpointChanges(m,[],[]);const S=[],p=new Map;for(const w of m)if(w instanceof k.SourceBreakpoint){let R=p.get(w.location.uri.toString());R||(R={type:"sourceMulti",uri:w.location.uri,lines:[]},p.set(w.location.uri.toString(),R),S.push(R)),R.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character})}else w instanceof k.FunctionBreakpoint&&S.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName});return this._debugServiceProxy.$registerBreakpoints(S)}removeBreakpoints(c){this.startBreakpoints();const m=c.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],m,[]);const S=m.filter(R=>R instanceof k.SourceBreakpoint).map(R=>R.id),p=m.filter(R=>R instanceof k.FunctionBreakpoint).map(R=>R.id),w=m.filter(R=>R instanceof k.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(S,p,w)}startDebugging(c,m,S){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,m,{parentSessionID:S.parentSession?S.parentSession.id:void 0,repl:S.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:S.noDebug,compact:S.compact})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,m,S){if(!m)return new k.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:p,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,S,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,p),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(w=>w.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(c,m,S){if(!S)return new k.Disposable(()=>{});if(!this.definesDebugType(c,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:p,factory:S}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,p),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(w=>w.factory!==S),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(c,m){if(!m)return new k.Disposable(()=>{});const S=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:S,factory:m}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==m)})}async $runInTerminal(c,m){return Promise.resolve(void 0)}async $substituteVariables(c,m){if(!this._variableResolver){const[w,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(w||[],this._editorsService,R)}let S;const p=await this.getFolder(c);return p&&(S={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(S,m)}createDebugAdapter(c,m){if(c.type==="implementation")return new r(c.implementation)}createSignService(){}async $startDASession(c,m){const S=this,p=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const R=this.convertToDto(w),F=this.createDebugAdapter(R,p);if(!F)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const z=F;return this._debugAdapters.set(c,z),this.getDebugAdapterTrackers(p).then(oe=>(oe&&this._debugAdaptersTrackers.set(c,oe),z.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const W=j,$={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(W.arguments.value);$.body={signature:U},z.sendResponse($)}else throw new Error("no signer")}catch(U){$.success=!1,$.message=U.message,z.sendResponse($)}}else oe&&oe.onDidSendMessage&&oe.onDidSendMessage(j),j=(0,a.convertToVSCPaths)(j,!0),S._debugServiceProxy.$acceptDAMessage(c,j)}),z.onError(j=>{oe&&oe.onError&&oe.onError(j),this._debugServiceProxy.$acceptDAError(c,j.name,j.message,j.stack)}),z.onExit(j=>{oe&&oe.onExit&&oe.onExit((0,v.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,v.withNullAsUndefined)(j),void 0)}),oe&&oe.onWillStartSession&&oe.onWillStartSession(),z.startSession()))})}$sendDAMessage(c,m){m=(0,a.convertToDAPaths)(m,!1);const S=this._debugAdaptersTrackers.get(c);S&&S.onWillReceiveMessage&&S.onWillReceiveMessage(m);const p=this._debugAdapters.get(c);p&&p.sendMessage(m)}$stopDASession(c){const m=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),m&&m.onWillStopSession&&m.onWillStopSession();const S=this._debugAdapters.get(c);return this._debugAdapters.delete(c),S?S.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const m=[],S=[],p=[];if(c.added)for(const w of c.added){const R=w.id;if(R&&!this._breakpoints.has(R)){let F;if(w.type==="function")F=new k.FunctionBreakpoint(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage);else if(w.type==="data")F=new k.DataBreakpoint(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage);else{const z=I.URI.revive(w.uri);F=new k.SourceBreakpoint(new k.Location(z,new k.Position(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage)}F._id=R,this._breakpoints.set(R,F),m.push(F)}}if(c.removed)for(const w of c.removed){const R=this._breakpoints.get(w);R&&(this._breakpoints.delete(w),S.push(R))}if(c.changed){for(const w of c.changed)if(w.id){const R=this._breakpoints.get(w.id);if(R){if(R instanceof k.FunctionBreakpoint&&w.type==="function"){const F=R;F.enabled=w.enabled,F.condition=w.condition,F.hitCondition=w.hitCondition,F.logMessage=w.logMessage,F.functionName=w.functionName}else if(R instanceof k.SourceBreakpoint&&w.type==="source"){const F=R;F.enabled=w.enabled,F.condition=w.condition,F.hitCondition=w.hitCondition,F.logMessage=w.logMessage,F.location=new k.Location(I.URI.revive(w.uri),new k.Position(w.line,w.character))}p.push(R)}}}this.fireBreakpointChanges(m,S,p)}$provideDebugConfigurations(c,m,S){return(0,A.asPromise)(async()=>{const p=this.getConfigProviderByHandle(c);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.getFolder(m);return p.provideDebugConfigurations(w,S)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(c,m,S,p){return(0,A.asPromise)(async()=>{const w=this.getConfigProviderByHandle(c);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(m);return w.resolveDebugConfiguration(R,S,p)})}$resolveDebugConfigurationWithSubstitutedVariables(c,m,S,p){return(0,A.asPromise)(async()=>{const w=this.getConfigProviderByHandle(c);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(m);return w.resolveDebugConfigurationWithSubstitutedVariables(R,S,p)})}async $provideDebugAdapter(c,m){const S=this.getAdapterDescriptorFactoryByHandle(c);if(!S)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(m);return this.getAdapterDescriptor(S,p).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(w)})}async $acceptDebugSessionStarted(c){const m=await this.getSession(c);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(c){const m=await this.getSession(c);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,m){const S=await this.getSession(c);S&&S._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(c,m){const p={session:await this.getSession(c),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(c){if(c instanceof k.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof k.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const m=this._adapterFactories.filter(S=>S.type===c);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(c){const m=this._adapterFactories.filter(S=>S.handle===c);if(m.length>0)return m[0].factory}getConfigProviderByHandle(c){const m=this._configProviders.filter(S=>S.handle===c);if(m.length>0)return m[0].provider}definesDebugType(c,m){if(c.contributes){const S=c.contributes.debuggers;if(S&&S.length>0){for(const p of S)if(p.label&&p.type&&p.type===m)return!0}}return!1}getDebugAdapterTrackers(c){const S=c.configuration.type,p=this._trackerFactories.filter(w=>w.type===S||w.type==="*").map(w=>(0,A.asPromise)(()=>w.factory.createDebugAdapterTracker(c)).then(R=>R,R=>null));return Promise.race([Promise.all(p).then(w=>{const R=w.filter(F=>!!F);if(R.length>0)return new t(R)}),new Promise((w,R)=>{const F=setTimeout(()=>{clearTimeout(F),R(new Error("timeout"))},1e3)})]).catch(w=>{})}async getAdapterDescriptor(c,m){const S=m.configuration.debugServer;if(typeof S=="number")return Promise.resolve(new k.DebugAdapterServer(S));if(c){const w=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>c.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,w))).then(R=>{if(R)return R})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,p))}daExecutableFromPackage(c,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,m,S){(c.length>0||m.length>0||S.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:m,changed:S}))}async getSession(c){if(c)if(typeof c=="string"){const m=this._debugSessions.get(c);if(m)return m}else{let m=this._debugSessions.get(c.id);if(!m){const S=await this.getFolder(c.folderUri);m=new l(this._debugServiceProxy,c.id,c.type,c.name,S,c.configuration),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(c){if(c){const m=I.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};g=je([Be(0,u.IExtHostRpcService),Be(1,P.IExtHostWorkspace),Be(2,s.IExtHostExtensionService),Be(3,C.IExtHostDocumentsAndEditors),Be(4,h.IExtHostConfiguration)],g),e.ExtHostDebugServiceBase=g;class l{constructor(c,m,S,p,w,R){this._debugServiceProxy=c,this._id=m,this._type=S,this._name=p,this._workspaceFolder=w,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,m)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=l;class d{constructor(c){this.value=Object.freeze({append(m){c.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=d;class n extends f.AbstractVariableResolverService{constructor(c,m,S,p){super({getFolderUri:w=>{const R=c.filter(F=>F.name===w);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(w,R)=>S.getConfiguration(void 0,w).get(R),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(m){const w=m.activeEditor();if(w)return b.normalize(w.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(m&&p){const w=m.activeEditor();if(w){const R=p.getWorkspaceFolder(w.document.uri);if(R)return b.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(m){const w=m.activeEditor();if(w&&!w.selection.isEmpty)return w.document.getText(w.selection)}},getLineNumber:()=>{if(m){const w=m.activeEditor();if(w)return String(w.selection.end.line+1)}}},void 0,_.env)}}e.ExtHostVariableResolverService=n;class t{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(m=>m.onError?m.onError(c):void 0)}onExit(c,m){this.trackers.forEach(S=>S.onExit?S.onExit(c,m):void 0)}}class r extends D.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends g{constructor(c,m,S,p,w){super(c,m,S,p,w)}createVariableResolver(c,m,S){return new n(c,m,S)}};i=je([Be(0,u.IExtHostRpcService),Be(1,P.IExtHostWorkspace),Be(2,s.IExtHostExtensionService),Be(3,C.IExtHostDocumentsAndEditors),Be(4,h.IExtHostConfiguration)],i),e.WorkerExtHostDebugService=i}),define(me[263],ge([0,1,67,2,5,35,41,28,14,27,4,42,36,13]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(g,l,d,n,t,r,i){this._apiFactory=g,this._extensionRegistry=l,this._instaService=d,this._extHostConfiguration=n,this._extHostExtensionService=t,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),b.mark("code/extHost/willWaitForConfig");const g=await this._extHostConfiguration.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,l,this._extensionRegistry,g,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(v,l,this._initData.environment.appUriScheme))}register(g){if(Array.isArray(g.nodeModuleName))for(let l of g.nodeModuleName)this._factories.set(l,g);else this._factories.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this._alternatives.push(l=>g.alternativeModuleName(l))}};a=je([Be(2,s.IInstantiationService),Be(3,A.IExtHostConfiguration),Be(4,C.IExtHostExtensionService),Be(5,P.IExtHostInitDataService),Be(6,h.ILogService)],a),e.RequireInterceptor=a;class u{constructor(g,l,d,n,t){this._apiFactory=g,this._extensionPaths=l,this._extensionRegistry=d,this._configProvider=n,this._logService=t,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(g,l){const d=this._extensionPaths.findSubstr(l.fsPath);if(d){let n=this._extApiImpl.get(k.ExtensionIdentifier.toKey(d.identifier));return n||(n=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(d.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((t,r)=>n+=`	${r} -> ${t.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l.fsPath}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(g,l){this.nodeModuleName="keytar";const{environment:d}=l,n=g.getProxy(T.MainContext.MainThreadKeytar);if(d.appRoot){let t=d.appRoot.fsPath;f.platform==="win32"&&(t=t.replace(/\\/g,"/")),t[t.length-1]==="/"&&(t=t.substr(0,t.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${t}/node_modules.asar/keytar`),this.alternativeNames.add(`${t}/node_modules/keytar`)}this._impl={getPassword:(t,r)=>n.$getPassword(t,r),setPassword:(t,r,i)=>n.$setPassword(t,r,i),deletePassword:(t,r)=>n.$deletePassword(t,r),findPassword:t=>n.$findPassword(t),findCredentials(t){return n.$findCredentials(t)}}}load(g,l){return this._impl}alternativeModuleName(g){const l=g.length;if(!(l<=7||!this.alternativeNames)){const d=l-7;if((g.charAt(d)==="/"||g.charAt(d)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.alternativeNames.has(g)))return"keytar"}}};E=je([Be(0,D.IExtHostRpcService),Be(1,P.IExtHostInitDataService)],E);let v=class{constructor(g,l,d){this._extensionPaths=g,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(T.MainContext.MainThreadTelemetry);const n=d.getProxy(T.MainContext.MainThreadWindow);this._impl=(t,r)=>{const i=I.URI.parse(t);return r?this.callOriginal(t,r):i.scheme==="http"||i.scheme==="https"?n.$openUri(i,t,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?n.$openUri(i,t,{}):this.callOriginal(t,r)}}load(g,l,d){const n=this._extensionPaths.findSubstr(l.fsPath);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=d(g),this._impl}callOriginal(g,l){return this.sendNoForwardTelemetry(),this._original(g,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};v=je([Be(2,D.IExtHostRpcService)],v)}),define(me[264],ge([0,1,168,9,7,205,32,42,39,35,34,14,46,189,208,16]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let E=class extends f.ExtHostDebugServiceBase{constructor(g,l,d,n,t,r){super(g,l,d,n,t);this._terminalService=r,this._integratedTerminalInstances=new v}createDebugAdapter(g,l){switch(g.type){case"server":return new A.SocketDebugAdapter(g);case"pipeServer":return new A.NamedPipeDebugAdapter(g);case"executable":return new A.ExecutableDebugAdapter(g,l.type)}return super.createDebugAdapter(g,l)}daExecutableFromPackage(g,l){const d=A.ExecutableDebugAdapter.platformAdapterExecutable(l.getAllExtensionDescriptions(),g.type);if(d)return new T.DebugAdapterExecutable(d.command,d.args,d.options)}createSignService(){return new h.SignService}async $runInTerminal(g,l){if(g.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(w=>{this._integratedTerminalInstances.onTerminalClosed(w)}));const d=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0,d),t=this._terminalService.getDefaultShellArgs(!0,d),r=JSON.stringify({shell:n,shellArgs:t});let i=await this._integratedTerminalInstances.checkout(r),o,c=!1;if(i)o=g.cwd;else{const w={shellPath:n,shellArgs:t,cwd:g.cwd,name:g.title||b.localize(0,null)};c=!0,i=this._terminalService.createTerminalFromOptions(w,!0),this._integratedTerminalInstances.insert(i,r)}i.show(!0);const m=await i.processId;c?await new Promise(w=>setTimeout(w,1e3)):d.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?i.sendText("cls"):n.indexOf("bash")>=0?i.sendText("clear"):I.isWindows?i.sendText("cls"):i.sendText("clear"));const S=(0,a.prepareCommand)(n,g.args,o,g.env);i.sendText(S);const p=this.onDidTerminateDebugSession(w=>{w.id===l&&(this._integratedTerminalInstances.free(i),p.dispose())});return m}else if(g.kind==="external")return(0,a.runInExternalTerminal)(g,await this._configurationService.getConfigProvider());return super.$runInTerminal(g,l)}createVariableResolver(g,l,d){return new f.ExtHostVariableResolverService(g,l,d,this._workspaceService)}};E=je([Be(0,C.IExtHostRpcService),Be(1,y.IExtHostWorkspace),Be(2,k.IExtHostExtensionService),Be(3,D.IExtHostDocumentsAndEditors),Be(4,P.IExtHostConfiguration),Be(5,s.IExtHostTerminalService)],E),e.ExtHostDebugService=E;class v{constructor(){this._terminalInstances=new Map}async checkout(g){const d=[...this._terminalInstances.entries()].map(([n,t])=>(0,u.createCancelablePromise)(async r=>{if(t.lastUsedAt!==-1&&await(0,a.hasChildProcesses)(await n.processId))return null;const i=Date.now();return t.lastUsedAt+v.minUseDelay>i||r.isCancellationRequested||t.config!==g?null:(t.lastUsedAt=i,n)}));return await(0,u.firstParallel)(d,n=>!!n)}insert(g,l){this._terminalInstances.set(g,{lastUsedAt:Date.now(),config:l})}free(g){const l=this._terminalInstances.get(g);l&&(l.lastUsedAt=-1)}onTerminalClosed(g){this._terminalInstances.delete(g)}}v.minUseDelay=1e3}),define(me[265],ge([0,1,8,2,77,32,46,39,35,34,14,27,66,11,13,63]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let E=class extends f.ExtHostTaskBase{constructor(_,g,l,d,n,t,r,i){super(_,g,l,d,n,t,r,i);this.workspaceService=l,g.remote.isRemote&&g.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:g.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(_,g){const l=g;if(!g.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const d=f.TaskHandleDTO.from(l,this.workspaceService),n=await this._proxy.$getTaskExecution(d);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const t=await this.getTaskExecution(n,g);return this._proxy.$executeTask(d).catch(()=>{}),t}else{const d=f.TaskDTO.from(g,_);if(d===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(d.execution)&&await this.addCustomExecution(d,g,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(d),g);return this._proxy.$executeTask(d).catch(()=>{}),n}}provideTasksInternal(_,g,l,d){const n=[];if(d)for(let t of d){this.checkDeprecation(t,l),(!t.definition||!_[t.definition.type])&&this._logService.warn(`The task [${t.source}, ${t.name}] uses an undefined task type. The task will be ignored in the future.`);const r=f.TaskDTO.from(t,l.extension);r&&(n.push(r),f.CustomExecutionDTO.is(r.execution)&&g.push(this.addCustomExecution(r,t,!0)))}return{tasks:n,extension:l.extension}}async resolveTaskInternal(_){return _}async getVariableResolver(_){if(this._variableResolver===void 0){const g=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(_,this._editorService,g,this.workspaceService)}return this._variableResolver}async $resolveVariables(_,g){const l=I.URI.revive(_),d={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(l),t=await this._workspaceProvider.getWorkspaceFolders2();if(!t||!n)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const r=await this.getVariableResolver(t),i={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}};for(let o of g.variables)d.variables[o]=await r.resolveAsync(i,o);if(g.process!==void 0){let o;if(g.process.path!==void 0){o=g.process.path.split(b.delimiter);for(let c=0;c<o.length;c++)o[c]=await r.resolveAsync(i,o[c])}d.process=await T.win32.findExecutable(await r.resolveAsync(i,g.process.name),g.process.cwd!==void 0?await r.resolveAsync(i,g.process.cwd):void 0,o)}return d}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(_,g,l){return T.win32.findExecutable(_,g,l)}};E=je([Be(0,s.IExtHostRpcService),Be(1,C.IExtHostInitDataService),Be(2,A.IExtHostWorkspace),Be(3,k.IExtHostDocumentsAndEditors),Be(4,D.IExtHostConfiguration),Be(5,P.IExtHostTerminalService),Be(6,a.ILogService),Be(7,u.IExtHostApiDeprecationService)],E),e.ExtHostTask=E}),define(me[266],ge([0,1,9,12,30,149,13,35,46,39,14,34,32,211,212]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let u=class extends C.BaseExtHostTerminalService{constructor(v,_,g,l,d){super(!0,v);this._extHostConfiguration=_,this._extHostWorkspace=g,this._extHostDocumentsAndEditors=l,this._logService=d,(0,A.getSystemShell)(b.OS,process.env).then(n=>this._defaultShell=n),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(v,_,g){const l=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),{name:v,shellPath:_,shellArgs:g},v);return this._terminals.push(l),l.create(_,g),l.value}createTerminalFromOptions(v,_){const g=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),v,v.name);return this._terminals.push(g),g.create((0,I.withNullAsUndefined)(v.shellPath),(0,I.withNullAsUndefined)(v.shellArgs),(0,I.withNullAsUndefined)(v.cwd),(0,I.withNullAsUndefined)(v.env),(0,I.withNullAsUndefined)(v.icon),(0,I.withNullAsUndefined)(v.message),void 0,(0,I.withNullAsUndefined)(v.strictEnv),(0,I.withNullAsUndefined)(v.hideFromUser),(0,I.withNullAsUndefined)(_),!0),g.value}getDefaultShell(v,_){var g;const l=d=>_.getConfiguration(d.substr(0,d.lastIndexOf("."))).get(d.substr(d.lastIndexOf(".")+1));return h.getDefaultShell(l,(g=this._defaultShell)!==null&&g!==void 0?g:(0,A.getSystemShellSync)(b.OS,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,h.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,v)}getDefaultShellArgs(v,_){const g=l=>_.getConfiguration(l.substr(0,l.lastIndexOf("."))).get(l.substr(l.lastIndexOf(".")+1));return h.getDefaultShellArgs(g,v,h.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const v=this._extHostDocumentsAndEditors.activeEditor();v&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(v.document.uri))}async _updateVariableResolver(){const v=await this._extHostConfiguration.getConfigProvider(),_=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new D.ExtHostVariableResolverService(_||[],this._extHostDocumentsAndEditors,v),this._variableResolver}async $getAvailableProfiles(v){const _=await(await this._extHostConfiguration.getConfigProvider()).getConfiguration().get("terminal.integrated");return(0,a.detectAvailableProfiles)(v,void 0,this._logService,_,await this._variableResolverPromise,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(v){const _=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(v,_),args:this.getDefaultShellArgs(v,_)}}};u=je([Be(0,s.IExtHostRpcService),Be(1,k.IExtHostConfiguration),Be(2,f.IExtHostWorkspace),Be(3,P.IExtHostDocumentsAndEditors),Be(4,y.ILogService)],u),e.ExtHostTerminalService=u}),define(me[267],ge([0,1,16,19,67,6,2,5,257,13,78,81,27,185,14,62,42,34]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(l,d,n,t){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=n;const r=new D.RPCProtocol(l,null,t);d=_._transform(d,r);const i=new C.ServiceCollection(...(0,s.getSingletonServiceDescriptors)());i.set(f.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},d)),i.set(a.IExtHostRpcService,new a.ExtHostRpcService(r)),i.set(u.IURITransformerService,new u.URITransformerService(t)),i.set(E.IHostUtils,n);const o=new h.InstantiationService(i,!0),c=o.invokeFunction(w=>w.get(v.IExtHostTerminalService));this._disposables.add(c),this._logService=o.invokeFunction(w=>w.get(P.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",d),this._extensionService=o.invokeFunction(w=>w.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const m=new WeakMap;this._extensionService.getExtensionPathIndex().then(w=>{Error.prepareStackTrace=(R,F)=>{let z="",oe,j;for(const W of F)z+=`
	at ${W.toString()}`,j=W.getFileName(),!oe&&j&&(oe=w.findSubstr(j));return m.set(R,oe),`${R.name||"Error"}: ${R.message||""}${z}`}});const S=r.getProxy(k.MainContext.MainThreadExtensionService),p=r.getProxy(k.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(w=>{const R=I.transformErrorForSerialization(w),F=m.get(w);F?S.$onExtensionRuntimeError(F.identifier,R):p.$onUnexpectedError(R)})}terminate(l){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(n=>{});const d=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,b.timeout)(4e3),d]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(l,d){l.extensions.forEach(t=>t.extensionLocation=y.URI.revive(d.transformIncomingURIs(t.extensionLocation))),l.environment.appRoot=y.URI.revive(d.transformIncomingURIs(l.environment.appRoot));const n=l.environment.extensionDevelopmentLocationURI;return n&&(l.environment.extensionDevelopmentLocationURI=n.map(t=>y.URI.revive(d.transformIncomingURIs(t)))),l.environment.extensionTestsLocationURI=y.URI.revive(d.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=y.URI.revive(d.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=y.URI.revive(d.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=y.URI.revive(d.transformIncomingURIs(l.logsLocation)),l.logFile=y.URI.revive(d.transformIncomingURIs(l.logFile)),l.workspace=d.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=_}),define(me[268],ge([0,1,8,21,59,33,25,47,31]),function(G,e,b,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(f,h,a){this.config=f,this.provider=h,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&A.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&A.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const h=this.config.folderQueries||[];return new Promise((a,u)=>{const E=v=>{this.resultCount++,f(v)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(v=>{const _=v.toString(),g=b.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,g)||this.matchFile(E,{base:v,basename:g})}),Promise.all(h.map(v=>this.searchInFolder(v,E))).then(v=>{a({limitHit:this.isLimitHit,stats:v[0]||void 0})},v=>{u(new Error((0,T.toErrorMessage)(v)))})})}async searchInFolder(f,h){const a=new I.CancellationTokenSource,u=this.getSearchOptionsForFolder(f),E=this.initDirectoryTree(),v=new D.QueryGlobTester(this.config,f),_=!v.hasSiblingExcludeClauses();let g;try{this.activeCancellationTokens.add(a),g=k.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,a.token),d=g.elapsed(),n=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(t=>{const r=b.posix.relative(f.folder.path,t.path);if(_){const i=b.basename(t.path);this.matchFile(h,{base:f.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(E,f.folder,r,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,v,h),{providerTime:d,postProcessTime:n.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(f){const h=(0,D.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:a,includes:h,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},h,a,u){if(a===this.filePattern){const v=b.basename(this.filePattern);this.matchFile(u,{base:h,relativePath:this.filePattern,basename:v})}function E(v){const _=b.basename(v),g=b.dirname(v);let l=f[g];l||(l=f[g]=[],E(g)),l.push({base:h,relativePath:v,basename:_})}E(a)}matchDirectoryTree({rootEntries:f,pathToEntries:h},a,u){const E=this,v=this.filePattern;function _(g){const l=A.hasSiblingFn(()=>g.map(d=>d.basename));for(let d=0,n=g.length;d<n;d++){const t=g[d],{relativePath:r,basename:i}=t;if(!!a.includedInQuerySync(r,i,v!==i?l:void 0)){const o=h[r];if(o)_(o);else{if(r===v)continue;E.matchFile(u,t)}if(E.isLimitHit)break}}}_(f)}matchFile(f,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(h))}}class s{constructor(){this.sessions=new Map}fileSearch(f,h,a,u){const E=this.getSessionTokenSource(f.cacheKey),v=new P(f,h,E&&E.token);let _=0;const g=l=>{_+=l.length,a(l.map(d=>this.rawMatchToSearchItem(d)))};return this.doSearch(v,s.BATCH_SIZE,g,u).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:l.stats}}))}clearCache(f){const h=this.getSessionTokenSource(f);h&&h.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new I.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:y.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,h,a,u){u.onCancellationRequested(()=>{f.cancel()});const E=_=>{_&&(v.push(_),h>0&&v.length>=h&&(a(v),v=[]))};let v=[];return f.search(E).then(_=>(v.length&&a(v),_),_=>(v.length&&a(v),Promise.reject(_)))}}e.FileSearchManager=s,s.BATCH_SIZE=512}),define(me[127],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class b{constructor(A,y){this.line=A,this.character=y}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,y){return new b(0,0)}with(A){return new b(0,0)}}e.Position=b;class I{constructor(A,y,k,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(A,y),this.end=new b(k,D)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new I(0,0,0,0)}with(A){return new I(0,0,0,0)}}e.Range=I}),define(me[128],ge([0,1,8,15,21,59,25,33,2,31,11]),function(G,e,b,I,T,A,y,k,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class C{constructor(_,g,l){this.query=_,this.provider=g,this.fileUtils=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(_,g){const l=this.query.folderQueries||[],d=new T.CancellationTokenSource;return g.onCancellationRequested(()=>d.cancel()),new Promise((n,t)=>{this.collector=new h(_);let r=!1;const i=(o,c)=>{if(!r&&!this.isLimitHit){const m=this.resultSize(o);u(o)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,r=!0,d.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const S=this.resultSize(o);this.resultCount+=S,(S>0||!u(o))&&this.collector.add(o,c)}};Promise.all(l.map((o,c)=>this.searchInFolder(o,m=>i(m,c),d.token))).then(o=>{d.dispose(),this.collector.flush();const c=o.some(m=>!!m&&!!m.limitHit);n({limitHit:this.isLimitHit||c,stats:{type:"textSearchProvider"}})},o=>{d.dispose();const c=(0,A.toErrorMessage)(o);t(new Error(c))})})}resultSize(_){return u(_)?Array.isArray(_.ranges)?_.ranges.length:1:0}trimResultToSize(_,g){const l=Array.isArray(_.ranges)?_.ranges:[_.ranges],d=Array.isArray(_.preview.matches)?_.preview.matches:[_.preview.matches];return{ranges:l.slice(0,g),preview:{matches:d.slice(0,g),text:_.preview.text},uri:_.uri}}async searchInFolder(_,g,l){const d=new P.QueryGlobTester(this.query,_),n=[],t={report:o=>{if(!!this.validateProviderResult(o)){const c=_.folder.scheme===s.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(o.uri))):void 0,m=y.relativePath(_.folder,o.uri);m&&n.push(d.includedInQuery(m,b.basename(m),c).then(S=>{S&&g(o)}))}}},r=this.getSearchOptionsForFolder(_),i=await this.provider.provideTextSearchResults(f(this.query.contentPattern),r,t,l);return await Promise.all(n),i}validateProviderResult(_){if(u(_)){if(Array.isArray(_.ranges)){if(!Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(_.preview.matches.length!==_.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(_){const g=(0,P.resolvePatternsForProvider)(this.query.includePattern,_.includePattern),l=(0,P.resolvePatternsForProvider)(this.query.excludePattern,_.excludePattern),d={folder:D.URI.from(_.folder),excludes:l,includes:g,useIgnoreFiles:!_.disregardIgnoreFiles,useGlobalIgnoreFiles:!_.disregardGlobalIgnoreFiles,followSymlinks:!_.ignoreSymlinks,encoding:_.fileEncoding&&this.fileUtils.toCanonicalName(_.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return d.usePCRE2=this.query.usePCRE2,d}}e.TextSearchManager=C;function f(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class h{constructor(_){this._onResult=_,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new E(512,g=>this.sendItems(g))}add(_,g){this._currentFileMatch&&(this._currentFolderIdx!==g||!y.isEqual(this._currentUri,_.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=g,this._currentFileMatch={resource:_.uri,results:[]}),this._currentFileMatch.results.push(a(_))}pushToCollector(){const _=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,_)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(_){this._onResult(_)}}e.TextSearchResultsCollector=h;function a(v){return u(v)?{preview:{matches:(0,I.mapArrayOrNot)(v.preview.matches,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character})),text:v.preview.text},ranges:(0,I.mapArrayOrNot)(v.ranges,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function u(v){return!!v.preview}e.extensionResultIsMatch=u;class E{constructor(_,g){this.maxBatchSize=_,this.cb=g,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(_,g){!_||this.addItemToBatch(_,g)}addItems(_,g){!_||this.addItemsToBatch(_,g)}addItemToBatch(_,g){this.batch.push(_),this.batchSize+=g,this.onUpdate()}addItemsToBatch(_,g){this.batch=this.batch.concat(_),this.batchSize+=g,this.onUpdate()}onUpdate(){this.totalNumberCompleted<E.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},E.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=E,E.TIMEOUT=4e3,E.START_BATCH_AFTER_COUNT=50}),define(me[68],ge([0,1,6,5,4,268,14,62,13,2,128]),function(G,e,b,I,T,A,y,k,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let C=class{constructor(u,E,v){this.extHostRpc=u,this._uriTransformer=E,this._logService=v,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,E){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const v=this._handlePool++;return this._textSearchProvider.set(v,E),this._proxy.$registerTextSearchProvider(v,this._transformScheme(u)),(0,b.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}registerFileSearchProvider(u,E){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const v=this._handlePool++;return this._fileSearchProvider.set(v,E),this._proxy.$registerFileSearchProvider(v,this._transformScheme(u)),(0,b.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(v),this._proxy.$unregisterProvider(v)})}$provideFileSearchResults(u,E,v,_){const g=f(v),l=this._fileSearchProvider.get(u);if(l)return this._fileSearchManager.fileSearch(g,l,d=>{this._proxy.$handleFileMatch(u,E,d.map(n=>n.resource))},_);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,E,v,_){const g=this._textSearchProvider.get(u);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const l=f(v);return this.createTextSearchManager(l,g).search(n=>this._proxy.$handleTextMatch(u,E,n),_)}createTextSearchManager(u,E){return new s.TextSearchManager(u,E,{readdir:v=>Promise.resolve([]),toCanonicalName:v=>v})}};C=je([Be(0,y.IExtHostRpcService),Be(1,k.IURITransformerService),Be(2,D.ILogService)],C),e.ExtHostSearch=C;function f(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(h),extraFileResources:a.extraFileResources&&a.extraFileResources.map(u=>P.URI.revive(u))})}e.reviveQuery=f;function h(a){return Object.assign(Object.assign({},a),{folder:P.URI.revive(a.folder)})}}),define(me[269],ge([0,1,159,21,19,3,57,2,151,107,141,76,45,5,231,230,51,232,35,233,234,235,216,236,39,42,237,217,239,240,241,64,220,244,245,246,91,34,247,221,20,7,250,65,126,32,41,53,201,238,116,125,66,46,68,13,62,14,27,242,199,50,63,228,248,198,92,90,253,251,252,229,61,260,249,89,195,118,243,84]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E,v,_,g,l,d,n,t,r,i,o,c,m,S,p,w,R,F,z,oe,j,W,$,U,M,L,N,O,B,q,Q,he,ve,Ie,ke,Le,V,J,ee,ae,we,Ce,Oe,be,Pe,Re,We,Ee,Ke,X,ie,_e,xe,ze,$e,Ye,K,se,fe,Z,ne,ce,pe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function qe(Me){const He=Me.get(Oe.IExtHostInitDataService),Qe=Me.get(K.IExtHostFileSystemInfo),it=Me.get(_e.IExtHostConsumerFileSystem),lt=Me.get(i.IExtHostExtensionService),Ze=Me.get(q.IExtHostWorkspace),nt=Me.get(ce.IExtHostTelemetry),ht=Me.get(_.IExtHostConfiguration),_t=Me.get(we.IURITransformerService),ue=Me.get(Ce.IExtHostRpcService),De=Me.get(j.IExtHostStorage),le=Me.get(ie.IExtensionStoragePaths),Y=Me.get(ae.ILogService),Ne=Me.get(Re.IExtHostTunnelService),Te=Me.get(We.IExtHostApiDeprecationService),Je=Me.get(B.IExtHostWindow),et=Me.get(Z.IExtHostSecretState);ue.set(h.ExtHostContext.ExtHostFileSystemInfo,Qe),ue.set(h.ExtHostContext.ExtHostLogService,Y),ue.set(h.ExtHostContext.ExtHostWorkspace,Ze),ue.set(h.ExtHostContext.ExtHostConfiguration,ht),ue.set(h.ExtHostContext.ExtHostExtensionService,lt),ue.set(h.ExtHostContext.ExtHostStorage,De),ue.set(h.ExtHostContext.ExtHostTunnelService,Ne),ue.set(h.ExtHostContext.ExtHostWindow,Je),ue.set(h.ExtHostContext.ExtHostSecretState,et),ue.set(h.ExtHostContext.ExtHostTelemetry,nt);const ut=ue.set(h.ExtHostContext.ExtHostDecorations,Me.get(Le.IExtHostDecorations)),rt=ue.set(h.ExtHostContext.ExtHostDocumentsAndEditors,Me.get(r.IExtHostDocumentsAndEditors)),Ge=ue.set(h.ExtHostContext.ExtHostCommands,Me.get(E.IExtHostCommands)),ft=ue.set(h.ExtHostContext.ExtHostTerminalService,Me.get(W.IExtHostTerminalService)),at=ue.set(h.ExtHostContext.ExtHostDebugService,Me.get(J.IExtHostDebugService)),vt=ue.set(h.ExtHostContext.ExtHostSearch,Me.get(ee.IExtHostSearch)),pt=ue.set(h.ExtHostContext.ExtHostTask,Me.get(V.IExtHostTask)),St=ue.set(h.ExtHostContext.ExtHostOutputService,Me.get(w.IExtHostOutputService)),Ct=ue.set(h.ExtHostContext.ExtHostEditorTabs,new ne.ExtHostEditorTabs),It=ue.set(h.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(ue)),bt=ue.set(h.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(ue,rt)),At=ue.set(h.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(ue,rt,Y)),Yt=ue.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(Y,bt,ue.getProxy(h.MainContext.MainThreadBulkEdits))),mt=ue.set(h.ExtHostContext.ExtHostNotebook,new be.ExtHostNotebookController(ue,Ge,rt,bt,Y,le)),Jt=ue.set(h.ExtHostContext.ExtHostNotebookKernels,new pe.ExtHostNotebookKernels(ue,He,mt)),yt=ue.set(h.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(ue,rt)),jt=ue.set(h.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(ue.getProxy(h.MainContext.MainThreadTreeViews),Ge,Y)),Zt=ue.set(h.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(ue.getProxy(h.MainContext.MainThreadEditorInsets),yt,He.environment)),qt=ue.set(h.ExtHostContext.ExtHostDiagnostics,new g.ExtHostDiagnostics(ue,Y)),ct=ue.set(h.ExtHostContext.ExtHostLanguageFeatures,new m.ExtHostLanguageFeatures(ue,_t,bt,Ge,qt,Y,Te)),en=ue.set(h.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(ue,ct)),Tt=ue.set(h.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(ue,Y,rt)),Ut=ue.set(h.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(ue,Ze,Ge)),mn=ue.set(h.ExtHostContext.ExtHostSCM,new z.ExtHostSCM(ue,Ge,Y)),_n=ue.set(h.ExtHostContext.ExtHostComments,new v.ExtHostComments(ue,Ge,bt)),gn=ue.set(h.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(ue.getProxy(h.MainContext.MainThreadProgress))),tn=ue.set(h.ExtHostContext.ExtHosLabelService,new Ie.ExtHostLabelService(ue)),Kt=ue.set(h.ExtHostContext.ExtHostTheming,new Pe.ExtHostTheming(ue)),Ot=ue.set(h.ExtHostContext.ExtHostAuthentication,new Ee.ExtHostAuthentication(ue)),En=ue.set(h.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(ue,Ge)),nn=ue.set(h.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(ue,He.environment,Ze,Y,Te)),rn=ue.set(h.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(ue,nn,Ze)),Gt=ue.set(h.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(ue,bt,le,nn,rn)),Sn=ue.set(h.ExtHostContext.ExtHostWebviewViews,new xe.ExtHostWebviewViews(ue,nn)),Rt=ue.set(h.ExtHostContext.ExtHostTesting,new se.ExtHostTesting(ue,rt,Ze)),sn=ue.set(h.ExtHostContext.ExtHostUriOpeners,new fe.ExtHostUriOpeners(ue)),yn=(0,he.values)(h.ExtHostContext);ue.assertRegistered(yn);const xt=new Ye.ExtHostBulkEdits(ue,rt),on=new u.ExtHostClipboard(ue),Nt=new p.ExtHostMessageService(ue,Y),Lt=new l.ExtHostDialogs(ue),pn=new oe.ExtHostStatusBar(ue,Ge.converter),Bt=new S.ExtHostLanguages(ue,bt);return a.ExtHostApiCommands.register(Ge),function(Fe,an,ln){const gt=function(){let te=!Fe.isUnderDevelopment;function de(Ae){te||(Y.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")de(st);else{const H=st;typeof H.scheme=="undefined"&&de(st),!Fe.enableProposedApi&&typeof H.exclusive=="boolean"&&(0,Q.throwProposedApiError)(Fe)}return st}}(),Dn={getSession(te,de,Ae){return Ot.getSession(Fe,te,de,Ae)},get onDidChangeSessions(){return Ot.onDidChangeSessions},registerAuthenticationProvider(te,de,Ae,st){return Ot.registerAuthenticationProvider(te,de,Ae,st)},get onDidChangeAuthenticationProviders(){return(0,Q.checkProposedApiEnabled)(Fe),Ot.onDidChangeAuthenticationProviders},get providers(){return(0,Q.checkProposedApiEnabled)(Fe),Ot.providers},logout(te,de){return(0,Q.checkProposedApiEnabled)(Fe),Ot.removeSession(te,de)}},Cn={registerCommand(te,de,Ae){return Ge.registerCommand(!0,te,de,Ae)},registerTextEditorCommand(te,de,Ae){return Ge.registerCommand(!0,te,(...st)=>{const H=yt.getActiveTextEditor();if(!H){Y.warn("Cannot execute "+te+" because there is no active text editor.");return}return H.edit(x=>{de.apply(Ae,[H,x,...st])}).then(x=>{x||Y.warn("Edits from command "+te+" were not applied.")},x=>{Y.warn("An error occurred while running command "+te,x)})})},registerDiffInformationCommand:(te,de,Ae)=>((0,Q.checkProposedApiEnabled)(Fe),Ge.registerCommand(!0,te,async(...st)=>{const H=rt.activeEditor(!0);if(!H){Y.warn("Cannot execute "+te+" because there is no active text editor.");return}const x=await yt.getDiffInformation(H.id);de.apply(Ae,[x,...st])})),executeCommand(te,...de){return Ge.executeCommand(te,...de)},getCommands(te=!1){return Ge.getCommands(te)}},Qt={get machineId(){return He.telemetryInfo.machineId},get sessionId(){return He.telemetryInfo.sessionId},get language(){return He.environment.appLanguage},get appName(){return He.environment.appName},get appRoot(){var te,de;return(de=(te=He.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return He.environment.appUriScheme},get clipboard(){return on.value},get shell(){return ft.getDefaultShell(!1,ln)},get isTelemetryEnabled(){return nt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return nt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(He.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,de){return Je.openUri(te,{allowTunneling:!!He.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(te){return te.scheme===He.environment.appUriScheme?It.createAppUri(te):Je.asExternalUri(te,{allowTunneling:!!He.remote.authority})},get remoteName(){return(0,ke.getRemoteName)(He.remote.authority)},get uiKind(){return He.uiKind}};He.environment.extensionTestsLocationURI||Object.freeze(Qt);const vn=He.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,kn={registerTestController(te){return(0,Q.checkProposedApiEnabled)(Fe),Rt.registerTestController(Fe.identifier.value,te)},createDocumentTestObserver(te){return(0,Q.checkProposedApiEnabled)(Fe),Rt.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return(0,Q.checkProposedApiEnabled)(Fe),Rt.createWorkspaceTestObserver(te)},runTests(te){return(0,Q.checkProposedApiEnabled)(Fe),Rt.runTests(te)},createTestItem(te,de){return new L.TestItemImpl(te.id,te.label,te.uri,de)},createTestRunTask(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),Rt.createTestRunTask(Fe.identifier.value,te,de,Ae)},get onDidChangeTestResults(){return(0,Q.checkProposedApiEnabled)(Fe),Rt.onResultsChanged},get testResults(){return(0,Q.checkProposedApiEnabled)(Fe),Rt.results}},Pn={getExtension(te){const de=an.getExtensionDescription(te);if(de)return new i.Extension(lt,Fe.identifier,de,vn)},get all(){return an.getAllExtensionDescriptions().map(te=>new i.Extension(lt,Fe.identifier,te,vn))},get onDidChange(){return an.onDidChange}},In={createDiagnosticCollection(te){return qt.createDiagnosticCollection(Fe.identifier,te)},get onDidChangeDiagnostics(){return qt.onDidChangeDiagnostics},getDiagnostics:te=>qt.getDiagnostics(te),getLanguages(){return Bt.getLanguages()},setTextDocumentLanguage(te,de){return Bt.changeLanguage(te.uri,de)},match(te,de){return(0,C.score)(M.LanguageSelector.from(te),de.uri,de.languageId,!0)},registerCodeActionsProvider(te,de,Ae){return ct.registerCodeActionProvider(Fe,gt(te),de,Ae)},registerCodeLensProvider(te,de){return ct.registerCodeLensProvider(Fe,gt(te),de)},registerDefinitionProvider(te,de){return ct.registerDefinitionProvider(Fe,gt(te),de)},registerDeclarationProvider(te,de){return ct.registerDeclarationProvider(Fe,gt(te),de)},registerImplementationProvider(te,de){return ct.registerImplementationProvider(Fe,gt(te),de)},registerTypeDefinitionProvider(te,de){return ct.registerTypeDefinitionProvider(Fe,gt(te),de)},registerHoverProvider(te,de){return ct.registerHoverProvider(Fe,gt(te),de,Fe.identifier)},registerEvaluatableExpressionProvider(te,de){return ct.registerEvaluatableExpressionProvider(Fe,gt(te),de,Fe.identifier)},registerInlineValuesProvider(te,de){return ct.registerInlineValuesProvider(Fe,gt(te),de,Fe.identifier)},registerDocumentHighlightProvider(te,de){return ct.registerDocumentHighlightProvider(Fe,gt(te),de)},registerLinkedEditingRangeProvider(te,de){return ct.registerLinkedEditingRangeProvider(Fe,gt(te),de)},registerReferenceProvider(te,de){return ct.registerReferenceProvider(Fe,gt(te),de)},registerRenameProvider(te,de){return ct.registerRenameProvider(Fe,gt(te),de)},registerDocumentSymbolProvider(te,de,Ae){return ct.registerDocumentSymbolProvider(Fe,gt(te),de,Ae)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Fe,te)},registerDocumentFormattingEditProvider(te,de){return ct.registerDocumentFormattingEditProvider(Fe,gt(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return ct.registerDocumentRangeFormattingEditProvider(Fe,gt(te),de)},registerOnTypeFormattingEditProvider(te,de,Ae,...st){return ct.registerOnTypeFormattingEditProvider(Fe,gt(te),de,[Ae].concat(st))},registerDocumentSemanticTokensProvider(te,de,Ae){return ct.registerDocumentSemanticTokensProvider(Fe,gt(te),de,Ae)},registerDocumentRangeSemanticTokensProvider(te,de,Ae){return ct.registerDocumentRangeSemanticTokensProvider(Fe,gt(te),de,Ae)},registerSignatureHelpProvider(te,de,Ae,...st){return typeof Ae=="object"?ct.registerSignatureHelpProvider(Fe,gt(te),de,Ae):ct.registerSignatureHelpProvider(Fe,gt(te),de,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(te,de,...Ae){return ct.registerCompletionItemProvider(Fe,gt(te),de,Ae)},registerDocumentLinkProvider(te,de){return ct.registerDocumentLinkProvider(Fe,gt(te),de)},registerColorProvider(te,de){return ct.registerColorProvider(Fe,gt(te),de)},registerFoldingRangeProvider(te,de){return ct.registerFoldingRangeProvider(Fe,gt(te),de)},registerSelectionRangeProvider(te,de){return ct.registerSelectionRangeProvider(Fe,te,de)},registerCallHierarchyProvider(te,de){return ct.registerCallHierarchyProvider(Fe,te,de)},setLanguageConfiguration:(te,de)=>ct.setLanguageConfiguration(Fe,te,de),getTokenInformationAtPosition(te,de){return(0,Q.checkProposedApiEnabled)(Fe),Bt.tokenAtPosition(te,de)},registerInlineHintsProvider(te,de){return(0,Q.checkProposedApiEnabled)(Fe),ct.registerInlineHintsProvider(Fe,te,de)}},An={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(te,de,Ae){const st=await(k.URI.isUri(te)?Promise.resolve(cn.openTextDocument(te)):Promise.resolve(te));return yt.showTextDocument(st,de,Ae)},createTextEditorDecorationType(te){return yt.createTextEditorDecorationType(te)},onDidChangeActiveTextEditor(te,de,Ae){return yt.onDidChangeActiveTextEditor(te,de,Ae)},onDidChangeVisibleTextEditors(te,de,Ae){return yt.onDidChangeVisibleTextEditors(te,de,Ae)},onDidChangeTextEditorSelection(te,de,Ae){return yt.onDidChangeTextEditorSelection(te,de,Ae)},onDidChangeTextEditorOptions(te,de,Ae){return yt.onDidChangeTextEditorOptions(te,de,Ae)},onDidChangeTextEditorVisibleRanges(te,de,Ae){return yt.onDidChangeTextEditorVisibleRanges(te,de,Ae)},onDidChangeTextEditorViewColumn(te,de,Ae){return yt.onDidChangeTextEditorViewColumn(te,de,Ae)},onDidCloseTerminal(te,de,Ae){return ft.onDidCloseTerminal(te,de,Ae)},onDidOpenTerminal(te,de,Ae){return ft.onDidOpenTerminal(te,de,Ae)},onDidChangeActiveTerminal(te,de,Ae){return ft.onDidChangeActiveTerminal(te,de,Ae)},onDidChangeTerminalDimensions(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeTerminalDimensions(te,de,Ae)},onDidWriteTerminalData(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidWriteTerminalData(te,de,Ae)},get state(){return Je.state},onDidChangeWindowState(te,de,Ae){return Je.onDidChangeWindowState(te,de,Ae)},showInformationMessage(te,...de){return Nt.showMessage(Fe,y.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return Nt.showMessage(Fe,y.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return Nt.showMessage(Fe,y.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Ae){return Ut.showQuickPick(te,!!Fe.enableProposedApi,de,Ae)},showWorkspaceFolderPick(te){return Ut.showWorkspaceFolderPick(te)},showInputBox(te,de){return Ut.showInput(te,de)},showOpenDialog(te){return Lt.showOpenDialog(te)},showSaveDialog(te){return Lt.showSaveDialog(te)},createStatusBarItem(te,de){let Ae,st,H,x;return te&&typeof te!="number"?(Ae=te.id,st=te.name,H=te.alignment,de=te.priority,x=te.accessibilityInformation):(Ae=Fe.identifier.value,st=b.localize(0,null,Fe.displayName||Fe.name),H=te),pn.createStatusBarEntry(Ae,st,H,de,x)},setStatusBarMessage(te,de){return pn.setStatusBarMessage(te,de)},withScmProgress(te){return Te.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),gn.withProgress(Fe,{location:L.ProgressLocation.SourceControl},(de,Ae)=>te({report(st){}}))},withProgress(te,de){return gn.withProgress(Fe,te,de)},createOutputChannel(te){return St.createOutputChannel(te)},createWebviewPanel(te,de,Ae,st){return rn.createWebviewPanel(Fe,te,de,Ae,st)},createWebviewTextEditorInset(te,de,Ae,st){return(0,Q.checkProposedApiEnabled)(Fe),Zt.createWebviewEditorInset(te,de,Ae,st,Fe)},createTerminal(te,de,Ae){return typeof te=="object"?"pty"in te?ft.createExtensionTerminal(te):(te.message&&(0,Q.checkProposedApiEnabled)(Fe),te.icon&&(0,Q.checkProposedApiEnabled)(Fe),ft.createTerminalFromOptions(te)):ft.createTerminal(te,de,Ae)},registerTerminalLinkProvider(te){return ft.registerLinkProvider(te)},registerTreeDataProvider(te,de){return jt.registerTreeDataProvider(te,de,Fe)},createTreeView(te,de){return jt.createTreeView(te,de,Fe)},registerWebviewPanelSerializer:(te,de)=>rn.registerWebviewPanelSerializer(Fe,te,de),registerCustomEditorProvider:(te,de,Ae={})=>Gt.registerCustomEditorProvider(Fe,te,de,Ae),registerFileDecorationProvider(te){return ut.registerFileDecorationProvider(te,Fe.identifier)},registerUriHandler(te){return It.registerUriHandler(Fe.identifier,te)},createQuickPick(){return Ut.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Ut.createInputBox(Fe.identifier)},get activeColorTheme(){return Kt.activeColorTheme},onDidChangeActiveColorTheme(te,de,Ae){return Kt.onDidChangeActiveColorTheme(te,de,Ae)},registerWebviewViewProvider(te,de,Ae){return Sn.registerWebviewViewProvider(Fe,te,de,Ae==null?void 0:Ae.webviewOptions)},get activeNotebookEditor(){return(0,Q.checkProposedApiEnabled)(Fe),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),mt.onDidChangeActiveNotebookEditor(te,de,Ae)},get visibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Fe),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Fe),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),mt.onDidChangeNotebookEditorSelection(te,de,Ae)},onDidChangeNotebookEditorVisibleRanges(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),mt.onDidChangeNotebookEditorVisibleRanges(te,de,Ae)},showNotebookDocument(te,de){return(0,Q.checkProposedApiEnabled)(Fe),mt.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),sn.registerExternalUriOpener(Fe.identifier,te,de,Ae)},get openEditors(){return(0,Q.checkProposedApiEnabled)(Fe),Ct.tabs},get onDidChangeOpenEditors(){return(0,Q.checkProposedApiEnabled)(Fe),Ct.onDidChangeTabs}},cn={get rootPath(){return Te.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(te){throw T.readonly()},getWorkspaceFolder(te){return Ze.getWorkspaceFolder(te)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(te){throw T.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(te){throw T.readonly()},updateWorkspaceFolders:(te,de,...Ae)=>Ze.updateWorkspaceFolders(Fe,te,de||0,...Ae),onDidChangeWorkspaceFolders:function(te,de,Ae){return Ze.onDidChangeWorkspace(te,de,Ae)},asRelativePath:(te,de)=>Ze.getRelativePath(te,de),findFiles:(te,de,Ae,st)=>Ze.findFiles(M.GlobPattern.from(te),M.GlobPattern.from(de),Ae,Fe.identifier,st),findTextInFiles:(te,de,Ae,st)=>{let H,x;return typeof de=="object"?(H=de,x=Ae):(H={},x=de,st=Ae),Ze.findTextInFiles(te,H||{},x,Fe.identifier,st)},saveAll:te=>Ze.saveAll(te),applyEdit(te){return xt.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,de,Ae,st)=>Tt.createFileSystemWatcher(M.GlobPattern.from(te),de,Ae,st),get textDocuments(){return bt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw T.readonly()},openTextDocument(te){let de;const Ae=te;if(typeof te=="string")de=Promise.resolve(k.URI.file(te));else if(k.URI.isUri(te))de=Promise.resolve(te);else if(!Ae||typeof Ae=="object")de=bt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>bt.ensureDocumentData(st).then(H=>H.document))},onDidOpenTextDocument:(te,de,Ae)=>bt.onDidAddDocument(te,de,Ae),onDidCloseTextDocument:(te,de,Ae)=>bt.onDidRemoveDocument(te,de,Ae),onDidChangeTextDocument:(te,de,Ae)=>bt.onDidChangeDocument(te,de,Ae),onDidSaveTextDocument:(te,de,Ae)=>bt.onDidSaveDocument(te,de,Ae),onWillSaveTextDocument:(te,de,Ae)=>Yt.getOnWillSaveTextDocumentEvent(Fe)(te,de,Ae),onDidChangeConfiguration:(te,de,Ae)=>ln.onDidChangeConfiguration(te,de,Ae),getConfiguration(te,de){return de=arguments.length===1?void 0:de,ln.getConfiguration(te,de,Fe)},registerTextDocumentContentProvider(te,de){return At.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(Te.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Fe,te,de)),registerFileSystemProvider(te,de,Ae){return en.registerFileSystemProvider(Fe.identifier,te,de,Ae)},get fs(){return it.value},registerFileSearchProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),vt.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),vt.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),lt.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,Q.checkProposedApiEnabled)(Fe),tn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,de,Ae)=>Tt.onDidCreateFile(te,de,Ae),onDidDeleteFiles:(te,de,Ae)=>Tt.onDidDeleteFile(te,de,Ae),onDidRenameFiles:(te,de,Ae)=>Tt.onDidRenameFile(te,de,Ae),onWillCreateFiles:(te,de,Ae)=>Tt.getOnWillCreateFileEvent(Fe)(te,de,Ae),onWillDeleteFiles:(te,de,Ae)=>Tt.getOnWillDeleteFileEvent(Fe)(te,de,Ae),onWillRenameFiles:(te,de,Ae)=>Tt.getOnWillRenameFileEvent(Fe)(te,de,Ae),openTunnel:te=>((0,Q.checkProposedApiEnabled)(Fe),Ne.openTunnel(Fe,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Q.checkProposedApiEnabled)(Fe),Ne.getTunnels()},onDidChangeTunnels:(te,de,Ae)=>((0,Q.checkProposedApiEnabled)(Fe),Ne.onDidChangeTunnels(te,de,Ae)),registerPortAttributesProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),Ne.registerPortsAttributesProvider(te,de)),registerTimelineProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),En.registerTimelineProvider(te,de,Fe.identifier,Ge.converter)),get isTrusted(){return(0,Q.checkProposedApiEnabled)(Fe),Ze.trusted},requestWorkspaceTrust:te=>((0,Q.checkProposedApiEnabled)(Fe),Ze.requestWorkspaceTrust(te)),onDidReceiveWorkspaceTrust:(te,de,Ae)=>Ze.onDidReceiveWorkspaceTrust(te,de,Ae)},wn={get inputBox(){return Te.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),mn.getLastInputBox(Fe)},createSourceControl(te,de,Ae){return mn.createSourceControl(Fe,te,de,Ae)}},Wt={createCommentController(te,de){return _n.createCommentController(Fe,te,de)}},Xt={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(te,de,Ae){return at.onDidStartDebugSession(te,de,Ae)},onDidTerminateDebugSession(te,de,Ae){return at.onDidTerminateDebugSession(te,de,Ae)},onDidChangeActiveDebugSession(te,de,Ae){return at.onDidChangeActiveDebugSession(te,de,Ae)},onDidReceiveDebugSessionCustomEvent(te,de,Ae){return at.onDidReceiveDebugSessionCustomEvent(te,de,Ae)},onDidChangeBreakpoints(te,de,Ae){return at.onDidChangeBreakpoints(te,de,Ae)},registerDebugConfigurationProvider(te,de,Ae){return at.registerDebugConfigurationProvider(te,de,Ae||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return at.registerDebugAdapterDescriptorFactory(Fe,te,de)},registerDebugAdapterTrackerFactory(te,de){return at.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?at.startDebugging(te,de,{parentSession:Ae}):at.startDebugging(te,de,Ae||{})},stopDebugging(te){return at.stopDebugging(te)},addBreakpoints(te){return at.addBreakpoints(te)},removeBreakpoints(te){return at.removeBreakpoints(te)},asDebugSourceUri(te,de){return at.asDebugSourceUri(te,de)}},Tn={registerTaskProvider:(te,de)=>pt.registerTaskProvider(Fe,te,de),fetchTasks:te=>pt.fetchTasks(te),executeTask:te=>pt.executeTask(Fe,te),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(te,de,Ae)=>pt.onDidStartTask(te,de,Ae),onDidEndTask:(te,de,Ae)=>pt.onDidEndTask(te,de,Ae),onDidStartTaskProcess:(te,de,Ae)=>pt.onDidStartTaskProcess(te,de,Ae),onDidEndTaskProcess:(te,de,Ae)=>pt.onDidEndTaskProcess(te,de,Ae)},un={openNotebookDocument:te=>((0,Q.checkProposedApiEnabled)(Fe),mt.openNotebookDocument(te)),get onDidOpenNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Fe),mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Fe),mt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Fe),mt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,Q.checkProposedApiEnabled)(Fe),mt.notebookDocuments.map(te=>te.notebookDocument)},registerNotebookSerializer(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),mt.registerNotebookSerializer(Fe,te,de,Ae)},registerNotebookContentProvider:(te,de,Ae)=>((0,Q.checkProposedApiEnabled)(Fe),mt.registerNotebookContentProvider(Fe,te,de,Ae)),registerNotebookCellStatusBarItemProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),mt.registerNotebookCellStatusBarItemProvider(Fe,te,de)),createNotebookEditorDecorationType(te){return(0,Q.checkProposedApiEnabled)(Fe),mt.createNotebookEditorDecorationType(te)},onDidChangeNotebookDocumentMetadata(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),mt.onDidChangeNotebookDocumentMetadata(te,de,Ae)},onDidChangeNotebookCells(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),mt.onDidChangeNotebookCells(te,de,Ae)},onDidChangeCellExecutionState(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),mt.onDidChangeNotebookCellExecutionState(te,de,Ae)},onDidChangeCellOutputs(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),mt.onDidChangeCellOutputs(te,de,Ae)},onDidChangeCellMetadata(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),mt.onDidChangeCellMetadata(te,de,Ae)},createConcatTextDocument(te,de){return(0,Q.checkProposedApiEnabled)(Fe),new X.ExtHostNotebookConcatDocument(mt,bt,te,de)},createNotebookCellExecutionTask(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),mt.createNotebookCellExecution(te,de,Ae)},createNotebookController(te,de,Ae,st,H){return(0,Q.checkProposedApiEnabled)(Fe),Jt.createNotebookController(Fe,te,de,Ae,st,H)}};return{version:He.version,authentication:Dn,commands:Cn,comments:Wt,debug:Xt,env:Qt,extensions:Pn,languages:In,notebook:un,scm:wn,tasks:Tn,test:kn,window:An,workspace:cn,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:f.FileType,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,Hover:L.Hover,IndentAction:s.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:P.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,UIKind:h.UIKind,Uri:k.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlineHint:L.InlineHint,InlineHintKind:L.InlineHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,RemoteTrustOption:Se.RemoteTrustOption,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookDocumentMetadata:L.NotebookDocumentMetadata,NotebookCellMetadata:L.NotebookCellMetadata,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,LinkedEditingRanges:L.LinkedEditingRanges,TestItemStatus:L.TestItemStatus,TestResultState:L.TestResultState,TestMessage:L.TestMessage,TestMessageSeverity:L.TestMessageSeverity,WorkspaceTrustState:L.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=qe}),define(me[270],ge([0,1,78,64,32,125,35,51,39,34,66,46,68,92,91,50,63,126,90,61,89,118]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E,v,_,g,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(h.IExtensionStoragePaths,h.ExtensionStoragePaths),(0,b.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),(0,b.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,b.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,b.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,b.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,b.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,b.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,b.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo),(0,b.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,b.registerSingleton)(f.IExtHostSearch,f.ExtHostSearch),(0,b.registerSingleton)(a.IExtHostStorage,a.ExtHostStorage),(0,b.registerSingleton)(s.IExtHostTask,s.WorkerExtHostTask),(0,b.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,b.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,b.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,b.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,b.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,b.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry)}),define(me[93],ge([0,1,15,13,31,127]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=y;function k(C,f,h,a){const u=(0,b.mapArrayOrNot)(h,D),E=new T.TextSearchMatch(f,u,a),v=E.preview.matches;return{ranges:(0,b.mapArrayOrNot)(u,P),uri:C,preview:{text:E.preview.text,matches:(0,b.mapArrayOrNot)(v,P)}}}e.createTextSearchResult=k;function D(C){return new T.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function P(C){return new A.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let s=class{constructor(f,h){this.prefix=f,this.logService=h}appendLine(f){this.logService.debug(`${this.prefix}#search`,f)}};s=je([Be(1,I.ILogService)],s),e.OutputChannel=s}),define(me[271],ge([0,1,94,22]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(n){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(t=>t===n)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,y=512,k=512*8,D=512*128;class P{constructor(t){this.iconvLiteDecoder=t}static async create(t){let r;if(t!==e.UTF8)r=(await new Promise((o,c)=>{G(["iconv-lite-umd"],o,c)})).getDecoder(h(t));else{const i=new TextDecoder;r={write(o){return i.decode(o,{stream:!0})},end(){return i.decode()}}}return new P(r)}write(t){return this.iconvLiteDecoder.write(t)}end(){return this.iconvLiteDecoder.end()}}function s(n,t){var r;const i=((r=t.minBytesRequiredForDetection)!==null&&r!==void 0?r:t.guessEncoding)?k:y;return new Promise((o,c)=>{const m=(0,b.newWriteableStream)(F=>F.join("")),S=[];let p=0,w;const R=async()=>{try{const F=await d({buffer:I.VSBuffer.concat(S),bytesRead:p},t.guessEncoding);F.encoding=await t.overwriteEncoding(F.encoding),w=await P.create(F.encoding);const z=w.write(I.VSBuffer.concat(S).buffer);m.write(z),S.length=0,p=0,o({stream:m,detected:F})}catch(F){c(F)}};(0,b.listenStream)(n,{onData:async F=>{w?m.write(w.write(F.buffer)):(S.push(F),p+=F.byteLength,p>=i&&(n.pause(),await R(),setTimeout(()=>n.resume())))},onError:F=>m.error(F),onEnd:async()=>{w||await R(),m.end(w==null?void 0:w.end())}})})}e.toDecodeStream=s;async function C(n,t,r){const o=(await new Promise((S,p)=>{G(["iconv-lite-umd"],S,p)})).getEncoder(h(t),r);let c=!1,m=!1;return{read(){if(m)return null;const S=n.read();if(typeof S!="string"){if(m=!0,!c&&(r==null?void 0:r.addBOM))switch(t){case e.UTF8:case e.UTF8_with_bom:return I.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const p=o.end();return p&&p.length>0?(c=!0,I.VSBuffer.wrap(p)):null}return c=!0,I.VSBuffer.wrap(o.write(S))}}}e.toEncodeReadable=C;async function f(n){return(await new Promise((r,i)=>{G(["iconv-lite-umd"],r,i)})).encodingExists(h(n))}e.encodingExists=f;function h(n){return n===e.UTF8_with_bom||n===null?e.UTF8:n}e.toNodeEncoding=h;function a(n,t){if(!n||t<e.UTF16be_BOM.length)return null;const r=n.readUInt8(0),i=n.readUInt8(1);if(r===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(t<e.UTF8_BOM.length)return null;const o=n.readUInt8(2);return r===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const u=["ascii","utf-16","utf-32"];async function E(n){const t=await new Promise((m,S)=>{G(["jschardet"],m,S)}),r=n.slice(0,D),i=g(r.buffer),o=t.detect(i);if(!o||!o.encoding)return null;const c=o.encoding.toLowerCase();return 0<=u.indexOf(c)?null:_(o.encoding)}const v={ibm866:"cp866",big5:"cp950"};function _(n){const t=n.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return v[t]||t}function g(n){let t="";for(let r=0;r<n.length;r++)t+=String.fromCharCode(n[r]);return t}function l(n){switch(n){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const t=n.match(/windows(\d+)/);return t?"windows-"+t[1]:n}}e.toCanonicalName=l;function d({buffer:n,bytesRead:t},r){let i=a(n,t),o=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&n){let c=!0,m=!0,S=!1;for(let p=0;p<t&&p<A;p++){const w=p%2==1,R=n.readUInt8(p)===0;if(R&&(S=!0),c&&(w&&!R||!w&&R)&&(c=!1),m&&(w&&R||!w&&!R)&&(m=!1),R&&!c&&!m)break}S&&(c?i=e.UTF16le:m?i=e.UTF16be:o=!0)}return r&&!o&&!i&&n?E(n.slice(0,t)).then(c=>({seemsBinary:!1,encoding:c})):{seemsBinary:o,encoding:i}}e.detectEncodingFromBuffer=d,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[129],ge([0,1,271,26,128]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends T.TextSearchManager{constructor(k,D,P=I){super(k,D,{readdir:s=>P.readdir(s.fsPath),toCanonicalName:s=>(0,b.toCanonicalName)(s)})}}e.NativeTextSearchManager=A}),define(me[272],ge([0,1,273,287,288,2,289]),function(G,e,b,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(C,f,h,a,u,E){const v=E.environment.useHostProxy,_=typeof v=="boolean"?v:!E.remote.isRemote,g=(0,y.createProxyResolver)({resolveProxy:d=>C.resolveProxy(d),getHttpProxySetting:()=>f.getConfiguration("http").get("proxy"),log:(d,n,...t)=>{switch(d){case y.LogLevel.Trace:a.trace(n,...t);break;case y.LogLevel.Debug:a.debug(n,...t);break;case y.LogLevel.Info:a.info(n,...t);break;case y.LogLevel.Warning:a.warn(n,...t);break;case y.LogLevel.Error:a.error(n,...t);break;case y.LogLevel.Critical:a.critical(n,...t);break;case y.LogLevel.Off:break;default:r(d,n,t);break}function r(i,o,...c){a.error("Unknown log level",i),a.error(o,...c)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:d=>{u.$publicLog2("resolveProxy",d)},useHostProxy:_,env:process.env}),l=D(f,g);return s(h,l)}e.connectProxyResolver=k;function D(C,f){const h={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(u=>{h.config=C.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(u=>{a.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},b,(0,y.createHttpPatch)(b,f,{config:"off"},a,!0)),on:Object.assign({},b,(0,y.createHttpPatch)(b,f,{config:"on"},a,!0)),override:Object.assign({},b,(0,y.createHttpPatch)(b,f,{config:"override"},a,!0)),onRequest:Object.assign({},b,(0,y.createHttpPatch)(b,f,h,a,!0)),default:Object.assign(b,(0,y.createHttpPatch)(b,f,h,a,!1))},https:{off:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"off"},a,!0)),on:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"on"},a,!0)),override:Object.assign({},I,(0,y.createHttpPatch)(I,f,{config:"override"},a,!0)),onRequest:Object.assign({},I,(0,y.createHttpPatch)(I,f,h,a,!0)),default:Object.assign(I,(0,y.createHttpPatch)(I,f,h,a,!1))},tls:Object.assign(T,(0,y.createTlsPatch)(T))}}const P=new Map;function s(C,f){return C.getExtensionPathIndex().then(h=>{const a=G.__$__nodeRequire("module"),u=a._load;a._load=function(v,_,g){if(v==="tls")return f.tls;if(v!=="http"&&v!=="https")return u.apply(this,arguments);const l=f[v],d=h.findSubstr(A.URI.file(_.filename).fsPath);let n=P.get(d);if(n||P.set(d,n={}),!n[v]){let t=l.default;d&&d.enableProposedApi&&(t=l[d.proxySupport]||l.onRequest),n[v]=Object.assign({},t)}return n[v]}})}}),define(me[274],ge([0,1,38,8,74,29,9,10,93,275]),function(G,e,b,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const s=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(g,l,d,n){const t=f(g,l,d,n),r=l.folder.fsPath;return{cmd:b.spawn(s,t.args,{cwd:r}),rgDiskPath:s,siblingClauses:t.siblingClauses,rgArgs:t,cwd:r}}e.spawnRipgrepCmd=C;function f(g,l,d,n){const t=["--files","--hidden","--case-sensitive"];a([l],d,!1).forEach(i=>{const o=(0,D.anchorGlob)(i);if(t.push("-g",o),y.isMacintosh){const c=(0,T.normalizeNFD)(o);c!==o&&t.push("-g",c)}});const r=h([l],n,void 0,!1);return r.globArgs.forEach(i=>{const o=`!${(0,D.anchorGlob)(i)}`;if(t.push("-g",o),y.isMacintosh){const c=(0,T.normalizeNFD)(o);c!==o&&t.push("-g",c)}}),l.disregardIgnoreFiles!==!1?t.push("--no-ignore"):t.push("--no-ignore-parent"),l.ignoreSymlinks||t.push("--follow"),g.exists&&t.push("--quiet"),t.push("--no-config"),l.disregardGlobalIgnoreFiles&&t.push("--no-ignore-global"),{args:t,siblingClauses:r.siblingClauses}}function h(g,l,d,n=!0){const t=[];let r={};return g.forEach(i=>{const o=Object.assign({},i.excludePattern||{},l||{}),c=u(o,n?i.folder.fsPath:void 0,d);t.push(...c.globArgs),c.siblingClauses&&(r=Object.assign(r,c.siblingClauses))}),{globArgs:t,siblingClauses:r}}e.foldersToRgExcludeGlobs=h;function a(g,l,d=!0){const n=[];return g.forEach(t=>{const r=Object.assign({},l||{},t.includePattern||{}),i=u(r,d?t.folder.fsPath:void 0);n.push(...i.globArgs)}),n}e.foldersToIncludeGlobs=a;function u(g,l,d){const n=[],t={};return Object.keys(g).forEach(r=>{if(!(d&&d.has(r))&&!!r){const i=g[r];r=v(l?E(l,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),n.push(_(r))):i&&i.when&&(t[r]=i)}}),{globArgs:n,siblingClauses:t}}function E(g,l){return I.isAbsolute(l)?l:I.join(g,l)}e.getAbsoluteGlob=E;function v(g){return g=k.rtrim(g,"\\"),k.rtrim(g,"/")}function _(g){return A.getRoot(g).toLowerCase()==="c:/"?g.replace(/^c:[/\\]/i,"/"):g}e.fixDriveC=_}),define(me[276],ge([0,1,38,37,8,101,15,59,33,74,29,9,47,10,12,26,31,274,99]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const g=new Set;process.on("exit",()=>{g.forEach(r=>r())});class l{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&D.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&D.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(o=>{const c=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),m=o.folder.fsPath;i.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==m).forEach(S=>{(0,s.isEqualOrParent)(S,m)&&(c[T.relative(m,S)]=!0)}),this.folderExcludePatterns.set(m,new n(c,m))})}cancel(){this.isCanceled=!0}walk(i,o,c,m,S){if(this.fileWalkSW=f.StopWatch.create(!1),this.isCanceled)return S(null,this.isLimitHit);o.forEach(p=>{const w=T.basename(p.fsPath);this.globalExcludePattern&&this.globalExcludePattern(p.fsPath,w)||this.matchFile(c,{relativePath:p.fsPath,searchPath:void 0})}),this.cmdSW=f.StopWatch.create(!1),this.parallel(i,(p,w)=>{this.call(this.cmdTraversal,this,p,c,m,R=>{if(R){const F=(0,k.toErrorMessage)(R);console.error(F),this.errors.push(F),w(R,void 0)}else w(null,void 0)})},(p,w)=>{this.fileWalkSW.stop();const R=p?y.coalesce(p)[0]:null;S(R,this.isLimitHit)})}parallel(i,o,c){const m=new Array(i.length),S=new Array(i.length);let p=!1,w=0;if(i.length===0)return c(null,[]);i.forEach((R,F)=>{o(R,(z,oe)=>{if(z?(p=!0,m[F]=null,S[F]=z):(m[F]=oe,S[F]=null),++w===i.length)return c(p?S:null,m)})})}call(i,o,...c){try{i.apply(o,c)}catch(m){c[c.length-1](m)}}cmdTraversal(i,o,c,m){const S=i.folder.fsPath,p=C.isMacintosh;let w;const R=()=>w&&w.kill();g.add(R);let F=M=>{g.delete(R),F=()=>{},m(M)},z="";const oe=this.initDirectoryTree();let j;const W=(0,v.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);w=W.cmd,j=!Object.keys(W.siblingClauses).length;const $=W.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let U=`${W.rgDiskPath} ${$}
 - cwd: ${W.cwd}`;W.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(W.rgArgs.siblingClauses)}`),c({message:U}),this.cmdResultCount=0,this.collectStdout(w,"utf8",c,(M,L,N)=>{if(M){F(M);return}if(this.isLimitHit){F();return}const B=(z+(p?P.normalizeNFC(L||""):L)).split(`
`);if(N){const q=B.length;B[q-1]=B[q-1].trim(),B[q-1]||B.pop()}else z=B.pop()||"";if(B.length&&B[0].indexOf(`
`)!==-1){F(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=B.length,j){for(const q of B)if(this.matchFile(o,{base:S,relativePath:q,searchPath:this.getSearchPath(i,q)}),this.isLimitHit){R();break}(N||this.isLimitHit)&&F();return}this.addDirectoryEntries(i,oe,S,B,o),N&&(this.matchDirectoryTree(oe,S,o),F())})}spawnFindCmd(i){const o=this.folderExcludePatterns.get(i.folder.fsPath),c=o.getBasenameTerms(),m=o.getPathTerms(),S=["-L","."];if(c.length||m.length){S.push("-not","(","(");for(const p of c)S.push("-name",p),S.push("-o");for(const p of m)S.push("-path",p),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),b.spawn("find",S,{cwd:i.folder.fsPath})}readStdout(i,o,c){let m="";this.collectStdout(i,o,()=>{},(S,p,w)=>{if(S){c(S);return}m+=p,w&&c(null,m)})}collectStdout(i,o,c,m){let S=(R,F,z)=>{(R||z)&&(S=()=>{},this.cmdSW&&this.cmdSW.stop()),m(R,F,z)},p=!1;i.stdout?(this.forwardData(i.stdout,o,S),i.stdout.once("data",()=>p=!0)):c({message:"stdout is null"});let w;i.stderr?w=this.collectData(i.stderr):c({message:"stderr is null"}),i.on("error",R=>{S(R)}),i.on("close",R=>{let F;!p&&(F=this.decodeData(w,o))&&t(F)?S(new Error(`command failed with error code ${R}: ${this.decodeData(w,o)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),S(null,"",!0))})}forwardData(i,o,c){const m=new A.StringDecoder(o);return i.on("data",S=>{c(null,m.write(S))}),m}collectData(i){const o=[];return i.on("data",c=>{o.push(c)}),o}decodeData(i,o){const c=new A.StringDecoder(o);return i.map(m=>c.write(m)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:o},c,m,S){m.indexOf(this.filePattern)!==-1&&this.matchFile(S,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const p=w=>{const R=T.basename(w),F=T.dirname(w);let z=o[F];z||(z=o[F]=[],p(F)),z.push({base:c,relativePath:w,basename:R,searchPath:this.getSearchPath(i,w)})};m.forEach(p)}matchDirectoryTree({rootEntries:i,pathToEntries:o},c,m){const S=this,p=this.folderExcludePatterns.get(c),w=this.filePattern;function R(F){S.directoriesWalked++;const z=D.hasSiblingFn(()=>F.map(oe=>oe.basename));for(let oe=0,j=F.length;oe<j;oe++){const W=F[oe],{relativePath:$,basename:U}=W;if(!p.test($,U,w!==U?z:void 0)){const M=o[$];if(M)R(M);else{if(S.filesWalked++,$===w)continue;S.matchFile(m,W)}if(S.isLimitHit)break}}}R(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,o,c,m,S){const p=i.folder,w=D.hasSiblingFn(()=>c);this.parallel(c,(R,F)=>{if(this.isCanceled||this.isLimitHit)return F(null);const z=o?[o,R].join(T.sep):R;if(this.folderExcludePatterns.get(i.folder.fsPath).test(z,R,this.config.filePattern!==R?w:void 0))return F(null);const oe=[p.fsPath,z].join(T.sep);I.lstat(oe,(j,W)=>{if(j||this.isCanceled||this.isLimitHit)return F(null);this.statLinkIfNeeded(oe,W,($,U)=>$||this.isCanceled||this.isLimitHit?F(null):U.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(oe,W,(M,L)=>M||this.isCanceled||this.isLimitHit||(L=L||"",this.walkedPaths[L])?F(null):(this.walkedPaths[L]=!0,(0,u.readdir)(oe).then(N=>{if(this.isCanceled||this.isLimitHit)return F(null);this.doWalk(i,z,N,m,O=>F(O||null))},N=>{F(null)})))):(this.filesWalked++,z===this.filePattern||this.maxFilesize&&a.isNumber(U.size)&&U.size>this.maxFilesize||this.matchFile(m,{base:p.fsPath,relativePath:z,searchPath:this.getSearchPath(i,z)}),F(null,void 0)))})},R=>{const F=R&&y.coalesce(R);return S(F&&F.length>0?F[0]:void 0)})}matchFile(i,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,T.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(o))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,o,c){return o.isSymbolicLink()?I.stat(i,c):c(null,o)}realPathIfNeeded(i,o,c){return o.isSymbolicLink()?I.realpath(i,(m,S)=>m?c(m):c(null,S)):c(null,i)}getSearchPath(i,o){return i.folderName?T.join(i.folderName,o):o}}e.FileWalker=l;class d{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new l(i)}search(i,o,c){this.walker.walk(this.folderQueries,this.extraFiles,i,o,(m,S)=>{c(m,{limitHit:S,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=d;class n{constructor(i,o){this.expression=i,this.root=o,this.init(i)}init(i){let o,c;Object.keys(i).filter(m=>i[m]).forEach(m=>{T.isAbsolute(m)?(o=o||D.getEmptyExpression(),o[m]=i[m]):(c=c||D.getEmptyExpression(),c[m]=i[m])}),this.absoluteParsedExpr=o&&D.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=c&&D.parse(c,{trimForExclusions:!0})}test(i,o,c){return this.relativeParsedExpr&&this.relativeParsedExpr(i,o,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(T.join(this.root,i),o,c)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getPathTerms(this.relativeParsedExpr)),i}}function t(r){const i=r.trim().split(`
`),o=i[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return h.uppercaseFirstLetter(i[i.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=t}),define(me[130],ge([0,1,38,290,101,15,53,33,8,10,2,31,127,291,275,93]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class v{constructor(p){this.outputChannel=p}provideTextSearchResults(p,w,R,F){return this.outputChannel.appendLine(`provideTextSearchResults ${p.pattern}, ${JSON.stringify(Object.assign(Object.assign({},w),{folder:w.folder.toString()}))}`),new Promise((z,oe)=>{F.onCancellationRequested(()=>O());const j=t(p,w),W=w.folder.fsPath,$=j.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${E} ${$}
 - cwd: ${W}`);let U=b.spawn(E,j,{cwd:W});U.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),oe((0,C.serializeSearchError)(new C.SearchError(ve&&ve.message,C.SearchErrorCode.rgProcessError)))});let M=!1;const L=new l(w.maxResults,W,w.previewOptions);L.on("result",ve=>{M=!0,q="",R.report(ve)});let N=!1;const O=()=>{N=!0,U&&U.kill(),L&&L.cancel()};let B=!1;L.on("hitLimit",()=>{B=!0,O()});let q="";U.stdout.on("data",ve=>{L.handleData(ve),M||(q+=ve)});let Q=!1;U.stdout.once("data",()=>Q=!0);let he="";U.stderr.on("data",ve=>{const Ie=ve.toString();this.outputChannel.appendLine(Ie),he+=Ie}),U.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),N)z({limitHit:B});else{L.flush(),U=null;let ve;he&&!Q&&(ve=_(he))?oe((0,C.serializeSearchError)(new C.SearchError(ve.message,ve.code))):z({limitHit:B})}})})}}e.RipgrepTextSearchEngine=v;function _(S){const p=S.split(`
`),w=p[0].trim();if(p.some(F=>F.startsWith("regex parse error")))return new C.SearchError(g(p),C.SearchErrorCode.regexParseError);const R=w.match(/grep config error: unknown encoding: (.*)/);if(R)return new C.SearchError(`Unknown encoding: ${R[1]}`,C.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new C.SearchError(w.charAt(0).toUpperCase()+w.substr(1),C.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new C.SearchError(w.charAt(0).toUpperCase()+w.substr(1),C.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(w,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function g(S){const p=["Regex parse error"],w=S.filter(R=>R.startsWith("PCRE2:"));if(w.length>=1){const R=w[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const F=R.split(":")[1];p.push(":"+F)}}return p.join("")}e.buildRegexParseError=g;class l extends I.EventEmitter{constructor(p,w,R){super();this.maxResults=p,this.rootFolder=w,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new T.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(p,w){return super.on(p,w),this}handleData(p){if(!this.isDone){const w=typeof p=="string"?p:this.stringDecoder.write(p);this.handleDecodedData(w)}}handleDecodedData(p){let w=p.indexOf(`
`);const R=this.remainder+p;if(w>=0)w+=this.remainder.length;else{this.remainder=R;return}let F=0;for(;w>=0;)this.handleLine(R.substring(F,w).trim()),F=w+1,w=R.indexOf(`
`,F);this.remainder=R.substring(F)}handleLine(p){if(!(this.isDone||!p)){let w;try{w=JSON.parse(p)}catch(R){throw new Error(`malformed line from rg: ${p}`)}if(w.type==="match"){const R=d(w.data.path),F=s.URI.file(D.join(this.rootFolder,R)),z=this.createTextSearchMatch(w.data,F);this.onResult(z),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const R=d(w.data.path),F=s.URI.file(D.join(this.rootFolder,R));this.createTextSearchContext(w.data,F).forEach(oe=>this.onResult(oe))}}}createTextSearchMatch(p,w){const R=p.line_number-1;let F=!1,z=d(p.lines);R===0&&(0,P.startsWithUTF8BOM)(z)&&(F=!0,z=(0,P.stripUTF8BOM)(z));const oe=Buffer.from(z);let j=0,W=0,$=R;p.submatches.length===0&&p.submatches.push(z.length?{start:0,end:1,match:{text:z[0]}}:{start:0,end:0,match:{text:""}});const U=(0,A.coalesce)(p.submatches.map((M,L)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let N=d(M.match);R===0&&L===0&&F&&(N=(0,P.stripUTF8BOM)(N),M.start=M.start<=3?0:M.start-3,M.end=M.end<=3?0:M.end-3);const O=oe.slice(j,M.start).toString().length,B=W+O,q=n(N),Q=$,he=q.numLines+Q,ve=q.numLines>0?q.lastLineLength:q.lastLineLength+B;return j=M.end,W=ve,$=he,new f.Range(Q,B,he,ve)}));return(0,u.createTextSearchResult)(w,z,U,this.previewOptions)}createTextSearchContext(p,w){const R=d(p.lines),F=p.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((z,oe)=>({text:z,uri:w,lineNumber:F+oe}))}onResult(p){this.emit("result",p)}}e.RipgrepParser=l;function d(S){return S.bytes?Buffer.from(S.bytes,"base64").toString():S.text}function n(S){const p=/\n/g;let w=0,R=-1,F;for(;F=p.exec(S);)w++,R=F.index;const z=R>=0?S.length-R-1:S.length;return{numLines:w,lastLineLength:z}}function t(S,p){const w=["--hidden"];w.push(S.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:F}=(0,y.groupBy)(p.includes,oe=>oe.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const oe=new Set;F.forEach(j=>{oe.add(j)}),w.push("-g","!*"),oe.forEach(j=>{r(j).map(u.anchorGlob).forEach(W=>{w.push("-g",W)})})}R&&R.length&&R.forEach(oe=>{w.push("-g",oe)}),p.excludes.map(u.anchorGlob).forEach(oe=>w.push("-g",`!${oe}`)),p.maxFileSize&&w.push("--max-filesize",p.maxFileSize+""),p.useIgnoreFiles?w.push("--no-ignore-parent"):w.push("--no-ignore"),p.followSymlinks&&w.push("--follow"),p.encoding&&p.encoding!=="utf8"&&w.push("--encoding",p.encoding),S.pattern==="--"&&(S.isRegExp=!0,S.pattern="\\-\\-"),S.isMultiline&&!S.isRegExp&&(S.pattern=(0,P.escapeRegExpCharacters)(S.pattern),S.isRegExp=!0),p.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),S.isRegExp&&(S.pattern=i(S.pattern),w.push("--auto-hybrid-regex"));let z;if(S.isWordMatch){const j=(0,P.createRegExp)(S.pattern,!!S.isRegExp,{wholeWord:S.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",j)}else if(S.isRegExp){let oe=c(S.pattern);oe=m(oe),w.push("--regexp",oe)}else z=S.pattern,w.push("--fixed-strings");return w.push("--no-config"),p.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),S.isMultiline&&w.push("--multiline"),p.beforeContext&&w.push("--before-context",p.beforeContext+""),p.afterContext&&w.push("--after-context",p.afterContext+""),w.push("--"),z&&w.push(z),w.push("."),w}function r(S){const p=(0,k.splitGlobAware)(S,"/");return p.map((w,R)=>p.slice(0,R+1).join("/"))}e.spreadGlobComponents=r;function i(S){const p=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;S.match(p);)S=S.replace(p,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;S.match(w);)S=S.replace(w,"$1\\x{$2}");return S}e.unicodeEscapesToPCRE2=i;const o=S=>S.type==="Assertion"&&S.kind==="lookbehind";function c(S){let p;try{p=new h.RegExpParser().parsePattern(S)}catch(j){return S}let w="",R=0;const F=(j,W,$)=>{w+=S.slice(R,j)+$,R=W},z=[];return new h.RegExpVisitor({onCharacterEnter(j){if(j.raw==="\\n"){const W=z[0];if(!W)F(j.start,j.end,"\\r?\\n");else if(!z.some(o))if(W.type==="CharacterClass"){const $=S.slice(W.start+1,j.start)+S.slice(j.end,W.end-1);F(W.start,W.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else W.type==="Quantifier"&&F(j.start,j.end,"(?:\\r?\\n)")}},onQuantifierEnter(j){z.unshift(j)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(j){z.unshift(j)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(j){z.unshift(j)},onCharacterClassLeave(){z.shift()},onAssertionEnter(j){o(j)&&z.push(j)},onAssertionLeave(j){z[0]===j&&z.shift()}}).visit(p),w+=S.slice(R),w}e.fixRegexNewline=c;function m(S){return S.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(me[277],ge([0,1,21,130,114,11]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,s,C,f){const h=new I.RipgrepTextSearchEngine(this.outputChannel);if(s.folder.scheme===A.Schemas.userData){const a=Object.assign(Object.assign({},s),{folder:s.folder.with({scheme:A.Schemas.file})}),u=new T.Progress(E=>C.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:s.folder.scheme})})));return this.withToken(f,E=>h.provideTextSearchResults(P,a,u,E))}else return this.withToken(f,a=>h.provideTextSearchResults(P,s,C,a))}async withToken(P,s){const C=k(P);this.inProgress.add(C);const f=await s(C.token);return this.inProgress.delete(C),f}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=y;function k(D){const P=new b.CancellationTokenSource;return D.onCancellationRequested(()=>P.cancel()),P}}),define(me[278],ge([0,1,26,130,129]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(D){this.query=D}search(D,P,s){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(h){s({message:h})}},f=new T.NativeTextSearchManager(this.query,new I.RipgrepTextSearchEngine(C),b);return new Promise((h,a)=>f.search(u=>{P(u.map(y))},D).then(u=>h({limitHit:u.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=A;function y(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((D,P)=>{if(P.ranges){const s=P;return D+(Array.isArray(s.ranges)?s.ranges.length:1)}else return D+1},0)}}}),define(me[279],ge([0,1,37,292,15,16,19,3,99,8,47,2,45,31,276,278]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,I.gracefulify(b);class E{constructor(){this.caches=Object.create(null)}fileSearch(n){let t;const r=g(n),i=new k.Emitter({onFirstListenerDidAdd:()=>{t=(0,A.createCancelablePromise)(o=>this.doFileSearchWithEngine(a.Engine,r,c=>i.fire(c),o)),t.then(o=>i.fire(o),o=>i.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{t.cancel()}});return i.event}textSearch(n){let t;const r=g(n),i=new k.Emitter({onFirstListenerDidAdd:()=>{t=(0,A.createCancelablePromise)(o=>this.ripgrepTextSearch(r,c=>i.fire(c),o)),t.then(o=>i.fire(o),o=>i.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{t.cancel()}});return i.event}ripgrepTextSearch(n,t,r){return n.maxFileSize=(0,f.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new u.TextSearchEngineAdapter(n).search(r,t,t)}doFileSearch(n,t,r){return this.doFileSearchWithEngine(a.Engine,n,t,r)}doFileSearchWithEngine(n,t,r,i,o=E.BATCH_SIZE){let c=0;const m=p=>{Array.isArray(p)?(c+=p.length,r(p.map(w=>this.rawMatchToSearchItem(w)))):p.relativePath?(c++,r(this.rawMatchToSearchItem(p))):r(p)};if(t.sortByScore){let p=this.trySortedSearchFromCache(t,m,i);if(!p){const w=t.maxResults?Object.assign({},t,{maxResults:null}):t,R=new n(w);p=this.doSortedSearch(R,t,r,m,i)}return new Promise((w,R)=>{p.then(([F,z])=>{const oe=z.map(j=>this.rawMatchToSearchItem(j));this.sendProgress(oe,r,o),w(F)},R)})}const S=new n(t);return this.doSearch(S,m,o,i).then(p=>({limitHit:p.limitHit,type:"success",stats:{detailStats:p.stats,type:"searchProcess",fromCache:!1,resultCount:c,sortingTime:void 0}}))}rawMatchToSearchItem(n){return{path:n.base?(0,P.join)(n.base,n.relativePath):n.relativePath}}doSortedSearch(n,t,r,i,o){const c=new k.Emitter;let m=(0,A.createCancelablePromise)(p=>{let w=[];const R=F=>{Array.isArray(F)?w=F:(i(F),c.fire(F))};return this.doSearch(n,R,-1,p).then(F=>[F,w])}),S;if(t.cacheKey){S=this.getOrCreateCache(t.cacheKey);const p={promise:m,event:c.event,resolved:!1};S.resultsToSearchCache[t.filePattern||""]=p,m.then(()=>{p.resolved=!0},w=>{delete S.resultsToSearchCache[t.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([p,w])=>{const R=S?S.scorerCache:Object.create(null),F=(typeof t.maxResults!="number"||t.maxResults>0)&&s.StopWatch.create(!1);return this.sortResults(t,w,R,o).then(z=>{const oe=F?F.elapsed():-1;return[{type:"success",stats:{detailStats:p.stats,sortingTime:oe,fromCache:!1,type:"searchProcess",workspaceFolderCount:t.folderQueries.length,resultCount:z.length},limitHit:p.limitHit||typeof t.maxResults=="number"&&w.length>t.maxResults},z]})})}getOrCreateCache(n){const t=this.caches[n];return t||(this.caches[n]=new v)}trySortedSearchFromCache(n,t,r){const i=n.cacheKey&&this.caches[n.cacheKey];if(!!i){const o=this.getResultsFromCache(i,n.filePattern||"",t,r);if(o)return o.then(([c,m,S])=>{const p=s.StopWatch.create(!1);return this.sortResults(n,m,i.scorerCache,r).then(w=>{const R=p.elapsed(),F={fromCache:!0,detailStats:S,type:"searchProcess",resultCount:m.length,sortingTime:R};return[{type:"success",limitHit:c.limitHit||typeof n.maxResults=="number"&&m.length>n.maxResults,stats:F},w]})})}}sortResults(n,t,r,i){const o=(0,D.prepareQuery)(n.filePattern||""),c=(S,p)=>(0,D.compareItemsByFuzzyScore)(S,p,o,!0,_,r),m=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return T.topAsync(t,c,m,1e4,i)}sendProgress(n,t,r){if(r&&r>0)for(let i=0;i<n.length;i+=r)t(n.slice(i,i+r));else t(n)}getResultsFromCache(n,t,r,i){const o=s.StopWatch.create(!1),c=t.indexOf(P.sep)>=0;let m;for(const R in n.resultsToSearchCache)if(t.startsWith(R)){if(c&&R.indexOf(P.sep)<0&&R!=="")continue;const F=n.resultsToSearchCache[R];m={promise:this.preventCancellation(F.promise),event:F.event,resolved:F.resolved};break}if(!m)return null;const S=o.elapsed(),p=s.StopWatch.create(!1),w=m.event(r);return i&&i.onCancellationRequested(()=>{w.dispose()}),m.promise.then(([R,F])=>{if(i&&i.isCancellationRequested)throw(0,y.canceled)();const z=[],oe=(0,D.prepareQuery)(t).normalizedLowercase;for(const j of F)!(0,h.isFilePatternMatch)(j,oe)||z.push(j);return[R,z,{cacheWasResolved:m.resolved,cacheLookupTime:S,cacheFilterTime:p.elapsed(),cacheEntryCount:F.length}]})}doSearch(n,t,r,i){return new Promise((o,c)=>{let m=[];i&&i.onCancellationRequested(()=>n.cancel()),n.search(S=>{S&&(r?(m.push(S),r>0&&m.length>=r&&(t(m),m=[])):t(S))},S=>{t(S)},(S,p)=>{m.length&&t(m),S?c(S):o(p)})})}clearCache(n){return delete this.caches[n],Promise.resolve(void 0)}preventCancellation(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,r){return n.then(t,r)}catch(t){return this.then(void 0,t)}finally(t){return n.finally(t)}}}}e.SearchService=E,E.BATCH_SIZE=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(d){return(0,P.basename)(d.relativePath)}getItemDescription(d){return(0,P.dirname)(d.relativePath)}getItemPath(d){return d.relativePath}};function g(d){return Object.assign(Object.assign({},d),{folderQueries:d.folderQueries&&d.folderQueries.map(l),extraFileResources:d.extraFileResources&&d.extraFileResources.map(n=>C.URI.revive(n))})}function l(d){return Object.assign(Object.assign({},d),{folder:C.URI.revive(d.folder)})}}),define(me[280],ge([0,1,6,2,26,13,31,279,277,93,14,62,27,68,11,129]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends h.ExtHostSearch{constructor(_,g,l,d){super(_,l,d);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const n=new P.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new D.RipgrepSearchProvider(n)),g.remote.isRemote&&g.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const _=new P.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new D.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(a.Schemas.file,new k.SearchService)}registerInternalFileSearchProvider(_,g){const l=this._handlePool++;return this._internalFileSearchProvider=g,this._internalFileSearchHandle=l,this._proxy.$registerFileSearchProvider(l,this._transformScheme(_)),(0,b.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(_,g,l,d){const n=(0,h.reviveQuery)(l);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,g,n,d):super.$provideFileSearchResults(_,g,l,d)}doInternalFileSearch(_,g,l,d){const n=t=>{if((0,y.isSerializedFileMatch)(t)&&(t=[t]),Array.isArray(t)){this._proxy.$handleFileMatch(_,g,t.map(r=>I.URI.file(r.path)));return}t.message&&this._logService.debug("ExtHostSearch",t.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(l,n,d)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,g){return new u.NativeTextSearchManager(_,g)}};E=je([Be(0,s.IExtHostRpcService),Be(1,f.IExtHostInitDataService),Be(2,C.IURITransformerService),Be(3,A.ILogService)],E),e.NativeExtHostSearch=E}),define(me[131],ge([0,1,293,121,294,3,104,8,48,30,6,22,105,19,9]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class u{constructor(m){this.socket=m,this._errorListener=S=>{if(S){if(S.code==="EPIPE")return;(0,h.onUnexpectedError)(S)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const S=p=>m(C.VSBuffer.wrap(p));return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(m){return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,h.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,h.onUnexpectedError)(S)}}end(){this.socket.end()}drain(){return new Promise((m,S)=>{if(this.socket.bufferSize===0){m();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),m()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=u;var E;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var v;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(v||(v={}));class _ extends s.Disposable{constructor(m,S,p,w){super();this._onDidZlibFlush=this._register(new A.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new A.Emitter),this._onClose=this._register(new A.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=S,this._recordInflateBytes=w,S?(this._zlibInflate=T.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",R=>{console.error(R),(0,h.onUnexpectedError)(R),this._onClose.fire()}),this._zlibInflate.on("data",R=>{this._pendingInflateData.push(R)}),p&&(this._zlibInflate.write(p.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=T.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{console.error(R),(0,h.onUnexpectedError)(R),this._onClose.fire()}),this._zlibDeflate.on("data",R=>{this._pendingDeflateData.push(R)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new f.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let S=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.length-4),this._isEnded||this._write(C.VSBuffer.wrap(S),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,S){let p=2;m.byteLength<126?p+=0:m.byteLength<2**16?p+=2:p+=8;const w=C.VSBuffer.alloc(p);if(S?w.writeUInt8(194,0):w.writeUInt8(130,0),m.byteLength<126)w.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){w.writeUInt8(126,1);let R=1;w.writeUInt8(m.byteLength>>>8&255,++R),w.writeUInt8(m.byteLength>>>0&255,++R)}else{w.writeUInt8(127,1);let R=1;w.writeUInt8(0,++R),w.writeUInt8(0,++R),w.writeUInt8(0,++R),w.writeUInt8(0,++R),w.writeUInt8(m.byteLength>>>24&255,++R),w.writeUInt8(m.byteLength>>>16&255,++R),w.writeUInt8(m.byteLength>>>8&255,++R),w.writeUInt8(m.byteLength>>>0&255,++R)}this._totalOutgoingWireBytes+=w.byteLength+m.byteLength,this.socket.write(C.VSBuffer.concat([w,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const S=this._incomingData.peek(this._state.readLen),w=(S.readUInt8(0)&128)>>>7,R=S.readUInt8(1),F=(R&128)>>>7,z=R&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(z===126?2:0)+(z===127?8:0),this._state.fin=w,this._state.mask=0}else if(this._state.state===2){const S=this._incomingData.read(this._state.readLen),p=S.readUInt8(1),w=(p&128)>>>7;let R=p&127,F=1;R===126?R=S.readUInt8(++F)*2**8+S.readUInt8(++F):R===127&&(R=S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*0+S.readUInt8(++F)*2**24+S.readUInt8(++F)*2**16+S.readUInt8(++F)*2**8+S.readUInt8(++F));let z=0;w&&(z=S.readUInt8(++F)*2**24+S.readUInt8(++F)*2**16+S.readUInt8(++F)*2**8+S.readUInt8(++F)),this._state.state=3,this._state.readLen=R,this._state.mask=z}else if(this._state.state===3){const S=this._incomingData.read(this._state.readLen);g(S,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(S.buffer)),this._zlibInflate.write(S.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const p=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=p.length,this._onData.fire(C.VSBuffer.wrap(p))})):(this._totalIncomingDataBytes+=S.byteLength,this._onData.fire(S))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await A.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=_;function g(c,m){if(m!==0){let S=c.byteLength>>>2;for(let oe=0;oe<S;oe++){const j=c.readUInt32BE(oe*4);c.writeUInt32BE(j^m,oe*4)}let p=S*4,w=c.byteLength-p;const R=m>>>24&255,F=m>>>16&255,z=m>>>8&255;w>=1&&c.writeUInt8(c.readUInt8(p)^R,p),w>=2&&c.writeUInt8(c.readUInt8(p+1)^F,p+1),w>=3&&c.writeUInt8(c.readUInt8(p+2)^z,p+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function d(){const c=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let m;return e.XDG_RUNTIME_DIR?m=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):m=(0,k.join)((0,D.tmpdir)(),`vscode-ipc-${c}.sock`),t(m),m}e.createRandomIPCHandle=d;function n(c,m,S){const p=(0,b.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${S}-${m}-sock`;let w;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?w=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${S}-${m}.sock`):w=(0,k.join)(c,`${S}-${m}.sock`),t(w),w}e.createStaticIPCHandle=n;function t(c){const m=l[a.platform];typeof m=="number"&&c.length>=m&&console.warn(`WARNING: IPC handle "${c}" is longer than ${m} chars, try a shorter --user-data-dir`)}class r extends y.IPCServer{constructor(m){super(r.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const S=A.Event.fromNodeEventEmitter(m,"connection");return A.Event.map(S,p=>({protocol:new f.Protocol(new u(p)),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(p,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(c){return new Promise((m,S)=>{const p=(0,I.createServer)();p.on("error",S),p.listen(c,()=>{p.removeListener("error",S),m(new r(p))})})}e.serve=i;function o(c,m){return new Promise((S,p)=>{const w=(0,I.createConnection)(c,()=>{w.removeListener("error",p),S(f.Client.fromSocket(new u(w),m))});w.once("error",p)})}e.connect=o}),define(me[281],ge([0,1,131,273,37,51,2,117,13]),function(G,e,b,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(f,h,a){this._commands=f,this.logService=h,this._ipcHandlePath=a,this._server=I.createServer((u,E)=>this.onRequest(u,E)),this.setup().catch(u=>(h.error(u),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",f=>this.logService.error(f))}catch(f){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(f,h){const a=[];f.setEncoding("utf8"),f.on("data",u=>a.push(u)),f.on("end",()=>{const u=JSON.parse(a.join(""));switch(u.type){case"open":this.open(u,h);break;case"openExternal":this.openExternal(u,h);break;case"status":this.getStatus(u,h);break;case"extensionManagement":this.manageExtensions(u,h).catch(this.logService.error);break;default:h.writeHead(404),h.write(`Unknown message type: ${u.type}`,E=>{E&&this.logService.error(E)}),h.end();break}})}open(f,h){let{fileURIs:a,folderURIs:u,forceNewWindow:E,diffMode:v,addMode:_,forceReuseWindow:g,gotoLineMode:l,waitMarkerFilePath:d}=f;const n=[];if(Array.isArray(u))for(const t of u)try{n.push({folderUri:y.URI.parse(t)})}catch(r){}if(Array.isArray(a))for(const t of a)try{(0,k.hasWorkspaceFileExtension)(t)?n.push({workspaceUri:y.URI.parse(t)}):n.push({fileUri:y.URI.parse(t)})}catch(r){}if(n.length){const t=d?y.URI.file(d):void 0,i={forceNewWindow:E,diffMode:v,addMode:_,gotoLineMode:l,forceReuseWindow:g,preferNewWindow:!g&&!t&&!_,waitMarkerFileURI:t};this._commands.executeCommand("_remoteCLI.windowOpen",n,i)}h.writeHead(200),h.end()}async openExternal(f,h){for(const a of f.uris){const u=y.URI.parse(a),E=u.scheme==="file"?u:a;await this._commands.executeCommand("_remoteCLI.openExternal",E)}h.writeHead(200),h.end()}async manageExtensions(f,h){try{const a=v=>v==null?void 0:v.map(_=>/\.vsix$/i.test(_)?y.URI.parse(_):_),u={list:f.list,install:a(f.install),uninstall:a(f.uninstall),force:f.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",u);h.writeHead(200),h.write(E)}catch(a){h.writeHead(500),h.write(String(a),u=>{u&&this.logService.error(u)})}h.end()}async getStatus(f,h){try{const a=await this._commands.executeCommand("_remoteCLI.getSystemStatus");h.writeHead(200),h.write(a),h.end()}catch(a){h.writeHead(500),h.write(String(a),u=>{u&&this.logService.error(u)}),h.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&T.existsSync(this._ipcHandlePath)&&T.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let s=class extends P{constructor(f,h){super(f,h,(0,b.createRandomIPCHandle)())}};s=je([Be(0,A.IExtHostCommands),Be(1,D.ILogService)],s),e.CLIServer=s}),define(me[282],ge([0,1,67,269,263,5,272,42,254,2,11,7,281,102]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends T.RequireInterceptor{_installInterceptor(){const v=this,_=G.__$__nodeRequire("module"),g=_._load;_._load=function(d,n,t){for(let r of v._alternatives){let i=r(d);if(i){d=i;break}}return v._factories.has(d)?v._factories.get(d).load(d,P.URI.file((0,h.realpathSync)(n.filename)),r=>g.apply(this,[r,n,t])):g.apply(this,arguments)}}}class u extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const v=this._instaService.invokeFunction(I.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const n=this._instaService.createInstance(f.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=n.ipcHandlePath}await this._instaService.createInstance(a,v,this._registry).install(),b.mark("code/extHost/didInitAPI");const g=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,g,this,this._logService,this._mainThreadTelemetryProxy,this._initData),b.mark("code/extHost/didInitProxyResolver");const l=process.send,d=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...n)=>n.length===0||!n[0]||n[0].type!=="__$console"?l.apply(process,n):(d.$logExtensionHostMessage(n[0]),!1)}_getEntryPoint(v){return v.main}_loadCommonJSModule(v,_,g){if(_.scheme!==s.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let l=null;g.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{v&&b.mark(`code/extHost/willLoadExtensionCode/${v.value}`),l=G.__$__nodeRequire(_.fsPath)}catch(d){return Promise.reject(d)}finally{v&&b.mark(`code/extHost/didLoadExtensionCode/${v.value}`),g.codeLoadingStop()}return Promise.resolve(l)}async $setRemoteEnvironment(v){if(!!this._initData.remote.isRemote)for(const _ in v){const g=v[_];g===null?delete process.env[_]:process.env[_]=g}}}e.ExtHostExtensionService=u}),define(me[283],ge([0,1,78,255,266,265,264,280,282,226,256,46,42,64,68,66,34,50,13]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(f.IExtHostExtensionService,D.ExtHostExtensionService),(0,b.registerSingleton)(_.ILogService,P.ExtHostLogService),(0,b.registerSingleton)(C.IExtHostDebugService,y.ExtHostDebugService),(0,b.registerSingleton)(h.IExtHostOutputService,I.ExtHostOutputService2),(0,b.registerSingleton)(a.IExtHostSearch,k.NativeExtHostSearch),(0,b.registerSingleton)(u.IExtHostTask,A.ExtHostTask),(0,b.registerSingleton)(E.IExtHostTerminalService,T.ExtHostTerminalService),(0,b.registerSingleton)(v.IExtHostTunnelService,s.ExtHostTunnelService)}),define(me[284],ge([0,1,121,295,67,19,105,131,187,224,267,22,100,26,102,16,270,283]),function(G,e,b,I,T,A,y,k,D,P,s,C,f,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let i=0;i<process.execArgv.length;i++)process.execArgv[i]==="--inspect-port=0"&&(process.execArgv.splice(i,1),i--)}();const E=I(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const r=G.__$__nodeRequire("module"),i=r._load;r._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return i.apply(this,arguments)}})();const v=process.exit.bind(process);function _(r){process.exit=function(i){if(r)v(i);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const i=new Error("An extension called process.crash() and this was prevented.");console.warn(i.stack)}}let g=function(r){v()};function l(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((r,i)=>{let o=null,c=setTimeout(()=>{i(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const m=108e5,S=3e5,p=new u.RunOnceScheduler(()=>g("renderer disconnected for too long (1)"),m),w=new u.RunOnceScheduler(()=>g("renderer disconnected for too long (2)"),S);process.on("message",(F,z)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){const oe=C.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let j;if(F.skipWebSocketFrames)j=new k.NodeSocket(z);else{const W=C.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));j=new k.WebSocketNodeSocket(new k.NodeSocket(z),F.permessageDeflate,W,!1)}o?(p.cancel(),w.cancel(),o.beginAcceptReconnection(j,oe),o.endAcceptReconnection()):(clearTimeout(c),o=new y.PersistentProtocol(j,oe),o.onDidDispose(()=>g("renderer disconnected")),r(o),o.onSocketClose(()=>{p.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(w.isScheduled())return;p.isScheduled()&&w.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const r=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((i,o)=>{const c=b.createConnection(r,()=>{c.removeListener("error",o),i(new y.PersistentProtocol(new k.NodeSocket(c)))});c.once("error",o)})}}async function d(){const r=await l();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,r.onMessage(i=>{(0,P.isMessageOfType)(i,2)?(this._terminating=!0,g("received terminate message from renderer")):this._onMessage.fire(i)})}send(i){this._terminating||r.send(i)}drain(){return r.drain()}}}function n(r){return new Promise(i=>{const o=r.onMessage(c=>{o.dispose();const m=JSON.parse(c.toString()),S=m.commit,p=D.default.commit;S&&p&&S!==p&&v(55);const w=[];process.on("unhandledRejection",(z,oe)=>{w.push(oe),setTimeout(()=>{const j=w.indexOf(oe);j>=0&&oe.catch(W=>{w.splice(j,1),console.warn(`rejected promise not handled within 1 second: ${W}`),W&&W.stack&&console.warn(`stack trace: ${W.stack}`),(0,A.onUnexpectedError)(z)})},1e3)}),process.on("rejectionHandled",z=>{const oe=w.indexOf(z);oe>=0&&w.splice(oe,1)}),process.on("uncaughtException",function(z){(0,A.onUnexpectedError)(z)});let R=0;setInterval(function(){try{process.kill(m.parentPid,0),R=0}catch(z){z&&z.code==="EPERM"?(R++,R>=3&&g(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):g(`parent process ${m.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let F;try{F=G.__$__nodeRequire("native-watchdog"),F.start(m.parentPid)}catch(z){(0,A.onUnexpectedError)(z)}r.send((0,P.createMessageOfType)(0)),i({protocol:r,initData:m})});r.send((0,P.createMessageOfType)(1))})}async function t(){T.mark("code/extHost/willConnectToRenderer");const r=await d();T.mark("code/extHost/didConnectToRenderer");const i=await n(r);T.mark("code/extHost/didWaitForInitData");const{initData:o}=i;_(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0;const c=new class{exit(w){v(w)}exists(w){return(0,h.exists)(w)}realpath(w){return(0,a.realpath)(w)}};let m=null;if(o.remote.authority&&E.uriTransformerPath)try{const w=G.__$__nodeRequire(E.uriTransformerPath)(o.remote.authority);m=new f.URITransformer(w)}catch(p){console.error(p)}const S=new s.ExtensionHostMain(i.protocol,o,c,m);g=p=>S.terminate(p)}e.startExtensionHostProcess=t}),define(me[296],ge([0,1,284]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.startExtensionHostProcess)().catch(I=>console.log(I))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/23a2409675bc1bde94f3532bc7c5826a6e99e4b6/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
