/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/network","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],we=function(J){for(var e=[],w=0,k=J.length;w<k;w++)e[w]=be[J[w]];return e};define(be[42],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(k,P){if(!k)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=w}),define(be[51],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const w=Object.prototype.hasOwnProperty;function k(i){const I=[];for(let c in i)w.call(i,c)&&I.push(i[c]);return I}e.values=k;function P(i,I){for(let c in i)if(w.call(i,c)&&I({key:c,value:i[c]},function(){delete i[c]})===!1)return}e.forEach=P;function A(i,I){const c=Object.create(null);for(const d of i){const o=I(d);let a=c[o];a||(a=c[o]=[]),a.push(d)}return c}e.groupBy=A;function S(i){const I=Object.create(null);return i&&i.forEach((c,d)=>{I[d]=c}),I}e.fromMap=S;function D(i,I){const c=[],d=[];for(let o of i)I.has(o)||c.push(o);for(let o of I)i.has(o)||d.push(o);return{removed:c,added:d}}e.diffSets=D;function y(i,I){const c=[],d=[];for(let[o,a]of i)I.has(o)||c.push(a);for(let[o,a]of I)i.has(o)||d.push(a);return{removed:c,added:d}}e.diffMaps=y;class C{constructor(){this.map=new Map}add(I,c){let d=this.map.get(I);d||(d=new Set,this.map.set(I,d)),d.add(c)}delete(I,c){const d=this.map.get(I);!d||(d.delete(c),d.size===0&&this.map.delete(I))}forEach(I,c){const d=this.map.get(I);!d||d.forEach(c)}}e.SetMap=C}),define(be[52],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function w(y){return(C,i,I)=>{let c=null,d=null;if(typeof I.value=="function"?(c="value",d=I.value):typeof I.get=="function"&&(c="get",d=I.get),!d)throw new Error("not supported");I[c]=y(d,i)}}e.createDecorator=w;let k=0;function P(){const y=`$memoize${k++}`;let C;const i=function(c,d,o){let a=null,g=null;if(typeof o.value=="function"?(a="value",g=o.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof o.get=="function"&&(a="get",g=o.get),!g)throw new Error("not supported");const h=`${y}:${d}`;o[a]=function(..._){return C=this,this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!0,enumerable:!1,writable:!0,value:g.apply(this,_)}),this[h]}};return i.clear=()=>{typeof C!="undefined"&&Object.getOwnPropertyNames(C).forEach(I=>{I.indexOf(y)===0&&delete C[I]})},i}e.createMemoizer=P;function A(y,C,i){return P()(y,C,i)}e.memoize=A;function S(y,C,i){return w((I,c)=>{const d=`$debounce$${c}`,o=`$debounce$result$${c}`;return function(...a){this[o]||(this[o]=i?i():void 0),clearTimeout(this[d]),C&&(this[o]=C(this[o],...a),a=[this[o]]),this[d]=setTimeout(()=>{I.apply(this,a),this[o]=i?i():void 0},y)}})}e.debounce=S;function D(y,C,i){return w((I,c)=>{const d=`$throttle$timer$${c}`,o=`$throttle$result$${c}`,a=`$throttle$lastRun$${c}`,g=`$throttle$pending$${c}`;return function(...h){if(this[o]||(this[o]=i?i():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),C&&(this[o]=C(this[o],...h)),!this[g]){const _=this[a]+y;_<=Date.now()?(this[a]=Date.now(),I.apply(this,[this[o]]),this[o]=i?i():void 0):(this[g]=!0,this[d]=setTimeout(()=>{this[g]=!1,this[a]=Date.now(),I.apply(this,[this[o]]),this[o]=i?i():void 0},_-Date.now()))}}})}e.throttle=D}),define(be[12],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=w,e.errorHandler=new w;function k(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=k;function P(p){y(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=P;function A(p){y(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=A;function S(p){if(p instanceof Error){let{name:t,message:n}=p;const s=p.stacktrace||p.stack;return{$isError:!0,name:t,message:n,stack:s}}return p}e.transformErrorForSerialization=S;const D="Canceled";function y(p){return p instanceof Error&&p.name===D&&p.message===D}e.isPromiseCanceledError=y;class C extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=C;function i(){const p=new Error(D);return p.name=p.message,p}e.canceled=i;function I(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=I;function c(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=c;function d(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function o(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=o;function a(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=a;class g extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=g;class h extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=h;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function m(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=m;function u(p,t=Object.create(null)){const n=new Error(p);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=u}),define(be[13],we([0,1,12]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(O,R=0){return O[O.length-(1+R)]}e.tail=k;function P(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}e.tail2=P;function A(O,R,N=($,U)=>$===U){if(O===R)return!0;if(!O||!R||O.length!==R.length)return!1;for(let $=0,U=O.length;$<U;$++)if(!N(O[$],R[$]))return!1;return!0}e.equals=A;function S(O,R,N){let $=0,U=O.length-1;for(;$<=U;){const Q=($+U)/2|0,Y=N(O[Q],R);if(Y<0)$=Q+1;else if(Y>0)U=Q-1;else return Q}return-($+1)}e.binarySearch=S;function D(O,R){let N=0,$=O.length;if($===0)return 0;for(;N<$;){const U=Math.floor((N+$)/2);R(O[U])?$=U:N=U+1}return N}e.findFirstInSorted=D;function y(O,R,N){if(O=O|0,O>=R.length)throw new TypeError("invalid index");let $=R[Math.floor(R.length*Math.random())],U=[],Q=[],Y=[];for(let ie of R){const pe=N(ie,$);pe<0?U.push(ie):pe>0?Q.push(ie):Y.push(ie)}return O<U.length?y(O,U,N):O<U.length+Y.length?Y[0]:y(O-(U.length+Y.length),Q,N)}e.quickSelect=y;function C(O,R){const N=[];let $;for(const U of O.slice(0).sort(R))!$||R($[0],U)!==0?($=[U],N.push($)):$.push(U);return N}e.groupBy=C;function i(O,R,N){const $=[];function U(ie,pe,Pe){if(!(pe===0&&Pe.length===0)){const Oe=$[$.length-1];Oe&&Oe.start+Oe.deleteCount===ie?(Oe.deleteCount+=pe,Oe.toInsert.push(...Pe)):$.push({start:ie,deleteCount:pe,toInsert:Pe})}}let Q=0,Y=0;for(;;){if(Q===O.length){U(Q,0,R.slice(Y));break}if(Y===R.length){U(Q,O.length-Q,[]);break}const ie=O[Q],pe=R[Y],Pe=N(ie,pe);Pe===0?(Q+=1,Y+=1):Pe<0?(U(Q,1,[]),Q+=1):Pe>0&&(U(Q,0,[pe]),Y+=1)}return $}e.sortedDiff=i;function I(O,R,N){const $=i(O,R,N),U=[],Q=[];for(const Y of $)U.push(...O.slice(Y.start,Y.start+Y.deleteCount)),Q.push(...Y.toInsert);return{removed:U,added:Q}}e.delta=I;function c(O,R,N){if(N===0)return[];const $=O.slice(0,N).sort(R);return o(O,R,$,N,O.length),$}e.top=c;function d(O,R,N,$,U){return N===0?Promise.resolve([]):new Promise((Q,Y)=>{(async()=>{const ie=O.length,pe=O.slice(0,N).sort(R);for(let Pe=N,Oe=Math.min(N+$,ie);Pe<ie;Pe=Oe,Oe=Math.min(Oe+$,ie)){if(Pe>N&&await new Promise(Te=>setTimeout(Te)),U&&U.isCancellationRequested)throw(0,w.canceled)();o(O,R,pe,Pe,Oe)}return pe})().then(Q,Y)})}e.topAsync=d;function o(O,R,N,$,U){for(const Q=N.length;$<U;$++){const Y=O[$];if(R(Y,N[Q-1])<0){N.pop();const ie=D(N,pe=>R(Y,pe)<0);N.splice(ie,0,Y)}}}function a(O){return O.filter(R=>!!R)}e.coalesce=a;function g(O){let R=0;for(let N=0;N<O.length;N++)O[N]&&(O[R]=O[N],R+=1);O.length=R}e.coalesceInPlace=g;function h(O,R,N){O.splice(N,0,O.splice(R,1)[0])}e.move=h;function _(O){return!Array.isArray(O)||O.length===0}e.isFalsyOrEmpty=_;function m(O){return Array.isArray(O)&&O.length>0}e.isNonEmptyArray=m;function u(O,R){if(!R)return O.filter(($,U)=>O.indexOf($)===U);const N=Object.create(null);return O.filter($=>{const U=R($);return N[U]?!1:(N[U]=!0,!0)})}e.distinct=u;function p(O){const R=new Set;return O.filter(N=>R.has(N)?!1:(R.add(N),!0))}e.distinctES6=p;function t(O){const R=Object.create(null);return N=>{const $=O(N);return R[$]?!1:(R[$]=!0,!0)}}e.uniqueFilter=t;function n(O,R){for(let N=O.length-1;N>=0;N--){const $=O[N];if(R($))return N}return-1}e.lastIndex=n;function s(O,R){return O.length>0?O[0]:R}e.firstOrDefault=s;function r(O,R,N=($,U)=>$===U){let $=0;for(let U=0,Q=Math.min(O.length,R.length);U<Q&&N(O[U],R[U]);U++)$++;return $}e.commonPrefixLength=r;function l(O){return[].concat(...O)}e.flatten=l;function f(O,R){let N=typeof R=="number"?O:0;typeof R=="number"?N=O:(N=0,R=O);const $=[];if(N<=R)for(let U=N;U<R;U++)$.push(U);else for(let U=N;U>R;U--)$.push(U);return $}e.range=f;function v(O,R,N){return O.reduce(($,U)=>($[R(U)]=N?N(U):U,$),Object.create(null))}e.index=v;function T(O,R){return O.push(R),()=>b(O,R)}e.insert=T;function b(O,R){const N=O.indexOf(R);if(N>-1)return O.splice(N,1),R}e.remove=b;function E(O,R,N){const $=O.slice(0,R),U=O.slice(R);return $.concat(N,U)}e.arrayInsert=E;function F(O,R){let N;if(typeof R=="number"){let $=R;N=()=>{const U=Math.sin($++)*179426549;return U-Math.floor(U)}}else N=Math.random;for(let $=O.length-1;$>0;$-=1){const U=Math.floor(N()*($+1)),Q=O[$];O[$]=O[U],O[U]=Q}}e.shuffle=F;function L(O,R){const N=O.indexOf(R);N>-1&&(O.splice(N,1),O.unshift(R))}e.pushToStart=L;function K(O,R){const N=O.indexOf(R);N>-1&&(O.splice(N,1),O.push(R))}e.pushToEnd=K;function fe(O,R){return Array.isArray(O)?O.map(R):R(O)}e.mapArrayOrNot=fe;function j(O){return Array.isArray(O)?O:[O]}e.asArray=j;function H(O){return O[Math.floor(Math.random()*O.length)]}e.getRandomElement=H;function ee(O,R){for(const N of O){const $=R(N);if($!==void 0)return $}}e.mapFind=ee}),define(be[53],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(k){const P=this;let A=!1,S;return function(){return A||(A=!0,S=k.apply(P,arguments)),S}}e.once=w}),define(be[54],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class w{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=w,e.defaultGenerator=new w("id#")}),define(be[43],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(k){function P(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}k.is=P;const A=Object.freeze([]);function S(){return A}k.empty=S;function*D(p){yield p}k.single=D;function y(p){return p||A}k.from=y;function C(p){return!p||p[Symbol.iterator]().next().done===!0}k.isEmpty=C;function i(p){return p[Symbol.iterator]().next().value}k.first=i;function I(p,t){for(const n of p)if(t(n))return!0;return!1}k.some=I;function c(p,t){for(const n of p)if(t(n))return n}k.find=c;function*d(p,t){for(const n of p)t(n)&&(yield n)}k.filter=d;function*o(p,t){for(const n of p)yield t(n)}k.map=o;function*a(...p){for(const t of p)for(const n of t)yield n}k.concat=a;function*g(p){for(const t of p)for(const n of t)yield n}k.concatNested=g;function h(p,t,n){let s=n;for(const r of p)s=t(s,r);return s}k.reduce=h;function*_(p,t,n=p.length){for(t<0&&(t+=p.length),n<0?n+=p.length:n>p.length&&(n=p.length);t<n;t++)yield p[t]}k.slice=_;function m(p,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,p];const s=p[Symbol.iterator]();for(let r=0;r<t;r++){const l=s.next();if(l.done)return[n,k.empty()];n.push(l.value)}return[n,{[Symbol.iterator](){return s}}]}k.consume=m;function u(p,t,n=(s,r)=>s===r){const s=p[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const l=s.next(),f=r.next();if(l.done!==f.done)return!1;if(l.done)return!0;if(!n(l.value,f.value))return!1}}k.equals=u})(w=e.Iterable||(e.Iterable={}))}),define(be[44],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function S(t,n=!1){let s=0,r=t.length,l="",f=0,v=16,T=0;function b(H){let ee=0,O=0;for(;ee<H;){const R=t.charCodeAt(s);if(R>=48&&R<=57)O=O*16+R-48;else if(R>=65&&R<=70)O=O*16+R-65+10;else if(R>=97&&R<=102)O=O*16+R-97+10;else break;s++,ee++}return ee<H&&(O=-1),O}function E(H){s=H,l="",f=0,v=16,T=0}function F(){const H=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&C(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&C(t.charCodeAt(s)))for(s++;s<t.length&&C(t.charCodeAt(s));)s++;else return T=3,t.substring(H,s);let ee=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&C(t.charCodeAt(s))){for(s++;s<t.length&&C(t.charCodeAt(s));)s++;ee=s}else T=3;return t.substring(H,ee)}function L(){let H="",ee=s;for(;;){if(s>=r){H+=t.substring(ee,s),T=2;break}const O=t.charCodeAt(s);if(O===34){H+=t.substring(ee,s),s++;break}if(O===92){if(H+=t.substring(ee,s),s++,s>=r){T=2;break}switch(t.charCodeAt(s++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:const N=b(4);N>=0?H+=String.fromCharCode(N):T=4;break;default:T=5}ee=s;continue}if(O>=0&&O<=31)if(y(O)){H+=t.substring(ee,s),T=2;break}else T=6;s++}return H}function K(){if(l="",T=0,f=s,s>=r)return f=r,v=17;let H=t.charCodeAt(s);if(D(H)){do s++,l+=String.fromCharCode(H),H=t.charCodeAt(s);while(D(H));return v=15}if(y(H))return s++,l+=String.fromCharCode(H),H===13&&t.charCodeAt(s)===10&&(s++,l+=`
`),v=14;switch(H){case 123:return s++,v=1;case 125:return s++,v=2;case 91:return s++,v=3;case 93:return s++,v=4;case 58:return s++,v=6;case 44:return s++,v=5;case 34:return s++,l=L(),v=10;case 47:const ee=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!y(t.charCodeAt(s));)s++;return l=t.substring(ee,s),v=12}if(t.charCodeAt(s+1)===42){s+=2;const O=r-1;let R=!1;for(;s<O;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,R=!0;break}s++}return R||(s++,T=1),l=t.substring(ee,s),v=13}return l+=String.fromCharCode(H),s++,v=16;case 45:if(l+=String.fromCharCode(H),s++,s===r||!C(t.charCodeAt(s)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=F(),v=11;default:for(;s<r&&fe(H);)s++,H=t.charCodeAt(s);if(f!==s){switch(l=t.substring(f,s),l){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return l+=String.fromCharCode(H),s++,v=16}}function fe(H){if(D(H)||y(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let H;do H=K();while(H>=12&&H<=15);return H}return{setPosition:E,getPosition:()=>s,scan:n?j:K,getToken:()=>v,getTokenValue:()=>l,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>T}}e.createScanner=S;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,n){const s=[],r=new Object;let l;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function T(b,E,F,L){f.value=b,f.offset=E,f.length=F,f.type=L,f.colonOffset=void 0,l=f}try{m(t,{onObjectBegin:(b,E)=>{if(n<=b)throw r;l=void 0,v=n>b,s.push("")},onObjectProperty:(b,E,F)=>{if(n<E||(T(b,E,F,"property"),s[s.length-1]=b,n<=E+F))throw r},onObjectEnd:(b,E)=>{if(n<=b)throw r;l=void 0,s.pop()},onArrayBegin:(b,E)=>{if(n<=b)throw r;l=void 0,s.push(0)},onArrayEnd:(b,E)=>{if(n<=b)throw r;l=void 0,s.pop()},onLiteralValue:(b,E,F)=>{if(n<E||(T(b,E,F,p(b)),n<=E+F))throw r},onSeparator:(b,E,F)=>{if(n<=E)throw r;if(b===":"&&l&&l.type==="property")l.colonOffset=E,v=!1,l=void 0;else if(b===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(v=!0,s[s.length-1]=""),l=void 0}}})}catch(b){if(b!==r)throw b}return{path:s,previousNode:l,isAtPropertyKey:v,matches:b=>{let E=0;for(let F=0;E<b.length&&F<s.length;F++)if(b[E]===s[F]||b[E]==="*")E++;else if(b[E]!=="**")return!1;return E===b.length}}}e.getLocation=I;function c(t,n=[],s=A.DEFAULT){let r=null,l=[];const f=[];function v(b){Array.isArray(l)?l.push(b):r!==null&&(l[r]=b)}return m(t,{onObjectBegin:()=>{const b={};v(b),f.push(l),l=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const b=[];v(b),f.push(l),l=b,r=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:v,onError:(b,E,F)=>{n.push({error:b,offset:E,length:F})}},s),l[0]}e.parse=c;function d(t,n=[],s=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(b){r.type==="property"&&(r.length=b-r.offset,r=r.parent)}function f(b){return r.children.push(b),b}m(t,{onObjectBegin:b=>{r=f({type:"object",offset:b,length:-1,parent:r,children:[]})},onObjectProperty:(b,E,F)=>{r=f({type:"property",offset:E,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:b,offset:E,length:F,parent:r})},onObjectEnd:(b,E)=>{r.length=b+E-r.offset,r=r.parent,l(b+E)},onArrayBegin:(b,E)=>{r=f({type:"array",offset:b,length:-1,parent:r,children:[]})},onArrayEnd:(b,E)=>{r.length=b+E-r.offset,r=r.parent,l(b+E)},onLiteralValue:(b,E,F)=>{f({type:p(b),offset:E,length:F,parent:r,value:b}),l(E+F)},onSeparator:(b,E,F)=>{r.type==="property"&&(b===":"?r.colonOffset=E:b===","&&l(E))},onError:(b,E,F)=>{n.push({error:b,offset:E,length:F})}},s);const T=r.children[0];return T&&delete T.parent,T}e.parseTree=d;function o(t,n){if(!!t){let s=t;for(let r of n)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===r){s=f.children[1],l=!0;break}if(!l)return}else{const l=r;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}}e.findNodeAtLocation=o;function a(t){if(!t.parent||!t.parent.children)return[];const n=a(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=a;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":const n=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(n[s.children[0].value]=g(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=g;function h(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=h;function _(t,n,s=!1){if(h(t,n,s)){const r=t.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=n;l++){const f=_(r[l],n,s);if(f)return f}return t}}e.findNodeAtOffset=_;function m(t,n,s=A.DEFAULT){const r=S(t,!1);function l(pe){return pe?()=>pe(r.getTokenOffset(),r.getTokenLength()):()=>!0}function f(pe){return pe?Pe=>pe(Pe,r.getTokenOffset(),r.getTokenLength()):()=>!0}const v=l(n.onObjectBegin),T=f(n.onObjectProperty),b=l(n.onObjectEnd),E=l(n.onArrayBegin),F=l(n.onArrayEnd),L=f(n.onLiteralValue),K=f(n.onSeparator),fe=l(n.onComment),j=f(n.onError),H=s&&s.disallowComments,ee=s&&s.allowTrailingComma;function O(){for(;;){const pe=r.scan();switch(r.getTokenError()){case 4:R(14);break;case 5:R(15);break;case 3:R(13);break;case 1:H||R(11);break;case 2:R(12);break;case 6:R(16);break}switch(pe){case 12:case 13:H?R(10):fe();break;case 16:R(1);break;case 15:case 14:break;default:return pe}}}function R(pe,Pe=[],Oe=[]){if(j(pe),Pe.length+Oe.length>0){let Te=r.getToken();for(;Te!==17;){if(Pe.indexOf(Te)!==-1){O();break}else if(Oe.indexOf(Te)!==-1)break;Te=O()}}}function N(pe){const Pe=r.getTokenValue();return pe?L(Pe):T(Pe),O(),!0}function $(){switch(r.getToken()){case 11:let pe=0;try{pe=JSON.parse(r.getTokenValue()),typeof pe!="number"&&(R(2),pe=0)}catch(Pe){R(2)}L(pe);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return O(),!0}function U(){return r.getToken()!==10?(R(3,[],[2,5]),!1):(N(!1),r.getToken()===6?(K(":"),O(),ie()||R(4,[],[2,5])):R(5,[],[2,5]),!0)}function Q(){v(),O();let pe=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(pe||R(4,[],[]),K(","),O(),r.getToken()===2&&ee)break}else pe&&R(6,[],[]);U()||R(4,[],[2,5]),pe=!0}return b(),r.getToken()!==2?R(7,[2],[]):O(),!0}function Y(){E(),O();let pe=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(pe||R(4,[],[]),K(","),O(),r.getToken()===4&&ee)break}else pe&&R(6,[],[]);ie()||R(4,[],[4,5]),pe=!0}return F(),r.getToken()!==4?R(8,[4],[]):O(),!0}function ie(){switch(r.getToken()){case 3:return Y();case 1:return Q();case 10:return N(!0);default:return $()}}return O(),r.getToken()===17?s.allowEmptyContent?!0:(R(4,[],[]),!1):ie()?(r.getToken()!==17&&R(9,[],[]),!0):(R(4,[],[]),!1)}e.visit=m;function u(t,n){let s=S(t),r=[],l,f=0,v;do switch(v=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:f!==v&&r.push(t.substring(f,v)),n!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,n)),f=s.getPosition();break}while(l!==17);return r.join("")}e.stripComments=u;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(be[105],we([0,1,44]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(y,C,i){let I,c,d,o,a;if(C){for(o=C.offset,a=o+C.length,d=o;d>0&&!D(y,d-1);)d--;let f=a;for(;f<y.length&&!D(y,f);)f++;c=y.substring(d,f),I=A(c,i)}else c=y,I=0,d=0,o=0,a=y.length;const g=S(i,y);let h=!1,_=0,m;i.insertSpaces?m=P(" ",i.tabSize||4):m="	";const u=(0,w.createScanner)(c,!1);let p=!1;function t(){return g+P(m,I+_)}function n(){let f=u.scan();for(h=!1;f===15||f===14;)h=h||f===14,f=u.scan();return p=f===16||u.getTokenError()!==0,f}const s=[];function r(f,v,T){!p&&v<a&&T>o&&y.substring(v,T)!==f&&s.push({offset:v,length:T-v,content:f})}let l=n();if(l!==17){const f=u.getTokenOffset()+d,v=P(m,I);r(v,d,f)}for(;l!==17;){let f=u.getTokenOffset()+u.getTokenLength()+d,v=n(),T="";for(;!h&&(v===12||v===13);){const E=u.getTokenOffset()+d;r(" ",f,E),f=u.getTokenOffset()+u.getTokenLength()+d,T=v===12?t():"",v=n()}if(v===2)l!==1&&(_--,T=t());else if(v===4)l!==3&&(_--,T=t());else{switch(l){case 3:case 1:_++,T=t();break;case 5:case 12:T=t();break;case 13:h?T=t():T=" ";break;case 6:T=" ";break;case 10:if(v===6){T="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?T=" ":v!==5&&v!==17&&(p=!0);break;case 16:p=!0;break}h&&(v===12||v===13)&&(T=t())}const b=u.getTokenOffset()+d;r(T,f,b),l=v}return s}e.format=k;function P(y,C){let i="";for(let I=0;I<C;I++)i+=y;return i}function A(y,C){let i=0,I=0;const c=C.tabSize||4;for(;i<y.length;){const d=y.charAt(i);if(d===" ")I++;else if(d==="	")I+=c;else break;i++}return Math.floor(I/c)}function S(y,C){for(let i=0;i<C.length;i++){const I=C.charAt(i);if(I==="\r")return i+1<C.length&&C.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=S;function D(y,C){return`\r
`.indexOf(y.charAt(C))!==-1}e.isEOL=D}),define(be[106],we([0,1,44,105]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(C,i,I){return A(C,i,void 0,I)}e.removeProperty=P;function A(C,i,I,c,d){const o=i.slice(),a=[],g=(0,w.parseTree)(C,a);let h,_;for(;o.length>0&&(_=o.pop(),h=(0,w.findNodeAtLocation)(g,o),h===void 0&&I!==void 0);)typeof _=="string"?I={[_]:I}:I=[I];if(h)if(h.type==="object"&&typeof _=="string"&&Array.isArray(h.children)){const m=(0,w.findNodeAtLocation)(h,[_]);if(m!==void 0)if(I===void 0){if(!m.parent)throw new Error("Malformed AST");const u=h.children.indexOf(m.parent);let p,t=m.parent.offset+m.parent.length;if(u>0){const n=h.children[u-1];p=n.offset+n.length}else p=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return S(C,{offset:p,length:t-p,content:""},c)}else return S(C,{offset:m.offset,length:m.length,content:JSON.stringify(I)},c);else{if(I===void 0)return[];const u=`${JSON.stringify(_)}: ${JSON.stringify(I)}`,p=d?d(h.children.map(n=>n.children[0].value)):h.children.length;let t;if(p>0){const n=h.children[p-1];t={offset:n.offset+n.length,length:0,content:","+u}}else h.children.length===0?t={offset:h.offset+1,length:0,content:u}:t={offset:h.offset+1,length:0,content:u+","};return S(C,t,c)}}else if(h.type==="array"&&typeof _=="number"&&Array.isArray(h.children))if(I!==void 0){const m=`${JSON.stringify(I)}`;let u;if(h.children.length===0||_===0)u={offset:h.offset+1,length:0,content:h.children.length===0?m:m+","};else{const p=_===-1||_>h.children.length?h.children.length:_,t=h.children[p-1];u={offset:t.offset+t.length,length:0,content:","+m}}return S(C,u,c)}else{const m=_,u=h.children[m];let p;if(h.children.length===1)p={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===m){const t=h.children[m-1],n=t.offset+t.length,s=h.offset+h.length;p={offset:n,length:s-2-n,content:""}}else p={offset:u.offset,length:h.children[m+1].offset-u.offset,content:""};return S(C,p,c)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${h.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return S(C,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(I)},c)}}e.setProperty=A;function S(C,i,I){let c=D(C,i),d=i.offset,o=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;d>0&&!(0,k.isEOL)(c,d-1);)d--;for(;o<c.length&&!(0,k.isEOL)(c,o);)o++}const a=(0,k.format)(c,{offset:d,length:o-d},I);for(let h=a.length-1;h>=0;h--){const _=a[h];c=D(c,_),d=Math.min(d,_.offset),o=Math.max(o,_.offset+_.length),o+=_.content.length-_.length}const g=C.length-(c.length-o)-d;return[{offset:d,length:g,content:c.substring(d,o)}]}e.withFormatting=S;function D(C,i){return C.substring(0,i.offset)+i.content+C.substring(i.offset+i.length)}e.applyEdit=D;function y(C,i){let I=i.slice(0).sort((d,o)=>{const a=d.offset-o.offset;return a===0?d.length-o.length:a}),c=C.length;for(let d=I.length-1;d>=0;d--){let o=I[d];if(o.offset+o.length<=c)C=D(C,o);else throw new Error("Overlapping edit");c=o.offset}return C}e.applyEdits=y}),define(be[107],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(P){this.executor=P,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(P){this._error=P}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(P){return new w(()=>P(this.getValue()))}}e.Lazy=w}),define(be[6],we([0,1,53,43]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const P=!1;let A=null;function S(m){A=m}if(e.setDisposableTracker=S,P){const m="__is_disposable_tracked__";A=new class{trackDisposable(u){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[m]||console.log(p)},3e3)}markTracked(u){if(u&&u!==a.None)try{u[m]=!0}catch(p){}}}}function D(m){!A||A.markTracked(m)}function y(m){return A&&A.trackDisposable(m),m}e.trackDisposable=y;class C extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=C;function i(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=i;function I(m){if(k.Iterable.is(m)){let u=[];for(const p of m)if(p){D(p);try{p.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new C(u);return Array.isArray(m)?[]:m}else if(m)return D(m),m.dispose(),m}e.dispose=I;function c(...m){return m.forEach(D),d(()=>I(m))}e.combinedDisposable=c;function d(m){const u=y({dispose:()=>{D(u),m()}});return u}e.toDisposable=d;class o{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return D(u),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=o,o.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this._store=new o,y(this)}dispose(){D(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=a,a.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var p;this._isDisposed||u===this._value||((p=this._value)===null||p===void 0||p.dispose(),u&&D(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,D(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=g;class h{constructor(){this.references=new Map}acquire(u,...p){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...p)},this.references.set(u,t));const{object:n}=t,s=(0,w.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=h;class _{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=_}),define(be[45],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(A){this.element=A,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class k{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,S){const D=new w(A);if(this._first===w.Undefined)this._first=D,this._last=D;else if(S){const C=this._last;this._last=D,D.prev=C,C.next=D}else{const C=this._first;this._first=D,D.next=C,C.prev=D}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(D))}}shift(){if(this._first!==w.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==w.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==w.Undefined&&A.next!==w.Undefined){const S=A.prev;S.next=A.next,A.next.prev=S}else A.prev===w.Undefined&&A.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):A.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):A.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==w.Undefined;)yield A.element,A=A.next}}e.LinkedList=k}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(W,se){for(var de=0;de<se.length;de++){var q=se[de];q.enumerable=q.enumerable||!1,q.configurable=!0,"value"in q&&(q.writable=!0),Object.defineProperty(W,q.key,q)}}function e(W,se,de){return se&&J(W.prototype,se),de&&J(W,de),W}function w(W,se){if(!!W){if(typeof W=="string")return k(W,se);var de=Object.prototype.toString.call(W).slice(8,-1);if(de==="Object"&&W.constructor&&(de=W.constructor.name),de==="Map"||de==="Set")return Array.from(W);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return k(W,se)}}function k(W,se){(se==null||se>W.length)&&(se=W.length);for(var de=0,q=new Array(se);de<se;de++)q[de]=W[de];return q}function P(W,se){var de;if(typeof Symbol=="undefined"||W[Symbol.iterator]==null){if(Array.isArray(W)||(de=w(W))||se&&W&&typeof W.length=="number"){de&&(W=de);var q=0;return function(){return q>=W.length?{done:!0}:{done:!1,value:W[q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return de=W[Symbol.iterator](),de.next.bind(de)}function A(W){var se={exports:{}};return W(se,se.exports),se.exports}var S=A(function(W){function se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function de(q){W.exports.defaults=q}W.exports={defaults:se(),getDefaults:se,changeDefaults:de}}),D=/[&<>"']/,y=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},c=function(se){return I[se]};function d(W,se){if(se){if(D.test(W))return W.replace(y,c)}else if(C.test(W))return W.replace(i,c);return W}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(W){return W.replace(o,function(se,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var g=/(^|[^\[])\^/g;function h(W,se){W=W.source||W,se=se||"";var de={replace:function(Z,le){return le=le.source||le,le=le.replace(g,"$1"),W=W.replace(Z,le),de},getRegex:function(){return new RegExp(W,se)}};return de}var _=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(W,se,de){if(W){var q;try{q=decodeURIComponent(a(de)).replace(_,"").toLowerCase()}catch(Z){return null}if(q.indexOf("javascript:")===0||q.indexOf("vbscript:")===0||q.indexOf("data:")===0)return null}se&&!m.test(de)&&(de=r(se,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch(Z){return null}return de}var p={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(W,se){p[" "+W]||(t.test(W)?p[" "+W]=W+"/":p[" "+W]=T(W,"/",!0)),W=p[" "+W];var de=W.indexOf(":")===-1;return se.substring(0,2)==="//"?de?se:W.replace(n,"$1")+se:se.charAt(0)==="/"?de?se:W.replace(s,"$1")+se:W+se}var l={exec:function(){}};function f(W){for(var se=1,de,q;se<arguments.length;se++){de=arguments[se];for(q in de)Object.prototype.hasOwnProperty.call(de,q)&&(W[q]=de[q])}return W}function v(W,se){var de=W.replace(/\|/g,function(le,he,Ee){for(var Ve=!1,Fe=he;--Fe>=0&&Ee[Fe]==="\\";)Ve=!Ve;return Ve?"|":" |"}),q=de.split(/ \|/),Z=0;if(q.length>se)q.splice(se);else for(;q.length<se;)q.push("");for(;Z<q.length;Z++)q[Z]=q[Z].trim().replace(/\\\|/g,"|");return q}function T(W,se,de){var q=W.length;if(q===0)return"";for(var Z=0;Z<q;){var le=W.charAt(q-Z-1);if(le===se&&!de)Z++;else if(le!==se&&de)Z++;else break}return W.substr(0,q-Z)}function b(W,se){if(W.indexOf(se[1])===-1)return-1;for(var de=W.length,q=0,Z=0;Z<de;Z++)if(W[Z]==="\\")Z++;else if(W[Z]===se[0])q++;else if(W[Z]===se[1]&&(q--,q<0))return Z;return-1}function E(W){W&&W.sanitize&&!W.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(W,se){if(se<1)return"";for(var de="";se>1;)se&1&&(de+=W),se>>=1,W+=W;return de+W}var L={escape:d,unescape:a,edit:h,cleanUrl:u,resolveUrl:r,noopTest:l,merge:f,splitCells:v,rtrim:T,findClosingBracket:b,checkSanitizeDeprecation:E,repeatString:F},K=S.defaults,fe=L.rtrim,j=L.splitCells,H=L.escape,ee=L.findClosingBracket;function O(W,se,de){var q=se.href,Z=se.title?H(se.title):null,le=W[1].replace(/\\([\[\]])/g,"$1");return W[0].charAt(0)!=="!"?{type:"link",raw:de,href:q,title:Z,text:le}:{type:"image",raw:de,href:q,title:Z,text:H(le)}}function R(W,se){var de=W.match(/^(\s+)(?:```)/);if(de===null)return se;var q=de[1];return se.split(`
`).map(function(Z){var le=Z.match(/^\s+/);if(le===null)return Z;var he=le[0];return he.length>=q.length?Z.slice(q.length):Z}).join(`
`)}var N=function(){function W(de){this.options=de||K}var se=W.prototype;return se.space=function(q){var Z=this.rules.block.newline.exec(q);if(Z)return Z[0].length>1?{type:"space",raw:Z[0]}:{raw:`
`}},se.code=function(q){var Z=this.rules.block.code.exec(q);if(Z){var le=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?le:fe(le,`
`)}}},se.fences=function(q){var Z=this.rules.block.fences.exec(q);if(Z){var le=Z[0],he=R(le,Z[3]||"");return{type:"code",raw:le,lang:Z[2]?Z[2].trim():Z[2],text:he}}},se.heading=function(q){var Z=this.rules.block.heading.exec(q);if(Z){var le=Z[2].trim();if(/#$/.test(le)){var he=fe(le,"#");(this.options.pedantic||!he||/ $/.test(he))&&(le=he.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:le}}},se.nptable=function(q){var Z=this.rules.block.nptable.exec(q);if(Z){var le={type:"table",header:j(Z[1].replace(/^ *| *\| *$/g,"")),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Z[3]?Z[3].replace(/\n$/,"").split(`
`):[],raw:Z[0]};if(le.header.length===le.align.length){var he=le.align.length,Ee;for(Ee=0;Ee<he;Ee++)/^ *-+: *$/.test(le.align[Ee])?le.align[Ee]="right":/^ *:-+: *$/.test(le.align[Ee])?le.align[Ee]="center":/^ *:-+ *$/.test(le.align[Ee])?le.align[Ee]="left":le.align[Ee]=null;for(he=le.cells.length,Ee=0;Ee<he;Ee++)le.cells[Ee]=j(le.cells[Ee],le.header.length);return le}}},se.hr=function(q){var Z=this.rules.block.hr.exec(q);if(Z)return{type:"hr",raw:Z[0]}},se.blockquote=function(q){var Z=this.rules.block.blockquote.exec(q);if(Z){var le=Z[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:Z[0],text:le}}},se.list=function(q){var Z=this.rules.block.list.exec(q);if(Z){var le=Z[0],he=Z[2],Ee=he.length>1,Ve={type:"list",raw:le,ordered:Ee,start:Ee?+he.slice(0,-1):"",loose:!1,items:[]},Fe=Z[0].match(this.rules.block.item),We=!1,Qe,it,lt,Ze,nt,ht,wt,ue,Se=Fe.length;lt=this.rules.block.listItemStart.exec(Fe[0]);for(var ae=0;ae<Se;ae++){if(Qe=Fe[ae],le=Qe,ae!==Se-1){if(Ze=this.rules.block.listItemStart.exec(Fe[ae+1]),this.options.pedantic?Ze[1].length>lt[1].length:Ze[1].length>lt[0].length||Ze[1].length>3){Fe.splice(ae,2,Fe[ae]+`
`+Fe[ae+1]),ae--,Se--;continue}else(!this.options.pedantic||this.options.smartLists?Ze[2][Ze[2].length-1]!==he[he.length-1]:Ee===(Ze[2].length===1))&&(nt=Fe.slice(ae+1).join(`
`),Ve.raw=Ve.raw.substring(0,Ve.raw.length-nt.length),ae=Se-1);lt=Ze}it=Qe.length,Qe=Qe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Qe.indexOf(`
 `)&&(it-=Qe.length,Qe=this.options.pedantic?Qe.replace(/^ {1,4}/gm,""):Qe.replace(new RegExp("^ {1,"+it+"}","gm"),"")),ht=We||/\n\n(?!\s*$)/.test(Qe),ae!==Se-1&&(We=Qe.charAt(Qe.length-1)===`
`,ht||(ht=We)),ht&&(Ve.loose=!0),this.options.gfm&&(wt=/^\[[ xX]\] /.test(Qe),ue=void 0,wt&&(ue=Qe[1]!==" ",Qe=Qe.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:le,task:wt,checked:ue,loose:ht,text:Qe})}return Ve}},se.html=function(q){var Z=this.rules.block.html.exec(q);if(Z)return{type:this.options.sanitize?"paragraph":"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):H(Z[0]):Z[0]}},se.def=function(q){var Z=this.rules.block.def.exec(q);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var le=Z[1].toLowerCase().replace(/\s+/g," ");return{tag:le,raw:Z[0],href:Z[2],title:Z[3]}}},se.table=function(q){var Z=this.rules.block.table.exec(q);if(Z){var le={type:"table",header:j(Z[1].replace(/^ *| *\| *$/g,"")),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Z[3]?Z[3].replace(/\n$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=Z[0];var he=le.align.length,Ee;for(Ee=0;Ee<he;Ee++)/^ *-+: *$/.test(le.align[Ee])?le.align[Ee]="right":/^ *:-+: *$/.test(le.align[Ee])?le.align[Ee]="center":/^ *:-+ *$/.test(le.align[Ee])?le.align[Ee]="left":le.align[Ee]=null;for(he=le.cells.length,Ee=0;Ee<he;Ee++)le.cells[Ee]=j(le.cells[Ee].replace(/^ *\| *| *\| *$/g,""),le.header.length);return le}}},se.lheading=function(q){var Z=this.rules.block.lheading.exec(q);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1]}},se.paragraph=function(q){var Z=this.rules.block.paragraph.exec(q);if(Z)return{type:"paragraph",raw:Z[0],text:Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1]}},se.text=function(q){var Z=this.rules.block.text.exec(q);if(Z)return{type:"text",raw:Z[0],text:Z[0]}},se.escape=function(q){var Z=this.rules.inline.escape.exec(q);if(Z)return{type:"escape",raw:Z[0],text:H(Z[1])}},se.tag=function(q,Z,le){var he=this.rules.inline.tag.exec(q);if(he)return!Z&&/^<a /i.test(he[0])?Z=!0:Z&&/^<\/a>/i.test(he[0])&&(Z=!1),!le&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?le=!0:le&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(le=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:Z,inRawBlock:le,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):H(he[0]):he[0]}},se.link=function(q){var Z=this.rules.inline.link.exec(q);if(Z){var le=Z[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var he=fe(le.slice(0,-1),"\\");if((le.length-he.length)%2==0)return}else{var Ee=ee(Z[2],"()");if(Ee>-1){var Ve=Z[0].indexOf("!")===0?5:4,Fe=Ve+Z[1].length+Ee;Z[2]=Z[2].substring(0,Ee),Z[0]=Z[0].substring(0,Fe).trim(),Z[3]=""}}var We=Z[2],Qe="";if(this.options.pedantic){var it=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(We);it&&(We=it[1],Qe=it[3])}else Qe=Z[3]?Z[3].slice(1,-1):"";return We=We.trim(),/^</.test(We)&&(this.options.pedantic&&!/>$/.test(le)?We=We.slice(1):We=We.slice(1,-1)),O(Z,{href:We&&We.replace(this.rules.inline._escapes,"$1"),title:Qe&&Qe.replace(this.rules.inline._escapes,"$1")},Z[0])}},se.reflink=function(q,Z){var le;if((le=this.rules.inline.reflink.exec(q))||(le=this.rules.inline.nolink.exec(q))){var he=(le[2]||le[1]).replace(/\s+/g," ");if(he=Z[he.toLowerCase()],!he||!he.href){var Ee=le[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return O(le,he,le[0])}},se.emStrong=function(q,Z,le){le===void 0&&(le="");var he=this.rules.inline.emStrong.lDelim.exec(q);if(!!he&&!(he[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=he[1]||he[2]||"";if(!Ee||Ee&&(le===""||this.rules.inline.punctuation.exec(le))){var Ve=he[0].length-1,Fe,We,Qe=Ve,it=0,lt=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(lt.lastIndex=0,Z=Z.slice(-1*q.length+Ve);(he=lt.exec(Z))!=null;)if(Fe=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Fe){if(We=Fe.length,he[3]||he[4]){Qe+=We;continue}else if((he[5]||he[6])&&Ve%3&&!((Ve+We)%3)){it+=We;continue}if(Qe-=We,!(Qe>0)){if(Qe+it-We<=0&&!Z.slice(lt.lastIndex).match(lt)&&(We=Math.min(We,We+Qe+it)),Math.min(Ve,We)%2)return{type:"em",raw:q.slice(0,Ve+he.index+We+1),text:q.slice(1,Ve+he.index+We)};if(Math.min(Ve,We)%2==0)return{type:"strong",raw:q.slice(0,Ve+he.index+We+1),text:q.slice(2,Ve+he.index+We-1)}}}}}},se.codespan=function(q){var Z=this.rules.inline.code.exec(q);if(Z){var le=Z[2].replace(/\n/g," "),he=/[^ ]/.test(le),Ee=/^ /.test(le)&&/ $/.test(le);return he&&Ee&&(le=le.substring(1,le.length-1)),le=H(le,!0),{type:"codespan",raw:Z[0],text:le}}},se.br=function(q){var Z=this.rules.inline.br.exec(q);if(Z)return{type:"br",raw:Z[0]}},se.del=function(q){var Z=this.rules.inline.del.exec(q);if(Z)return{type:"del",raw:Z[0],text:Z[2]}},se.autolink=function(q,Z){var le=this.rules.inline.autolink.exec(q);if(le){var he,Ee;return le[2]==="@"?(he=H(this.options.mangle?Z(le[1]):le[1]),Ee="mailto:"+he):(he=H(le[1]),Ee=he),{type:"link",raw:le[0],text:he,href:Ee,tokens:[{type:"text",raw:he,text:he}]}}},se.url=function(q,Z){var le;if(le=this.rules.inline.url.exec(q)){var he,Ee;if(le[2]==="@")he=H(this.options.mangle?Z(le[0]):le[0]),Ee="mailto:"+he;else{var Ve;do Ve=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(Ve!==le[0]);he=H(le[0]),le[1]==="www."?Ee="http://"+he:Ee=he}return{type:"link",raw:le[0],text:he,href:Ee,tokens:[{type:"text",raw:he,text:he}]}}},se.inlineText=function(q,Z,le){var he=this.rules.inline.text.exec(q);if(he){var Ee;return Z?Ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):H(he[0]):he[0]:Ee=H(this.options.smartypants?le(he[0]):he[0]),{type:"text",raw:he[0],text:Ee}}},W}(),$=L.noopTest,U=L.edit,Q=L.merge,Y={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:$,table:$,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Y._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Y._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Y.def=U(Y.def).replace("label",Y._label).replace("title",Y._title).getRegex(),Y.bullet=/(?:[*+-]|\d{1,9}[.)])/,Y.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,Y.item=U(Y.item,"gm").replace(/bull/g,Y.bullet).getRegex(),Y.listItemStart=U(/^( *)(bull)/).replace("bull",Y.bullet).getRegex(),Y.list=U(Y.list).replace(/bull/g,Y.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Y.def.source+")").getRegex(),Y._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Y._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Y.html=U(Y.html,"i").replace("comment",Y._comment).replace("tag",Y._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Y.paragraph=U(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",Y._tag).getRegex(),Y.blockquote=U(Y.blockquote).replace("paragraph",Y.paragraph).getRegex(),Y.normal=Q({},Y),Y.gfm=Q({},Y.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Y.gfm.nptable=U(Y.gfm.nptable).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",Y._tag).getRegex(),Y.gfm.table=U(Y.gfm.table).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",Y._tag).getRegex(),Y.pedantic=Q({},Y.normal,{html:U(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Y._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,paragraph:U(Y.normal._paragraph).replace("hr",Y.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Y.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ie={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:$,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:$,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ie._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ie.punctuation=U(ie.punctuation).replace(/punctuation/g,ie._punctuation).getRegex(),ie.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ie.escapedEmSt=/\\\*|\\_/g,ie._comment=U(Y._comment).replace("(?:-->|$)","-->").getRegex(),ie.emStrong.lDelim=U(ie.emStrong.lDelim).replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimAst=U(ie.emStrong.rDelimAst,"g").replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimUnd=U(ie.emStrong.rDelimUnd,"g").replace(/punct/g,ie._punctuation).getRegex(),ie._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ie._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ie._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ie.autolink=U(ie.autolink).replace("scheme",ie._scheme).replace("email",ie._email).getRegex(),ie._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ie.tag=U(ie.tag).replace("comment",ie._comment).replace("attribute",ie._attribute).getRegex(),ie._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ie._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ie._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ie.link=U(ie.link).replace("label",ie._label).replace("href",ie._href).replace("title",ie._title).getRegex(),ie.reflink=U(ie.reflink).replace("label",ie._label).getRegex(),ie.reflinkSearch=U(ie.reflinkSearch,"g").replace("reflink",ie.reflink).replace("nolink",ie.nolink).getRegex(),ie.normal=Q({},ie),ie.pedantic=Q({},ie.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:U(/^!?\[(label)\]\((.*?)\)/).replace("label",ie._label).getRegex(),reflink:U(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ie._label).getRegex()}),ie.gfm=Q({},ie.normal,{escape:U(ie.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ie.gfm.url=U(ie.gfm.url,"i").replace("email",ie.gfm._extended_email).getRegex(),ie.breaks=Q({},ie.gfm,{br:U(ie.br).replace("{2,}","*").getRegex(),text:U(ie.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var pe={block:Y,inline:ie},Pe=S.defaults,Oe=pe.block,Te=pe.inline,Be=L.repeatString;function x(W){return W.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(W){var se="",de,q,Z=W.length;for(de=0;de<Z;de++)q=W.charCodeAt(de),Math.random()>.5&&(q="x"+q.toString(16)),se+="&#"+q+";";return se}var re=function(){function W(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||Pe,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var q={block:Oe.normal,inline:Te.normal};this.options.pedantic?(q.block=Oe.pedantic,q.inline=Te.pedantic):this.options.gfm&&(q.block=Oe.gfm,this.options.breaks?q.inline=Te.breaks:q.inline=Te.gfm),this.tokenizer.rules=q}W.lex=function(q,Z){var le=new W(Z);return le.lex(q)},W.lexInline=function(q,Z){var le=new W(Z);return le.inlineTokens(q)};var se=W.prototype;return se.lex=function(q){return q=q.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(q,this.tokens,!0),this.inline(this.tokens),this.tokens},se.blockTokens=function(q,Z,le){Z===void 0&&(Z=[]),le===void 0&&(le=!0),this.options.pedantic&&(q=q.replace(/^ +$/gm,""));for(var he,Ee,Ve,Fe;q;){if(he=this.tokenizer.space(q)){q=q.substring(he.raw.length),he.type&&Z.push(he);continue}if(he=this.tokenizer.code(q)){q=q.substring(he.raw.length),Fe=Z[Z.length-1],Fe&&Fe.type==="paragraph"?(Fe.raw+=`
`+he.raw,Fe.text+=`
`+he.text):Z.push(he);continue}if(he=this.tokenizer.fences(q)){q=q.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.heading(q)){q=q.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.nptable(q)){q=q.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.hr(q)){q=q.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.blockquote(q)){q=q.substring(he.raw.length),he.tokens=this.blockTokens(he.text,[],le),Z.push(he);continue}if(he=this.tokenizer.list(q)){for(q=q.substring(he.raw.length),Ve=he.items.length,Ee=0;Ee<Ve;Ee++)he.items[Ee].tokens=this.blockTokens(he.items[Ee].text,[],!1);Z.push(he);continue}if(he=this.tokenizer.html(q)){q=q.substring(he.raw.length),Z.push(he);continue}if(le&&(he=this.tokenizer.def(q))){q=q.substring(he.raw.length),this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(q)){q=q.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.lheading(q)){q=q.substring(he.raw.length),Z.push(he);continue}if(le&&(he=this.tokenizer.paragraph(q))){q=q.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.text(q)){q=q.substring(he.raw.length),Fe=Z[Z.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+he.raw,Fe.text+=`
`+he.text):Z.push(he);continue}if(q){var We="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(We);break}else throw new Error(We)}}return Z},se.inline=function(q){var Z,le,he,Ee,Ve,Fe,We=q.length;for(Z=0;Z<We;Z++)switch(Fe=q[Z],Fe.type){case"paragraph":case"text":case"heading":{Fe.tokens=[],this.inlineTokens(Fe.text,Fe.tokens);break}case"table":{for(Fe.tokens={header:[],cells:[]},Ee=Fe.header.length,le=0;le<Ee;le++)Fe.tokens.header[le]=[],this.inlineTokens(Fe.header[le],Fe.tokens.header[le]);for(Ee=Fe.cells.length,le=0;le<Ee;le++)for(Ve=Fe.cells[le],Fe.tokens.cells[le]=[],he=0;he<Ve.length;he++)Fe.tokens.cells[le][he]=[],this.inlineTokens(Ve[he],Fe.tokens.cells[le][he]);break}case"blockquote":{this.inline(Fe.tokens);break}case"list":{for(Ee=Fe.items.length,le=0;le<Ee;le++)this.inline(Fe.items[le].tokens);break}}return q},se.inlineTokens=function(q,Z,le,he){Z===void 0&&(Z=[]),le===void 0&&(le=!1),he===void 0&&(he=!1);var Ee,Ve,Fe=q,We,Qe,it;if(this.tokens.links){var lt=Object.keys(this.tokens.links);if(lt.length>0)for(;(We=this.tokenizer.rules.inline.reflinkSearch.exec(Fe))!=null;)lt.includes(We[0].slice(We[0].lastIndexOf("[")+1,-1))&&(Fe=Fe.slice(0,We.index)+"["+Be("a",We[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(We=this.tokenizer.rules.inline.blockSkip.exec(Fe))!=null;)Fe=Fe.slice(0,We.index)+"["+Be("a",We[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(We=this.tokenizer.rules.inline.escapedEmSt.exec(Fe))!=null;)Fe=Fe.slice(0,We.index)+"++"+Fe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;q;){if(Qe||(it=""),Qe=!1,Ee=this.tokenizer.escape(q)){q=q.substring(Ee.raw.length),Z.push(Ee);continue}if(Ee=this.tokenizer.tag(q,le,he)){q=q.substring(Ee.raw.length),le=Ee.inLink,he=Ee.inRawBlock;var Ze=Z[Z.length-1];Ze&&Ee.type==="text"&&Ze.type==="text"?(Ze.raw+=Ee.raw,Ze.text+=Ee.text):Z.push(Ee);continue}if(Ee=this.tokenizer.link(q)){q=q.substring(Ee.raw.length),Ee.type==="link"&&(Ee.tokens=this.inlineTokens(Ee.text,[],!0,he)),Z.push(Ee);continue}if(Ee=this.tokenizer.reflink(q,this.tokens.links)){q=q.substring(Ee.raw.length);var nt=Z[Z.length-1];Ee.type==="link"?(Ee.tokens=this.inlineTokens(Ee.text,[],!0,he),Z.push(Ee)):nt&&Ee.type==="text"&&nt.type==="text"?(nt.raw+=Ee.raw,nt.text+=Ee.text):Z.push(Ee);continue}if(Ee=this.tokenizer.emStrong(q,Fe,it)){q=q.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],le,he),Z.push(Ee);continue}if(Ee=this.tokenizer.codespan(q)){q=q.substring(Ee.raw.length),Z.push(Ee);continue}if(Ee=this.tokenizer.br(q)){q=q.substring(Ee.raw.length),Z.push(Ee);continue}if(Ee=this.tokenizer.del(q)){q=q.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],le,he),Z.push(Ee);continue}if(Ee=this.tokenizer.autolink(q,G)){q=q.substring(Ee.raw.length),Z.push(Ee);continue}if(!le&&(Ee=this.tokenizer.url(q,G))){q=q.substring(Ee.raw.length),Z.push(Ee);continue}if(Ee=this.tokenizer.inlineText(q,he,x)){q=q.substring(Ee.raw.length),Ee.raw.slice(-1)!=="_"&&(it=Ee.raw.slice(-1)),Qe=!0,Ve=Z[Z.length-1],Ve&&Ve.type==="text"?(Ve.raw+=Ee.raw,Ve.text+=Ee.text):Z.push(Ee);continue}if(q){var ht="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(ht);break}else throw new Error(ht)}}return Z},e(W,null,[{key:"rules",get:function(){return{block:Oe,inline:Te}}}]),W}(),oe=S.defaults,me=L.cleanUrl,De=L.escape,Ne=function(){function W(de){this.options=de||oe}var se=W.prototype;return se.code=function(q,Z,le){var he=(Z||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(q,he);Ee!=null&&Ee!==q&&(le=!0,q=Ee)}return q=q.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+De(he,!0)+'">'+(le?q:De(q,!0))+`</code></pre>
`:"<pre><code>"+(le?q:De(q,!0))+`</code></pre>
`},se.blockquote=function(q){return`<blockquote>
`+q+`</blockquote>
`},se.html=function(q){return q},se.heading=function(q,Z,le,he){return this.options.headerIds?"<h"+Z+' id="'+this.options.headerPrefix+he.slug(le)+'">'+q+"</h"+Z+`>
`:"<h"+Z+">"+q+"</h"+Z+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(q,Z,le){var he=Z?"ol":"ul",Ee=Z&&le!==1?' start="'+le+'"':"";return"<"+he+Ee+`>
`+q+"</"+he+`>
`},se.listitem=function(q){return"<li>"+q+`</li>
`},se.checkbox=function(q){return"<input "+(q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(q){return"<p>"+q+`</p>
`},se.table=function(q,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+q+`</thead>
`+Z+`</table>
`},se.tablerow=function(q){return`<tr>
`+q+`</tr>
`},se.tablecell=function(q,Z){var le=Z.header?"th":"td",he=Z.align?"<"+le+' align="'+Z.align+'">':"<"+le+">";return he+q+"</"+le+`>
`},se.strong=function(q){return"<strong>"+q+"</strong>"},se.em=function(q){return"<em>"+q+"</em>"},se.codespan=function(q){return"<code>"+q+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(q){return"<del>"+q+"</del>"},se.link=function(q,Z,le){if(q=me(this.options.sanitize,this.options.baseUrl,q),q===null)return le;var he='<a href="'+De(q)+'"';return Z&&(he+=' title="'+Z+'"'),he+=">"+le+"</a>",he},se.image=function(q,Z,le){if(q=me(this.options.sanitize,this.options.baseUrl,q),q===null)return le;var he='<img src="'+q+'" alt="'+le+'"';return Z&&(he+=' title="'+Z+'"'),he+=this.options.xhtml?"/>":">",he},se.text=function(q){return q},W}(),ge=function(){function W(){}var se=W.prototype;return se.strong=function(q){return q},se.em=function(q){return q},se.codespan=function(q){return q},se.del=function(q){return q},se.html=function(q){return q},se.text=function(q){return q},se.link=function(q,Z,le){return""+le},se.image=function(q,Z,le){return""+le},se.br=function(){return""},W}(),Ce=function(){function W(){this.seen={}}var se=W.prototype;return se.serialize=function(q){return q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(q,Z){var le=q,he=0;if(this.seen.hasOwnProperty(le)){he=this.seen[q];do he++,le=q+"-"+he;while(this.seen.hasOwnProperty(le))}return Z||(this.seen[q]=he,this.seen[le]=0),le},se.slug=function(q,Z){Z===void 0&&(Z={});var le=this.serialize(q);return this.getNextSafeSlug(le,Z.dryrun)},W}(),Ae=S.defaults,$e=L.unescape,_e=function(){function W(de){this.options=de||Ae,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new Ce}W.parse=function(q,Z){var le=new W(Z);return le.parse(q)},W.parseInline=function(q,Z){var le=new W(Z);return le.parseInline(q)};var se=W.prototype;return se.parse=function(q,Z){Z===void 0&&(Z=!0);var le="",he,Ee,Ve,Fe,We,Qe,it,lt,Ze,nt,ht,wt,ue,Se,ae,V,Le,Ie,Xe=q.length;for(he=0;he<Xe;he++)switch(nt=q[he],nt.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,$e(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(lt="",it="",Fe=nt.header.length,Ee=0;Ee<Fe;Ee++)it+=this.renderer.tablecell(this.parseInline(nt.tokens.header[Ee]),{header:!0,align:nt.align[Ee]});for(lt+=this.renderer.tablerow(it),Ze="",Fe=nt.cells.length,Ee=0;Ee<Fe;Ee++){for(Qe=nt.tokens.cells[Ee],it="",We=Qe.length,Ve=0;Ve<We;Ve++)it+=this.renderer.tablecell(this.parseInline(Qe[Ve]),{header:!1,align:nt.align[Ve]});Ze+=this.renderer.tablerow(it)}le+=this.renderer.table(lt,Ze);continue}case"blockquote":{Ze=this.parse(nt.tokens),le+=this.renderer.blockquote(Ze);continue}case"list":{for(ht=nt.ordered,wt=nt.start,ue=nt.loose,Fe=nt.items.length,Ze="",Ee=0;Ee<Fe;Ee++)ae=nt.items[Ee],V=ae.checked,Le=ae.task,Se="",ae.task&&(Ie=this.renderer.checkbox(V),ue?ae.tokens.length>0&&ae.tokens[0].type==="text"?(ae.tokens[0].text=Ie+" "+ae.tokens[0].text,ae.tokens[0].tokens&&ae.tokens[0].tokens.length>0&&ae.tokens[0].tokens[0].type==="text"&&(ae.tokens[0].tokens[0].text=Ie+" "+ae.tokens[0].tokens[0].text)):ae.tokens.unshift({type:"text",text:Ie}):Se+=Ie),Se+=this.parse(ae.tokens,ue),Ze+=this.renderer.listitem(Se,Le,V);le+=this.renderer.list(Ze,ht,wt);continue}case"html":{le+=this.renderer.html(nt.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(Ze=nt.tokens?this.parseInline(nt.tokens):nt.text;he+1<Xe&&q[he+1].type==="text";)nt=q[++he],Ze+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);le+=Z?this.renderer.paragraph(Ze):Ze;continue}default:{var et='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return le},se.parseInline=function(q,Z){Z=Z||this.renderer;var le="",he,Ee,Ve=q.length;for(he=0;he<Ve;he++)switch(Ee=q[he],Ee.type){case"escape":{le+=Z.text(Ee.text);break}case"html":{le+=Z.html(Ee.text);break}case"link":{le+=Z.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,Z));break}case"image":{le+=Z.image(Ee.href,Ee.title,Ee.text);break}case"strong":{le+=Z.strong(this.parseInline(Ee.tokens,Z));break}case"em":{le+=Z.em(this.parseInline(Ee.tokens,Z));break}case"codespan":{le+=Z.codespan(Ee.text);break}case"br":{le+=Z.br();break}case"del":{le+=Z.del(this.parseInline(Ee.tokens,Z));break}case"text":{le+=Z.text(Ee.text);break}default:{var Fe='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}return le},W}(),qe=L.merge,z=L.checkSanitizeDeprecation,te=L.escape,ve=S.getDefaults,Ue=S.changeDefaults,He=S.defaults;function xe(W,se,de){if(typeof W=="undefined"||W===null)throw new Error("marked(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");if(typeof se=="function"&&(de=se,se=null),se=qe({},xe.defaults,se||{}),z(se),de){var q=se.highlight,Z;try{Z=re.lex(W,se)}catch(Ve){return de(Ve)}var le=function(Fe){var We;if(!Fe)try{We=_e.parse(Z,se)}catch(Qe){Fe=Qe}return se.highlight=q,Fe?de(Fe):de(null,We)};if(!q||q.length<3||(delete se.highlight,!Z.length))return le();var he=0;xe.walkTokens(Z,function(Ve){Ve.type==="code"&&(he++,setTimeout(function(){q(Ve.text,Ve.lang,function(Fe,We){if(Fe)return le(Fe);We!=null&&We!==Ve.text&&(Ve.text=We,Ve.escaped=!0),he--,he===0&&le()})},0))}),he===0&&le();return}try{var Ee=re.lex(W,se);return se.walkTokens&&xe.walkTokens(Ee,se.walkTokens),_e.parse(Ee,se)}catch(Ve){if(Ve.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+te(Ve.message+"",!0)+"</pre>";throw Ve}}xe.options=xe.setOptions=function(W){return qe(xe.defaults,W),Ue(xe.defaults),xe},xe.getDefaults=ve,xe.defaults=He,xe.use=function(W){var se=qe({},W);if(W.renderer&&function(){var q=xe.defaults.renderer||new Ne,Z=function(Ee){var Ve=q[Ee];q[Ee]=function(){for(var Fe=arguments.length,We=new Array(Fe),Qe=0;Qe<Fe;Qe++)We[Qe]=arguments[Qe];var it=W.renderer[Ee].apply(q,We);return it===!1&&(it=Ve.apply(q,We)),it}};for(var le in W.renderer)Z(le);se.renderer=q}(),W.tokenizer&&function(){var q=xe.defaults.tokenizer||new N,Z=function(Ee){var Ve=q[Ee];q[Ee]=function(){for(var Fe=arguments.length,We=new Array(Fe),Qe=0;Qe<Fe;Qe++)We[Qe]=arguments[Qe];var it=W.tokenizer[Ee].apply(q,We);return it===!1&&(it=Ve.apply(q,We)),it}};for(var le in W.tokenizer)Z(le);se.tokenizer=q}(),W.walkTokens){var de=xe.defaults.walkTokens;se.walkTokens=function(q){W.walkTokens(q),de&&de(q)}}xe.setOptions(se)},xe.walkTokens=function(W,se){for(var de=P(W),q;!(q=de()).done;){var Z=q.value;switch(se(Z),Z.type){case"table":{for(var le=P(Z.tokens.header),he;!(he=le()).done;){var Ee=he.value;xe.walkTokens(Ee,se)}for(var Ve=P(Z.tokens.cells),Fe;!(Fe=Ve()).done;)for(var We=Fe.value,Qe=P(We),it;!(it=Qe()).done;){var lt=it.value;xe.walkTokens(lt,se)}break}case"list":{xe.walkTokens(Z.items,se);break}default:Z.tokens&&xe.walkTokens(Z.tokens,se)}}},xe.parseInline=function(W,se){if(typeof W=="undefined"||W===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");se=qe({},xe.defaults,se||{}),z(se);try{var de=re.lexInline(W,se);return se.walkTokens&&xe.walkTokens(de,se.walkTokens),_e.parseInline(de,se)}catch(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+te(q.message+"",!0)+"</pre>";throw q}},xe.Parser=_e,xe.parser=_e.parse,xe.Renderer=Ne,xe.TextRenderer=ge,xe.Lexer=re,xe.lexer=re.lex,xe.Tokenizer=N,xe.Slugger=Ce,xe.parse=xe;var Ye=xe;return Ye}),define(be[81],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(S,D,y){return Math.min(Math.max(S,D),y)}e.clamp=w;function k(S,D){return(D+S%D)%D}e.rot=k;class P{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=P;class A{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function J(P){const A=[];typeof P=="number"&&A.push("code/timeOrigin",P);function S(y){A.push(y,Date.now())}function D(){const y=[];for(let C=0;C<A.length;C+=2)y.push({name:A[C],startTime:A[C+1]});return y}return{mark:S,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const S of performance.getEntriesByType("mark"))A.push({name:S.name,startTime:Math.round(P+S.startTime)});return A}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function w(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=w(k))})(),define(be[21],we([0,1]),function(J,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let P=!1,A=!1,S=!1,D=!1,y=!1,C=!1,i=!1,I,c=k,d,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode!="undefined"?a=e.globals.vscode.process:typeof process!="undefined"&&(a=process);const g=typeof((w=a==null?void 0:a.versions)===null||w===void 0?void 0:w.electron)=="string"&&a.type==="renderer";if(e.isElectronSandboxed=g&&(a==null?void 0:a.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=a==null?void 0:a.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!g)o=navigator.userAgent,P=o.indexOf("Windows")>=0,A=o.indexOf("Macintosh")>=0,i=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=o.indexOf("Linux")>=0,C=!0,I=navigator.language,c=I;else if(typeof a=="object"){P=a.platform==="win32",A=a.platform==="darwin",S=a.platform==="linux",D=S&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,I=k,c=k;const r=a.env.VSCODE_NLS_CONFIG;if(r)try{const l=JSON.parse(r),f=l.availableLanguages["*"];I=l.locale,c=f||k,d=l._translationsConfigFile}catch(l){}y=!0}else console.error("Unable to resolve platform.");var h;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function _(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=_;let m=0;A?m=1:P?m=3:S&&(m=2),e.isWindows=P,e.isMacintosh=A,e.isLinux=S,e.isLinuxSnap=D,e.isNative=y,e.isWeb=C,e.isIOS=i,e.platform=m,e.userAgent=o,e.language=c;var u;(function(r){function l(){return e.language}r.value=l;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=f;function v(){return e.language==="en"}r.isDefault=v})(u=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=d,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",T=>{if(T.data&&T.data.vscodeSetImmediateId)for(let b=0,E=f.length;b<E;b++){const F=f[b];if(F.id===T.data.vscodeSetImmediateId){f.splice(b,1),F.callback();return}}});let v=0;return T=>{const b=++v;f.push({id:b,callback:T}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(typeof(a==null?void 0:a.nextTick)=="function")return a.nextTick.bind(a);const l=Promise.resolve();return f=>l.then(f)}();var p;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(p=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||i?2:P?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(be[46],we([0,1,21]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof w.globals.vscode!="undefined"){const P=w.globals.vscode.process;k={get platform(){return P.platform},get env(){return P.env},cwd(){return P.cwd()},nextTick(A){return(0,w.setImmediate)(A)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(P){return process.nextTick(P)}}:k={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},nextTick(P){return(0,w.setImmediate)(P)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(be[14],we([0,1,46]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,P=97,A=90,S=122,D=46,y=47,C=92,i=58,I=63;class c extends Error{constructor(u,p,t){let n;typeof p=="string"&&p.indexOf("not ")===0?(n="must not be",p=p.replace(/^not /,"")):n="must be";const s=u.indexOf(".")!==-1?"property":"argument";let r=`The "${u}" ${s} ${n} of type ${p}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function d(m,u){if(typeof m!="string")throw new c(u,"string",m)}function o(m){return m===y||m===C}function a(m){return m===y}function g(m){return m>=k&&m<=A||m>=P&&m<=S}function h(m,u,p,t){let n="",s=0,r=-1,l=0,f=0;for(let v=0;v<=m.length;++v){if(v<m.length)f=m.charCodeAt(v);else{if(t(f))break;f=y}if(t(f)){if(!(r===v-1||l===1))if(l===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==D||n.charCodeAt(n.length-2)!==D){if(n.length>2){const T=n.lastIndexOf(p);T===-1?(n="",s=0):(n=n.slice(0,T),s=n.length-1-n.lastIndexOf(p)),r=v,l=0;continue}else if(n.length!==0){n="",s=0,r=v,l=0;continue}}u&&(n+=n.length>0?`${p}..`:"..",s=2)}else n.length>0?n+=`${p}${m.slice(r+1,v)}`:n=m.slice(r+1,v),s=v-r-1;r=v,l=0}else f===D&&l!==-1?++l:l=-1}return n}function _(m,u){if(u===null||typeof u!="object")throw new c("pathObject","Object",u);const p=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return p?p===u.root?`${p}${t}`:`${p}${m}${t}`:t}e.win32={resolve(...m){let u="",p="",t=!1;for(let n=m.length-1;n>=-1;n--){let s;if(n>=0){if(s=m[n],d(s,"path"),s.length===0)continue}else u.length===0?s=w.cwd():(s=w.env[`=${u}`]||w.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==u.toLowerCase()&&s.charCodeAt(2)===C)&&(s=`${u}\\`));const r=s.length;let l=0,f="",v=!1;const T=s.charCodeAt(0);if(r===1)o(T)&&(l=1,v=!0);else if(o(T))if(v=!0,o(s.charCodeAt(1))){let b=2,E=b;for(;b<r&&!o(s.charCodeAt(b));)b++;if(b<r&&b!==E){const F=s.slice(E,b);for(E=b;b<r&&o(s.charCodeAt(b));)b++;if(b<r&&b!==E){for(E=b;b<r&&!o(s.charCodeAt(b));)b++;(b===r||b!==E)&&(f=`\\\\${F}\\${s.slice(E,b)}`,l=b)}}}else l=1;else g(T)&&s.charCodeAt(1)===i&&(f=s.slice(0,2),l=2,r>2&&o(s.charCodeAt(2))&&(v=!0,l=3));if(f.length>0)if(u.length>0){if(f.toLowerCase()!==u.toLowerCase())continue}else u=f;if(t){if(u.length>0)break}else if(p=`${s.slice(l)}\\${p}`,t=v,v&&u.length>0)break}return p=h(p,!t,"\\",o),t?`${u}\\${p}`:`${u}${p}`||"."},normalize(m){d(m,"path");const u=m.length;if(u===0)return".";let p=0,t,n=!1;const s=m.charCodeAt(0);if(u===1)return a(s)?"\\":m;if(o(s))if(n=!0,o(m.charCodeAt(1))){let l=2,f=l;for(;l<u&&!o(m.charCodeAt(l));)l++;if(l<u&&l!==f){const v=m.slice(f,l);for(f=l;l<u&&o(m.charCodeAt(l));)l++;if(l<u&&l!==f){for(f=l;l<u&&!o(m.charCodeAt(l));)l++;if(l===u)return`\\\\${v}\\${m.slice(f)}\\`;l!==f&&(t=`\\\\${v}\\${m.slice(f,l)}`,p=l)}}}else p=1;else g(s)&&m.charCodeAt(1)===i&&(t=m.slice(0,2),p=2,u>2&&o(m.charCodeAt(2))&&(n=!0,p=3));let r=p<u?h(m.slice(p),!n,"\\",o):"";return r.length===0&&!n&&(r="."),r.length>0&&o(m.charCodeAt(u-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(m){d(m,"path");const u=m.length;if(u===0)return!1;const p=m.charCodeAt(0);return o(p)||u>2&&g(p)&&m.charCodeAt(1)===i&&o(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let u,p;for(let s=0;s<m.length;++s){const r=m[s];d(r,"path"),r.length>0&&(u===void 0?u=p=r:u+=`\\${r}`)}if(u===void 0)return".";let t=!0,n=0;if(typeof p=="string"&&o(p.charCodeAt(0))){++n;const s=p.length;s>1&&o(p.charCodeAt(1))&&(++n,s>2&&(o(p.charCodeAt(2))?++n:t=!1))}if(t){for(;n<u.length&&o(u.charCodeAt(n));)n++;n>=2&&(u=`\\${u.slice(n)}`)}return e.win32.normalize(u)},relative(m,u){if(d(m,"from"),d(u,"to"),m===u)return"";const p=e.win32.resolve(m),t=e.win32.resolve(u);if(p===t||(m=p.toLowerCase(),u=t.toLowerCase(),m===u))return"";let n=0;for(;n<m.length&&m.charCodeAt(n)===C;)n++;let s=m.length;for(;s-1>n&&m.charCodeAt(s-1)===C;)s--;const r=s-n;let l=0;for(;l<u.length&&u.charCodeAt(l)===C;)l++;let f=u.length;for(;f-1>l&&u.charCodeAt(f-1)===C;)f--;const v=f-l,T=r<v?r:v;let b=-1,E=0;for(;E<T;E++){const L=m.charCodeAt(n+E);if(L!==u.charCodeAt(l+E))break;L===C&&(b=E)}if(E!==T){if(b===-1)return t}else{if(v>T){if(u.charCodeAt(l+E)===C)return t.slice(l+E+1);if(E===2)return t.slice(l+E)}r>T&&(m.charCodeAt(n+E)===C?b=E:E===2&&(b=3)),b===-1&&(b=0)}let F="";for(E=n+b+1;E<=s;++E)(E===s||m.charCodeAt(E)===C)&&(F+=F.length===0?"..":"\\..");return l+=b,F.length>0?`${F}${t.slice(l,f)}`:(t.charCodeAt(l)===C&&++l,t.slice(l,f))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const u=e.win32.resolve(m);if(u.length<=2)return m;if(u.charCodeAt(0)===C){if(u.charCodeAt(1)===C){const p=u.charCodeAt(2);if(p!==I&&p!==D)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(g(u.charCodeAt(0))&&u.charCodeAt(1)===i&&u.charCodeAt(2)===C)return`\\\\?\\${u}`;return m},dirname(m){d(m,"path");const u=m.length;if(u===0)return".";let p=-1,t=0;const n=m.charCodeAt(0);if(u===1)return o(n)?m:".";if(o(n)){if(p=t=1,o(m.charCodeAt(1))){let l=2,f=l;for(;l<u&&!o(m.charCodeAt(l));)l++;if(l<u&&l!==f){for(f=l;l<u&&o(m.charCodeAt(l));)l++;if(l<u&&l!==f){for(f=l;l<u&&!o(m.charCodeAt(l));)l++;if(l===u)return m;l!==f&&(p=t=l+1)}}}}else g(n)&&m.charCodeAt(1)===i&&(p=u>2&&o(m.charCodeAt(2))?3:2,t=p);let s=-1,r=!0;for(let l=u-1;l>=t;--l)if(o(m.charCodeAt(l))){if(!r){s=l;break}}else r=!1;if(s===-1){if(p===-1)return".";s=p}return m.slice(0,s)},basename(m,u){u!==void 0&&d(u,"ext"),d(m,"path");let p=0,t=-1,n=!0,s;if(m.length>=2&&g(m.charCodeAt(0))&&m.charCodeAt(1)===i&&(p=2),u!==void 0&&u.length>0&&u.length<=m.length){if(u===m)return"";let r=u.length-1,l=-1;for(s=m.length-1;s>=p;--s){const f=m.charCodeAt(s);if(o(f)){if(!n){p=s+1;break}}else l===-1&&(n=!1,l=s+1),r>=0&&(f===u.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=l))}return p===t?t=l:t===-1&&(t=m.length),m.slice(p,t)}for(s=m.length-1;s>=p;--s)if(o(m.charCodeAt(s))){if(!n){p=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":m.slice(p,t)},extname(m){d(m,"path");let u=0,p=-1,t=0,n=-1,s=!0,r=0;m.length>=2&&m.charCodeAt(1)===i&&g(m.charCodeAt(0))&&(u=t=2);for(let l=m.length-1;l>=u;--l){const f=m.charCodeAt(l);if(o(f)){if(!s){t=l+1;break}continue}n===-1&&(s=!1,n=l+1),f===D?p===-1?p=l:r!==1&&(r=1):p!==-1&&(r=-1)}return p===-1||n===-1||r===0||r===1&&p===n-1&&p===t+1?"":m.slice(p,n)},format:_.bind(null,"\\"),parse(m){d(m,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return u;const p=m.length;let t=0,n=m.charCodeAt(0);if(p===1)return o(n)?(u.root=u.dir=m,u):(u.base=u.name=m,u);if(o(n)){if(t=1,o(m.charCodeAt(1))){let b=2,E=b;for(;b<p&&!o(m.charCodeAt(b));)b++;if(b<p&&b!==E){for(E=b;b<p&&o(m.charCodeAt(b));)b++;if(b<p&&b!==E){for(E=b;b<p&&!o(m.charCodeAt(b));)b++;b===p?t=b:b!==E&&(t=b+1)}}}}else if(g(n)&&m.charCodeAt(1)===i){if(p<=2)return u.root=u.dir=m,u;if(t=2,o(m.charCodeAt(2))){if(p===3)return u.root=u.dir=m,u;t=3}}t>0&&(u.root=m.slice(0,t));let s=-1,r=t,l=-1,f=!0,v=m.length-1,T=0;for(;v>=t;--v){if(n=m.charCodeAt(v),o(n)){if(!f){r=v+1;break}continue}l===-1&&(f=!1,l=v+1),n===D?s===-1?s=v:T!==1&&(T=1):s!==-1&&(T=-1)}return l!==-1&&(s===-1||T===0||T===1&&s===l-1&&s===r+1?u.base=u.name=m.slice(r,l):(u.name=m.slice(r,s),u.base=m.slice(r,l),u.ext=m.slice(s,l))),r>0&&r!==t?u.dir=m.slice(0,r-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let u="",p=!1;for(let t=m.length-1;t>=-1&&!p;t--){const n=t>=0?m[t]:w.cwd();d(n,"path"),n.length!==0&&(u=`${n}/${u}`,p=n.charCodeAt(0)===y)}return u=h(u,!p,"/",a),p?`/${u}`:u.length>0?u:"."},normalize(m){if(d(m,"path"),m.length===0)return".";const u=m.charCodeAt(0)===y,p=m.charCodeAt(m.length-1)===y;return m=h(m,!u,"/",a),m.length===0?u?"/":p?"./":".":(p&&(m+="/"),u?`/${m}`:m)},isAbsolute(m){return d(m,"path"),m.length>0&&m.charCodeAt(0)===y},join(...m){if(m.length===0)return".";let u;for(let p=0;p<m.length;++p){const t=m[p];d(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(m,u){if(d(m,"from"),d(u,"to"),m===u||(m=e.posix.resolve(m),u=e.posix.resolve(u),m===u))return"";const p=1,t=m.length,n=t-p,s=1,r=u.length-s,l=n<r?n:r;let f=-1,v=0;for(;v<l;v++){const b=m.charCodeAt(p+v);if(b!==u.charCodeAt(s+v))break;b===y&&(f=v)}if(v===l)if(r>l){if(u.charCodeAt(s+v)===y)return u.slice(s+v+1);if(v===0)return u.slice(s+v)}else n>l&&(m.charCodeAt(p+v)===y?f=v:v===0&&(f=0));let T="";for(v=p+f+1;v<=t;++v)(v===t||m.charCodeAt(v)===y)&&(T+=T.length===0?"..":"/..");return`${T}${u.slice(s+f)}`},toNamespacedPath(m){return m},dirname(m){if(d(m,"path"),m.length===0)return".";const u=m.charCodeAt(0)===y;let p=-1,t=!0;for(let n=m.length-1;n>=1;--n)if(m.charCodeAt(n)===y){if(!t){p=n;break}}else t=!1;return p===-1?u?"/":".":u&&p===1?"//":m.slice(0,p)},basename(m,u){u!==void 0&&d(u,"ext"),d(m,"path");let p=0,t=-1,n=!0,s;if(u!==void 0&&u.length>0&&u.length<=m.length){if(u===m)return"";let r=u.length-1,l=-1;for(s=m.length-1;s>=0;--s){const f=m.charCodeAt(s);if(f===y){if(!n){p=s+1;break}}else l===-1&&(n=!1,l=s+1),r>=0&&(f===u.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=l))}return p===t?t=l:t===-1&&(t=m.length),m.slice(p,t)}for(s=m.length-1;s>=0;--s)if(m.charCodeAt(s)===y){if(!n){p=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":m.slice(p,t)},extname(m){d(m,"path");let u=-1,p=0,t=-1,n=!0,s=0;for(let r=m.length-1;r>=0;--r){const l=m.charCodeAt(r);if(l===y){if(!n){p=r+1;break}continue}t===-1&&(n=!1,t=r+1),l===D?u===-1?u=r:s!==1&&(s=1):u!==-1&&(s=-1)}return u===-1||t===-1||s===0||s===1&&u===t-1&&u===p+1?"":m.slice(u,t)},format:_.bind(null,"/"),parse(m){d(m,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return u;const p=m.charCodeAt(0)===y;let t;p?(u.root="/",t=1):t=0;let n=-1,s=0,r=-1,l=!0,f=m.length-1,v=0;for(;f>=t;--f){const T=m.charCodeAt(f);if(T===y){if(!l){s=f+1;break}continue}r===-1&&(l=!1,r=f+1),T===D?n===-1?n=f:v!==1&&(v=1):n!==-1&&(v=-1)}if(r!==-1){const T=s===0&&p?1:s;n===-1||v===0||v===1&&n===r-1&&n===s+1?u.base=u.name=m.slice(T,r):(u.name=m.slice(T,n),u.base=m.slice(T,r),u.ext=m.slice(n,r))}return s>0?u.dir=m.slice(0,s-1):p&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[55],we([0,1,21]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=w.globals.performance&&typeof w.globals.performance.now=="function";class P{constructor(S){this._highResolution=k&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new P(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=P}),define(be[3],we([0,1,12,53,6,45,55]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(h){h.None=()=>P.Disposable.None;function _(j){return(H,ee=null,O)=>{let R=!1,N;return N=j($=>{if(!R)return N?N.dispose():R=!0,H.call(ee,$)},null,O),R&&N.dispose(),N}}h.once=_;function m(j,H){return r((ee,O=null,R)=>j(N=>ee.call(O,H(N)),null,R))}h.map=m;function u(j,H){return r((ee,O=null,R)=>j(N=>{H(N),ee.call(O,N)},null,R))}h.forEach=u;function p(j,H){return r((ee,O=null,R)=>j(N=>H(N)&&ee.call(O,N),null,R))}h.filter=p;function t(j){return j}h.signal=t;function n(...j){return(H,ee=null,O)=>(0,P.combinedDisposable)(...j.map(R=>R(N=>H.call(ee,N),null,O)))}h.any=n;function s(j,H,ee){let O=ee;return m(j,R=>(O=H(O,R),O))}h.reduce=s;function r(j){let H;const ee=new c({onFirstListenerAdd(){H=j(ee.fire,ee)},onLastListenerRemove(){H.dispose()}});return ee.event}h.snapshot=r;function l(j,H,ee=100,O=!1,R){let N,$,U,Q=0;const Y=new c({leakWarningThreshold:R,onFirstListenerAdd(){N=j(ie=>{Q++,$=H($,ie),O&&!U&&(Y.fire($),$=void 0),clearTimeout(U),U=setTimeout(()=>{const pe=$;$=void 0,U=void 0,(!O||Q>1)&&Y.fire(pe),Q=0},ee)})},onLastListenerRemove(){N.dispose()}});return Y.event}h.debounce=l;function f(j){const H=new Date().getTime();return m(_(j),ee=>new Date().getTime()-H)}h.stopwatch=f;function v(j){let H=!0,ee;return p(j,O=>{const R=H||O!==ee;return H=!1,ee=O,R})}h.latch=v;function T(j,H=!1,ee=[]){let O=ee.slice(),R=j(U=>{O?O.push(U):$.fire(U)});const N=()=>{O&&O.forEach(U=>$.fire(U)),O=null},$=new c({onFirstListenerAdd(){R||(R=j(U=>$.fire(U)))},onFirstListenerDidAdd(){O&&(H?setTimeout(N):N())},onLastListenerRemove(){R&&R.dispose(),R=null}});return $.event}h.buffer=T;class b{constructor(H){this.event=H}map(H){return new b(m(this.event,H))}forEach(H){return new b(u(this.event,H))}filter(H){return new b(p(this.event,H))}reduce(H,ee){return new b(s(this.event,H,ee))}latch(){return new b(v(this.event))}debounce(H,ee=100,O=!1,R){return new b(l(this.event,H,ee,O,R))}on(H,ee,O){return this.event(H,ee,O)}once(H,ee,O){return _(this.event)(H,ee,O)}}function E(j){return new b(j)}h.chain=E;function F(j,H,ee=O=>O){const O=(...U)=>$.fire(ee(...U)),R=()=>j.on(H,O),N=()=>j.removeListener(H,O),$=new c({onFirstListenerAdd:R,onLastListenerRemove:N});return $.event}h.fromNodeEventEmitter=F;function L(j,H,ee=O=>O){const O=(...U)=>$.fire(ee(...U)),R=()=>j.addEventListener(H,O),N=()=>j.removeEventListener(H,O),$=new c({onFirstListenerAdd:R,onLastListenerRemove:N});return $.event}h.fromDOMEventEmitter=L;function K(j){const H=new c;let ee=!1;return j.then(void 0,()=>null).then(()=>{ee?H.fire(void 0):setTimeout(()=>H.fire(void 0),0)}),ee=!0,H.event}h.fromPromise=K;function fe(j){return new Promise(H=>_(j)(H))}h.toPromise=fe})(D=e.Event||(e.Event={}));class y{constructor(_){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${_}_${y._idPool++}`}start(_){this._stopWatch=new S.StopWatch(!0),this._listenerCount=_}stop(){if(this._stopWatch){const _=this._stopWatch.elapsed();this._elapsedOverall+=_,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${_.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let C=-1;function i(h){const _=C;return C=h,{dispose(){C=_}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(_,m=Math.random().toString(18).slice(2,5)){this.customThreshold=_,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(_){let m=C;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),!(m<=0||_<m)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),p=this._stacks.get(u)||0;if(this._stacks.set(u,p+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let t,n=0;for(const[s,r]of this._stacks)(!t||n<r)&&(t=s,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class c{constructor(_){var m;this._disposed=!1,this._options=_,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((m=this._options)===null||m===void 0?void 0:m._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(_,m,u)=>{var p;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(m?[_,m]:_);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,_,m);const s=(p=this._leakageMon)===null||p===void 0?void 0:p.check(this._listeners.size);let r;return r={dispose:()=>{s&&s(),r.dispose=c._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof P.DisposableStore?u.add(r):Array.isArray(u)&&u.push(r),r}),this._event}fire(_){var m,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,_]);for((m=this._perfMon)===null||m===void 0||m.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(n){(0,w.onUnexpectedError)(n)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var _,m,u;(_=this._listeners)===null||_===void 0||_.clear(),(m=this._deliveryQueue)===null||m===void 0||m.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=c,c._noop=function(){};class d extends c{constructor(_){super(_);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=_==null?void 0:_.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const _=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(_))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(_){this._listeners&&(this._isPaused!==0?this._eventQueue.push(_):super.fire(_))}}e.PauseableEmitter=d;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(_){const m={event:_,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const u=()=>{this.hasListeners&&this.unhook(m);const p=this.events.indexOf(m);this.events.splice(p,1)};return(0,P.toDisposable)((0,k.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(_=>this.hook(_))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(_=>this.unhook(_))}hook(_){_.listener=_.event(m=>this.emitter.fire(m))}unhook(_){_.listener&&_.listener.dispose(),_.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class a{constructor(){this.buffers=[]}wrapEvent(_){return(m,u,p)=>_(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>m.call(u,t)):m.call(u,t)},void 0,p)}bufferEvents(_){const m=[];this.buffers.push(m);const u=_();return this.buffers.pop(),m.forEach(p=>p()),u}}e.EventBufferer=a;class g{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=P.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(_){this.inputEvent=_,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=_(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(be[20],we([0,1,3]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(D,y){const C=setTimeout(D.bind(y),0);return{dispose(){clearTimeout(C)}}});var P;(function(D){function y(C){return C===D.None||C===D.Cancelled||C instanceof A?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}D.isCancellationToken=y,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(P=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=P.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=S}),define(be[36],we([0,1,3]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class k{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(I){const c=this._icons.get(I.id);c?I.description?c.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const P=new k;e.iconRegistry=P;function A(i,I){return new D(i,I)}e.registerCodicon=A;function S(i){return i?i.replace(/\$\((.*?)\)/g,(I,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=S;class D{constructor(I,c,d){this.id=I,this.definition=c,this.description=d,P.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function y(i,I){const c=["codicon","codicon-"+i];return I&&c.push("codicon-modifier-"+I),c}e.getClassNamesArray=y;var C;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function c(a){if(a instanceof D)return["codicon","codicon-"+a.id];const g=I.exec(a.id);if(!g)return c(D.error);let[,h,_]=g;const m=["codicon","codicon-"+h];return _&&m.push("codicon-modifier-"+_.substr(1)),m}i.asClassNameArray=c;function d(a){return c(a).join(" ")}i.asClassName=d;function o(a){return"."+c(a).join(".")}i.asCSSSelector=o})(C=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personAdd=new i("person-add",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(be[108],we([0,1,12,6]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function P(m){const u=m;return u?[u.on,u.pause,u.resume,u.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=P;function A(m){const u=m;return u?P(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=A;function S(m,u){return new D(m,u)}e.newWriteableStream=S;class D{constructor(u,p){this.reducer=u,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){var p;if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof((p=this.options)===null||p===void 0?void 0:p.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(p=>p(u))}emitError(u){this.listeners.error.length===0?(0,w.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(p=>p(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,p){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(u,p){if(!this.state.destroyed){let t;switch(u){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(p);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(m,u){const p=[];let t;for(;(t=m.read())!==null;)p.push(t);return u(p)}e.consumeReadable=y;function C(m,u,p){const t=[];let n;for(;(n=m.read())!==null&&t.length<p;)t.push(n);return n===null&&t.length>0?u(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const s=n;return n=void 0,s}return m.read()}}}e.peekReadable=C;function i(m,u){return new Promise((p,t)=>{const n=[];I(m,{onData:s=>{u&&n.push(s)},onError:s=>{u?t(s):p(void 0)},onEnd:()=>{p(u?u(n):void 0)}})})}e.consumeStream=i;function I(m,u){m.on("error",p=>u.onError(p)),m.on("end",()=>u.onEnd()),m.on("data",p=>u.onData(p))}e.listenStream=I;function c(m,u){return new Promise((p,t)=>{const n=new k.DisposableStore,s=[],r=v=>{if(s.push(v),s.length>u)return n.dispose(),m.pause(),p({stream:m,buffer:s,ended:!1})},l=v=>t(v),f=()=>p({stream:m,buffer:s,ended:!0});n.add((0,k.toDisposable)(()=>m.removeListener("error",l))),m.on("error",l),n.add((0,k.toDisposable)(()=>m.removeListener("end",f))),m.on("end",f),n.add((0,k.toDisposable)(()=>m.removeListener("data",r))),m.on("data",r)})}e.peekStream=c;function d(m,u){const p=S(u);return p.end(m),p}e.toStream=d;function o(){const m=S(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=o;function a(m){let u=!1;return{read:()=>u?null:(u=!0,m)}}e.toReadable=a;function g(m,u,p){const t=S(p);return I(m,{onData:n=>t.write(u.data(n)),onError:n=>t.error(u.error?u.error(n):n),onEnd:()=>t.end()}),t}e.transform=g;function h(m,u,p){let t=!1;return{read:()=>{const n=u.read();return t?n:(t=!0,n!==null?p([m,n]):m)}}}e.prefixedReadable=h;function _(m,u,p){let t=!1;const n=S(p);return I(u,{onData:s=>t?n.write(s):(t=!0,n.write(p([m,s]))),onError:s=>n.error(s),onEnd:()=>{t||(t=!0,n.write(m)),n.end()}}),n}e.prefixedStream=_}),define(be[8],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function w(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=w;const k=/{(\d+)}/g;function P(W,...se){return se.length===0?W:W.replace(k,function(de,q){const Z=parseInt(q,10);return isNaN(Z)||Z<0||Z>=se.length?de:se[Z]})}e.format=P;function A(W){return W.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=A;function S(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function D(W,se){let de=0;const q=se.charCodeAt(0);for(let Z=W.length-1;Z>=0;Z--)W.charCodeAt(Z)===q&&de++;return de}e.count=D;function y(W,se,de="\u2026"){return W.length<=se?W:`${W.substr(0,se)}${de}`}e.truncate=y;function C(W,se=" "){const de=i(W,se);return I(de,se)}e.trim=C;function i(W,se){if(!W||!se)return W;const de=se.length;if(de===0||W.length===0)return W;let q=0;for(;W.indexOf(se,q)===q;)q=q+de;return W.substring(q)}e.ltrim=i;function I(W,se){if(!W||!se)return W;const de=se.length,q=W.length;if(de===0||q===0)return W;let Z=q,le=-1;for(;le=W.lastIndexOf(se,Z-1),!(le===-1||le+de!==Z);){if(le===0)return"";Z=le}return W.substring(0,Z)}e.rtrim=I;function c(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function d(W){return W.replace(/\*/g,"")}e.stripWildcards=d;function o(W,se,de={}){if(!W)throw new Error("Cannot create regex from empty string");se||(W=S(W)),de.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let q="";return de.global&&(q+="g"),de.matchCase||(q+="i"),de.multiline&&(q+="m"),de.unicode&&(q+="u"),new RegExp(W,q)}e.createRegExp=o;function a(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function g(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function h(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=h;function _(W){return W.split(/\r\n|\r|\n/)}e.splitLines=_;function m(W){for(let se=0,de=W.length;se<de;se++){const q=W.charCodeAt(se);if(q!==32&&q!==9)return se}return-1}e.firstNonWhitespaceIndex=m;function u(W,se=0,de=W.length){for(let q=se;q<de;q++){const Z=W.charCodeAt(q);if(Z!==32&&Z!==9)return W.substring(se,q)}return W.substring(se,de)}e.getLeadingWhitespace=u;function p(W,se=W.length-1){for(let de=se;de>=0;de--){const q=W.charCodeAt(de);if(q!==32&&q!==9)return de}return-1}e.lastNonWhitespaceIndex=p;function t(W,se){return W<se?-1:W>se?1:0}e.compare=t;function n(W,se,de=0,q=W.length,Z=0,le=se.length){for(;de<q&&Z<le;de++,Z++){let Ve=W.charCodeAt(de),Fe=se.charCodeAt(Z);if(Ve<Fe)return-1;if(Ve>Fe)return 1}const he=q-de,Ee=le-Z;return he<Ee?-1:he>Ee?1:0}e.compareSubstring=n;function s(W,se){return r(W,se,0,W.length,0,se.length)}e.compareIgnoreCase=s;function r(W,se,de=0,q=W.length,Z=0,le=se.length){for(;de<q&&Z<le;de++,Z++){let Ve=W.charCodeAt(de),Fe=se.charCodeAt(Z);if(Ve!==Fe){const We=Ve-Fe;if(!(We===32&&f(Fe))&&!(We===-32&&f(Ve)))return l(Ve)&&l(Fe)?We:n(W.toLowerCase(),se.toLowerCase(),de,q,Z,le)}}const he=q-de,Ee=le-Z;return he<Ee?-1:he>Ee?1:0}e.compareSubstringIgnoreCase=r;function l(W){return W>=97&&W<=122}e.isLowerAsciiLetter=l;function f(W){return W>=65&&W<=90}e.isUpperAsciiLetter=f;function v(W){return l(W)||f(W)}function T(W,se){return W.length===se.length&&b(W,se)}e.equalsIgnoreCase=T;function b(W,se,de=W.length){for(let q=0;q<de;q++){const Z=W.charCodeAt(q),le=se.charCodeAt(q);if(Z!==le){if(v(Z)&&v(le)){const he=Math.abs(Z-le);if(he!==0&&he!==32)return!1}else if(String.fromCharCode(Z).toLowerCase()!==String.fromCharCode(le).toLowerCase())return!1}}return!0}function E(W,se){const de=se.length;return se.length>W.length?!1:b(W,se,de)}e.startsWithIgnoreCase=E;function F(W,se){let de,q=Math.min(W.length,se.length);for(de=0;de<q;de++)if(W.charCodeAt(de)!==se.charCodeAt(de))return de;return q}e.commonPrefixLength=F;function L(W,se){let de,q=Math.min(W.length,se.length);const Z=W.length-1,le=se.length-1;for(de=0;de<q;de++)if(W.charCodeAt(Z-de)!==se.charCodeAt(le-de))return de;return q}e.commonSuffixLength=L;function K(W){return 55296<=W&&W<=56319}e.isHighSurrogate=K;function fe(W){return 56320<=W&&W<=57343}e.isLowSurrogate=fe;function j(W,se){return(W-55296<<10)+(se-56320)+65536}e.computeCodePoint=j;function H(W,se,de){const q=W.charCodeAt(de);if(K(q)&&de+1<se){const Z=W.charCodeAt(de+1);if(fe(Z))return j(q,Z)}return q}e.getNextCodePoint=H;function ee(W,se){const de=W.charCodeAt(se-1);if(fe(de)&&se>1){const q=W.charCodeAt(se-2);if(K(q))return j(q,de)}return de}function O(W,se){const de=xe.getInstance(),q=se,Z=W.length,le=H(W,Z,se);se+=le>=65536?2:1;let he=de.getGraphemeBreakType(le);for(;se<Z;){const Ee=H(W,Z,se),Ve=de.getGraphemeBreakType(Ee);if(Ue(he,Ve))break;se+=Ee>=65536?2:1,he=Ve}return se-q}e.nextCharLength=O;function R(W,se){const de=xe.getInstance(),q=se,Z=ee(W,se);se-=Z>=65536?2:1;let le=de.getGraphemeBreakType(Z);for(;se>0;){const he=ee(W,se),Ee=de.getGraphemeBreakType(he);if(Ue(Ee,le))break;se-=he>=65536?2:1,le=Ee}return q-se}e.prevCharLength=R;function N(W,se){const de=xe.getInstance(),q=W.length,Z=se,le=H(W,q,se),he=de.getGraphemeBreakType(le);se+=le>=65536?2:1;let Ee=he;for(;se<q;){const Fe=H(W,q,se),We=de.getGraphemeBreakType(Fe);if(Ue(Ee,We))break;se+=Fe>=65536?2:1,Ee=We}const Ve=se;for(se=Z,Ee=he;se>0;){const Fe=ee(W,se),We=de.getGraphemeBreakType(Fe);if(Ue(We,Ee))break;se-=Fe>=65536?2:1,Ee=We}return[se,Ve]}function $(W,se){return se>0&&fe(W.charCodeAt(se))?N(W,se-1):N(W,se)}e.getCharContainingOffset=$;function U(W){const se=W.length;let de=0,q=0;for(;q<se;){const he=H(W,se,q);q+=he>=65536?2:1,he<128?de+=1:he<2048?de+=2:he<65536?de+=3:de+=4}const Z=new Uint8Array(de);q=0;let le=0;for(;q<se;){const he=H(W,se,q);q+=he>=65536?2:1,he<128?Z[le++]=he:he<2048?(Z[le++]=192|(he&1984)>>>6,Z[le++]=128|(he&63)>>>0):he<65536?(Z[le++]=224|(he&61440)>>>12,Z[le++]=128|(he&4032)>>>6,Z[le++]=128|(he&63)>>>0):(Z[le++]=240|(he&1835008)>>>18,Z[le++]=128|(he&258048)>>>12,Z[le++]=128|(he&4032)>>>6,Z[le++]=128|(he&63)>>>0)}return Z}e.encodeUTF8=U;function Q(W){const se=W.byteLength,de=[];let q=0;for(;q<se;){const Z=W[q];let le;if(Z>=240&&q+3<se?le=(W[q++]&7)<<18>>>0|(W[q++]&63)<<12>>>0|(W[q++]&63)<<6>>>0|(W[q++]&63)<<0>>>0:Z>=224&&q+2<se?le=(W[q++]&15)<<12>>>0|(W[q++]&63)<<6>>>0|(W[q++]&63)<<0>>>0:Z>=192&&q+1<se?le=(W[q++]&31)<<6>>>0|(W[q++]&63)<<0>>>0:le=W[q++],le>=0&&le<=55295||le>=57344&&le<=65535)de.push(String.fromCharCode(le));else if(le>=65536&&le<=1114111){const he=le-65536,Ee=55296+((he&1047552)>>>10),Ve=56320+((he&1023)>>>0);de.push(String.fromCharCode(Ee)),de.push(String.fromCharCode(Ve))}else de.push(String.fromCharCode(65533))}return de.join("")}e.decodeUTF8=Q;const Y=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ie(W){return Y.test(W)}e.containsRTL=ie;const pe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Pe(W){return pe.test(W)}e.containsEmoji=Pe;const Oe=/^[\t\n\r\x20-\x7E]*$/;function Te(W){return Oe.test(W)}e.isBasicASCII=Te,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Be(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=Be;function x(W){for(let se=0,de=W.length;se<de;se++)if(G(W.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=x;function G(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=G;function re(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=re;function oe(W,se){if(W.length<se)return W;const de=/\b/g;let q=0;for(;de.test(W)&&!(W.length-de.lastIndex<se);)q=de.lastIndex,de.lastIndex+=1;return W.substring(q).replace(/^\s/,"")}e.lcut=oe;const me=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Ne=/\x1b\[0?m/g;function ge(W){return W&&(W=W.replace(me,""),W=W.replace(De,""),W=W.replace(Ne,"")),W}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ae(W){return Ce(W)?W.substr(1):W}e.stripUTF8BOM=Ae;function $e(W,se){if(!W||!se||W.length<se.length)return!1;const de=se.length,q=W.toLowerCase();let Z=0,le=-1;for(;Z<de;){const he=q.indexOf(se[Z],le+1);if(he<0)return!1;le=he,Z++}return!0}e.fuzzyContains=$e;function _e(W,se=!1){return W?(se&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=_e;function qe(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=qe;function z(W,se=1){if(se===0)return"";let de=-1;do de=W.indexOf(`
`,de+1),se--;while(se>0&&de>=0);return de===-1?W:(W[de-1]==="\r"&&de--,W.substr(0,de))}e.getNLines=z;function te(W){const se=90-65+1;return W=W%(2*se),W<se?String.fromCharCode(97+W):String.fromCharCode(65+W-se)}e.singleLetterHash=te;function ve(W){return xe.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=ve;function Ue(W,se){return W===0?se!==5&&se!==7:W===2&&se===3?!1:W===4||W===2||W===3||se===4||se===2||se===3?!0:!(W===8&&(se===8||se===9||se===11||se===12)||(W===11||W===9)&&(se===9||se===10)||(W===12||W===10)&&se===10||se===5||se===13||se===7||W===1||W===13&&se===14||W===6&&se===6)}e.breakBetweenGraphemeBreakType=Ue;var He;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class xe{constructor(){this._data=Ye()}static getInstance(){return xe._INSTANCE||(xe._INSTANCE=new xe),xe._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const de=this._data,q=de.length/3;let Z=1;for(;Z<=q;)if(se<de[3*Z])Z=2*Z;else if(se>de[3*Z+1])Z=2*Z+1;else return de[3*Z+2];return 0}}xe._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(be[23],we([0,1,8,108]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",S=typeof TextDecoder!="undefined";let D,y;class C{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return P?new C(Buffer.allocUnsafe(v)):new C(new Uint8Array(v))}static wrap(v){return P&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new C(v)}static fromString(v,T){return!((T==null?void 0:T.dontUseNodeBuffer)||!1)&&P?new C(Buffer.from(v)):A?(D||(D=new TextEncoder),new C(D.encode(v))):new C(w.encodeUTF8(v))}static concat(v,T){if(typeof T=="undefined"){T=0;for(let F=0,L=v.length;F<L;F++)T+=v[F].byteLength}const b=C.alloc(T);let E=0;for(let F=0,L=v.length;F<L;F++){const K=v[F];b.set(K,E),E+=K.byteLength}return b}toString(){return P?this.buffer.toString():S?(y||(y=new TextDecoder),y.decode(this.buffer)):w.decodeUTF8(this.buffer)}slice(v,T){return new C(this.buffer.subarray(v,T))}set(v,T){v instanceof C?this.buffer.set(v.buffer,T):this.buffer.set(v,T)}readUInt32BE(v){return c(this.buffer,v)}writeUInt32BE(v,T){d(this.buffer,v,T)}readUInt32LE(v){return o(this.buffer,v)}writeUInt32LE(v,T){a(this.buffer,v,T)}readUInt8(v){return g(this.buffer,v)}writeUInt8(v,T){h(this.buffer,v,T)}}e.VSBuffer=C;function i(f,v){return f[v+0]<<0>>>0|f[v+1]<<8>>>0}e.readUInt16LE=i;function I(f,v,T){f[T+0]=v&255,v=v>>>8,f[T+1]=v&255}e.writeUInt16LE=I;function c(f,v){return f[v]*2**24+f[v+1]*2**16+f[v+2]*2**8+f[v+3]}e.readUInt32BE=c;function d(f,v,T){f[T+3]=v,v=v>>>8,f[T+2]=v,v=v>>>8,f[T+1]=v,v=v>>>8,f[T]=v}e.writeUInt32BE=d;function o(f,v){return f[v+0]<<0>>>0|f[v+1]<<8>>>0|f[v+2]<<16>>>0|f[v+3]<<24>>>0}e.readUInt32LE=o;function a(f,v,T){f[T+0]=v&255,v=v>>>8,f[T+1]=v&255,v=v>>>8,f[T+2]=v&255,v=v>>>8,f[T+3]=v&255}e.writeUInt32LE=a;function g(f,v){return f[v]}e.readUInt8=g;function h(f,v,T){f[T]=v}e.writeUInt8=h;function _(f){return k.consumeReadable(f,v=>C.concat(v))}e.readableToBuffer=_;function m(f){return k.toReadable(f)}e.bufferToReadable=m;function u(f){return k.consumeStream(f,v=>C.concat(v))}e.streamToBuffer=u;async function p(f){return f.ended?C.concat(f.buffer):C.concat([...f.buffer,await u(f.stream)])}e.bufferedStreamToBuffer=p;function t(f){return k.toStream(f,v=>C.concat(v))}e.bufferToStream=t;function n(f){return k.transform(f,{data:v=>typeof v=="string"?C.fromString(v):C.wrap(v)},v=>C.concat(v))}e.streamToBufferReadableStream=n;function s(f){return k.newWriteableStream(v=>C.concat(v),f)}e.newWriteableBufferStream=s;function r(f,v){return k.prefixedReadable(f,v,T=>C.concat(T))}e.prefixedBufferReadable=r;function l(f,v){return k.prefixedStream(f,v,T=>C.concat(T))}e.prefixedBufferStream=l}),define(be[56],we([0,1,8]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function k(h){return P(h,0)}e.hash=k;function P(h,_){switch(typeof h){case"object":return h===null?A(349,_):Array.isArray(h)?y(h,_):C(h,_);case"string":return D(h,_);case"boolean":return S(h,_);case"number":return A(h,_);case"undefined":return A(937,_);default:return A(617,_)}}e.doHash=P;function A(h,_){return(_<<5)-_+h|0}function S(h,_){return A(h?433:863,_)}function D(h,_){_=A(149417,_);for(let m=0,u=h.length;m<u;m++)_=A(h.charCodeAt(m),_);return _}e.stringHash=D;function y(h,_){return _=A(104579,_),h.reduce((m,u)=>P(u,m),_)}function C(h,_){return _=A(181387,_),Object.keys(h).sort().reduce((m,u)=>(m=D(u,m),P(h[u],m)),_)}class i{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=P(_,this._value),this._value}}e.Hasher=i;var I;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function c(h,_,m=32){const u=m-_,p=~((1<<u)-1);return(h<<_|(p&h)>>>u)>>>0}function d(h,_=0,m=h.byteLength,u=0){for(let p=0;p<m;p++)h[_+p]=u}function o(h,_,m="0"){for(;h.length<_;)h=m+h;return h}function a(h,_=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(m=>m.toString(16).padStart(2,"0")).join(""):o((h>>>0).toString(16),_/4)}e.toHexString=a;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const m=_.length;if(m!==0){const u=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=_.charCodeAt(0),s=0);;){let r=n;if(w.isHighSurrogate(n))if(s+1<m){const l=_.charCodeAt(s+1);w.isLowSurrogate(l)?(s++,r=w.computeCodePoint(n,l)):r=65533}else{t=n;break}else w.isLowSurrogate(n)&&(r=65533);if(p=this._push(u,p,r),s++,s<m)n=_.charCodeAt(s);else break}this._buffLen=p,this._leftoverHighSurrogate=t}}_push(_,m,u){return u<128?_[m++]=u:u<2048?(_[m++]=192|(u&1984)>>>6,_[m++]=128|(u&63)>>>0):u<65536?(_[m++]=224|(u&61440)>>>12,_[m++]=128|(u&4032)>>>6,_[m++]=128|(u&63)>>>0):(_[m++]=240|(u&1835008)>>>18,_[m++]=128|(u&258048)>>>12,_[m++]=128|(u&4032)>>>6,_[m++]=128|(u&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=g._bigBlock32,m=this._buffDV;for(let v=0;v<64;v+=4)_.setUint32(v,m.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)_.setUint32(v,c(_.getUint32(v-12,!1)^_.getUint32(v-32,!1)^_.getUint32(v-56,!1)^_.getUint32(v-64,!1),1),!1);let u=this._h0,p=this._h1,t=this._h2,n=this._h3,s=this._h4,r,l,f;for(let v=0;v<80;v++)v<20?(r=p&t|~p&n,l=1518500249):v<40?(r=p^t^n,l=1859775393):v<60?(r=p&t|p&n|t&n,l=2400959708):(r=p^t^n,l=3395469782),f=c(u,5)+r+s+l+_.getUint32(v*4,!1)&4294967295,s=n,n=t,t=c(p,30),p=u,u=f;this._h0=this._h0+u&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[47],we([0,1,8]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(k||(k={})),function(P){const A="error",S="warning",D="warn",y="info";function C(i){return i?w.equalsIgnoreCase(A,i)?P.Error:w.equalsIgnoreCase(S,i)||w.equalsIgnoreCase(D,i)?P.Warning:w.equalsIgnoreCase(y,i)?P.Info:P.Ignore:P.Ignore}P.fromValue=C}(k||(k={})),e.default=k}),define(be[10],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(v){return Array.isArray(v)}e.isArray=w;function k(v){return typeof v=="string"}e.isString=k;function P(v){return Array.isArray(v)&&v.every(T=>k(T))}e.isStringArray=P;function A(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=A;function S(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=S;function D(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=D;function y(v){return v===!0||v===!1}e.isBoolean=y;function C(v){return typeof v=="undefined"}e.isUndefined=C;function i(v){return!I(v)}e.isDefined=i;function I(v){return C(v)||v===null}e.isUndefinedOrNull=I;function c(v,T){if(!v)throw new Error(T?`Unexpected type, expected '${T}'`:"Unexpected type")}e.assertType=c;function d(v){if(I(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=d;function o(...v){const T=[];for(let b=0;b<v.length;b++){const E=v[b];if(I(E))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);T.push(E)}return T}e.assertAllDefined=o;const a=Object.prototype.hasOwnProperty;function g(v){if(!A(v))return!1;for(let T in v)if(a.call(v,T))return!1;return!0}e.isEmptyObject=g;function h(v){return typeof v=="function"}e.isFunction=h;function _(...v){return v.length>0&&v.every(h)}e.areFunctions=_;function m(v,T){const b=Math.min(v.length,T.length);for(let E=0;E<b;E++)u(v[E],T[E])}e.validateConstraints=m;function u(v,T){if(k(T)){if(typeof v!==T)throw new Error(`argument does not match constraint: typeof ${T}`)}else if(h(T)){try{if(v instanceof T)return}catch(b){}if(!I(v)&&v.constructor===T||T.length===1&&T.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function p(v){let T=[],b=Object.getPrototypeOf(v);for(;Object.prototype!==b;)T=T.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return T}e.getAllPropertyNames=p;function t(v){const T=[];for(const b of p(v))typeof v[b]=="function"&&T.push(b);return T}e.getAllMethodNames=t;function n(v,T){const b=F=>function(){const L=Array.prototype.slice.call(arguments,0);return T(F,L)};let E={};for(const F of v)E[F]=b(F);return E}e.createProxyObject=n;function s(v){return v===null?void 0:v}e.withNullAsUndefined=s;function r(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=r;function l(v){return class{constructor(){return new Proxy({},{get(T,b){if(T[b])return T[b];throw new Error(`Not Implemented: ${v}->${String(b)}`)}})}}}e.NotImplementedProxy=l;function f(v){throw new Error("Unreachable")}e.assertNever=f}),define(be[37],we([0,1,21,8,14,10]),function(J,e,w,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function S(n){return n===47||n===92}e.isPathSeparator=S;function D(n){return n.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=D;function y(n,s=P.posix.sep){if(!n)return"";const r=n.length,l=n.charCodeAt(0);if(S(l)){if(S(n.charCodeAt(1))&&!S(n.charCodeAt(2))){let v=3;const T=v;for(;v<r&&!S(n.charCodeAt(v));v++);if(T!==v&&!S(n.charCodeAt(v+1))){for(v+=1;v<r;v++)if(S(n.charCodeAt(v)))return n.slice(0,v+1).replace(/[\\/]/g,s)}}return s}else if(g(l)&&n.charCodeAt(1)===58)return S(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let f=n.indexOf("://");if(f!==-1){for(f+=3;f<r;f++)if(S(n.charCodeAt(f)))return n.slice(0,f+1)}return""}e.getRoot=y;function C(n){if(!w.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let r=2;const l=r;for(;r<n.length&&(s=n.charCodeAt(r),s!==92);r++);return!(l===r||(s=n.charCodeAt(r+1),isNaN(s)||s===92))}e.isUNC=C;const i=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(n,s=w.isWindows){const r=s?i:I;return!(!n||n.length===0||/^\s+$/.test(n)||(r.lastIndex=0,r.test(n))||s&&c.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=d;function o(n,s,r){const l=n===s;return!r||l?l:!n||!s?!1:(0,k.equalsIgnoreCase)(n,s)}e.isEqual=o;function a(n,s,r,l=P.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(r){if(!(0,k.startsWithIgnoreCase)(n,s))return!1;if(s.length===n.length)return!0;let v=s.length;return s.charAt(s.length-1)===l&&v--,n.charAt(v)===l}return s.charAt(s.length-1)!==l&&(s+=l),n.indexOf(s)===0}e.isEqualOrParent=a;function g(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=g;function h(n,s){return w.isWindows&&n.endsWith(":")&&(n+=P.sep),(0,P.isAbsolute)(n)||(n=(0,P.join)(s,n)),n=(0,P.normalize)(n),w.isWindows?(n=(0,k.rtrim)(n,P.sep),n.endsWith(":")&&(n+=P.sep)):(n=(0,k.rtrim)(n,P.sep),n||(n=P.sep)),n}e.sanitizeFilePath=h;function _(n){const s=(0,P.normalize)(n);return w.isWindows?n.length>3?!1:m(s)&&(n.length===2||s.charCodeAt(2)===92):s===P.posix.sep}e.isRootOrDriveLetter=_;function m(n){return w.isWindows?g(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function u(n){return m(n)?n[0]:void 0}e.getDriveLetter=u;function p(n,s,r){return s.length>n.length?-1:n===s?0:(r&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=p;function t(n){const s=n.split(":");let r,l,f;if(s.forEach(v=>{const T=Number(v);(0,A.isNumber)(T)?l===void 0?l=T:f===void 0&&(f=T):r=r?[r,v].join(":"):v}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:l!==void 0?l:void 0,column:f!==void 0?f:l!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(be[24],we([0,1,10]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const a=Array.isArray(o)?[]:{};return Object.keys(o).forEach(g=>{o[g]&&typeof o[g]=="object"?a[g]=k(o[g]):a[g]=o[g]}),a}e.deepClone=k;function P(o){if(!o||typeof o!="object")return o;const a=[o];for(;a.length>0;){const g=a.shift();Object.freeze(g);for(const h in g)if(A.call(g,h)){const _=g[h];typeof _=="object"&&!Object.isFrozen(_)&&a.push(_)}}return o}e.deepFreeze=P;const A=Object.prototype.hasOwnProperty;function S(o,a){return D(o,a,new Set)}e.cloneAndChange=S;function D(o,a,g){if((0,w.isUndefinedOrNull)(o))return o;const h=a(o);if(typeof h!="undefined")return h;if((0,w.isArray)(o)){const _=[];for(const m of o)_.push(D(m,a,g));return _}if((0,w.isObject)(o)){if(g.has(o))throw new Error("Cannot clone recursive data-structure");g.add(o);const _={};for(let m in o)A.call(o,m)&&(_[m]=D(o[m],a,g));return g.delete(o),_}return o}function y(o,a,g=!0){return(0,w.isObject)(o)?((0,w.isObject)(a)&&Object.keys(a).forEach(h=>{h in o?g&&((0,w.isObject)(o[h])&&(0,w.isObject)(a[h])?y(o[h],a[h],g):o[h]=a[h]):o[h]=a[h]}),o):a}e.mixin=y;function C(o,a){if(o===a)return!0;if(o==null||a===null||a===void 0||typeof o!=typeof a||typeof o!="object"||Array.isArray(o)!==Array.isArray(a))return!1;let g,h;if(Array.isArray(o)){if(o.length!==a.length)return!1;for(g=0;g<o.length;g++)if(!C(o[g],a[g]))return!1}else{const _=[];for(h in o)_.push(h);_.sort();const m=[];for(h in a)m.push(h);if(m.sort(),!C(_,m))return!1;for(g=0;g<_.length;g++)if(!C(o[_[g]],a[_[g]]))return!1}return!0}e.equals=C;function i(o){const a=new Set;return JSON.stringify(o,(g,h)=>{if((0,w.isObject)(h)||Array.isArray(h)){if(a.has(h))return"[Circular]";a.add(h)}return h})}e.safeStringify=i;function I(o,a,g){const h=a(o);return typeof h=="undefined"?g:h}e.getOrDefault=I;function c(o,a){const g=Object.create(null);return!o||!a||Object.keys(a).forEach(_=>{const m=o[_],u=a[_];C(m,u)||(g[_]=u)}),g}e.distinct=c;function d(o,a){const g=a.toLowerCase(),h=Object.keys(o).find(_=>_.toLowerCase()===g);return h?o[h]:o[a]}e.getCaseInsensitive=d}),define(be[82],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var w;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(w=e.Constants||(e.Constants={}));function k(A){return A<0?0:A>255?255:A|0}e.toUint8=k;function P(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=P}),define(be[2],we([0,1,21,14]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,A=/^\//,S=/^\/\//;function D(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!P.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(s,r){return!s&&!r?"file":s}function C(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const i="",I="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(r,l,f,v,T,b=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=y(r,b),this.authority=l||i,this.path=C(this.scheme,f||i),this.query=v||i,this.fragment=T||i,D(this,b))}static isUri(r){return r instanceof d?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return m(this,!1)}with(r){if(!r)return this;let{scheme:l,authority:f,path:v,query:T,fragment:b}=r;return l===void 0?l=this.scheme:l===null&&(l=i),f===void 0?f=this.authority:f===null&&(f=i),v===void 0?v=this.path:v===null&&(v=i),T===void 0?T=this.query:T===null&&(T=i),b===void 0?b=this.fragment:b===null&&(b=i),l===this.scheme&&f===this.authority&&v===this.path&&T===this.query&&b===this.fragment?this:new a(l,f,v,T,b)}static parse(r,l=!1){const f=c.exec(r);return f?new a(f[2]||i,n(f[4]||i),n(f[5]||i),n(f[7]||i),n(f[9]||i),l):new a(i,i,i,i,i)}static file(r){let l=i;if(w.isWindows&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const f=r.indexOf(I,2);f===-1?(l=r.substring(2),r=I):(l=r.substring(2,f),r=r.substring(f)||I)}return new a("file",l,r,i,i)}static from(r){return new a(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...l){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return w.isWindows&&r.scheme==="file"?f=d.file(k.win32.join(m(r,!0),...l)).path:f=k.posix.join(r.path,...l),r.with({path:f})}toString(r=!1){return u(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof d)return r;{const l=new a(r);return l._formatted=r.external,l._fsPath=r._sep===o?r.fsPath:null,l}}else return r}}e.URI=d;const o=w.isWindows?1:void 0;class a extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(r=!1){return r?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=o),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(s,r){let l,f=-1;for(let v=0;v<s.length;v++){const T=s.charCodeAt(v);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||r&&T===47)f!==-1&&(l+=encodeURIComponent(s.substring(f,v)),f=-1),l!==void 0&&(l+=s.charAt(v));else{l===void 0&&(l=s.substr(0,v));const b=g[T];b!==void 0?(f!==-1&&(l+=encodeURIComponent(s.substring(f,v)),f=-1),l+=b):f===-1&&(f=v)}}return f!==-1&&(l+=encodeURIComponent(s.substring(f))),l!==void 0?l:s}function _(s){let r;for(let l=0;l<s.length;l++){const f=s.charCodeAt(l);f===35||f===63?(r===void 0&&(r=s.substr(0,l)),r+=g[f]):r!==void 0&&(r+=s[l])}return r!==void 0?r:s}function m(s,r){let l;return s.authority&&s.path.length>1&&s.scheme==="file"?l=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?l=s.path.substr(1):l=s.path[1].toLowerCase()+s.path.substr(2):l=s.path,w.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=m;function u(s,r){const l=r?_:h;let f="",{scheme:v,authority:T,path:b,query:E,fragment:F}=s;if(v&&(f+=v,f+=":"),(T||v==="file")&&(f+=I,f+=I),T){let L=T.indexOf("@");if(L!==-1){const K=T.substr(0,L);T=T.substr(L+1),L=K.indexOf(":"),L===-1?f+=l(K,!1):(f+=l(K.substr(0,L),!1),f+=":",f+=l(K.substr(L+1),!1)),f+="@"}T=T.toLowerCase(),L=T.indexOf(":"),L===-1?f+=l(T,!1):(f+=l(T.substr(0,L),!1),f+=T.substr(L))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const L=b.charCodeAt(1);L>=65&&L<=90&&(b=`/${String.fromCharCode(L+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const L=b.charCodeAt(0);L>=65&&L<=90&&(b=`${String.fromCharCode(L+32)}:${b.substr(2)}`)}f+=l(b,!0)}return E&&(f+="?",f+=l(E,!1)),F&&(f+="#",f+=r?F:h(F,!1)),f}function p(s){try{return decodeURIComponent(s)}catch(r){return s.length>3?s.substr(0,3)+p(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,r=>p(r)):s}});var tt=this&&this.__classPrivateFieldSet||function(J,e,w,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,w):P?P.value=w:e.set(J,w),w},Me=this&&this.__classPrivateFieldGet||function(J,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(J):k?k.value:e.get(J)};define(be[22],we([0,1,2,8]),function(J,e,w,k){"use strict";var P,A,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,n,s){let r=t.get(n);return r===void 0&&(r=s,t.set(n,r)),r}e.getOrSet=D;function y(t){const n=[];return t.forEach((s,r)=>{n.push(`${r} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=y;function C(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=C;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class c{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var d;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(d||(d={}));class o{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,k.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class g{constructor(n){this._iter=n}static forUris(n=()=>!1){return new g(new o(n))}static forPaths(){return new g(new c)}static forStrings(){return new g(new i)}static forConfigKeys(){return new g(new I)}clear(){this._root=void 0}set(n,s){const r=this._iter.reset(n);let l;for(this._root||(this._root=new a,this._root.segment=r.value()),l=this._root;;){const v=r.cmp(l.segment);if(v>0)l.left||(l.left=new a,l.left.segment=r.value()),l=l.left;else if(v<0)l.right||(l.right=new a,l.right.segment=r.value()),l=l.right;else if(r.hasNext())r.next(),l.mid||(l.mid=new a,l.mid.segment=r.value()),l=l.mid;else break}const f=l.value;return l.value=s,l.key=n,f}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const l=s.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const r=this._iter.reset(n),l=[];let f=this._root;for(;f;){const v=r.cmp(f.segment);if(v>0)l.push([1,f]),f=f.left;else if(v<0)l.push([-1,f]),f=f.right;else if(r.hasNext())r.next(),l.push([0,f]),f=f.mid;else{for(s?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;l.length>0&&f.isEmpty();){let[T,b]=l.pop();switch(T){case 1:b.left=void 0;break;case 0:b.mid=void 0;break;case-1:b.right=void 0;break}f=b}break}}}findSubstr(n){const s=this._iter.reset(n);let r=this._root,l;for(;r;){const f=s.cmp(r.segment);if(f>0)r=r.left;else if(f<0)r=r.right;else if(s.hasNext())s.next(),l=r.value||l,r=r.mid;else break}return r&&r.value||l}findSuperstr(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const l=s.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[s,r]of this)n(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=g;class h{constructor(n,s){this[P]="ResourceMap",n instanceof h?(this.map=new Map(n.map),this.toKey=s!=null?s:h.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:h.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[r,l]of this.map)n(l,w.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield w.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[w.URI.parse(n[0]),n[1]]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[w.URI.parse(n[0]),n[1]]}}e.ResourceMap=h,h.defaultToKey=t=>t.toString();var _;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(_=e.Touch||(e.Touch={}));class m{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const r=this._map.get(n);if(!!r)return s!==0&&this.touch(r,s),r.value}set(n,s,r=0){let l=this._map.get(n);if(l)l.value=s,r!==0&&this.touch(l,r);else{switch(l={key:n,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,s){const r=this._state;let l=this._head;for(;l;){if(s?n.bind(s)(l.value,l.key,this):n(l.value,l.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,s=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const f={value:r.key,done:!1};return r=r.next,f}else return{value:void 0,done:!0}}};return l}values(){const n=this,s=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const f={value:r.value,done:!1};return r=r.next,f}else return{value:void 0,done:!0}}};return l}entries(){const n=this,s=this._state;let r=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const f={value:[r.key,r.value],done:!1};return r=r.next,f}else return{value:void 0,done:!0}}};return l}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>n;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,r=n.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const r=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(r.previous=l,l.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const r=n.next,l=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=l,l.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,r)=>{n.push([r,s])}),n}fromJSON(n){this.clear();for(const[s,r]of n)this.set(s,r)}}e.LinkedMap=m;class u extends m{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class p{constructor(n){S.set(this,void 0),tt(this,S,n,"f")}get size(){return Me(this,S,"f").size}forEach(n,s){Me(this,S,"f").forEach(n,s)}get(n){return Me(this,S,"f").get(n)}has(n){return Me(this,S,"f").has(n)}entries(){return Me(this,S,"f").entries()}keys(){return Me(this,S,"f").keys()}values(){return Me(this,S,"f").values()}[(S=new WeakMap,Symbol.iterator)](){return Me(this,S,"f").entries()}}e.ReadonlyMapView=p}),define(be[109],we([0,1,22,8]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function P(...ge){return function(Ce,Ae){for(let $e=0,_e=ge.length;$e<_e;$e++){const qe=ge[$e](Ce,Ae);if(qe)return qe}return null}}e.or=P,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ge,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let $e;return ge?$e=k.startsWithIgnoreCase(Ae,Ce):$e=Ae.indexOf(Ce)===0,$e?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function S(ge,Ce){const Ae=Ce.toLowerCase().indexOf(ge.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+ge.length}]}e.matchesContiguousSubString=S;function D(ge,Ce){return y(ge.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=D;function y(ge,Ce,Ae,$e){if(Ae===ge.length)return[];if($e===Ce.length)return null;if(ge[Ae]===Ce[$e]){let _e=null;return(_e=y(ge,Ce,Ae+1,$e+1))?h({start:$e,end:$e+1},_e):null}return y(ge,Ce,Ae,$e+1)}function C(ge){return 97<=ge&&ge<=122}function i(ge){return 65<=ge&&ge<=90}e.isUpper=i;function I(ge){return 48<=ge&&ge<=57}function c(ge){return ge===32||ge===9||ge===10||ge===13}const d=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ge=>d.add(ge.charCodeAt(0)));function o(ge){return c(ge)||d.has(ge)}function a(ge,Ce){return ge===Ce||o(ge)&&o(Ce)}function g(ge){return C(ge)||i(ge)||I(ge)}function h(ge,Ce){return Ce.length===0?Ce=[ge]:ge.end===Ce[0].start?Ce[0].start=ge.start:Ce.unshift(ge),Ce}function _(ge,Ce){for(let Ae=Ce;Ae<ge.length;Ae++){const $e=ge.charCodeAt(Ae);if(i($e)||I($e)||Ae>0&&!g(ge.charCodeAt(Ae-1)))return Ae}return ge.length}function m(ge,Ce,Ae,$e){if(Ae===ge.length)return[];if($e===Ce.length)return null;if(ge[Ae]!==Ce[$e].toLowerCase())return null;{let _e=null,qe=$e+1;for(_e=m(ge,Ce,Ae+1,$e+1);!_e&&(qe=_(Ce,qe))<Ce.length;)_e=m(ge,Ce,Ae+1,qe),qe++;return _e===null?null:h({start:$e,end:$e+1},_e)}}function u(ge){let Ce=0,Ae=0,$e=0,_e=0,qe=0;for(let He=0;He<ge.length;He++)qe=ge.charCodeAt(He),i(qe)&&Ce++,C(qe)&&Ae++,g(qe)&&$e++,I(qe)&&_e++;const z=Ce/ge.length,te=Ae/ge.length,ve=$e/ge.length,Ue=_e/ge.length;return{upperPercent:z,lowerPercent:te,alphaPercent:ve,numericPercent:Ue}}function p(ge){const{upperPercent:Ce,lowerPercent:Ae}=ge;return Ae===0&&Ce>.6}function t(ge){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:$e,numericPercent:_e}=ge;return Ae>.2&&Ce<.8&&$e>.6&&_e<.2}function n(ge){let Ce=0,Ae=0,$e=0,_e=0;for(let qe=0;qe<ge.length;qe++)$e=ge.charCodeAt(qe),i($e)&&Ce++,C($e)&&Ae++,c($e)&&_e++;return(Ce===0||Ae===0)&&_e===0?ge.length<=30:Ce<=5}function s(ge,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!n(ge)||Ce.length>60)return null;const Ae=u(Ce);if(!t(Ae)){if(!p(Ae))return null;Ce=Ce.toLowerCase()}let $e=null,_e=0;for(ge=ge.toLowerCase();_e<Ce.length&&($e=m(ge,Ce,0,_e))===null;)_e=_(Ce,_e+1);return $e}e.matchesCamelCase=s;function r(ge,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let $e=null,_e=0;for(ge=ge.toLowerCase(),Ce=Ce.toLowerCase();_e<Ce.length&&($e=l(ge,Ce,0,_e,Ae))===null;)_e=f(Ce,_e+1);return $e}e.matchesWords=r;function l(ge,Ce,Ae,$e,_e){if(Ae===ge.length)return[];if($e===Ce.length)return null;if(a(ge.charCodeAt(Ae),Ce.charCodeAt($e))){let qe=null,z=$e+1;if(qe=l(ge,Ce,Ae+1,$e+1,_e),!_e)for(;!qe&&(z=f(Ce,z))<Ce.length;)qe=l(ge,Ce,Ae+1,z,_e),z++;return qe===null?null:h({start:$e,end:$e+1},qe)}else return null}function f(ge,Ce){for(let Ae=Ce;Ae<ge.length;Ae++)if(o(ge.charCodeAt(Ae))||Ae>0&&o(ge.charCodeAt(Ae-1)))return Ae;return ge.length}const v=P(e.matchesPrefix,s,S),T=P(e.matchesPrefix,s,D),b=new w.LRUCache(1e4);function E(ge,Ce,Ae=!1){if(typeof ge!="string"||typeof Ce!="string")return null;let $e=b.get(ge);$e||($e=new RegExp(k.convertSimple2RegExpPattern(ge),"i"),b.set(ge,$e));const _e=$e.exec(Ce);return _e?[{start:_e.index,end:_e.index+_e[0].length}]:Ae?T(ge,Ce):v(ge,Ce)}e.matchesFuzzy=E;function F(ge,Ce){const Ae=x(ge,ge.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Ae?K(Ae):null}e.matchesFuzzy2=F;function L(ge,Ce,Ae,$e,_e,qe){const z=Math.min(13,ge.length);for(;Ae<z;Ae++){const te=x(ge,Ce,Ae,$e,_e,qe,!1);if(te)return te}return[0,qe]}e.anyScore=L;function K(ge){if(typeof ge=="undefined")return[];const Ce=[],Ae=ge[1];for(let $e=ge.length-1;$e>1;$e--){const _e=ge[$e]+Ae,qe=Ce[Ce.length-1];qe&&qe.end===_e?qe.end=_e+1:Ce.push({start:_e,end:_e+1})}return Ce}e.createMatches=K;const fe=128;function j(){const ge=[],Ce=[];for(let Ae=0;Ae<=fe;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=fe;Ae++)ge.push(Ce.slice(0));return ge}function H(ge){const Ce=[];for(let Ae=0;Ae<=ge;Ae++)Ce[Ae]=0;return Ce}const ee=H(2*fe),O=H(2*fe),R=j(),N=j(),$=j(),U=!1;function Q(ge,Ce,Ae,$e,_e){function qe(te,ve,Ue=" "){for(;te.length<ve;)te=Ue+te;return te}let z=` |   |${$e.split("").map(te=>qe(te,3)).join("|")}
`;for(let te=0;te<=Ae;te++)te===0?z+=" |":z+=`${Ce[te-1]}|`,z+=ge[te].slice(0,_e+1).map(ve=>qe(ve.toString(),3)).join("|")+`
`;return z}function Y(ge,Ce,Ae,$e){ge=ge.substr(Ce),Ae=Ae.substr($e),console.log(Q(N,ge,ge.length,Ae,Ae.length)),console.log(Q($,ge,ge.length,Ae,Ae.length)),console.log(Q(R,ge,ge.length,Ae,Ae.length))}function ie(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;const Ae=ge.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(Ae)}}function pe(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;switch(ge.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Pe(ge,Ce,Ae){return Ce[ge]!==Ae[ge]}function Oe(ge,Ce,Ae,$e,_e,qe,z=!1){for(;Ce<Ae&&_e<qe;)ge[Ce]===$e[_e]&&(z&&(ee[Ce]=_e),Ce+=1),_e+=1;return Ce===Ae}e.isPatternInWord=Oe;var Te;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Te||(Te={}));var Be;(function(ge){ge.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}ge.isDefault=Ce})(Be=e.FuzzyScore||(e.FuzzyScore={}));function x(ge,Ce,Ae,$e,_e,qe,z){const te=ge.length>fe?fe:ge.length,ve=$e.length>fe?fe:$e.length;if(!(Ae>=te||qe>=ve||te-Ae>ve-qe)&&!!Oe(Ce,Ae,te,_e,qe,ve,!0)){G(te,ve,Ae,qe,Ce,_e);let Ue=1,He=1,xe=Ae,Ye=qe;const W=[!1];for(Ue=1,xe=Ae;xe<te;Ue++,xe++){const le=ee[xe],he=O[xe],Ee=xe+1<te?O[xe+1]:ve;for(He=le-qe+1,Ye=le;Ye<Ee;He++,Ye++){let Ve=Number.MIN_SAFE_INTEGER,Fe=!1;Ye<=he&&(Ve=re(ge,Ce,xe,Ae,$e,_e,Ye,ve,qe,R[Ue-1][He-1]===0,W));let We=0;Ve!==Number.MAX_SAFE_INTEGER&&(Fe=!0,We=Ve+N[Ue-1][He-1]);const Qe=Ye>le,it=Qe?N[Ue][He-1]+(R[Ue][He-1]>0?-5:0):0,lt=Ye>le+1&&R[Ue][He-1]>0,Ze=lt?N[Ue][He-2]+(R[Ue][He-2]>0?-5:0):0;if(lt&&(!Qe||Ze>=it)&&(!Fe||Ze>=We))N[Ue][He]=Ze,$[Ue][He]=3,R[Ue][He]=0;else if(Qe&&(!Fe||it>=We))N[Ue][He]=it,$[Ue][He]=2,R[Ue][He]=0;else if(Fe)N[Ue][He]=We,$[Ue][He]=1,R[Ue][He]=R[Ue-1][He-1]+1;else throw new Error("not possible")}}if(U&&Y(ge,Ae,$e,qe),!(!W[0]&&!z)){Ue--,He--;const se=[N[Ue][He],qe];let de=0,q=0;for(;Ue>=1;){let le=He;do{const he=$[Ue][le];if(he===3)le=le-2;else if(he===2)le=le-1;else break}while(le>=1);de>1&&Ce[Ae+Ue-1]===_e[qe+He-1]&&!Pe(le+qe-1,$e,_e)&&de+1>R[Ue][le]&&(le=He),le===He?de++:de=1,q||(q=le),Ue--,He=le-1,se.push(He)}ve===te&&(se[0]+=2);const Z=q-te;return se[0]-=Z,se}}}e.fuzzyScore=x;function G(ge,Ce,Ae,$e,_e,qe){let z=ge-1,te=Ce-1;for(;z>=Ae&&te>=$e;)_e[z]===qe[te]&&(O[z]=te,z--),te--}function re(ge,Ce,Ae,$e,_e,qe,z,te,ve,Ue,He){if(Ce[Ae]!==qe[z])return Number.MIN_SAFE_INTEGER;let xe=1,Ye=!1;return z===Ae-$e?xe=ge[Ae]===_e[z]?7:5:Pe(z,_e,qe)&&(z===0||!Pe(z-1,_e,qe))?(xe=ge[Ae]===_e[z]?7:5,Ye=!0):ie(qe,z)&&(z===0||!ie(qe,z-1))?xe=5:(ie(qe,z-1)||pe(qe,z-1))&&(xe=5,Ye=!0),xe>1&&Ae===$e&&(He[0]=!0),Ye||(Ye=Pe(z,_e,qe)||ie(qe,z-1)||pe(qe,z-1)),Ae===$e?z>ve&&(xe-=Ye?3:5):Ue?xe+=Ye?2:0:xe+=Ye?0:1,z+1===te&&(xe-=Ye?3:5),xe}function oe(ge,Ce,Ae,$e,_e,qe,z){return De(ge,Ce,Ae,$e,_e,qe,!0,z)}e.fuzzyScoreGracefulAggressive=oe;function me(ge,Ce,Ae,$e,_e,qe,z){return De(ge,Ce,Ae,$e,_e,qe,!1,z)}e.fuzzyScoreGraceful=me;function De(ge,Ce,Ae,$e,_e,qe,z,te){let ve=x(ge,Ce,Ae,$e,_e,qe,te);if(ve&&!z)return ve;if(ge.length>=3){const Ue=Math.min(7,ge.length-1);for(let He=Ae+1;He<Ue;He++){const xe=Ne(ge,He);if(xe){const Ye=x(xe,xe.toLowerCase(),Ae,$e,_e,qe,te);Ye&&(Ye[0]-=3,(!ve||Ye[0]>ve[0])&&(ve=Ye))}}}return ve}function Ne(ge,Ce){if(!(Ce+1>=ge.length)){const Ae=ge[Ce],$e=ge[Ce+1];if(Ae!==$e)return ge.slice(0,Ce)+$e+Ae+ge.slice(Ce+2)}}}),define(be[110],we([0,1,36,109,8]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${A.source}`,"g");function D(a){return a.replace(S,(g,h)=>h?g:`\\${g}`)}e.escapeIcons=D;const y=new RegExp(`\\\\${A.source}`,"g");function C(a){return a.replace(y,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=C;const i=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function I(a){return a.indexOf(e.iconStartMarker)===-1?a:a.replace(i,(g,h,_,m)=>_?g:h||m||"")}e.stripIcons=I;function c(a){const g=a.indexOf(e.iconStartMarker);return g===-1?{text:a}:d(a,g)}e.parseLabelWithIcons=c;function d(a,g){const h=[];let _="";function m(f){if(f){_+=f;for(const v of f)h.push(t)}}let u=-1,p="",t=0,n,s,r=g;const l=a.length;for(m(a.substr(0,g));r<l;)n=a[r],s=a[r+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(u=r,m(p),p=e.iconStartMarker,r++):n===")"&&u!==-1?(t+=r-u+1,u=-1,p=""):u!==-1?/^[a-z0-9\-]$/i.test(n)?p+=n:(m(p),u=-1,p=""):m(n),r++;return m(p),{text:_,iconOffsets:h}}function o(a,g,h=!1){const{text:_,iconOffsets:m}=g;if(!m||m.length===0)return(0,k.matchesFuzzy)(a,_,h);const u=(0,P.ltrim)(_," "),p=_.length-u.length,t=(0,k.matchesFuzzy)(a,u,h);if(t)for(const n of t){const s=m[n.start+p]+p;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=o}),define(be[83],we([0,1,13,110,12]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(a="",g=!1){var h,_;if(this.value=a,typeof this.value!="string")throw(0,P.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1):(this.isTrusted=(h=g.isTrusted)!==null&&h!==void 0?h:void 0,this.supportThemeIcons=(_=g.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(a,g=0){return this.value+=I(this.supportThemeIcons?(0,k.escapeIcons)(a):a).replace(/([ \t]+)/g,(h,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,g){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}}e.MarkdownString=S;function D(o){return y(o)?!o.value:Array.isArray(o)?o.every(D):!0}e.isEmptyMarkdownString=D;function y(o){return o instanceof S?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function C(o,a){return!o&&!a?!0:!o||!a?!1:Array.isArray(o)&&Array.isArray(a)?(0,w.equals)(o,a,i):y(o)&&y(a)?i(o,a):!1}e.markedStringsEquals=C;function i(o,a){return o===a?!0:!o||!a?!1:o.value===a.value&&o.isTrusted===a.isTrusted&&o.supportThemeIcons===a.supportThemeIcons}function I(o){return o.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function c(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=c;function d(o){const a=[],g=o.split("|").map(_=>_.trim());o=g[0];const h=g[1];if(h){const _=/height=(\d+)/.exec(h),m=/width=(\d+)/.exec(h),u=_?_[1]:"",p=m?m[1]:"",t=isFinite(parseInt(p)),n=isFinite(parseInt(u));t&&a.push(`width="${p}"`),n&&a.push(`height="${u}"`)}return{href:o,dimensions:a}}e.parseHrefAndDimensions=d}),define(be[57],we([0,1,23,8,2]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(C){return JSON.stringify(C,D)}e.stringify=A;function S(C){let i=JSON.parse(C);return i=y(i),i}e.parse=S;function D(C,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,k.regExpFlags)(i)}:i}function y(C,i=0){if(!C||i>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return P.URI.revive(C);case 2:return new RegExp(C.source,C.flags)}if(C instanceof w.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let I=0;I<C.length;++I)C[I]=y(C[I],i+1);else for(const I in C)Object.hasOwnProperty.call(C,I)&&(C[I]=y(C[I],i+1))}return C}e.revive=y}),define(be[18],we([0,1,2,21]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var P;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file"})(P=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,C,i){this._hosts[y]=C,this._ports[y]=i}setConnectionToken(y,C){this._connectionTokens[y]=C}rewrite(y){if(this._delegate)return this._delegate(y);const C=y.authority;let i=this._hosts[C];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[C],c=this._connectionTokens[C];let d=`path=${encodeURIComponent(y.path)}`;return typeof c=="string"&&(d+=`&tkn=${encodeURIComponent(c)}`),w.URI.from({scheme:k.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new A;class S{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,C,i){const I=this.toUri(y,C);return I.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(I):k.isNative&&(i||k.isPreferringBrowserCodeLoad)&&I.scheme===P.file?I.with({scheme:P.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(y,C){const i=this.toUri(y,C);return i.scheme===P.vscodeFileResource?i.with({scheme:P.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(y,C){return w.URI.isUri(y)?y:w.URI.parse(C.toUrl(y))}}e.FileAccess=new S}),define(be[25],we([0,1,37,14,2,8,18,21]),function(J,e,w,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(d){return(0,P.uriToFsPath)(d,!0)}e.originalFSPath=y;class C{constructor(o){this._ignorePathCasing=o}compare(o,a,g=!1){return o===a?0:(0,A.compare)(this.getComparisonKey(o,g),this.getComparisonKey(a,g))}isEqual(o,a,g=!1){return o===a?!0:!o||!a?!1:this.getComparisonKey(o,g)===this.getComparisonKey(a,g)}getComparisonKey(o,a=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,a,g=!1){if(o.scheme===a.scheme){if(o.scheme===S.Schemas.file)return w.isEqualOrParent(y(o),y(a),this._ignorePathCasing(o))&&o.query===a.query&&(g||o.fragment===a.fragment);if((0,e.isEqualAuthority)(o.authority,a.authority))return w.isEqualOrParent(o.path,a.path,this._ignorePathCasing(o),"/")&&o.query===a.query&&(g||o.fragment===a.fragment)}return!1}joinPath(o,...a){return P.URI.joinPath(o,...a)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return k.posix.basename(o.path)}extname(o){return k.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let a;return o.scheme===S.Schemas.file?a=P.URI.file(k.dirname(y(o))).path:(a=k.posix.dirname(o.path),o.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),a="/")),o.with({path:a})}normalizePath(o){if(!o.path.length)return o;let a;return o.scheme===S.Schemas.file?a=P.URI.file(k.normalize(y(o))).path:a=k.posix.normalize(o.path),o.with({path:a})}relativePath(o,a){if(!(o.scheme!==a.scheme||!(0,e.isEqualAuthority)(o.authority,a.authority))){if(o.scheme===S.Schemas.file){const _=k.relative(y(o),y(a));return D.isWindows?w.toSlashes(_):_}let g=o.path||"/",h=a.path||"/";if(this._ignorePathCasing(o)){let _=0;for(const m=Math.min(g.length,h.length);_<m&&!(g.charCodeAt(_)!==h.charCodeAt(_)&&g.charAt(_).toLowerCase()!==h.charAt(_).toLowerCase());_++);g=h.substr(0,_)+g.substr(_)}return k.posix.relative(g,h)}}resolvePath(o,a){if(o.scheme===S.Schemas.file){const g=P.URI.file(k.resolve(y(o),a));return o.with({authority:g.authority,path:g.path})}return a.indexOf("/")===-1&&(a=w.toSlashes(a),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a)),o.with({path:k.posix.resolve(o.path,a)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,a){return o===a||(0,A.equalsIgnoreCase)(o,a)}hasTrailingPathSeparator(o,a=k.sep){if(o.scheme===S.Schemas.file){const g=y(o);return g.length>w.getRoot(g).length&&g[g.length-1]===a}else{const g=o.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,a=k.sep){return(0,e.hasTrailingPathSeparator)(o,a)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,a=k.sep){let g=!1;if(o.scheme===S.Schemas.file){const h=y(o);g=h!==void 0&&h.length===w.getRoot(h).length&&h[h.length-1]===a}else{a="/";const h=o.path;g=h.length===1&&h.charCodeAt(h.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(o,a)?o.with({path:o.path+"/"}):o}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(d=>d.scheme===S.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new C(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(d,o){const a=[];for(let g=0;g<d.length;g++){const h=o(d[g]);d.some((_,m)=>m===g?!1:(0,e.isEqualOrParent)(h,o(_)))||a.push(d[g])}return a}e.distinctParents=i;var I;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function o(a){const g=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(m=>{const[u,p]=m.split(":");u&&p&&g.set(u,p)});const _=a.path.substring(0,a.path.indexOf(";"));return _&&g.set(d.META_DATA_MIME,_),g}d.parseMetaData=o})(I=e.DataUri||(e.DataUri={}));function c(d,o,a){if(o){let g=d.path;return g&&g[0]!==k.posix.sep&&(g=k.posix.sep+g),d.with({scheme:a,authority:o,path:g})}return d.with({scheme:a})}e.toLocalResource=c}),define(be[11],we([0,1,20,12,3,6,45,25]),function(J,e,w,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(N){return!!N&&typeof N.then=="function"}e.isThenable=y;function C(N){const $=new w.CancellationTokenSource,U=N($.token),Q=new Promise((Y,ie)=>{$.token.onCancellationRequested(()=>{ie((0,k.canceled)())}),Promise.resolve(U).then(pe=>{$.dispose(),Y(pe)},pe=>{$.dispose(),ie(pe)})});return new class{cancel(){$.cancel()}then(Y,ie){return Q.then(Y,ie)}catch(Y){return this.then(void 0,Y)}finally(Y){return Q.finally(Y)}}}e.createCancelablePromise=C;function i(N,$,U){return Promise.race([N,new Promise(Q=>$.onCancellationRequested(()=>Q(U)))])}e.raceCancellation=i;async function I(N){let $=-1;const U=N.map((Y,ie)=>Y.then(pe=>($=ie,pe))),Q=await Promise.race(U);return N.forEach((Y,ie)=>{ie!==$&&Y.cancel()}),Q}e.raceCancellablePromises=I;function c(N,$,U){let Q;const Y=setTimeout(()=>{Q==null||Q(void 0),U==null||U()},$);return Promise.race([N.finally(()=>clearTimeout(Y)),new Promise(ie=>Q=ie)])}e.raceTimeout=c;function d(N){return new Promise(($,U)=>{const Q=N();y(Q)?Q.then($,U):$(Q)})}e.asPromise=d;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const Q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Q};this.queuedPromise=new Promise(Q=>{this.activePromise.then(U,U).then(Q)})}return new Promise((U,Q)=>{this.queuedPromise.then(U,Q)})}return this.activePromise=$(),new Promise((U,Q)=>{this.activePromise.then(Y=>{this.activePromise=null,U(Y)},Y=>{this.activePromise=null,Q(Y)})})}}e.Throttler=o;class a{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=a;class g{constructor(){this.promiseMap=new Map}queue($,U){var Q;const ie=((Q=this.promiseMap.get($))!==null&&Q!==void 0?Q:Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get($)===ie&&this.promiseMap.delete($)});return this.promiseMap.set($,ie),ie}}e.SequencerByKey=g;class h{constructor($){this.defaultDelay=$,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,U=this.defaultDelay){return this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Q,Y)=>{this.doResolve=Q,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Q=this.task;return this.task=null,Q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=h;class _{constructor($){this.delayer=new h($),this.throttler=new o}trigger($,U){return this.delayer.trigger(()=>this.throttler.queue($),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class m{constructor(){this._isOpen=!1,this._promise=new Promise(($,U)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class u extends m{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function p(N,$){return $?new Promise((U,Q)=>{const Y=setTimeout(U,N);$.onCancellationRequested(()=>{clearTimeout(Y),Q((0,k.canceled)())})}):C(U=>p(N,U))}e.timeout=p;function t(N,$=0){const U=setTimeout(N,$);return(0,A.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=t;function n(N){return N.then(void 0,$=>{})}e.ignoreErrors=n;function s(N){const $=[];let U=0;const Q=N.length;function Y(){return U<Q?N[U++]():null}function ie(pe){pe!=null&&$.push(pe);const Pe=Y();return Pe?Pe.then(ie):Promise.resolve($)}return Promise.resolve(null).then(ie)}e.sequence=s;function r(N,$=Q=>!!Q,U=null){let Q=0;const Y=N.length,ie=()=>{if(Q>=Y)return Promise.resolve(U);const pe=N[Q++];return Promise.resolve(pe()).then(Oe=>$(Oe)?Promise.resolve(Oe):ie())};return ie()}e.first=r;function l(N,$=Q=>!!Q,U=null){if(N.length===0)return Promise.resolve(U);let Q=N.length;const Y=()=>{var ie,pe;Q=-1;for(const Pe of N)(pe=(ie=Pe).cancel)===null||pe===void 0||pe.call(ie)};return new Promise((ie,pe)=>{for(const Pe of N)Pe.then(Oe=>{--Q>=0&&$(Oe)?(Y(),ie(Oe)):Q===0&&ie(U)}).catch(Oe=>{--Q>=0&&(Y(),pe(Oe))})})}e.firstParallel=l;class f{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new P.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((U,Q)=>{this.outstandingPromises.push({factory:$,c:U,e:Q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const U=$.factory();U.then($.c,$.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class v extends f{constructor(){super(1)}}e.Queue=v;class T{constructor(){this.queues=new Map}queueFor($,U=D.extUri){const Q=U.getComparisonKey($);let Y=this.queues.get(Q);return Y||(Y=new v,P.Event.once(Y.onFinished)(()=>{Y==null||Y.dispose(),this.queues.delete(Q)}),this.queues.set(Q,Y)),Y}dispose(){this.queues.forEach($=>$.dispose()),this.queues.clear()}}e.ResourceQueue=T;class b{constructor($,U){this._token=-1,typeof $=="function"&&typeof U=="number"&&this.setIfNotSet($,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},U)}setIfNotSet($,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},U))}}e.TimeoutTimer=b;class E{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,U){this.cancel(),this._token=setInterval(()=>{$()},U)}}e.IntervalTimer=E;class F{constructor($,U){this.timeoutToken=-1,this.runner=$,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class L extends F{constructor($,U){super($,U);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=$=>{const U=setTimeout(()=>$(N));let Q=!1;return{dispose(){Q||(Q=!0,clearTimeout(U))}}}}else e.runWhenIdle=(N,$)=>{const U=requestIdleCallback(N,typeof $=="number"?{timeout:$}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,cancelIdleCallback(U))}}}}();class K{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=K;async function fe(N,$,U){let Q;for(let Y=0;Y<U;Y++)try{return await N()}catch(ie){Q=ie,await p($)}throw Q}e.retry=fe;class j{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var $;($=this._pending)===null||$===void 0||$.cancel()}setPending($,U,Q){return this._pending={taskId:$,cancel:()=>Q==null?void 0:Q(),promise:U},U.then(()=>this.donePending($),()=>this.donePending($)),U}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let U,Q;const Y=new Promise((ie,pe)=>{U=ie,Q=pe});this._next={run:$,promise:Y,promiseResolve:U,promiseReject:Q}}return this._next.promise}}e.TaskSequentializer=j;class H{constructor($){this.interval=$,this.lastIncrementTime=0,this.value=0}increment(){const $=Date.now();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class ee{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,U)=>{this.completeCallback=$,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(U=>{this.completeCallback($),this.resolved=!0,U()})}error($){return new Promise(U=>{this.errorCallback($),this.rejected=!0,U()})}cancel(){new Promise($=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,$()})}}e.DeferredPromise=ee;class O extends P.Emitter{async fireAsync($,U,Q){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const Y of this._listeners)this._asyncDeliveryQueue.push([Y,$]);for(;this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[Y,ie]=this._asyncDeliveryQueue.shift(),pe=[],Pe=Object.assign(Object.assign({},ie),{waitUntil:Oe=>{if(Object.isFrozen(pe))throw new Error("waitUntil can NOT be called asynchronous");Q&&(Oe=Q(Oe,typeof Y=="function"?Y:Y[0])),pe.push(Oe)}});try{typeof Y=="function"?Y.call(void 0,Pe):Y[0].call(Y[1],Pe)}catch(Oe){(0,k.onUnexpectedError)(Oe);continue}Object.freeze(pe),await R.settled(pe).catch(Oe=>(0,k.onUnexpectedError)(Oe))}}}}e.AsyncEmitter=O;var R;(function(N){async function $(ie){return typeof Promise.allSettled=="function"?U(ie):Q(ie)}N.allSettled=$;async function U(ie){return Promise.allSettled(ie)}async function Q(ie){return Promise.all(ie.map(pe=>pe.then(Pe=>({status:"fulfilled",value:Pe}),Pe=>({status:"rejected",reason:Pe}))))}async function Y(ie){let pe;const Pe=await Promise.all(ie.map(Oe=>Oe.then(Te=>Te,Te=>{pe||(pe=Te)})));if(typeof pe!="undefined")throw pe;return Pe}N.settled=Y})(R=e.Promises||(e.Promises={}))}),define(be[111],we([0,1,14,11]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const P=new k.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),A=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(u,p,t=!1){const n=u||"",s=p||"",r=P.value.collator.compare(n,s);return P.value.collatorIsNumeric&&r===0&&n!==s?n<s?-1:1:r}e.compareFileNames=D;function y(u,p){const t=A.value.collator;return u=u||"",p=p||"",a(t,u,p)}e.compareFileNamesDefault=y;function C(u,p,t=!1){t||(u=u&&u.toLowerCase(),p=p&&p.toLowerCase());const[n,s]=d(u),[r,l]=d(p);return n!==r?n<r?-1:1:s===l?0:s<l?-1:1}e.noIntlCompareFileNames=C;function i(u,p){const[t,n]=d(u),[s,r]=d(p);let l=P.value.collator.compare(n,r);if(l===0){if(P.value.collatorIsNumeric&&n!==r)return n<r?-1:1;if(l=P.value.collator.compare(t,s),P.value.collatorIsNumeric&&l===0&&t!==s)return t<s?-1:1}return l}e.compareFileExtensions=i;function I(u,p){u=u||"",p=p||"";const t=o(u),n=o(p),s=A.value.collator,r=S.value.collator;let l;return l=a(r,t,n),l!==0?l:a(s,u,p)}e.compareFileExtensionsDefault=I;const c=/^(.*?)(\.([^.]*))?$/;function d(u,p=!1){const t=u?c.exec(u):[];let n=[t&&t[1]||"",t&&t[3]||""];return p&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function o(u){const p=u?c.exec(u):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function a(u,p,t){let n=u.compare(p,t);return n!==0?n:p.length!==t.length?p.length<t.length?-1:1:0}function g(u,p,t=!1){return t||(u=u&&u.toLowerCase(),p=p&&p.toLowerCase()),u===p?0:u<p?-1:1}function h(u,p,t=!1){const n=u.split(w.sep),s=p.split(w.sep),r=n.length-1,l=s.length-1;let f,v;for(let T=0;;T++){if(f=r===T,v=l===T,f&&v)return D(n[T],s[T],t);if(f)return-1;if(v)return 1;const b=g(n[T],s[T],t);if(b!==0)return b}}e.comparePaths=h;function _(u,p,t){const n=u.toLowerCase(),s=p.toLowerCase(),r=m(u,p,t);if(r)return r;const l=n.endsWith(t),f=s.endsWith(t);if(l!==f)return l?-1:1;const v=D(n,s);return v!==0?v:n.localeCompare(s)}e.compareAnything=_;function m(u,p,t){const n=u.toLowerCase(),s=p.toLowerCase(),r=n.startsWith(t),l=s.startsWith(t);if(r!==l)return r?-1:1;if(r&&l){if(n.length<s.length)return-1;if(n.length>s.length)return 1}return 0}e.compareByPrefix=m}),define(be[28],we([0,1,8,37,14,22,11]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const y="**",C="/",i="[/\\\\]",I="[^/\\\\]",c=/\//g;function d(U){switch(U){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function o(U,Q){if(!U)return[];const Y=[];let ie=!1,pe=!1,Pe="";for(const Oe of U){switch(Oe){case Q:if(!ie&&!pe){Y.push(Pe),Pe="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}Pe+=Oe}return Pe&&Y.push(Pe),Y}e.splitGlobAware=o;function a(U){if(!U)return"";let Q="";const Y=o(U,C);if(Y.every(ie=>ie===y))Q=".*";else{let ie=!1;Y.forEach((pe,Pe)=>{if(pe===y){ie||(Q+=d(2),ie=!0);return}let Oe=!1,Te="",Be=!1,x="";for(const G of pe){if(G!=="}"&&Oe){Te+=G;continue}if(Be&&(G!=="]"||!x)){let re;G==="-"?re=G:(G==="^"||G==="!")&&!x?re="^":G===C?re="":re=w.escapeRegExpCharacters(G),x+=re;continue}switch(G){case"{":Oe=!0;continue;case"[":Be=!0;continue;case"}":Q+=`(?:${o(Te,",").map(me=>a(me)).join("|")})`,Oe=!1,Te="";break;case"]":Q+="["+x+"]",Be=!1,x="";break;case"?":Q+=I;continue;case"*":Q+=d(1);continue;default:Q+=w.escapeRegExpCharacters(G)}}Pe<Y.length-1&&(Y[Pe+1]!==y||Pe+2<Y.length)&&(Q+=i),ie=!1})}return Q}const g=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,m=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),n=function(){return!1},s=function(){return null};function r(U,Q){if(!U)return s;let Y;typeof U!="string"?Y=U.pattern:Y=U,Y=Y.trim();const ie=`${Y}_${!!Q.trimForExclusions}`;let pe=t.get(ie);if(pe)return l(pe,U);let Pe;if(g.test(Y)){const Oe=Y.substr(4);pe=function(Te,Be){return typeof Te=="string"&&Te.endsWith(Oe)?Y:null}}else(Pe=h.exec(f(Y,Q)))?pe=v(Pe[1],Y):(Q.trimForExclusions?m:_).test(Y)?pe=T(Y,Q):(Pe=u.exec(f(Y,Q)))?pe=b(Pe[1].substr(1),Y,!0):(Pe=p.exec(f(Y,Q)))?pe=b(Pe[1],Y,!1):pe=E(Y);return t.set(ie,pe),l(pe,U)}function l(U,Q){return typeof Q=="string"?U:function(Y,ie){return k.isEqualOrParent(Y,Q.base)?U(P.relative(Q.base,Y),ie):null}}function f(U,Q){return Q.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function v(U,Q){const Y=`/${U}`,ie=`\\${U}`,pe=function(Oe,Te){return typeof Oe!="string"?null:Te?Te===U?Q:null:Oe===U||Oe.endsWith(Y)||Oe.endsWith(ie)?Q:null},Pe=[U];return pe.basenames=Pe,pe.patterns=[Q],pe.allBasenames=Pe,pe}function T(U,Q){const Y=$(U.slice(1,-1).split(",").map(Te=>r(Te,Q)).filter(Te=>Te!==s),U),ie=Y.length;if(!ie)return s;if(ie===1)return Y[0];const pe=function(Te,Be){for(let x=0,G=Y.length;x<G;x++)if(Y[x](Te,Be))return U;return null},Pe=Y.find(Te=>!!Te.allBasenames);Pe&&(pe.allBasenames=Pe.allBasenames);const Oe=Y.reduce((Te,Be)=>Be.allPaths?Te.concat(Be.allPaths):Te,[]);return Oe.length&&(pe.allPaths=Oe),pe}function b(U,Q,Y){const ie=P.sep===P.posix.sep,pe=ie?U:U.replace(c,P.sep),Pe=P.sep+pe,Oe=P.posix.sep+U,Te=Y?function(Be,x){return typeof Be=="string"&&(Be===pe||Be.endsWith(Pe)||!ie&&(Be===U||Be.endsWith(Oe)))?Q:null}:function(Be,x){return typeof Be=="string"&&(Be===pe||!ie&&Be===U)?Q:null};return Te.allPaths=[(Y?"*/":"./")+U],Te}function E(U){try{const Q=new RegExp(`^${a(U)}$`);return function(Y){return Q.lastIndex=0,typeof Y=="string"&&Q.test(Y)?U:null}}catch(Q){return s}}function F(U,Q,Y){return!U||typeof Q!="string"?!1:L(U)(Q,void 0,Y)}e.match=F;function L(U,Q={}){if(!U)return n;if(typeof U=="string"||H(U)){const Y=r(U,Q);if(Y===s)return n;const ie=function(pe,Pe){return!!Y(pe,Pe)};return Y.allBasenames&&(ie.allBasenames=Y.allBasenames),Y.allPaths&&(ie.allPaths=Y.allPaths),ie}return R(U,Q)}e.parse=L;function K(U){if(!!U){let Q;return Y=>(Q||(Q=(U()||Promise.resolve([])).then(ie=>ie?j(ie):{})),Q.then(ie=>!!ie[Y]))}}e.hasSiblingPromiseFn=K;function fe(U){if(!!U){let Q;return Y=>{if(!Q){const ie=U();Q=ie?j(ie):{}}return!!Q[Y]}}}e.hasSiblingFn=fe;function j(U){const Q={};for(const Y of U)Q[Y]=!0;return Q}function H(U){const Q=U;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=H;function ee(U){return U.allBasenames||[]}e.getBasenameTerms=ee;function O(U){return U.allPaths||[]}e.getPathTerms=O;function R(U,Q){const Y=$(Object.getOwnPropertyNames(U).map(Te=>N(Te,U[Te],Q)).filter(Te=>Te!==s)),ie=Y.length;if(!ie)return s;if(!Y.some(Te=>!!Te.requiresSiblings)){if(ie===1)return Y[0];const Te=function(G,re){for(let oe=0,me=Y.length;oe<me;oe++){const De=Y[oe](G,re);if(De)return De}return null},Be=Y.find(G=>!!G.allBasenames);Be&&(Te.allBasenames=Be.allBasenames);const x=Y.reduce((G,re)=>re.allPaths?G.concat(re.allPaths):G,[]);return x.length&&(Te.allPaths=x),Te}const pe=function(Te,Be,x){let G;for(let re=0,oe=Y.length;re<oe;re++){const me=Y[re];me.requiresSiblings&&x&&(Be||(Be=P.basename(Te)),G||(G=Be.substr(0,Be.length-P.extname(Te).length)));const De=me(Te,Be,G,x);if(De)return De}return null},Pe=Y.find(Te=>!!Te.allBasenames);Pe&&(pe.allBasenames=Pe.allBasenames);const Oe=Y.reduce((Te,Be)=>Be.allPaths?Te.concat(Be.allPaths):Te,[]);return Oe.length&&(pe.allPaths=Oe),pe}function N(U,Q,Y){if(Q===!1)return s;const ie=r(U,Y);if(ie===s)return s;if(typeof Q=="boolean")return ie;if(Q){const pe=Q.when;if(typeof pe=="string"){const Pe=(Oe,Te,Be,x)=>{if(!x||!ie(Oe,Te))return null;const G=pe.replace("$(basename)",Be),re=x(G);return(0,S.isThenable)(re)?re.then(oe=>oe?U:null):re?U:null};return Pe.requiresSiblings=!0,Pe}}return ie}function $(U,Q){const Y=U.filter(Te=>!!Te.basenames);if(Y.length<2)return U;const ie=Y.reduce((Te,Be)=>{const x=Be.basenames;return x?Te.concat(x):Te},[]);let pe;if(Q){pe=[];for(let Te=0,Be=ie.length;Te<Be;Te++)pe.push(Q)}else pe=Y.reduce((Te,Be)=>{const x=Be.patterns;return x?Te.concat(x):Te},[]);const Pe=function(Te,Be){if(typeof Te!="string")return null;if(!Be){let G;for(G=Te.length;G>0;G--){const re=Te.charCodeAt(G-1);if(re===47||re===92)break}Be=Te.substr(G)}const x=ie.indexOf(Be);return x!==-1?pe[x]:null};Pe.basenames=ie,Pe.patterns=pe,Pe.allBasenames=ie;const Oe=U.filter(Te=>!Te.basenames);return Oe.push(Pe),Oe}}),define(be[58],we([0,1,2,14,8,18,21,25,37]),function(J,e,w,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(r,l,f){if(typeof r=="string"&&(r=w.URI.file(r)),f){const T=f.getWorkspaceFolder(r);if(T){const b=f.getWorkspace().folders.length>1;let E;if((0,D.isEqual)(T.uri,r)?E="":E=(0,D.relativePath)(T.uri,r),b){const F=T.name?T.name:(0,D.basename)(T.uri);E=E?F+" \u2022 "+E:F}return E}}if(r.scheme!==A.Schemas.file&&r.scheme!==A.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(r.fsPath))return(0,k.normalize)(I(r.fsPath));let v=(0,k.normalize)(r.fsPath);return!S.isWindows&&(l==null?void 0:l.userHome)&&(v=d(v,l.userHome.fsPath)),v}e.getPathLabel=C;function i(r){if(!!r){typeof r=="string"&&(r=w.URI.file(r));const l=(0,D.basename)(r)||(r.scheme===A.Schemas.file?r.fsPath:r.path);return S.isWindows&&(0,y.isRootOrDriveLetter)(l)?I(l):l}}e.getBaseLabel=i;function I(r){return(0,y.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=I;let c=Object.create(null);function d(r,l){if(S.isWindows||!r||!l)return r;let f=c.original===l?c.normalized:void 0;return f||(f=`${(0,P.rtrim)(l,k.posix.sep)}${k.posix.sep}`,c={original:l,normalized:f}),(S.isLinux?r.startsWith(f):(0,P.startsWithIgnoreCase)(r,f))&&(r=`~/${r.substr(f.length)}`),r}e.tildify=d;function o(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=o;const a="\u2026",g="\\\\",h="~";function _(r,l=k.sep){const f=new Array(r.length);let v=!1;for(let T=0;T<r.length;T++){let b=r[T];if(b===""){f[T]=`.${l}`;continue}if(!b){f[T]=b;continue}v=!0;let E="";b.indexOf(g)===0?(E=b.substr(0,b.indexOf(g)+g.length),b=b.substr(b.indexOf(g)+g.length)):b.indexOf(l)===0?(E=b.substr(0,b.indexOf(l)+l.length),b=b.substr(b.indexOf(l)+l.length)):b.indexOf(h)===0&&(E=b.substr(0,b.indexOf(h)+h.length),b=b.substr(b.indexOf(h)+h.length));const F=b.split(l);for(let L=1;v&&L<=F.length;L++)for(let K=F.length-L;v&&K>=0;K--){v=!1;let fe=F.slice(K,K+L).join(l);for(let j=0;!v&&j<r.length;j++)if(j!==T&&r[j]&&r[j].indexOf(fe)>-1){const H=K+L===F.length,ee=K>0&&r[j].indexOf(l)>-1?l+fe:fe,O=r[j].endsWith(ee);v=!H||O}if(!v){let j="";(F[0].endsWith(":")||E!=="")&&(K===1&&(K=0,L++,fe=F[0]+l+fe),K>0&&(j=F[0]+l),j=E+j),K>0&&(j=j+a+l),j=j+fe,K+L<F.length&&(j=j+l+a),f[T]=j}}v&&(f[T]=b)}return f}e.shorten=_;var m;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function u(r,l=Object.create(null)){const f=[];let v=!1,T="";for(const b of r)if(b==="$"||v&&b==="{")T&&f.push({value:T,type:m.TEXT}),T="",v=!0;else if(b==="}"&&v){const E=l[T];if(typeof E=="string")E.length&&f.push({value:E,type:m.VARIABLE});else if(E){const F=f[f.length-1];(!F||F.type!==m.SEPARATOR)&&f.push({value:E.label,type:m.SEPARATOR})}T="",v=!1}else T+=b;return T&&!v&&f.push({value:T,type:m.TEXT}),f.filter((b,E)=>{if(b.type===m.SEPARATOR){const F=f[E-1],L=f[E+1];return[F,L].every(K=>K&&(K.type===m.VARIABLE||K.type===m.TEXT)&&K.value.length>0)}return!0}).map(b=>b.value).join("")}e.template=u;function p(r,l){return S.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):r.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(r,l){return S.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):S.isWindows?r.replace(/&&|&/g,f=>f==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(r){const l=r.indexOf("/")!==-1?k.posix:k.win32,f=l.basename(r),v=l.dirname(r);return f.length?{name:f,parentPath:v}:{name:v,parentPath:""}}e.splitName=s}),define(be[112],we([0,1,2]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(i){return i.toJSON()}class P{constructor(I){this._uriTransformer=I}transformIncoming(I){const c=this._uriTransformer.transformIncoming(I);return c===I?I:k(w.URI.from(c))}transformOutgoing(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:k(w.URI.from(c))}transformOutgoingURI(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:w.URI.from(c)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function A(i,I,c){if(!i||c>200)return null;if(typeof i=="object"){if(i instanceof w.URI)return I.transformOutgoing(i);for(let d in i)if(Object.hasOwnProperty.call(i,d)){const o=A(i[d],I,c+1);o!==null&&(i[d]=o)}}return null}function S(i,I){const c=A(i,I,0);return c===null?i:c}e.transformOutgoingURIs=S;function D(i,I,c,d){if(!i||d>200)return null;if(typeof i=="object"){if(i.$mid===1)return c?w.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let o in i)if(Object.hasOwnProperty.call(i,o)){const a=D(i[o],I,c,d+1);a!==null&&(i[o]=a)}}return null}function y(i,I){const c=D(i,I,!1,0);return c===null?i:c}e.transformIncomingURIs=y;function C(i,I){const c=D(i,I,!0,0);return c===null?i:c}e.transformAndReviveIncomingURIs=C}),define(be[31],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(y){return w.test(y)}e.isUUID=k;const P=new Uint8Array(16),A=[];for(let y=0;y<256;y++)A.push(y.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(y){for(let C=0;C<y.length;C++)y[C]=Math.floor(Math.random()*256);return y};function D(){S(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let y=0,C="";return C+=A[P[y++]],C+=A[P[y++]],C+=A[P[y++]],C+=A[P[y++]],C+="-",C+=A[P[y++]],C+=A[P[y++]],C+="-",C+=A[P[y++]],C+=A[P[y++]],C+="-",C+=A[P[y++]],C+=A[P[y++]],C+="-",C+=A[P[y++]],C+=A[P[y++]],C+=A[P[y++]],C+=A[P[y++]],C+=A[P[y++]],C+=A[P[y++]],C}e.generateUuid=D}),define(be[84],we([0,1,82]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class k{constructor(D){let y=(0,w.toUint8)(D);this._defaultValue=y,this._asciiMap=k._createAsciiMap(y),this._map=new Map}static _createAsciiMap(D){let y=new Uint8Array(256);for(let C=0;C<256;C++)y[C]=D;return y}set(D,y){let C=(0,w.toUint8)(y);D>=0&&D<256?this._asciiMap[D]=C:this._map.set(D,C)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=k;var P;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(P||(P={}));class A{constructor(){this._actual=new k(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=A}),define(be[113],we([0,1,84]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var k;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(k=e.WordCharacterClass||(e.WordCharacterClass={}));class P extends w.CharacterClassifier{constructor(D){super(0);for(let y=0,C=D.length;y<C;y++)this.set(D.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=P;function A(S){let D={};return y=>(D.hasOwnProperty(y)||(D[y]=S(y)),D[y])}e.getMapForWordSeparators=A(S=>new P(S))}),define(be[38],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class w{constructor(P,A){this.lineNumber=P,this.column=A}with(P=this.lineNumber,A=this.column){return P===this.lineNumber&&A===this.column?this:new w(P,A)}delta(P=0,A=0){return this.with(this.lineNumber+P,this.column+A)}equals(P){return w.equals(this,P)}static equals(P,A){return!P&&!A?!0:!!P&&!!A&&P.lineNumber===A.lineNumber&&P.column===A.column}isBefore(P){return w.isBefore(this,P)}static isBefore(P,A){return P.lineNumber<A.lineNumber?!0:A.lineNumber<P.lineNumber?!1:P.column<A.column}isBeforeOrEqual(P){return w.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,A){return P.lineNumber<A.lineNumber?!0:A.lineNumber<P.lineNumber?!1:P.column<=A.column}static compare(P,A){let S=P.lineNumber|0,D=A.lineNumber|0;if(S===D){let y=P.column|0,C=A.column|0;return y-C}return S-D}clone(){return new w(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new w(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}}e.Position=w}),define(be[32],we([0,1,38]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class k{constructor(A,S,D,y){A>D||A===D&&S>y?(this.startLineNumber=D,this.startColumn=y,this.endLineNumber=A,this.endColumn=S):(this.startLineNumber=A,this.startColumn=S,this.endLineNumber=D,this.endColumn=y)}isEmpty(){return k.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return k.containsPosition(this,A)}static containsPosition(A,S){return!(S.lineNumber<A.startLineNumber||S.lineNumber>A.endLineNumber||S.lineNumber===A.startLineNumber&&S.column<A.startColumn||S.lineNumber===A.endLineNumber&&S.column>A.endColumn)}containsRange(A){return k.containsRange(this,A)}static containsRange(A,S){return!(S.startLineNumber<A.startLineNumber||S.endLineNumber<A.startLineNumber||S.startLineNumber>A.endLineNumber||S.endLineNumber>A.endLineNumber||S.startLineNumber===A.startLineNumber&&S.startColumn<A.startColumn||S.endLineNumber===A.endLineNumber&&S.endColumn>A.endColumn)}strictContainsRange(A){return k.strictContainsRange(this,A)}static strictContainsRange(A,S){return!(S.startLineNumber<A.startLineNumber||S.endLineNumber<A.startLineNumber||S.startLineNumber>A.endLineNumber||S.endLineNumber>A.endLineNumber||S.startLineNumber===A.startLineNumber&&S.startColumn<=A.startColumn||S.endLineNumber===A.endLineNumber&&S.endColumn>=A.endColumn)}plusRange(A){return k.plusRange(this,A)}static plusRange(A,S){let D,y,C,i;return S.startLineNumber<A.startLineNumber?(D=S.startLineNumber,y=S.startColumn):S.startLineNumber===A.startLineNumber?(D=S.startLineNumber,y=Math.min(S.startColumn,A.startColumn)):(D=A.startLineNumber,y=A.startColumn),S.endLineNumber>A.endLineNumber?(C=S.endLineNumber,i=S.endColumn):S.endLineNumber===A.endLineNumber?(C=S.endLineNumber,i=Math.max(S.endColumn,A.endColumn)):(C=A.endLineNumber,i=A.endColumn),new k(D,y,C,i)}intersectRanges(A){return k.intersectRanges(this,A)}static intersectRanges(A,S){let D=A.startLineNumber,y=A.startColumn,C=A.endLineNumber,i=A.endColumn,I=S.startLineNumber,c=S.startColumn,d=S.endLineNumber,o=S.endColumn;return D<I?(D=I,y=c):D===I&&(y=Math.max(y,c)),C>d?(C=d,i=o):C===d&&(i=Math.min(i,o)),D>C||D===C&&y>i?null:new k(D,y,C,i)}equalsRange(A){return k.equalsRange(this,A)}static equalsRange(A,S){return!!A&&!!S&&A.startLineNumber===S.startLineNumber&&A.startColumn===S.startColumn&&A.endLineNumber===S.endLineNumber&&A.endColumn===S.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(A){return new w.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(A){return new w.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,S){return new k(this.startLineNumber,this.startColumn,A,S)}setStartPosition(A,S){return new k(A,S,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(A){return new k(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,S=A){return new k(A.lineNumber,A.column,S.lineNumber,S.column)}static lift(A){return A?new k(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,S){return!(A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<S.startColumn||S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<A.startColumn)}static areIntersecting(A,S){return!(A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<=S.startColumn||S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,S){if(A&&S){const C=A.startLineNumber|0,i=S.startLineNumber|0;if(C===i){const I=A.startColumn|0,c=S.startColumn|0;if(I===c){const d=A.endLineNumber|0,o=S.endLineNumber|0;if(d===o){const a=A.endColumn|0,g=S.endColumn|0;return a-g}return d-o}return I-c}return C-i}return(A?1:0)-(S?1:0)}static compareRangesUsingEnds(A,S){return A.endLineNumber===S.endLineNumber?A.endColumn===S.endColumn?A.startLineNumber===S.startLineNumber?A.startColumn-S.startColumn:A.startLineNumber-S.startLineNumber:A.endColumn-S.endColumn:A.endLineNumber-S.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=k}),define(be[114],we([0,1,38,32]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var P;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(P=e.SelectionDirection||(e.SelectionDirection={}));class A extends k.Range{constructor(D,y,C,i){super(D,y,C,i);this.selectionStartLineNumber=D,this.selectionStartColumn=y,this.positionLineNumber=C,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return A.selectionsEqual(this,D)}static selectionsEqual(D,y){return D.selectionStartLineNumber===y.selectionStartLineNumber&&D.selectionStartColumn===y.selectionStartColumn&&D.positionLineNumber===y.positionLineNumber&&D.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,y){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,D,y):new A(D,y,this.startLineNumber,this.startColumn)}getPosition(){return new w.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,y){return this.getDirection()===0?new A(D,y,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,D,y)}static fromPositions(D,y=D){return new A(D.lineNumber,D.column,y.lineNumber,y.column)}static liftSelection(D){return new A(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,y){if(D&&!y||!D&&y)return!1;if(!D&&!y)return!0;if(D.length!==y.length)return!1;for(let C=0,i=D.length;C<i;C++)if(!this.selectionsEqual(D[C],y[C]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,y,C,i,I){return I===0?new A(D,y,C,i):new A(C,i,D,y)}}e.Selection=A}),define(be[85],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var w;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(w=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(P=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(o){this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace)}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class y{constructor(o,a){this.range=o,this.matches=a}}e.FindMatch=y;var C;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(i=e.ModelConstants||(e.ModelConstants={}));class I{constructor(o,a,g,h,_,m){this.identifier=o,this.range=a,this.text=g,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=_,this._isTracked=m}}e.ValidAnnotatedEditOperation=I;class c{constructor(o,a,g){this.reverseEdits=o,this.changes=a,this.trimAutoWhitespaceLineNumbers=g}}e.ApplyEditsResult=c}),define(be[115],we([0,1,8,113,38,32,85]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class y{constructor(m,u,p,t){this.searchString=m,this.isRegex=u,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let m;this.isRegex?m=C(this.searchString):m=this.searchString.indexOf(`
`)>=0;let u=null;try{u=w.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:m,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let p=!this.isRegex&&!m;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new i(u,this.wordSeparators?(0,k.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=y;function C(_){if(!_||_.length===0)return!1;for(let m=0,u=_.length;m<u;m++)if(_.charCodeAt(m)===92){if(m++,m>=u)break;const t=_.charCodeAt(m);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class i{constructor(m,u,p){this.regex=m,this.wordSeparators=u,this.simpleSearch=p}}e.SearchData=i;function I(_,m,u){if(!u)return new S.FindMatch(_,null);let p=[];for(let t=0,n=m.length;t<n;t++)p[t]=m[t];return new S.FindMatch(_,p)}e.createFindMatch=I;class c{constructor(m){let u=[],p=0;for(let t=0,n=m.length;t<n;t++)m.charCodeAt(t)===10&&(u[p++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(m){const u=this._lineFeedsOffsets;let p=0,t=u.length-1;if(t===-1||m<=u[0])return 0;for(;p<t;){const n=p+((t-p)/2>>0);u[n]>=m?t=n-1:u[n+1]>=m?(p=n,t=n):p=n+1}return p+1}}class d{static findMatches(m,u,p,t,n){const s=u.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(m,p,new h(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(m,p,s,t,n):[]}static _getMultilineMatchRange(m,u,p,t,n,s){let r,l=0;t?(l=t.findLineFeedCountBeforeOffset(n),r=u+n+l):r=u+n;let f;if(t){let E=t.findLineFeedCountBeforeOffset(n+s.length)-l;f=r+s.length+E}else f=r+s.length;const v=m.getPositionAt(r),T=m.getPositionAt(f);return new A.Range(v.lineNumber,v.column,T.lineNumber,T.column)}static _doFindMatchesMultiline(m,u,p,t,n){const s=m.getOffsetAt(u.getStartPosition()),r=m.getValueInRange(u,1),l=m.getEOL()===`\r
`?new c(r):null,f=[];let v=0,T;for(p.reset(0);T=p.next(r);)if(f[v++]=I(this._getMultilineMatchRange(m,s,r,l,T.index,T[0]),T,t),v>=n)return f;return f}static _doFindMatchesLineByLine(m,u,p,t,n){const s=[];let r=0;if(u.startLineNumber===u.endLineNumber){const f=m.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return r=this._findMatchesInLine(p,f,u.startLineNumber,u.startColumn-1,r,s,t,n),s}const l=m.getLineContent(u.startLineNumber).substring(u.startColumn-1);r=this._findMatchesInLine(p,l,u.startLineNumber,u.startColumn-1,r,s,t,n);for(let f=u.startLineNumber+1;f<u.endLineNumber&&r<n;f++)r=this._findMatchesInLine(p,m.getLineContent(f),f,0,r,s,t,n);if(r<n){const f=m.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);r=this._findMatchesInLine(p,f,u.endLineNumber,0,r,s,t,n)}return s}static _findMatchesInLine(m,u,p,t,n,s,r,l){const f=m.wordSeparators;if(!r&&m.simpleSearch){const b=m.simpleSearch,E=b.length,F=u.length;let L=-E;for(;(L=u.indexOf(b,L+E))!==-1;)if((!f||g(f,u,F,L,E))&&(s[n++]=new S.FindMatch(new A.Range(p,L+1+t,p,L+1+E+t),null),n>=l))return n;return n}const v=new h(m.wordSeparators,m.regex);let T;v.reset(0);do if(T=v.next(u),T&&(s[n++]=I(new A.Range(p,T.index+1+t,p,T.index+1+T[0].length+t),T,r),n>=l))return n;while(T);return n}static findNextMatch(m,u,p,t){const n=u.parseSearchRequest();if(!n)return null;const s=new h(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(m,p,s,t):this._doFindNextMatchLineByLine(m,p,s,t)}static _doFindNextMatchMultiline(m,u,p,t){const n=new P.Position(u.lineNumber,1),s=m.getOffsetAt(n),r=m.getLineCount(),l=m.getValueInRange(new A.Range(n.lineNumber,n.column,r,m.getLineMaxColumn(r)),1),f=m.getEOL()===`\r
`?new c(l):null;p.reset(u.column-1);let v=p.next(l);return v?I(this._getMultilineMatchRange(m,s,l,f,v.index,v[0]),v,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(m,new P.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(m,u,p,t){const n=m.getLineCount(),s=u.lineNumber,r=m.getLineContent(s),l=this._findFirstMatchInLine(p,r,s,u.column,t);if(l)return l;for(let f=1;f<=n;f++){const v=(s+f-1)%n,T=m.getLineContent(v+1),b=this._findFirstMatchInLine(p,T,v+1,1,t);if(b)return b}return null}static _findFirstMatchInLine(m,u,p,t,n){m.reset(t-1);const s=m.next(u);return s?I(new A.Range(p,s.index+1,p,s.index+1+s[0].length),s,n):null}static findPreviousMatch(m,u,p,t){const n=u.parseSearchRequest();if(!n)return null;const s=new h(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(m,p,s,t):this._doFindPreviousMatchLineByLine(m,p,s,t)}static _doFindPreviousMatchMultiline(m,u,p,t){const n=this._doFindMatchesMultiline(m,new A.Range(1,1,u.lineNumber,u.column),p,t,10*D);if(n.length>0)return n[n.length-1];const s=m.getLineCount();return u.lineNumber!==s||u.column!==m.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(m,new P.Position(s,m.getLineMaxColumn(s)),p,t):null}static _doFindPreviousMatchLineByLine(m,u,p,t){const n=m.getLineCount(),s=u.lineNumber,r=m.getLineContent(s).substring(0,u.column-1),l=this._findLastMatchInLine(p,r,s,t);if(l)return l;for(let f=1;f<=n;f++){const v=(n+s-f-1)%n,T=m.getLineContent(v+1),b=this._findLastMatchInLine(p,T,v+1,t);if(b)return b}return null}static _findLastMatchInLine(m,u,p,t){let n=null,s;for(m.reset(0);s=m.next(u);)n=I(new A.Range(p,s.index+1,p,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=d;function o(_,m,u,p,t){if(p===0)return!0;const n=m.charCodeAt(p-1);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=m.charCodeAt(p);if(_.get(s)!==0)return!0}return!1}function a(_,m,u,p,t){if(p+t===u)return!0;const n=m.charCodeAt(p+t);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=m.charCodeAt(p+t-1);if(_.get(s)!==0)return!0}return!1}function g(_,m,u,p,t){return o(_,m,u,p,t)&&a(_,m,u,p,t)}e.isValidMatch=g;class h{constructor(m,u){this._wordSeparators=m,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(m){this._searchRegex.lastIndex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(m){const u=m.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(p=this._searchRegex.exec(m),!p))return null;const t=p.index,n=p[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){w.getNextCodePoint(m,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||g(this._wordSeparators,m,u,t,n))return p}while(p);return null}}e.Searcher=h}),define(be[86],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function w(D=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)D.indexOf(C)>=0||(y+="\\"+C);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=w();function k(D){let y=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)y=D;else{let C="g";D.ignoreCase&&(C+="i"),D.multiline&&(C+="m"),D.unicode&&(C+="u"),y=new RegExp(D.source,C)}return y.lastIndex=0,y}e.ensureValidWordDefinition=k;const P={maxLen:1e3,windowSize:15,timeBudget:150};function A(D,y,C,i,I=P){if(C.length>I.maxLen){let g=D-I.maxLen/2;return g<0?g=0:i+=g,C=C.substring(g,D+I.maxLen/2),A(D,y,C,i,I)}const c=Date.now(),d=D-1-i;let o=-1,a=null;for(let g=1;!(Date.now()-c>=I.timeBudget);g++){const h=d-I.windowSize*g;y.lastIndex=Math.max(0,h);const _=S(y,C,d,o);if(!_&&a||(a=_,h<=0))break;o=h}if(a){let g={word:a[0],startColumn:i+1+a.index,endColumn:i+1+a.index+a[0].length};return y.lastIndex=0,g}return null}e.getWordAtText=A;function S(D,y,C,i){let I;for(;I=D.exec(y);){const c=I.index||0;if(c<=C&&D.lastIndex>=C)return I;if(i>0&&c>i)return null}return null}}),define(be[116],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var w;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(w=e.IndentAction||(e.IndentAction={}));class k{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let y=0,C=D.notIn.length;y<C;y++)switch(D.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=k;class P{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of D)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=P;function A(S,D,y){S.has(D)?S.get(D).push(y):S.set(D,[y])}}),define(be[59],we([0,1,28,14]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function P(A,S,D,y){if(Array.isArray(A)){let C=0;for(const i of A){const I=P(i,S,D,y);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof A=="string")return y?A==="*"?5:A===D?10:0:0;if(A){const{language:C,pattern:i,scheme:I,hasAccessToAllModels:c}=A;if(!y&&!c)return 0;let d=0;if(I)if(I===S.scheme)d=10;else if(I==="*")d=5;else return 0;if(C)if(C===D)d=10;else if(C==="*")d=Math.max(d,5);else return 0;if(i){let o;if(typeof i=="string"?o=i:o=Object.assign(Object.assign({},i),{base:(0,k.normalize)(i.base)}),o===S.fsPath||(0,w.match)(o,S.fsPath))d=10;else return 0}return d}else return 0}}e.score=P}),define(be[117],we([0,1,84]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var k;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(k=e.State||(e.State={}));class P{constructor(o,a,g){const h=new Uint8Array(o*a);for(let _=0,m=o*a;_<m;_++)h[_]=g;this._data=h,this.rows=o,this.cols=a}get(o,a){return this._data[o*this.cols+a]}set(o,a,g){this._data[o*this.cols+a]=g}}e.Uint8Matrix=P;class A{constructor(o){let a=0,g=0;for(let _=0,m=o.length;_<m;_++){let[u,p,t]=o[_];p>a&&(a=p),u>g&&(g=u),t>g&&(g=t)}a++,g++;let h=new P(g,a,0);for(let _=0,m=o.length;_<m;_++){let[u,p,t]=o[_];h.set(u,p,t)}this._states=h,this._maxCharCode=a}nextState(o,a){return a<0||a>=this._maxCharCode?0:this._states.get(o,a)}}e.StateMachine=A;let S=null;function D(){return S===null&&(S=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var y;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let C=null;function i(){if(C===null){C=new w.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<d.length;a++)C.set(d.charCodeAt(a),1);const o=".,;";for(let a=0;a<o.length;a++)C.set(o.charCodeAt(a),2)}return C}class I{static _createLink(o,a,g,h,_){let m=_-1;do{const u=a.charCodeAt(m);if(o.get(u)!==2)break;m--}while(m>h);if(h>0){const u=a.charCodeAt(h-1),p=a.charCodeAt(m);(u===40&&p===41||u===91&&p===93||u===123&&p===125)&&m--}return{range:{startLineNumber:g,startColumn:h+1,endLineNumber:g,endColumn:m+2},url:a.substring(h,m+1)}}static computeLinks(o,a=D()){const g=i();let h=[];for(let _=1,m=o.getLineCount();_<=m;_++){const u=o.getLineContent(_),p=u.length;let t=0,n=0,s=0,r=1,l=!1,f=!1,v=!1,T=!1;for(;t<p;){let b=!1;const E=u.charCodeAt(t);if(r===13){let F;switch(E){case 40:l=!0,F=0;break;case 41:F=l?0:1;break;case 91:v=!0,f=!0,F=0;break;case 93:v=!1,F=f?0:1;break;case 123:T=!0,F=0;break;case 125:F=T?0:1;break;case 39:F=s===34||s===96?0:1;break;case 34:F=s===39||s===96?0:1;break;case 96:F=s===39||s===34?0:1;break;case 42:F=s===42?1:0;break;case 124:F=s===124?1:0;break;case 32:F=v?0:1;break;default:F=g.get(E)}F===1&&(h.push(I._createLink(g,u,_,n,t)),b=!0)}else if(r===12){let F;E===91?(f=!0,F=0):F=g.get(E),F===1?b=!0:r=13}else r=a.nextState(r,E),r===0&&(b=!0);b&&(r=1,l=!1,f=!1,T=!1,n=t+1,s=E),t++}r===13&&h.push(I._createLink(g,u,_,n,p))}return h}}e.LinkComputer=I;function c(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:I.computeLinks(d)}e.computeLinks=c}),define(be[118],we([0,1,3,6]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class P{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new w.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,D){return this._map.set(S,D),this.fire([S]),(0,k.toDisposable)(()=>{this._map.get(S)===D&&(this._map.delete(S),this.fire([S]))})}registerPromise(S,D){let y=null,C=!1;return this._promises.set(S,D.then(i=>{this._promises.delete(S),!(C||!i)&&(y=this.register(S,i))})),(0,k.toDisposable)(()=>{C=!0,y&&y.dispose()})}getPromise(S){const D=this.get(S);if(D)return Promise.resolve(D);const y=this._promises.get(S);return y?y.then(C=>this.get(S)):null}get(S){return this._map.get(S)||null}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=P}),define(be[87],we([0,1,23,21]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var P;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(P||(P={}));function A(I){for(let c=0,d=I.length;c<d;c+=4){const o=I[c+0],a=I[c+1],g=I[c+2],h=I[c+3];I[c+0]=h,I[c+1]=g,I[c+2]=a,I[c+3]=o}}function S(I){const c=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return k.isLittleEndian()||A(c),w.VSBuffer.wrap(c)}function D(I){const c=I.buffer;if(k.isLittleEndian()||A(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const d=new Uint8Array(c.byteLength);return d.set(c),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function y(I){const c=new Uint32Array(C(I));let d=0;if(c[d++]=I.id,I.type==="full")c[d++]=1,c[d++]=I.data.length,c.set(I.data,d),d+=I.data.length;else{c[d++]=2,c[d++]=I.deltas.length;for(const o of I.deltas)c[d++]=o.start,c[d++]=o.deleteCount,o.data?(c[d++]=o.data.length,c.set(o.data,d),d+=o.data.length):c[d++]=0}return S(c)}e.encodeSemanticTokensDto=y;function C(I){let c=0;if(c+=1+1,I.type==="full")c+=1+I.data.length;else{c+=1,c+=(1+1+1)*I.deltas.length;for(const d of I.deltas)d.data&&(c+=d.data.length)}return c}function i(I){const c=D(I);let d=0;const o=c[d++];if(c[d++]===1){const _=c[d++],m=c.subarray(d,d+_);return d+=_,{id:o,type:"full",data:m}}const g=c[d++];let h=[];for(let _=0;_<g;_++){const m=c[d++],u=c[d++],p=c[d++];let t;p>0&&(t=c.subarray(d,d+p),d+=p),h[_]={start:m,deleteCount:u,data:t}}return{id:o,type:"delta",deltas:h}}e.decodeSemanticTokensDto=i}),define(be[88],we([0,1,82]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class k{constructor(S,D){this.index=S,this.remainder=D}}e.PrefixSumIndexOfResult=k;class P{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,D){S=(0,w.toUint32)(S);const y=this.values,C=this.prefixSum,i=D.length;return i===0?!1:(this.values=new Uint32Array(y.length+i),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S),S+i),this.values.set(D,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,D){return S=(0,w.toUint32)(S),D=(0,w.toUint32)(D),this.values[S]===D?!1:(this.values[S]=D,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,D){S=(0,w.toUint32)(S),D=(0,w.toUint32)(D);const y=this.values,C=this.prefixSum;if(S>=y.length)return!1;let i=y.length-S;return D>=i&&(D=i),D===0?!1:(this.values=new Uint32Array(y.length-D),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S+D),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(S){return S<0?0:(S=(0,w.toUint32)(S),this._getAccumulatedValue(S))}_getAccumulatedValue(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),S>=this.values.length&&(S=this.values.length-1);for(let y=D;y<=S;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalValue();let D=0,y=this.values.length-1,C=0,i=0,I=0;for(;D<=y;)if(C=D+(y-D)/2|0,i=this.prefixSum[C],I=i-this.values[C],S<I)y=C-1;else if(S>=i)D=C+1;else break;return new k(C,S-I)}}e.PrefixSumComputer=P}),define(be[119],we([0,1,8,38,88]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(D,y,C,i){this._uri=D,this._lines=y,this._eol=C,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const y=D.changes;for(const C of y)this._acceptDeleteRange(C.range),this._acceptInsertText(new k.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,y=this._lines.length,C=new Uint32Array(y);for(let i=0;i<y;i++)C[i]=this._lines[i].length+D;this._lineStarts=new P.PrefixSumComputer(C)}}_setLineText(D,y){this._lines[D]=y,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,y){if(y.length!==0){let C=(0,w.splitLines)(y);if(C.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}C[C.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]);let i=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(D.lineNumber+I-1,0,C[I]),i[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,i)}}}e.MirrorTextModel=A}),define(be[120],we([16,17]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(be[60],we([0,1,120,10,13]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(C,i){return i&&(C.stack||C.stacktrace)?w.localize(0,null,D(C),S(C.stack)||S(C.stacktrace)):D(C)}function S(C){return Array.isArray(C)?C.join(`
`):C}function D(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?w.localize(1,null,C.message):C.message||w.localize(2,null)}function y(C=null,i=!1){if(!C)return w.localize(3,null);if(Array.isArray(C)){const I=P.coalesce(C),c=y(I[0],i);return I.length>1?w.localize(4,null,c,I.length):c}if(k.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return A(I.error,i);if(I.exception)return A(I.exception,i)}return C.stack?A(C,i):C.message?C.message:w.localize(5,null)}e.toErrorMessage=y}),define(be[121],we([16,17]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(be[122],we([0,1,121,21,86]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=S;class D{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,ve){this._values[te]=ve}}e.ValidatedEditorOptions=D;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class C{constructor(te,ve,Ue,He){this.id=te,this.name=ve,this.defaultValue=Ue,this.schema=He}compute(te,ve,Ue){return Ue}}class i{constructor(te,ve=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(te){return this.defaultValue}}class I{constructor(te,ve,Ue,He){this.id=te,this.name=ve,this.defaultValue=Ue,this.schema=He}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,ve,Ue){return Ue}}function c(z,te){return typeof z=="undefined"?te:z==="false"?!1:Boolean(z)}e.boolean=c;class d extends I{constructor(te,ve,Ue,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Ue),super(te,ve,Ue,He)}validate(te){return c(te,this.defaultValue)}}class o extends I{constructor(te,ve,Ue,He,xe,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=Ue,Ye.minimum=He,Ye.maximum=xe),super(te,ve,Ue,Ye),this.minimum=He,this.maximum=xe}static clampedInt(te,ve,Ue,He){if(typeof te=="undefined")return ve;let xe=parseInt(te,10);return isNaN(xe)?ve:(xe=Math.max(Ue,xe),xe=Math.min(He,xe),xe|0)}validate(te){return o.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class a extends I{constructor(te,ve,Ue,He,xe){typeof xe!="undefined"&&(xe.type="number",xe.default=Ue),super(te,ve,Ue,xe),this.validationFn=He}static clamp(te,ve,Ue){return te<ve?ve:te>Ue?Ue:te}static float(te,ve){if(typeof te=="number")return te;if(typeof te=="undefined")return ve;const Ue=parseFloat(te);return isNaN(Ue)?ve:Ue}validate(te){return this.validationFn(a.float(te,this.defaultValue))}}class g extends I{static string(te,ve){return typeof te!="string"?ve:te}constructor(te,ve,Ue,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Ue),super(te,ve,Ue,He)}validate(te){return g.string(te,this.defaultValue)}}function h(z,te,ve){return typeof z!="string"||ve.indexOf(z)===-1?te:z}e.stringSet=h;class _ extends I{constructor(te,ve,Ue,He,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.enum=He,xe.default=Ue),super(te,ve,Ue,xe),this._allowedValues=He}validate(te){return h(te,this.defaultValue,this._allowedValues)}}class m extends C{constructor(te,ve,Ue,He,xe,Ye,W=void 0){typeof W!="undefined"&&(W.type="string",W.enum=xe,W.default=He),super(te,ve,Ue,W),this._allowedValues=xe,this._convert=Ye}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function u(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",description:w.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,ve,Ue){return Ue===0?te.accessibilitySupport:Ue}}class t extends C{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:w.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertSpace:c(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(z){switch(z){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function f(z){switch(z){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class v extends i{constructor(){super(123,[62,31])}compute(te,ve,Ue){const He=["monaco-editor"];return ve.get(31)&&He.push(ve.get(31)),te.extraEditorClassName&&He.push(te.extraEditorClassName),ve.get(62)==="default"?He.push("mouse-default"):ve.get(62)==="copy"&&He.push("mouse-copy"),ve.get(97)&&He.push("showUnused"),ve.get(121)&&He.push("showDeprecated"),He.join(" ")}}class T extends d{constructor(){super(30,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(te,ve,Ue){return Ue&&te.emptySelectionClipboard}}class b extends C{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:te.seedSearchStringFromSelection,description:w.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[w.localize(9,null),w.localize(10,null),w.localize(11,null)],description:w.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:w.localize(13,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:w.localize(14,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:w.localize(15,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{cursorMoveOnType:c(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:c(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":h(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(ve.loop,this.defaultValue.loop)}}}class E extends C{constructor(){super(41,"fontLigatures",E.OFF,{anyOf:[{type:"boolean",description:w.localize(16,null)},{type:"string",description:w.localize(17,null)}],description:w.localize(18,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?E.OFF:te==="true"?E.ON:te:Boolean(te)?E.ON:E.OFF}}e.EditorFontLigatures=E,E.OFF='"liga" off, "calt" off',E.ON='"liga" on, "calt" on';class F extends i{constructor(){super(40)}compute(te,ve,Ue){return te.fontInfo}}class L extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(19,null)})}validate(te){let ve=a.float(te,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(ve,6,100)}compute(te,ve,Ue){return te.fontInfo.fontSize}}class K extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:w.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(21,null)})}validate(te){return te==="normal"||te==="bold"?te:String(o.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class fe extends C{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[w.localize(22,null),w.localize(23,null),w.localize(24,null)]};super(47,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:w.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:w.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:w.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:w.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:w.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,description:w.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,description:w.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,description:w.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,description:w.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,description:w.localize(35,null)}})}validate(te){var ve,Ue,He,xe,Ye;if(!te||typeof te!="object")return this.defaultValue;const W=te;return{multiple:h(W.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=W.multipleDefinitions)!==null&&ve!==void 0?ve:h(W.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ue=W.multipleTypeDefinitions)!==null&&Ue!==void 0?Ue:h(W.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=W.multipleDeclarations)!==null&&He!==void 0?He:h(W.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(xe=W.multipleImplementations)!==null&&xe!==void 0?xe:h(W.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ye=W.multipleReferences)!==null&&Ye!==void 0?Ye:h(W.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(W.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(W.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(W.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(W.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(W.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends C{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(50,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:w.localize(36,null)},"editor.hover.delay":{type:"number",default:te.delay,description:w.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:w.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:c(ve.enabled,this.defaultValue.enabled),delay:o.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:c(ve.sticky,this.defaultValue.sticky)}}}var H;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(H=e.RenderMinimap||(e.RenderMinimap={}));class ee extends i{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(te,ve,Ue){return ee.computeLayout(ve,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const ve=te.height/te.lineHeight,Ue=te.scrollBeyondLastLine?ve-1:0,He=(te.viewLineCount+Ue)/(te.pixelRatio*te.height),xe=Math.floor(te.viewLineCount/He);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Ue,desiredRatio:He,minimapLineCount:xe}}static _computeMinimapLayout(te,ve){const Ue=te.outerWidth,He=te.outerHeight,xe=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Ye=ve.stableMinimapLayoutInput,W=Ye&&te.outerHeight===Ye.outerHeight&&te.lineHeight===Ye.lineHeight&&te.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&te.pixelRatio===Ye.pixelRatio&&te.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&te.minimap.enabled===Ye.minimap.enabled&&te.minimap.side===Ye.minimap.side&&te.minimap.size===Ye.minimap.size&&te.minimap.showSlider===Ye.minimap.showSlider&&te.minimap.renderCharacters===Ye.minimap.renderCharacters&&te.minimap.maxColumn===Ye.minimap.maxColumn&&te.minimap.scale===Ye.minimap.scale&&te.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&te.isViewportWrapping===Ye.isViewportWrapping,se=te.lineHeight,de=te.typicalHalfwidthCharacterWidth,q=te.scrollBeyondLastLine,Z=te.minimap.renderCharacters;let le=xe>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const he=te.minimap.maxColumn,Ee=te.minimap.size,Ve=te.minimap.side,Fe=te.verticalScrollbarWidth,We=te.viewLineCount,Qe=te.remainingWidth,it=te.isViewportWrapping,lt=Z?2:3;let Ze=Math.floor(xe*He);const nt=Ze/xe;let ht=!1,wt=!1,ue=lt*le,Se=le/xe,ae=1;if(Ee==="fill"||Ee==="fit"){const{typicalViewportLineCount:rt,extraLinesBeyondLastLine:Ge,desiredRatio:ft,minimapLineCount:at}=ee.computeContainedMinimapLineCount({viewLineCount:We,scrollBeyondLastLine:q,height:He,lineHeight:se,pixelRatio:xe});if(We/at>1)ht=!0,wt=!0,le=1,ue=1,Se=le/xe;else{let pt=!1,Et=le+1;if(Ee==="fit"){const Dt=Math.ceil((We+Ge)*ue);it&&W&&Qe<=ve.stableFitRemainingWidth?(pt=!0,Et=ve.stableFitMaxMinimapScale):(pt=Dt>Ze,it&&pt?(ve.stableMinimapLayoutInput=te,ve.stableFitRemainingWidth=Qe):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(Ee==="fill"||pt){ht=!0;const Dt=le;ue=Math.min(se*xe,Math.max(1,Math.floor(1/ft))),le=Math.min(Et,Math.max(1,Math.floor(ue/lt))),le>Dt&&(ae=Math.min(2,le/Dt)),Se=le/xe/ae,Ze=Math.ceil(Math.max(rt,We+Ge)*ue),it&&pt&&(ve.stableFitMaxMinimapScale=le)}}}const V=Math.floor(he*Se),Le=Math.min(V,Math.max(0,Math.floor((Qe-Fe-2)*Se/(de+Se)))+e.MINIMAP_GUTTER_WIDTH);let Ie=Math.floor(xe*Le);const Xe=Ie/xe;Ie=Math.floor(Ie*ae);const et=Z?1:2,ct=Ve==="left"?0:Ue-Le-Fe;return{renderMinimap:et,minimapLeft:ct,minimapWidth:Le,minimapHeightIsEditorHeight:ht,minimapIsSampling:wt,minimapScale:le,minimapLineHeight:ue,minimapCanvasInnerWidth:Ie,minimapCanvasInnerHeight:Ze,minimapCanvasOuterWidth:Xe,minimapCanvasOuterHeight:nt}}static computeLayout(te,ve){const Ue=ve.outerWidth|0,He=ve.outerHeight|0,xe=ve.lineHeight|0,Ye=ve.lineNumbersDigitCount|0,W=ve.typicalHalfwidthCharacterWidth,se=ve.maxDigitWidth,de=ve.pixelRatio,q=ve.viewLineCount,Z=te.get(118),le=Z==="inherit"?te.get(117):Z,he=le==="inherit"?te.get(113):le,Ee=te.get(116),Ve=te.get(2),Fe=ve.isDominatedByLongLines,We=te.get(46),Qe=te.get(56).renderType!==0,it=te.get(57),lt=te.get(91),Ze=te.get(61),nt=te.get(89),ht=nt.verticalScrollbarSize,wt=nt.verticalHasArrows,ue=nt.arrowSize,Se=nt.horizontalScrollbarSize,ae=te.get(54),V=te.get(35);let Le;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const Pt=parseFloat(ae.substr(0,ae.length-2));Le=o.clampedInt(Pt*W,0,0,1e3)}else Le=o.clampedInt(ae,0,0,1e3);V&&(Le+=16);let Ie=0;if(Qe){const Pt=Math.max(Ye,it);Ie=Math.round(Pt*se)}let Xe=0;We&&(Xe=xe);let et=0,ct=et+Xe,rt=ct+Ie,Ge=rt+Le;const ft=Ue-Xe-Ie-Le;let at=!1,vt=!1,pt=-1;Ve!==2&&(le==="inherit"&&Fe?(at=!0,vt=!0):he==="on"||he==="bounded"?vt=!0:he==="wordWrapColumn"&&(pt=Ee));const Et=ee._computeMinimapLayout({outerWidth:Ue,outerHeight:He,lineHeight:xe,typicalHalfwidthCharacterWidth:W,pixelRatio:de,scrollBeyondLastLine:lt,minimap:Ze,verticalScrollbarWidth:ht,viewLineCount:q,remainingWidth:ft,isViewportWrapping:vt},ve.memory||new y);Et.renderMinimap!==0&&Et.minimapLeft===0&&(et+=Et.minimapWidth,ct+=Et.minimapWidth,rt+=Et.minimapWidth,Ge+=Et.minimapWidth);const Dt=ft-Et.minimapWidth,It=Math.max(1,Math.floor((Dt-ht-2)/W)),bt=wt?ue:0;return vt&&(pt=Math.max(1,It),he==="bounded"&&(pt=Math.min(pt,Ee))),{width:Ue,height:He,glyphMarginLeft:et,glyphMarginWidth:Xe,lineNumbersLeft:ct,lineNumbersWidth:Ie,decorationsLeft:rt,decorationsWidth:Le,contentLeft:Ge,contentWidth:Dt,minimap:Et,viewportColumn:It,isWordWrapMinified:at,isViewportWrapping:vt,wrappingColumn:pt,verticalScrollbarWidth:ht,horizontalScrollbarHeight:Se,overviewRuler:{top:bt,width:ht,height:He-2*bt,right:0}}}}e.EditorLayoutInfoComputer=ee;class O extends C{constructor(){const te={enabled:!0};super(53,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:w.localize(39,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:c(te.enabled,this.defaultValue.enabled)}}}class R extends C{constructor(){const te={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",te,{"editor.inlineHints.enabled":{type:"boolean",default:te.enabled,description:w.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:te.fontSize,description:w.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:te.fontFamily,description:w.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:c(ve.enabled,this.defaultValue.enabled),fontSize:o.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class N extends o{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:w.localize(43,null)})}compute(te,ve,Ue){return te.fontInfo.lineHeight}}class $ extends C{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:w.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(45,null),w.localize(46,null),w.localize(47,null)],default:te.size,description:w.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:w.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:w.localize(50,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:w.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:w.localize(53,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:c(ve.enabled,this.defaultValue.enabled),size:h(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(ve.side,this.defaultValue.side,["right","left"]),showSlider:h(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(ve.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(ve.scale,1,1,3),maxColumn:o.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function U(z){return z==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Q extends C{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(55,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{top:o.clampedInt(ve.top,0,0,1e3),bottom:o.clampedInt(ve.bottom,0,0,1e3)}}}class Y extends C{constructor(){const te={enabled:!0,cycle:!1};super(72,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:w.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:w.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:c(ve.enabled,this.defaultValue.enabled),cycle:c(ve.cycle,this.defaultValue.cycle)}}}class ie extends i{constructor(){super(124)}compute(te,ve,Ue){return te.pixelRatio}}class pe extends C{constructor(){const te={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:w.localize(58,null)},comments:{type:"boolean",default:te.comments,description:w.localize(59,null)},other:{type:"boolean",default:te.other,description:w.localize(60,null)}}}],default:te,description:w.localize(61,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const ve=te,Ue={other:c(ve.other,this.defaultValue.other),comments:c(ve.comments,this.defaultValue.comments),strings:c(ve.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var Pe;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(Pe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Oe extends C{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(62,null),w.localize(63,null),w.localize(64,null),w.localize(65,null)],default:"on",description:w.localize(66,null)})}validate(te){let ve=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(ve=4,Ue=te):te==="interval"?ve=3:te==="relative"?ve=2:te==="on"?ve=1:ve=0),{renderType:ve,renderFn:Ue}}}function Te(z){const te=z.get(84);return te==="editable"?z.get(77):te!=="on"}e.filterValidationDecorations=Te;class Be extends C{constructor(){const te=[],ve={type:"number",description:w.localize(67,null)};super(88,"rulers",te,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:w.localize(68,null),format:"color-hex"}}}]},default:te,description:w.localize(69,null)})}validate(te){if(Array.isArray(te)){let ve=[];for(let Ue of te)if(typeof Ue=="number")ve.push({column:o.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const He=Ue;ve.push({column:o.clampedInt(He.column,0,0,1e4),color:He.color})}return ve.sort((Ue,He)=>Ue.column-He.column),ve}return this.defaultValue}}function x(z,te){if(typeof z!="string")return te;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class G extends C{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te,Ue=o.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=o.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:x(ve.vertical,this.defaultValue.vertical),horizontal:x(ve.horizontal,this.defaultValue.horizontal),useShadows:c(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:o.clampedInt(ve.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:He,verticalSliderSize:o.clampedInt(ve.verticalSliderSize,He,0,1e3),scrollByPage:c(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class re extends C{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(70,null),w.localize(71,null)],default:te.insertMode,description:w.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:w.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:w.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:w.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:w.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:w.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:w.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:w.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(109,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertMode:h(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(ve.showIcons,this.defaultValue.showIcons),showStatusBar:c(ve.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:c(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(ve.showMethods,this.defaultValue.showMethods),showFunctions:c(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:c(ve.showConstructors,this.defaultValue.showConstructors),showFields:c(ve.showFields,this.defaultValue.showFields),showVariables:c(ve.showVariables,this.defaultValue.showVariables),showClasses:c(ve.showClasses,this.defaultValue.showClasses),showStructs:c(ve.showStructs,this.defaultValue.showStructs),showInterfaces:c(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:c(ve.showModules,this.defaultValue.showModules),showProperties:c(ve.showProperties,this.defaultValue.showProperties),showEvents:c(ve.showEvents,this.defaultValue.showEvents),showOperators:c(ve.showOperators,this.defaultValue.showOperators),showUnits:c(ve.showUnits,this.defaultValue.showUnits),showValues:c(ve.showValues,this.defaultValue.showValues),showConstants:c(ve.showConstants,this.defaultValue.showConstants),showEnums:c(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:c(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(ve.showKeywords,this.defaultValue.showKeywords),showWords:c(ve.showWords,this.defaultValue.showWords),showColors:c(ve.showColors,this.defaultValue.showColors),showFiles:c(ve.showFiles,this.defaultValue.showFiles),showReferences:c(ve.showReferences,this.defaultValue.showReferences),showFolders:c(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:c(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(ve.showSnippets,this.defaultValue.showSnippets),showUsers:c(ve.showUsers,this.defaultValue.showUsers),showIssues:c(ve.showIssues,this.defaultValue.showIssues)}}}class oe extends C{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(110,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends i{constructor(){super(125,[77])}compute(te,ve,Ue){return ve.get(77)?!0:te.tabFocusMode}}var De;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Ne(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends i{constructor(){super(127,[126])}compute(te,ve,Ue){const He=ve.get(126);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?Ae:k.isLinux?$e:Ce,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(z){return e.editorOptionsRegistry[z.id]=z,z}var qe;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.codeLens=12]="codeLens",z[z.codeLensFontFamily=13]="codeLensFontFamily",z[z.codeLensFontSize=14]="codeLensFontSize",z[z.colorDecorators=15]="colorDecorators",z[z.columnSelection=16]="columnSelection",z[z.comments=17]="comments",z[z.contextmenu=18]="contextmenu",z[z.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",z[z.cursorBlinking=20]="cursorBlinking",z[z.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",z[z.cursorStyle=22]="cursorStyle",z[z.cursorSurroundingLines=23]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",z[z.cursorWidth=25]="cursorWidth",z[z.disableLayerHinting=26]="disableLayerHinting",z[z.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",z[z.domReadOnly=28]="domReadOnly",z[z.dragAndDrop=29]="dragAndDrop",z[z.emptySelectionClipboard=30]="emptySelectionClipboard",z[z.extraEditorClassName=31]="extraEditorClassName",z[z.fastScrollSensitivity=32]="fastScrollSensitivity",z[z.find=33]="find",z[z.fixedOverflowWidgets=34]="fixedOverflowWidgets",z[z.folding=35]="folding",z[z.foldingStrategy=36]="foldingStrategy",z[z.foldingHighlight=37]="foldingHighlight",z[z.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=39]="fontFamily",z[z.fontInfo=40]="fontInfo",z[z.fontLigatures=41]="fontLigatures",z[z.fontSize=42]="fontSize",z[z.fontWeight=43]="fontWeight",z[z.formatOnPaste=44]="formatOnPaste",z[z.formatOnType=45]="formatOnType",z[z.glyphMargin=46]="glyphMargin",z[z.gotoLocation=47]="gotoLocation",z[z.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",z[z.hover=50]="hover",z[z.inDiffEditor=51]="inDiffEditor",z[z.letterSpacing=52]="letterSpacing",z[z.lightbulb=53]="lightbulb",z[z.lineDecorationsWidth=54]="lineDecorationsWidth",z[z.lineHeight=55]="lineHeight",z[z.lineNumbers=56]="lineNumbers",z[z.lineNumbersMinChars=57]="lineNumbersMinChars",z[z.linkedEditing=58]="linkedEditing",z[z.links=59]="links",z[z.matchBrackets=60]="matchBrackets",z[z.minimap=61]="minimap",z[z.mouseStyle=62]="mouseStyle",z[z.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=64]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",z[z.multiCursorModifier=66]="multiCursorModifier",z[z.multiCursorPaste=67]="multiCursorPaste",z[z.occurrencesHighlight=68]="occurrencesHighlight",z[z.overviewRulerBorder=69]="overviewRulerBorder",z[z.overviewRulerLanes=70]="overviewRulerLanes",z[z.padding=71]="padding",z[z.parameterHints=72]="parameterHints",z[z.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",z[z.quickSuggestions=75]="quickSuggestions",z[z.quickSuggestionsDelay=76]="quickSuggestionsDelay",z[z.readOnly=77]="readOnly",z[z.renameOnType=78]="renameOnType",z[z.renderControlCharacters=79]="renderControlCharacters",z[z.renderIndentGuides=80]="renderIndentGuides",z[z.renderFinalNewline=81]="renderFinalNewline",z[z.renderLineHighlight=82]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=84]="renderValidationDecorations",z[z.renderWhitespace=85]="renderWhitespace",z[z.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",z[z.roundedSelection=87]="roundedSelection",z[z.rulers=88]="rulers",z[z.scrollbar=89]="scrollbar",z[z.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=91]="scrollBeyondLastLine",z[z.scrollPredominantAxis=92]="scrollPredominantAxis",z[z.selectionClipboard=93]="selectionClipboard",z[z.selectionHighlight=94]="selectionHighlight",z[z.selectOnLineNumbers=95]="selectOnLineNumbers",z[z.showFoldingControls=96]="showFoldingControls",z[z.showUnused=97]="showUnused",z[z.snippetSuggestions=98]="snippetSuggestions",z[z.smartSelect=99]="smartSelect",z[z.smoothScrolling=100]="smoothScrolling",z[z.stickyTabStops=101]="stickyTabStops",z[z.stopRenderingLineAfter=102]="stopRenderingLineAfter",z[z.suggest=103]="suggest",z[z.suggestFontSize=104]="suggestFontSize",z[z.suggestLineHeight=105]="suggestLineHeight",z[z.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",z[z.suggestSelection=107]="suggestSelection",z[z.tabCompletion=108]="tabCompletion",z[z.tabIndex=109]="tabIndex",z[z.unusualLineTerminators=110]="unusualLineTerminators",z[z.useTabStops=111]="useTabStops",z[z.wordSeparators=112]="wordSeparators",z[z.wordWrap=113]="wordWrap",z[z.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=116]="wordWrapColumn",z[z.wordWrapOverride1=117]="wordWrapOverride1",z[z.wordWrapOverride2=118]="wordWrapOverride2",z[z.wrappingIndent=119]="wrappingIndent",z[z.wrappingStrategy=120]="wrappingStrategy",z[z.showDeprecated=121]="showDeprecated",z[z.inlineHints=122]="inlineHints",z[z.editorClassName=123]="editorClassName",z[z.pixelRatio=124]="pixelRatio",z[z.tabFocusMode=125]="tabFocusMode",z[z.layoutInfo=126]="layoutInfo",z[z.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(111,null)})),acceptSuggestionOnEnter:_e(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(112,null),""],markdownDescription:w.localize(113,null)})),accessibilitySupport:_e(new p),accessibilityPageSize:_e(new o(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(114,null)})),ariaLabel:_e(new g(4,"ariaLabel",w.localize(115,null))),autoClosingBrackets:_e(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(116,null),w.localize(117,null),""],description:w.localize(118,null)})),autoClosingDelete:_e(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(119,null),""],description:w.localize(120,null)})),autoClosingOvertype:_e(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(121,null),""],description:w.localize(122,null)})),autoClosingQuotes:_e(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(123,null),w.localize(124,null),""],description:w.localize(125,null)})),autoIndent:_e(new m(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[w.localize(126,null),w.localize(127,null),w.localize(128,null),w.localize(129,null),w.localize(130,null)],description:w.localize(131,null)})),automaticLayout:_e(new d(10,"automaticLayout",!1)),autoSurround:_e(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(132,null),w.localize(133,null),w.localize(134,null),""],description:w.localize(135,null)})),stickyTabStops:_e(new d(101,"stickyTabStops",!1,{description:w.localize(136,null)})),codeLens:_e(new d(12,"codeLens",!0,{description:w.localize(137,null)})),codeLensFontFamily:_e(new g(13,"codeLensFontFamily","",{description:w.localize(138,null)})),codeLensFontSize:_e(new o(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:w.localize(139,null)})),colorDecorators:_e(new d(15,"colorDecorators",!0,{description:w.localize(140,null)})),columnSelection:_e(new d(16,"columnSelection",!1,{description:w.localize(141,null)})),comments:_e(new t),contextmenu:_e(new d(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new d(19,"copyWithSyntaxHighlighting",!0,{description:w.localize(142,null)})),cursorBlinking:_e(new m(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:w.localize(143,null)})),cursorSmoothCaretAnimation:_e(new d(21,"cursorSmoothCaretAnimation",!1,{description:w.localize(144,null)})),cursorStyle:_e(new m(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:w.localize(145,null)})),cursorSurroundingLines:_e(new o(23,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(146,null)})),cursorSurroundingLinesStyle:_e(new _(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(147,null),w.localize(148,null)],description:w.localize(149,null)})),cursorWidth:_e(new o(25,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(150,null)})),disableLayerHinting:_e(new d(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new d(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new d(28,"domReadOnly",!1)),dragAndDrop:_e(new d(29,"dragAndDrop",!0,{description:w.localize(151,null)})),emptySelectionClipboard:_e(new T),extraEditorClassName:_e(new g(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new a(32,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:w.localize(152,null)})),find:_e(new b),fixedOverflowWidgets:_e(new d(34,"fixedOverflowWidgets",!1)),folding:_e(new d(35,"folding",!0,{description:w.localize(153,null)})),foldingStrategy:_e(new _(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(154,null),w.localize(155,null)],description:w.localize(156,null)})),foldingHighlight:_e(new d(37,"foldingHighlight",!0,{description:w.localize(157,null)})),unfoldOnClickAfterEndOfLine:_e(new d(38,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(158,null)})),fontFamily:_e(new g(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(159,null)})),fontInfo:_e(new F),fontLigatures2:_e(new E),fontSize:_e(new L),fontWeight:_e(new K),formatOnPaste:_e(new d(44,"formatOnPaste",!1,{description:w.localize(160,null)})),formatOnType:_e(new d(45,"formatOnType",!1,{description:w.localize(161,null)})),glyphMargin:_e(new d(46,"glyphMargin",!0,{description:w.localize(162,null)})),gotoLocation:_e(new fe),hideCursorInOverviewRuler:_e(new d(48,"hideCursorInOverviewRuler",!1,{description:w.localize(163,null)})),highlightActiveIndentGuide:_e(new d(49,"highlightActiveIndentGuide",!0,{description:w.localize(164,null)})),hover:_e(new j),inDiffEditor:_e(new d(51,"inDiffEditor",!1)),letterSpacing:_e(new a(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>a.clamp(z,-5,20),{description:w.localize(165,null)})),lightbulb:_e(new O),lineDecorationsWidth:_e(new I(54,"lineDecorationsWidth",10)),lineHeight:_e(new N),lineNumbers:_e(new Oe),lineNumbersMinChars:_e(new o(57,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new d(58,"linkedEditing",!1,{description:w.localize(166,null)})),links:_e(new d(59,"links",!0,{description:w.localize(167,null)})),matchBrackets:_e(new _(60,"matchBrackets","always",["always","near","never"],{description:w.localize(168,null)})),minimap:_e(new $),mouseStyle:_e(new _(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new a(63,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:w.localize(169,null)})),mouseWheelZoom:_e(new d(64,"mouseWheelZoom",!1,{markdownDescription:w.localize(170,null)})),multiCursorMergeOverlapping:_e(new d(65,"multiCursorMergeOverlapping",!0,{description:w.localize(171,null)})),multiCursorModifier:_e(new m(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],U,{markdownEnumDescriptions:[w.localize(172,null),w.localize(173,null)],markdownDescription:w.localize(174,null)})),multiCursorPaste:_e(new _(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(175,null),w.localize(176,null)],markdownDescription:w.localize(177,null)})),occurrencesHighlight:_e(new d(68,"occurrencesHighlight",!0,{description:w.localize(178,null)})),overviewRulerBorder:_e(new d(69,"overviewRulerBorder",!0,{description:w.localize(179,null)})),overviewRulerLanes:_e(new o(70,"overviewRulerLanes",3,0,3)),padding:_e(new Q),parameterHints:_e(new Y),peekWidgetDefaultFocus:_e(new _(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(180,null),w.localize(181,null)],description:w.localize(182,null)})),definitionLinkOpensInPeek:_e(new d(74,"definitionLinkOpensInPeek",!1,{description:w.localize(183,null)})),quickSuggestions:_e(new pe),quickSuggestionsDelay:_e(new o(76,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(184,null)})),readOnly:_e(new d(77,"readOnly",!1)),renameOnType:_e(new d(78,"renameOnType",!1,{description:w.localize(185,null),markdownDeprecationMessage:w.localize(186,null)})),renderControlCharacters:_e(new d(79,"renderControlCharacters",!1,{description:w.localize(187,null)})),renderIndentGuides:_e(new d(80,"renderIndentGuides",!0,{description:w.localize(188,null)})),renderFinalNewline:_e(new d(81,"renderFinalNewline",!0,{description:w.localize(189,null)})),renderLineHighlight:_e(new _(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(190,null)],description:w.localize(191,null)})),renderLineHighlightOnlyWhenFocus:_e(new d(83,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(192,null)})),renderValidationDecorations:_e(new _(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new _(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(193,null),w.localize(194,null),w.localize(195,null),""],description:w.localize(196,null)})),revealHorizontalRightPadding:_e(new o(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new d(87,"roundedSelection",!0,{description:w.localize(197,null)})),rulers:_e(new Be),scrollbar:_e(new G),scrollBeyondLastColumn:_e(new o(90,"scrollBeyondLastColumn",5,0,1073741824,{description:w.localize(198,null)})),scrollBeyondLastLine:_e(new d(91,"scrollBeyondLastLine",!0,{description:w.localize(199,null)})),scrollPredominantAxis:_e(new d(92,"scrollPredominantAxis",!0,{description:w.localize(200,null)})),selectionClipboard:_e(new d(93,"selectionClipboard",!0,{description:w.localize(201,null),included:k.isLinux})),selectionHighlight:_e(new d(94,"selectionHighlight",!0,{description:w.localize(202,null)})),selectOnLineNumbers:_e(new d(95,"selectOnLineNumbers",!0)),showFoldingControls:_e(new _(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[w.localize(203,null),w.localize(204,null)],description:w.localize(205,null)})),showUnused:_e(new d(97,"showUnused",!0,{description:w.localize(206,null)})),showDeprecated:_e(new d(121,"showDeprecated",!0,{description:w.localize(207,null)})),inlineHints:_e(new R),snippetSuggestions:_e(new _(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(208,null),w.localize(209,null),w.localize(210,null),w.localize(211,null)],description:w.localize(212,null)})),smartSelect:_e(new oe),smoothScrolling:_e(new d(100,"smoothScrolling",!1,{description:w.localize(213,null)})),stopRenderingLineAfter:_e(new o(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new re),suggestFontSize:_e(new o(104,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(214,null)})),suggestLineHeight:_e(new o(105,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(215,null)})),suggestOnTriggerCharacters:_e(new d(106,"suggestOnTriggerCharacters",!0,{description:w.localize(216,null)})),suggestSelection:_e(new _(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(217,null),w.localize(218,null),w.localize(219,null)],description:w.localize(220,null)})),tabCompletion:_e(new _(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(221,null),w.localize(222,null),w.localize(223,null)],description:w.localize(224,null)})),tabIndex:_e(new o(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new _(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(225,null),w.localize(226,null),w.localize(227,null)],description:w.localize(228,null)})),useTabStops:_e(new d(111,"useTabStops",!0,{description:w.localize(229,null)})),wordSeparators:_e(new g(112,"wordSeparators",P.USUAL_WORD_SEPARATORS,{description:w.localize(230,null)})),wordWrap:_e(new _(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(231,null),w.localize(232,null),w.localize(233,null),w.localize(234,null)],description:w.localize(235,null)})),wordWrapBreakAfterCharacters:_e(new g(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new g(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new o(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(236,null)})),wordWrapOverride1:_e(new _(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new _(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new m(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ne,{enumDescriptions:[w.localize(237,null),w.localize(238,null),w.localize(239,null),w.localize(240,null)],description:w.localize(241,null)})),wrappingStrategy:_e(new _(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[w.localize(242,null),w.localize(243,null)],description:w.localize(244,null)})),editorClassName:_e(new v),pixelRatio:_e(new ie),tabFocusMode:_e(new me),layoutInfo:_e(new ee),wrappingInfo:_e(new ge)}}),define(be[123],we([16,17]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[124],we([16,17]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[125],we([16,17]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(be[126],we([16,17]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(be[127],we([16,17]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(be[128],we([16,17]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(be[129],we([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHost.api.impl",e)}),define(be[130],we([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[131],we([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(be[132],we([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[133],we([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(be[134],we([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[135],we([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[136],we([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[137],we([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[138],we([16,17]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(be[139],we([16,17]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[140],we([16,17]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[141],we([16,17]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[142],we([16,17]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[143],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var w;(function(S){S[S.ACTIVATE=0]="ACTIVATE",S[S.RESTORE=1]="RESTORE",S[S.PRESERVE=2]="PRESERVE"})(w=e.EditorActivation||(e.EditorActivation={}));var k;(function(S){S[S.PICK=1]="PICK",S[S.DISABLED=2]="DISABLED"})(k=e.EditorOverride||(e.EditorOverride={}));var P;(function(S){S[S.API=0]="API",S[S.USER=1]="USER"})(P=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(S){S[S.Center=0]="Center",S[S.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",S[S.NearTop=2]="NearTop",S[S.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[144],we([0,1,124]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function P(I){return I=I.trim(),I==="*"||k.test(I)}e.isValidVersionStr=P;function A(I){if(!P(I))return null;if(I=I.trim(),I==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let c=I.match(k);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.parseVersion=A;function S(I){if(!I)return null;let c=I.majorBase,d=I.majorMustEqual,o=I.minorBase,a=I.minorMustEqual,g=I.patchBase,h=I.patchMustEqual;return I.hasCaret&&(c===0||(a=!1),h=!1),{majorBase:c,majorMustEqual:d,minorBase:o,minorMustEqual:a,patchBase:g,patchMustEqual:h,isMinimum:I.hasGreaterEquals}}e.normalizeVersion=S;function D(I,c){let d;typeof I=="string"?d=S(A(I)):d=I;let o;if(typeof c=="string"?o=S(A(c)):o=c,!d||!o)return!1;let a=d.majorBase,g=d.minorBase,h=d.patchBase,_=o.majorBase,m=o.minorBase,u=o.patchBase,p=o.majorMustEqual,t=o.minorMustEqual,n=o.patchMustEqual;return o.isMinimum?a>_?!0:a<_?!1:g>m?!0:g<m?!1:h>=u:(a===1&&_===0&&(!p||!t||!n)&&(_=1,m=0,u=0,p=!0,t=!1,n=!1),a<_?!1:a>_?!p:g<m?!1:g>m?!t:h<u?!1:h>u?!n:!0)}e.isValidVersion=D;function y(I,c,d){return c.isBuiltin||typeof c.main=="undefined"?!0:i(I,c.engines.vscode,d)}e.isValidExtensionVersion=y;function C(I,c){return I==="*"||i(c,I)}e.isEngineValid=C;function i(I,c,d=[]){let o=S(A(c));if(!o)return d.push(w.localize(0,null,c)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return d.push(w.localize(1,null,c)),!1}else if(!o.majorMustEqual)return d.push(w.localize(2,null,c)),!1;return D(I,o)?!0:(d.push(w.localize(3,null,I,c)),!1)}e.isVersionValid=i}),define(be[89],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class w{constructor(A,S=[],D=!1){this.ctor=A,this.staticArguments=S,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=w;const k=(P,...A)=>new w(P,A);e.createSyncDescriptor=k}),define(be[61],we([0,1,89]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function P(S,D,y){D instanceof w.SyncDescriptor||(D=new w.SyncDescriptor(D,[],y)),k.push([S,D])}e.registerSingleton=P;function A(){return k}e.getSingletonServiceDescriptors=A}),define(be[145],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=w;class k{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let S of this._nodes.values())S.outgoing.size===0&&A.push(S);return A}insertEdge(A,S){const D=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(S);D.outgoing.set(this._hashFn(S),y),y.incoming.set(this._hashFn(A),D)}removeNode(A){const S=this._hashFn(A);this._nodes.delete(S);for(let D of this._nodes.values())D.outgoing.delete(S),D.incoming.delete(S)}lookupOrInsertNode(A){const S=this._hashFn(A);let D=this._nodes.get(S);return D||(D=new w(A),this._nodes.set(S,D)),D}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[S,D]of this._nodes)A.push(`${S}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,S]of this._nodes){const D=new Set([A]),y=this._findCycle(S,D);if(y)return y}}_findCycle(A,S){for(let[D,y]of A.outgoing){if(S.has(D))return[...S,D].join(" -> ");S.add(D);const C=this._findCycle(y,S);if(C)return C;S.delete(D)}}}e.Graph=k}),define(be[4],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(C){return C[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(w=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function k(D,y,C,i){y[w.DI_TARGET]===y?y[w.DI_DEPENDENCIES].push({id:D,index:C,optional:i}):(y[w.DI_DEPENDENCIES]=[{id:D,index:C,optional:i}],y[w.DI_TARGET]=y)}function P(D){if(w.serviceIds.has(D))return w.serviceIds.get(D);const y=function(C,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(y,C,I,!1)};return y.toString=()=>D,w.serviceIds.set(D,y),y}e.createDecorator=P;function A(D){return D}e.refineServiceDecorator=A;function S(D){return function(y,C,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(D,y,i,!0)}}e.optional=S}),define(be[146],we([0,1,4]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,w.createDecorator)("modelService");function k(P){return!P.isTooLargeForSyncing()&&!P.isForSimpleWidget}e.shouldSynchronizeModel=k}),define(be[147],we([0,1,3,56,6,22,81,59,146]),function(J,e,w,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(c){return typeof c=="string"?!1:Array.isArray(c)?c.every(C):!!c.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new w.Emitter}get onDidChange(){return this._onDidChange.event}register(d,o){let a={selector:d,provider:o,_score:-1,_time:this._clock++};return this._entries.push(a),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,P.toDisposable)(()=>{if(a){let g=this._entries.indexOf(a);g>=0&&(this._entries.splice(g,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),a=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const o=[];for(let a of this._entries)a._score>0&&o.push(a.provider);return o}ordered(d){const o=[];return this._orderedForEach(d,a=>o.push(a.provider)),o}orderedGroups(d){const o=[];let a,g;return this._orderedForEach(d,h=>{a&&g===h._score?a.push(h.provider):(g=h._score,a=[h.provider],o.push(a))}),o}_orderedForEach(d,o){if(!!d){this._updateScores(d);for(const a of this._entries)a._score>0&&o(a)}}_updateScores(d){let o={uri:d.uri.toString(),language:d.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===o.language&&this._lastCandidate.uri===o.uri)){this._lastCandidate=o;for(let a of this._entries)if(a._score=(0,D.score)(a.selector,d.uri,d.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(d)),C(a.selector)&&a._score>0){for(let g of this._entries)g._score=0;a._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(d,o){return d._score<o._score?1:d._score>o._score?-1:d._time<o._time?1:d._time>o._time?-1:0}}e.LanguageFeatureRegistry=i;class I{constructor(d,o,a=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=o,this.max=a,this._cache=new A.LRUCache(50,.7)}_key(d){return d.id+(0,k.hash)(this._registry.all(d))}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const o=this._key(d),a=this._cache.get(o);return this._clamp(a==null?void 0:a.value)}update(d,o){const a=this._key(d);let g=this._cache.get(a);return g||(g=new S.MovingAverage,this._cache.set(a,g)),g.update(o),this.get(d)}}e.LanguageFeatureRequestDelays=I}),define(be[62],we([0,1,2,32,147,118,36]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(b){b[b.Null=0]="Null",b[b.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class y{constructor(E,F){this.language=E,this.id=F}}e.LanguageIdentifier=y;var C;(function(b){b[b.NotSet=-1]="NotSet",b[b.None=0]="None",b[b.Italic=1]="Italic",b[b.Bold=2]="Bold",b[b.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var i;(function(b){b[b.None=0]="None",b[b.DefaultForeground=1]="DefaultForeground",b[b.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var I;(function(b){b[b.Other=0]="Other",b[b.Comment=1]="Comment",b[b.String=2]="String",b[b.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var c;(function(b){b[b.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",b[b.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",b[b.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",b[b.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",b[b.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",b[b.ITALIC_MASK=2048]="ITALIC_MASK",b[b.BOLD_MASK=4096]="BOLD_MASK",b[b.UNDERLINE_MASK=8192]="UNDERLINE_MASK",b[b.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",b[b.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",b[b.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",b[b.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",b[b.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",b[b.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",b[b.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",b[b.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",b[b.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",b[b.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(c=e.MetadataConsts||(e.MetadataConsts={}));class d{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let F=this.getForeground(E),L="mtk"+F,K=this.getFontStyle(E);return K&1&&(L+=" mtki"),K&2&&(L+=" mtkb"),K&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(E,F){const L=this.getForeground(E),K=this.getFontStyle(E);let fe=`color: ${F[L]};`;return K&1&&(fe+="font-style: italic;"),K&2&&(fe+="font-weight: bold;"),K&4&&(fe+="text-decoration: underline;"),fe}}e.TokenMetadata=d;var o;(function(b){b[b.Method=0]="Method",b[b.Function=1]="Function",b[b.Constructor=2]="Constructor",b[b.Field=3]="Field",b[b.Variable=4]="Variable",b[b.Class=5]="Class",b[b.Struct=6]="Struct",b[b.Interface=7]="Interface",b[b.Module=8]="Module",b[b.Property=9]="Property",b[b.Event=10]="Event",b[b.Operator=11]="Operator",b[b.Unit=12]="Unit",b[b.Value=13]="Value",b[b.Constant=14]="Constant",b[b.Enum=15]="Enum",b[b.EnumMember=16]="EnumMember",b[b.Keyword=17]="Keyword",b[b.Text=18]="Text",b[b.Color=19]="Color",b[b.File=20]="File",b[b.Reference=21]="Reference",b[b.Customcolor=22]="Customcolor",b[b.Folder=23]="Folder",b[b.TypeParameter=24]="TypeParameter",b[b.User=25]="User",b[b.Issue=26]="Issue",b[b.Snippet=27]="Snippet"})(o=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let b=Object.create(null);return b[0]="symbol-method",b[1]="symbol-function",b[2]="symbol-constructor",b[3]="symbol-field",b[4]="symbol-variable",b[5]="symbol-class",b[6]="symbol-struct",b[7]="symbol-interface",b[8]="symbol-module",b[9]="symbol-property",b[10]="symbol-event",b[11]="symbol-operator",b[12]="symbol-unit",b[13]="symbol-value",b[14]="symbol-constant",b[15]="symbol-enum",b[16]="symbol-enum-member",b[17]="symbol-keyword",b[27]="symbol-snippet",b[18]="symbol-text",b[19]="symbol-color",b[20]="symbol-file",b[21]="symbol-reference",b[22]="symbol-customcolor",b[23]="symbol-folder",b[24]="symbol-type-parameter",b[25]="account",b[26]="issues",function(E){const F=b[E];let L=F&&S.iconRegistry.get(F);return L||(console.info("No codicon found for CompletionItemKind "+E),L=S.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let b=Object.create(null);return b.method=0,b.function=1,b.constructor=2,b.field=3,b.variable=4,b.class=5,b.struct=6,b.interface=7,b.module=8,b.property=9,b.event=10,b.operator=11,b.unit=12,b.value=13,b.constant=14,b.enum=15,b["enum-member"]=16,b.enumMember=16,b.keyword=17,b.snippet=27,b.text=18,b.color=19,b.file=20,b.reference=21,b.customcolor=22,b.folder=23,b["type-parameter"]=24,b.typeParameter=24,b.account=25,b.issue=26,function(E,F){let L=b[E];return typeof L=="undefined"&&!F&&(L=9),L}}();var a;(function(b){b[b.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var g;(function(b){b[b.KeepWhitespace=1]="KeepWhitespace",b[b.InsertAsSnippet=4]="InsertAsSnippet"})(g=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var h;(function(b){b[b.Invoke=0]="Invoke",b[b.TriggerCharacter=1]="TriggerCharacter",b[b.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(b){b[b.Invoke=1]="Invoke",b[b.Auto=2]="Auto"})(_=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(b){b[b.Invoke=1]="Invoke",b[b.TriggerCharacter=2]="TriggerCharacter",b[b.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(b){b[b.Text=0]="Text",b[b.Read=1]="Read",b[b.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(b){return b&&w.URI.isUri(b.uri)&&k.Range.isIRange(b.range)&&(k.Range.isIRange(b.originSelectionRange)||k.Range.isIRange(b.targetSelectionRange))}e.isLocationLink=p;var t;(function(b){b[b.File=0]="File",b[b.Module=1]="Module",b[b.Namespace=2]="Namespace",b[b.Package=3]="Package",b[b.Class=4]="Class",b[b.Method=5]="Method",b[b.Property=6]="Property",b[b.Field=7]="Field",b[b.Constructor=8]="Constructor",b[b.Enum=9]="Enum",b[b.Interface=10]="Interface",b[b.Function=11]="Function",b[b.Variable=12]="Variable",b[b.Constant=13]="Constant",b[b.String=14]="String",b[b.Number=15]="Number",b[b.Boolean=16]="Boolean",b[b.Array=17]="Array",b[b.Object=18]="Object",b[b.Key=19]="Key",b[b.Null=20]="Null",b[b.EnumMember=21]="EnumMember",b[b.Struct=22]="Struct",b[b.Event=23]="Event",b[b.Operator=24]="Operator",b[b.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(b){b[b.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var s;(function(b){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function L(j){return E.get(j)}b.fromString=L;function K(j){return F.get(j)}b.toString=K;function fe(j,H){const ee=F.get(j);let O=ee&&S.iconRegistry.get("symbol-"+ee);return O||(console.info("No codicon found for SymbolKind "+j),O=S.Codicon.symbolProperty),`${H?"inline":"block"} ${O.classNames}`}b.toCssClassName=fe})(s=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(E){this.value=E}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var l;(function(b){b[b.Collapsed=0]="Collapsed",b[b.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(b){b[b.Editing=0]="Editing",b[b.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var v;(function(b){b[b.Other=0]="Other",b[b.Type=1]="Type",b[b.Parameter=2]="Parameter"})(v=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new P.LanguageFeatureRegistry,e.RenameProviderRegistry=new P.LanguageFeatureRegistry,e.CompletionProviderRegistry=new P.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new P.LanguageFeatureRegistry,e.HoverProviderRegistry=new P.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new P.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new P.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new P.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new P.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new P.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new P.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new P.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new P.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new P.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.LinkProviderRegistry=new P.LanguageFeatureRegistry,e.ColorProviderRegistry=new P.LanguageFeatureRegistry,e.SelectionRangeRegistry=new P.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new P.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var T;(function(b){b[b.None=0]="None",b[b.Option=1]="Option",b[b.Default=2]="Default",b[b.Preferred=3]="Preferred"})(T=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[148],we([0,1,6,10,4,3,45,43]),function(J,e,w,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,P.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,C){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!C)throw new Error("invalid command");return this.registerCommand({id:y,handler:C})}if(y.description){const o=[];for(let g of y.description.args)o.push(g.constraint);const a=y.handler;y.handler=function(g,...h){return(0,k.validateConstraints)(h,o),a(g,...h)}}const{id:i}=y;let I=this._commands.get(i);I||(I=new S.LinkedList,this._commands.set(i,I));let c=I.unshift(y),d=(0,w.toDisposable)(()=>{c();const o=this._commands.get(i);(o==null?void 0:o.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),d}registerCommandAlias(y,C){return e.CommandsRegistry.registerCommand(y,(i,...I)=>i.get(e.ICommandService).executeCommand(C,...I))}getCommand(y){const C=this._commands.get(y);if(!(!C||C.isEmpty()))return D.Iterable.first(C)}getCommands(){const y=new Map;for(const C of this._commands.keys()){const i=this.getCommand(C);i&&y.set(C,i)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>w.Disposable.None,onDidExecuteCommand:()=>w.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(be[63],we([0,1,8,4,21]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=P.userAgent||"";const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",P.isMacintosh),S.set("isLinux",P.isLinux),S.set("isWindows",P.isWindows),S.set("isWeb",P.isWeb),S.set("isMacNative",P.isMacintosh&&!P.isWeb),S.set("isEdge",A.indexOf("Edg/")>=0),S.set("isFirefox",A.indexOf("Firefox")>=0),S.set("isChrome",A.indexOf("Chrome")>=0),S.set("isSafari",A.indexOf("Safari")>=0),S.set("isIPad",A.indexOf("iPad")>=0);const D=Object.prototype.hasOwnProperty;var y;(function(b){b[b.False=0]="False",b[b.True=1]="True",b[b.Defined=2]="Defined",b[b.Not=3]="Not",b[b.Equals=4]="Equals",b[b.NotEquals=5]="NotEquals",b[b.And=6]="And",b[b.Regex=7]="Regex",b[b.NotRegex=8]="NotRegex",b[b.Or=9]="Or",b[b.In=10]="In",b[b.NotIn=11]="NotIn",b[b.Greater=12]="Greater",b[b.GreaterEquals=13]="GreaterEquals",b[b.Smaller=14]="Smaller",b[b.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return I.INSTANCE}static true(){return c.INSTANCE}static has(E){return d.create(E)}static equals(E,F){return o.create(E,F)}static notEquals(E,F){return h.create(E,F)}static regex(E,F){return n.create(E,F)}static in(E,F){return a.create(E,F)}static not(E){return _.create(E)}static and(...E){return r.create(E)}static or(...E){return l.create(E)}static greater(E,F){return m.create(E,F)}static less(E,F){return p.create(E,F)}static deserialize(E,F=!1){if(!!E)return this._deserializeOrExpression(E,F)}static _deserializeOrExpression(E,F){let L=E.split("||");return l.create(L.map(K=>this._deserializeAndExpression(K,F)))}static _deserializeAndExpression(E,F){let L=E.split("&&");return r.create(L.map(K=>this._deserializeOne(K,F)))}static _deserializeOne(E,F){if(E=E.trim(),E.indexOf("!=")>=0){let L=E.split("!=");return h.create(L[0].trim(),this._deserializeValue(L[1],F))}if(E.indexOf("==")>=0){let L=E.split("==");return o.create(L[0].trim(),this._deserializeValue(L[1],F))}if(E.indexOf("=~")>=0){let L=E.split("=~");return n.create(L[0].trim(),this._deserializeRegexValue(L[1],F))}if(E.indexOf(" in ")>=0){let L=E.split(" in ");return a.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const L=E.split(">=");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const L=E.split(">");return m.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const L=E.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const L=E.split("<");return p.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(E)?_.create(E.substr(1).trim()):d.create(E)}static _deserializeValue(E,F){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let L=/^'([^']*)'$/.exec(E);return L?L[1].trim():E}static _deserializeRegexValue(E,F){if((0,w.isFalsyOrWhitespace)(E)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=E.indexOf("/"),K=E.lastIndexOf("/");if(L===K||L<0){if(F)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let fe=E.slice(L+1,K),j=E[K+1]==="i"?"i":"";try{return new RegExp(fe,j)}catch(H){if(F)throw new Error(`bad regexp-value '${E}', parse error: ${H}`);return console.warn(`bad regexp-value '${E}', parse error: ${H}`),null}}}e.ContextKeyExpr=C;function i(b,E){return b.cmp(E)}class I{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class c{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class d{constructor(E){this.key=E,this.type=2}static create(E){const F=S.get(E);return typeof F=="boolean"?F?c.INSTANCE:I.INSTANCE:new d(E)}cmp(E){return E.type!==this.type?this.type-E.type:v(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return _.create(this.key)}}e.ContextKeyDefinedExpr=d;class o{constructor(E,F){this.key=E,this.value=F,this.type=4}static create(E,F){if(typeof F=="boolean")return F?d.create(E):_.create(E);const L=S.get(E);return typeof L=="boolean"?F===(L?"true":"false")?c.INSTANCE:I.INSTANCE:new o(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:T(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyEqualsExpr=o;class a{constructor(E,F){this.key=E,this.valueKey=F,this.type=10}static create(E,F){return new a(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:T(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}evaluate(E){const F=E.getValue(this.valueKey),L=E.getValue(this.key);return Array.isArray(F)?F.indexOf(L)>=0:typeof L=="string"&&typeof F=="object"&&F!==null?D.call(F,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return g.create(this)}}e.ContextKeyInExpr=a;class g{constructor(E){this._actual=E,this.type=11}static create(E){return new g(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new g(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class h{constructor(E,F){this.key=E,this.value=F,this.type=5}static create(E,F){if(typeof F=="boolean")return F?_.create(E):d.create(E);const L=S.get(E);return typeof L=="boolean"?F===(L?"true":"false")?I.INSTANCE:c.INSTANCE:new h(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:T(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=h;class _{constructor(E){this.key=E,this.type=3}static create(E){const F=S.get(E);return typeof F=="boolean"?F?I.INSTANCE:c.INSTANCE:new _(E)}cmp(E){return E.type!==this.type?this.type-E.type:v(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return d.create(this.key)}}e.ContextKeyNotExpr=_;class m{constructor(E,F){this.key=E,this.value=F,this.type=12}static create(E,F){return new m(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:T(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=m;class u{constructor(E,F){this.key=E,this.value=F,this.type=13}static create(E,F){return new u(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:T(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class p{constructor(E,F){this.key=E,this.value=F,this.type=14}static create(E,F){return new p(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:T(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=p;class t{constructor(E,F){this.key=E,this.value=F,this.type=15}static create(E,F){return new t(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:T(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(E,F){this.key=E,this.regexp=F,this.type=7}static create(E,F){return new n(E,F)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const F=this.regexp?this.regexp.source:"",L=E.regexp?E.regexp.source:"";return F<L?-1:F>L?1:0}equals(E){if(E.type===this.type){const F=this.regexp?this.regexp.source:"",L=E.regexp?E.regexp.source:"";return this.key===E.key&&F===L}return!1}evaluate(E){let F=E.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(E){this._actual=E,this.type=8}static create(E){return new s(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new s(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class r{constructor(E){this.expr=E,this.type=6}static create(E){return r._normalizeArr(E)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,L=this.expr.length;F<L;F++){const K=i(this.expr[F],E.expr[F]);if(K!==0)return K}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,L=this.expr.length;F<L;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}evaluate(E){for(let F=0,L=this.expr.length;F<L;F++)if(!this.expr[F].evaluate(E))return!1;return!0}static _normalizeArr(E){const F=[];let L=!1;for(const K of E)if(!!K){if(K.type===1){L=!0;continue}if(K.type===0)return I.INSTANCE;if(K.type===6){F.push(...K.expr);continue}F.push(K)}if(F.length===0&&L)return c.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(i);F.length>1;){const K=F[F.length-1];if(K.type!==9)break;F.pop();const fe=F.pop(),j=l.create(K.expr.map(H=>r.create([H,fe])));j&&(F.push(j),F.sort(i))}return F.length===1?F[0]:new r(F)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let F of this.expr)E.push(...F.keys());return E}map(E){return new r(this.expr.map(F=>F.map(E)))}negate(){let E=[];for(let F of this.expr)E.push(F.negate());return l.create(E)}}e.ContextKeyAndExpr=r;class l{constructor(E){this.expr=E,this.type=9}static create(E){const F=l._normalizeArr(E);if(F.length!==0)return F.length===1?F[0]:new l(F)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,L=this.expr.length;F<L;F++){const K=i(this.expr[F],E.expr[F]);if(K!==0)return K}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,L=this.expr.length;F<L;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}evaluate(E){for(let F=0,L=this.expr.length;F<L;F++)if(this.expr[F].evaluate(E))return!0;return!1}static _normalizeArr(E){let F=[],L=!1;if(E){for(let K=0,fe=E.length;K<fe;K++){const j=E[K];if(!!j){if(j.type===0){L=!0;continue}if(j.type===1)return[c.INSTANCE];if(j.type===9){F=F.concat(j.expr);continue}F.push(j)}}if(F.length===0&&L)return[I.INSTANCE];F.sort(i)}return F}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let F of this.expr)E.push(...F.keys());return E}map(E){return new l(this.expr.map(F=>F.map(E)))}negate(){let E=[];for(let L of this.expr)E.push(L.negate());const F=L=>L.type===9?L.expr:[L];for(;E.length>1;){const L=E.shift(),K=E.shift(),fe=[];for(const j of F(L))for(const H of F(K))fe.push(C.and(j,H));E.unshift(C.or(...fe))}return E[0]}}e.ContextKeyOrExpr=l;class f extends d{constructor(E,F,L){super(E);this._defaultValue=F,typeof L=="object"?f._info.push(Object.assign(Object.assign({},L),{key:E})):L!==!0&&f._info.push({key:E,description:L,type:F!=null?typeof F:void 0})}static all(){return f._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(E){return C.equals(this.key,E)}notEqualsTo(E){return C.notEquals(this.key,E)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(b,E){return b<E?-1:b>E?1:0}function T(b,E,F,L){return b<F?-1:b>F?1:E<L?-1:E>L?1:0}}),define(be[149],we([0,1,4]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],we([0,1,8,4]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function P(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(C){C[C.System=0]="System",C[C.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class S{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,I){if(typeof i=="undefined"||i===null)return typeof I=="undefined"||I===null;if(typeof I=="undefined"||I===null)return!1;if(typeof i=="string"||typeof I=="string"){let c=typeof i=="string"?i:i.value,d=typeof I=="string"?I:I.value;return w.equalsIgnoreCase(c,d)}return i._lower===I._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=S;function D(C){return C.contributes&&C.contributes.localizations?C.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function y(C){return C.contributes&&C.contributes.authentication?C.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[150],we([0,1,8,26]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function P(d,o){return d.uuid&&o.uuid?d.uuid===o.uuid:d.id===o.id?!0:(0,w.compareIgnoreCase)(d.id,o.id)===0}e.areSameExtensions=P;class A{constructor(o,a){this.version=a,this.id=o.id,this.uuid=o.uuid}key(){return`${this.id}-${this.version}`}equals(o){return o instanceof A?P(this,o)&&this.version===o.version:!1}}e.ExtensionIdentifierWithVersion=A;function S(d,o){return`${d}.${o}`}e.getExtensionId=S;function D(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function y(d,o){return D(S(d,o))}e.getGalleryExtensionId=y;function C(d,o){const a=[],g=h=>{for(const _ of a)if(_.some(m=>P(o(m),o(h))))return _;return null};for(const h of d){const _=g(h);_?_.push(h):a.push([h])}return a}e.groupByExtension=C;function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(d){return Object.assign({id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0)},d.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function c(d){const o=new Set;for(const a of d)a.malicious&&o.add(a.id.id);return o}e.getMaliciousExtensionsSet=c}),define(be[64],we([0,1,125,14,2,4,8,10,22]),function(J,e,w,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function C(j){return j.create===!0}e.isFileOpenForWriteOptions=C;var i;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function c(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=c;function d(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=d;function o(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function a(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=a;var g;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(H,ee){super(H);this.code=ee}}e.FileSystemProviderError=h;function _(j,H){const ee=new h(j.toString(),H);return u(ee,H),ee}e.createFileSystemProviderError=_;function m(j){return j||_((0,w.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=m;function u(j,H){return j.name=H?`${H} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=u;function p(j){if(!j)return g.Unknown;if(j instanceof h)return j.code;const H=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!H)return g.Unknown;switch(H[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=p;function t(j){if(j instanceof v)return j.fileOperationResult;switch(p(j)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(H,ee,O){this.resource=H,this.operation=ee,this.target=O}isOperation(H){return this.operation===H}}e.FileOperationEvent=s;var r;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class l{constructor(H,ee){this.ignorePathCasing=ee,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=H;for(const O of H)switch(O.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(O.resource,O);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(O.resource,O);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(O.resource,O);break}}contains(H,...ee){return this.doContains(H,{includeChildren:!1},...ee)}affects(H,...ee){return this.doContains(H,{includeChildren:!0},...ee)}doContains(H,ee,...O){var R,N,$,U,Q,Y;if(!H)return!1;const ie=O.length>0;return!!((!ie||O.includes(1))&&(((R=this.added)===null||R===void 0?void 0:R.get(H))||ee.includeChildren&&((N=this.added)===null||N===void 0?void 0:N.findSuperstr(H)))||(!ie||O.includes(0))&&((($=this.updated)===null||$===void 0?void 0:$.get(H))||ee.includeChildren&&((U=this.updated)===null||U===void 0?void 0:U.findSuperstr(H)))||(!ie||O.includes(2))&&(((Q=this.deleted)===null||Q===void 0?void 0:Q.findSubstr(H))||ee.includeChildren&&((Y=this.deleted)===null||Y===void 0?void 0:Y.findSuperstr(H))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(H){const ee=[],O=H===1?this.added:H===0?this.updated:this.deleted;if(O)for(const[,R]of O)ee.push(R);return ee}filter(H){return new l(this.changes.filter(ee=>H(ee)),this.ignorePathCasing)}}e.FileChangesEvent=l;function f(j,H,ee){return!j||!H||j===H||H.length>j.length?!1:(H.charAt(H.length-1)!==k.sep&&(H+=k.sep),ee?(0,S.startsWithIgnoreCase)(j,H):j.indexOf(H)===0)}e.isParent=f;class v extends Error{constructor(H,ee,O){super(H);this.fileOperationResult=ee,this.options=O}static isFileOperationError(H){return H instanceof Error&&!(0,D.isUndefinedOrNull)(H.fileOperationResult)}}e.FileOperationError=v;var T;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var b;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(b=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function E(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=E;async function F(j,H){if(!H.canHandleResource(P.URI.from({scheme:j.scheme})))return new Promise(ee=>{const O=H.onDidChangeFileSystemProviderRegistrations(R=>{R.scheme===j.scheme&&R.added&&(O.dispose(),ee())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(H){return(0,D.isNumber)(H)||(H=0),H<L.KB?(0,w.localize)(1,null,H.toFixed(0)):H<L.MB?(0,w.localize)(2,null,(H/L.KB).toFixed(2)):H<L.GB?(0,w.localize)(3,null,(H/L.MB).toFixed(2)):H<L.TB?(0,w.localize)(4,null,(H/L.GB).toFixed(2)):(0,w.localize)(5,null,(H/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var K;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function fe(j){return{maxFileSize:j===0?300*L.MB:16*L.GB,maxHeapSize:j===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=fe}),define(be[65],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...P){this._entries=new Map;for(let[A,S]of P)this.set(A,S)}set(P,A){const S=this._entries.get(P);return this._entries.set(P,A),S}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=w}),define(be[151],we([0,1,12,145,89,4,65,11]),function(J,e,w,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class C extends Error{constructor(o){var a;super("cyclic dependency between services");this.message=(a=o.findCycleSlow())!==null&&a!==void 0?a:`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class i{constructor(o=new S.ServiceCollection,a=!1,g){this._activeInstantiations=new Set,this._services=o,this._strict=a,this._parent=g,this._services.set(A.IInstantiationService,this)}createChild(o){return new i(o,this._strict,this)}invokeFunction(o,...a){let g=c.traceInvocation(o),h=!1;try{return o({get:(m,u)=>{if(h)throw(0,w.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(m,g);if(!p&&u!==A.optional)throw new Error(`[invokeFunction] unknown service '${m}'`);return p}},...a)}finally{h=!0,g.stop()}}createInstance(o,...a){let g,h;return o instanceof P.SyncDescriptor?(g=c.traceCreation(o.ctor),h=this._createInstance(o.ctor,o.staticArguments.concat(a),g)):(g=c.traceCreation(o),h=this._createInstance(o,a,g)),g.stop(),h}_createInstance(o,a=[],g){let h=A._util.getServiceDependencies(o).sort((u,p)=>u.index-p.index),_=[];for(const u of h){let p=this._getOrCreateServiceInstance(u.id,g);if(!p&&this._strict&&!u.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${u.id}.`);_.push(p)}let m=h.length>0?h[0].index:a.length;if(a.length!==m){console.warn(`[createInstance] First service dependency of ${o.name} at position ${m+1} conflicts with ${a.length} static arguments`);let u=m-a.length;u>0?a=a.concat(new Array(u)):a=a.slice(0,m)}return new o(...[...a,..._])}_setServiceInstance(o,a){if(this._services.get(o)instanceof P.SyncDescriptor)this._services.set(o,a);else if(this._parent)this._parent._setServiceInstance(o,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let a=this._services.get(o);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):a}_getOrCreateServiceInstance(o,a){let g=this._getServiceInstanceOrDescriptor(o);return g instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,g,a.branch(o,!0)):(a.branch(o,!1),g)}_safeCreateAndCacheServiceInstance(o,a,g){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,a,g)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,a,g){const h=new k.Graph(u=>u.id.toString());let _=0;const m=[{id:o,desc:a,_trace:g}];for(;m.length;){const u=m.pop();if(h.lookupOrInsertNode(u),_++>1e3)throw new C(h);for(let p of A._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${o} depends on ${p.id} which is NOT registered.`),t instanceof P.SyncDescriptor){const n={id:p.id,desc:t,_trace:u._trace.branch(p.id,!0)};h.insertEdge(u,n),m.push(n)}}}for(;;){const u=h.roots();if(u.length===0){if(!h.isEmpty())throw new C(h);break}for(const{data:p}of u){if(this._getServiceInstanceOrDescriptor(p.id)instanceof P.SyncDescriptor){const n=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,n)}h.removeNode(p)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,a,g=[],h,_){if(this._services.get(o)instanceof P.SyncDescriptor)return this._createServiceInstance(a,g,h,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,a,g,h,_);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(o,a=[],g,h){if(g){const _=new D.IdleValue(()=>this._createInstance(o,a,h));return new Proxy(Object.create(null),{get(m,u){if(u in m)return m[u];let p=_.value,t=p[u];return typeof t!="function"||(t=t.bind(p),m[u]=t),t},set(m,u,p){return _.value[u]=p,!0}})}else return this._createInstance(o,a,h)}}e.InstantiationService=i;var I;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(I||(I={}));class c{constructor(o,a){this.type=o,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return y?new c(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(o){return y?new c(0,o.name):c._None}branch(o,a){let g=new c(2,o.toString());return this._dep.push([o,a,g]),g}stop(){let o=Date.now()-this._start;c._totals+=o;let a=!1;function g(_,m){let u=[],p=new Array(_+1).join("	");for(const[t,n,s]of m._dep)if(n&&s){a=!0,u.push(`${p}CREATES -> ${t}`);let r=g(_+1,s);r&&u.push(r)}else u.push(`${p}uses -> ${t}`);return u.join(`
`)}let h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(o>2||a)&&console.log(h.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(be[19],we([0,1,4,6,21,3,60]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function D(){return new Date().toISOString()}var y;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class C extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class i extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(y.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(y.Error,this.format(s))}else this.log(y.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}n+=(s>0?" ":"")+r}return n}}e.AbstractMessageLogger=i;class I extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!P.isWindows}trace(t,...n){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}debug(t,...n){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}info(t,...n){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}warn(t,...n){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...n):console.warn(`[main ${D()}]`,t,...n))}error(t,...n){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}critical(t,...n){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class c extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=c;class d extends C{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,S.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class o extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=o;class a extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=a;class g extends k.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?y.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class h{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=h;function _(p){if(p.verbose)return y.Trace;if(typeof p.logLevel=="string"){const t=m(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function m(p){switch(p){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=m;function u(p){switch(p){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=u}),define(be[90],we([0,1,4,126,47]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function C(o,a){return a-o}y.compare=C;const i=Object.create(null);i[y.Error]=(0,k.localize)(0,null),i[y.Warning]=(0,k.localize)(1,null),i[y.Info]=(0,k.localize)(2,null);function I(o){return i[o]||""}y.toString=I;function c(o){switch(o){case P.default.Error:return y.Error;case P.default.Warning:return y.Warning;case P.default.Info:return y.Info;case P.default.Ignore:return y.Hint}}y.fromSeverity=c;function d(o){switch(o){case y.Error:return P.default.Error;case y.Warning:return P.default.Warning;case y.Info:return P.default.Info;case y.Hint:return P.default.Ignore}}y.toSeverity=d}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(y){const C="";function i(c){return I(c,!0)}y.makeKey=i;function I(c,d){let o=[C];return c.source?o.push(c.source.replace("\xA6","\\\xA6")):o.push(C),c.code?typeof c.code=="string"?o.push(c.code.replace("\xA6","\\\xA6")):o.push(c.code.value.replace("\xA6","\\\xA6")):o.push(C),c.severity!==void 0&&c.severity!==null?o.push(S.toString(c.severity)):o.push(C),c.message&&d?o.push(c.message.replace("\xA6","\\\xA6")):o.push(C),c.startLineNumber!==void 0&&c.startLineNumber!==null?o.push(c.startLineNumber.toString()):o.push(C),c.startColumn!==void 0&&c.startColumn!==null?o.push(c.startColumn.toString()):o.push(C),c.endLineNumber!==void 0&&c.endLineNumber!==null?o.push(c.endLineNumber.toString()):o.push(C),c.endColumn!==void 0&&c.endColumn!==null?o.push(c.endColumn.toString()):o.push(C),o.push(C),o.join("\xA6")}y.makeKeyOptionalMessage=I})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(be[152],we([0,1,47,4,3]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=w.default,e.INotificationService=(0,k.createDecorator)("notificationService");var A;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new y,this.onDidClose=P.Event.None,this.onDidChangeVisibility=P.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=D;class y{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=y});var je=this&&this.__decorate||function(J,e,w,k){var P=arguments.length,A=P<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,w):k,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,w,k);else for(var D=J.length-1;D>=0;D--)(S=J[D])&&(A=(P<3?S(A):P>3?S(e,w,A):S(e,w))||A);return P>3&&A&&Object.defineProperty(e,w,A),A},Ke=this&&this.__param||function(J,e){return function(w,k){e(w,k,J)}};define(be[153],we([0,1,4,20,6,11]),function(J,e,w,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,w.createDecorator)("progressService");var S;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let y=class extends P.Disposable{constructor(I,c){super();this.deferred=new A.DeferredPromise,c.withProgress(I,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,P.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};y=je([Ke(1,e.IProgressService)],y),e.UnmanagedProgress=y;class C extends P.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new P.DisposableStore)}start(I){this.stop();const c=++this.currentOperationId,d=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,P.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,P.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,P.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:d.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,w.createDecorator)("editorProgressService")}),define(be[29],we([0,1,10,42]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(S,D){k.ok(w.isString(S)),k.ok(w.isObject(D)),k.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,D)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new P}),define(be[91],we([0,1,29,3]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class A{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,C){this.schemasById[P(y)]=C,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new A;w.Registry.add(e.Extensions.JSONContribution,S)}),define(be[66],we([0,1,123,3,29,10,91]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=P.Registry.as(S.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,_=!0){this.registerConfigurations([h],_)}registerConfigurations(h,_=!0){const m=[];h.forEach(u=>{m.push(...this.validateAndRegisterProperties(u,_,u.extensionInfo)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(m)}deregisterConfigurations(h){const _=[],m=u=>{if(u.properties)for(const p in u.properties)_.push(p),delete this.configurationProperties[p],this.removeFromSchema(p,u.properties[p]);u.allOf&&u.allOf.forEach(p=>m(p))};for(const u of h){m(u);const p=this.configurationContributors.indexOf(u);p!==-1&&this.configurationContributors.splice(p,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}registerDefaultConfigurations(h){const _=[],m=[];for(const u of h)for(const p in u)if(_.push(p),e.OVERRIDE_PROPERTY_PATTERN.test(p)){this.defaultValues[p]=Object.assign(Object.assign({},this.defaultValues[p]||{}),u[p]);const t={type:"object",default:this.defaultValues[p],description:w.localize(1,null,p),$ref:e.resourceLanguageSettingsSchemaId};m.push(I(p)),this.configurationProperties[p]=t,this.defaultLanguageConfigurationOverridesNode.properties[p]=t}else{this.defaultValues[p]=u[p];const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.registerOverrideIdentifiers(m),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterDefaultConfigurations(h){const _=[];for(const m of h)for(const u in m)if(_.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const p=this.configurationProperties[u];p&&(this.updatePropertyDefaultValue(u,p),this.updateSchema(u,p))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const _ of h)this.overrideIdentifiers.add(_);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(h,_=!0,m,u=3){var p;u=A.isUndefinedOrNull(h.scope)?u:h.scope;let t=[],n=h.properties;if(n)for(let r in n){if(_&&o(r)){delete n[r];continue}const l=n[r];if(this.updatePropertyDefaultValue(r,l),e.OVERRIDE_PROPERTY_PATTERN.test(r)?l.scope=void 0:(l.scope=A.isUndefinedOrNull(l.scope)?u:l.scope,l.requireTrust=A.isUndefinedOrNull(l.requireTrust)?!!((p=m==null?void 0:m.requireTrustForConfigurations)===null||p===void 0?void 0:p.includes(r)):l.requireTrust),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let s=h.allOf;if(s)for(let r of s)t.push(...this.validateAndRegisterProperties(r,_,m,u));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const _=m=>{let u=m.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let p=m.allOf;p&&p.forEach(_)};_(h)}updateSchema(h,_){switch(e.allSettings.properties[h]=_,_.scope){case 1:e.applicationSettings.properties[h]=_;break;case 2:e.machineSettings.properties[h]=_;break;case 6:e.machineOverridableSettings.properties[h]=_;break;case 3:e.windowSettings.properties[h]=_;break;case 4:e.resourceSettings.properties[h]=_;break;case 5:e.resourceSettings.properties[h]=_,this.resourceLanguageSettingsSchema.properties[h]=_;break}}removeFromSchema(h,_){switch(delete e.allSettings.properties[h],_.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const _=`[${h}]`,m={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(_,m),e.allSettings.properties[_]=m,e.applicationSettings.properties[_]=m,e.machineSettings.properties[_]=m,e.machineOverridableSettings.properties[_]=m,e.windowSettings.properties[_]=m,e.resourceSettings.properties[_]=m}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,_){let m=this.defaultValues[h];A.isUndefined(m)&&(m=_.default),A.isUndefined(m)&&(m=c(_.type)),_.default=m}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(g){return g.substring(1,g.length-1)}e.overrideIdentifierFromKey=I;function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const d=new C;P.Registry.add(e.Extensions.Configuration,d);function o(g){return g.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(g)?w.localize(5,null,g):d.getConfigurationProperties()[g]!==void 0?w.localize(6,null,g):null:w.localize(4,null)}e.validateProperty=o;function a(){const g=[],h=d.getConfigurationProperties();for(const _ of Object.keys(h))g.push([_,h[_].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=a}),define(be[92],we([0,1,24,10,2,29,4,66]),function(J,e,w,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function y(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof P.URI)}e.isConfigurationOverrides=y;var C;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(n,s){const r=s?n?s.keys.filter(F=>n.keys.indexOf(F)===-1):[...s.keys]:[],l=n?s?n.keys.filter(F=>s.keys.indexOf(F)===-1):[...n.keys]:[],f=[];if(s&&n){for(const F of n.keys)if(s.keys.indexOf(F)!==-1){const L=h(n.contents,F),K=h(s.contents,F);w.equals(L,K)||f.push(F)}}const v=[],T=F=>{const L={};for(const K of F)for(const fe of K.identifiers)L[p(fe)]=K;return L},b=s?T(s.overrides):{},E=n?T(n.overrides):{};if(Object.keys(b).length)for(const F of r){const L=b[F];L&&v.push([(0,D.overrideIdentifierFromKey)(F),L.keys])}if(Object.keys(E).length)for(const F of l){const L=E[F];L&&v.push([(0,D.overrideIdentifierFromKey)(F),L.keys])}if(Object.keys(b).length&&Object.keys(E).length)for(const F of f){const L=E[F],K=b[F];if(L&&K){const fe=I({contents:L.contents,keys:L.keys,overrides:[]},{contents:K.contents,keys:K.keys,overrides:[]});v.push([(0,D.overrideIdentifierFromKey)(F),[...fe.added,...fe.removed,...fe.updated]])}}return{added:r,removed:l,updated:f,overrides:v}}e.compare=I;function c(n,s){const r=[];for(const l of Object.keys(n))if(D.OVERRIDE_PROPERTY_PATTERN.test(l)){const f={};for(const v in n[l])f[v]=n[l][v];r.push({identifiers:[(0,D.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(f),contents:d(f,s)})}return r}e.toOverrides=c;function d(n,s){const r=Object.create(null);for(let l in n)o(r,l,n[l],s);return r}e.toValuesTree=d;function o(n,s,r,l){const f=s.split("."),v=f.pop();let T=n;for(let b=0;b<f.length;b++){let E=f[b],F=T[E];switch(typeof F){case"undefined":F=T[E]=Object.create(null);break;case"object":break;default:l(`Ignoring ${s} as ${f.slice(0,b+1).join(".")} is ${JSON.stringify(F)}`);return}T=F}if(typeof T=="object"&&T!==null)try{T[v]=r}catch(b){l(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(T)}`)}else l(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(T)}`)}e.addToValueTree=o;function a(n,s){const r=s.split(".");g(n,r)}e.removeFromValueTree=a;function g(n,s){const r=s.shift();if(s.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const l=n[r];typeof l=="object"&&!Array.isArray(l)&&(g(l,s),Object.keys(l).length===0&&delete n[r])}}function h(n,s,r){function l(T,b){let E=T;for(const F of b){if(typeof E!="object"||E===null)return;E=E[F]}return E}const f=s.split("."),v=l(n,f);return typeof v=="undefined"?r:v}e.getConfigurationValue=h;function _(n,s,r){Object.keys(s).forEach(l=>{l!=="__proto__"&&(l in n?k.isObject(n[l])&&k.isObject(s[l])?_(n[l],s[l],r):r&&(n[l]=s[l]):n[l]=s[l])})}e.merge=_;function m(){const n=A.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=m;function u(){const n=Object.create(null),s=A.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let r in s){let l=s[r].default;o(n,r,l,f=>console.error(`Conflict in default settings: ${f}`))}return n}e.getDefaultValues=u;function p(n){return`[${n}]`}e.keyFromOverrideIdentifier=p;function t(n,s,r){const l=n.inspect(s),f=n.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:l.defaultValue}e.getMigratedSettingValue=t}),define(be[154],we([0,1,44,22,13,10,24,2,66,92,29,6,3]),function(J,e,w,k,P,A,S,D,y,C,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,C.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const r of P.distinct([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[r],f=n[r];f&&(typeof l=="object"&&typeof f=="object"?(l=S.deepClone(l),this.mergeContents(l,f)):l=f),s[r]=l}return new d(s,this.keys,this.overrides)}merge(...t){const n=S.deepClone(this.contents),s=S.deepClone(this.overrides),r=[...this.keys];for(const l of t){this.mergeContents(n,l.contents);for(const f of l.overrides){const[v]=s.filter(T=>P.equals(T.identifiers,f.identifiers));v?this.mergeContents(v.contents,f.contents):s.push(S.deepClone(f))}for(const f of l.keys)r.indexOf(f)===-1&&r.push(f)}return new d(n,r,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&A.isObject(t[s])&&A.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=S.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,C.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,C.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=d;class o extends d{constructor(){const t=(0,C.getDefaultValues)(),n=(0,C.getConfigurationKeys)(),s=[];for(const r of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,y.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,C.toValuesTree)(t[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,n,s)}}e.DefaultConfigurationModel=o;class a{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!A.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:r,overrides:l,untrusted:f}=this.doParseRaw(t,n);this._configurationModel=new d(s,r,l),this._untrustedConfigurations=f||[]}doParseContent(t){let n={},s=null,r=[],l=[],f=[];function v(b){Array.isArray(r)?r.push(b):s&&(r[s]=b)}let T={onObjectBegin:()=>{let b={};v(b),l.push(r),r=b,s=null},onObjectProperty:b=>{s=b},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let b=[];v(b),l.push(r),r=b,s=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:v,onError:(b,E,F)=>{f.push({error:b,offset:E,length:F})}};if(t)try{w.visit(t,T),n=r[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return n}doParseRaw(t,n){const s=i.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,n);t=r.raw;const l=(0,C.toValuesTree)(t,T=>console.error(`Conflict in settings file ${this._name}: ${T}`)),f=Object.keys(t),v=(0,C.toOverrides)(t,T=>console.error(`Conflict in settings file ${this._name}: ${T}`));return{contents:l,keys:f,overrides:v,untrusted:r.untrusted}}filter(t,n,s,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.isUntrusted))return{raw:t,untrusted:[]};const l={},f=[];for(let v in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(v)&&s){const T=this.filter(t[v],n,!1,r);l[v]=T.raw,f.push(...T.untrusted)}else{const T=n[v],b=T?typeof T.scope!="undefined"?T.scope:3:void 0;(b===void 0||r.scopes===void 0||r.scopes.includes(b))&&(r.isUntrusted&&(T==null?void 0:T.requireTrust)?f.push(v):l[v]=t[v])}return{raw:l,untrusted:f}}}e.ConfigurationModelParser=a;class g extends I.Disposable{constructor(t,n,s,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new c.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(c.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=g;class h{constructor(t,n,s=new d,r=new d,l=new k.ResourceMap,f=new d,v=new k.ResourceMap,T=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=f,this._memoryConfigurationByResource=v,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new d,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const r=this.getConsolidateConfigurationModel(n,s),l=this.getFolderConfigurationModelForResource(n.resource,s),f=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,v=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),T=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),b=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),E=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=l?n.overrideIdentifier?l.freeze().override(n.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,K=n.overrideIdentifier?f.override(n.overrideIdentifier).getValue(t):f.getValue(t),fe=r.getValue(t),j=P.distinct(P.flatten(r.overrides.map(H=>H.identifiers))).filter(H=>r.getOverrideValue(t,H)!==void 0);return{defaultValue:v,userValue:T,userLocalValue:b,userRemoteValue:E,workspaceValue:F,workspaceFolderValue:L,memoryValue:K,value:fe,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:b!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:E!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:l==null?void 0:l.freeze().getValue(t),override:n.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:K!==void 0?{value:f.getValue(t),override:n.overrideIdentifier?f.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(r=>y.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,y.overrideIdentifierFromKey)(r),f=this._defaultConfiguration.getKeysForOverrideIdentifier(l),v=t.getKeysForOverrideIdentifier(l),T=[...v.filter(b=>f.indexOf(b)===-1),...f.filter(b=>v.indexOf(b)===-1),...f.filter(b=>!S.equals(this._defaultConfiguration.override(l).getValue(b),t.override(l).getValue(b)))];return[l,T]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:l}=(0,C.compare)(this.localUserConfiguration,t),f=[...n,...s,...r];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:l}=(0,C.compare)(this.remoteUserConfiguration,t);let f=[...n,...s,...r];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:r,overrides:l}=(0,C.compare)(this.workspaceConfiguration,t);let f=[...n,...s,...r];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:r,updated:l,removed:f,overrides:v}=(0,C.compare)(s,n);let T=[...r,...l,...f];return(T.length||!s)&&this.updateFolderConfiguration(t,n),{keys:T,overrides:v}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:l,overrides:f}=(0,C.compare)(n,void 0);return{keys:[...s,...r,...l],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const l=this._memoryConfigurationByResource.get(t);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=s.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:r,keys:l}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((f,v)=>(f.set(D.URI.revive(v[0]),this.parseConfigurationModel(v[1])),f),new k.ResourceMap);return new h(n,s,new d,r,l,new d,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new d(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=h;function _(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,n=new Map;for(const r of p)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,f])=>{const v=(0,k.getOrSet)(n,l,new Set);f.forEach(T=>v.add(T))});const s=[];return n.forEach((r,l)=>s.push([l,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=_;class m{constructor(t,n,s,r){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(v=>l.add(v)),t.overrides.forEach(([,v])=>v.forEach(T=>l.add(T))),this.affectedKeys=[...l.values()];const f=new d;this.affectedKeys.forEach(v=>f.setValue(v,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,l=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!S.equals(r,l)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,C.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=m;class u extends m{constructor(t,n,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=u}),define(be[67],we([0,1,4]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var k;(function(S){S[S.Unknown=0]="Unknown",S[S.DisableTrust=1]="DisableTrust",S[S.MachineTrusted=2]="MachineTrusted"})(k=e.RemoteTrustOption||(e.RemoteTrustOption={}));var P;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(P=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(D,y=P.Unknown,C){super(D);this._message=D,this._code=y,this._detail=C,this.isHandled=y===P.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(D){return D instanceof A&&D._code===P.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof A&&D._code===P.NoResolverFound}static isHandled(D){return D instanceof A&&D.isHandled}}e.RemoteAuthorityResolverError=A}),define(be[93],we([0,1,18]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function k(y){return y.scheme===w.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=k;function P(y){if(!!y){const C=y.indexOf("+");return C<0?y:y.substr(0,C)}}e.getRemoteName=P;function A(y){return y.scheme!==w.Schemas.file&&y.scheme!==w.Schemas.vscodeRemote}function S(y){if(y.folders.length)return y.folders.every(C=>A(C.uri))?y.folders[0].uri:void 0;if(y.configuration&&A(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=S;function D(y){var C;return(C=S(y))===null||C===void 0?void 0:C.scheme}e.getVirtualWorkspaceScheme=D}),define(be[155],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(P){this._callback=P,this._terminalBufferMap=new Map}dispose(){for(const P of this._terminalBufferMap.values())P.dispose()}startBuffering(P,A,S=5){let D;return D=A(y=>{const C=typeof y=="string"?y:y.data;let i=this._terminalBufferMap.get(P);if(i){i.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(P),S);i={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(P),D.dispose()}},this._terminalBufferMap.set(P,i)}),D}stopBuffering(P){const A=this._terminalBufferMap.get(P);A&&A.dispose()}flushBuffer(P){const A=this._terminalBufferMap.get(P);A&&(this._terminalBufferMap.delete(P),this._callback(P,A.data.join("")))}}e.TerminalDataBufferer=w}),define(be[156],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(be[157],we([0,1,4,6,29,3,156,36]),function(J,e,w,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,w.createDecorator)("themeService");var y;(function(g){function h(_){return _&&typeof _=="object"&&typeof _.id=="string"}g.isThemeColor=h})(y=e.ThemeColor||(e.ThemeColor={}));function C(g){return{id:g}}e.themeColorFromId=C;var i;(function(g){function h(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}g.isThemeIcon=h;const _=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function m(t){const n=_.exec(t);if(!!n){let[,s]=n;return{id:s}}}g.fromString=m;function u(t,n){let s=t.id;const r=s.lastIndexOf("~");return r!==-1&&(s=s.substring(0,r)),n&&(s=`${s}~${n}`),{id:s}}g.modify=u;function p(t,n){var s,r;return t.id===n.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((r=n.color)===null||r===void 0?void 0:r.id)}g.isEqual=p,g.asClassNameArray=D.CSSIcon.asClassNameArray,g.asClassName=D.CSSIcon.asClassName,g.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function I(g){switch(g){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(h){return this.themingParticipants.push(h),this.onThemingParticipantAddedEmitter.fire(h),(0,k.toDisposable)(()=>{const _=this.themingParticipants.indexOf(h);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new c;P.Registry.add(e.Extensions.ThemingContribution,d);function o(g){return d.onColorThemeChange(g)}e.registerThemingParticipant=o;class a extends k.Disposable{constructor(h){super();this.themeService=h,this.theme=h.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(h){this.theme=h,this.updateStyles()}updateStyles(){}getColor(h,_){let m=this.theme.getColor(h);return m&&_&&(m=_(m,this.theme)),m?m.toString():null}}e.Themable=a}),define(be[158],we([0,1,29,157,3,127,91,11,36]),function(J,e,w,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class C{constructor(){this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(h,_,m,u){const p=this.iconsById[h];if(p){if(m&&!p.description){p.description=m,this.iconSchema.properties[h].markdownDescription=`${m} $(${h})`;const s=this.iconReferenceSchema.enum.indexOf(h);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=m),this._onDidChange.fire()}return p}let t={id:h,description:m,defaults:_,deprecationMessage:u};this.iconsById[h]=t;let n={$ref:"#/definitions/icons"};return u&&(n.deprecationMessage=u),m&&(n.markdownDescription=`${m}: $(${h})`),this.iconSchema.properties[h]=n,this.iconReferenceSchema.enum.push(h),this.iconReferenceSchema.enumDescriptions.push(m||""),this._onDidChange.fire(),{id:h}}deregisterIcon(h){delete this.iconsById[h],delete this.iconSchema.properties[h];const _=this.iconReferenceSchema.enum.indexOf(h);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(h=>this.iconsById[h])}getIcon(h){return this.iconsById[h]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(h,_){const m=this.iconFontsById[h];if(m)return m;let u={id:h,definition:_};return this.iconFontsById[h]=u,this._onDidChange.fire(),u}deregisterIconFont(h){delete this.iconFontsById[h]}getIconFonts(){return Object.keys(this.iconFontsById).map(h=>this.iconFontsById[h])}getIconFont(h){return this.iconFontsById[h]}toString(){const h=(p,t)=>p.id.localeCompare(t.id),_=p=>{for(;k.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of u.filter(t=>!!t.description).sort(h))m.push(`|<i class="${_(p)}"></i>|${p.id}|${k.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const p of u.filter(t=>!k.ThemeIcon.isThemeIcon(t.defaults)).sort(h))m.push(`|<i class="${_(p)}"></i>|${p.id}|`);return m.join(`
`)}}const i=new C;w.Registry.add(e.Extensions.IconContribution,i);function I(g,h,_,m){return i.registerIcon(g,h,_,m)}e.registerIcon=I;function c(){return i}e.getIconRegistry=c;function d(){for(const g of y.iconRegistry.all)i.registerIcon(g.id,g.definition,g.description);y.iconRegistry.onDidRegister(g=>i.registerIcon(g.id,g.definition,g.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let o=w.Registry.as(S.Extensions.JSONContribution);o.registerSchema(e.iconsSchemaId,i.getIconSchema());const a=new D.RunOnceScheduler(()=>o.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=I("widget-close",y.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",y.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",y.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=k.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(be[48],we([0,1,2,25,4,22]),function(J,e,w,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");var S;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function D(c){const d=c;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=D;function y(c){const d=c;return!!(d&&typeof d=="object"&&w.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=y;class C{constructor(d,o,a,g){this._id=d,this._configuration=a,this._ignorePathCasing=g,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(d){this._id=d.id,this._configuration=d.configuration,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class i{constructor(d,o){this.raw=o,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,k.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(c){return new i({uri:c,index:0,name:(0,k.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=I}),define(be[159],we([0,1,4,128,48,2,21,14,25,106,44,18,58,37,93]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const a=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(ee){return(typeof ee=="string"?(0,D.extname)(ee):(0,y.extname)(ee))===a}e.hasWorkspaceFileExtension=g,e.IWorkspacesService=(0,w.createDecorator)("workspacesService");function h(ee){return ee.hasOwnProperty("workspace")}e.isRecentWorkspace=h;function _(ee){return ee.hasOwnProperty("folderUri")}e.isRecentFolder=_;function m(ee){return ee.hasOwnProperty("fileUri")}e.isRecentFile=m;function u(ee){const O=ee;return typeof(O==null?void 0:O.id)=="string"&&A.URI.isUri(O.uri)}e.isSingleFolderWorkspaceIdentifier=u;function p(ee){if(ee.configuration)return{id:ee.id,configPath:ee.configuration};if(ee.folders.length===1)return{id:ee.id,uri:ee.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(ee){const O=ee;return typeof(O==null?void 0:O.id)=="string"&&A.URI.isUri(O.configPath)}e.isWorkspaceIdentifier=t;function n(ee){const O=ee;if(O==null?void 0:O.uri)return{id:O.id,uri:A.URI.revive(O.uri)};const R=ee;if(R==null?void 0:R.configPath)return{id:R.id,configPath:A.URI.revive(R.configPath)};if(ee==null?void 0:ee.id)return{id:ee.id}}e.reviveIdentifier=n;function s(ee,O){return y.extUriBiasedIgnorePathCase.isEqualOrParent(ee,O.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(ee){return l(ee)||f(ee)}e.isStoredWorkspaceFolder=r;function l(ee){const O=ee;return typeof(O==null?void 0:O.path)=="string"&&(!O.name||typeof O.name=="string")}e.isRawFileWorkspaceFolder=l;function f(ee){const O=ee;return typeof(O==null?void 0:O.uri)=="string"&&(!O.name||typeof O.name=="string")}e.isRawUriWorkspaceFolder=f;function v(ee,O,R,N,$=!S.isWindows,U){if(ee.scheme!==N.scheme)return{name:R,uri:ee.toString(!0)};let Q=O?void 0:U.relativePath(N,ee);if(Q!==void 0)Q.length===0?Q=".":S.isWindows&&ee.scheme===I.Schemas.file&&!$&&(Q=Q.replace(/\//g,"\\"));else if(ee.scheme===I.Schemas.file)Q=ee.fsPath,S.isWindows&&(Q=(0,c.normalizeDriveLetter)(Q),$&&(Q=(0,d.toSlashes)(Q)));else{if(!U.isEqualAuthority(ee.authority,N.authority))return{name:R,uri:ee.toString(!0)};Q=ee.path}return{name:R,path:Q}}e.getStoredWorkspaceFolder=v;function T(ee,O,R){let N=[],$=new Set;const U=R.dirname(O);for(let Q of ee){let Y=null;if(l(Q))Q.path&&(Y=R.resolvePath(U,Q.path));else if(f(Q))try{Y=A.URI.parse(Q.uri),Y.path[0]!=="/"&&(Y=Y.with({path:"/"+Y.path}))}catch(ie){console.warn(ie)}if(Y){let ie=R.getComparisonKey(Y);if(!$.has(ie)){$.add(ie);const pe=Q.name||R.basenameOrAuthority(Y);N.push(new P.WorkspaceFolder({uri:Y,name:pe,index:N.length},Q))}}}return N}e.toWorkspaceFolders=T;function b(ee,O,R,N,$){let U=E(O,ee);const Q=$.dirname(O),Y=$.dirname(N),ie=[],pe=F(U.folders);for(const Be of U.folders){const x=l(Be)?$.resolvePath(Q,Be.path):A.URI.parse(Be.uri);let G;R?G=!1:G=!l(Be)||(0,D.isAbsolute)(Be.path),ie.push(v(x,G,Be.name,Y,pe,$))}const Pe={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},Oe=C.setProperty(ee,["folders"],ie,Pe);let Te=C.applyEdits(ee,Oe);return U.remoteAuthority===(0,o.getRemoteAuthority)(N)&&(Te=C.applyEdits(Te,C.removeProperty(Te,["remoteAuthority"],Pe))),Te}e.rewriteWorkspaceFileForNewLocation=b;function E(ee,O){let R=i.parse(O);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(N=>r(N));else throw new Error(`${ee} looks like an invalid workspace file.`);return R}function F(ee){return S.isWindows?ee.some(O=>l(O)&&O.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function L(ee){return ee.workspace&&typeof ee.workspace=="object"&&typeof ee.workspace.id=="string"&&typeof ee.workspace.configPath=="string"}function K(ee){return typeof ee.folderUri=="string"}function fe(ee){return typeof ee.fileUri=="string"}function j(ee,O){const R={workspaces:[],files:[]};if(ee){const N=function(U,Q){for(let Y=0;Y<U.length;Y++)try{Q(U[Y],Y)}catch(ie){O.warn(`Error restoring recent entry ${JSON.stringify(U[Y])}: ${ie.toString()}. Skip entry.`)}},$=ee;if(Array.isArray($.entries))N($.entries,U=>{const Q=U.label,Y=U.remoteAuthority;L(U)?R.workspaces.push({label:Q,remoteAuthority:Y,workspace:{id:U.workspace.id,configPath:A.URI.parse(U.workspace.configPath)}}):K(U)?R.workspaces.push({label:Q,remoteAuthority:Y,folderUri:A.URI.parse(U.folderUri)}):fe(U)&&R.files.push({label:Q,remoteAuthority:Y,fileUri:A.URI.parse(U.fileUri)})});else{const U=ee;Array.isArray(U.workspaces3)&&N(U.workspaces3,(Q,Y)=>{const ie=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[Y]||void 0;typeof Q=="object"&&typeof Q.id=="string"&&typeof Q.configURIPath=="string"?R.workspaces.push({label:ie,workspace:{id:Q.id,configPath:A.URI.parse(Q.configURIPath)}}):typeof Q=="string"&&R.workspaces.push({label:ie,folderUri:A.URI.parse(Q)})}),Array.isArray(U.files2)&&N(U.files2,(Q,Y)=>{const ie=Array.isArray(U.fileLabels)&&U.fileLabels[Y]||void 0;typeof Q=="string"&&R.files.push({label:ie,fileUri:A.URI.parse(Q)})})}}return R}e.restoreRecentlyOpened=j;function H(ee){const O={entries:[]};for(const R of ee.workspaces)_(R)?O.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):O.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of ee.files)O.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return O}e.toStoreData=H}),define(be[68],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class w{constructor(P){this.id=P,this._data=new Map,this._idPool=1}add(P){const A=this._idPool++;return this._data.set(A,P),this.logDebugInfo(),A}get(P,A){return this._data.has(P)?this._data.get(P)[A]:void 0}delete(P){this._data.delete(P),this.logDebugInfo()}logDebugInfo(){!w.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=w,w.enableDebugLogging=!1}),define(be[160],we([0,1,2,3]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class P{constructor(){this._onDidChangeTabs=new k.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(D=>({name:D.name,group:D.group,resource:w.URI.revive(D.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=P}),define(be[49],we([0,1,18,4]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(w.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(S,D){D===null?this._providerInfo.delete(S):this._providerInfo.set(S,D)}isFreeScheme(S){return!this._providerInfo.has(S)&&!this._systemSchemes.has(S)}getCapabilities(S){return this._providerInfo.get(S)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(be[27],we([0,1,4]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(be[161],we([0,1,11]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(S,D,y){this._deferredPromises=new Map,this._id=S,this._shared=D,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new w.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of C.values())i.complete()}catch(i){for(const I of C.values())I.error(i)}})()},0)}get whenReady(){return this._init}get(S,D){let y=this._value[S];return typeof y=="undefined"&&(y=D),y}update(S,D){this._value[S]=D;let y=this._deferredPromises.get(S);if(y!==void 0)return y.p;const C=new w.DeferredPromise;return this._deferredPromises.set(S,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=k;class P extends k{constructor(S,D){super(S.identifier.value,!0,D);this._extension=S}setKeysForSync(S){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},S)}}e.ExtensionGlobalMemento=P}),define(be[15],we([0,1,4]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class k{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=k});var tt=this&&this.__classPrivateFieldSet||function(J,e,w,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,w):P?P.value=w:e.set(J,w),w},Me=this&&this.__classPrivateFieldGet||function(J,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(J):k?k.value:e.get(J)};define(be[162],we([0,1,26,3]),function(J,e,w,k){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(D,y){P.set(this,void 0),this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=w.ExtensionIdentifier.toKey(D.identifier),tt(this,P,y,"f"),Me(this,P,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(D){return Me(this,P,"f").get(this._id,D)}store(D,y){return Me(this,P,"f").store(this._id,D,y)}delete(D){return Me(this,P,"f").delete(this._id,D)}}e.ExtensionSecrets=A,P=new WeakMap}),define(be[94],we([0,1,4,3]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class P{constructor(){this._onDidChangeTelemetryEnabled=new k.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(S){this._enabled=S}$onDidChangeTelemetryEnabled(S){this._enabled=S,this._onDidChangeTelemetryEnabled.fire(S)}}e.ExtHostTelemetry=P,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(be[69],we([0,1,3]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var k;(function(S){S[S.NewChild=0]="NewChild",S[S.Disposed=1]="Disposed",S[S.Invalidated=2]="Invalidated",S[S.SetProp=3]="SetProp"})(k=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const P=new WeakMap,A=S=>{let D=P.get(S);return D||(D={children:new Map,bus:new w.Emitter},P.set(S,D)),D};e.getPrivateApiFor=A}),define(be[70],we([0,1,4,3,15]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(D){function y(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}D.fromApiTunnel=y;function C(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}D.fromServiceTunnel=C})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,w.createDecorator)("IExtHostTunnelService");let S=class{constructor(y){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,C){return{dispose:()=>{}}}async $providePortAttributes(y,C,i,I,c){return[]}async $forwardPort(y,C){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};S=je([Ke(0,P.IExtHostRpcService)],S),e.ExtHostTunnelService=S});var tt=this&&this.__classPrivateFieldSet||function(J,e,w,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,w):P?P.value=w:e.set(J,w),w},Me=this&&this.__classPrivateFieldGet||function(J,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(J):k?k.value:e.get(J)},Wt=this&&this.__rest||function(J,e){var w={};for(var k in J)Object.prototype.hasOwnProperty.call(J,k)&&e.indexOf(k)<0&&(w[k]=J[k]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var P=0,k=Object.getOwnPropertySymbols(J);P<k.length;P++)e.indexOf(k[P])<0&&Object.prototype.propertyIsEnumerable.call(J,k[P])&&(w[k[P]]=J[k[P]]);return w};define(be[7],we([0,1,13,12,83,22,10,2,31,64,67,69]),function(J,e,w,k,P,A,S,D,y,C,i,I){"use strict";var c,d,o,a,g,h,_,m,u,p,t,n,s,r,l,f;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function v(B){function M(){return Reflect.construct(B,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(B,"name")),Object.setPrototypeOf(M,B),Object.setPrototypeOf(M.prototype,B.prototype),M}let T=o=class{constructor(M){c.set(this,void 0),tt(this,c,M,"f")}static from(...M){let ne=M;return new o(function(){if(ne){for(const ye of ne)ye&&typeof ye.dispose=="function"&&ye.dispose();ne=void 0}})}dispose(){typeof Me(this,c,"f")=="function"&&(Me(this,c,"f").call(this),tt(this,c,void 0,"f"))}};c=new WeakMap,T=o=je([v],T),e.Disposable=T;let b=a=class{constructor(M,ne){if(M<0)throw(0,k.illegalArgument)("line must be non-negative");if(ne<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=M,this._character=ne}static Min(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let ye=1;ye<M.length;ye++){const ze=M[ye];ze.isBefore(ne)&&(ne=ze)}return ne}static Max(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let ye=1;ye<M.length;ye++){const ze=M[ye];ze.isAfter(ne)&&(ne=ze)}return ne}static isPosition(M){if(!M)return!1;if(M instanceof a)return!0;let{line:ne,character:ye}=M;return typeof ne=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,ne=0){if(M===null||ne===null)throw(0,k.illegalArgument)();let ye;return typeof M=="undefined"?ye=0:typeof M=="number"?ye=M:(ye=typeof M.lineDelta=="number"?M.lineDelta:0,ne=typeof M.characterDelta=="number"?M.characterDelta:0),ye===0&&ne===0?this:new a(this.line+ye,this.character+ne)}with(M,ne=this.character){if(M===null||ne===null)throw(0,k.illegalArgument)();let ye;return typeof M=="undefined"?ye=this.line:typeof M=="number"?ye=M:(ye=typeof M.line=="number"?M.line:this.line,ne=typeof M.character=="number"?M.character:this.character),ye===this.line&&ne===this.character?this:new a(ye,ne)}toJSON(){return{line:this.line,character:this.character}}};b=a=je([v],b),e.Position=b;let E=g=class{constructor(M,ne,ye,ze){let Je,ot;if(typeof M=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof ze=="number"?(Je=new b(M,ne),ot=new b(ye,ze)):M instanceof b&&ne instanceof b&&(Je=M,ot=ne),!Je||!ot)throw new Error("Invalid arguments");Je.isBefore(ot)?(this._start=Je,this._end=ot):(this._start=ot,this._end=Je)}static isRange(M){return M instanceof g?!0:M?b.isPosition(M.start)&&b.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof g?this.contains(M._start)&&this.contains(M._end):M instanceof b?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const ne=b.Max(M.start,this._start),ye=b.Min(M.end,this._end);if(!ne.isAfter(ye))return new g(ne,ye)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ne=b.Min(M.start,this._start),ye=b.Max(M.end,this.end);return new g(ne,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,ne=this.end){if(M===null||ne===null)throw(0,k.illegalArgument)();let ye;return M?b.isPosition(M)?ye=M:(ye=M.start||this.start,ne=M.end||this.end):ye=this.start,ye.isEqual(this._start)&&ne.isEqual(this.end)?this:new g(ye,ne)}toJSON(){return[this.start,this.end]}};E=g=je([v],E),e.Range=E;let F=h=class extends E{constructor(M,ne,ye,ze){let Je,ot;if(typeof M=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof ze=="number"?(Je=new b(M,ne),ot=new b(ye,ze)):M instanceof b&&ne instanceof b&&(Je=M,ot=ne),!Je||!ot)throw new Error("Invalid arguments");super(Je,ot);this._anchor=Je,this._active=ot}static isSelection(M){return M instanceof h?!0:M?E.isRange(M)&&b.isPosition(M.anchor)&&b.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};F=h=je([v],F),e.Selection=F;class L{constructor(M,ne,ye){if(typeof M!="string"||M.length===0)throw(0,k.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,k.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,k.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(ne),this.connectionToken=ye}}e.ResolvedAuthority=L;class K extends Error{constructor(M,ne=i.RemoteAuthorityResolverErrorCode.Unknown,ye){super(M);this._message=M,this._code=ne,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,K.prototype)}static NotAvailable(M,ne){return new K(M,i.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(M){return new K(M,i.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=K;var fe;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(fe=e.EndOfLine||(e.EndOfLine={}));var j;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let H=_=class{constructor(M,ne){this._range=M,this._newText=ne}static isTextEdit(M){return M instanceof _?!0:M?E.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ne){return new _(M,ne)}static insert(M,ne){return _.replace(new E(M,M),ne)}static delete(M){return _.replace(M,"")}static setEndOfLine(M){const ne=new _(new E(new b(0,0),new b(0,0)),"");return ne.newEol=M,ne}get range(){return this._range}set range(M){if(M&&!E.isRange(M))throw(0,k.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,k.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,k.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};H=_=je([v],H),e.TextEdit=H;var ee;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellOutput=4]="CellOutput",B[B.CellReplace=5]="CellReplace",B[B.CellOutputItem=6]="CellOutputItem"})(ee=e.FileEditType||(e.FileEditType={}));let O=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,ne,ye,ze){this._edits.push({_type:1,from:M,to:ne,options:ye,metadata:ze})}createFile(M,ne,ye){this._edits.push({_type:1,from:void 0,to:M,options:ne,metadata:ye})}deleteFile(M,ne,ye){this._edits.push({_type:1,from:M,to:void 0,options:ne,metadata:ye})}replaceNotebookMetadata(M,ne,ye){this._edits.push({_type:3,metadata:ye,uri:M,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(M,ne,ye,ze,Je){let ot,dt,_t=[],St;if(Ut.isNotebookRange(ne)&&Rt.isNotebookCellDataArray(ye)&&!Rt.isNotebookCellDataArray(ze)?(ot=ne.start,dt=ne.end,_t=ye,St=ze):typeof ne=="number"&&typeof ye=="number"&&Rt.isNotebookCellDataArray(ze)&&(ot=ne,dt=ye,_t=ze,St=Je),ot===void 0||dt===void 0)throw new Error("Invalid arguments");(ot!==dt||_t.length>0)&&this._edits.push({_type:5,uri:M,index:ot,count:dt-ot,cells:_t,metadata:St})}replaceNotebookCellOutput(M,ne,ye,ze){this._editNotebookCellOutput(M,ne,!1,ye,ze)}appendNotebookCellOutput(M,ne,ye,ze){this._editNotebookCellOutput(M,ne,!0,ye,ze)}replaceNotebookCellOutputItems(M,ne,ye,ze,Je){this._editNotebookCellOutputItems(M,ne,ye,!1,ze,Je)}appendNotebookCellOutputItems(M,ne,ye,ze,Je){this._editNotebookCellOutputItems(M,ne,ye,!0,ze,Je)}_editNotebookCellOutputItems(M,ne,ye,ze,Je,ot){this._edits.push({_type:6,metadata:ot,uri:M,index:ne,outputId:ye,append:ze,newOutputItems:Je})}_editNotebookCellOutput(M,ne,ye,ze,Je){this._edits.push({_type:4,metadata:Je,uri:M,index:ne,append:ye,newOutputs:ze,newMetadata:void 0})}replaceNotebookCellMetadata(M,ne,ye,ze){this._edits.push({_type:3,metadata:ze,uri:M,edit:{editType:11,index:ne,metadata:ye}})}replace(M,ne,ye,ze){this._edits.push({_type:2,uri:M,edit:new H(ne,ye),metadata:ze})}insert(M,ne,ye,ze){this.replace(M,new E(ne,ne),ye,ze)}delete(M,ne,ye){this.replace(M,ne,"",ye)}has(M){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===M.toString())}set(M,ne){if(ne)for(const ye of ne)ye&&this._edits.push({_type:2,uri:M,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const ze=this._edits[ye];ze._type===2&&ze.uri.toString()===M.toString()&&(this._edits[ye]=void 0)}(0,w.coalesceInPlace)(this._edits)}}get(M){const ne=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===M.toString()&&ne.push(ye.edit);return ne}entries(){const M=new A.ResourceMap;for(let ne of this._edits)if(ne._type===2){let ye=M.get(ne.uri);ye||(ye=[ne.uri,[]],M.set(ne.uri,ye)),ye[1].push(ne.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};O=je([v],O),e.WorkspaceEdit=O;let R=m=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof m?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=m._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ne=this._tabstop++){if(typeof M=="function"){const ye=new m;ye._tabstop=this._tabstop,M(ye),this._tabstop=ye._tabstop,M=ye.value}else M=m._escape(M);return this.value+="${",this.value+=ne,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ne=this._tabstop++){const ye=M.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(M,ne){if(typeof ne=="function"){const ye=new m;ye._tabstop=this._tabstop,ne(ye),this._tabstop=ye._tabstop,ne=ye.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};R=m=je([v],R),e.SnippetString=R;var N;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(N=e.DiagnosticTag||(e.DiagnosticTag={}));var $;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})($=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let U=u=class{constructor(M,ne){if(this.uri=M,ne)if(ne instanceof E)this.range=ne;else if(ne instanceof b)this.range=new E(ne,ne);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof u?!0:M?E.isRange(M.range)&&D.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};U=u=je([v],U),e.Location=U;let Q=class{constructor(M,ne){this.location=M,this.message=ne}static is(M){return M?typeof M.message=="string"&&M.location&&E.isRange(M.location.range)&&D.URI.isUri(M.location.uri):!1}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.location.range.isEqual(ne.location.range)&&M.location.uri.toString()===ne.location.uri.toString()}};Q=je([v],Q),e.DiagnosticRelatedInformation=Q;let Y=class{constructor(M,ne,ye=$.Error){if(!E.isRange(M))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=M,this.message=ne,this.severity=ye}toJSON(){return{severity:$[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.severity===ne.severity&&M.code===ne.code&&M.severity===ne.severity&&M.source===ne.source&&M.range.isEqual(ne.range)&&(0,w.equals)(M.tags,ne.tags)&&(0,w.equals)(M.relatedInformation,ne.relatedInformation,Q.isEqual)}};Y=je([v],Y),e.Diagnostic=Y;let ie=class{constructor(M,ne){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:(0,P.isMarkdownString)(M)?this.contents=[M]:this.contents=[M],this.range=ne}};ie=je([v],ie),e.Hover=ie;var pe;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(pe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Pe=class{constructor(M,ne=pe.Text){this.range=M,this.kind=ne}toJSON(){return{range:this.range,kind:pe[this.kind]}}};Pe=je([v],Pe),e.DocumentHighlight=Pe;var Oe;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Oe=e.SymbolKind||(e.SymbolKind={}));var Te;(function(B){B[B.Deprecated=1]="Deprecated"})(Te=e.SymbolTag||(e.SymbolTag={}));let Be=p=class{constructor(M,ne,ye,ze,Je){this.name=M,this.kind=ne,this.containerName=Je,typeof ye=="string"&&(this.containerName=ye),ze instanceof U?this.location=ze:ye instanceof E&&(this.location=new U(ze,ye)),p.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Oe[this.kind],location:this.location,containerName:this.containerName}}};Be=p=je([v],Be),e.SymbolInformation=Be;let x=t=class{constructor(M,ne,ye,ze,Je){this.name=M,this.detail=ne,this.kind=ye,this.range=ze,this.selectionRange=Je,this.children=[],t.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(t.validate)}};x=t=je([v],x),e.DocumentSymbol=x;var G;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(G=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let re=class{constructor(M,ne){this.title=M,this.kind=ne}};re=je([v],re),e.CodeAction=re;let oe=n=class{constructor(M){this.value=M}append(M){return new n(this.value?this.value+n.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+n.sep)}};oe.sep=".",oe=n=je([v],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let me=class{constructor(M,ne){if(this.range=M,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};me=je([v],me),e.SelectionRange=me;class De{constructor(M,ne,ye,ze,Je,ot){this.kind=M,this.name=ne,this.detail=ye,this.uri=ze,this.range=Je,this.selectionRange=ot}}e.CallHierarchyItem=De;class Ne{constructor(M,ne){this.fromRanges=ne,this.from=M}}e.CallHierarchyIncomingCall=Ne;class ge{constructor(M,ne){this.fromRanges=ne,this.to=M}}e.CallHierarchyOutgoingCall=ge;let Ce=class{constructor(M,ne){this.range=M,this.command=ne}get isResolved(){return!!this.command}};Ce=je([v],Ce),e.CodeLens=Ce;let Ae=s=class{constructor(M,ne=!1){d.set(this,void 0),tt(this,d,new P.MarkdownString(M,{supportThemeIcons:ne}),"f")}static isMarkdownString(M){return M instanceof s?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Me(this,d,"f").value}set value(M){Me(this,d,"f").value=M}get isTrusted(){return Me(this,d,"f").isTrusted}set isTrusted(M){Me(this,d,"f").isTrusted=M}get supportThemeIcons(){return Me(this,d,"f").supportThemeIcons}appendText(M){return Me(this,d,"f").appendText(M),this}appendMarkdown(M){return Me(this,d,"f").appendMarkdown(M),this}appendCodeblock(M,ne){return Me(this,d,"f").appendCodeblock(ne!=null?ne:"",M),this}};d=new WeakMap,Ae=s=je([v],Ae),e.MarkdownString=Ae;let $e=class{constructor(M,ne){this.label=M,this.documentation=ne}};$e=je([v],$e),e.ParameterInformation=$e;let _e=class{constructor(M,ne){this.label=M,this.documentation=ne,this.parameters=[]}};_e=je([v],_e),e.SignatureInformation=_e;let qe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};qe=je([v],qe),e.SignatureHelp=qe;var z;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(z=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var te;(function(B){B[B.Other=0]="Other",B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(te=e.InlineHintKind||(e.InlineHintKind={}));let ve=class{constructor(M,ne,ye){this.text=M,this.range=ne,this.kind=ye}};ve=je([v],ve),e.InlineHint=ve;var Ue;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var He;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(He=e.CompletionItemKind||(e.CompletionItemKind={}));var xe;(function(B){B[B.Deprecated=1]="Deprecated"})(xe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ye=class{constructor(M,ne){this.label=M,this.kind=ne}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ye=je([v],Ye),e.CompletionItem=Ye;let W=class{constructor(M=[],ne=!1){this.items=M,this.isIncomplete=ne}};W=je([v],W),e.CompletionList=W;var se;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(se=e.ViewColumn||(e.ViewColumn={}));var de;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(de=e.StatusBarAlignment||(e.StatusBarAlignment={}));var q;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(q=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Z;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var le;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(le=e.TextEditorRevealType||(e.TextEditorRevealType={}));var he;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(he=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ee;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Ee=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function M(ne){switch(ne){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=M}(he=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ve=class{constructor(M,ne){if(ne&&!D.URI.isUri(ne))throw(0,k.illegalArgument)("target");if(!E.isRange(M)||M.isEmpty)throw(0,k.illegalArgument)("range");this.range=M,this.target=ne}};Ve=je([v],Ve),e.DocumentLink=Ve;let Fe=class{constructor(M,ne,ye,ze){this.red=M,this.green=ne,this.blue=ye,this.alpha=ze}};Fe=je([v],Fe),e.Color=Fe;let We=class{constructor(M,ne){if(ne&&!(ne instanceof Fe))throw(0,k.illegalArgument)("color");if(!E.isRange(M)||M.isEmpty)throw(0,k.illegalArgument)("range");this.range=M,this.color=ne}};We=je([v],We),e.ColorInformation=We;let Qe=class{constructor(M){if(!M||typeof M!="string")throw(0,k.illegalArgument)("label");this.label=M}};Qe=je([v],Qe),e.ColorPresentation=Qe;var it;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(it=e.ColorFormat||(e.ColorFormat={}));var lt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ze;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Ze=e.TaskRevealKind||(e.TaskRevealKind={}));var nt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(nt=e.TaskPanelKind||(e.TaskPanelKind={}));let ht=r=class{constructor(M,ne){if(typeof M!="string"||typeof ne!="string")throw(0,k.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return r.Clean;case"build":return r.Build;case"rebuild":return r.Rebuild;case"test":return r.Test;default:return}}get id(){return this._id}};ht.Clean=new r("clean","Clean"),ht.Build=new r("build","Build"),ht.Rebuild=new r("rebuild","Rebuild"),ht.Test=new r("test","Test"),ht=r=je([v],ht),e.TaskGroup=ht;function wt(B){let M="";for(let ne=0;ne<B.length;ne++)M+=B[ne].replace(/,/g,",,")+",";return M}let ue=class{constructor(M,ne,ye){if(typeof M!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=M,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=ye):this._options=ne)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,k.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)M.push(ne);return wt(M)}};ue=je([v],ue),e.ProcessExecution=ue;let Se=class{constructor(M,ne,ye){if(this._args=[],Array.isArray(ne)){if(!M)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,k.illegalArgument)("command");this._command=M,this._args=ne,this._options=ye}else{if(typeof M!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=M,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,k.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)M.push(typeof ne=="string"?ne:ne.value);return wt(M)}};Se=je([v],Se),e.ShellExecution=Se;var ae;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ae=e.ShellQuoting||(e.ShellQuoting={}));var V;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(V=e.TaskScope||(e.TaskScope={}));class Le{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Le;let Ie=l=class{constructor(M,ne,ye,ze,Je,ot){this.__deprecated=!1,this._definition=this.definition=M;let dt;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=ye,this.execution=ze,dt=Je,this.__deprecated=!0):ne===V.Global||ne===V.Workspace?(this.target=ne,this._name=this.name=ye,this._source=this.source=ze,this.execution=Je,dt=ot):(this.target=ne,this._name=this.name=ye,this._source=this.source=ze,this.execution=Je,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ue?this._definition={type:l.ProcessType,id:this._execution.computeId()}:this._execution instanceof Se?this._definition={type:l.ShellType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:l.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:l.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const ne=this._definition.type;(l.EmptyType===ne||l.ProcessType===ne||l.ShellType===ne||l.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};Ie.ExtensionCallbackType="customExecution",Ie.ProcessType="process",Ie.ShellType="shell",Ie.EmptyType="$empty",Ie=l=je([v],Ie),e.Task=Ie;var Xe;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Xe=e.ProgressLocation||(e.ProgressLocation={}));let et=class{constructor(M,ne=ct.None){this.collapsibleState=ne,D.URI.isUri(M)?this.resourceUri=M:this.label=M}};et=je([v],et),e.TreeItem=et;var ct;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let rt=class{constructor(M,ne){this.id=M,this.color=ne}};rt=je([v],rt),e.ThemeIcon=rt,rt.File=new rt("file"),rt.Folder=new rt("folder");let Ge=class{constructor(M){this.id=M}};Ge=je([v],Ge),e.ThemeColor=Ge;var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let at=class{constructor(M,ne){if(typeof M!="string"&&(!M||!D.URI.isUri(M)&&!D.URI.isUri(M.uri)))throw(0,k.illegalArgument)("base");if(typeof ne!="string")throw(0,k.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=D.URI.file(M),this.base=M):D.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=ne}};at=je([v],at),e.RelativePattern=at;let vt=class{constructor(M,ne,ye,ze){this.enabled=typeof M=="boolean"?M:!0,typeof ne=="string"&&(this.condition=ne),typeof ye=="string"&&(this.hitCondition=ye),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};vt=je([v],vt),e.Breakpoint=vt;let pt=class extends vt{constructor(M,ne,ye,ze,Je){super(ne,ye,ze,Je);if(M===null)throw(0,k.illegalArgument)("location");this.location=M}};pt=je([v],pt),e.SourceBreakpoint=pt;let Et=class extends vt{constructor(M,ne,ye,ze,Je){super(ne,ye,ze,Je);this.functionName=M}};Et=je([v],Et),e.FunctionBreakpoint=Et;let Dt=class extends vt{constructor(M,ne,ye,ze,Je,ot,dt){super(ze,Je,ot,dt);if(!ne)throw(0,k.illegalArgument)("dataId");this.label=M,this.dataId=ne,this.canPersist=ye}};Dt=je([v],Dt),e.DataBreakpoint=Dt;let It=class{constructor(M,ne,ye){this.command=M,this.args=ne||[],this.options=ye}};It=je([v],It),e.DebugAdapterExecutable=It;let bt=class{constructor(M,ne){this.port=M,this.host=ne}};bt=je([v],bt),e.DebugAdapterServer=bt;let Pt=class{constructor(M){this.path=M}};Pt=je([v],Pt),e.DebugAdapterNamedPipeServer=Pt;let Gt=class{constructor(M){this.implementation=M}};Gt=je([v],Gt),e.DebugAdapterInlineImplementation=Gt;let mt=class{constructor(M,ne){this.range=M,this.expression=ne}};mt=je([v],mt),e.EvaluatableExpression=mt;let Qt=class{constructor(M,ne){this.range=M,this.text=ne}};Qt=je([v],Qt),e.InlineValueText=Qt;let yt=class{constructor(M,ne,ye=!0){this.range=M,this.variableName=ne,this.caseSensitiveLookup=ye}};yt=je([v],yt),e.InlineValueVariableLookup=yt;let Ht=class{constructor(M,ne){this.range=M,this.expression=ne}};Ht=je([v],Ht),e.InlineValueEvaluatableExpression=Ht;let Jt=class{constructor(M,ne){this.frameId=M,this.stoppedLocation=ne}};Jt=je([v],Jt),e.InlineValueContext=Jt;var zt;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(zt=e.FileChangeType||(e.FileChangeType={}));let ut=f=class extends Error{constructor(M,ne=C.FileSystemProviderErrorCode.Unknown,ye){var ze;super(D.URI.isUri(M)?M.toString(!0):M);this.code=(ze=ye==null?void 0:ye.name)!==null&&ze!==void 0?ze:"Unknown",(0,C.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(M){return new f(M,C.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(M){return new f(M,C.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(M){return new f(M,C.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(M){return new f(M,C.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(M){return new f(M,C.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(M){return new f(M,C.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}};ut=f=je([v],ut),e.FileSystemError=ut;let Yt=class{constructor(M,ne,ye){this.start=M,this.end=ne,this.kind=ye}};Yt=je([v],Yt),e.FoldingRange=Yt;var At;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(At=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Nt;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Nt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var cn;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(cn=e.CommentMode||(e.CommentMode={}));class pn{constructor(M,ne=[]){this.tokenTypes=M,this.tokenModifiers=ne}}e.SemanticTokensLegend=pn;function dn(B){return typeof B=="undefined"||(0,S.isStringArray)(B)}class Xt{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let ne=0,ye=M.tokenTypes.length;ne<ye;ne++)this._tokenTypeStrToInt.set(M.tokenTypes[ne],ne);for(let ne=0,ye=M.tokenModifiers.length;ne<ye;ne++)this._tokenModifierStrToInt.set(M.tokenModifiers[ne],ne)}}push(M,ne,ye,ze,Je){if(typeof M=="number"&&typeof ne=="number"&&typeof ye=="number"&&typeof ze=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded(M,ne,ye,ze,Je);if(E.isRange(M)&&typeof ne=="string"&&dn(ye))return this._push(M,ne,ye);throw(0,k.illegalArgument)()}_push(M,ne,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const ze=M.start.line,Je=M.start.character,ot=M.end.character-M.start.character,dt=this._tokenTypeStrToInt.get(ne);let _t=0;if(ye)for(const St of ye){if(!this._tokenModifierStrToInt.has(St))throw new Error("`tokenModifier` is not in the provided legend");const Ct=this._tokenModifierStrToInt.get(St);_t|=1<<Ct>>>0}this._pushEncoded(ze,Je,ot,dt,_t)}_pushEncoded(M,ne,ye,ze,Je){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const _t=this._data.length/5|0;let St=0,Ct=0;for(let kt=0;kt<_t;kt++){let Ft=this._data[5*kt],ln=this._data[5*kt+1];Ft===0?(Ft=St,ln+=Ct):Ft+=St,this._data[5*kt]=Ft,this._data[5*kt+1]=ln,St=Ft,Ct=ln}}let ot=M,dt=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Je,this._prevLine=M,this._prevChar=ne}static _sortAndDeltaEncode(M){let ne=[];const ye=M.length/5|0;for(let dt=0;dt<ye;dt++)ne[dt]=dt;ne.sort((dt,_t)=>{const St=M[5*dt],Ct=M[5*_t];if(St===Ct){const kt=M[5*dt+1],Ft=M[5*_t+1];return kt-Ft}return St-Ct});const ze=new Uint32Array(M.length);let Je=0,ot=0;for(let dt=0;dt<ye;dt++){const _t=5*ne[dt],St=M[_t+0],Ct=M[_t+1],kt=M[_t+2],Ft=M[_t+3],ln=M[_t+4],In=St-Je,Rn=In===0?Ct-ot:Ct,un=5*dt;ze[un+0]=In,ze[un+1]=Rn,ze[un+2]=kt,ze[un+3]=Ft,ze[un+4]=ln,Je=St,ot=Ct}return ze}build(M){return this._dataIsSortedAndDeltaEncoded?new Vt(new Uint32Array(this._data),M):new Vt(Xt._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Xt;class Vt{constructor(M,ne){this.resultId=ne,this.data=M}}e.SemanticTokens=Vt;class Mt{constructor(M,ne,ye){this.start=M,this.deleteCount=ne,this.data=ye}}e.SemanticTokensEdit=Mt;class vn{constructor(M,ne){this.resultId=ne,this.edits=M}}e.SemanticTokensEdits=vn;var Zt;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Zt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var en;(function(B){B[B.Initial=1]="Initial",B[B.Dynamic=2]="Dynamic"})(en=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let jt=class{constructor(){}};jt.Back={iconPath:new rt("arrow-left")},jt=je([v],jt),e.QuickInputButtons=jt;var bn;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(bn=e.ExtensionKind||(e.ExtensionKind={}));class Tt{constructor(M,ne,ye){this.badge=M,this.tooltip=ne,this.color=ye}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Tt;let tn=class{constructor(M){this.kind=M}};tn=je([v],tn),e.ColorTheme=tn;var wn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast"})(wn=e.ColorThemeKind||(e.ColorThemeKind={}));class Ut{constructor(M,ne){if(M<0)throw(0,k.illegalArgument)("start must be positive");if(ne<0)throw(0,k.illegalArgument)("end must be positive");M<=ne?(this._start=M,this._end=ne):(this._start=ne,this._end=M)}static isNotebookRange(M){return M instanceof Ut?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let ne=this._start,ye=this._end;return M.start!==void 0&&(ne=M.start),M.end!==void 0&&(ye=M.end),ne===this._start&&ye===this._end?this:new Ut(ne,ye)}}e.NotebookRange=Ut;class nn{constructor(M,ne){typeof M=="object"?Object.assign(this,M):(this.inputCollapsed=M,this.outputCollapsed=ne)}with(M){let{inputCollapsed:ne,outputCollapsed:ye,custom:ze}=M,Je=Wt(M,["inputCollapsed","outputCollapsed","custom"]);return ne===void 0?ne=this.inputCollapsed:ne===null&&(ne=void 0),ye===void 0?ye=this.outputCollapsed:ye===null&&(ye=void 0),ze===void 0?ze=this.custom:ze===null&&(ze=void 0),ne===this.inputCollapsed&&ye===this.outputCollapsed&&ze===this.custom&&Object.keys(Je).length===0?this:new nn(Object.assign({inputCollapsed:ne,outputCollapsed:ye,custom:ze},Je))}}e.NotebookCellMetadata=nn;class Ot{constructor(M=!0,ne={}){var ye,ze;typeof M=="object"?(Object.assign(this,M),this.trusted=(ye=M.trusted)!==null&&ye!==void 0?ye:!0,this.custom=(ze=M.custom)!==null&&ze!==void 0?ze:{}):(this.trusted=M,this.custom=ne)}with(M){let{custom:ne,trusted:ye}=M,ze=Wt(M,["custom","trusted"]);return ne===void 0?ne=this.custom:ne===null&&(ne=void 0),ye===void 0?ye=this.trusted:ye===null&&(ye=void 0),ne===this.custom&&ye===this.trusted&&Object.keys(ze).length===0?this:new Ot(Object.assign({trusted:ye,custom:ne},ze))}}e.NotebookDocumentMetadata=Ot;class Rt{constructor(M,ne,ye,ze,Je,ot){this.kind=M,this.source=ne,this.language=ye,this.outputs=ze!=null?ze:[],this.metadata=Je,this.latestExecutionSummary=ot}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ne=>Rt.isNotebookCellData(ne))}static isNotebookCellData(M){return!0}}e.NotebookCellData=Rt;class hn{constructor(M,ne){this.cells=M,this.metadata=ne!=null?ne:new Ot}}e.NotebookData=hn;class Bt{constructor(M,ne,ye){this.mime=M,this.value=ne,this.metadata=ye}static isNotebookCellOutputItem(M){return M instanceof Bt}}e.NotebookCellOutputItem=Bt;class Re{constructor(M,ne,ye){this.outputs=M,typeof ne=="string"?(this.id=ne,this.metadata=ye):(this.id=(0,y.generateUuid)(),this.metadata=ne!=null?ne:ye)}}e.NotebookCellOutput=Re;var rn;(function(B){B[B.Markdown=1]="Markdown",B[B.Code=2]="Code"})(rn=e.NotebookCellKind||(e.NotebookCellKind={}));var sn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(sn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(gt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _n;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(_n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class En{constructor(M,ne,ye,ze,Je,ot){this.text=M,this.alignment=ne,this.command=ye,this.tooltip=ze,this.priority=Je,this.accessibilityInformation=ot}}e.NotebookCellStatusBarItem=En;let qt=class{constructor(M,ne){this.label=M,this.timestamp=ne}};qt=je([v],qt),e.TimelineItem=qt;var fn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(fn=e.ExtensionMode||(e.ExtensionMode={}));var yn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(yn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Sn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=4]="RegEx"})(Sn=e.StandardTokenType||(e.StandardTokenType={}));class Dn{constructor(M,ne){this.ranges=M,this.wordPattern=ne}}e.LinkedEditingRanges=Dn;var Cn;(function(B){B[B.Unset=0]="Unset",B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(Cn=e.TestResultState||(e.TestResultState={}));var on;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information",B[B.Hint=3]="Hint"})(on=e.TestMessageSeverity||(e.TestMessageSeverity={}));var mn;(function(B){B[B.Pending=0]="Pending",B[B.Resolved=1]="Resolved"})(mn=e.TestItemStatus||(e.TestItemStatus={}));const xt=(B,M,ne,ye)=>{let ze=ne;return{enumerable:!0,configurable:!1,get(){return ze},set(Je){ye(ze,Je)||(ze=Je,B.bus.fire([3,M,Je]))}}},Kt=(B,M)=>B===M,kn=(B,M)=>B===M?!0:!B||!M?!1:B.isEqual(M);class an{constructor(M,ne,ye,ze){this.label=ne,this.data=ze;const Je=(0,I.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:M,enumerable:!0,writable:!1},uri:{value:ye,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>Je.parent},children:{value:new A.ReadonlyMapView(Je.children),enumerable:!0,writable:!1},range:xt(Je,"range",void 0,kn),description:xt(Je,"description",void 0,Kt),runnable:xt(Je,"runnable",!0,Kt),debuggable:xt(Je,"debuggable",!0,Kt),status:xt(Je,"status",mn.Resolved,Kt)})}invalidate(){(0,I.getPrivateApiFor)(this).bus.fire([2])}dispose(){const M=(0,I.getPrivateApiFor)(this);M.parent&&(0,I.getPrivateApiFor)(M.parent).children.delete(this.id),M.bus.fire([1])}addChild(M){if(!(M instanceof an))throw new Error("Test child must be created through vscode.test.createTestItem()");const ne=(0,I.getPrivateApiFor)(this);if(ne.children.has(M.id))throw new Error(`Attempted to insert a duplicate test item ID ${M.id}`);ne.children.set(M.id,M),ne.bus.fire([0,M])}}e.TestItemImpl=an;class X{constructor(M){this.message=M,this.severity=on.Error}static diff(M,ne,ye){const ze=new X(M);return ze.expectedOutput=ne,ze.actualOutput=ye,ze}}e.TestMessage=X;var ce;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(ce=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ke;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(ke=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var st;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore"})(st=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(be[95],we([0,1,42,18,8,119,86,7,13]),function(J,e,w,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function i(o,a){a?C.set(o,a):C.delete(o)}e.setWordDefinitionFor=i;function I(o){return C.get(o)}e.getWordDefinitionFor=I;class c extends A.MirrorTextModel{constructor(a,g,h,_,m,u,p,t){super(g,h,_,m);this._proxy=a,this._languageId=u,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,w.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,y.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===k.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},get notebook(){return a._notebook},save(){return a._save()},getText(g){return g?a._getTextInRange(g):a.getText()},get eol(){return a._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(g){return a._lineAt(g)},offsetAt(g){return a._offsetAt(g)},positionAt(g){return a._positionAt(g)},validateRange(g){return a._validateRange(g)},validatePosition(g){return a._validatePosition(g)},getWordRangeAtPosition(g,h){return a._getWordRangeAtPosition(g,h)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,w.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,w.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const g=this._validateRange(a);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const h=this._eol,_=g.start.line,m=g.end.line,u=[];u.push(this._lines[_].substring(g.start.character));for(let p=_+1;p<m;p++)u.push(this._lines[p]);return u.push(this._lines[m].substring(0,g.end.character)),u.join(h)}_lineAt(a){let g;if(a instanceof D.Position?g=a.line:typeof a=="number"&&(g=a),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new d(g,this._lines[g],g===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(a),h=this._lines[g.index].length;return new D.Position(g.index,Math.min(g.remainder,h))}_validateRange(a){if(!(a instanceof D.Range))throw new Error("Invalid argument");const g=this._validatePosition(a.start),h=this._validatePosition(a.end);return g===a.start&&h===a.end?a:new D.Range(g.line,g.character,h.line,h.character)}_validatePosition(a){if(!(a instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:g,character:h}=a,_=!1;if(g<0)g=0,h=0,_=!0;else if(g>=this._lines.length)g=this._lines.length-1,h=this._lines[g].length,_=!0;else{const m=this._lines[g].length;h<0?(h=0,_=!0):h>m&&(h=m,_=!0)}return _?new D.Position(g,h):a}_getWordRangeAtPosition(a,g){const h=this._validatePosition(a);if(!g)g=I(this._languageId);else if((0,P.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const _=(0,S.getWordAtText)(h.character+1,(0,S.ensureValidWordDefinition)(g),this._lines[h.line],0);if(_)return new D.Range(h.line,_.startColumn-1,h.line,_.endColumn-1)}}e.ExtHostDocumentData=c;class d{constructor(a,g,h){this._line=a,this._text=g,this._isLastLine=h}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(be[163],we([0,1,7,3,88,6,59,22,2,31]),function(J,e,w,k,P,A,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(c,d,o,a){this._notebook=o,this._selector=a,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(h=>{const _=this._cellUris.get(h.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const g=h=>{h===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(h=>g(h.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const c=[],d=[];for(const o of this._notebook.getCells())o.kind===w.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),c.push(o.document.getText().length+1),d.push(o.document.lineCount));this._cellLengths=new P.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new P.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(c){var d,o;if(!c){let m="";for(const u of this._cells)m+=u.document.getText()+`
`;return m=m.slice(0,-1),m}if(c.isEmpty)return"";const a=this.locationAt(c.start),g=this.locationAt(c.end),h=this._cells[(d=this._cellUris.get(a.uri))!==null&&d!==void 0?d:-1],_=this._cells[(o=this._cellUris.get(g.uri))!==null&&o!==void 0?o:-1];if(!h||!_)return"";if(h===_)return h.document.getText(new w.Range(a.range.start,g.range.end));{const m=h.document.getText(new w.Range(a.range.start,new w.Position(h.document.lineCount,0))),u=_.document.getText(new w.Range(new w.Position(0,0),g.range.end));return m+`
`+u}}offsetAt(c){const d=this._cellLines.getIndexOf(c.line),o=this._cellLengths.getAccumulatedValue(d.index-1),a=this._cells[d.index].document.offsetAt(c.with(d.remainder));return o+a}positionAt(c){if(typeof c=="number"){const o=this._cellLengths.getIndexOf(c),a=this._cellLines.getAccumulatedValue(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(a)}const d=this._cellUris.get(c.uri);if(d!==void 0){const o=this._cellLines.getAccumulatedValue(d-1);return new w.Position(o+c.range.start.line,c.range.start.character)}return new w.Position(0,0)}locationAt(c){w.Range.isRange(c)||(c=new w.Range(c,c));const d=this._cellLines.getIndexOf(c.start.line);let o=d;c.isEmpty||(o=this._cellLines.getIndexOf(c.end.line));const a=new w.Position(d.remainder,c.start.character),g=new w.Position(o.remainder,c.end.character),h=new w.Range(a,g),_=this._cells[d.index];return new w.Location(_.document.uri,_.document.validateRange(h))}contains(c){return this._cellUris.has(c)}validateRange(c){const d=this.validatePosition(c.start),o=this.validatePosition(c.end);return c.with(d,o)}validatePosition(c){const d=this._cellLines.getIndexOf(c.line),o=new w.Position(d.remainder,c.character),a=this._cells[d.index].document.validatePosition(o),g=this._cellLines.getAccumulatedValue(d.index-1);return new w.Position(g+a.line,a.character)}}e.ExtHostNotebookConcatDocument=i}),define(be[164],we([0,1,7,15,3]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(D){this._actual=new w.ColorTheme(w.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new P.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let y=D==="light"?w.ColorThemeKind.Light:D==="dark"?w.ColorThemeKind.Dark:w.ColorThemeKind.HighContrast;this._actual=new w.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=je([Ke(0,k.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(be[71],we([0,1,4]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,w.createDecorator)("IURITransformerService");class k{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=k}),define(be[165],we([0,1,23]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(y){let C=this.buffers.indexOf(y);return C<0&&(C=this.buffers.length,this.buffers.push(y)),C}}function P(D,y){if(y){const C=new k,i=(d,o)=>{if(o instanceof ArrayBuffer){const a=C.add(o);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(o)){const a=A(o);if(a){const g=C.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:a,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},I=JSON.stringify(D,i),c=C.buffers.map(d=>{const o=new Uint8Array(d);return w.VSBuffer.wrap(o)});return{message:I,buffers:c}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=P;function A(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(D,y){const C=y.map(c=>{const d=new ArrayBuffer(c.byteLength);return new Uint8Array(d).set(c.buffer),d}),i=y.length?(c,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const o=d,{index:a}=o,g=C[a];if(o.view)switch(o.view.type){case 1:return new Int8Array(g,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return d}:void 0;return{message:JSON.parse(D,i),arrayBuffers:C}}e.deserializeWebviewMessage=S}),define(be[72],we([0,1,2]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function k(A,S,D){const y=A.webviewResourceRoot.replace("{{resource}}",D.scheme+P(D)).replace("{{uuid}}",S);return w.URI.parse(y)}e.asWebviewUri=k;function P(A){return A.toString().replace(/^\S+?:/,"")}}),define(be[166],we([0,1,3,6,72,31]),function(J,e,w,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(y,C,i){this._proxy=y,this._editors=C,this._initData=i,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const I=C.getVisibleTextEditors();for(const c of this._insets.values())I.indexOf(c.editor)<0&&c.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,C,i,I,c){let d;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===y){d=u;break}if(!d)throw new Error("not a visible editor");const o=this,a=this._handlePool++,g=new w.Emitter,h=new w.Emitter,_=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,P.asWebviewUri)(o._initData,this._uuid,u)}get cspSource(){return o._initData.webviewCspSource}set options(u){this._options=u,o._proxy.$setOptions(a,u)}get options(){return this._options}set html(u){this._html=u,o._proxy.$setHtml(a,u)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(u){return o._proxy.$postMessage(a,u)}},m=new class{constructor(){this.editor=y,this.line=C,this.height=i,this.webview=_,this.onDidDispose=h.event}dispose(){o._insets.has(a)&&(o._insets.delete(a),o._proxy.$disposeEditorInset(a),h.fire(),h.dispose(),g.dispose())}};return this._proxy.$createEditorInset(a,d.id,d.value.document.uri,C+1,i,I||{},c.identifier,c.extensionLocation),this._insets.set(a,{editor:y,inset:m,onDidReceiveMessage:g}),m}$onDidDispose(y){const C=this._insets.get(y);C&&C.inset.dispose()}$onDidReceiveMessage(y,C){const i=this._insets.get(y);i&&i.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=S}),define(be[167],we([0,1,3,63,138,4,6,22,29,13,51,24,36,158]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",c.Codicon.window,(0,P.localize)(0,null));var o;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(o=e.Extensions||(e.Extensions={}));var a;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel"})(a=e.ViewContainerLocation||(e.ViewContainerLocation={}));function g(l){switch(l){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=g;function h(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=h;class _ extends S.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new w.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new w.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,C.flatten)([...this.viewContainers.values()])}registerViewContainer(f,v,T){var b;const E=this.get(f.id);if(E)return E;const F=f;return F.openCommandActionDescriptor=(T==null?void 0:T.donotRegisterOpenCommand)?void 0:(b=F.openCommandActionDescriptor)!==null&&b!==void 0?b:{id:F.id},(0,D.getOrSet)(this.viewContainers,v,[]).push(F),(T==null?void 0:T.isDefault)&&this.defaultViewContainers.push(F),this._onDidRegister.fire({viewContainer:F,viewContainerLocation:v}),F}deregisterViewContainer(f){for(const v of this.viewContainers.keys()){const T=this.viewContainers.get(v),b=T==null?void 0:T.indexOf(f);if(b!==-1){T==null||T.splice(b,1),T.length===0&&this.viewContainers.delete(v),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:v});return}}}get(f){return this.all.filter(v=>v.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(v=>this.getViewContainers(v).filter(T=>(T==null?void 0:T.id)===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(v=>this.getViewContainerLocation(v)===f)}}y.Registry.add(o.ViewContainersRegistry,new _);var m;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(m=e.ViewContentGroups||(e.ViewContentGroups={}));function u(l,f){var v,T,b,E;const F=(v=l.group)!==null&&v!==void 0?v:m.More,L=(T=f.group)!==null&&T!==void 0?T:m.More;return F!==L?F.localeCompare(L):((b=l.order)!==null&&b!==void 0?b:5)-((E=f.order)!==null&&E!==void 0?E:5)}class p extends S.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new w.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new w.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new w.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new w.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(f,v){this.registerViews2([{views:f,viewContainer:v}])}registerViews2(f){f.forEach(({views:v,viewContainer:T})=>this.addViews(v,T)),this._onViewsRegistered.fire(f)}deregisterViews(f,v){const T=this.removeViews(f,v);T.length&&this._onViewsDeregistered.fire({views:T,viewContainer:v})}moveViews(f,v){for(const T of this._views.keys())if(T!==v){const b=this.removeViews(f,T);b.length&&(this.addViews(b,v),this._onDidChangeContainer.fire({views:b,from:T,to:v}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const v of this._viewContainers){const T=(this._views.get(v)||[]).filter(b=>b.id===f)[0];if(T)return T}return null}getViewContainer(f){for(const v of this._viewContainers)if((this._views.get(v)||[]).filter(b=>b.id===f)[0])return v;return null}registerViewWelcomeContent(f,v){return this._viewWelcomeContents.add(f,v),this._onDidChangeViewWelcomeContent.fire(f),(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(f,v),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,v){const T=new Map;for(const[b,E]of v)this._viewWelcomeContents.add(f,E),T.set(b,(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(f,E),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),T}getViewWelcomeContent(f){const v=[];return this._viewWelcomeContents.forEach(f,T=>v.push(T)),v.sort(u)}addViews(f,v){let T=this._views.get(v);T||(T=[],this._views.set(v,T),this._viewContainers.push(v));for(const b of f){if(this.getView(b.id)!==null)throw new Error((0,P.localize)(1,null,b.id));T.push(b)}}removeViews(f,v){const T=this._views.get(v);if(!T)return[];const b=[],E=[];for(const F of T)f.includes(F)?b.push(F):E.push(F);return b.length&&(E.length?this._views.set(v,E):(this._views.delete(v),this._viewContainers.splice(this._viewContainers.indexOf(v),1))),b}}y.Registry.add(o.ViewsRegistry,new p),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new k.RawContextKey("focusedView","",(0,P.localize)(2,null));function t(l){return`view.${l}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var n;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(f,v){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,f),this._hasResolve=!!v,this.resolve=async T=>{var b,E;if(v&&!this.resolved){const F=await v(T);F&&(this.tooltip=(b=this.tooltip)!==null&&b!==void 0?b:F.tooltip,this.command=(E=this.command)!==null&&E!==void 0?E:F.command)}T.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(be[168],we([0,1,2,148,159,19,149,167]),function(J,e,w,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(a){return(g,...h)=>a(g.get(k.ICommandService),...h)}class C{static execute(g,h){const _={forceReuseWindow:h&&h.reuseWindow,remoteAuthority:h&&h.remoteAuthority};return g.executeCommand("_files.newWindow",_)}}e.NewWindowAPICommand=C,C.ID="vscode.newWindow",k.CommandsRegistry.registerCommand({id:C.ID,handler:y(C.execute),description:{description:"Opens an new window",args:[]}}),k.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(a,g){return a.get(P.IWorkspacesService).removeRecentlyOpened([g])});class i{static execute(g,h){return typeof h=="string"?h=h.match(/^[^:/?#]+:\/\//)?w.URI.parse(h):w.URI.file(h):h=w.URI.revive(h),g.executeCommand("_workbench.removeFromRecentlyOpened",h)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",k.CommandsRegistry.registerCommand(i.ID,y(i.execute));class I{static execute(g,h){const _=typeof h=="string"?{extensionId:h}:h;return g.executeCommand("workbench.action.openIssueReporter",_)}}e.OpenIssueReporter=I,I.ID="vscode.openIssueReporter",k.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(a,g){const h=a.get(P.IWorkspacesService);let _;const m=g.uri,u=g.label,p=g.remoteAuthority;return g.type==="workspace"?_={workspace:await h.getWorkspaceIdentifier(m),label:u,remoteAuthority:p}:g.type==="folder"?_={folderUri:m,label:u,remoteAuthority:p}:_={fileUri:m,label:u,remoteAuthority:p},h.addRecentlyOpened([_])}),k.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(a){return a.get(P.IWorkspacesService).getRecentlyOpened()}),k.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(a,g){const h=a.get(A.ILogService),_=a.get(S.IEnvironmentService);_.isExtensionDevelopment&&!!_.extensionTestsLocationURI&&h.setLevel(g)}),k.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(a){return a.get(A.ILogService).getLevel()}),k.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(a,g){const h=a.get(D.IViewDescriptorService),_=h.getViewContainerById(g.destinationId);if(!!_){for(const m of g.viewIds){const u=h.getViewDescriptorById(m);(u==null?void 0:u.canMoveView)&&h.moveViewsToContainer([u],_,D.ViewVisibilityState.Default)}await a.get(D.IViewsService).openViewContainer(_.id,!0)}});class c{static execute(g,h){return!Array.isArray(h==null?void 0:h.viewIds)||typeof(h==null?void 0:h.destinationId)!="string"?Promise.reject("Invalid arguments"):g.executeCommand("_workbench.action.moveViews",h)}}e.MoveViewsAPICommand=c,c.ID="vscode.moveViews",k.CommandsRegistry.registerCommand({id:c.ID,handler:y(c.execute),description:{description:"Move Views",args:[]}});class d{static execute(g,h){return g.executeCommand("_workbench.open",h)}}d.ID="vscode.open",k.CommandsRegistry.registerCommand(d.ID,y(d.execute));class o{static execute(g,h,_,m,u){return g.executeCommand("_workbench.diff",[h,_,m])}}o.ID="vscode.diff",k.CommandsRegistry.registerCommand(o.ID,y(o.execute))}),define(be[169],we([0,1,3,11,139]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new w.Emitter,this._onExit=new w.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,y,C,i){const I={command:D};if(y&&Object.keys(y).length>0&&(I.arguments=y),this.internalSend("request",I),typeof i=="number"){const c=setTimeout(()=>{clearTimeout(c);const d=this.pendingRequests.get(I.seq);if(d){this.pendingRequests.delete(I.seq);const o={type:"response",seq:0,request_seq:I.seq,success:!1,command:D,message:(0,P.localize)(0,null,i,D)};d(o)}},i)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,y){return D.type!=="event"||y.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,k.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const y=D,C=this.pendingRequests.get(y.request_seq);C&&(this.pendingRequests.delete(y.request_seq),C(y));break}}}internalSend(D,y){y.type=D,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((y,C)=>D.set(C,y)),await(0,k.timeout)(500),D.forEach((y,C)=>{y({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(be[170],we([0,1,8,2,14,24,18]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function y(n,s,r){return n.replace(D,function(l,f){return s&&f.length>0&&f[0]!=="_"?l:r&&r.hasOwnProperty(f)?r[f]:l})}e.formatPII=y;function C(n){const s={};for(const r of Object.keys(n))r.startsWith("!")||(s[r]=n[r]);return s}e.filterExceptionsFromTelemetry=C;function i(n){return n.configuration.request==="attach"&&!I(n)}e.isSessionAttach=i;function I(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,w.equalsIgnoreCase)(s,"extensionhost")||(0,w.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?I(n.parentSession):void 0}e.getExtensionHostDebugSession=I;function c(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=c;function d(n,s,r){let l,f=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,T=null;for(;T=v.exec(n);){let b=T.index+1,E=b+T[0].length;if(b<=s&&E>=r){l=T[0],f=b;break}}if(l){let b=/\w+/g,E=null;for(;(E=b.exec(l))&&!(E.index+1+f+E[0].length>=r););E&&(l=l.substring(0,b.lastIndex))}return l?{start:f,end:f+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(n){return!!(n&&n.match(o))}e.isUri=a;function g(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(a(n.path))return k.URI.parse(n.path);if((0,P.isAbsolute)(n.path))return k.URI.file(n.path)}return n.path}function h(n){if(typeof n.path=="object"){const s=k.URI.revive(n.path);if(s)return s.scheme===S.Schemas.file?s.fsPath:s.toString()}return n.path}function _(n,s){const r=s?g:h,l=(0,A.deepClone)(n);return u(l,(f,v)=>{f&&v&&(v.path=r(v))}),l}e.convertToDAPaths=_;function m(n,s){const r=s?g:h,l=(0,A.deepClone)(n);return u(l,(f,v)=>{!f&&v&&(v.path=r(v))}),l}e.convertToVSCPaths=m;function u(n,s){switch(n.type){case"event":const r=n;switch(r.event){case"output":s(!1,r.body.source);break;case"loadedSource":s(!1,r.body.source);break;case"breakpoint":s(!1,r.body.breakpoint.source);break;default:break}break;case"request":const l=n;switch(l.command){case"setBreakpoints":s(!0,l.arguments.source);break;case"breakpointLocations":s(!0,l.arguments.source);break;case"source":s(!0,l.arguments.source);break;case"gotoTargets":s(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(v=>s(!1,v));break;default:break}break;case"response":const f=n;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(v=>s(!1,v.source));break;case"loadedSources":f.body.sources.forEach(v=>s(!1,v));break;case"scopes":f.body.scopes.forEach(v=>s(!1,v.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(v=>s(!1,v.source));break;case"setBreakpoints":f.body.breakpoints.forEach(v=>s(!1,v.source));break;default:break}break}}function p(n){return n.filter(s=>{var r;return!((r=s.presentation)===null||r===void 0?void 0:r.hidden)}).sort((s,r)=>s.presentation?r.presentation?s.presentation.group?r.presentation.group?s.presentation.group!==r.presentation.group?s.presentation.group.localeCompare(r.presentation.group):t(s.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(s.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=p;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(be[73],we([0,1,28,18,14,21,63]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(L){L[L.Markdown=1]="Markdown",L[L.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var C;(function(L){L[L.Idle=1]="Idle",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(C=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.CellClearOutput=3]="CellClearOutput",L[L.CellsClearOutput=4]="CellsClearOutput",L[L.ChangeLanguage=5]="ChangeLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.Unknown=12]="Unknown"})(I=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.OutputsSplice=6]="OutputsSplice",L[L.Move=7]="Move",L[L.Unknown=8]="Unknown",L[L.CellContent=9]="CellContent",L[L.OutputItems=10]="OutputItems",L[L.PartialMetadata=11]="PartialMetadata"})(d=e.CellEditType||(e.CellEditType={}));function o(L){const K=a.parse(L);return K?K.notebook.toString():L.toString()}e.getCellUndoRedoComparisonKey=o;var a;(function(L){L.scheme=k.Schemas.vscodeNotebookCell;const K=/^ch(\d{7,})/;function fe(O,R){return O.with({scheme:L.scheme,fragment:`ch${R.toString().padStart(7,"0")}${O.scheme!==k.Schemas.file?O.scheme:""}`})}L.generate=fe;function j(O){if(O.scheme===L.scheme){const R=K.exec(O.fragment);if(!!R)return{handle:Number(R[1]),notebook:O.with({scheme:O.fragment.substr(R[0].length)||k.Schemas.file,fragment:null})}}}L.parse=j;function H(O,R){return O.with({scheme:k.Schemas.vscodeNotebookCellMetadata,fragment:`ch${R.toString().padStart(7,"0")}${O.scheme!==k.Schemas.file?O.scheme:""}`})}L.generateCellMetadataUri=H;function ee(O){if(O.scheme===k.Schemas.vscodeNotebookCellMetadata){const R=K.exec(O.fragment);if(!!R)return{handle:Number(R[1]),notebook:O.with({scheme:O.fragment.substr(R[0].length)||k.Schemas.file,fragment:null})}}}L.parseCellMetadataUri=ee})(a=e.CellUri||(e.CellUri={}));const g=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function h(L){var K,fe;return(fe=(K=g.get(L))===null||K===void 0?void 0:K.alwaysSecure)!==null&&fe!==void 0?fe:!1}e.mimeTypeIsAlwaysSecure=h;function _(L){var K,fe;return(fe=(K=g.get(L))===null||K===void 0?void 0:K.supportedByCore)!==null&&fe!==void 0?fe:!1}e.mimeTypeSupportedByCore=_;function m(L){var K,fe;return(fe=(K=g.get(L))===null||K===void 0?void 0:K.mergeable)!==null&&fe!==void 0?fe:!1}e.mimeTypeIsMergeable=m;function u(L,K){return A.isWindows&&(L=L.replace(/\//g,"\\"),K=K.replace(/\//g,"\\")),w.match(L,K)}function p(L,K,fe){let j=0;for(let H=0;H<K.length;H++){if(u(K[H],L))return j;j++}for(let H=0;H<fe.length;H++){if(u(fe[H],L))return j;j++}return j}function t(L,K,fe){return L.sort((j,H)=>p(j,K,fe)-p(H,K,fe))}e.sortMimeTypes=t;function n(L,K,fe,j=(H,ee)=>H===ee){const H=[];function ee(N,$,U){if(!($===0&&U.length===0)){const Q=H[H.length-1];Q&&Q.start+Q.deleteCount===N?(Q.deleteCount+=$,Q.toInsert.push(...U)):H.push({start:N,deleteCount:$,toInsert:U})}}let O=0,R=0;for(;;){if(O===L.length){ee(O,0,K.slice(R));break}if(R===K.length){ee(O,L.length-O,[]);break}const N=L[O],$=K[R];if(j(N,$)){O+=1,R+=1;continue}fe($)?(ee(O,1,[]),O+=1):(ee(O,0,[$]),R+=1)}return H}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(L){L.default="default",L.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(L){const K=L;return!!((typeof K.include=="string"||w.isRelativePattern(K.include))&&(typeof K.exclude=="string"||w.isRelativePattern(K.exclude)))}e.isDocumentExcludePattern=r;function l(L,K,fe){if(Array.isArray(L.viewType)&&L.viewType.indexOf(K)>=0||L.viewType===K)return!0;if(L.filenamePattern){let j=r(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,H=r(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(w.match(j,(0,P.basename)(fe.fsPath).toLowerCase()))return!(H&&w.match(H,(0,P.basename)(fe.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class f{constructor(K){this.textModel=K}getElements(){const K=new Int32Array(this.textModel.cells.length);for(let fe=0;fe<this.textModel.cells.length;fe++)K[fe]=this.textModel.cells[fe].getHashValue();return K}}e.CellSequence=f,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var v;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(v=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function T(L){L.sort((fe,j)=>fe-j);const K=L.shift();return K===void 0?[]:L.reduce(function(fe,j){return j<=fe[0][1]?fe[0][1]=j+1:fe.unshift([j,j+1]),fe},[[K,K+1]]).reverse().map(fe=>({start:fe[0],end:fe[1]}))}e.cellIndexesToRanges=T;function b(L){return L.reduce((fe,j)=>{for(let H=j.start;H<j.end;H++)fe.push(H);return fe},[])}e.cellRangesToIndexes=b;function E(L){const K=L.sort((j,H)=>j.start-H.start),fe=K[0];return fe?K.reduce((j,H)=>{const ee=j[j.length-1];return ee.end>=H.start?ee.end=Math.max(ee.end,H.end):j.push(H),j},[fe]):[]}e.reduceRanges=E;function F(L,K){return K.start>=L.start&&K.end<=L.end}e.cellRangeContains=F}),define(be[171],we([0,1,141,4,63]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new P.RawContextKey("customExecutionSupported",!0,w.localize(0,null)),e.ShellExecutionSupportedContext=new P.RawContextKey("shellExecutionSupported",!1,w.localize(1,null)),e.ProcessExecutionSupportedContext=new P.RawContextKey("processExecutionSupported",!1,w.localize(2,null)),e.ITaskService=(0,k.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[172],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function w(P){return[...P.entries()]}e.serializeEnvironmentVariableCollection=w;function k(P){return new Map(P)}e.deserializeEnvironmentVariableCollection=k}),define(be[96],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var w;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(y,C)=>{C.expand!==void 0&&(y.expand=C.expand),C.item!==void 0&&Object.assign(y.item,C.item)};e.applyTestItemUpdate=k;var P;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(P=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(y,C)=>`${y}:${C.toString()}`;e.getTestSubscriptionKey=A;class S{add(C){}update(C){}remove(C,i){}complete(){}}e.IncrementalChangeCollector=S;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(C){const i=this.createChangeCollector();for(const I of C)switch(I[0]){case 0:{const c=I[1];if(c.parent){if(this.items.has(c.parent)){const d=this.items.get(c.parent);d.children.add(c.item.extId);const o=this.createItem(c,d);this.items.set(c.item.extId,o),i.add(o)}}else{this.roots.add(c.item.extId);const d=this.createItem(c);this.items.set(c.item.extId,d),i.add(d)}c.expand===2&&this.updateBusyControllers(1);break}case 1:{const c=I[1],d=this.items.get(c.extId);if(!d)break;(0,e.applyTestItemUpdate)(d,c),i.update(d),c.expand!==void 0&&d.expand===2&&c.expand!==2&&this.updateBusyControllers(-1);break}case 2:{const c=this.items.get(I[1]);if(!c)break;c.parent?this.items.get(c.parent).children.delete(c.item.extId):this.roots.delete(c.item.extId);const d=[[I[1]]];for(;d.length;)for(const o of d.pop()){const a=this.items.get(o);a&&(d.push(a.children),this.items.delete(o),i.remove(a,a!==c),a.expand===2&&this.updateBusyControllers(-1))}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}i.complete()}retireTest(C){}updateBusyControllers(C){this.busyControllerCount+=C}updatePendingRoots(C){this.pendingRootCount+=C}createChangeCollector(){return new S}}e.AbstractIncrementalTestCollection=D}),define(be[173],we([0,1,14,46,10,24,21,58,142]),function(J,e,w,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,c,d,o){if(this._contributedVariables=new Map,this._context=I,this._labelService=c,d)if(S.isWindows){const a=Object.create(null);this._envVariables=a,Object.keys(d).forEach(g=>{a[g.toLowerCase()]=d[g]})}else this._envVariables=d}resolveWithEnvironment(I,c,d){return this.recursiveResolve(I,c?c.uri:void 0,d)}async resolveAsync(I,c){return this.recursiveResolve(this._envVariables,I?I.uri:void 0,c)}resolve(I,c){return this.recursiveResolve(this._envVariables,I?I.uri:void 0,c)}resolveAnyBase(I,c,d,o){const a=A.deepClone(c);return S.isWindows&&a.windows?Object.keys(a.windows).forEach(g=>a[g]=a.windows[g]):S.isMacintosh&&a.osx?Object.keys(a.osx).forEach(g=>a[g]=a.osx[g]):S.isLinux&&a.linux&&Object.keys(a.linux).forEach(g=>a[g]=a.linux[g]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(this._envVariables,I?I.uri:void 0,a,d,o)}resolveAny(I,c,d){return this.resolveAnyBase(I,c,d)}async resolveAnyAsync(I,c,d){return this.resolveAnyBase(I,c,d)}resolveAnyMap(I,c,d){const o=new Map;return{newConfig:this.resolveAnyBase(I,c,d,o),resolvedVariables:o}}resolveWithInteractionReplace(I,c,d,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,c,d,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,c){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,c)}recursiveResolve(I,c,d,o,a){if(P.isString(d))return this.resolveString(I,c,d,o,a);if(P.isArray(d))return d.map(g=>this.recursiveResolve(I,c,g,o,a));if(P.isObject(d)){let g=Object.create(null);return Object.keys(d).forEach(h=>{const _=this.resolveString(I,c,h,o,a);g[_]=this.recursiveResolve(I,c,d[h],o,a)}),g}return d}resolveString(I,c,d,o,a){return d.replace(C.VARIABLE_REGEXP,(h,_)=>{if(_.includes(C.VARIABLE_LHS))return h;let m=this.evaluateSingleVariable(I,h,_,c,o);return a&&a.set(_,m),m})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,c,d,o,a){let g;const h=d.split(":");h.length>1&&(d=h[0],g=h[1]);const _=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,y.localize)(0,null,c))},m=()=>{const p=_();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,c,w.basename(p)))},u=()=>{if(g){const p=this._context.getFolderUri(g);if(p)return p;throw new Error((0,y.localize)(2,null,c,g))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,c)):new Error((0,y.localize)(4,null,c))};switch(d){case"env":if(g){if(I){const p=I[S.isWindows?g.toLowerCase():g];if(P.isString(p))return p}return""}throw new Error((0,y.localize)(5,null,c));case"config":if(g){const p=this._context.getConfigurationValue(o,g);if(P.isUndefinedOrNull(p))throw new Error((0,y.localize)(6,null,c,g));if(P.isObject(p))throw new Error((0,y.localize)(7,null,c,g));return p}throw new Error((0,y.localize)(8,null,c));case"command":return this.resolveFromMap(c,g,a,"command");case"input":return this.resolveFromMap(c,g,a,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return o||g?(0,D.normalizeDriveLetter)(this.fsPath(u())):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return w.basename(this.fsPath(u()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,y.localize)(9,null,c));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,c));case"file":return _();case"fileWorkspaceFolder":return m();case"relativeFile":return o||g?w.relative(this.fsPath(u()),_()):_();case"relativeFileDirname":const n=w.dirname(_());if(o||g){const f=w.relative(this.fsPath(u()),n);return f.length===0?".":f}return n;case"fileDirname":return w.dirname(_());case"fileExtname":return w.extname(_());case"fileBasename":return w.basename(_());case"fileBasenameNoExtension":const s=w.basename(_());return s.slice(0,s.length-w.extname(s).length);case"fileDirnameBasename":return w.basename(w.dirname(_()));case"execPath":const r=this._context.getExecPath();return r||c;case"execInstallFolder":const l=this._context.getAppRoot();return l||c;case"pathSeparator":return w.sep;default:try{const f=g?`${d}:${g}`:d;return this.resolveFromMap(c,f,a,void 0)}catch(f){return c}}}}resolveFromMap(I,c,d,o){if(c&&d){const a=o===void 0?d[c]:d[o+":"+c];if(typeof a=="string")return a;throw new Error((0,y.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[174],we([0,1,4]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var k;(function(c){c[c.UP=0]="UP",c[c.DOWN=1]="DOWN",c[c.LEFT=2]="LEFT",c[c.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var P;(function(c){c[c.HORIZONTAL=0]="HORIZONTAL",c[c.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(c){c[c.FIRST=0]="FIRST",c[c.LAST=1]="LAST",c[c.NEXT=2]="NEXT",c[c.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var S;(function(c){c[c.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",c[c.EVEN=1]="EVEN",c[c.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(c){c[c.COPY_EDITORS=0]="COPY_EDITORS",c[c.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(c){c[c.CREATION_TIME=0]="CREATION_TIME",c[c.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",c[c.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(c){c[c.GROUP_ACTIVE=0]="GROUP_ACTIVE",c[c.GROUP_INDEX=1]="GROUP_INDEX",c[c.EDITOR_OPEN=2]="EDITOR_OPEN",c[c.EDITOR_CLOSE=3]="EDITOR_CLOSE",c[c.EDITOR_MOVE=4]="EDITOR_MOVE",c[c.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",c[c.EDITOR_LABEL=6]="EDITOR_LABEL",c[c.EDITOR_PIN=7]="EDITOR_PIN",c[c.EDITOR_STICKY=8]="EDITOR_STICKY",c[c.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(c){c[c.NEW_EDITOR=1]="NEW_EDITOR",c[c.MOVE_EDITOR=2]="MOVE_EDITOR",c[c.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function I(c){return c.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(be[175],we([0,1,4]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(be[9],we([0,1,13,83,229,57,24,10,2,32,62,143,90,73,175,7]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var g;(function(ue){function Se(V){const{selectionStartLineNumber:Le,selectionStartColumn:Ie,positionLineNumber:Xe,positionColumn:et}=V,ct=new a.Position(Le-1,Ie-1),rt=new a.Position(Xe-1,et-1);return new a.Selection(ct,rt)}ue.to=Se;function ae(V){const{anchor:Le,active:Ie}=V;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}ue.from=ae})(g=e.Selection||(e.Selection={}));var h;(function(ue){function Se(V){if(!!V){const{start:Le,end:Ie}=V;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}}ue.from=Se;function ae(V){if(!!V){const{startLineNumber:Le,startColumn:Ie,endLineNumber:Xe,endColumn:et}=V;return new a.Range(Le-1,Ie-1,Xe-1,et-1)}}ue.to=ae})(h=e.Range||(e.Range={}));var _;(function(ue){function Se(ae){switch(ae){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 4:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}ue.to=Se})(_=e.TokenType||(e.TokenType={}));var m;(function(ue){function Se(V){return new a.Position(V.lineNumber-1,V.column-1)}ue.to=Se;function ae(V){return{lineNumber:V.line+1,column:V.character+1}}ue.from=ae})(m=e.Position||(e.Position={}));var u;(function(ue){function Se(V){switch(V){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}ue.from=Se;function ae(V){switch(V){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}ue.to=ae})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var p;(function(ue){function Se(V){let Le;return V.code&&((0,D.isString)(V.code)||(0,D.isNumber)(V.code)?Le=String(V.code):Le={value:String(V.code.value),target:V.code.target}),Object.assign(Object.assign({},h.from(V.range)),{message:V.message,source:V.source,code:Le,severity:n.from(V.severity),relatedInformation:V.relatedInformation&&V.relatedInformation.map(t.from),tags:Array.isArray(V.tags)?(0,w.coalesce)(V.tags.map(u.from)):void 0})}ue.from=Se;function ae(V){var Le;const Ie=new a.Diagnostic(h.to(V),V.message,n.to(V.severity));return Ie.source=V.source,Ie.code=(0,D.isString)(V.code)?V.code:(Le=V.code)===null||Le===void 0?void 0:Le.value,Ie.relatedInformation=V.relatedInformation&&V.relatedInformation.map(t.to),Ie.tags=V.tags&&(0,w.coalesce)(V.tags.map(u.to)),Ie}ue.to=ae})(p=e.Diagnostic||(e.Diagnostic={}));var t;(function(ue){function Se(V){return Object.assign(Object.assign({},h.from(V.location.range)),{message:V.message,resource:V.location.uri})}ue.from=Se;function ae(V){return new a.DiagnosticRelatedInformation(new a.Location(V.resource,h.to(V)),V.message)}ue.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(ue){function Se(V){switch(V){case a.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ue.from=Se;function ae(V){switch(V){case c.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}ue.to=ae})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(ue){function Se(V){return typeof V=="number"&&V>=a.ViewColumn.One?V-1:V===a.ViewColumn.Beside?o.SIDE_GROUP:o.ACTIVE_GROUP}ue.from=Se;function ae(V){if(typeof V=="number"&&V>=0)return V+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=ae})(s=e.ViewColumn||(e.ViewColumn={}));function r(ue){return typeof ue.range!="undefined"}function l(ue){return ue.length===0?!0:!!r(ue[0])}e.isDecorationOptionsArr=l;var f;(function(ue){function Se(et){return et.map(ue.from)}ue.fromMany=Se;function ae(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function V(et){let ct;if(ae(et)){const{language:at,value:vt}=et;ct={value:"```"+at+`
`+vt+"\n```\n"}}else a.MarkdownString.isMarkdownString(et)?ct={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ct={value:et}:ct={value:""};const rt=Object.create(null);ct.uris=rt;const Ge=at=>{try{let vt=y.URI.parse(at,!0);vt=vt.with({query:Le(vt.query,rt)}),rt[at]=vt}catch(vt){}return""},ft=new P.Renderer;return ft.link=Ge,ft.image=at=>Ge(k.parseHrefAndDimensions(at).href),P(ct.value,{renderer:ft}),ct}ue.from=V;function Le(et,ct){if(!et)return et;let rt;try{rt=(0,A.parse)(et)}catch(ft){}if(!rt)return et;let Ge=!1;return rt=(0,S.cloneAndChange)(rt,ft=>{if(y.URI.isUri(ft)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[at]=ft,Ge=!0,at}else return}),Ge?JSON.stringify(rt):et}function Ie(et){const ct=new a.MarkdownString(et.value,et.supportThemeIcons);return ct.isTrusted=et.isTrusted,ct}ue.to=Ie;function Xe(et){if(!!et)return typeof et=="string"?et:ue.from(et)}ue.fromStrict=Xe})(f=e.MarkdownString||(e.MarkdownString={}));function v(ue){return l(ue)?ue.map(Se=>({range:h.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?f.fromMany(Se.hoverMessage):Se.hoverMessage?f.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):ue.map(Se=>({range:h.from(Se)}))}e.fromRangeOrRangeWithMessage=v;function T(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?y.URI.file(ue):ue}e.pathOrURIToURI=T;var b;(function(ue){function Se(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?T(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}ue.from=Se})(b=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var E;(function(ue){function Se(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?T(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?b.from(ae.before):void 0,after:ae.after?b.from(ae.after):void 0}}ue.from=Se})(E=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(ue){function Se(ae){if(typeof ae=="undefined")return ae;switch(ae){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=Se})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ue){function Se(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?F.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?E.from(ae.light):void 0,dark:ae.dark?E.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?T(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?b.from(ae.before):void 0,after:ae.after?b.from(ae.after):void 0}}ue.from=Se})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(ue){function Se(V){return{text:V.newText,eol:V.newEol&&te.from(V.newEol),range:h.from(V.range)}}ue.from=Se;function ae(V){const Le=new a.TextEdit(h.to(V.range),V.text);return Le.newEol=typeof V.eol=="undefined"?void 0:te.to(V.eol),Le}ue.to=ae})(K=e.TextEdit||(e.TextEdit={}));var fe;(function(ue){function Se(V,Le,Ie){var Xe,et,ct;const rt={edits:[]};if(V instanceof a.WorkspaceEdit)for(let Ge of V._allEntries())if(Ge._type===1)rt.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const ft=Le==null?void 0:Le.getDocument(Ge.uri);rt.edits.push({_type:2,resource:Ge.uri,edit:K.from(Ge.edit),modelVersionId:ft==null?void 0:ft.version,metadata:Ge.metadata})}else Ge._type===3?rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:(Xe=Ie==null?void 0:Ie.lookupNotebookDocument(Ge.uri))===null||Xe===void 0?void 0:Xe.notebookDocument.version}):Ge._type===4?(Ge.newOutputs&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:2,index:Ge.index,append:Ge.append,outputs:Ge.newOutputs.map(Ve.from)}}),Ge.newMetadata&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:11,index:Ge.index,metadata:Ge.newMetadata}})):Ge._type===5?rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:(et=Ie==null?void 0:Ie.lookupNotebookDocument(Ge.uri))===null||et===void 0?void 0:et.notebookDocument.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(he.from)}}):Ge._type===6&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:10,outputId:Ge.outputId,items:((ct=Ge.newOutputItems)===null||ct===void 0?void 0:ct.map(Ee.from))||[],append:Ge.append}});return rt}ue.from=Se;function ae(V){const Le=new a.WorkspaceEdit;for(const Ie of V.edits)Ie.edit?Le.replace(y.URI.revive(Ie.resource),h.to(Ie.edit.range),Ie.edit.text):Le.renameFile(y.URI.revive(Ie.oldUri),y.URI.revive(Ie.newUri),Ie.options);return Le}ue.to=ae})(fe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(ue){const Se=Object.create(null);Se[a.SymbolKind.File]=0,Se[a.SymbolKind.Module]=1,Se[a.SymbolKind.Namespace]=2,Se[a.SymbolKind.Package]=3,Se[a.SymbolKind.Class]=4,Se[a.SymbolKind.Method]=5,Se[a.SymbolKind.Property]=6,Se[a.SymbolKind.Field]=7,Se[a.SymbolKind.Constructor]=8,Se[a.SymbolKind.Enum]=9,Se[a.SymbolKind.Interface]=10,Se[a.SymbolKind.Function]=11,Se[a.SymbolKind.Variable]=12,Se[a.SymbolKind.Constant]=13,Se[a.SymbolKind.String]=14,Se[a.SymbolKind.Number]=15,Se[a.SymbolKind.Boolean]=16,Se[a.SymbolKind.Array]=17,Se[a.SymbolKind.Object]=18,Se[a.SymbolKind.Key]=19,Se[a.SymbolKind.Null]=20,Se[a.SymbolKind.EnumMember]=21,Se[a.SymbolKind.Struct]=22,Se[a.SymbolKind.Event]=23,Se[a.SymbolKind.Operator]=24,Se[a.SymbolKind.TypeParameter]=25;function ae(Le){return typeof Se[Le]=="number"?Se[Le]:6}ue.from=ae;function V(Le){for(const Ie in Se)if(Se[Ie]===Le)return Number(Ie);return a.SymbolKind.Property}ue.to=V})(j=e.SymbolKind||(e.SymbolKind={}));var H;(function(ue){function Se(V){switch(V){case a.SymbolTag.Deprecated:return 1}}ue.from=Se;function ae(V){switch(V){case 1:return a.SymbolTag.Deprecated}}ue.to=ae})(H=e.SymbolTag||(e.SymbolTag={}));var ee;(function(ue){function Se(V){return{name:V.name,kind:j.from(V.kind),tags:V.tags&&V.tags.map(H.from),containerName:V.containerName,location:U.from(V.location)}}ue.from=Se;function ae(V){const Le=new a.SymbolInformation(V.name,j.to(V.kind),V.containerName,U.to(V.location));return Le.tags=V.tags&&V.tags.map(H.to),Le}ue.to=ae})(ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(ue){function Se(V){var Le,Ie;const Xe={name:V.name||"!!MISSING: name!!",detail:V.detail,range:h.from(V.range),selectionRange:h.from(V.selectionRange),kind:j.from(V.kind),tags:(Ie=(Le=V.tags)===null||Le===void 0?void 0:Le.map(H.from))!==null&&Ie!==void 0?Ie:[]};return V.children&&(Xe.children=V.children.map(Se)),Xe}ue.from=Se;function ae(V){const Le=new a.DocumentSymbol(V.name,V.detail,j.to(V.kind),h.to(V.range),h.to(V.selectionRange));return(0,w.isNonEmptyArray)(V.tags)&&(Le.tags=V.tags.map(H.to)),V.children&&(Le.children=V.children.map(ae)),Le}ue.to=ae})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var R;(function(ue){function Se(ae){const V=new a.CallHierarchyItem(j.to(ae.kind),ae.name,ae.detail||"",y.URI.revive(ae.uri),h.to(ae.range),h.to(ae.selectionRange));return V._sessionId=ae._sessionId,V._itemId=ae._itemId,V}ue.to=Se})(R=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(ue){function Se(ae){return new a.CallHierarchyIncomingCall(R.to(ae.from),ae.fromRanges.map(V=>h.to(V)))}ue.to=Se})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var $;(function(ue){function Se(ae){return new a.CallHierarchyOutgoingCall(R.to(ae.to),ae.fromRanges.map(V=>h.to(V)))}ue.to=Se})($=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(ue){function Se(V){return{range:V.range&&h.from(V.range),uri:V.uri}}ue.from=Se;function ae(V){return new a.Location(y.URI.revive(V.uri),h.to(V.range))}ue.to=ae})(U=e.location||(e.location={}));var Q;(function(ue){function Se(V){const Le=V,Ie=V;return{originSelectionRange:Le.originSelectionRange?h.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ie.uri,range:h.from(Le.targetRange?Le.targetRange:Ie.range),targetSelectionRange:Le.targetSelectionRange?h.from(Le.targetSelectionRange):void 0}}ue.from=Se;function ae(V){return{targetUri:y.URI.revive(V.uri),targetRange:h.to(V.range),targetSelectionRange:V.targetSelectionRange?h.to(V.targetSelectionRange):void 0,originSelectionRange:V.originSelectionRange?h.to(V.originSelectionRange):void 0}}ue.to=ae})(Q=e.DefinitionLink||(e.DefinitionLink={}));var Y;(function(ue){function Se(V){return{range:h.from(V.range),contents:f.fromMany(V.contents)}}ue.from=Se;function ae(V){return new a.Hover(V.contents.map(f.to),h.to(V.range))}ue.to=ae})(Y=e.Hover||(e.Hover={}));var ie;(function(ue){function Se(V){return{range:h.from(V.range),expression:V.expression}}ue.from=Se;function ae(V){return new a.EvaluatableExpression(h.to(V.range),V.expression)}ue.to=ae})(ie=e.EvaluatableExpression||(e.EvaluatableExpression={}));var pe;(function(ue){function Se(V){if(V instanceof a.InlineValueText)return{type:"text",range:h.from(V.range),text:V.text};if(V instanceof a.InlineValueVariableLookup)return{type:"variable",range:h.from(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};if(V instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(V.range),expression:V.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=Se;function ae(V){switch(V.type){case"text":return{range:h.to(V.range),text:V.text};case"variable":return{range:h.to(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};case"expression":return{range:h.to(V.range),expression:V.expression}}}ue.to=ae})(pe=e.InlineValue||(e.InlineValue={}));var Pe;(function(ue){function Se(V){return{frameId:V.frameId,stoppedLocation:h.from(V.stoppedLocation)}}ue.from=Se;function ae(V){return new a.InlineValueContext(V.frameId,h.to(V.stoppedLocation))}ue.to=ae})(Pe=e.InlineValueContext||(e.InlineValueContext={}));var Oe;(function(ue){function Se(V){return{range:h.from(V.range),kind:V.kind}}ue.from=Se;function ae(V){return new a.DocumentHighlight(h.to(V.range),V.kind)}ue.to=ae})(Oe=e.DocumentHighlight||(e.DocumentHighlight={}));var Te;(function(ue){function Se(ae){switch(ae){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}ue.to=Se})(Te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(ue){function Se(ae){return{triggerKind:Te.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}ue.to=Se})(Be=e.CompletionContext||(e.CompletionContext={}));var x;(function(ue){function Se(V){switch(V){case a.CompletionItemTag.Deprecated:return 1}}ue.from=Se;function ae(V){switch(V){case 1:return a.CompletionItemTag.Deprecated}}ue.to=ae})(x=e.CompletionItemTag||(e.CompletionItemTag={}));var G;(function(ue){const Se=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ae(Ie){var Xe;return(Xe=Se.get(Ie))!==null&&Xe!==void 0?Xe:9}ue.from=ae;const V=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Le(Ie){var Xe;return(Xe=V.get(Ie))!==null&&Xe!==void 0?Xe:a.CompletionItemKind.Property}ue.to=Le})(G=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(ue){function Se(ae,V){var Le;const Ie=new a.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Ie.label2=ae.label),Ie.insertText=ae.insertText,Ie.kind=G.to(ae.kind),Ie.tags=(Le=ae.tags)===null||Le===void 0?void 0:Le.map(x.to),Ie.detail=ae.detail,Ie.documentation=k.isMarkdownString(ae.documentation)?f.to(ae.documentation):ae.documentation,Ie.sortText=ae.sortText,Ie.filterText=ae.filterText,Ie.preselect=ae.preselect,Ie.commitCharacters=ae.commitCharacters,C.Range.isIRange(ae.range)?Ie.range=h.to(ae.range):typeof ae.range=="object"&&(Ie.range={inserting:h.to(ae.range.insert),replacing:h.to(ae.range.replace)}),Ie.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Ie.insertText=new a.SnippetString(ae.insertText):(Ie.insertText=ae.insertText,Ie.textEdit=Ie.range instanceof a.Range?new a.TextEdit(Ie.range,Ie.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Ie.additionalTextEdits=ae.additionalTextEdits.map(Xe=>K.to(Xe))),Ie.command=V&&ae.command?V.fromInternal(ae.command):void 0,Ie}ue.to=Se})(re=e.CompletionItem||(e.CompletionItem={}));var oe;(function(ue){function Se(V){return{label:V.label,documentation:V.documentation?f.fromStrict(V.documentation):void 0}}ue.from=Se;function ae(V){return{label:V.label,documentation:k.isMarkdownString(V.documentation)?f.to(V.documentation):V.documentation}}ue.to=ae})(oe=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(ue){function Se(V){return{label:V.label,documentation:V.documentation?f.fromStrict(V.documentation):void 0,parameters:Array.isArray(V.parameters)?V.parameters.map(oe.from):[],activeParameter:V.activeParameter}}ue.from=Se;function ae(V){return{label:V.label,documentation:k.isMarkdownString(V.documentation)?f.to(V.documentation):V.documentation,parameters:Array.isArray(V.parameters)?V.parameters.map(oe.to):[],activeParameter:V.activeParameter}}ue.to=ae})(me=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(ue){function Se(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(me.from):[]}}ue.from=Se;function ae(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(me.to):[]}}ue.to=ae})(De=e.SignatureHelp||(e.SignatureHelp={}));var Ne;(function(ue){function Se(V){var Le;return{text:V.text,range:h.from(V.range),kind:ge.from((Le=V.kind)!==null&&Le!==void 0?Le:a.InlineHintKind.Other),description:V.description&&f.fromStrict(V.description),whitespaceBefore:V.whitespaceBefore,whitespaceAfter:V.whitespaceAfter}}ue.from=Se;function ae(V){const Le=new a.InlineHint(V.text,h.to(V.range),ge.to(V.kind));return Le.whitespaceAfter=V.whitespaceAfter,Le.whitespaceBefore=V.whitespaceBefore,Le.description=k.isMarkdownString(V.description)?f.to(V.description):V.description,Le}ue.to=ae})(Ne=e.InlineHint||(e.InlineHint={}));var ge;(function(ue){function Se(V){return V}ue.from=Se;function ae(V){return V}ue.to=ae})(ge=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(ue){function Se(V){return{range:h.from(V.range),url:V.target,tooltip:V.tooltip}}ue.from=Se;function ae(V){let Le;if(V.url)try{Le=typeof V.url=="string"?y.URI.parse(V.url,!0):y.URI.revive(V.url)}catch(Ie){}return new a.DocumentLink(h.to(V.range),Le)}ue.to=ae})(Ce=e.DocumentLink||(e.DocumentLink={}));var Ae;(function(ue){function Se(V){const Le=new a.ColorPresentation(V.label);return V.textEdit&&(Le.textEdit=K.to(V.textEdit)),V.additionalTextEdits&&(Le.additionalTextEdits=V.additionalTextEdits.map(Ie=>K.to(Ie))),Le}ue.to=Se;function ae(V){return{label:V.label,textEdit:V.textEdit?K.from(V.textEdit):void 0,additionalTextEdits:V.additionalTextEdits?V.additionalTextEdits.map(Le=>K.from(Le)):void 0}}ue.from=ae})(Ae=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(ue){function Se(V){return new a.Color(V[0],V[1],V[2],V[3])}ue.to=Se;function ae(V){return[V.red,V.green,V.blue,V.alpha]}ue.from=ae})($e=e.Color||(e.Color={}));var _e;(function(ue){function Se(V){return{range:h.from(V.range)}}ue.from=Se;function ae(V){return new a.SelectionRange(h.to(V.range))}ue.to=ae})(_e=e.SelectionRange||(e.SelectionRange={}));var qe;(function(ue){function Se(ae){switch(ae){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}ue.to=Se})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var z;(function(ue){function Se(V){switch(V){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=Se;function ae(V){switch(V){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}ue.to=ae})(z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(ue){function Se(V){if(V===a.EndOfLine.CRLF)return 1;if(V===a.EndOfLine.LF)return 0}ue.from=Se;function ae(V){if(V===1)return a.EndOfLine.CRLF;if(V===0)return a.EndOfLine.LF}ue.to=ae})(te=e.EndOfLine||(e.EndOfLine={}));var ve;(function(ue){function Se(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=Se})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Ue;(function(ue){function Se(ae){const V={start:ae.start+1,end:ae.end+1};return ae.kind&&(V.kind=He.from(ae.kind)),V}ue.from=Se})(Ue=e.FoldingRange||(e.FoldingRange={}));var He;(function(ue){function Se(ae){if(ae)switch(ae){case a.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}ue.from=Se})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var xe;(function(ue){function Se(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?h.from(ae.selection):void 0,override:typeof ae.override=="boolean"?I.EditorOverride.DISABLED:void 0}}ue.from=Se})(xe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(ue){function Se(V){return V instanceof a.RelativePattern||typeof V=="string"?V:ae(V)?new a.RelativePattern(V.base,V.pattern):V}ue.from=Se;function ae(V){const Le=V;return Le&&typeof Le.base=="string"&&typeof Le.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var W;(function(ue){function Se(ae){if(ae){if(Array.isArray(ae))return ae.map(Se);if(typeof ae=="string")return ae;{const V=ae;return{language:V.language,scheme:V.scheme,pattern:typeof V.pattern=="undefined"?void 0:Ye.from(V.pattern),exclusive:V.exclusive}}}else return}ue.from=Se})(W=e.LanguageSelector||(e.LanguageSelector={}));var se;(function(ue){function Se(V){return{start:V.start,end:V.end}}ue.from=Se;function ae(V){return new a.NotebookRange(V.start,V.end)}ue.to=ae})(se=e.NotebookRange||(e.NotebookRange={}));var de;(function(ue){function Se(ae){return new a.NotebookCellMetadata().with(Object.assign(Object.assign({},ae),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}ue.to=Se})(de=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var q;(function(ue){function Se(V){return V}ue.from=Se;function ae(V){return new a.NotebookDocumentMetadata().with(V)}ue.to=ae})(q=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var Z;(function(ue){function Se(V){return{startTime:V.runStartTime,endTime:V.runEndTime,executionOrder:V.executionOrder,success:V.lastRunSuccess}}ue.to=Se;function ae(V){return{lastRunSuccess:V.success,runStartTime:V.startTime,runEndTime:V.endTime,executionOrder:V.executionOrder}}ue.from=ae})(Z=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var le;(function(ue){function Se(V){switch(V){case a.NotebookCellKind.Markdown:return d.CellKind.Markdown;case a.NotebookCellKind.Code:default:return d.CellKind.Code}}ue.from=Se;function ae(V){switch(V){case d.CellKind.Markdown:return a.NotebookCellKind.Markdown;case d.CellKind.Code:default:return a.NotebookCellKind.Code}}ue.to=ae})(le=e.NotebookCellKind||(e.NotebookCellKind={}));var he;(function(ue){function Se(V){var Le;return{cellKind:le.from(V.kind),language:V.language,source:V.source,metadata:Object.assign(Object.assign({},V.metadata),Z.from((Le=V.latestExecutionSummary)!==null&&Le!==void 0?Le:{})),outputs:V.outputs?V.outputs.map(Ve.from):[]}}ue.from=Se;function ae(V){return new a.NotebookCellData(le.to(V.cellKind),V.source,V.language,V.outputs?V.outputs.map(Ve.to):void 0,V.metadata?de.to(V.metadata):void 0)}ue.to=ae})(he=e.NotebookCellData||(e.NotebookCellData={}));var Ee;(function(ue){function Se(V){return{mime:V.mime,value:V.value,metadata:V.metadata}}ue.from=Se;function ae(V){return new a.NotebookCellOutputItem(V.mime,V.value,V.metadata)}ue.to=ae})(Ee=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ve;(function(ue){function Se(V){return{outputId:V.id,outputs:V.outputs.map(Ee.from),metadata:V.metadata}}ue.from=Se;function ae(V){const Le=V.outputs.map(Ee.to);return new a.NotebookCellOutput(Le,V.outputId,V.metadata)}ue.to=ae})(Ve=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Fe;(function(ue){function Se(Ie){if(Ie!=null){if(Ie instanceof a.RelativePattern||typeof Ie=="string")return Ie;if(Le(Ie))return new a.RelativePattern(Ie.base,Ie.pattern);if(V(Ie))return{include:Ye.from(Ie.include)||void 0,exclude:Ye.from(Ie.exclude)||void 0}}}ue.from=Se;function ae(Ie){return typeof Ie=="string"?Ie:Le(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}ue.to=ae;function V(Ie){const Xe=Ie,et=Ye.from(Xe.include);if(!(et&&et instanceof a.RelativePattern||typeof et=="string"))return!1;const ct=Ye.from(Xe.exclude);return!!(ct&&ct instanceof a.RelativePattern||typeof ct=="string")}function Le(Ie){const Xe=Ie;return Xe&&typeof Xe.base=="string"&&typeof Xe.pattern=="string"}})(Fe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var We;(function(ue){function Se(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?b.from(ae.top):void 0}}ue.from=Se})(We=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Qe;(function(ue){function Se(ae,V,Le){const Ie=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:V.toInternal(Ie,Le),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}ue.from=Se})(Qe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var it;(function(ue){function Se(ae){var V,Le,Ie;return{transientOutputs:(V=ae==null?void 0:ae.transientOutputs)!==null&&V!==void 0?V:!1,transientCellMetadata:Object.assign(Object.assign({},(Le=ae==null?void 0:ae.transientCellMetadata)!==null&&Le!==void 0?Le:ae==null?void 0:ae.transientMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Ie=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Ie!==void 0?Ie:{}}}ue.from=Se})(it=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var lt;(function(ue){function Se(V){var Le;return{uri:V.uri,provides:typeof V.provides=="string"?[V.provides]:(Le=V.provides)!==null&&Le!==void 0?Le:[]}}ue.from=Se;function ae(V){return{uri:y.URI.revive(V.uri),provides:V.provides}}ue.to=ae})(lt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var Ze;(function(ue){function Se(V){return{message:f.fromStrict(V.message)||"",severity:V.severity,expectedOutput:V.expectedOutput,actualOutput:V.actualOutput,location:V.location?U.from(V.location):void 0}}ue.from=Se;function ae(V){const Le=new a.TestMessage(typeof V.message=="string"?V.message:f.to(V.message));return Le.severity=V.severity,Le.actualOutput=V.actualOutput,Le.expectedOutput=V.expectedOutput,Le}ue.to=ae})(Ze=e.TestMessage||(e.TestMessage={}));var nt;(function(ue){function Se(Ie){var Xe,et;return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:h.from(Ie.range),debuggable:(Xe=Ie.debuggable)!==null&&Xe!==void 0?Xe:!1,description:Ie.description,runnable:(et=Ie.runnable)!==null&&et!==void 0?et:!0}}ue.from=Se;function ae(Ie){return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:h.from(Ie.range),debuggable:!1,description:Ie.description,runnable:!0}}ue.fromResultSnapshot=ae;function V(Ie){return{id:Ie.extId,label:Ie.label,uri:y.URI.revive(Ie.uri),range:h.to(Ie.range),addChild:()=>{},dispose:()=>{},status:a.TestItemStatus.Pending,data:void 0,debuggable:Ie.debuggable,description:Ie.description,runnable:Ie.runnable}}ue.toPlain=V;function Le(Ie){const Xe=new a.TestItemImpl(Ie.extId,Ie.label,y.URI.revive(Ie.uri),void 0);return Xe.range=h.to(Ie.range),Xe.debuggable=Ie.debuggable,Xe.description=Ie.description,Xe.runnable=Ie.runnable,Xe}ue.to=Le})(nt=e.TestItem||(e.TestItem={}));var ht;(function(ue){const Se=(V,Le)=>Object.assign(Object.assign({},nt.toPlain(V.item)),{taskStates:V.tasks.map(Ie=>({state:Ie.state,duration:Ie.duration,messages:Ie.messages.map(Ze.to)})),children:V.children.map(Ie=>Le.get(Ie)).filter(D.isDefined).map(Ie=>Se(Ie,Le))});function ae(V){const Le=[],Ie=new Map;for(const Xe of V.items)Ie.set(Xe.item.extId,Xe),Xe.direct&&Le.push(Xe);return{completedAt:V.completedAt,results:Le.map(Xe=>Se(Xe,Ie))}}ue.to=ae})(ht=e.TestResults||(e.TestResults={}));var wt;(function(ue){function Se(ae){switch(ae){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}ue.to=Se})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(be[176],we([0,1,2,12,7,9,45]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(C,i,I,c={timeout:1500,errors:3}){this._logService=C,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=c,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(i,I,c)=>{const o={dispose:this._callbacks.push([i,I,C])};return Array.isArray(c)&&c.push(o),o}}async $participateInSave(C,i){const I=w.URI.revive(C);let c=!1;const d=setTimeout(()=>c=!0,this._thresholds.timeout),o=[];try{for(let a of[...this._callbacks]){if(c)break;const g=this._documents.getDocument(I),h=await this._deliverEventAsyncAndBlameBadListeners(a,{document:g,reason:A.TextDocumentSaveReason.to(i)});o.push(h)}}finally{clearTimeout(d)}return o}_deliverEventAsyncAndBlameBadListeners([C,i,I],c){const d=this._badListeners.get(C);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,i,c).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const a=this._badListeners.get(C);this._badListeners.set(C,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,i,I,c){const d=[],o=Date.now(),{document:a,reason:g}=c,{version:h}=a,_=Object.freeze({document:a,reason:g,waitUntil(m){if(Object.isFrozen(d))throw(0,k.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(m))}});try{i.apply(I,[_])}catch(m){return Promise.reject(m)}return Object.freeze(d),new Promise((m,u)=>{const p=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(p),m(t)}).catch(t=>{clearTimeout(p),u(t)})}).then(m=>{const u={edits:[]};for(const p of m)if(Array.isArray(p)&&p.every(t=>t instanceof P.TextEdit))for(const{newText:t,newEol:n,range:s}of p)u.edits.push({_type:2,resource:a.uri,edit:{range:s&&A.Range.from(s),text:t,eol:n&&A.EndOfLine.from(n)}});if(u.edits.length!==0)return h===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(be[177],we([0,1,3,11,28,2,9,7]),function(J,e,w,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(I,c,d,o,a){this._onDidCreate=new w.Emitter,this._onDidChange=new w.Emitter,this._onDidDelete=new w.Emitter,this._config=0,d&&(this._config+=1),o&&(this._config+=2),a&&(this._config+=4);const g=(0,P.parse)(c),h=I(_=>{if(!d)for(let m of _.created){const u=A.URI.revive(m);g(u.fsPath)&&this._onDidCreate.fire(u)}if(!o)for(let m of _.changed){const u=A.URI.revive(m);g(u.fsPath)&&this._onDidChange.fire(u)}if(!a)for(let m of _.deleted){const u=A.URI.revive(m);g(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,h)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(I,c,d){this._logService=c,this._extHostDocumentsAndEditors=d,this._onFileSystemEvent=new w.Emitter,this._onDidRenameFile=new w.Emitter,this._onDidCreateFile=new w.Emitter,this._onDidDeleteFile=new w.Emitter,this._onWillRenameFile=new k.AsyncEmitter,this._onWillCreateFile=new k.AsyncEmitter,this._onWillDeleteFile=new k.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,c,d,o){return new y(this._onFileSystemEvent.event,I,c,d,o)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,c){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:c.map(d=>({oldUri:A.URI.revive(d.source),newUri:A.URI.revive(d.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:c.map(d=>A.URI.revive(d.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:c.map(d=>A.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,c){return(d,o,a)=>{const g=function(_){d.call(o,_)};return g.extension=I,c.event(g,void 0,a)}}async $onWillRunFileOperation(I,c,d,o){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:c.map(a=>({oldUri:A.URI.revive(a.source),newUri:A.URI.revive(a.target)}))},d,o);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:c.map(a=>A.URI.revive(a.target))},d,o);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:c.map(a=>A.URI.revive(a.target))},d,o)}}async _fireWillEvent(I,c,d,o){const a=new Set,g=[];if(await I.fireAsync(c,o,async(_,m)=>{var u;const p=Date.now(),t=await Promise.resolve(_);t instanceof D.WorkspaceEdit&&(g.push(t),a.add((u=m.extension.displayName)!==null&&u!==void 0?u:m.extension.identifier.value)),Date.now()-p>d&&this._logService.warn("SLOW file-participant",m.extension.identifier)}),!o.isCancellationRequested&&g.length!==0){const h={edits:[]};for(let _ of g){let{edits:m}=S.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);h.edits=h.edits.concat(m)}return{edit:h,extensionNames:Array.from(a)}}}}e.ExtHostFileSystemEventService=C}),define(be[178],we([0,1,18,24,2,9,7,73]),function(J,e,w,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(c,d,o,a){this.start=c,this.deletedCount=d,this.deletedItems=o,this.items=a}static asApiEvents(c){return c.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(o=>o.cell)}))}}class C{constructor(c,d,o){var a;this._notebook=c,this._extHostDocument=d,this._cellData=o,this.handle=o.handle,this.uri=P.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(a=o.metadata)!==null&&a!==void 0?a:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(c,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const c=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return c._notebook.getCellIndex(c)},notebook:c._notebook.notebookDocument,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get latestExecutionSummary(){return c._previousResult}})}return this._cell}setOutputs(c){this._outputs=c.map(A.NotebookCellOutput.to)}setOutputItems(c,d,o){const a=o.map(A.NotebookCellOutputItem.to),g=this._outputs.find(h=>h.id===c);g&&(d||(g.outputs.length=0),g.outputs.push(...a))}setMetadata(c){this._internalMetadata=c,this._metadata=A.NotebookCellMetadata.to(c),this._previousResult=A.NotebookCellPreviousExecutionResult.to(c)}}e.ExtHostCell=C;class i{constructor(c,d,o,a,g,h,_){this._proxy=c,this._textDocumentsAndEditors=d,this._textDocuments=o,this._emitter=a,this._viewType=g,this._metadata=h,this.uri=_,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get notebookDocument(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get viewType(){return c._viewType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===w.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(d){return d=c._validateIndex(d),c._cells[d].cell},getCells(d){return(d?c._getCells(d):c._cells).map(a=>a.cell)},save(){return c._save()}}}return this._notebook}updateBackup(c){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=c}disposeBackup(){var c;(c=this._backup)===null||c===void 0||c.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=this._metadata.with(c.metadata))}acceptModelChanged(c,d){this._versionId=c.versionId,this._isDirty=d;for(const o of c.rawEvents)o.kind===D.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(o.changes,!0),o.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===D.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===D.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(o.index,o.metadata)}_validateIndex(c){return c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){return c.start<0&&(c=c.with({start:0})),c.end>this._cells.length&&(c=c.with({end:this._cells.length})),c}_getCells(c){c=this._validateRange(c);const d=[];for(let o=c.start;o<c.end;o++)d.push(this._cells[o]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(c,d){if(!this._disposed){const o=[],a=[],g=[];c.reverse().forEach(h=>{const m=h[2].map(t=>{const n=new C(this,this._textDocumentsAndEditors,t);return d||a.push(C.asModelAddData(this.notebookDocument,t)),n}),u=new y(h[0],h[1],[],m),p=this._cells.splice(h[0],h[1],...m);for(let t of p)g.push(t.uri),u.deletedItems.push(t.cell);o.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:g}),d||this._emitter.emitModelChange((0,k.deepFreeze)({document:this.notebookDocument,changes:y.asApiEvents(o)}))}}_moveCell(c,d){const o=this._cells.splice(c,1);this._cells.splice(d,0,...o);const a=[new y(c,1,o.map(g=>g.cell),[]),new y(d,0,[],o)];this._emitter.emitModelChange((0,k.deepFreeze)({document:this.notebookDocument,changes:y.asApiEvents(a)}))}_setCellOutputs(c,d){const o=this._cells[c];o.setOutputs(d),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.notebookDocument,cells:[o.cell]}))}_setCellOutputItems(c,d,o,a){const g=this._cells[c];g.setOutputItems(d,o,a),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.notebookDocument,cells:[g.cell]}))}_changeCellLanguage(c,d){const o=this._cells[c];o.cell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(o.uri,d)}_changeCellMetadata(c,d){var o;const a=this._cells[c],g=a.internalMetadata,h=a.cell.metadata;a.setMetadata(d);const _=a.cell.metadata;if((0,k.equals)(h,_)||this._emitter.emitCellMetadataChange((0,k.deepFreeze)({document:this.notebookDocument,cell:a.cell})),g.runState!==d.runState){const m=(o=d.runState)!==null&&o!==void 0?o:S.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,k.deepFreeze)({document:this.notebookDocument,cell:a.cell,executionState:m}))}}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(d=>d.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(be[179],we([0,1,7,9]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,y){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:D,metadata:y})}replaceCellOutput(D,y){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:D,outputs:y.map(C=>k.NotebookCellOutput.from(C))})}replaceCells(D,y,C){this._throwIfFinalized(),!(D===y&&C.length===0)&&this._collectedEdits.push({editType:1,index:D,count:y-D,cells:C.map(k.NotebookCellData.from)})}}class A{constructor(D,y,C,i,I,c){this.id=D,this._proxy=y,this.notebookData=C,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=I,this._visibleRanges=i,this._viewColumn=c}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.notebookDocument},get selections(){return D._selections},get visibleRanges(){return D._visibleRanges},revealRange(y,C){D._proxy.$tryRevealRange(D.id,k.NotebookRange.from(y),C!=null?C:w.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(y){const C=new P(this.document.version);return y(C),D._applyEdit(C.finalize())},setDecorations(y,C){return D.setDecorations(y,C)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const y=[];let C=-1;for(let i=0;i<D.cellEdits.length;i++){if(C<0){y.push(D.cellEdits[i]),C++;continue}const c=y[C],d=D.cellEdits[i];if(c.editType===1&&d.editType===1&&c.index===d.index){c.cells.push(...D.cellEdits[i].cells),c.count+=D.cellEdits[i].count;continue}y.push(D.cellEdits[i]),C++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,y)}setDecorations(D,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return y.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,k.NotebookRange.from(y),D.key)}}e.ExtHostNotebookEditor=A}),define(be[180],we([0,1,9,153,133,20,52]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,c,d){const o=this._handles++,{title:a,location:g,cancellable:h}=c,_={label:(0,P.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(o,{location:w.ProgressLocation.from(g),title:a,source:_,cancellable:h},I),this._withProgress(o,d,!!h)}_withProgress(I,c,d){let o;d&&(o=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,o));const a=h=>{this._proxy.$progressEnd(h),this._mapHandleToCancellationSource.delete(h),o&&o.dispose()};let g;try{g=c(new C(this._proxy,I),d&&o?o.token:A.CancellationToken.None)}catch(h){throw a(I),h}return g.then(h=>a(I),h=>a(I)),g}$acceptProgressCanceled(I){const c=this._mapHandleToCancellationSource.get(I);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=D;function y(i,I){return i.message=I.message,typeof I.increment=="number"&&(typeof i.increment=="number"?i.increment+=I.increment:i.increment=I.increment),i}class C extends k.Progress{constructor(I,c){super(d=>this.throttledReport(d));this._proxy=I,this._handle=c}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}je([(0,S.throttle)(100,(i,I)=>y(i,I),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(be[97],we([0,1,42,12,54,9,7]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(c,d){const o=D._Keys.nextId();c.$registerTextEditorDecorationType(o,A.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:o,dispose(){c.$removeTextEditorDecorationType(o)}})}}e.TextEditorDecorationType=D,D._Keys=new P.IdGenerator("TextEditorDecorationType");class y{constructor(c,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,d){this._throwIfFinalized();let o=null;if(c instanceof S.Position)o=new S.Range(c,c);else if(c instanceof S.Range)o=c;else throw new Error("Unrecognized location");this._pushEdit(o,d,!1)}insert(c,d){this._throwIfFinalized(),this._pushEdit(new S.Range(c,c),d,!0)}delete(c){this._throwIfFinalized();let d=null;if(c instanceof S.Range)d=c;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(c,d,o){const a=this._document.validateRange(c);this._collectedEdits.push({range:a,text:d,forceMoveMarkers:o})}setEndOfLine(c){if(this._throwIfFinalized(),c!==S.EndOfLine.LF&&c!==S.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=y;class C{constructor(c,d,o,a){this._proxy=c,this._id=d,this._accept(o),this._logService=a;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(h){g._setTabSize(h)},get insertSpaces(){return g._insertSpaces},set insertSpaces(h){g._setInsertSpaces(h)},get cursorStyle(){return g._cursorStyle},set cursorStyle(h){g._setCursorStyle(h)},get lineNumbers(){return g._lineNumbers},set lineNumbers(h){g._setLineNumbers(h)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const d=Math.floor(c);return d>0?d:null}if(typeof c=="string"){const d=parseInt(c,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(c){const d=this._validateTabSize(c);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const d=this._validateInsertSpaces(c);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(c)})))}assign(c){const d={};let o=!1;if(typeof c.tabSize!="undefined"){const a=this._validateTabSize(c.tabSize);a==="auto"?(o=!0,d.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,o=!0,d.tabSize=a)}if(typeof c.insertSpaces!="undefined"){const a=this._validateInsertSpaces(c.insertSpaces);a==="auto"?(o=!0,d.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,o=!0,d.insertSpaces=a)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,o=!0,d.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,o=!0,d.lineNumbers=A.TextEditorLineNumbersStyle.from(c.lineNumbers)),o&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(c){c.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=C;class i{constructor(c,d,o,a,g,h,_,m){this.id=c,this._proxy=d,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new C(this._proxy,this.id,h,o),this._visibleRanges=_,this._viewColumn=m;const u=this;this.value=Object.freeze({get document(){return a.getValue()},set document(p){throw(0,k.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(p){if(!(p instanceof S.Selection))throw(0,k.illegalArgument)("selection");u._selections=[p],u._trySetSelection()},get selections(){return u._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof S.Selection)))throw(0,k.illegalArgument)("selections");u._selections=p,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(p){throw(0,k.readonly)("visibleRanges")},get options(){return u._options.value},set options(p){u._disposed||u._options.assign(p)},get viewColumn(){return u._viewColumn},set viewColumn(p){throw(0,k.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new y(a.getValue(),t);return p(n),u._applyEdit(n)},insertSnippet(p,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=u._selections.map(r=>A.Range.from(r));else if(t instanceof S.Position){const{lineNumber:r,column:l}=A.Position.from(t);s=[{startLineNumber:r,startColumn:l,endLineNumber:r,endColumn:l}]}else if(t instanceof S.Range)s=[A.Range.from(t)];else{s=[];for(const r of t)if(r instanceof S.Range)s.push(A.Range.from(r));else{const{lineNumber:l,column:f}=A.Position.from(r);s.push({startLineNumber:l,startColumn:f,endLineNumber:l,endColumn:f})}}return d.$tryInsertSnippet(c,p.value,s,n)},setDecorations(p,t){const n=t.length===0;n&&!u._hasDecorationsForKey.has(p.key)||(n?u._hasDecorationsForKey.delete(p.key):u._hasDecorationsForKey.add(p.key),u._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return d.$trySetDecorations(c,p.key,A.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let r=0,l=t.length;r<l;r++){const f=t[r];s[4*r]=f.start.line+1,s[4*r+1]=f.start.character+1,s[4*r+2]=f.end.line+1,s[4*r+3]=f.end.character+1}return d.$trySetDecorationsFast(c,p.key,s)}}))},revealRange(p,t){u._runOnProxy(()=>d.$tryRevealRange(c,A.Range.from(p),t||S.TextEditorRevealType.Default))},show(p){d.$tryShowEditor(c,A.ViewColumn.from(p))},hide(){d.$tryHideEditor(c)}})}dispose(){(0,w.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,w.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,w.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,w.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,w.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const d=c.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const o=d.edits.map(g=>g.range);o.sort((g,h)=>g.end.line===h.end.line?g.end.character===h.end.character?g.start.line===h.start.line?g.start.character-h.start.character:g.start.line-h.start.line:g.end.character-h.end.character:g.end.line-h.end.line);for(let g=0,h=o.length-1;g<h;g++){const _=o[g].end;if(o[g+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=d.edits.map(g=>({range:A.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,a,{setEndOfLine:typeof d.setEndOfLine=="number"?A.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=i}),define(be[181],we([0,1,136,25,2,3,6,11,7,10,13,9,20]),function(J,e,w,k,P,A,S,D,y,C,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(g,h){if((0,C.isString)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let _;return Array.isArray(g.highlights)&&(_=g.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),_=_.length?_:void 0),{label:g.label,highlights:_}}}class o{constructor(h,_,m){this._proxy=h,this.commands=_,this.logService=m,this.treeViews=new Map;function u(p){return p&&p.$treeViewId&&p.$treeItemHandle}_.registerArgumentProcessor({processArgument:p=>u(p)?this.convertArgument(p):Array.isArray(p)&&p.length>0?p.map(t=>u(t)?this.convertArgument(t):t):p})}registerTreeDataProvider(h,_,m){const u=this.createTreeView(h,{treeDataProvider:_},m);return{dispose:()=>u.dispose()}}createTreeView(h,_,m){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(h,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany}),p=this.createExtHostTreeView(h,_,m);return{get onDidCollapseElement(){return p.onDidCollapseElement},get onDidExpandElement(){return p.onDidExpandElement},get selection(){return p.selectedElements},get onDidChangeSelection(){return p.onDidChangeSelection},get visible(){return p.visible},get onDidChangeVisibility(){return p.onDidChangeVisibility},get message(){return p.message},set message(t){p.message=t},get title(){return p.title},set title(t){p.title=t},get description(){return p.description},set description(t){p.description=t},reveal:(t,n)=>p.reveal(t,n),dispose:async()=>{await u,this.treeViews.delete(h),p.dispose()}}}$getChildren(h,_){const m=this.treeViews.get(h);return m?m.getChildren(_):Promise.reject(new Error((0,w.localize)(0,null,h)))}async $hasResolve(h){const _=this.treeViews.get(h);if(!_)throw new Error((0,w.localize)(1,null,h));return _.hasResolve}$resolve(h,_,m){const u=this.treeViews.get(h);if(!u)throw new Error((0,w.localize)(2,null,h));return u.resolveTreeItem(_,m)}$setExpanded(h,_,m){const u=this.treeViews.get(h);if(!u)throw new Error((0,w.localize)(3,null,h));u.setExpanded(_,m)}$setSelection(h,_){const m=this.treeViews.get(h);if(!m)throw new Error((0,w.localize)(4,null,h));m.setSelection(_)}$setVisible(h,_){const m=this.treeViews.get(h);if(!m)throw new Error((0,w.localize)(5,null,h));m.setVisible(_)}createExtHostTreeView(h,_,m){const u=new a(h,_,this._proxy,this.commands.converter,this.logService,m);return this.treeViews.set(h,u),u}convertArgument(h){const _=this.treeViews.get(h.$treeViewId);return _?_.getExtensionElement(h.$treeItemHandle):null}}e.ExtHostTreeViews=o;class a extends S.Disposable{constructor(h,_,m,u,p,t){super();if(this.viewId=h,this.proxy=m,this.commands=u,this.logService=p,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const l of t.contributes.views[r])l.id===h&&(this._title=l.name);this.dataProvider=_.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,s;this._register(A.Event.debounce(this._onDidChangeData.event,(r,l)=>(r||(r={message:!1,elements:[]}),l.element!==!1&&(n||(n=new Promise(f=>s=f),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(l.element)),l.message&&(r.message=!0),r),200,!0)(({message:r,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=s;return n=null,this.refresh(l).then(()=>f())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(h=>this.getExtensionElement(h)).filter(h=>!(0,C.isUndefinedOrNull)(h))}getChildren(h){const _=h?this.getExtensionElement(h):void 0;if(h&&!_)return this.logService.error(`No tree item with id '${h}' found.`),Promise.resolve([]);const m=this.getChildrenNodes(h);return(m?Promise.resolve(m):this.fetchChildrenNodes(_)).then(u=>u.map(p=>p.item))}getExtensionElement(h){return this.elements.get(h)}reveal(h,_){_=_||{select:!0,focus:!1};const m=(0,C.isUndefinedOrNull)(_.select)?!0:_.select,u=(0,C.isUndefinedOrNull)(_.focus)?!1:_.focus,p=(0,C.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.refreshPromise.then(()=>this.resolveUnknownParentChain(h)).then(t=>this.resolveTreeNode(h,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:m,focus:u,expand:p})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:m,focus:u,expand:p})}get message(){return this._message}set message(h){this._message=h,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(h){this._title=h,this.proxy.$setTitle(this.viewId,h,this._description)}get description(){return this._description}set description(h){this._description=h,this.proxy.$setTitle(this.viewId,this._title,h)}setExpanded(h,_){const m=this.getExtensionElement(h);m&&(_?this._onDidExpandElement.fire(Object.freeze({element:m})):this._onDidCollapseElement.fire(Object.freeze({element:m})))}setSelection(h){(0,i.equals)(this._selectedHandles,h)||(this._selectedHandles=h,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(h){h!==this._visible&&(this._visible=h,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(h,_){var m;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(h);if(u){const p=this.nodes.get(u);if(p){const t=(m=await this.dataProvider.resolveTreeItem(p.extensionItem,u,_))!==null&&m!==void 0?m:p.extensionItem;return p.item.tooltip=this.getTooltip(t.tooltip),p.item.command=this.getCommand(p.disposableStore,t.command),p.item}}}}resolveUnknownParentChain(h){return this.resolveParent(h).then(_=>_?this.resolveUnknownParentChain(_).then(m=>this.resolveTreeNode(_,m[m.length-1]).then(u=>(m.push(u),m))):Promise.resolve([]))}resolveParent(h){const _=this.nodes.get(h);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(h))}resolveTreeNode(h,_){const m=this.nodes.get(h);return m?Promise.resolve(m):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(u=>this.createHandle(h,u,_,!0)).then(u=>this.getChildren(_?_.item.handle:void 0).then(()=>{const p=this.getExtensionElement(u);if(p){const t=this.nodes.get(p);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(h){if(h){let _;if(typeof h=="string"){const m=this.getExtensionElement(h);_=m?this.nodes.get(m):void 0}else _=h;return _&&_.children||null}return this.roots}async fetchChildrenNodes(h){this.clearChildren(h);const _=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const m=h?this.nodes.get(h):void 0,u=await this.dataProvider.getChildren(h);if(_.token.isCancellationRequested)return[];const p=await Promise.all((0,i.coalesce)(u||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,m):null}));return _.token.isCancellationRequested?[]:(0,i.coalesce)(p)}finally{_.dispose()}}refresh(h){if(h.some(m=>!m))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const m=this.getHandlesToRefresh(h);if(m.length)return this.refreshHandles(m)}return Promise.resolve(void 0)}getHandlesToRefresh(h){const _=new Set,m=h.map(p=>this.nodes.get(p));for(const p of m)if(p&&!_.has(p.item.handle)){let t=p;for(;t&&t.parent&&m.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&_.add(p.item.handle)}const u=[];return _.forEach(p=>{const t=this.elements.get(p);if(t){const n=this.nodes.get(t);n&&(!n.parent||!_.has(n.parent.item.handle))&&u.push(p)}}),u}refreshHandles(h){const _={};return Promise.all(h.map(m=>this.refreshNode(m).then(u=>{u&&(_[m]=u.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(h){const _=this.getExtensionElement(h);if(_){const m=this.nodes.get(_);if(m)return this.clearChildren(_),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(u=>{if(u){const p=this.createTreeNode(_,u,m.parent);return this.updateNodeCache(_,p,m,m.parent),m.dispose(),p}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(h,_,m){const u=this.createTreeNode(h,_,m);if(_.id&&this.elements.has(u.item.handle))throw new Error((0,w.localize)(6,null,_.id));return this.addNodeToCache(h,u),this.addNodeToParentCache(u,m),u}getTooltip(h){return y.MarkdownString.isMarkdownString(h)?I.MarkdownString.from(h):h}getCommand(h,_){return _?this.commands.toInternal(_,h):void 0}createTreeNode(h,_,m){const u=new S.DisposableStore,p=this.createHandle(h,_,m),t=this.getLightIconPath(_);return{item:{handle:p,parentHandle:m?m.item.handle:void 0,label:d(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(u,_.command),contextValue:_.contextValue,icon:t,iconDark:this.getDarkIconPath(_)||t,themeIcon:this.getThemeIcon(_),collapsibleState:(0,C.isUndefinedOrNull)(_.collapsibleState)?y.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:m,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(h){return h.iconPath instanceof y.ThemeIcon?h.iconPath:void 0}createHandle(h,{id:_,label:m,resourceUri:u},p,t){if(_)return`${a.ID_HANDLE_PREFIX}/${_}`;const n=d(m,this.extension),s=p?p.item.handle:a.LABEL_HANDLE_PREFIX;let r=n?n.label:u?(0,k.basename)(u):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const l=this.nodes.has(h)?this.nodes.get(h).item.handle:void 0,f=this.getChildrenNodes(p)||[];let v,T=0;do{if(v=`${s}/${T}:${r}`,t||!this.elements.has(v)||l===v)break;T++}while(T<=f.length);return v}getLightIconPath(h){if(h.iconPath&&!(h.iconPath instanceof y.ThemeIcon))return typeof h.iconPath=="string"||P.URI.isUri(h.iconPath)?this.getIconPath(h.iconPath):this.getIconPath(h.iconPath.light)}getDarkIconPath(h){if(h.iconPath&&!(h.iconPath instanceof y.ThemeIcon)&&h.iconPath.dark)return this.getIconPath(h.iconPath.dark)}getIconPath(h){return P.URI.isUri(h)?h:P.URI.file(h)}addNodeToCache(h,_){this.elements.set(_.item.handle,h),this.nodes.set(h,_)}updateNodeCache(h,_,m,u){this.elements.delete(_.item.handle),this.nodes.delete(h),_.item.handle!==m.item.handle&&this.elements.delete(m.item.handle),this.addNodeToCache(h,_);const p=this.getChildrenNodes(u)||[],t=p.filter(n=>n.item.handle===m.item.handle)[0];t&&p.splice(p.indexOf(t),1,_)}addNodeToParentCache(h,_){_?(_.children||(_.children=[]),_.children.push(h)):(this.roots||(this.roots=[]),this.roots.push(h))}clearChildren(h){if(h){const _=this.nodes.get(h);if(_){if(_.children)for(const m of _.children){const u=this.elements.get(m.item.handle);u&&this.clear(u)}_.children=void 0}}else this.clearAll()}clear(h){const _=this.nodes.get(h);if(_){if(_.children)for(const m of _.children){const u=this.elements.get(m.item.handle);u&&this.clear(u)}this.nodes.delete(h),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(h=>h.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}a.LABEL_HANDLE_PREFIX="0",a.ID_HANDLE_PREFIX="1"}),define(be[182],we([0,1,13,11,20,10,69,9,7,96]),function(J,e,w,k,P,A,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(g,h){if(h!==void 0){const _=this.testIdsToInternal.get(h),m=_==null?void 0:_.get(g);if(m)return[_,m]}return(0,w.mapFind)(this.testIdsToInternal.values(),_=>{const m=_.get(g);return m&&[_,m]})}createForHierarchy(g=()=>{}){return new o(this.createIdMap(c++),g)}createIdMap(g){const h=new d(g);return this.testIdsToInternal.set(h.id,h),{object:h,dispose:()=>this.testIdsToInternal.delete(h.id)}}}e.OwnedTestCollection=i;var I;(function(a){a[a.Disconnected=0]="Disconnected",a[a.IsChild=1]="IsChild",a[a.IsParent=2]="IsParent",a[a.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let c=0;class d{constructor(g){this.id=g,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(g){if(this.map.has(g.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${g.item.extId}`);this.map.set(g.item.extId,g),g.parent||this._roots.add(g)}has(g){return this.map.has(g)}delete(g){const h=this.map.get(g);return h?(this.map.delete(g),this._roots.delete(h),!0):!1}get(g){return this.map.get(g)}comparePositions(g,h){const _=typeof g=="string"?this.map.get(g):g,m=typeof h=="string"?this.map.get(h):h;if(!_||!m)return 0;if(_===m)return 3;for(let u=this.map.get(m.parent);u;u=this.map.get(u.parent))if(u===_)return 1;for(let u=this.map.get(_.parent);u;u=this.map.get(u.parent))if(u===m)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=d;class o{constructor(g,h){this.testIdToInternal=g,this.publishDiff=h,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new k.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(g,h){this.addItem(g,h,null)}getTestByReference(g){return this.testItemToInternal.get(g)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const h=this.diff[this.diff.length-1];if(h&&g[0]===1){if(h[0]===1&&h[1].extId===g[1].extId){(0,C.applyTestItemUpdate)(h[1],g[1]);return}if(h[0]===0&&h[1].item.extId===g[1].extId){(0,C.applyTestItemUpdate)(h[1],g[1]);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,h){var _;const m=this.testIdToInternal.object.get(g);if(!!m){if((m.expandLevels===void 0||h>m.expandLevels)&&(m.expandLevels=h),m.expand===1){const u=this.refreshChildren(m);return u.isSettled?this.expandChildren(m,h-1):u.p.then(()=>this.expandChildren(m,h-1))}else if(m.expand===3)return((_=m.initialExpand)===null||_===void 0?void 0:_.isSettled)===!1?m.initialExpand.p.then(()=>this.expandChildren(m,h-1)):this.expandChildren(m,h-1)}}dispose(){var g;for(const h of this.testItemToInternal.values())(g=h.discoverCts)===null||g===void 0||g.dispose(!0),(0,S.getPrivateApiFor)(h.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(g,h){const _=g==null?void 0:g.actual.id;switch(h[0]){case 2:this.pushDiff([4,_]);break;case 1:this.removeItem(g);break;case 0:this.addItem(h[1],g.src.controller,g);break;case 3:const[m,u,p]=h;switch(u){case"status":this.updateExpandability(g);break;case"range":this.pushDiff([1,{extId:_,item:{range:D.Range.from(p)}}]);break;default:this.pushDiff([1,{extId:_,item:{[u]:p}}]);break}break;default:(0,A.assertNever)(h[0])}}addItem(g,h,_){if(!(g instanceof y.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${g.id} did not`);if(this.testItemToInternal.has(g))throw new Error(`Attempted to add a single TestItem ${g.id} multiple times to the tree`);if(this.testIdToInternal.object.has(g.id))throw new Error(`Attempted to insert a duplicate test item ID ${g.id}`);const m=_?_.item.extId:null,u=g.resolveHandler?1:0,p=_==null?void 0:_.expandLevels,t={controller:h,tree:this.testIdToInternal.object.id},n={actual:g,parent:m,item:D.TestItem.from(g),expandLevels:p?p-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(g,n),this.pushDiff([0,{parent:m,src:t,expand:u,item:n.item}]);const s=(0,S.getPrivateApiFor)(g);s.parent=_==null?void 0:_.actual,s.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const r of s.children.values())this.testItemToInternal.has(r)||this.addItem(r,h,n)}updateExpandability(g){var h;let _;g.actual.resolveHandler?g.actual.status===y.TestItemStatus.Pending?_=g.discoverCts?2:1:((h=g.initialExpand)===null||h===void 0||h.complete(),_=3):_=0,_!==g.expand&&(g.expand=_,this.pushDiff([1,{extId:g.actual.id,expand:_}]),_===1&&g.expandLevels!==void 0&&this.refreshChildren(g))}expandChildren(g,h){if(!(h<0)){const _=[...g.actual.children.values()].map(m=>this.expand(m.id,h)).filter(k.isThenable);if(_.length)return Promise.all(_).then(()=>{})}}refreshChildren(g){if(g.discoverCts&&g.discoverCts.dispose(!0),!g.actual.resolveHandler){const h=new k.DeferredPromise;return h.complete(),h}return g.expand=2,g.discoverCts=new P.CancellationTokenSource,this.pushExpandStateUpdate(g),g.initialExpand=new k.DeferredPromise,g.actual.resolveHandler(g.discoverCts.token),g.initialExpand}pushExpandStateUpdate(g){this.pushDiff([1,{extId:g.actual.id,expand:g.expand}])}removeItem(g){var h;this.pushDiff([2,g.actual.id]);const _=[g];for(;_.length;){const m=_.pop();if(!!m){(h=m.discoverCts)===null||h===void 0||h.dispose(!0),this.testIdToInternal.object.delete(m.item.extId),this.testItemToInternal.delete(m.actual);for(const u of m.actual.children.values())_.push(this.testIdToInternal.object.get(u.id))}}}flushDiff(){const g=this.collectDiff();g.length&&this.publishDiff(g)}}e.SingleUseTestCollection=o}),define(be[183],we([0,1,26,3,14]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=A;class S{constructor(i){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(w.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(w.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${w.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(c=>I.add(w.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>I.has(w.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const c=S._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(c.map(d=>d.identifier)),I.length>0){const d=new Set;I.forEach(o=>d.add(w.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!d.has(w.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(c)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,h){this.addNode(g),this.addNode(h),this._arcs.has(g)?this._arcs.get(g).push(h):this._arcs.set(g,[h])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,h){const _=I.getArcs(g);for(let m=0;m<_.length;m++)if(!h.has(_[m]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let g of i){const h=w.ExtensionIdentifier.toKey(g.identifier);if(c.set(h,g),g.extensionDependencies)for(let _ of g.extensionDependencies){const m=w.ExtensionIdentifier.toKey(_);I.addArc(h,m)}}let d=new Set;I.getNodes().filter(g=>I.getArcs(g).length===0).forEach(g=>d.add(g));let o=I.getNodes().filter(g=>!d.has(g)),a;do{a=!1;for(let g=0;g<o.length;g++){const h=o[g];I.hasOnlyGoodArcs(h,d)&&(o.splice(g,1),g--,d.add(h),a=!0)}}while(a);return o.map(g=>c.get(g))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(w.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(w.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=S;var D;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(D||(D={}));function y(C,i){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==c)return I-c;const d=P.posix.basename(C.extensionLocation.path),o=P.posix.basename(i.extensionLocation.path);return d<o?-1:d>o?1:0}}),define(be[184],we([0,1,23]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var k;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function A(D){const y=w.VSBuffer.alloc(1);switch(D){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=A;function S(D,y){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=S}),define(be[33],we([0,1,3,2,4,26,150]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,P.createDecorator)("extensionService");class D{constructor(_){this.dependency=_}}e.MissingDependencyError=D;var y;(function(h){h[h.LocalProcess=0]="LocalProcess",h[h.LocalWebWorker=1]="LocalWebWorker",h[h.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(_,m,u,p){this.codeLoadingTime=_,this.activateCallTime=m,this.activateResolvedTime=u,this.activationReason=p}}e.ActivationTimes=C;class i{constructor(_,m){this.description=_,this.value=m}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var I;(function(h){h[h.Normal=0]="Normal",h[h.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function c(h){h.enableProposedApi||d(h)}e.checkProposedApiEnabled=c;function d(h){throw new Error(`[${h.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`)}e.throwProposedApiError=d;function o(h){return{type:h.isBuiltin?0:1,isBuiltin:h.isBuiltin||h.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(h.publisher,h.name),uuid:h.uuid},manifest:h,location:h.extensionLocation}}e.toExtension=o;function a(h){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(h.identifier.id),isBuiltin:h.type===0,isUserBuiltin:h.type===1&&h.isBuiltin,isUnderDevelopment:!1,extensionLocation:h.location},h.manifest),{uuid:h.identifier.uuid})}e.toExtensionDescription=a;class g{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None}activateByEvent(_){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(_){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(_,m){}_activateById(_,m){return Promise.resolve()}_onWillActivateExtension(_){}_onDidActivateExtension(_,m,u,p,t){}_onExtensionRuntimeError(_,m){}_onExtensionHostExit(_){}}e.NullExtensionService=g}),define(be[185],we([0,1,131,26,33,19]),function(J,e,w,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class D{constructor(a,g,h,_){this.startup=a,this.codeLoadingTime=g,this.activateCallTime=h,this.activateResolvedTime=_}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class y{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,g){return a===-1||g===-1?-1:g-a}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class C{constructor(a,g,h,_,m,u){this.activationFailed=a,this.activationFailedError=g,this.activationTimes=h,this.module=_,this.exports=m,this.subscriptions=u}}e.ActivatedExtension=C;class i extends C{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=i;class I extends C{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=I;class c extends C{constructor(a){super(!0,a,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=c;let d=class{constructor(a,g,h,_,m){this._logService=m,this._registry=a,this._resolvedExtensionsSet=new Set,g.forEach(u=>this._resolvedExtensionsSet.add(k.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,h.forEach(u=>this._hostExtensionsMap.set(k.ExtensionIdentifier.toKey(u),u)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const g=k.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(g)}getActivatedExtension(a){const g=k.ExtensionIdentifier.toKey(a),h=this._activatedExtensions.get(g);if(!h)throw new Error("Extension `"+a.value+"` is not known or not activated");return h}activateByEvent(a,g){if(this._alreadyActivatedEvents[a])return S;const h=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(h.map(_=>({id:_.identifier,reason:{startup:g,extensionId:_.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,g){const h=this._registry.getExtensionDescription(a);if(!h)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:h.identifier,reason:g}])}_handleActivateRequest(a,g,h){if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(a.id))){g[k.ExtensionIdentifier.toKey(a.id)]=a;return}const _=this._registry.getExtensionDescription(a.id);if(!_){this._host.onExtensionActivationError(a.id,new P.MissingDependencyError(a.id.value));const p=new Error(`Unknown dependency '${a.id.value}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(a.id),new c(p));return}const m=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let u=!0;for(let p=0,t=m.length;p<t;p++){const n=m[p];if(!this._resolvedExtensionsSet.has(k.ExtensionIdentifier.toKey(n))){const s=this._activatedExtensions.get(k.ExtensionIdentifier.toKey(n));if(!(s&&!s.activationFailed)){if(s&&s.activationFailed){this._host.onExtensionActivationError(_.identifier,w.localize(0,null,_.displayName||_.identifier.value,n));const f=new Error(`Dependency ${n} failed to activate`);f.detail=s.activationFailedError,this._activatedExtensions.set(k.ExtensionIdentifier.toKey(_.identifier),new c(f));return}if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(n))){u=!1,g[k.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(k.ExtensionIdentifier.toKey(n)),reason:a.reason};continue}const r=this._registry.getExtensionDescription(n);if(r){u=!1,g[k.ExtensionIdentifier.toKey(n)]={id:r.identifier,reason:a.reason};continue}this._host.onExtensionActivationError(_.identifier,new P.MissingDependencyError(n));const l=new Error(`Unknown dependency '${n}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(_.identifier),new c(l));return}}}u?g[k.ExtensionIdentifier.toKey(_.identifier)]=a:h.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(m=>!this._activatedExtensions.has(k.ExtensionIdentifier.toKey(m.id))),a.length===0))return Promise.resolve(void 0);const g=Object.create(null),h=[];for(let m=0,u=a.length;m<u;m++)this._handleActivateRequest(a[m],g,h);for(let m=0,u=h.length;m<u;m++){const p=k.ExtensionIdentifier.toKey(h[m].id);g[p]&&delete g[p]}const _=Object.keys(g).map(m=>g[m]);return h.length===0?Promise.all(_.map(m=>this._activateExtension(m.id,m.reason))).then(m=>{}):this._activateExtensions(_).then(m=>this._activateExtensions(h))}_activateExtension(a,g){const h=k.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(h))return Promise.resolve(void 0);const _=this._activatingExtensions.get(h);if(_)return _;const m=this._host.actualActivateExtension(a,g).then(void 0,u=>(this._host.onExtensionActivationError(a,w.localize(1,null,a.value,u.message)),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(u),new c(u))).then(u=>{this._activatedExtensions.set(h,u),this._activatingExtensions.delete(h)});return this._activatingExtensions.set(h,m),m}};d=je([Ke(4,A.ILogService)],d),e.ExtensionsActivator=d}),define(be[186],we([0,1,12]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,S)=>{this._actualOk=A,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,w.onUnexpectedError)(A))}then(A,S){return this._ensureActual().then(A,S)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=k}),define(be[98],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class w{constructor(y,C){this.isMain=y,this.sid=C,this.nid=++w.count}}e.ProxyIdentifier=w,w.count=0;const k=[];function P(D){const y=new w(!0,D);return k[y.nid]=y,y}e.createMainContextProxyIdentifier=P;function A(D){const y=new w(!1,D);return k[y.nid]=y,y}e.createExtHostContextProxyIdentifier=A;function S(D){return k[D].sid}e.getStringIdentifierForProxy=S}),define(be[5],we([0,1,2,98,57]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var S;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(S=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(u){u[u.Markdown=1]="Markdown",u[u.Code=2]="Code"})(C=e.CellKind||(e.CellKind={}));var i;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var c;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(c=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(u){u.name="$ident";function p(n,s){return Object.defineProperty(n,u.name,{value:s,enumerable:!0}),n}u.mixin=p;function t(n){return n[u.name]}u.of=t})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class o{static mixin(p){return p._id=o._n++,p}}e.IdObject=o,o._n=0;var a;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var h;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(h=e.WorkspaceEditType||(e.WorkspaceEditType={}));function _(u){if(u&&u.edits)for(const p of u.edits)typeof p.resource=="object"?p.resource=w.URI.revive(p.resource):(p.newUri=w.URI.revive(p.newUri),p.oldUri=w.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,P.revive)(p.metadata));return u}e.reviveWorkspaceEditDto=_;var m;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[74],we([0,1,5,3,4]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(D){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(w.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,y){return this._proxy.$getPassword(D,y)}store(D,y,C){return this._proxy.$setPassword(D,y,C)}delete(D,y){return this._proxy.$deletePassword(D,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,P.createDecorator)("IExtHostSecretState")}),define(be[75],we([0,1,4,19,5,15]),function(J,e,w,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,w.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(P.MainContext.MainThreadTelemetry)}report(y,C,i){const I=this.getUsageKey(y,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:y}))}getUsageKey(y,C){return`${y}-${C.identifier.value}`}};S=je([Ke(0,A.IExtHostRpcService),Ke(1,k.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(D,y,C){}})}),define(be[187],we([0,1,3,5,7,26]),function(J,e,w,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new w.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new w.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,C,i,I={}){const c=A.ExtensionIdentifier.toKey(y.identifier),d=this._inFlightRequests.get(c)||[],o=i.sort().join(" ");let a=d.find(g=>g.scopes===o);if(a)return a.result;{const g=this._getSession(y,c,C,i,I);a={scopes:o,result:g},d.push(a),this._inFlightRequests.set(c,d);try{await g}finally{const h=d.findIndex(_=>_.scopes===o);h>-1&&(d.splice(h),this._inFlightRequests.set(c,d))}return g}}async _getSession(y,C,i,I,c={}){await this._proxy.$ensureProvider(i);const d=y.displayName||y.name;return this._proxy.$getSession(i,I,C,d,c)}async removeSession(y,C){const i=this._authenticationProviders.get(y);return i?i.provider.removeSession(C):this._proxy.$removeSession(y,C)}registerAuthenticationProvider(y,C,i,I){var c;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:C,provider:i,options:I!=null?I:{supportsMultipleAccounts:!1}}),this._providers.find(o=>o.id===y)||this._providers.push({id:y,label:C});const d=i.onDidChangeSessions(o=>{var a,g,h;this._proxy.$sendDidChangeSessions(y,{added:(a=o.added)!==null&&a!==void 0?a:[],changed:(g=o.changed)!==null&&g!==void 0?g:[],removed:(h=o.removed)!==null&&h!==void 0?h:[]})});return this._proxy.$registerAuthenticationProvider(y,C,(c=I==null?void 0:I.supportsMultipleAccounts)!==null&&c!==void 0?c:!1),new P.Disposable(()=>{d.dispose(),this._authenticationProviders.delete(y);const o=this._providers.findIndex(a=>a.id===y);o>-1&&this._providers.splice(o),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,C){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,C){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,C){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,C){return this._onDidChangeSessions.fire({provider:{id:y,label:C}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,C){return y.forEach(i=>{this._providers.some(I=>I.id===i.id)||this._providers.push(i)}),C.forEach(i=>{const I=this._providers.findIndex(c=>c.id===i.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:C}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(be[188],we([0,1,5,15,9]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(D,y){this._extHostDocumentsAndEditors=y,this._proxy=D.getProxy(w.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const y=P.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};A=je([Ke(0,k.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(be[189],we([0,1,5]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(A){const S=A.getProxy(w.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(D){return S.$writeText(D)}})}}e.ExtHostClipboard=k}),define(be[76],we([0,1,10,7,9,24,5,13,19,57,32,38,2,6,4,15]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let g=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadCommands),this._logService=n,this.converter=new h(this,s=>{const r=this._apiCommands.get(s);return(r==null?void 0:r.result)===m.Void?r:void 0},n),this._argumentProcessors=[{processArgument(s){return(0,C.revive)(s)}},{processArgument(s){return(0,A.cloneAndChange)(s,function(r){if(i.Range.isIRange(r))return P.Range.to(r);if(I.Position.isIPosition(r))return P.Position.to(r);if(i.Range.isIRange(r.range)&&c.URI.isUri(r.uri))return P.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const r=t.args.map((f,v)=>{if(!f.validate(s[v]))throw new Error(`Invalid argument '${f.name}' when running '${t.id}', received: ${s[v]}`);return f.convert(s[v])}),l=await this.executeCommand(t.internalId,...r);return t.result.convert(l,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new k.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,r,l){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:r,description:l}),t&&this._proxy.$registerCommand(n),new k.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=(0,A.cloneAndChange)(n,function(l){if(l instanceof k.Position)return P.Position.from(l);if(l instanceof k.Range)return P.Range.from(l);if(l instanceof k.Location)return P.location.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,r,s);return(0,C.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw l}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:r,thisArg:l,description:f}=s;if(f)for(let v=0;v<f.args.length;v++)try{(0,w.validateConstraint)(n[v],f.args[v].constraint)}catch(T){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${f.args[v].name}' - ${f.args[v].description}`)}try{return await r.apply(l,n)}catch(v){if(t===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...n);T&&(t=T.command)}throw this._logService.error(v,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((r,l)=>l.processArgument(r),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:r}=s;r&&(t[n]=r)}return Promise.resolve(t)}};g=je([Ke(0,a.IExtHostRpcService),Ke(1,y.ILogService)],g),e.ExtHostCommands=g,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class h{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const r=this._lookupApiCommand(t.command);if(r)s.id=r.internalId,s.arguments=r.args.map((l,f)=>l.convert(t.arguments&&t.arguments[f]));else if((0,D.isNonEmptyArray)(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),n.add((0,d.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),s.$ident=l,s.id=this.delegatingCommandId,s.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return s}}fromInternal(t){const n=S.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=h;class _{constructor(t,n,s,r){this.name=t,this.description=n,this.validate=s,this.convert=r}optional(){return new _(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new _(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=_,_.Uri=new _("uri","Uri of a text document",p=>c.URI.isUri(p),p=>p),_.Position=new _("position","A position in a text document",p=>k.Position.isPosition(p),P.Position.from),_.Range=new _("range","A range in a text document",p=>k.Range.isRange(p),P.Range.from),_.Selection=new _("selection","A selection in a text document",p=>k.Selection.isSelection(p),P.Selection.from),_.Number=new _("number","",p=>typeof p=="number",p=>p),_.String=new _("string","",p=>typeof p=="string",p=>p),_.CallHierarchyItem=new _("item","A call hierarchy item",p=>p instanceof k.CallHierarchyItem,P.CallHierarchyItem.to);class m{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=m,m.Void=new m("no result",p=>p);class u{constructor(t,n,s,r,l){this.id=t,this.internalId=n,this.description=s,this.args=r,this.result=l}}e.ApiCommand=u}),define(be[190],we([0,1,6,9,7,62,76,168,13,87]),function(J,e,w,k,P,A,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",c(k.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,a)=>{if(!(0,y.isFalsyOrEmpty)(o)){class g extends P.SymbolInformation{static to(_){const m=new g(_.name,k.SymbolKind.to(_.kind),_.containerName||"",new P.Location(a[0],k.Range.to(_.range)));return m.detail=_.detail,m.range=m.location.range,m.selectionRange=k.Range.to(_.selectionRange),m.children=_.children?_.children.map(g.to):[],m}}return o.map(g.to)}})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",c(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",c(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new S.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",c(k.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",c(k.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",c(k.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(a=>P.Position.isPosition(a)),o=>o.map(k.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(a=>{let g;for(const h of a.reverse())g=new P.SelectionRange(k.Range.to(h),g);return g}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>{const a=[];if(Array.isArray(o))for(let g of o)a.push(...g[1].map(k.WorkspaceSymbol.to));return a})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(k.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(k.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(k.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return k.WorkspaceEdit.to(o)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(k.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new P.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!!o){const a=(0,C.decodeSemanticTokensDto)(o);if(a.type==="full")return new P.SemanticTokens(a.data,void 0)}})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new P.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!!o){const a=(0,C.decodeSemanticTokensDto)(o);if(a.type==="full")return new P.SemanticTokens(a.data,void 0)}})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,a,g)=>{if(!o)return new P.CompletionList([]);const h=o.suggestions.map(_=>k.CompletionItem.to(_,g));return new P.CompletionList(h,o.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return k.SignatureHelp.to(o)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,a,g)=>c(h=>new P.CodeLens(k.Range.to(h.range),h.command&&g.fromInternal(h.command)))(o))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>P.Range.isRange(o),o=>P.Selection.isSelection(o)?k.Selection.from(o):k.Range.from(o)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,a,g)=>c(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return g.fromInternal(h.command)}else{const _=new P.CodeAction(h.title,h.kind?new P.CodeActionKind(h.kind):void 0);return h.edit&&(_.edit=k.WorkspaceEdit.to(h.edit)),h.command&&(_.command=g.fromInternal(h.command)),_.isPreferred=h.isPreferred,_}})(o))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(a=>new P.ColorInformation(k.Range.to(a.range),k.Color.to(a.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",o=>o instanceof P.Color,k.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:k.Range.from(o.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(k.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineHint objects",o=>o.map(k.InlineHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",c(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientMetadata:o.options.transientCellMetadata,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(a=>k.NotebookExclusiveDocumentPattern.to(a))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(k.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[k.ViewColumn.from(o.viewColumn),k.TextEditorOpenOptions.from(o)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[k.ViewColumn.from(o.viewColumn),k.TextEditorOpenOptions.from(o)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[k.ViewColumn.from(o.viewColumn),k.TextEditorOpenOptions.from(o)]).optional()],S.ApiCommandResult.Void)];class I{constructor(a){this._disposables=new w.DisposableStore,this._commands=a}static register(a){return i.forEach(a.registerApiCommand,a),new I(a).registerCommands()}registerCommands(){const a=g=>(...h)=>g(this._commands,...h);this._register(D.RemoveFromRecentlyOpenedAPICommand.ID,a(D.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:g=>typeof g=="string"}]}),this._register(D.OpenIssueReporter.ID,a(D.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:g=>typeof g=="string"||typeof g=="object"&&typeof g.extensionId=="string"}]})}_register(a,g,h){const _=this._commands.registerCommand(!1,a,g,this,h);this._disposables.add(_)}}e.ExtHostApiCommands=I;function c(o){return a=>{if(Array.isArray(a))return a.map(o)}}function d(o){if(!!Array.isArray(o)){const a=[];for(const g of o)A.isLocationLink(g)?a.push(k.DefinitionLink.to(g)):a.push(k.location.to(g));return a}}}),define(be[191],we([0,1,11,52,3,6,2,62,26,9,7,5]),function(J,e,w,k,P,A,S,D,y,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class c{constructor(u,p,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(I.MainContext.MainThreadComments),p.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let l=n.commentUniqueId,f=r.getCommentByUniqueId(l);return f||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let l=n.text,f=n.commentUniqueId,v=r.getCommentByUniqueId(f);return v?(v.body=l,v):n}return n}})}createCommentController(u,p,t){const n=c.handlePool++,s=new o(u,n,this._proxy,p,t);this._commentControllers.set(s.handle,s);const r=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(u.identifier))||[];return r.push(s),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(u.identifier),r),s}$createCommentThreadTemplate(u,p,t){const n=this._commentControllers.get(u);!n||n.$createCommentThreadTemplate(p,t)}async $updateCommentThreadTemplate(u,p,t){const n=this._commentControllers.get(u);!n||n.$updateCommentThreadTemplate(p,t)}$deleteCommentThread(u,p){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(p)}$provideCommentingRanges(u,p,t){const n=this._commentControllers.get(u);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(S.URI.revive(p));return(0,w.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(r=>r?r.map(l=>C.Range.from(l)):void 0)}$toggleReaction(u,p,t,n,s){const r=this._commentControllers.get(u);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,w.asPromise)(()=>{const l=r.getCommentThread(p);if(l){const f=l.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&f&&r.reactionHandler)return r.reactionHandler(f,h(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=c,c.handlePool=0;class d{constructor(u,p,t,n,s,r,l){this._proxy=u,this._commentController=p,this._id=t,this._uri=n,this._range=s,this._comments=r,this.handle=d._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new P.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${p.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,C.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),p={};u("range")&&(p.range=C.Range.from(this._range)),u("label")&&(p.label=this.label),u("contextValue")&&(p.contextValue=this.contextValue),u("comments")&&(p.comments=this._comments.map(t=>a(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(p.collapseState=_(this._collapseState)),u("canReply")&&(p.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,p)}}getCommentByUniqueId(u){for(let p of this._commentsMap){let t=p[0],n=p[1];if(u===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}d._handlePool=0,je([(0,k.debounce)(100)],d.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=d;class o{constructor(u,p,t,n,s){this._extension=u,this._handle=p,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,p,t,n){if(typeof u=="string"){const s=new d(this._proxy,this,u,p,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new d(this._proxy,this,void 0,u,p,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(u,p){const t=new d(this._proxy,this,void 0,S.URI.revive(u),C.Range.to(p),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,p){let t=this._threads.get(u);t&&(t.range=C.Range.to(p))}$deleteCommentThread(u){let p=this._threads.get(u);p&&p.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function a(m,u,p,t){let n=t.get(p);n||(n=++m.commentHandle,t.set(p,n));const s=p.author&&p.author.iconPath?p.author.iconPath.toString():void 0;return{mode:p.mode,contextValue:p.contextValue,uniqueIdInThread:n,body:C.MarkdownString.from(p.body),userName:p.author.name,userIconPath:s,label:p.label,commentReactions:p.reactions?p.reactions.map(r=>g(r)):void 0}}function g(m){return{label:m.label,iconPath:m.iconPath?C.pathOrURIToURI(m.iconPath):void 0,count:m.count,hasReacted:m.authorHasReacted}}function h(m){return{label:m.label||"",count:m.count||0,iconPath:m.iconPath?S.URI.revive(m.iconPath):"",authorHasReacted:m.hasReacted||!1}}function _(m){if(m!==void 0)switch(m){case i.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(be[99],we([0,1,2,5,7,4,15,19,13,8,14]),function(J,e,w,k,P,A,S,D,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class gn{constructor(d,o){this._logService=o,this._provider=new Map,this._proxy=d.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,o){const a=gn._handlePool++;this._provider.set(a,{provider:d,extensionId:o}),this._proxy.$registerDecorationProvider(a,o.value);const g=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(h=>{if(!h){this._proxy.$onDidChange(a,null);return}let _=(0,y.asArray)(h);if(_.length<=gn._maxEventSize){this._proxy.$onDidChange(a,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,_.length);const m=_.map(t=>({uri:t,rank:(0,C.count)(t.path,"/")})),u=(0,y.groupBy)(m,(t,n)=>t.rank-n.rank||(0,C.compare)(t.uri.path,n.uri.path));let p=[];e:for(let t of u){let n;for(let s of t){let r=(0,i.dirname)(s.uri.path);if(n!==r&&(n=r,p.push(s.uri)>=gn._maxEventSize))break e}}this._proxy.$onDidChange(a,p)});return new P.Disposable(()=>{g==null||g.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(d,o,a){if(!this._provider.has(d))return Object.create(null);const g=Object.create(null),{provider:h,extensionId:_}=this._provider.get(d);return await Promise.all(o.map(async m=>{try{const{uri:u,id:p}=m,t=await Promise.resolve(h.provideFileDecoration(w.URI.revive(u),a));if(!t)return;try{P.FileDecoration.validate(t),g[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${_.value}': ${n}`)}}catch(u){this._logService.error(u)}})),g}};I._handlePool=0,I._maxEventSize=250,I=je([Ke(0,S.IExtHostRpcService),Ke(1,D.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(be[192],we([0,1,130,90,2,5,7,9,3,19,22]),function(J,e,w,k,P,A,S,D,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(o,a,g,h,_){this._name=o,this._owner=a,this._maxDiagnosticsPerFile=g,this._proxy=h,this._onDidChangeDiagnostics=_,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,a){if(!o){this.clear();return}this._checkDisposed();let g=[];if(P.URI.isUri(o)){if(!a){this.delete(o);return}this._data.set(o,a.slice()),g=[o]}else if(Array.isArray(o)){g=[];let _;o=[...o].sort(I._compareIndexedTuplesByUri);for(const m of o){const[u,p]=m;if((!_||u.toString()!==_.toString())&&(_&&this._data.get(_).length===0&&this._data.delete(_),_=u,g.push(u),this._data.set(u,[])),p){const t=this._data.get(u);t&&t.push(...p)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(g),!!this._proxy){const h=[];for(let _ of g){let m=[];const u=this._data.get(_);if(u)if(u.length>this._maxDiagnosticsPerFile){m=[];const p=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of u)if(n.severity===p[t]&&m.push(D.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;m.push({severity:k.MarkerSeverity.Info,message:(0,w.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:m[m.length-1].startLineNumber,startColumn:m[m.length-1].startColumn,endLineNumber:m[m.length-1].endLineNumber,endColumn:m[m.length-1].endColumn})}else m=u.map(p=>D.Diagnostic.from(p));h.push([_,m])}this._proxy.$changeMany(this._owner,h)}}delete(o){this._checkDisposed(),this._onDidChangeDiagnostics.fire([o]),this._data.delete(o),this._proxy&&this._proxy.$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(o,a){this._checkDisposed();for(let g of this._data.keys())o.apply(a,[g,this.get(g),this])}get(o){this._checkDisposed();const a=this._data.get(o);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(this._data.get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,a){return o[0].toString()<a[0].toString()?-1:o[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=I;let c=class $t{constructor(o,a){this._logService=a,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,$t._debouncer,50),$t._mapper),this._proxy=o.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(o,a){return o?o.concat(a):a}static _mapper(o){const a=[],g=new Set;for(const h of o)typeof h=="string"?g.has(h)||(g.add(h),a.push(P.URI.parse(h))):g.has(h.toString())||(g.add(h.toString()),a.push(h));return Object.freeze(a),{uris:a}}createDiagnosticCollection(o,a){const{_collections:g,_proxy:h,_onDidChangeDiagnostics:_,_logService:m}=this,u=new class{$changeMany(n,s){h.$changeMany(n,s),m.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,n,s.length===0?"CLEARING":s)}$clear(n){h.$clear(n),m.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,n)}dispose(){h.dispose()}};let p;if(!a)a="_generated_diagnostic_collection_name_#"+$t._idPool++,p=a;else if(!g.has(a))p=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do p=a+$t._idPool++;while(g.has(p))}return new class extends I{constructor(){super(a,p,$t._maxDiagnosticsPerFile,u,_);g.set(p,this)}dispose(){super.dispose(),g.delete(p)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const a=new Map,g=[];for(const h of this._collections.values())h.forEach((_,m)=>{let u=a.get(_.toString());typeof u=="undefined"&&(u=g.length,a.set(_.toString(),u),g.push([_,[]])),g[u][1]=g[u][1].concat(...m)});return g}}_getDiagnostics(o){let a=[];for(let g of this._collections.values())g.has(o)&&(a=a.concat(g.get(o)));return a}$acceptMarkersChange(o){if(!this._mirrorCollection){const a="_generated_mirror",g=new I(a,a,$t._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(a,g),this._mirrorCollection=g}for(const[a,g]of o)this._mirrorCollection.set(P.URI.revive(a),g.map(D.Diagnostic.to))}};c._idPool=0,c._maxDiagnosticsPerFile=1e3,c=je([Ke(1,C.ILogService)],c),e.ExtHostDiagnostics=c}),define(be[193],we([0,1,2,5]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class P{constructor(S){this._proxy=S.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(D=>D?D.map(y=>w.URI.revive(y)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(D=>D?w.URI.revive(D):void 0)}}e.ExtHostDialogs=P}),define(be[194],we([0,1,12,2,7,5,18,20,8]),function(J,e,w,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,c,d){this._documentsAndEditors=c,this._logService=d,this._documentContentProviders=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,c){if(Object.keys(S.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const d=C._handlePool++;this._documentContentProviders.set(d,c),this._proxy.$registerTextContentProvider(d,I);let o;return typeof c.onDidChange=="function"&&(o=c.onDidChange(a=>{if(a.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(d,a).then(g=>{if(!(!g&&typeof g!="string")){const h=this._documentsAndEditors.getDocument(a);if(!!h){const _=(0,y.splitLines)(g);if(!h.equalLines(_))return this._proxy.$onVirtualDocumentChange(a,g)}}},w.onUnexpectedError)})),new P.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(I,c){const d=this._documentContentProviders.get(I);return d?Promise.resolve(d.provideTextDocumentContent(k.URI.revive(c),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(be[195],we([0,1,3,6,2,5,95,9,10,24]),function(J,e,w,k,P,A,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(c,d){this._onDidAddDocument=new w.Emitter,this._onDidRemoveDocument=new w.Emitter,this._onDidChangeDocument=new w.Emitter,this._onDidSaveDocument=new w.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=d,this._documentsAndEditors.onDidRemoveDocuments(o=>{for(const a of o)this._onDidRemoveDocument.fire(a.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(o=>{for(const a of o)this._onDidAddDocument.fire(a.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(c){if(!!c){const d=this._documentsAndEditors.getDocument(c);if(d)return d}}getDocument(c){const d=this.getDocumentData(c);if(!(d==null?void 0:d.document))throw new Error(`Unable to retrieve document from URI '${c}'`);return d.document}ensureDocumentData(c){const d=this._documentsAndEditors.getDocument(c);if(d)return Promise.resolve(d);let o=this._documentLoader.get(c.toString());return o||(o=this._proxy.$tryOpenDocument(c).then(a=>{this._documentLoader.delete(c.toString());const g=P.URI.revive(a);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(g))},a=>(this._documentLoader.delete(c.toString()),Promise.reject(a))),this._documentLoader.set(c.toString(),o)),o}createDocumentData(c){return this._proxy.$tryCreateDocument(c).then(d=>P.URI.revive(d))}$acceptModelModeChanged(c,d){const o=P.URI.revive(c),a=this._documentsAndEditors.getDocument(o);if(!a)throw new Error("unknown document");this._onDidRemoveDocument.fire(a.document),a._acceptLanguageId(d),this._onDidAddDocument.fire(a.document)}$acceptModelSaved(c){const d=P.URI.revive(c),o=this._documentsAndEditors.getDocument(d);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(c,!1),this._onDidSaveDocument.fire(o.document)}$acceptDirtyStateChanged(c,d){const o=P.URI.revive(c),a=this._documentsAndEditors.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(d),this._onDidChangeDocument.fire({document:a.document,contentChanges:[]})}$acceptModelChanged(c,d,o){const a=P.URI.revive(c),g=this._documentsAndEditors.getDocument(a);if(!g)throw new Error("unknown document");g._acceptIsDirty(o),g.onEvents(d),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:g.document,contentChanges:d.changes.map(h=>({range:D.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text}))}))}setWordDefinitionFor(c,d){(0,S.setWordDefinitionFor)(c,d)}}e.ExtHostDocuments=i}),define(be[39],we([0,1,42,3,6,2,4,5,95,15,97,9,19,22,18,43,107]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(u,p){this._extHostRpc=u,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const p=[],t=[],n=[];if(u.removedDocuments)for(const s of u.removedDocuments){const r=A.URI.revive(s),l=this._documents.get(r);(l==null?void 0:l.unref())&&(this._documents.delete(r),p.push(l.value))}if(u.addedDocuments)for(const s of u.addedDocuments){const r=A.URI.revive(s.uri);let l=this._documents.get(r);if(l&&r.scheme!==o.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);l||(l=new h(new y.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),r,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(r,l),t.push(l.value)),l.ref()}if(u.removedEditors)for(const s of u.removedEditors){const r=this._editors.get(s);this._editors.delete(s),r&&n.push(r)}if(u.addedEditors)for(const s of u.addedEditors){const r=A.URI.revive(s.documentUri);w.ok(this._documents.has(r),`document '${r}' does not exist`),w.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const l=this._documents.get(r).value,f=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>l.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(v=>I.Range.to(v)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,f)}u.newActiveEditor!==void 0&&(w.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,P.dispose)(p),(0,P.dispose)(n),u.removedDocuments&&this._onDidRemoveDocuments.fire(p),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var p;return(p=this._documents.get(u))===null||p===void 0?void 0:p.value}allDocuments(){return a.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const p=this._editors.get(this._activeEditorId);return u?p:p==null?void 0:p.value}}allEditors(){return[...this._editors.values()]}};_=je([Ke(0,C.IExtHostRpcService),Ke(1,c.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[196],we([0,1,2,5,6,7,9,117,8,23]),function(J,e,w,k,P,A,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const o=this._schemes.indexOf(d);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),o=[];let a,g,h=14,_=14;for(const m of d){let u=a?(0,y.commonPrefixLength)(a,m):0;for(u===0?g=1:g=_;u<m.length;u++)u+1===m.length?(h=_,_=9):_+=1,o.push([g,m.toUpperCase().charCodeAt(u),_]),o.push([g,m.toLowerCase().charCodeAt(u),_]),g=_;a=m,_=h}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new D.StateMachine(o)}}provideDocumentLinks(d){this._initStateMachine();const o=[],a=D.LinkComputer.computeLinks({getLineContent(g){return d.lineAt(g-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const g of a){const h=S.DocumentLink.to(g);h.target&&o.push(h)}return o}}class I{constructor(d,o){this._extHostLanguageFeatures=o,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=d.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){var d;(d=this._linkProviderRegistration)===null||d===void 0||d.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,o,a,g={}){if(this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const h=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(h,a);let _=2;g.isCaseSensitive&&(_+=1024),g.isReadonly&&(_+=2048),typeof a.copy=="function"&&(_+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&(_+=4),this._proxy.$registerFileSystemProvider(h,o,_).catch(u=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${o}`),console.error(u)});const m=a.onDidChangeFile(u=>{const p=[];for(const t of u){let{uri:n,type:s}=t;if(n.scheme===o){let r;switch(s){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}p.push({resource:n,type:r})}}this._proxy.$onFileSystemChange(h,p)});return(0,P.toDisposable)(()=>{m.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(h),this._proxy.$unregisterProvider(h)})}static _asIStat(d){const{type:o,ctime:a,mtime:g,size:h}=d;return{type:o,ctime:a,mtime:g,size:h}}$stat(d,o){return Promise.resolve(this._getFsProvider(d).stat(w.URI.revive(o))).then(I._asIStat)}$readdir(d,o){return Promise.resolve(this._getFsProvider(d).readDirectory(w.URI.revive(o)))}$readFile(d,o){return Promise.resolve(this._getFsProvider(d).readFile(w.URI.revive(o))).then(a=>C.VSBuffer.wrap(a))}$writeFile(d,o,a,g){return Promise.resolve(this._getFsProvider(d).writeFile(w.URI.revive(o),a.buffer,g))}$delete(d,o,a){return Promise.resolve(this._getFsProvider(d).delete(w.URI.revive(o),a))}$rename(d,o,a,g){return Promise.resolve(this._getFsProvider(d).rename(w.URI.revive(o),w.URI.revive(a),g))}$copy(d,o,a,g){const h=this._getFsProvider(d);if(!h.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(h.copy(w.URI.revive(o),w.URI.revive(a),g))}$mkdir(d,o){return Promise.resolve(this._getFsProvider(d).createDirectory(w.URI.revive(o)))}$watch(d,o,a,g){const h=this._getFsProvider(d).watch(w.URI.revive(a),g);this._watches.set(o,h)}$unwatch(d,o){const a=this._watches.get(o);a&&(a.dispose(),this._watches.delete(o))}$open(d,o,a){const g=this._getFsProvider(d);if(!g.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(g.open(w.URI.revive(o),a))}$close(d,o){const a=this._getFsProvider(d);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(o))}$read(d,o,a,g){const h=this._getFsProvider(d);if(!h.read)throw new Error('FileSystemProvider does not implement "read"');const _=C.VSBuffer.alloc(g);return Promise.resolve(h.read(o,a,_.buffer,0,g)).then(m=>_.slice(0,m))}$write(d,o,a,g){const h=this._getFsProvider(d);if(!h.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(h.write(o,a,g.buffer,0,g.byteLength))}_getFsProvider(d){const o=this._fsProvider.get(d);if(!o){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return o}}e.ExtHostFileSystem=I}),define(be[77],we([0,1,5,64,7,23,4,15,49]),function(J,e,w,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Lt{constructor(I,c){const d=I.getProxy(w.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(o){return d.$stat(o).catch(Lt._handleError)},readDirectory(o){return d.$readdir(o).catch(Lt._handleError)},createDirectory(o){return d.$mkdir(o).catch(Lt._handleError)},async readFile(o){return d.$readFile(o).then(a=>a.buffer).catch(Lt._handleError)},writeFile(o,a){return d.$writeFile(o,A.VSBuffer.wrap(a)).catch(Lt._handleError)},delete(o,a){return d.$delete(o,Object.assign({recursive:!1,useTrash:!1},a)).catch(Lt._handleError)},rename(o,a,g){return d.$rename(o,a,Object.assign({overwrite:!1},g)).catch(Lt._handleError)},copy(o,a,g){return d.$copy(o,a,Object.assign({overwrite:!1},g)).catch(Lt._handleError)},isWritableFileSystem(o){const a=c.getCapabilities(o);if(typeof a=="number")return!(a&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new P.FileSystemError(String(I));if(I.name==="ENOPRO")throw P.FileSystemError.Unavailable(I.message);switch(I.name){case k.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(I.message);case k.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(I.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(I.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(I.message);case k.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(I.message);case k.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(I.message);default:throw new P.FileSystemError(I.message,I.name)}}};C=je([Ke(0,D.IExtHostRpcService),Ke(1,y.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(be[197],we([0,1,6,5]),function(J,e,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class P{constructor(S){this._handlePool=0,this._proxy=S.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,S),(0,w.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=P}),define(be[198],we([0,1,2,24,9,7,11,5,8,32,13,10,114,6,87,54,68,55,12]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a,g,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor(x,G){this._documents=x,this._provider=G}provideDocumentSymbols(x,G){const re=this._documents.getDocument(x);return(0,S.asPromise)(()=>this._provider.provideDocumentSymbols(re,G)).then(oe=>{if(!(0,i.isFalsyOrEmpty)(oe))return oe[0]instanceof A.DocumentSymbol?oe.map(P.DocumentSymbol.from):m._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree(x){var G;x=x.slice(0).sort((me,De)=>{let Ne=me.location.range.start.compareTo(De.location.range.start);return Ne===0&&(Ne=De.location.range.end.compareTo(me.location.range.end)),Ne});const re=[],oe=[];for(const me of x){const De={name:me.name||"!!MISSING: name!!",kind:P.SymbolKind.from(me.kind),tags:((G=me.tags)===null||G===void 0?void 0:G.map(P.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:P.Range.from(me.location.range),selectionRange:P.Range.from(me.location.range),children:[]};for(;;){if(oe.length===0){oe.push(De),re.push(De);break}const Ne=oe[oe.length-1];if(C.Range.containsRange(Ne.range,De.range)&&!C.Range.equalsRange(Ne.range,De.range)){Ne.children&&Ne.children.push(De),oe.push(De);break}oe.pop()}}return re}}class u{constructor(x,G,re){this._documents=x,this._commands=G,this._provider=re,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,G){const re=this._documents.getDocument(x),oe=await this._provider.provideCodeLenses(re,G);if(!(!oe||G.isCancellationRequested)){const me=this._cache.add(oe),De=new d.DisposableStore;this._disposables.set(me,De);const Ne={cacheId:me,lenses:[]};for(let ge=0;ge<oe.length;ge++)Ne.lenses.push({cacheId:[me,ge],range:P.Range.from(oe[ge].range),command:this._commands.toInternal(oe[ge].command,De)});return Ne}}async resolveCodeLens(x,G){var re;const oe=x.cacheId&&this._cache.get(...x.cacheId);if(!!oe){let me;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?me=oe:me=await this._provider.resolveCodeLens(oe,G),me||(me=oe),!G.isCancellationRequested){const De=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!De)return x.command=this._commands.toInternal((re=me.command)!==null&&re!==void 0?re:u._badCmd,De),x}}}releaseCodeLenses(x){var G;(G=this._disposables.get(x))===null||G===void 0||G.dispose(),this._disposables.delete(x),this._cache.delete(x)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(Be){return Array.isArray(Be)?Be.map(P.DefinitionLink.from):Be?[P.DefinitionLink.from(Be)]:[]}class t{constructor(x,G){this._documents=x,this._provider=G}provideDefinition(x,G,re){const oe=this._documents.getDocument(x),me=P.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDefinition(oe,me,re)).then(p)}}class n{constructor(x,G){this._documents=x,this._provider=G}provideDeclaration(x,G,re){const oe=this._documents.getDocument(x),me=P.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDeclaration(oe,me,re)).then(p)}}class s{constructor(x,G){this._documents=x,this._provider=G}provideImplementation(x,G,re){const oe=this._documents.getDocument(x),me=P.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideImplementation(oe,me,re)).then(p)}}class r{constructor(x,G){this._documents=x,this._provider=G}provideTypeDefinition(x,G,re){const oe=this._documents.getDocument(x),me=P.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideTypeDefinition(oe,me,re)).then(p)}}class l{constructor(x,G){this._documents=x,this._provider=G}provideHover(x,G,re){const oe=this._documents.getDocument(x),me=P.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideHover(oe,me,re)).then(De=>{if(!(!De||(0,i.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=oe.getWordRangeAtPosition(me)),De.range||(De.range=new A.Range(me,me)),P.Hover.from(De)})}}class f{constructor(x,G){this._documents=x,this._provider=G}provideEvaluatableExpression(x,G,re){const oe=this._documents.getDocument(x),me=P.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideEvaluatableExpression(oe,me,re)).then(De=>{if(De)return P.EvaluatableExpression.from(De)})}}class v{constructor(x,G){this._documents=x,this._provider=G}provideInlineValues(x,G,re,oe){const me=this._documents.getDocument(x);return(0,S.asPromise)(()=>this._provider.provideInlineValues(me,P.Range.to(G),P.InlineValueContext.to(re),oe)).then(De=>{if(Array.isArray(De))return De.map(Ne=>P.InlineValue.from(Ne))})}}class T{constructor(x,G){this._documents=x,this._provider=G}provideDocumentHighlights(x,G,re){const oe=this._documents.getDocument(x),me=P.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDocumentHighlights(oe,me,re)).then(De=>{if(Array.isArray(De))return De.map(P.DocumentHighlight.from)})}}class b{constructor(x,G){this._documents=x,this._provider=G}provideLinkedEditingRanges(x,G,re){const oe=this._documents.getDocument(x),me=P.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideLinkedEditingRanges(oe,me,re)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,i.coalesce)(De.ranges.map(P.Range.from)),wordPattern:De.wordPattern}})}}class E{constructor(x,G){this._documents=x,this._provider=G}provideReferences(x,G,re,oe){const me=this._documents.getDocument(x),De=P.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideReferences(me,De,re,oe)).then(Ne=>{if(Array.isArray(Ne))return Ne.map(P.location.from)})}}class F{constructor(x,G,re,oe,me,De,Ne){this._documents=x,this._commands=G,this._diagnostics=re,this._provider=oe,this._logService=me,this._extension=De,this._apiDeprecation=Ne,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(x,G,re,oe){const me=this._documents.getDocument(x),De=c.Selection.isISelection(G)?P.Selection.to(G):P.Range.to(G),Ne=[];for(const Ce of this._diagnostics.getDiagnostics(x))if(De.intersection(Ce.range)&&Ne.push(Ce)>F._maxCodeActionsPerFile)break;const ge={diagnostics:Ne,only:re.only?new A.CodeActionKind(re.only):void 0,triggerKind:P.CodeActionTriggerKind.to(re.trigger)};return(0,S.asPromise)(()=>this._provider.provideCodeActions(me,De,ge,oe)).then(Ce=>{var Ae;if(!(!(0,i.isNonEmptyArray)(Ce)||oe.isCancellationRequested)){const $e=this._cache.add(Ce),_e=new d.DisposableStore;this._disposables.set($e,_e);const qe=[];for(let z=0;z<Ce.length;z++){const te=Ce[z];!te||(F._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,_e)})):(ge.only&&(te.kind?ge.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[$e,z],title:te.title,command:te.command&&this._commands.toInternal(te.command,_e),diagnostics:te.diagnostics&&te.diagnostics.map(P.Diagnostic.from),edit:te.edit&&P.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:(Ae=te.disabled)===null||Ae===void 0?void 0:Ae.reason})))}return{cacheId:$e,actions:qe}}})}async resolveCodeAction(x,G){var re;const[oe,me]=x,De=this._cache.get(oe,me);if(!(!De||F._isCommand(De))&&!!this._provider.resolveCodeAction){const Ne=(re=await this._provider.resolveCodeAction(De,G))!==null&&re!==void 0?re:De;return(Ne==null?void 0:Ne.edit)?P.WorkspaceEdit.from(Ne.edit):void 0}}releaseCodeActions(x){var G;(G=this._disposables.get(x))===null||G===void 0||G.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}F._maxCodeActionsPerFile=1e3;class L{constructor(x,G){this._documents=x,this._provider=G}provideDocumentFormattingEdits(x,G,re){const oe=this._documents.getDocument(x);return(0,S.asPromise)(()=>this._provider.provideDocumentFormattingEdits(oe,G,re)).then(me=>{if(Array.isArray(me))return me.map(P.TextEdit.from)})}}class K{constructor(x,G){this._documents=x,this._provider=G}provideDocumentRangeFormattingEdits(x,G,re,oe){const me=this._documents.getDocument(x),De=P.Range.to(G);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,De,re,oe)).then(Ne=>{if(Array.isArray(Ne))return Ne.map(P.TextEdit.from)})}}class fe{constructor(x,G){this._documents=x,this._provider=G,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(x,G,re,oe,me){const De=this._documents.getDocument(x),Ne=P.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Ne,re,oe,me)).then(ge=>{if(Array.isArray(ge))return ge.map(P.TextEdit.from)})}}class j{constructor(x,G){this._provider=x,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(x,G){const re=D.IdObject.mixin({symbols:[]});return(0,S.asPromise)(()=>this._provider.provideWorkspaceSymbols(x,G)).then(oe=>{if((0,i.isNonEmptyArray)(oe)){for(const me of oe)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const De=D.IdObject.mixin(P.WorkspaceSymbol.from(me));this._symbolCache.set(De._id,me),re.symbols.push(De)}}}).then(()=>(re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re))}async resolveWorkspaceSymbol(x,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const re=this._symbolCache.get(x._id);if(re){const oe=await(0,S.asPromise)(()=>this._provider.resolveWorkspaceSymbol(re,G));return oe&&(0,k.mixin)(x,P.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(x){const G=this._resultCache.get(x);if(G){for(let[re,oe]=G;re<=oe;re++)this._symbolCache.delete(re);this._resultCache.delete(x)}}}class H{constructor(x,G,re){this._documents=x,this._provider=G,this._logService=re}static supportsResolving(x){return typeof x.prepareRename=="function"}provideRenameEdits(x,G,re,oe){const me=this._documents.getDocument(x),De=P.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideRenameEdits(me,De,re,oe)).then(Ne=>{if(!!Ne)return P.WorkspaceEdit.from(Ne)},Ne=>{const ge=H._asMessage(Ne);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Ne)})}resolveRenameLocation(x,G,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(x),me=P.Position.to(G);return(0,S.asPromise)(()=>this._provider.prepareRename(oe,me,re)).then(De=>{let Ne,ge;if(A.Range.isRange(De)?(Ne=De,ge=oe.getText(De)):(0,I.isObject)(De)&&(Ne=De.range,ge=De.placeholder),!!Ne){if(Ne.start.line>me.line||Ne.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(Ne),text:ge}}},De=>{const Ne=H._asMessage(De);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class ee{constructor(x,G){this.resultId=x,this.tokens=G}}class O{constructor(x,G){this._documents=x,this._provider=G,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(x,G,re){const oe=this._documents.getDocument(x),me=G!==0?this._previousResults.get(G):null;return(0,S.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,me.resultId,re):this._provider.provideDocumentSemanticTokens(oe,re)).then(De=>(me&&this._previousResults.delete(G),De?(De=O._fixProvidedSemanticTokens(De),this._send(O._convertToEdits(me,De),De)):null))}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return O._isSemanticTokens(x)?O._isCorrectSemanticTokens(x)?x:new A.SemanticTokens(new Uint32Array(x.data),x.resultId):O._isSemanticTokensEdits(x)?O._isCorrectSemanticTokensEdits(x)?x:new A.SemanticTokensEdits(x.edits.map(G=>new A.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const G of x.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,G){if(!O._isSemanticTokens(G)||!x||!x.tokens)return G;const re=x.tokens,oe=re.length,me=G.data,De=me.length;let Ne=0;const ge=Math.min(oe,De);for(;Ne<ge&&re[Ne]===me[Ne];)Ne++;if(Ne===oe&&Ne===De)return new A.SemanticTokensEdits([],G.resultId);let Ce=0;const Ae=ge-Ne;for(;Ce<Ae&&re[oe-Ce-1]===me[De-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Ne,deleteCount:oe-Ne-Ce,data:me.subarray(Ne,De-Ce)}],G.resultId)}_send(x,G){if(O._isSemanticTokens(x)){const re=this._nextResultId++;return this._previousResults.set(re,new ee(x.resultId,x.data)),(0,o.encodeSemanticTokensDto)({id:re,type:"full",data:x.data})}if(O._isSemanticTokensEdits(x)){const re=this._nextResultId++;return O._isSemanticTokens(G)?this._previousResults.set(re,new ee(G.resultId,G.data)):this._previousResults.set(re,new ee(x.resultId)),(0,o.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(x.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=O;class R{constructor(x,G){this._documents=x,this._provider=G}provideDocumentRangeSemanticTokens(x,G,re){const oe=this._documents.getDocument(x);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(oe,P.Range.to(G),re)).then(me=>me?this._send(me):null)}_send(x){return(0,o.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=R;class N{constructor(x,G,re,oe,me){this._documents=x,this._commands=G,this._provider=re,this._apiDeprecation=oe,this._extension=me,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,G,re,oe){const me=this._documents.getDocument(x),De=P.Position.to(G),Ne=me.getWordRangeAtPosition(De)||new A.Range(De,De),ge=Ne.with({end:De}),Ce=new h.StopWatch(!0),Ae=await(0,S.asPromise)(()=>this._provider.provideCompletionItems(me,De,oe,P.CompletionContext.to(re)));if(!!Ae&&!oe.isCancellationRequested){const $e=Array.isArray(Ae)?new A.CompletionList(Ae):Ae,_e=N.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),qe=new d.DisposableStore;this._disposables.set(_e,qe);const z=[],te={x:_e,b:z,a:{replace:P.Range.from(Ne),insert:P.Range.from(ge)},c:$e.isIncomplete||void 0,d:Ce.elapsed()};for(let ve=0;ve<$e.items.length;ve++){const Ue=$e.items[ve],He=this._convertCompletionItem(Ue,[_e,ve],ge,Ne);z.push(He)}return te}}async resolveCompletionItem(x,G){if(typeof this._provider.resolveCompletionItem=="function"){const re=this._cache.get(...x);if(!!re){const oe=await(0,S.asPromise)(()=>this._provider.resolveCompletionItem(re,G));if(!!oe)return this._convertCompletionItem(oe,x)}}}releaseCompletionItems(x){var G;(G=this._disposables.get(x))===null||G===void 0||G.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,G,re,oe){var me;const De=this._disposables.get(G[0]);if(!De)throw Error("DisposableStore is missing...");const Ne={x:G,a:(me=x.label)!==null&&me!==void 0?me:"",o:x.label2,b:x.kind!==void 0?P.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(P.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:P.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(P.TextEdit.from),m:this._commands.toInternal(x.command,De)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne.h=x.textEdit.newText):typeof x.insertText=="string"?Ne.h=x.insertText:x.insertText instanceof A.SnippetString&&(Ne.h=x.insertText.value,Ne.i|=4);let ge;return x.textEdit?ge=x.textEdit.range:x.range&&(ge=x.range),A.Range.isRange(ge)?Ne.j=P.Range.from(ge):ge&&(!(re==null?void 0:re.isEqual(ge.inserting))||!(oe==null?void 0:oe.isEqual(ge.replacing)))&&(Ne.j={insert:P.Range.from(ge.inserting),replace:P.Range.from(ge.replacing)}),Ne}}class ${constructor(x,G){this._documents=x,this._provider=G,this._cache=new g.Cache("SignatureHelp")}provideSignatureHelp(x,G,re,oe){const me=this._documents.getDocument(x),De=P.Position.to(G),Ne=this.reviveContext(re);return(0,S.asPromise)(()=>this._provider.provideSignatureHelp(me,De,oe,Ne)).then(ge=>{if(ge){const Ce=this._cache.add([ge]);return Object.assign(Object.assign({},P.SignatureHelp.from(ge)),{id:Ce})}})}reviveContext(x){let G;if(x.activeSignatureHelp){const re=P.SignatureHelp.to(x.activeSignatureHelp),oe=this._cache.get(x.activeSignatureHelp.id,0);oe?(G=oe,G.activeSignature=re.activeSignature,G.activeParameter=re.activeParameter):G=re}return Object.assign(Object.assign({},x),{activeSignatureHelp:G})}releaseSignatureHelp(x){this._cache.delete(x)}}class U{constructor(x,G){this._documents=x,this._provider=G}provideInlineHints(x,G,re){const oe=this._documents.getDocument(x);return(0,S.asPromise)(()=>this._provider.provideInlineHints(oe,P.Range.to(G),re)).then(me=>me?{hints:me.map(P.InlineHint.from)}:void 0)}}class Q{constructor(x,G){this._documents=x,this._provider=G,this._cache=new g.Cache("DocumentLink")}provideLinks(x,G){const re=this._documents.getDocument(x);return(0,S.asPromise)(()=>this._provider.provideDocumentLinks(re,G)).then(oe=>{if(!(!Array.isArray(oe)||oe.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.map(P.DocumentLink.from)};{const me=this._cache.add(oe),De={links:[],id:me};for(let Ne=0;Ne<oe.length;Ne++){const ge=P.DocumentLink.from(oe[Ne]);ge.cacheId=[me,Ne],De.links.push(ge)}return De}}})}resolveLink(x,G){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const re=this._cache.get(...x);return re?(0,S.asPromise)(()=>this._provider.resolveDocumentLink(re,G)).then(oe=>oe&&P.DocumentLink.from(oe)||void 0):Promise.resolve(void 0)}releaseLinks(x){this._cache.delete(x)}}class Y{constructor(x,G){this._documents=x,this._provider=G}provideColors(x,G){const re=this._documents.getDocument(x);return(0,S.asPromise)(()=>this._provider.provideDocumentColors(re,G)).then(oe=>Array.isArray(oe)?oe.map(De=>({color:P.Color.from(De.color),range:P.Range.from(De.range)})):[])}provideColorPresentations(x,G,re){const oe=this._documents.getDocument(x),me=P.Range.to(G.range),De=P.Color.to(G.color);return(0,S.asPromise)(()=>this._provider.provideColorPresentations(De,{document:oe,range:me},re)).then(Ne=>{if(!!Array.isArray(Ne))return Ne.map(P.ColorPresentation.from)})}}class ie{constructor(x,G){this._documents=x,this._provider=G}provideFoldingRanges(x,G,re){const oe=this._documents.getDocument(x);return(0,S.asPromise)(()=>this._provider.provideFoldingRanges(oe,G,re)).then(me=>{if(!!Array.isArray(me))return me.map(P.FoldingRange.from)})}}class pe{constructor(x,G,re){this._documents=x,this._provider=G,this._logService=re}provideSelectionRanges(x,G,re){const oe=this._documents.getDocument(x),me=G.map(P.Position.to);return(0,S.asPromise)(()=>this._provider.provideSelectionRanges(oe,me,re)).then(De=>{if(!(0,i.isNonEmptyArray)(De))return[];if(De.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let ge=0;ge<me.length;ge++){const Ce=[];Ne.push(Ce);let Ae=me[ge],$e=De[ge];for(;;){if(!$e.range.contains(Ae))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(P.SelectionRange.from($e)),!$e.parent)break;Ae=$e.range,$e=$e.parent}}return Ne})}}class Pe{constructor(x,G){this._documents=x,this._provider=G,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(x,G,re){const oe=this._documents.getDocument(x),me=P.Position.to(G),De=await this._provider.prepareCallHierarchy(oe,me,re);if(!!De){const Ne=this._idPool.nextId();return this._cache.set(Ne,new Map),Array.isArray(De)?De.map(ge=>this._cacheAndConvertItem(Ne,ge)):[this._cacheAndConvertItem(Ne,De)]}}async provideCallsTo(x,G,re){const oe=this._itemFromCache(x,G);if(!oe)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(oe,re);if(!!me)return me.map(De=>({from:this._cacheAndConvertItem(x,De.from),fromRanges:De.fromRanges.map(Ne=>P.Range.from(Ne))}))}async provideCallsFrom(x,G,re){const oe=this._itemFromCache(x,G);if(!oe)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(oe,re);if(!!me)return me.map(De=>({to:this._cacheAndConvertItem(x,De.to),fromRanges:De.fromRanges.map(Ne=>P.Range.from(Ne))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,G){var re;const oe=this._cache.get(x),me={_sessionId:x,_itemId:oe.size.toString(36),name:G.name,detail:G.detail,kind:P.SymbolKind.from(G.kind),uri:G.uri,range:P.Range.from(G.range),selectionRange:P.Range.from(G.selectionRange),tags:(re=G.tags)===null||re===void 0?void 0:re.map(P.SymbolTag.from)};return oe.set(me._itemId,G),me}_itemFromCache(x,G){const re=this._cache.get(x);return re==null?void 0:re.get(G)}}class Oe{constructor(x,G){this.adapter=x,this.extension=G}}class Te{constructor(x,G,re,oe,me,De,Ne){this._adapter=new Map,this._uriTransformer=G,this._proxy=x.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=oe,this._diagnostics=me,this._logService=De,this._apiDeprecation=Ne}_transformDocumentSelector(x){return(0,i.coalesce)((0,i.asArray)(x).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:P.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new A.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return Te._handlePool++}_withAdapter(x,G,re,oe,me=!1){const De=this._adapter.get(x);if(!De)return Promise.resolve(oe);if(De.adapter instanceof G){let Ne;De.extension&&(Ne=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${G.name}'`));const ge=re(De.adapter,De.extension),Ce=De.extension;return Ce&&Promise.resolve(ge).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Ne}ms`),Ae=>{me&&Ae instanceof _.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Ae))}),ge}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,G){const re=this._nextHandle();return this._adapter.set(re,new Oe(x,G)),re}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,G,re,oe){const me=this._addNewAdapter(new m(this._documents,re),x),De=oe&&oe.label||Te._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(G),De),this._createDisposable(me)}$provideDocumentSymbols(x,G,re){return this._withAdapter(x,m,oe=>oe.provideDocumentSymbols(w.URI.revive(G),re),void 0)}registerCodeLensProvider(x,G,re){const oe=this._nextHandle(),me=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Oe(new u(this._documents,this._commands.converter,re),x)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(G),me);let De=this._createDisposable(oe);if(me!==void 0){const Ne=re.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(me));De=A.Disposable.from(De,Ne)}return De}$provideCodeLenses(x,G,re){return this._withAdapter(x,u,oe=>oe.provideCodeLenses(w.URI.revive(G),re),void 0)}$resolveCodeLens(x,G,re){return this._withAdapter(x,u,oe=>oe.resolveCodeLens(G,re),void 0)}$releaseCodeLenses(x,G){this._withAdapter(x,u,re=>Promise.resolve(re.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(x,G,re){const oe=this._addNewAdapter(new t(this._documents,re),x);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDefinition(x,G,re,oe){return this._withAdapter(x,t,me=>me.provideDefinition(w.URI.revive(G),re,oe),[])}registerDeclarationProvider(x,G,re){const oe=this._addNewAdapter(new n(this._documents,re),x);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDeclaration(x,G,re,oe){return this._withAdapter(x,n,me=>me.provideDeclaration(w.URI.revive(G),re,oe),[])}registerImplementationProvider(x,G,re){const oe=this._addNewAdapter(new s(this._documents,re),x);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideImplementation(x,G,re,oe){return this._withAdapter(x,s,me=>me.provideImplementation(w.URI.revive(G),re,oe),[])}registerTypeDefinitionProvider(x,G,re){const oe=this._addNewAdapter(new r(this._documents,re),x);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideTypeDefinition(x,G,re,oe){return this._withAdapter(x,r,me=>me.provideTypeDefinition(w.URI.revive(G),re,oe),[])}registerHoverProvider(x,G,re,oe){const me=this._addNewAdapter(new l(this._documents,re),x);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(G)),this._createDisposable(me)}$provideHover(x,G,re,oe){return this._withAdapter(x,l,me=>me.provideHover(w.URI.revive(G),re,oe),void 0)}registerEvaluatableExpressionProvider(x,G,re,oe){const me=this._addNewAdapter(new f(this._documents,re),x);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(G)),this._createDisposable(me)}$provideEvaluatableExpression(x,G,re,oe){return this._withAdapter(x,f,me=>me.provideEvaluatableExpression(w.URI.revive(G),re,oe),void 0)}registerInlineValuesProvider(x,G,re,oe){const me=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new v(this._documents,re),x);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(G),me);let Ne=this._createDisposable(De);if(me!==void 0){const ge=re.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(me));Ne=A.Disposable.from(Ne,ge)}return Ne}$provideInlineValues(x,G,re,oe,me){return this._withAdapter(x,v,De=>De.provideInlineValues(w.URI.revive(G),re,oe,me),void 0)}registerDocumentHighlightProvider(x,G,re){const oe=this._addNewAdapter(new T(this._documents,re),x);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDocumentHighlights(x,G,re,oe){return this._withAdapter(x,T,me=>me.provideDocumentHighlights(w.URI.revive(G),re,oe),void 0)}registerLinkedEditingRangeProvider(x,G,re){const oe=this._addNewAdapter(new b(this._documents,re),x);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideLinkedEditingRanges(x,G,re,oe){return this._withAdapter(x,b,async me=>{const De=await me.provideLinkedEditingRanges(w.URI.revive(G),re,oe);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Te._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(x,G,re){const oe=this._addNewAdapter(new E(this._documents,re),x);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideReferences(x,G,re,oe,me){return this._withAdapter(x,E,De=>De.provideReferences(w.URI.revive(G),re,oe,me),void 0)}registerCodeActionProvider(x,G,re,oe){var me,De;const Ne=new d.DisposableStore,ge=this._addNewAdapter(new F(this._documents,this._commands.converter,this._diagnostics,re,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(G),{providedKinds:(me=oe==null?void 0:oe.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Ce=>Ce.value),documentation:(De=oe==null?void 0:oe.documentation)===null||De===void 0?void 0:De.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Ne)}))},Te._extLabel(x),Boolean(re.resolveCodeAction)),Ne.add(this._createDisposable(ge)),Ne}$provideCodeActions(x,G,re,oe,me){return this._withAdapter(x,F,De=>De.provideCodeActions(w.URI.revive(G),re,oe,me),void 0)}$resolveCodeAction(x,G,re){return this._withAdapter(x,F,oe=>oe.resolveCodeAction(G,re),void 0)}$releaseCodeActions(x,G){this._withAdapter(x,F,re=>Promise.resolve(re.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(x,G,re){const oe=this._addNewAdapter(new L(this._documents,re),x);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(G),x.identifier,x.displayName||x.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(x,G,re,oe){return this._withAdapter(x,L,me=>me.provideDocumentFormattingEdits(w.URI.revive(G),re,oe),void 0)}registerDocumentRangeFormattingEditProvider(x,G,re){const oe=this._addNewAdapter(new K(this._documents,re),x);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(G),x.identifier,x.displayName||x.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(x,G,re,oe,me){return this._withAdapter(x,K,De=>De.provideDocumentRangeFormattingEdits(w.URI.revive(G),re,oe,me),void 0)}registerOnTypeFormattingEditProvider(x,G,re,oe){const me=this._addNewAdapter(new fe(this._documents,re),x);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(G),oe,x.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(x,G,re,oe,me,De){return this._withAdapter(x,fe,Ne=>Ne.provideOnTypeFormattingEdits(w.URI.revive(G),re,oe,me,De),void 0)}registerWorkspaceSymbolProvider(x,G){const re=this._addNewAdapter(new j(G,this._logService),x);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(x,G,re){return this._withAdapter(x,j,oe=>oe.provideWorkspaceSymbols(G,re),{symbols:[]})}$resolveWorkspaceSymbol(x,G,re){return this._withAdapter(x,j,oe=>oe.resolveWorkspaceSymbol(G,re),void 0)}$releaseWorkspaceSymbols(x,G){this._withAdapter(x,j,re=>re.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(x,G,re){const oe=this._addNewAdapter(new H(this._documents,re,this._logService),x);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(G),H.supportsResolving(re)),this._createDisposable(oe)}$provideRenameEdits(x,G,re,oe,me){return this._withAdapter(x,H,De=>De.provideRenameEdits(w.URI.revive(G),re,oe,me),void 0)}$resolveRenameLocation(x,G,re,oe){return this._withAdapter(x,H,me=>me.resolveRenameLocation(w.URI.revive(G),re,oe),void 0)}registerDocumentSemanticTokensProvider(x,G,re,oe){const me=this._nextHandle(),De=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new Oe(new O(this._documents,re),x)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(G),oe,De);let Ne=this._createDisposable(me);if(De){const ge=re.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(De));Ne=A.Disposable.from(Ne,ge)}return Ne}$provideDocumentSemanticTokens(x,G,re,oe){return this._withAdapter(x,O,me=>me.provideDocumentSemanticTokens(w.URI.revive(G),re,oe),null,!0)}$releaseDocumentSemanticTokens(x,G){this._withAdapter(x,O,re=>re.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(x,G,re,oe){const me=this._addNewAdapter(new R(this._documents,re),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(G),oe),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(x,G,re,oe){return this._withAdapter(x,R,me=>me.provideDocumentRangeSemanticTokens(w.URI.revive(G),re,oe),null,!0)}registerCompletionItemProvider(x,G,re,oe){const me=this._addNewAdapter(new N(this._documents,this._commands.converter,re,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(G),oe,N.supportsResolving(re),`${x.identifier.value}(${oe.join("")})`),this._createDisposable(me)}$provideCompletionItems(x,G,re,oe,me){return this._withAdapter(x,N,De=>De.provideCompletionItems(w.URI.revive(G),re,oe,me),void 0)}$resolveCompletionItem(x,G,re){return this._withAdapter(x,N,oe=>oe.resolveCompletionItem(G,re),void 0)}$releaseCompletionItems(x,G){this._withAdapter(x,N,re=>re.releaseCompletionItems(G),void 0)}registerSignatureHelpProvider(x,G,re,oe){const me=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,De=this._addNewAdapter(new $(this._documents,re),x);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(G),me),this._createDisposable(De)}$provideSignatureHelp(x,G,re,oe,me){return this._withAdapter(x,$,De=>De.provideSignatureHelp(w.URI.revive(G),re,oe,me),void 0)}$releaseSignatureHelp(x,G){this._withAdapter(x,$,re=>re.releaseSignatureHelp(G),void 0)}registerInlineHintsProvider(x,G,re){const oe=typeof re.onDidChangeInlineHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new U(this._documents,re),x);this._proxy.$registerInlineHintsProvider(me,this._transformDocumentSelector(G),oe);let De=this._createDisposable(me);if(oe!==void 0){const Ne=re.onDidChangeInlineHints(ge=>this._proxy.$emitInlineHintsEvent(oe));De=A.Disposable.from(De,Ne)}return De}$provideInlineHints(x,G,re,oe){return this._withAdapter(x,U,me=>me.provideInlineHints(w.URI.revive(G),re,oe),void 0)}registerDocumentLinkProvider(x,G,re){const oe=this._addNewAdapter(new Q(this._documents,re),x);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(G),typeof re.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(x,G,re){return this._withAdapter(x,Q,oe=>oe.provideLinks(w.URI.revive(G),re),void 0)}$resolveDocumentLink(x,G,re){return this._withAdapter(x,Q,oe=>oe.resolveLink(G,re),void 0)}$releaseDocumentLinks(x,G){this._withAdapter(x,Q,re=>re.releaseLinks(G),void 0)}registerColorProvider(x,G,re){const oe=this._addNewAdapter(new Y(this._documents,re),x);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDocumentColors(x,G,re){return this._withAdapter(x,Y,oe=>oe.provideColors(w.URI.revive(G),re),[])}$provideColorPresentations(x,G,re,oe){return this._withAdapter(x,Y,me=>me.provideColorPresentations(w.URI.revive(G),re,oe),void 0)}registerFoldingRangeProvider(x,G,re){const oe=this._nextHandle(),me=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Oe(new ie(this._documents,re),x)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(G),me);let De=this._createDisposable(oe);if(me!==void 0){const Ne=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));De=A.Disposable.from(De,Ne)}return De}$provideFoldingRanges(x,G,re,oe){return this._withAdapter(x,ie,me=>me.provideFoldingRanges(w.URI.revive(G),re,oe),void 0)}registerSelectionRangeProvider(x,G,re){const oe=this._addNewAdapter(new pe(this._documents,re,this._logService),x);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideSelectionRanges(x,G,re,oe){return this._withAdapter(x,pe,me=>me.provideSelectionRanges(w.URI.revive(G),re,oe),[])}registerCallHierarchyProvider(x,G,re){const oe=this._addNewAdapter(new Pe(this._documents,re),x);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$prepareCallHierarchy(x,G,re,oe){return this._withAdapter(x,Pe,me=>Promise.resolve(me.prepareSession(w.URI.revive(G),re,oe)),void 0)}$provideCallHierarchyIncomingCalls(x,G,re,oe){return this._withAdapter(x,Pe,me=>me.provideCallsTo(G,re,oe),void 0)}$provideCallHierarchyOutgoingCalls(x,G,re,oe){return this._withAdapter(x,Pe,me=>me.provideCallsFrom(G,re,oe),void 0)}$releaseCallHierarchy(x,G){this._withAdapter(x,Pe,re=>Promise.resolve(re.releaseSession(G)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,y.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:Te._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:Te._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?Te._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?Te._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:Te._serializeRegExp(x.beforeText),afterText:x.afterText?Te._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?Te._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(Te._serializeOnEnterRule)}setLanguageConfiguration(x,G,re){let{wordPattern:oe}=re;if(oe&&(0,y.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(G,oe):this._documents.setWordDefinitionFor(G,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const me=this._nextHandle(),De={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Te._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Te._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Te._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,G,De),this._createDisposable(me)}$setWordDefinitions(x){for(const G of x)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Te,Te._handlePool=0}),define(be[199],we([0,1,5,9,7]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(D,y){this._proxy=D.getProxy(w.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,y){await this._proxy.$changeLanguage(D,y);const C=this._documents.getDocumentData(D);if(!C)throw new Error(`document '${D.toString}' NOT found`);return C.document}async tokenAtPosition(D,y){var C;const i=D.version,I=k.Position.from(y),c=await this._proxy.$tokensAtPosition(D.uri,I),d={type:P.StandardTokenType.Other,range:(C=D.getWordRangeAtPosition(y))!==null&&C!==void 0?C:new P.Range(y.line,y.character,y.line,y.character)};if(!c)return d;const o={range:k.Range.to(c.range),type:k.TokenType.to(c.type)};return!o.range.contains(y)||i!==D.version?d:o}}e.ExtHostLanguages=A}),define(be[200],we([0,1,5,19,33]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(D){return D&&D.title}let S=class{constructor(y,C){this._logService=C,this._proxy=y.getProxy(w.MainContext.MainThreadMessageService)}showMessage(y,C,i,I,c){const d={extension:y};let o;typeof I=="string"||A(I)?o=[I,...c]:(d.modal=I&&I.modal,d.useCustom=I&&I.useCustom,o=c),d.useCustom&&(0,P.checkProposedApiEnabled)(y);const a=[];for(let g=0;g<o.length;g++){const h=o[g];if(typeof h=="string")a.push({title:h,handle:g,isCloseAffordance:!1});else if(typeof h=="object"){let{title:_,isCloseAffordance:m}=h;a.push({title:_,isCloseAffordance:!!m,handle:g})}else this._logService.warn("Invalid message item:",h)}return this._proxy.$showMessage(C,i,d,a).then(g=>{if(typeof g=="number")return o[g]})}};S=je([Ke(1,k.ILogService)],S),e.ExtHostMessageService=S}),define(be[201],we([0,1,20,3,6,2,5,9,7,73,22,178,179,54,10,23,56,68]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class _{constructor(n,s){const r=_._Keys.nextId();n.$registerNotebookEditorDecorationType(r,D.NotebookDecorationRenderOptions.from(s)),this.value={key:r,dispose(){n.$removeNotebookEditorDecorationType(r)}}}}e.NotebookEditorDecorationType=_,_._Keys=new d.IdGenerator("NotebookEditorDecorationType");class m{constructor(n,s,r,l,f,v){this._textDocumentsAndEditors=r,this._textDocuments=l,this.logService=f,this._extensionStoragePaths=v,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new i.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new k.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new k.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new k.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new k.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new k.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new k.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new k.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new k.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new k.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new i.ResourceMap,this._statusBarCache=new h.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=n.getProxy(S.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=n.getProxy(S.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=n.getProxy(S.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:T=>{var b;if(T&&T.$mid===12){const E=(b=T.notebookEditor)===null||b===void 0?void 0:b.notebookUri,F=T.cell.handle,L=this._documents.get(E),K=L==null?void 0:L.getCell(F);if(K)return K.cell}return T}})}get activeNotebookEditor(){var n;return(n=this._activeNotebookEditor)===null||n===void 0?void 0:n.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(n=>n.apiEditor)}getEditorById(n){return this._editors.get(n)}getIdByEditor(n){for(const[s,r]of this._editors)if(r.apiEditor===n)return s}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(n){return this._documents.get(n)}_getNotebookDocument(n){const s=this._documents.get(n);if(!s)throw new Error(`NO notebook document for '${n}'`);return s}_getProviderData(n){const s=this._notebookContentProviders.get(n);if(!s)throw new Error(`NO provider for '${n}'`);return s}registerNotebookContentProvider(n,s,r,l){var f,v,T;if(this._notebookContentProviders.has(s))throw new Error(`Notebook provider for '${s}' already registered`);this._notebookContentProviders.set(s,{extension:n,provider:r});let b;r.onDidChangeNotebookContentOptions&&(b=r.onDidChangeNotebookContentOptions(()=>{const L=D.NotebookDocumentContentOptions.from(r.options);this._notebookProxy.$updateNotebookProviderOptions(s,L)}));const E=(f=l==null?void 0:l.viewOptions)===null||f===void 0?void 0:f.filenamePattern.map(L=>D.NotebookExclusiveDocumentPattern.from(L)).filter(L=>L!==void 0);((v=l==null?void 0:l.viewOptions)===null||v===void 0?void 0:v.filenamePattern)&&!E&&console.warn(`Notebook content provider view options file name pattern is invalid ${(T=l==null?void 0:l.viewOptions)===null||T===void 0?void 0:T.filenamePattern}`);const F=D.NotebookDocumentContentOptions.from(l);return this._notebookProxy.$registerNotebookProvider({id:n.identifier,location:n.extensionLocation,description:n.description},s,{transientOutputs:F.transientOutputs,transientCellMetadata:F.transientCellMetadata,transientDocumentMetadata:F.transientDocumentMetadata,viewOptions:(l==null?void 0:l.viewOptions)&&E?{displayName:l.viewOptions.displayName,filenamePattern:E,exclusive:l.viewOptions.exclusive||!1}:void 0}),new y.Disposable(()=>{b==null||b.dispose(),this._notebookContentProviders.delete(s),this._notebookProxy.$unregisterNotebookProvider(s)})}registerNotebookCellStatusBarItemProvider(n,s,r){const l=m._notebookStatusBarItemProviderHandlePool++,f=typeof r.onDidChangeCellStatusBarItems=="function"?m._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,r),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,f,s);let v;return f!==void 0&&(v=r.onDidChangeCellStatusBarItems(T=>this._notebookProxy.$emitCellStatusBarEvent(f))),new y.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,f),v&&v.dispose()})}createNotebookEditorDecorationType(n){return new _(this._notebookEditorsProxy,n).value}async openNotebookDocument(n){const s=this._documents.get(n);if(s)return s.notebookDocument;const r=await this._notebookDocumentsProxy.$tryOpenDocument(n),l=this._documents.get(A.URI.revive(r));return(0,o.assertIsDefined)(l==null?void 0:l.notebookDocument)}async showNotebookDocument(n,s){var r;A.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let l;typeof s=="object"?l={position:D.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(D.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:l={preserveFocus:!1};const f=await this._notebookEditorsProxy.$tryShowNotebookDocument(n.uri,n.viewType,l),v=f&&((r=this._editors.get(f))===null||r===void 0?void 0:r.apiEditor);if(v)return v;throw f?new Error(`Could NOT open editor for "${n.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.toString()}".`)}async $provideNotebookCellStatusBarItems(n,s,r,l){var f;const v=this._notebookStatusBarItemProviders.get(n),T=A.URI.revive(s),b=this._documents.get(T);if(!(!b||!v)){const E=b.getCellFromIndex(r);if(!!E){const F=await v.provideCellStatusBarItems(E.cell,l);if(!!F){const L=new P.DisposableStore,K=this._statusBarCache.add([L]),fe=(f=F&&F.map(j=>D.NotebookStatusBarItem.from(j,this._commandsConverter,L)))!==null&&f!==void 0?f:void 0;return{cacheId:K,items:fe}}}}}$releaseNotebookCellStatusBarItems(n){this._statusBarCache.delete(n)}registerNotebookSerializer(n,s,r,l){const f=this._handlePool++;this._notebookSerializer.set(f,r);const v=D.NotebookDocumentContentOptions.from(l);return this._notebookProxy.$registerNotebookSerializer(f,{id:n.identifier,location:n.extensionLocation,description:n.description},s,v),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(f)})}async $dataToNotebook(n,s,r){const l=this._notebookSerializer.get(n);if(!l)throw new Error("NO serializer found");const f=await l.deserializeNotebook(s.buffer,r);return{metadata:D.NotebookDocumentMetadata.from(f.metadata),cells:f.cells.map(D.NotebookCellData.from)}}async $notebookToData(n,s,r){const l=this._notebookSerializer.get(n);if(!l)throw new Error("NO serializer found");const f=await l.serializeNotebook({metadata:D.NotebookDocumentMetadata.to(s.metadata),cells:s.cells.map(D.NotebookCellData.to)},r);return a.VSBuffer.wrap(f)}cancelOneNotebookCellExecution(n){const s=this._activeExecutions.get(n.uri);s==null||s.cancel()}async $openNotebook(n,s,r,l,f){const{provider:v}=this._getProviderData(n),T=await v.openNotebook(A.URI.revive(s),{backupId:r,untitledDocumentData:l==null?void 0:l.buffer},f);return{metadata:D.NotebookDocumentMetadata.from(T.metadata),cells:T.cells.map(D.NotebookCellData.from)}}async $saveNotebook(n,s,r){const l=this._getNotebookDocument(A.URI.revive(s)),{provider:f}=this._getProviderData(n);return await f.saveNotebook(l.notebookDocument,r),!0}async $saveNotebookAs(n,s,r,l){const f=this._getNotebookDocument(A.URI.revive(s)),{provider:v}=this._getProviderData(n);return await v.saveNotebookAs(A.URI.revive(r),f.notebookDocument,l),!0}async $backupNotebook(n,s,r){var l;const f=this._getNotebookDocument(A.URI.revive(s)),v=this._getProviderData(n),T=(l=this._extensionStoragePaths.workspaceValue(v.extension))!==null&&l!==void 0?l:this._extensionStoragePaths.globalValue(v.extension),b=String((0,g.hash)([f.uri.toString(),this._backupIdPool++])),E=A.URI.joinPath(T,b),F=await v.provider.backupNotebook(f.notebookDocument,{destination:E},r);return f.updateBackup(F),F.id}$acceptModelChanged(n,s,r){this._getNotebookDocument(A.URI.revive(n)).acceptModelChanged(s,r)}$acceptDirtyStateChanged(n,s){const r=this._getNotebookDocument(A.URI.revive(n));r.acceptModelChanged({rawEvents:[],versionId:r.notebookDocument.version},s)}$acceptModelSaved(n){const s=this._getNotebookDocument(A.URI.revive(n));this._onDidSaveNotebookDocument.fire(s.notebookDocument)}$acceptEditorPropertiesChanged(n,s){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",n,s);const r=this._editors.get(n);if(!r)throw new Error(`unknown text editor: ${n}. known editors: ${[...this._editors.keys()]} `);s.visibleRanges&&r._acceptVisibleRanges(s.visibleRanges.ranges.map(D.NotebookRange.to)),s.selections&&r._acceptSelections(s.selections.selections.map(D.NotebookRange.to)),s.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:r.apiEditor,visibleRanges:r.apiEditor.visibleRanges}),s.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:r.apiEditor,selections:r.apiEditor.selections}))}$acceptEditorViewColumns(n){for(const s in n){const r=this._editors.get(s);if(!r)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);r._acceptViewColumn(D.ViewColumn.to(n[s]))}}$acceptDocumentPropertiesChanged(n,s){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",n.path,s);const r=this._getNotebookDocument(A.URI.revive(n));r.acceptDocumentPropertiesChanged(s),s.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:r.notebookDocument})}_createExtHostEditor(n,s,r){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const l=new c.ExtHostNotebookEditor(s,this._notebookEditorsProxy,n,r.visibleRanges.map(D.NotebookRange.to),r.selections.map(D.NotebookRange.to),typeof r.viewColumn=="number"?D.ViewColumn.to(r.viewColumn):void 0);this._editors.set(s,l)}$acceptDocumentAndEditorsDelta(n){var s,r,l;if(n.removedDocuments)for(const v of n.removedDocuments){const T=A.URI.revive(v),b=this._documents.get(T);b&&(b.dispose(),this._documents.delete(T),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.notebookDocument.getCells().map(E=>E.document.uri)}),this._onDidCloseNotebookDocument.fire(b.notebookDocument));for(const E of this._editors.values())E.notebookData.uri.toString()===T.toString()&&this._editors.delete(E.id)}if(n.addedDocuments){const v=[];for(const T of n.addedDocuments){const b=A.URI.revive(T.uri),E=T.viewType;if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const F=this,L=new I.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(K){F._onDidChangeNotebookCells.fire(K)},emitCellOutputsChange(K){F._onDidChangeCellOutputs.fire(K)},emitCellMetadataChange(K){F._onDidChangeCellMetadata.fire(K)},emitCellExecutionStateChange(K){F._onDidChangeCellExecutionState.fire(K)}},E,T.metadata?D.NotebookDocumentMetadata.to(T.metadata):new y.NotebookDocumentMetadata,b);L.acceptModelChanged({versionId:T.versionId,rawEvents:[{kind:C.NotebookCellsChangeType.Initialize,changes:[[0,0,T.cells]]}]},!1),v.push(...T.cells.map(K=>I.ExtHostCell.asModelAddData(L.notebookDocument,K))),(s=this._documents.get(b))===null||s===void 0||s.dispose(),this._documents.set(b,L),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(L.notebookDocument)}}if(n.addedEditors)for(const v of n.addedEditors){if(this._editors.has(v.id))return;const T=A.URI.revive(v.documentUri),b=this._documents.get(T);b&&this._createExtHostEditor(b,v.id,v)}const f=[];if(n.removedEditors)for(const v of n.removedEditors){const T=this._editors.get(v);T&&(this._editors.delete(v),((r=this._activeNotebookEditor)===null||r===void 0?void 0:r.id)===T.id&&(this._activeNotebookEditor=void 0),f.push(T))}if(n.visibleEditors){this._visibleNotebookEditors=n.visibleEditors.map(T=>this._editors.get(T)).filter(T=>!!T);const v=new Set;this._visibleNotebookEditors.forEach(T=>v.add(T.id));for(const T of this._editors.values()){const b=v.has(T.id);T._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(T=>T).filter(T=>T.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}n.newActiveEditor===null?this._activeNotebookEditor=void 0:n.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(n.newActiveEditor)),n.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((l=this._activeNotebookEditor)===null||l===void 0?void 0:l.apiEditor)}createNotebookCellExecution(n,s,r){const l=this.lookupNotebookDocument(n);if(!l)throw new Error(`Invalid uri: ${n} `);const f=l.getCellFromIndex(s);if(!f)throw new Error(`Invalid cell index: ${n}, ${s} `);if(this._activeExecutions.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const v=new p(n,l,f,this._notebookDocumentsProxy);this._activeExecutions.set(f.uri,v);const T=v.onDidChangeState(()=>{v.state===u.Resolved&&(v.dispose(),T.dispose(),this._activeExecutions.delete(f.uri))});return v.asApiObject()}}e.ExtHostNotebookController=m,m._notebookStatusBarItemProviderHandlePool=0;var u;(function(t){t[t.Init=0]="Init",t[t.Started=1]="Started",t[t.Resolved=2]="Resolved"})(u||(u={}));class p extends P.Disposable{constructor(n,s,r,l){super();this._uri=n,this._document=s,this._cell=r,this._proxy=l,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:y.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(n){return this._proxy.$applyEdits(this._uri,n,!1)}verifyStateForOutput(){if(this._state===u.Init)throw new Error("Must call start before modifying cell output");if(this._state===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(n){const s=[{editType:11,handle:this._cell.handle,metadata:n}];this.applyEdits(s)}cellIndexToHandle(n){const s=typeof n=="number"?this._document.getCellFromIndex(n):this._cell;if(!!s)return s.handle}asApiObject(){const n=this;return Object.freeze({get document(){return n._document.notebookDocument},get cell(){return n._cell.cell},get executionOrder(){return n._executionOrder},set executionOrder(s){n._executionOrder=s,n.mixinMetadata({executionOrder:s})},start(s){if(n._state===u.Resolved||n._state===u.Started)throw new Error("Cannot call start again");n._state=u.Started,n._onDidChangeState.fire(),n.mixinMetadata({runState:y.NotebookCellExecutionState.Executing,runStartTime:s==null?void 0:s.startTime})},end(s){var r,l;if(n._state===u.Resolved)throw new Error("Cannot call resolve twice");n._state=u.Resolved,n._onDidChangeState.fire(),n.mixinMetadata({runState:y.NotebookCellExecutionState.Idle,lastRunSuccess:(r=s==null?void 0:s.success)!==null&&r!==void 0?r:null,runEndTime:(l=s==null?void 0:s.endTime)!==null&&l!==void 0?l:null})},clearOutput(s){return n.verifyStateForOutput(),this.replaceOutput([],s)},async appendOutput(s,r){n.verifyStateForOutput();const l=n.cellIndexToHandle(r);if(typeof l=="number")return s=Array.isArray(s)?s:[s],n.applyEdits([{editType:2,handle:l,append:!0,outputs:s.map(D.NotebookCellOutput.from)}])},async replaceOutput(s,r){n.verifyStateForOutput();const l=n.cellIndexToHandle(r);if(typeof l=="number")return s=Array.isArray(s)?s:[s],n.applyEdits([{editType:2,handle:l,outputs:s.map(D.NotebookCellOutput.from)}])},async appendOutputItems(s,r){return n.verifyStateForOutput(),s=Array.isArray(s)?s:[s],n.applyEdits([{editType:10,append:!0,items:s.map(D.NotebookCellOutputItem.from),outputId:r}])},async replaceOutputItems(s,r){return n.verifyStateForOutput(),s=Array.isArray(s)?s:[s],n.applyEdits([{editType:10,items:s.map(D.NotebookCellOutputItem.from),outputId:r}])},token:n._tokenSource.token})}}}),define(be[202],we([0,1,3,6,5,2,9,13,72]),function(J,e,w,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class C{constructor(I,c,d){this._initData=c,this._extHostNotebook=d,this._kernelData=new Map,this._handlePool=0,this._proxy=I.getProxy(P.MainContext.MainThreadNotebookKernels)}createNotebookController(I,c,d,o,a,g){for(let E of this._kernelData.values())if(E.controller.id===c)throw new Error(`notebook controller with id '${c}' ALREADY exist`);const h=this._handlePool++,_=this,m=["plaintext"],u=()=>console.warn(`NO execute handler from notebook controller '${r.id}' of extension: '${I.identifier}'`);let p=!1;const t=new k.DisposableStore,n=new w.Emitter,s=new w.Emitter,r={id:c,selector:d,extensionId:I.identifier,extensionLocation:I.extensionLocation,label:o||I.identifier.value,supportedLanguages:m,preloads:g?g.map(S.NotebookKernelPreload.from):[]};let l=a!=null?a:u,f;this._proxy.$addKernel(h,r).catch(E=>{console.log(E),p=!0});let v=0;const T=()=>{if(!p){const E=++v;Promise.resolve().then(()=>{E===v&&this._proxy.$updateKernel(h,r)})}},b={get id(){return r.id},get selector(){return r.selector},onDidChangeNotebookAssociation:n.event,get label(){return r.label},set label(E){var F;r.label=(F=E!=null?E:I.displayName)!==null&&F!==void 0?F:I.name,T()},get detail(){var E;return(E=r.detail)!==null&&E!==void 0?E:""},set detail(E){r.detail=E,T()},get description(){var E;return(E=r.description)!==null&&E!==void 0?E:""},set description(E){r.description=E,T()},get isPreferred(){var E;return(E=r.isPreferred)!==null&&E!==void 0?E:!1},set isPreferred(E){r.isPreferred=E,T()},get supportedLanguages(){return r.supportedLanguages},set supportedLanguages(E){r.supportedLanguages=(0,D.isNonEmptyArray)(E)?E:m,T()},get hasExecutionOrder(){var E;return(E=r.hasExecutionOrder)!==null&&E!==void 0?E:!1},set hasExecutionOrder(E){r.hasExecutionOrder=E,T()},get preloads(){return r.preloads?r.preloads.map(S.NotebookKernelPreload.to):[]},get executeHandler(){return l},set executeHandler(E){l=E!=null?E:u},get interruptHandler(){return f},set interruptHandler(E){f=E,r.supportsInterrupt=Boolean(E),T()},createNotebookCellExecutionTask(E){if(p)throw new Error("notebook controller is DISPOSED");return _._extHostNotebook.createNotebookCellExecution(E.notebook.uri,E.index,r.id)},dispose:()=>{p||(p=!0,this._kernelData.delete(h),t.dispose(),n.dispose(),s.dispose(),this._proxy.$removeKernel(h))},onDidReceiveMessage:s.event,postMessage(E,F){return _._proxy.$postMessage(h,F&&_._extHostNotebook.getIdByEditor(F),E)},asWebviewUri(E){return(0,y.asWebviewUri)(_._initData.environment,String(h),E)}};return this._kernelData.set(h,{extensionId:I.identifier,controller:b,onDidChangeSelection:n,onDidReceiveMessage:s}),b}$acceptSelection(I,c,d){const o=this._kernelData.get(I);o&&o.onDidChangeSelection.fire({selected:d,notebook:this._extHostNotebook.lookupNotebookDocument(A.URI.revive(c)).notebookDocument})}async $executeCells(I,c,d){const o=this._kernelData.get(I);if(!!o){const a=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(c));if(!a)throw new Error("MISSING notebook");const g=[];for(let h of d){const _=a.getCell(h);_&&g.push(_.cell)}try{await o.controller.executeHandler.call(o.controller,g,o.controller)}catch(h){console.error(h)}}}async $cancelCells(I,c,d){const o=this._kernelData.get(I);if(!!o){const a=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(c));if(!a)throw new Error("MISSING notebook");o.controller.interruptHandler&&await o.controller.interruptHandler.call(o.controller);for(let g of d){const h=a.getCell(g);h&&this._extHostNotebook.cancelOneNotebookCellExecution(h)}}}$acceptRendererMessage(I,c,d){const o=this._kernelData.get(I);if(!!o){const a=this._extHostNotebook.getEditorById(c);if(!a)throw new Error(`send message for UNKNOWN editor: ${c}`);o.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:d}))}}}e.ExtHostNotebookKernels=C}),define(be[100],we([0,1,5,3,6,23,4,15]),function(J,e,w,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends P.Disposable{constructor(o,a,g,h){super();this._onDidAppend=this._register(new k.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=o,this._proxy=h,this._id=h.$register(this.name,a,g),this._disposed=!1,this._offset=0}get name(){return this._name}append(o){this.validate(),this._offset+=o?A.VSBuffer.fromString(o).byteLength:0}update(){this._id.then(o=>this._proxy.$update(o))}appendLine(o){this.validate(),this.append(o+`
`)}clear(){this.validate();const o=this._offset;this._id.then(a=>this._proxy.$clear(a,o))}show(o,a){this.validate(),this._id.then(g=>this._proxy.$reveal(g,!!(typeof o=="boolean"?o:a)))}hide(){this.validate(),this._id.then(o=>this._proxy.$close(o))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(o=>this._proxy.$dispose(o)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class C extends y{constructor(o,a){super(o,!1,void 0,a)}append(o){super.append(o),this._id.then(a=>this._proxy.$append(a,o)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class i extends y{constructor(o,a,g){super(o,!0,a,g)}append(o){throw new Error("Not supported")}}class I{constructor(o,a){this.name=o,this._channel=a}append(o){this._channel.then(a=>a.append(o))}appendLine(o){this._channel.then(a=>a.appendLine(o))}clear(){this._channel.then(o=>o.clear())}show(o,a){this._channel.then(g=>g.show(o,a))}hide(){this._channel.then(o=>o.hide())}dispose(){this._channel.then(o=>o.dispose())}}e.LazyOutputChannel=I;let c=class{constructor(o){this._proxy=o.getProxy(w.MainContext.MainThreadOutputService)}$setVisibleChannel(o){}createOutputChannel(o){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");return new C(o,this._proxy)}createOutputChannelFromLogFile(o,a){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if(!a)throw new Error("illegal argument `file`. must not be falsy");return new i(o,a,this._proxy)}};c=je([Ke(0,D.IExtHostRpcService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(be[203],we([0,1,11,20,3,6,5,2,7,12,13,47]),function(J,e,w,k,P,A,S,D,y,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function c(d,o,a){const g=d.getProxy(S.MainContext.MainThreadQuickOpen);class h{constructor(r,l){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=l}showQuickPick(r,l,f,v=k.CancellationToken.None){this._onDidSelectItem=void 0;const T=Promise.resolve(r),b=++this._instances,E=g.$show(b,{title:f==null?void 0:f.title,placeHolder:f==null?void 0:f.placeHolder,matchOnDescription:f==null?void 0:f.matchOnDescription,matchOnDetail:f==null?void 0:f.matchOnDetail,ignoreFocusLost:f==null?void 0:f.ignoreFocusOut,canPickMany:f==null?void 0:f.canPickMany},v),F={},L=E.then(()=>F);return Promise.race([L,T]).then(K=>{if(K!==F)return T.then(fe=>{const j=[];for(let H=0;H<fe.length;H++){const ee=fe[H];let O,R,N,$,U;typeof ee=="string"?O=ee:(O=ee.label,R=ee.description,N=ee.detail,$=ee.picked,U=ee.alwaysShow),j.push({label:O,description:R,handle:H,detail:N,picked:$,alwaysShow:U})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{f.onDidSelectItem(fe[H])}),g.$setItems(b,j),E.then(H=>{if(typeof H=="number")return fe[H];if(Array.isArray(H))return H.map(ee=>fe[ee])})})}).then(void 0,K=>{if(!(0,C.isPromiseCanceledError)(K))return g.$setError(b,K),Promise.reject(K)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,l=k.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,g.$input(r,typeof this._validateInput=="function",l).then(void 0,f=>{if(!(0,C.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(r){return this._validateInput?(0,w.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,l=k.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!f){const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(T=>T.uri.toString()===f.uri.toString())}}createQuickPick(r,l){const f=new t(r,l,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(r){const l=new n(r,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(r,l){const f=this._sessions.get(r);f&&f._fireDidChangeValue(l)}$onDidAccept(r){const l=this._sessions.get(r);l&&l._fireDidAccept()}$onDidChangeActive(r,l){const f=this._sessions.get(r);f instanceof t&&f._fireDidChangeActive(l)}$onDidChangeSelection(r,l){const f=this._sessions.get(r);f instanceof t&&f._fireDidChangeSelection(l)}$onDidTriggerButton(r,l){const f=this._sessions.get(r);f&&f._fireDidTriggerButton(l)}$onDidHide(r){const l=this._sessions.get(r);l&&l._fireDidHide()}}class _{constructor(r,l){this._extensionId=r,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new P.Emitter,this._onDidChangeValueEmitter=new P.Emitter,this._onDidTriggerButtonEmitter=new P.Emitter,this._onDidHideEmitter=new P.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((l,f)=>{const v=l===y.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(v,l)}),this.update({buttons:r.map((l,f)=>({iconPath:m(l.iconPath),tooltip:l.tooltip,handle:l===y.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const l=this._handlesToButtons.get(r);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),g.$dispose(this._id))}update(r){if(!this._disposed){for(const l of Object.keys(r)){const f=r[l];this._pendingUpdate[l]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){g.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function m(s){if(s instanceof y.ThemeIcon)return{id:s.id};const r=p(s),l=u(s);return{dark:typeof r=="string"?D.URI.file(r):r,light:typeof l=="string"?D.URI.file(l):l}}function u(s){return typeof s=="object"&&"light"in s?s.light:s}function p(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends _{constructor(r,l,f){super(r,f);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new P.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new P.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((l,f)=>{this._handlesToItems.set(f,l),this._itemsToHandles.set(l,f)}),this.update({items:r.map((l,f)=>({label:l.label,description:l.description,handle:f,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(r){const l=(0,i.coalesce)(r.map(f=>this._handlesToItems.get(f)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(r){const l=(0,i.coalesce)(r.map(f=>this._handlesToItems.get(f)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class n extends _{constructor(r,l){super(r,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?I.default.Error:I.default.Ignore})}}return new h(o,a)}e.createExtHostQuickOpen=c}),define(be[204],we([0,1,2,3,52,6,11,5,13,111,19,26,33]),function(J,e,w,k,P,A,S,D,y,C,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(r){if(r)return typeof r.iconPath=="string"?w.URI.file(r.iconPath):r.iconPath}function o(r,l){if(!r.iconPath&&!l.iconPath)return 0;if(r.iconPath){if(!l.iconPath)return 1}else return-1;const f=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,v=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath;return(0,C.comparePaths)(f,v)}function a(r,l){let f=0;if(r.strikeThrough!==l.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==l.faded)return r.faded?1:-1;if(r.tooltip!==l.tooltip)return(r.tooltip||"").localeCompare(l.tooltip||"");if(f=o(r,l),f!==0)return f;if(r.light&&l.light)f=o(r.light,l.light);else{if(r.light)return 1;if(l.light)return-1}if(f!==0)return f;if(r.dark&&l.dark)f=o(r.dark,l.dark);else{if(r.dark)return 1;if(l.dark)return-1}return f}function g(r,l){if(r.command!==l.command)return r.command<l.command?-1:1;if(r.title!==l.title)return r.title<l.title?-1:1;if(r.tooltip!==l.tooltip){if(r.tooltip!==void 0&&l.tooltip!==void 0)return r.tooltip<l.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(r.arguments===l.arguments)return 0;if(r.arguments)if(l.arguments){if(r.arguments.length!==l.arguments.length)return r.arguments.length-l.arguments.length}else return 1;else return-1;for(let f=0;f<r.arguments.length;f++){const v=r.arguments[f],T=l.arguments[f];if(v!==T)return v<T?-1:1}return 0}function h(r,l){let f=(0,C.comparePaths)(r.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(f!==0)return f;if(r.command&&l.command)f=g(r.command,l.command);else{if(r.command)return 1;if(l.command)return-1}if(f!==0)return f;if(r.decorations&&l.decorations)f=a(r.decorations,l.decorations);else{if(r.decorations)return 1;if(l.decorations)return-1}return f}function _(r,l){for(let f=0;f<r.length;f++)if(r[f]!==l[f])return!1;return!0}function m(r,l){return r.command===l.command&&r.title===l.title&&r.tooltip===l.tooltip&&(r.arguments&&l.arguments?_(r.arguments,l.arguments):r.arguments===l.arguments)}function u(r,l){return(0,y.equals)(r,l,m)}class p{constructor(l,f,v){this._extension=l,this._proxy=f,this._sourceControlHandle=v,this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,c.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(l){if((0,c.checkProposedApiEnabled)(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}focus(){(0,c.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(l,f){(0,c.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,l,f)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=p;class t{constructor(l,f,v,T,b){this._proxy=l,this._commands=f,this._sourceControlHandle=v,this._id=T,this._label=b,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,f){const v=this._resourceStatesCommandsMap.get(l);return v?(0,S.asPromise)(()=>this._commands.executeCommand(v.command,...v.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var l;const f=[...this._resourceStates].sort(h),T=(0,y.sortedDiff)(this._resourceSnapshot,f,h).map(F=>{const L=F.toInsert.map(K=>{const fe=this._resourceHandlePool++;this._resourceStatesMap.set(fe,K);const j=K.resourceUri,H=d(K.decorations),ee=K.decorations&&d(K.decorations.light)||H,O=K.decorations&&d(K.decorations.dark)||H,R=[];let N;if(K.command)if(K.command.command==="vscode.open"||K.command.command==="vscode.diff"){const pe=new A.DisposableStore;N=this._commands.converter.toInternal(K.command,pe),this._resourceStatesDisposablesMap.set(fe,pe)}else this._resourceStatesCommandsMap.set(fe,K.command);ee&&R.push(ee),O&&O.toString()!==(ee==null?void 0:ee.toString())&&R.push(O);const $=K.decorations&&K.decorations.tooltip||"",U=K.decorations&&!!K.decorations.strikeThrough,Q=K.decorations&&!!K.decorations.faded,Y=K.contextValue||"";return{rawResource:[fe,j,R,$,U,Q,Y,N],handle:fe}});return{start:F.start,deleteCount:F.deleteCount,toInsert:L}}),b=T.map(({start:F,deleteCount:L,toInsert:K})=>[F,L,K.map(fe=>fe.rawResource)]),E=T.reverse();for(const{start:F,deleteCount:L,toInsert:K}of E){const fe=K.map(H=>H.handle),j=this._handlesSnapshot.splice(F,L,...fe);for(const H of j)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),(l=this._resourceStatesDisposablesMap.get(H))===null||l===void 0||l.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=f,b}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(l,f,v,T,b,E){this._proxy=f,this._commands=v,this._id=T,this._label=b,this._rootUri=E,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new p(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,T,b,E)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=l;const f=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(!(this._statusBarCommands&&l&&u(this._statusBarCommands,l))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=l;const f=(l||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}}get selected(){return this._selected}createResourceGroup(l,f){const v=new t(this._proxy,this._commands,this.handle,l,f),T=k.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,T),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const l=[],f=[];for(const[v,T]of this.createdResourceGroups){T.dispose();const b=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});k.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),b.dispose(),this._groups.delete(v.handle),this._proxy.$unregisterGroup(this.handle,v.handle)}),l.push([v.handle,v.id,v.label,v.features]);const E=v._takeResourceStateSnapshot();E.length>0&&f.push([v.handle,E]),this._groups.set(v.handle,v)}this._proxy.$registerGroups(this.handle,l,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(f=>{const v=f._takeResourceStateSnapshot();v.length!==0&&l.push([f.handle,v])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,je([(0,P.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),je([(0,P.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Pn{constructor(l,f,v){this._commands=f,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=l.getProxy(D.MainContext.MainThreadSCM),this._telemetry=l.getProxy(D.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===3){const b=this._sourceControls.get(T.sourceControlHandle);if(!b)return T;const E=b.getResourceGroup(T.groupHandle);return E?E.getResourceState(T.handle):T}else if(T&&T.$mid===4){const b=this._sourceControls.get(T.sourceControlHandle);return b?b.getResourceGroup(T.groupHandle):T}else if(T&&T.$mid===5){const b=this._sourceControls.get(T.handle);return b||T}return T}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,f,v,T){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,f,v,T),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const b=Pn._handlePool++,E=new n(l,this._proxy,this._commands,f,v,T);this._sourceControls.set(b,E);const F=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(l.identifier))||[];return F.push(E),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(l.identifier),F),E}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const f=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(l.identifier)),v=f&&f[f.length-1];return v&&v.inputBox}$provideOriginalResource(l,f,v){const T=w.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,T.toString());const b=this._sourceControls.get(l);return!b||!b.quickDiffProvider||!b.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>b.quickDiffProvider.provideOriginalResource(T,v)).then(E=>E||null)}$onInputBoxValueChange(l,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const v=this._sourceControls.get(l);return v&&v.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(l,f,v,T){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,f,v);const b=this._sourceControls.get(l);if(!b)return Promise.resolve(void 0);const E=b.getResourceGroup(f);return E?E.$executeResourceCommand(v,T):Promise.resolve(void 0)}$validateInput(l,f,v){this.logService.trace("ExtHostSCM#$validateInput",l);const T=this._sourceControls.get(l);return!T||!T.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>T.inputBox.validateInput(f,v)).then(b=>b?Promise.resolve([b.message,b.type]):Promise.resolve(void 0))}$setSelectedSourceControl(l){var f,v;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&((f=this._sourceControls.get(l))===null||f===void 0||f.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((v=this._sourceControls.get(this._selectedSourceControlHandle))===null||v===void 0||v.setSelectionState(!1)),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};s._handlePool=0,s=je([Ke(2,i.ILogService)],s),e.ExtHostSCM=s});var tt=this&&this.__classPrivateFieldSet||function(J,e,w,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,w):P?P.value=w:e.set(J,w),w},Me=this&&this.__classPrivateFieldGet||function(J,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(J):k?k.value:e.get(J)};define(be[205],we([0,1,7,5,134,6]),function(J,e,w,k,P,A){"use strict";var S,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(c,d,o,a,g=w.StatusBarAlignment.Left,h,_){S.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,tt(this,S,c,"f"),tt(this,D,d,"f"),this._id=y.ID_GEN++,this._statusId=o,this._statusName=a,this._alignment=g,this._priority=h,this._accessibilityInformation=_}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var c;return(c=this._command)===null||c===void 0?void 0:c.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(c){this._text=c,this.update()}set tooltip(c){this._tooltip=c,this.update()}set color(c){this._color=c,this.update()}set backgroundColor(c){c&&!y.ALLOWED_BACKGROUND_COLORS.has(c.id)&&(c=void 0),this._backgroundColor=c,this.update()}set command(c){var d;((d=this._command)===null||d===void 0?void 0:d.fromApi)!==c&&(this._internalCommandRegistration.clear(),typeof c=="string"?this._command={fromApi:c,internal:Me(this,D,"f").toInternal({title:"",command:c},this._internalCommandRegistration)}:c?this._command={fromApi:c,internal:Me(this,D,"f").toInternal(c,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(c){this._accessibilityInformation=c,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,S,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var c;this._timeoutHandle=void 0;let d=this._color;this._backgroundColor&&(d=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Me(this,S,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(c=this._command)===null||c===void 0?void 0:c.internal,d,this._backgroundColor,this._alignment===w.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,S=new WeakMap,D=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new w.ThemeColor("statusBarItem.errorForeground")]]);class C{constructor(c){this._messages=[],this._item=c.createStatusBarEntry("status.extensionMessage",(0,P.localize)(0,null),w.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(c){const d={message:c};return this._messages.unshift(d),this._update(),new w.Disposable(()=>{const o=this._messages.indexOf(d);o>=0&&(this._messages.splice(o,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(c,d){this._proxy=c.getProxy(k.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new C(this)}createStatusBarEntry(c,d,o,a,g){return new y(this._proxy,this._commands,c,d,o,a,g)}setStatusBarMessage(c,d){const o=this._statusMessage.setMessage(c);let a;return typeof d=="number"?a=setTimeout(()=>o.dispose(),d):typeof d!="undefined"&&d.then(()=>o.dispose(),()=>o.dispose()),new w.Disposable(()=>{o.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=i}),define(be[78],we([0,1,5,3,4]),function(J,e,w,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(D){this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(w.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,y){this._proxy.$registerExtensionStorageKeysToSync(D,y)}getValue(D,y,C){return this._proxy.$getValue(D,y).then(i=>i||C)}setValue(D,y,C){return this._proxy.$setValue(D,y,C)}$acceptValue(D,y,C){this._onDidChangeStorage.fire({shared:D,key:y,value:C})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,P.createDecorator)("IExtHostStorage")}),define(be[79],we([0,1,4,27,19,77,2]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,w.createDecorator)("IExtensionStoragePaths");let D=class{constructor(C,i,I){var c;this._logService=i,this._extHostFileSystem=I,this._workspace=(c=C.workspace)!==null&&c!==void 0?c:void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(d=>this._value=d)}async _getOrCreateWorkspaceStoragePath(){var C;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,I=S.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(c){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(C=S.URI.revive(this._workspace.configuration))===null||C===void 0?void 0:C.toString(),name:this._workspace.name},void 0,2))),I}catch(c){this._logService.error("[ExtHostStorage]",c);return}}workspaceValue(C){if(this._value)return S.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return S.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}};D=je([Ke(0,k.IExtHostInitDataService),Ke(1,P.ILogService),Ke(2,A.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(be[40],we([0,1,3,5,4,2,15,6,7,135,12,172,20,31,155]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,P.createDecorator)("IExtHostTerminalService");class a{constructor(t,n,s,r){this._proxy=t,this._id=n,this._creationOptions=s,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(f=>this._pidPromiseComplete=f);const l=this;this.value={get name(){return l._name||""},get processId(){return l._pidPromise},get creationOptions(){return l._creationOptions},get exitStatus(){return l._exitStatus},sendText(f,v=!0){l._checkDisposed(),l._proxy.$sendText(l._id,f,v)},show(f){l._checkDisposed(),l._proxy.$show(l._id,f)},hide(){l._checkDisposed(),l._proxy.$hide(l._id)},dispose(){l._disposed||(l._disposed=!0,l._proxy.$dispose(l._id))},get dimensions(){if(!(l._cols===void 0||l._rows===void 0))return{columns:l._cols,rows:l._rows}}}}async create(t,n,s,r,l,f,v,T,b,E,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:s,env:r,icon:l,initialText:f,waitOnExit:v,strictEnv:T,hideFromUser:b,isFeatureTerminal:E,isExtensionOwnedTerminal:F})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=a;class g{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new w.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new w.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new w.Emitter,this._onProcessTitleChanged=new w.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new w.Emitter,this._onProcessShellTypeChanged=new w.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=g;let h=1,_=class extends D.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new w.Emitter,this._onDidOpenTerminal=new w.Emitter,this._onDidChangeActiveTerminal=new w.Emitter,this._onDidChangeTerminalDimensions=new w.Emitter,this._proxy=n.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new w.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new a(this._proxy,(0,d.generateUuid)(),t,t.name),s=new g(t.pty);return n.createExtensionTerminal().then(r=>{const l=this._setupExtHostProcessListeners(r,s);this._terminalProcessDisposables[r]=l}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new g(n),l=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=l}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:n})}async $acceptTerminalDimensions(t,n,s){const r=this._getTerminalById(t);r&&r.setDimensions(n,s)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,s){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}async $acceptTerminalTitleChange(t,n){const s=this._getTerminalById(t);s&&(s.name=n)}async $acceptTerminalClosed(t,n){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const r=this._terminals.splice(s,1)[0];r.setExitCode(n),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,n,s,r){if(n){const v=this._getTerminalObjectIndexById(this._terminals,n);if(v!==null){this._terminals[v]._id=t,this._onDidOpenTerminal.fire(this.terminals[v]),this._terminals[v].isOpen=!0;return}}const l={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:A.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},f=new a(this._proxy,t,l,s);this._terminals.push(f),this._onDidOpenTerminal.fire(f.value),f.isOpen=!0}async $acceptTerminalProcessId(t,n){const s=this._getTerminalById(t);s&&s._setProcessId(n)}async $startExtensionTerminal(t,n){const s=this._getTerminalById(t);if(!s)return{message:(0,C.localize)(0,null,t)};s.isOpen||await new Promise(l=>{const f=this.onDidOpenTerminal(async v=>{v===s.value&&(f.dispose(),l())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const s=new D.DisposableStore;s.add(n.onProcessReady(l=>this._proxy.$sendProcessReady(t,l.pid,l.cwd))),s.add(n.onProcessTitleChanged(l=>this._proxy.$sendProcessTitle(t,l))),this._bufferer.startBuffering(t,n.onProcessData),s.add(n.onProcessExit(l=>this._onProcessExit(t,l))),n.onProcessOverrideDimensions&&s.add(n.onProcessOverrideDimensions(l=>this._proxy.$sendOverrideDimensions(t,l))),this._terminalProcesses.set(t,n);const r=this._extensionTerminalAwaitingStart[t];return r&&n instanceof g&&(n.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(n)}$acceptProcessResize(t,n,s){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}catch(l){if(l.code!=="EPIPE"&&l.code!=="ERR_IPC_CHANNEL_CLOSED")throw l}}$acceptProcessShutdown(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const l=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,l);const f=[],v={terminal:s.value,line:n},T=[];for(const F of this._linkProviders)T.push(new Promise(async L=>{l.token.onCancellationRequested(()=>L({provider:F,links:[]}));const K=await F.provideTerminalLinks(v,l.token)||[];l.token.isCancellationRequested||L({provider:F,links:K})}));const b=await Promise.all(T);if(l.token.isCancellationRequested)return[];const E=new Map;for(const F of b)F&&F.links.length>0&&f.push(...F.links.map(L=>{const K={id:h++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return E.set(K.id,{provider:F.provider,link:L}),K}));return this._terminalLinkCache.set(t,E),f}$activateLink(t,n){var s;const r=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(n);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const s=this._getTerminalObjectIndexById(t,n);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,n){let s=null;return t.some((r,l)=>r._id===n?(s=l,!0):!1),s}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new m,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const s=(0,I.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const s=n[0],r=new m(n[1]);this._setEnvironmentVariableCollection(s,r)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};_=je([Ke(1,S.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class m{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new w.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const s=this.map.get(t);(!s||s.value!==n.value||s.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((s,r)=>t.call(n,r,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=m;let u=class extends _{constructor(t){super(!1,t)}createTerminal(t,n,s){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}getDefaultShell(t,n){throw new i.NotSupportedError}getDefaultShellArgs(t,n){throw new i.NotSupportedError}$getAvailableProfiles(t){throw new i.NotSupportedError}async $getDefaultShellAndArgs(t){throw new i.NotSupportedError}};u=je([Ke(0,S.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(be[206],we([0,1,3,13,5,97,9,7]),function(J,e,w,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new w.Emitter,this._onDidChangeTextEditorOptions=new w.Emitter,this._onDidChangeTextEditorVisibleRanges=new w.Emitter,this._onDidChangeTextEditorViewColumn=new w.Emitter,this._onDidChangeActiveTextEditor=new w.Emitter,this._onDidChangeVisibleTextEditors=new w.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(P.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(c=>c.value)}async showTextDocument(i,I,c){let d;typeof I=="number"?d={position:S.ViewColumn.from(I),preserveFocus:c}:typeof I=="object"?d={position:S.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?S.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:d={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(i.uri,d),a=o&&this._extHostDocumentsAndEditors.getEditor(o);if(a)return a.value;throw o?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new A.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,I){const c=this._extHostDocumentsAndEditors.getEditor(i);if(!c)throw new Error("unknown text editor");if(I.options&&c._acceptOptions(I.options),I.selections){const d=I.selections.selections.map(S.Selection.to);c._acceptSelections(d)}if(I.visibleRanges){const d=k.coalesce(I.visibleRanges.map(S.Range.to));c._acceptVisibleRanges(d)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:S.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const d=D.TextEditorSelectionChangeKind.fromValue(I.selections.source),o=I.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:o,kind:d})}if(I.visibleRanges){const d=k.coalesce(I.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:d})}}$acceptEditorPositionData(i){for(const I in i){const c=this._extHostDocumentsAndEditors.getEditor(I);if(!c)throw new Error("Unknown text editor");const d=S.ViewColumn.to(i[I]);c.value.viewColumn!==d&&(c._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:d}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=y});var Wt=this&&this.__rest||function(J,e){var w={};for(var k in J)Object.prototype.hasOwnProperty.call(J,k)&&e.indexOf(k)<0&&(w[k]=J[k]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var P=0,k=Object.getOwnPropertySymbols(J);P<k.length;P++)e.indexOf(k[P])<0&&Object.prototype.propertyIsEnumerable.call(J,k[P])&&(w[k[P]]=J[k[P]]);return w};define(be[207],we([0,1,2,4,5,6,7]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class D{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(P.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:c=>{var d,o;if(c&&c.$mid===11){const a=c.uri===void 0?void 0:w.URI.revive(c.uri);return(o=(d=this._itemsBySourceAndUriMap.get(c.source))===null||d===void 0?void 0:d.get(y(a)))===null||o===void 0?void 0:o.get(c.handle)}return c}})}async $getTimeline(i,I,c,d,o){const a=this._providers.get(i);return a==null?void 0:a.provideTimeline(w.URI.revive(I),c,d,o)}registerTimelineProvider(i,I,c,d){const o=new A.DisposableStore,a=this.convertTimelineItem(I.id,d,o).bind(this);let g;I.onDidChange&&(g=I.onDidChange(_=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},_),{id:I.id})),this));const h=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:i,onDidChange:void 0,async provideTimeline(_,m,u,p){var t;(p==null?void 0:p.resetCache)&&(o.clear(),(t=h.get(I.id))===null||t===void 0||t.clear());const n=await I.provideTimeline(_,m,u);if(n!=null){const s=a(_,p);return Object.assign(Object.assign({},n),{source:I.id,items:n.items.map(s)})}},dispose(){var _;for(const m of h.values())(_=m.get(I.id))===null||_===void 0||_.clear();g==null||g.dispose(),o.dispose()}}))}convertTimelineItem(i,I,c){return(d,o)=>{let a;if(o==null?void 0:o.cacheResults){let g=this._itemsBySourceAndUriMap.get(i);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(i,g));const h=y(d);a=g.get(h),a===void 0&&(a=new Map,g.set(h,a))}return g=>{var h,_;const{iconPath:m}=g,u=Wt(g,["iconPath"]),p=`${i}|${(h=g.id)!==null&&h!==void 0?h:g.timestamp}`;a==null||a.set(p,g);let t,n,s;return g.iconPath&&(m instanceof S.ThemeIcon?s={id:m.id}:w.URI.isUri(m)?(t=m,n=m):{light:t,dark:n}=m),Object.assign(Object.assign({},u),{id:(_=u.id)!==null&&_!==void 0?_:void 0,handle:p,source:i,command:g.command?I.toInternal(g.command,c):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:g.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,A.toDisposable)(()=>{var c;for(const d of this._itemsBySourceAndUriMap.values())(c=d.get(i.id))===null||c===void 0||c.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=D;function y(C){return C==null?void 0:C.toString()}}),define(be[208],we([0,1,6,18,2,5]),function(J,e,w,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,C,i,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const c=I.schemes.find(d=>!S.supportedSchemes.has(d));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,i),this._proxy.$registerUriOpener(C,I.schemes,y,I.label),(0,w.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(y,C,i){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener with id: ${y}`);const c=P.URI.revive(C);return I.canOpenExternalUri(c,i)}async $openUri(y,C,i){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener id: '${y}'`);return I.openExternalUri(P.URI.revive(C.resolvedUri),{sourceUri:P.URI.revive(C.sourceUri)},i)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}),define(be[209],we([0,1,5,2,6,12,26]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(w.MainContext.MainThreadUrls)}registerUriHandler(C,i){if(this.handles.has(S.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=D.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(C)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,C),(0,P.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,i){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(k.URI.revive(i))}catch(c){(0,A.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(C){return k.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=D,D.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(J,e,w,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,w):P?P.value=w:e.set(J,w),w},Me=this&&this.__classPrivateFieldGet||function(J,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(J):k?k.value:e.get(J)};define(be[50],we([0,1,23,3,2,144,165,72,5]),function(J,e,w,k,P,A,S,D,y){"use strict";var C,i,I,c,d,o,a,g,h,_,m,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class p{constructor(b,E,F,L,K,fe,j){C.set(this,void 0),i.set(this,void 0),I.set(this,void 0),c.set(this,void 0),d.set(this,void 0),o.set(this,void 0),a.set(this,""),g.set(this,void 0),h.set(this,!1),_.set(this,!1),m.set(this,!1),this._onMessageEmitter=new k.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new k.Emitter),this._onDidDispose=Me(this,u,"f").event,tt(this,C,b,"f"),tt(this,i,E,"f"),tt(this,g,F,"f"),tt(this,c,L,"f"),tt(this,d,K,"f"),tt(this,o,fe,"f"),tt(this,m,t(fe),"f"),tt(this,I,j,"f")}dispose(){tt(this,h,!0,"f"),Me(this,u,"f").fire(),Me(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return tt(this,_,!0,"f"),(0,D.asWebviewUri)(Me(this,c,"f"),Me(this,C,"f"),b)}get cspSource(){return Me(this,c,"f").webviewCspSource.replace("{{uuid}}",Me(this,C,"f"))}get html(){return this.assertNotDisposed(),Me(this,a,"f")}set html(b){this.assertNotDisposed(),Me(this,a,"f")!==b&&(tt(this,a,b,"f"),!Me(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(tt(this,_,!0,"f"),Me(this,I,"f").report("Webview vscode-resource: uris",Me(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,i,"f").$setHtml(Me(this,C,"f"),b))}get options(){return this.assertNotDisposed(),Me(this,g,"f")}set options(b){this.assertNotDisposed(),Me(this,i,"f").$setOptions(Me(this,C,"f"),l(Me(this,o,"f"),Me(this,d,"f"),b)),tt(this,g,b,"f")}async postMessage(b){if(Me(this,h,"f"))return!1;const E=n(b,{serializeBuffersForPostMessage:Me(this,m,"f")});return Me(this,i,"f").$postMessage(Me(this,C,"f"),E.message,...E.buffers)}assertNotDisposed(){if(Me(this,h,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=p,C=new WeakMap,i=new WeakMap,I=new WeakMap,c=new WeakMap,d=new WeakMap,o=new WeakMap,a=new WeakMap,g=new WeakMap,h=new WeakMap,_=new WeakMap,m=new WeakMap,u=new WeakMap;function t(T){if(!T.enableProposedApi)return!1;try{const b=(0,A.normalizeVersion)((0,A.parseVersion)(T.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=56}catch(b){return!1}}e.shouldSerializeBuffersForPostMessage=t;function n(T,b){if(b.serializeBuffersForPostMessage){const E=[],F=(K,fe)=>{if(fe&&fe instanceof ArrayBuffer){let j=E.findIndex(H=>H.original===fe);if(j===-1){const H=new Uint8Array(fe),ee=w.VSBuffer.wrap(H);j=E.length,E.push({original:fe,vsBuffer:ee})}return{$$vscode_array_buffer_reference$$:!0,index:j}}return fe};return{message:JSON.stringify(T,F),buffers:E.map(K=>K.vsBuffer)}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeMessage=n;class s{constructor(b,E,F,L,K){this.initData=E,this.workspace=F,this._logService=L,this._deprecationService=K,this._webviews=new Map,this._webviewProxy=b.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(b,E,...F){const L=this.getWebview(b);if(L){const{message:K}=(0,S.deserializeWebviewMessage)(E,F);L._onMessageEmitter.fire(K)}}$onMissingCsp(b,E){this._logService.warn(`${E} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,E,F){const L=new p(b,this._webviewProxy,f(E),this.initData,this.workspace,F,this._deprecationService);return this._webviews.set(b,L),L._onDidDispose(()=>{this._webviews.delete(b)}),L}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=s;function r(T){return{id:T.identifier,location:T.extensionLocation}}e.toExtensionData=r;function l(T,b,E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots||v(T,b)}}e.serializeWebviewOptions=l;function f(T){var b;return{enableCommandUris:T.enableCommandUris,enableScripts:T.enableScripts,portMapping:T.portMapping,localResourceRoots:(b=T.localResourceRoots)===null||b===void 0?void 0:b.map(E=>P.URI.from(E))}}e.reviveOptions=f;function v(T,b){return[...((b==null?void 0:b.getWorkspaceFolders())||[]).map(E=>E.uri),T.extensionLocation]}}),define(be[210],we([0,1,20,56,6,18,25,2,9,50,68,5,7]),function(J,e,w,k,P,A,S,D,y,C,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class o{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const l=new d(n,s);return this._documents.set(r,l),l}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var a;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(a||(a={}));class g{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:r}),new c.Disposable(()=>this._providers.delete(n))}}class h{constructor(t,n,s,r,l){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=r,this._extHostWebviewPanels=l,this._editorProviders=new g,this._documents=new o,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,r){const l=new P.DisposableStore;return _(s)?(l.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(t),n,r.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(t))):(l.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&l.add(s.onDidChangeCustomDocument(f=>{const v=this.getCustomDocumentEntry(n,f.document.uri);if(m(f)){const T=v.addEdit(f);this._proxy.$onDidEdit(f.document.uri,n,T,f.label)}else this._proxy.$onContentChange(f.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(t))),c.Disposable.from(l,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,r,l){var f;const v=this._editorProviders.get(n);if(!v)throw new Error(`No provider found for '${n}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${n}'`);const T=D.URI.revive(t),b=await v.provider.openCustomDocument(T,{backupId:s,untitledDocumentData:r==null?void 0:r.buffer},l);let E;return this.supportEditing(v.provider)&&this._extensionStoragePaths&&(E=(f=this._extensionStoragePaths.workspaceValue(v.extension))!==null&&f!==void 0?f:this._extensionStoragePaths.globalValue(v.extension)),this._documents.add(n,b,E),{editable:this.supportEditing(v.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=D.URI.revive(t),{document:l}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,l),l.dispose()}async $resolveWebviewEditor(t,n,s,r,l,f){const v=this._editorProviders.get(s);if(!v)throw new Error(`No provider found for '${s}'`);const T=y.ViewColumn.to(l),b=this._extHostWebview.createNewWebview(n,r.webviewOptions,v.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(n,s,r.title,T,r.panelOptions,b),F=D.URI.revive(t);switch(v.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,F);return v.provider.resolveCustomEditor(L,E,f)}case 0:{const L=this._extHostDocuments.getDocument(F);return v.provider.resolveCustomTextEditor(L,E,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const f=D.URI.revive(n),v=this._extHostDocuments.getDocument(f);await r.provider.moveCustomTextEditor(v,l,w.CancellationToken.None)}async $undo(t,n,s,r){return this.getCustomDocumentEntry(n,t).undo(s,r)}async $redo(t,n,s,r){return this.getCustomDocumentEntry(n,t).redo(s,r)}async $revert(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,s),r.disposeBackup()}async $onSave(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,s),r.disposeBackup()}async $onSaveAs(t,n,s,r){const l=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(l.document,D.URI.revive(s),r)}async $backup(t,n,s){const r=this.getCustomDocumentEntry(n,t),f=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},s);return r.updateBackup(f),f.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,D.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=h;function _(p){return typeof p.resolveCustomTextEditor=="function"}function m(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function u(p){const t=p.scheme===A.Schemas.file||p.scheme===A.Schemas.untitled?p.fsPath:p.toString();return(0,k.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(J,e,w,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,w):P?P.value=w:e.set(J,w),w},Me=this&&this.__classPrivateFieldGet||function(J,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(J):k?k.value:e.get(J)};define(be[211],we([0,1,3,6,2,31,9,50,5,7]),function(J,e,w,k,P,A,S,D,y,C){"use strict";var i,I,c,d,o,a,g,h,_,m,u,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends k.Disposable{constructor(f,v,T,b,E,F,L){super();i.set(this,void 0),I.set(this,void 0),c.set(this,void 0),d.set(this,void 0),o.set(this,void 0),a.set(this,void 0),g.set(this,void 0),h.set(this,void 0),_.set(this,!0),m.set(this,!0),u.set(this,!1),p.set(this,this._register(new w.Emitter)),this.onDidDispose=Me(this,p,"f").event,t.set(this,this._register(new w.Emitter)),this.onDidChangeViewState=Me(this,t,"f").event,tt(this,i,f,"f"),tt(this,I,v,"f"),tt(this,c,T,"f"),tt(this,o,F,"f"),tt(this,h,E,"f"),tt(this,a,b,"f"),tt(this,d,L,"f")}dispose(){Me(this,u,"f")||(tt(this,u,!0,"f"),Me(this,p,"f").fire(),Me(this,I,"f").$disposeWebview(Me(this,i,"f")),Me(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,d,"f")}get viewType(){return this.assertNotDisposed(),Me(this,c,"f")}get title(){return this.assertNotDisposed(),Me(this,a,"f")}set title(f){this.assertNotDisposed(),Me(this,a,"f")!==f&&(tt(this,a,f,"f"),Me(this,I,"f").$setTitle(Me(this,i,"f"),f))}get iconPath(){return this.assertNotDisposed(),Me(this,g,"f")}set iconPath(f){this.assertNotDisposed(),Me(this,g,"f")!==f&&(tt(this,g,f,"f"),Me(this,I,"f").$setIconPath(Me(this,i,"f"),P.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Me(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,h,"f")=="number"&&Me(this,h,"f")<0))return Me(this,h,"f")}get active(){return this.assertNotDisposed(),Me(this,m,"f")}get visible(){return this.assertNotDisposed(),Me(this,_,"f")}_updateViewState(f){Me(this,u,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(tt(this,m,f.active,"f"),tt(this,_,f.visible,"f"),tt(this,h,f.viewColumn,"f"),Me(this,t,"f").fire({webviewPanel:this}))}reveal(f,v){this.assertNotDisposed(),Me(this,I,"f").$reveal(Me(this,i,"f"),{viewColumn:f?S.ViewColumn.from(f):void 0,preserveFocus:!!v})}assertNotDisposed(){if(Me(this,u,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,c=new WeakMap,d=new WeakMap,o=new WeakMap,a=new WeakMap,g=new WeakMap,h=new WeakMap,_=new WeakMap,m=new WeakMap,u=new WeakMap,p=new WeakMap,t=new WeakMap;class s{constructor(f,v,T){this.webviews=v,this.workspace=T,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(f,v,T,b,E={}){const F=typeof b=="object"?b.viewColumn:b,L={viewColumn:S.ViewColumn.from(F),preserveFocus:typeof b=="object"&&!!b.preserveFocus},K=(0,D.shouldSerializeBuffersForPostMessage)(f),fe=s.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(f),fe,v,{title:T,panelOptions:r(E),webviewOptions:(0,D.serializeWebviewOptions)(f,this.workspace,E),serializeBuffersForPostMessage:K},L);const j=this.webviews.createNewWebview(fe,E,f);return this.createNewWebviewPanel(fe,v,T,F,E,j)}$onDidChangeWebviewPanelViewStates(f){const v=Object.keys(f);v.sort((T,b)=>{const E=f[T],F=f[b];return E.active?1:F.active?-1:+E.visible-+F.visible});for(const T of v){const b=this.getWebviewPanel(T);if(!!b){const E=f[T];b._updateViewState({active:E.active,visible:E.visible,viewColumn:S.ViewColumn.to(E.position)})}}}async $onDidDisposeWebviewPanel(f){const v=this.getWebviewPanel(f);v==null||v.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,v,T){if(this._serializers.has(v))throw new Error(`Serializer for '${v}' already registered`);return this._serializers.set(v,{serializer:T,extension:f}),this._proxy.$registerSerializer(v,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(f)}),new C.Disposable(()=>{this._serializers.delete(v),this._proxy.$unregisterSerializer(v)})}async $deserializeWebviewPanel(f,v,T,b){const E=this._serializers.get(v);if(!E)throw new Error(`No serializer found for '${v}'`);const{serializer:F,extension:L}=E,K=this.webviews.createNewWebview(f,T.webviewOptions,L),fe=this.createNewWebviewPanel(f,v,T.title,b,T.panelOptions,K);await F.deserializeWebviewPanel(fe,T.state)}createNewWebviewPanel(f,v,T,b,E,F){const L=new n(f,this._proxy,v,T,b,E,F);return this._webviewPanels.set(f,L),L}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=s;function r(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(J,e,w,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,w):P?P.value=w:e.set(J,w),w},Me=this&&this.__classPrivateFieldGet||function(J,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(J):k?k.value:e.get(J)};define(be[212],we([0,1,3,6,50,5,7]),function(J,e,w,k,P,A,S){"use strict";var D,y,C,i,I,c,d,o,a,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class h extends k.Disposable{constructor(u,p,t,n,s,r){super();D.set(this,void 0),y.set(this,void 0),C.set(this,void 0),i.set(this,void 0),I.set(this,!1),c.set(this,void 0),d.set(this,void 0),o.set(this,void 0),a.set(this,this._register(new w.Emitter)),this.onDidChangeVisibility=Me(this,a,"f").event,g.set(this,this._register(new w.Emitter)),this.onDidDispose=Me(this,g,"f").event,tt(this,C,t,"f"),tt(this,d,n,"f"),tt(this,D,u,"f"),tt(this,y,p,"f"),tt(this,i,s,"f"),tt(this,c,r,"f")}dispose(){Me(this,I,"f")||(tt(this,I,!0,"f"),Me(this,g,"f").fire(),Me(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,d,"f")}set title(u){this.assertNotDisposed(),Me(this,d,"f")!==u&&(tt(this,d,u,"f"),Me(this,y,"f").$setWebviewViewTitle(Me(this,D,"f"),u))}get description(){return this.assertNotDisposed(),Me(this,o,"f")}set description(u){this.assertNotDisposed(),Me(this,o,"f")!==u&&(tt(this,o,u,"f"),Me(this,y,"f").$setWebviewViewDescription(Me(this,D,"f"),u))}get visible(){return Me(this,c,"f")}get webview(){return Me(this,i,"f")}get viewType(){return Me(this,C,"f")}_setVisible(u){u===Me(this,c,"f")||Me(this,I,"f")||(tt(this,c,u,"f"),Me(this,a,"f").fire())}show(u){this.assertNotDisposed(),Me(this,y,"f").$show(Me(this,D,"f"),!!u)}assertNotDisposed(){if(Me(this,I,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,y=new WeakMap,C=new WeakMap,i=new WeakMap,I=new WeakMap,c=new WeakMap,d=new WeakMap,o=new WeakMap,a=new WeakMap,g=new WeakMap;class _{constructor(u,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,p,t,n){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,P.toExtensionData)(u),p,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new S.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(u,p,t,n,s){const r=this._viewProviders.get(p);if(!r)throw new Error(`No view provider found for '${p}'`);const{provider:l,extension:f}=r,v=this._extHostWebview.createNewWebview(u,{},f),T=new h(u,this._proxy,p,t,v,!0);this._webviewViews.set(u,T),await l.resolveWebviewView(T,{state:n},s)}async $onDidChangeWebviewViewVisibility(u,p){this.getWebviewView(u)._setVisible(p)}async $disposeWebviewView(u){const p=this.getWebviewView(u);this._webviewViews.delete(u),p.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const p=this._webviewViews.get(u);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=_}),define(be[101],we([0,1,3,5,2,18,8,4,15]),function(J,e,w,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class An{constructor(I){this._onDidChangeWindowState=new w.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=An.InitialState,this._proxy=I.getProxy(k.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,c){let d;if(typeof I=="string"){d=I;try{I=P.URI.parse(I)}catch(o){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,S.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,d,c)}async asExternalUri(I,c){if((0,S.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(I.scheme))return Promise.reject(`Invalid scheme '${I.scheme}'`);const d=await this._proxy.$asExternalUri(I,c);return P.URI.from(d)}};C.InitialState={focused:!0},C=je([Ke(0,y.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(be[213],we([0,1,19,5,27,15]),function(J,e,w,k,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let S=class extends w.AbstractLogger{constructor(y,C){super();this._proxy=y.getProxy(k.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...C){this.getLevel()<=w.LogLevel.Trace&&this._proxy.$log(this._logFile,w.LogLevel.Trace,Array.from(arguments))}debug(y,...C){this.getLevel()<=w.LogLevel.Debug&&this._proxy.$log(this._logFile,w.LogLevel.Debug,Array.from(arguments))}info(y,...C){this.getLevel()<=w.LogLevel.Info&&this._proxy.$log(this._logFile,w.LogLevel.Info,Array.from(arguments))}warn(y,...C){this.getLevel()<=w.LogLevel.Warning&&this._proxy.$log(this._logFile,w.LogLevel.Warning,Array.from(arguments))}error(y,...C){this.getLevel()<=w.LogLevel.Error&&this._proxy.$log(this._logFile,w.LogLevel.Error,Array.from(arguments))}critical(y,...C){this.getLevel()<=w.LogLevel.Critical&&this._proxy.$log(this._logFile,w.LogLevel.Critical,Array.from(arguments))}flush(){}};S=je([Ke(0,A.IExtHostRpcService),Ke(1,P.IExtHostInitDataService)],S),e.ExtHostLogService=S}),define(be[214],we([0,1,11,20,12,3,6,112,186,98,23]),function(J,e,w,k,P,A,S,D,y,C,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function c(r,l){try{return JSON.stringify(r,l)}catch(f){return"null"}}function d(r,l){return JSON.stringify(r,l)}function o(r){return r?(l,f)=>f&&f.$mid===1?r.transformOutgoing(f):f:null}var a;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const h=()=>{},_=Symbol.for("rpcProtocol"),m=Symbol.for("rpcProxy");class u extends S.Disposable{constructor(l,f=null,v=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=f,this._uriTransformer=v,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let T=0,b=C.ProxyIdentifier.count;T<b;T++)this._locals[T]=null,this._proxies[T]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new w.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(T=>this._receiveOneMessage(T))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?(0,D.transformIncomingURIs)(l,this._uriTransformer):l}getProxy(l){const{nid:f,sid:v}=l;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,v)),this._proxies[f]}_createProxy(l,f){let v={get:(T,b)=>(typeof b=="string"&&!T[b]&&b.charCodeAt(0)===36&&(T[b]=(...E)=>this._remoteCall(l,b,E)),b===m?f:T[b])};return new Proxy(Object.create(null),v)}set(l,f){return this._locals[l.nid]=f,f}assertRegistered(l){for(let f=0,v=l.length;f<v;f++){const T=l[f];if(!this._locals[T.nid])throw new Error(`Missing actor ${T.sid} (isMain: ${T.isMain})`)}}_receiveOneMessage(l){if(!this._isDisposed){const f=l.byteLength,v=p.read(l,0),T=v.readUInt8(),b=v.readUInt32();switch(T){case 1:case 2:{let{rpcId:E,method:F,args:L}=t.deserializeRequestJSONArgs(v);this._uriTransformer&&(L=(0,D.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(f,b,E,F,L,T===2);break}case 3:case 4:{let{rpcId:E,method:F,args:L}=t.deserializeRequestMixedArgs(v);this._uriTransformer&&(L=(0,D.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(f,b,E,F,L,T===4);break}case 5:{this._logger&&this._logger.logIncoming(f,b,0,"ack"),this._onDidReceiveAcknowledge(b);break}case 6:{this._receiveCancel(f,b);break}case 7:{this._receiveReply(f,b,void 0);break}case 9:{let E=t.deserializeReplyOKJSON(v);this._uriTransformer&&(E=(0,D.transformIncomingURIs)(E,this._uriTransformer)),this._receiveReply(f,b,E);break}case 8:{let E=t.deserializeReplyOKVSBuffer(v);this._receiveReply(f,b,E);break}case 10:{let E=t.deserializeReplyErrError(v);this._uriTransformer&&(E=(0,D.transformIncomingURIs)(E,this._uriTransformer)),this._receiveReplyErr(f,b,E);break}case 11:{this._receiveReplyErr(f,b,void 0);break}default:console.error("received unexpected message"),console.error(l)}}}_receiveRequest(l,f,v,T,b,E){this._logger&&this._logger.logIncoming(l,f,1,`receiveRequest ${(0,C.getStringIdentifierForProxy)(v)}.${T}(`,b);const F=String(f);let L,K;if(E){const j=new k.CancellationTokenSource;b.push(j.token),L=this._invokeHandler(v,T,b),K=()=>j.cancel()}else L=this._invokeHandler(v,T,b),K=h;this._cancelInvokedHandlers[F]=K;const fe=t.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(fe.byteLength,f,1,"ack"),this._protocol.send(fe),L.then(j=>{delete this._cancelInvokedHandlers[F];const H=t.serializeReplyOK(f,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(H.byteLength,f,1,"reply:",j),this._protocol.send(H)},j=>{delete this._cancelInvokedHandlers[F];const H=t.serializeReplyErr(f,j);this._logger&&this._logger.logOutgoing(H.byteLength,f,1,"replyErr:",j),this._protocol.send(H)})}_receiveCancel(l,f){this._logger&&this._logger.logIncoming(l,f,1,"receiveCancel");const v=String(f);this._cancelInvokedHandlers[v]&&this._cancelInvokedHandlers[v]()}_receiveReply(l,f,v){this._logger&&this._logger.logIncoming(l,f,0,"receiveReply:",v);const T=String(f);if(!!this._pendingRPCReplies.hasOwnProperty(T)){const b=this._pendingRPCReplies[T];delete this._pendingRPCReplies[T],b.resolveOk(v)}}_receiveReplyErr(l,f,v){this._logger&&this._logger.logIncoming(l,f,0,"receiveReplyErr:",v);const T=String(f);if(!!this._pendingRPCReplies.hasOwnProperty(T)){const b=this._pendingRPCReplies[T];delete this._pendingRPCReplies[T];let E;v&&(v.$isError?(E=new Error,E.name=v.name,E.message=v.message,E.stack=v.stack):E=v),b.resolveErr(E)}}_invokeHandler(l,f,v){try{return Promise.resolve(this._doInvokeHandler(l,f,v))}catch(T){return Promise.reject(T)}}_doInvokeHandler(l,f,v){const T=this._locals[l];if(!T)throw new Error("Unknown actor "+(0,C.getStringIdentifierForProxy)(l));let b=T[f];if(typeof b!="function")throw new Error("Unknown method "+f+" on actor "+(0,C.getStringIdentifierForProxy)(l));return b.apply(T,v)}_remoteCall(l,f,v){if(this._isDisposed)return Promise.reject(P.canceled());let T=null;if(v.length>0&&k.CancellationToken.isCancellationToken(v[v.length-1])&&(T=v.pop()),T&&T.isCancellationRequested)return Promise.reject(P.canceled());const b=t.serializeRequestArguments(v,this._uriReplacer),E=++this._lastMessageId,F=String(E),L=new y.LazyPromise;T&&T.onCancellationRequested(()=>{const fe=t.serializeCancel(E);this._logger&&this._logger.logOutgoing(fe.byteLength,E,0,"cancel"),this._protocol.send(t.serializeCancel(E))}),this._pendingRPCReplies[F]=L,this._onWillSendRequest(E);const K=t.serializeRequest(E,l,f,b,!!T);return this._logger&&this._logger.logOutgoing(K.byteLength,E,0,`request: ${(0,C.getStringIdentifierForProxy)(l)}.${f}(`,v),this._protocol.send(K),L}}e.RPCProtocol=u,I=_,u.UNRESPONSIVE_TIME=3*1e3;class p{constructor(l,f){this._buff=l,this._offset=f}static alloc(l,f,v){let T=new p(i.VSBuffer.alloc(v+1+4),0);return T.writeUInt8(l),T.writeUInt32(f),T}static read(l,f){return new p(l,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const v=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,v}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,v}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,f}static sizeMixedArray(l,f){let v=0;v+=1;for(let T=0,b=l.length;T<b;T++){const E=l[T],F=f[T];switch(v+=1,F){case 1:v+=this.sizeLongString(E);break;case 2:v+=this.sizeVSBuffer(E);break;case 3:break}}return v}writeMixedArray(l,f){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let v=0,T=l.length;v<T;v++){const b=l[v];switch(f[v]){case 1:this.writeUInt8(1),this.writeLongString(b);break;case 2:this.writeUInt8(2),this.writeVSBuffer(b);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(l);for(let v=0;v<l;v++)switch(this.readUInt8()){case 1:f[v]=this.readLongString();break;case 2:f[v]=this.readVSBuffer();break;case 3:f[v]=void 0;break}return f}}class t{static _arrayContainsBufferOrUndefined(l){for(let f=0,v=l.length;f<v;f++)if(l[f]instanceof i.VSBuffer||typeof l[f]=="undefined")return!0;return!1}static serializeRequestArguments(l,f){if(this._arrayContainsBufferOrUndefined(l)){let v=[],T=[];for(let b=0,E=l.length;b<E;b++){const F=l[b];F instanceof i.VSBuffer?(v[b]=F,T[b]=2):typeof F=="undefined"?(v[b]=i.VSBuffer.alloc(0),T[b]=3):(v[b]=i.VSBuffer.fromString(d(F,f)),T[b]=1)}return{type:"mixed",args:v,argsType:T}}return{type:"simple",args:d(l,f)}}static serializeRequest(l,f,v,T,b){return T.type==="mixed"?this._requestMixedArgs(l,f,v,T.args,T.argsType,b):this._requestJSONArgs(l,f,v,T.args,b)}static _requestJSONArgs(l,f,v,T,b){const E=i.VSBuffer.fromString(v),F=i.VSBuffer.fromString(T);let L=0;L+=p.sizeUInt8(),L+=p.sizeShortString(E),L+=p.sizeLongString(F);let K=p.alloc(b?2:1,l,L);return K.writeUInt8(f),K.writeShortString(E),K.writeLongString(F),K.buffer}static deserializeRequestJSONArgs(l){const f=l.readUInt8(),v=l.readShortString(),T=l.readLongString();return{rpcId:f,method:v,args:JSON.parse(T)}}static _requestMixedArgs(l,f,v,T,b,E){const F=i.VSBuffer.fromString(v);let L=0;L+=p.sizeUInt8(),L+=p.sizeShortString(F),L+=p.sizeMixedArray(T,b);let K=p.alloc(E?4:3,l,L);return K.writeUInt8(f),K.writeShortString(F),K.writeMixedArray(T,b),K.buffer}static deserializeRequestMixedArgs(l){const f=l.readUInt8(),v=l.readShortString(),T=l.readMixedArray(),b=new Array(T.length);for(let E=0,F=T.length;E<F;E++){const L=T[E];typeof L=="string"?b[E]=JSON.parse(L):b[E]=L}return{rpcId:f,method:v,args:b}}static serializeAcknowledged(l){return p.alloc(5,l,0).buffer}static serializeCancel(l){return p.alloc(6,l,0).buffer}static serializeReplyOK(l,f,v){return typeof f=="undefined"?this._serializeReplyOKEmpty(l):f instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(l,f):this._serializeReplyOKJSON(l,c(f,v))}static _serializeReplyOKEmpty(l){return p.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,f){let v=0;v+=p.sizeVSBuffer(f);let T=p.alloc(8,l,v);return T.writeVSBuffer(f),T.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,f){const v=i.VSBuffer.fromString(f);let T=0;T+=p.sizeLongString(v);let b=p.alloc(9,l,T);return b.writeLongString(v),b.buffer}static deserializeReplyOKJSON(l){const f=l.readLongString();return JSON.parse(f)}static serializeReplyErr(l,f){return f?this._serializeReplyErrEror(l,f):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,f){const v=i.VSBuffer.fromString(c(P.transformErrorForSerialization(f),null));let T=0;T+=p.sizeLongString(v);let b=p.alloc(10,l,T);return b.writeLongString(v),b.buffer}static deserializeReplyErrError(l){const f=l.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(l){return p.alloc(11,l,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(s||(s={}))}),define(be[215],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const w=function(A){const S=D=>{self.removeEventListener("message",S);const y=D.data;Object.defineProperties(self,{postMessage:{value(C,i){y.postMessage(C,i)}},onmessage:{get(){return y.onmessage},set(C){y.onmessage=C}}}),y.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",S)}.toString();class k extends EventTarget{constructor(A,S,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${w})('${S}'))`,C=new Blob([y],{type:"application/javascript"}),i=URL.createObjectURL(C),I=new MessageChannel,c=i,d={type:"_newWorker",id:c,port:I.port2,url:i,options:D};A(d,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:c};I.port1.postMessage(o),URL.revokeObjectURL(i),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(o){I.port1.onmessage=o}},onmessageerror:{get(){return I.port1.onmessageerror},set(o){I.port1.onmessageerror=o}}}),I.port1.addEventListener("messageerror",o=>{const a=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(a)}),I.port1.addEventListener("message",o=>{const a=new MessageEvent("message",{data:o.data});this.dispatchEvent(a)}),I.port1.start()}}e.NestedWorker=k}),define(be[216],we([0,1,4]),function(J,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,w.createDecorator)("remoteAgentService")}),define(be[217],we([0,1,18,14,21,2,4,216]),function(J,e,w,k,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class{constructor(i,I){this.localUserHome=i,this.remoteAgentService=I,this.resolveOS=(async()=>{const c=await this.remoteAgentService.getEnvironment();return(c==null?void 0:c.os)||P.OS})(),this.resolveUserHome=(async()=>{const c=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(c==null?void 0:c.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?k.win32:k.posix)}async fileURI(i){let I="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const d=i.indexOf("/",2);d===-1?(I=i.substring(2),i="/"):(I=i.substring(2,d),i=i.substring(d)||"/")}return A.URI.from({scheme:w.Schemas.file,authority:I,path:i,query:"",fragment:""})}};y=je([Ke(1,D.IRemoteAgentService)],y),e.AbstractPathService=y}),define(be[41],we([0,1,13,28,24,37,8,4,14,12]),function(J,e,w,k,P,A,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const i="\u27EA ",I=" characters skipped \u27EB",c=(i.length+I.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var d;(function(O){O[O.file=0]="file",O[O.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(O){O[O.File=1]="File",O[O.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function a(O){return!!O.preview}e.resultIsMatch=a;function g(O){return!!O.resource}e.isFileMatch=g;function h(O){return!!O.message}e.isProgressMessage=h;var _;(function(O){O[O.Normal=0]="Normal",O[O.NewSearchStarted=1]="NewSearchStarted"})(_=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(R){this.resource=R,this.results=[]}}e.FileMatch=m;class u{constructor(R,N,$){this.ranges=N;const U=Array.isArray(N)?N:[N];if($&&$.matchLines===1&&p(U)){R=(0,S.getNLines)(R,$.matchLines);let Q="",Y=0,ie=0;const pe=Math.floor($.charsPerLine/5),Pe=[];for(const Oe of U){const Te=Math.max(Oe.startColumn-pe,0),Be=Oe.startColumn+$.charsPerLine;if(Te>ie+pe+c){const x=i+(Te-ie)+I;Q+=x+R.slice(Te,Be),Y+=Te-(ie+x.length)}else Q+=R.slice(ie,Be);Pe.push(new n(0,Oe.startColumn-Y,Oe.endColumn-Y)),ie=Be}this.preview={text:Q,matches:Array.isArray(this.ranges)?Pe:Pe[0]}}else{const Q=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:R,matches:(0,w.mapArrayOrNot)(N,Y=>new t(Y.startLineNumber-Q,Y.startColumn,Y.endLineNumber-Q,Y.endColumn))}}}}e.TextSearchMatch=u;function p(O){const R=O[0].startLineNumber;for(const N of O)if(N.startLineNumber!==R||N.endLineNumber!==R)return!1;return!0}class t{constructor(R,N,$,U){this.startLineNumber=R,this.startColumn=N,this.endLineNumber=$,this.endColumn=U}}e.SearchRange=t;class n extends t{constructor(R,N,$){super(R,N,R,$)}}e.OneLineRange=n;var s;(function(O){O.Default="default",O.FileNames="fileNames",O.Type="type",O.Modified="modified",O.CountDescending="countDescending",O.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function r(O,R=!0){const N=O&&O.files&&O.files.exclude,$=R&&O&&O.search&&O.search.exclude;if(!(!N&&!$)){if(!N||!$)return N||$;let U=Object.create(null);return U=P.mixin(U,P.deepClone(N)),U=P.mixin(U,P.deepClone($),!0),U}}e.getExcludes=r;function l(O,R){return O.excludePattern&&k.match(O.excludePattern,R)?!1:O.includePattern||O.usingSearchPaths?O.includePattern&&k.match(O.includePattern,R)?!0:O.usingSearchPaths?!!O.folderQueries&&O.folderQueries.some(N=>{const $=N.folder.fsPath;if(A.isEqualOrParent(R,$)){const U=y.relative($,R);return!N.includePattern||!!k.match(N.includePattern,U)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var f;(function(O){O[O.unknownEncoding=1]="unknownEncoding",O[O.regexParseError=2]="regexParseError",O[O.globParseError=3]="globParseError",O[O.invalidLiteral=4]="invalidLiteral",O[O.rgProcessError=5]="rgProcessError",O[O.other=6]="other",O[O.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class v extends Error{constructor(R,N){super(R);this.code=N}}e.SearchError=v;function T(O){const R=O.message;if((0,C.isPromiseCanceledError)(O))return new v(R,f.canceled);try{const N=JSON.parse(R);return new v(N.message,N.code)}catch(N){return new v(R,f.other)}}e.deserializeSearchError=T;function b(O){const R={message:O.message,code:O.code};return new Error(JSON.stringify(R))}e.serializeSearchError=b;function E(O){return O.type==="error"?!0:O.type==="success"}e.isSerializedSearchComplete=E;function F(O){return O.type==="success"}e.isSerializedSearchSuccess=F;function L(O){return!!O.path}e.isSerializedFileMatch=L;function K(O,R){const N=O.searchPath?O.searchPath:O.relativePath;return(0,S.fuzzyContains)(N,R)}e.isFilePatternMatch=K;class fe{constructor(R){this.path=R,this.results=[]}addMatch(R){this.results.push(R)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=fe;function j(O,R){const N=Object.assign(Object.assign({},O||{}),R||{});return Object.keys(N).filter($=>{const U=N[$];return typeof U=="boolean"&&U})}e.resolvePatternsForProvider=j;class H{constructor(R,N){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},R.excludePattern||{}),N.excludePattern||{}),this._parsedExcludeExpression=k.parse(this._excludeExpression);let $=R.includePattern;N.includePattern&&($?$=Object.assign(Object.assign({},$),N.includePattern):$=N.includePattern),$&&(this._parsedIncludeExpression=k.parse($))}includedInQuerySync(R,N,$){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(R,N,$)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(R,N,$))}includedInQuery(R,N,$){return Promise.resolve(this._parsedExcludeExpression(R,N,$)).then(Q=>!!Q).then(Q=>Q?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(R,N,$)).then(Y=>!!Y):Promise.resolve(!0)).then(Q=>Q)}hasSiblingExcludeClauses(){return ee(this._excludeExpression)}}e.QueryGlobTester=H;function ee(O){for(const R in O)if(typeof O[R]!="boolean")return!0;return!1}}),define(be[30],we([0,1,13,11,20,3,22,18,81,25,8,10,2,137,4,19,152,48,49,27,15,7,41,5]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a,g,h,_,m,u,p,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(F,L,K){return new C.ExtUri(fe=>v(fe,K)).isEqual(F,L)}function r(F,L,K){return s(F.uri,L.uri,K)?0:(0,i.compare)(F.uri.toString(),L.uri.toString())}function l(F,L,K){return F.index!==L.index?F.index<L.index?-1:1:s(F.uri,L.uri,K)?(0,i.compare)(F.name,L.name):(0,i.compare)(F.uri.toString(),L.uri.toString())}function f(F,L,K,fe){const j=F.slice(0).sort((ee,O)=>K(ee,O,fe)),H=L.slice(0).sort((ee,O)=>K(ee,O,fe));return(0,w.delta)(j,H,(ee,O)=>K(ee,O,fe))}function v(F,L){const K=L.getCapabilities(F.scheme);return!(K&&K&1024)}class T extends h.Workspace{constructor(L,K,fe,j,H,ee){super(L,fe.map(O=>new h.WorkspaceFolder(O)),j,ee);this._name=K,this._isUntitled=H,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(ee),fe.forEach(O=>{this._workspaceFolders.push(O),this._structure.set(O.uri,O)})}static toExtHostWorkspace(L,K,fe,j){if(!L)return{workspace:null,added:[],removed:[]};const{id:H,name:ee,folders:O,configuration:R,isUntitled:N}=L,$=[],U=K;K?O.forEach((pe,Pe)=>{const Oe=c.URI.revive(pe.uri),Te=T._findFolder(fe||K,Oe,j);Te?(Te.name=pe.name,Te.index=pe.index,$.push(Te)):$.push({uri:Oe,name:pe.name,index:Pe})}):$.push(...O.map(({uri:pe,name:Pe,index:Oe})=>({uri:c.URI.revive(pe),name:Pe,index:Oe}))),$.sort((pe,Pe)=>pe.index<Pe.index?-1:1);const Q=new T(H,ee,$,R?c.URI.revive(R):null,!!N,pe=>v(pe,j)),{added:Y,removed:ie}=f(U?U.workspaceFolders:[],Q.workspaceFolders,r,j);return{workspace:Q,added:Y,removed:ie}}static _findFolder(L,K,fe){for(let j=0;j<L.folders.length;j++){const H=L.workspaceFolders[j];if(s(H.uri,K,fe))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,K){return K&&this._structure.get(L)&&(L=(0,C.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let b=class{constructor(L,K,fe,j){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidReceieveWorkspaceTrust=new A.Emitter,this.onDidReceiveWorkspaceTrust=this._onDidReceieveWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=j,this._extHostFileSystemInfo=fe,this._requestIdProvider=new y.Counter,this._barrier=new k.Barrier,this._proxy=L.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(n.MainContext.MainThreadMessageService);const H=K.workspace;this._confirmedWorkspace=H?new T(H.id,H.name,[],H.configuration?c.URI.revive(H.configuration):null,!!H.isUntitled,ee=>v(ee,fe)):void 0}$initializeWorkspace(L,K){this._trusted=K,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:D.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,K,fe,...j){const H=[];if(Array.isArray(j)&&j.forEach($=>{c.URI.isUri($.uri)&&!H.some(U=>s(U.uri,$.uri,this._extHostFileSystemInfo))&&H.push({uri:$.uri,name:$.name||(0,C.basenameOrAuthority)($.uri)})}),this._unconfirmedWorkspace||[K,fe].some($=>typeof $!="number"||$<0)||fe===0&&H.length===0)return!1;const ee=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(K+fe>ee.length)return!1;const O=ee.slice(0);O.splice(K,fe,...H.map($=>({uri:$.uri,name:$.name||(0,C.basenameOrAuthority)($.uri),index:void 0})));for(let $=0;$<O.length;$++){const U=O[$];if(O.some((Q,Y)=>Y!==$&&s(U.uri,Q.uri,this._extHostFileSystemInfo)))return!1}O.forEach(($,U)=>$.index=U);const{added:R,removed:N}=f(ee,O,l,this._extHostFileSystemInfo);if(R.length===0&&N.length===0)return!1;if(this._proxy){const $=L.displayName||L.name;this._proxy.$updateWorkspaceFolders($,K,fe,H).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(g.Severity.Error,(0,d.localize)(0,null,$,U.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(O),!0}getWorkspaceFolder(L,K){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,K)}async getWorkspaceFolder2(L,K){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,K)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,K){let fe,j="";if(typeof L=="string"?(fe=c.URI.file(L),j=L):typeof L!="undefined"&&(fe=L,j=L.fsPath),!fe)return j;const H=this.getWorkspaceFolder(fe,!0);if(!H)return j;typeof K=="undefined"&&this._actualWorkspace&&(K=this._actualWorkspace.folders.length>1);let ee=(0,C.relativePath)(H.uri,fe);return K&&H.name&&(ee=`${H.name}/${ee}`),ee}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=T.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:K,added:fe,removed:j}=T.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=K||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:fe,removed:j}))}findFiles(L,K,fe,j,H=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let ee;if(K===null?ee=!1:K&&(typeof K=="string"?ee=K:ee=K.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:O,folder:R}=E(L);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(O),(0,I.withUndefinedAsNull)(R),(0,I.withUndefinedAsNull)(ee),(0,I.withUndefinedAsNull)(fe),H).then(N=>Array.isArray(N)?N.map($=>c.URI.revive($)):[])}async findTextInFiles(L,K,fe,j,H=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const ee=this._requestIdProvider.getNext(),O=typeof K.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:K.previewOptions,{includePattern:R,folder:N}=E(K.include),$=typeof K.exclude=="string"?K.exclude:K.exclude?K.exclude.pattern:void 0,U={ignoreSymlinks:typeof K.followSymlinks=="boolean"?!K.followSymlinks:void 0,disregardIgnoreFiles:typeof K.useIgnoreFiles=="boolean"?!K.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof K.useGlobalIgnoreFiles=="boolean"?!K.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof K.useDefaultExcludes=="boolean"?!K.useDefaultExcludes:!0,fileEncoding:K.encoding,maxResults:K.maxResults,previewOptions:O,afterContext:K.afterContext,beforeContext:K.beforeContext,includePattern:R,excludePattern:$},Q=!1;if(this._activeSearchCallbacks[ee]=Y=>{if(!Q){const ie=c.URI.revive(Y.resource);Y.results.forEach(pe=>{(0,t.resultIsMatch)(pe)?fe({uri:ie,preview:{text:pe.preview.text,matches:(0,w.mapArrayOrNot)(pe.preview.matches,Pe=>new p.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))},ranges:(0,w.mapArrayOrNot)(pe.ranges,Pe=>new p.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))}):fe({uri:ie,text:pe.text,lineNumber:pe.lineNumber})})}},H.isCancellationRequested)return{};try{const Y=await this._proxy.$startTextSearch(L,(0,I.withUndefinedAsNull)(N),U,ee,H);return delete this._activeSearchCallbacks[ee],Y||{}}catch(Y){throw delete this._activeSearchCallbacks[ee],Y}}$handleTextSearchResult(L,K){this._activeSearchCallbacks[K]&&this._activeSearchCallbacks[K](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){const K=this._proxy.$requestWorkspaceTrust(L);return(L==null?void 0:L.modal)?K:Promise.resolve(this._trusted)}$onDidReceiveWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidReceieveWorkspaceTrust.fire())}};b=je([Ke(0,u.IExtHostRpcService),Ke(1,m.IExtHostInitDataService),Ke(2,_.IExtHostFileSystemInfo),Ke(3,a.ILogService)],b),e.ExtHostWorkspace=b,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function E(F){let L,K;return F&&(typeof F=="string"?L=F:(L=F.pattern,K=F.baseFolder||c.URI.file(F.base))),{includePattern:L,folder:K}}}),define(be[34],we([0,1,24,3,30,5,7,154,66,10,11,4,15,19,2]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(n,s){if(s){const r=s.split(".");let l=n;for(let f=0;l&&f<r.length;f++)l=l[r[f]];return l}}function g(n){return n instanceof o.URI}function h(n){return n&&n.uri instanceof o.URI&&n.languageId&&typeof n.languageId=="string"}function _(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function m(n){return n&&n.uri instanceof o.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function u(n){if(g(n))return{resource:n};if(h(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(_(n))return{overrideIdentifier:n.languageId};if(m(n))return{resource:n.uri};if(n===null)return{resource:null}}let p=class{constructor(s,r,l){this._proxy=s.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=l,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,r){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(s,r))}};p=je([Ke(0,c.IExtHostRpcService),Ke(1,P.IExtHostWorkspace),Ke(2,d.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(s,r,l,f){this._onDidChangeConfiguration=new k.Emitter,this._proxy=s,this._logService=f,this._extHostWorkspace=r,this._configuration=D.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,r){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,l))}getConfiguration(s,r,l){const f=u(r)||{},v=this._toReadonlyValue(s?a(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,f,l==null?void 0:l.identifier);function T(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const b={has(E){return typeof a(v,E)!="undefined"},get:(E,F)=>{this._validateConfigurationAccess(s?`${s}.${E}`:E,f,l==null?void 0:l.identifier);let L=a(v,E);if(typeof L=="undefined")L=F;else{let K;const fe=(j,H)=>{let ee;const O=()=>{K=K||(0,w.deepClone)(v),ee=ee||a(K,H)};return(0,C.isObject)(j)?new Proxy(j,{get:(R,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return O(),()=>ee;if(K)return ee=ee||a(K,H),ee[N];const $=R[N];return typeof N=="string"?fe($,`${H}.${N}`):$},set:(R,N,$)=>(O(),ee&&(ee[N]=$),!0),deleteProperty:(R,N)=>(O(),ee&&delete ee[N],!0),defineProperty:(R,N,$)=>(O(),ee&&Object.defineProperty(ee,N,$),!0)}):j};L=fe(L,E)}return L},update:(E,F,L,K)=>{E=s?`${s}.${E}`:E;const fe=T(L);return F!==void 0?this._proxy.$updateConfigurationOption(fe,E,F,f,K):this._proxy.$removeConfigurationOption(fe,E,f,K)},inspect:E=>{var F,L,K,fe,j,H,ee,O;E=s?`${s}.${E}`:E;const R=(0,w.deepClone)(this._configuration.inspect(E,f,this._extHostWorkspace.workspace));if(R)return{key:E,defaultValue:(F=R.default)===null||F===void 0?void 0:F.value,globalValue:(L=R.user)===null||L===void 0?void 0:L.value,workspaceValue:(K=R.workspace)===null||K===void 0?void 0:K.value,workspaceFolderValue:(fe=R.workspaceFolder)===null||fe===void 0?void 0:fe.value,defaultLanguageValue:(j=R.default)===null||j===void 0?void 0:j.override,globalLanguageValue:(H=R.user)===null||H===void 0?void 0:H.override,workspaceLanguageValue:(ee=R.workspace)===null||ee===void 0?void 0:ee.override,workspaceFolderLanguageValue:(O=R.workspaceFolder)===null||O===void 0?void 0:O.override,languageIds:R.overrideIdentifiers}}};return typeof v=="object"&&(0,w.mixin)(b,v,!1),Object.freeze(b)}_toReadonlyValue(s){const r=l=>(0,C.isObject)(l)?new Proxy(l,{get:(f,v)=>r(f[v]),set:(f,v,T)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(f,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(f,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return r(s)}_validateConfigurationAccess(s,r,l){const f=y.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),v=l?`[${l.value}] `:"";if(f===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){(r==null?void 0:r.resource)&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,r){const l=new D.ConfigurationChangeEvent(s,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,v)=>l.affectsConfiguration(f,u(v))})}_toMap(s){return s.reduce((r,l)=>(r.set(l[0],l[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(J,e,w,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,w):P?P.value=w:e.set(J,w),w},Me=this&&this.__classPrivateFieldGet||function(J,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(J):k?k.value:e.get(J)};define(be[102],we([0,1,2,11,3,5,7,30,39,34,20,40,15,27,4,18,21,19,75,171,12]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a,g,h,_,m,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(j){function H(O){if(O!=null)return O}j.from=H;function ee(O){if(O!=null)return O}j.to=ee})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(j){function H(O){if(O!=null)return O}j.from=H;function ee(O){if(O!=null)return O}j.to=ee})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(j){function H(O){if(O!=null)return O}j.from=H;function ee(O){if(O!=null)return O}j.to=ee})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(j){function H(R){if(R){const N=R;return N&&!!N.process}else return!1}j.is=H;function ee(R){if(R!=null){const N={process:R.process,args:R.args};return R.options&&(N.options=s.from(R.options)),N}}j.from=ee;function O(R){if(R!=null)return new S.ProcessExecution(R.process,R.args,R.options)}j.to=O})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(j){function H(O){if(O!=null)return O}j.from=H;function ee(O){if(O!=null)return O}j.to=ee})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(j){function H(R){if(R){const N=R;return N&&(!!N.commandLine||!!N.command)}else return!1}j.is=H;function ee(R){if(R!=null){const N={};return R.commandLine!==void 0?N.commandLine=R.commandLine:(N.command=R.command,N.args=R.args),R.options&&(N.options=l.from(R.options)),N}}j.from=ee;function O(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new S.ShellExecution(R.commandLine,R.options):new S.ShellExecution(R.command,R.args?R.args:[],R.options)}j.to=O})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var v;(function(j){function H(R){if(R){let N=R;return N&&N.customExecution==="customExecution"}else return!1}j.is=H;function ee(R){return{customExecution:"customExecution"}}j.from=ee;function O(R,N){return N.get(R)}j.to=O})(v=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var T;(function(j){function H(ee,O){let R;return ee.scope!==void 0&&typeof ee.scope!="number"?R=ee.scope.uri:ee.scope!==void 0&&typeof ee.scope=="number"&&(ee.scope===S.TaskScope.Workspace&&O&&O.workspaceFile?R=O.workspaceFile:R=m.USER_TASKS_GROUP_KEY),{id:ee._id,workspaceFolder:R}}j.from=H})(T=e.TaskHandleDTO||(e.TaskHandleDTO={}));var b;(function(j){function H(R,N){if(R==null)return[];const $=[];for(let U of R){const Q=ee(U,N);Q&&$.push(Q)}return $}j.fromMany=H;function ee(R,N){if(R!=null){let $;R.execution instanceof S.ProcessExecution?$=r.from(R.execution):R.execution instanceof S.ShellExecution?$=f.from(R.execution):R.execution&&R.execution instanceof S.CustomExecution&&($=v.from(R.execution));const U=t.from(R.definition);let Q;if(R.scope?typeof R.scope=="number"?Q=R.scope:Q=R.scope.uri:Q=S.TaskScope.Workspace,!(!U||!Q)){const Y=R.group?R.group.id:void 0;return{_id:R._id,definition:U,name:R.name,source:{extensionId:N.identifier.value,label:R.source,scope:Q},execution:$,isBackground:R.isBackground,group:Y,presentationOptions:n.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}}}j.from=ee;async function O(R,N,$){if(R!=null){let U;r.is(R.execution)?U=r.to(R.execution):f.is(R.execution)?U=f.to(R.execution):v.is(R.execution)&&(U=v.to(R._id,$));const Q=t.to(R.definition);let Y;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?Y=R.source.scope:Y=await N.resolveWorkspaceFolder(w.URI.revive(R.source.scope)):Y=S.TaskScope.Workspace),!(!Q||!Y)){const ie=new S.Task(Q,Y,R.name,R.source.label,U,R.problemMatchers);return R.isBackground!==void 0&&(ie.isBackground=R.isBackground),R.group!==void 0&&(ie.group=S.TaskGroup.from(R.group)),R.presentationOptions&&(ie.presentationOptions=n.to(R.presentationOptions)),R._id&&(ie._id=R._id),R.detail&&(ie.detail=R.detail),ie}}}j.to=O})(b=e.TaskDTO||(e.TaskDTO={}));var E;(function(j){function H(O){return O}j.from=H;function ee(O){if(!!O)return Object.assign(Object.create(null),O)}j.to=ee})(E=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(H,ee,O){this._id=ee,this._task=O,p.set(this,void 0),tt(this,p,H,"f")}get task(){return this._task}terminate(){Me(this,p,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}p=new WeakMap;var L;(function(j){function H(ee){return{id:ee._id,task:void 0}}j.from=H})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let K=class{constructor(H,ee,O,R,N,$,U,Q){this._onDidExecuteTask=new P.Emitter,this._onDidTerminateTask=new P.Emitter,this._onDidTaskProcessStarted=new P.Emitter,this._onDidTaskProcessEnded=new P.Emitter,this._proxy=H.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=O,this._editorService=R,this._configurationService=N,this._terminalService=$,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=U,this._deprecationService=Q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,ee,O){if(!O)return new S.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:ee,provider:O,extension:H}),this._proxy.$registerTaskProvider(R,ee),new S.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(H,ee){this._proxy.$registerTaskSystem(H,ee)}fetchTasks(H){return this._proxy.$fetchTasks(E.from(H)).then(async ee=>{const O=[];for(let R of ee){const N=await b.to(R,this._workspaceProvider,this._providedCustomExecutions2);N&&O.push(N)}return O})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(ee=>H.push(ee)),H}terminateTask(H){if(!(H instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,ee,O){const R=this._providedCustomExecutions2.get(H.id);if(R){if(this._activeCustomExecutions2.get(H.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(H.id,R),this._terminalService.attachPtyToTerminal(ee,await R.callback(O))}this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const ee=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:ee})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const ee=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:ee,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const ee=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:ee,exitCode:H.exitCode})}$provideTasks(H,ee){const O=this._handlers.get(H);if(!O)return Promise.reject(new Error("no handler found"));const R=[],N=(0,k.asPromise)(()=>O.provider.provideTasks(i.CancellationToken.None)).then($=>this.provideTasksInternal(ee,R,O,$));return new Promise($=>{N.then(U=>{Promise.all(R).then(()=>{$(U)})})})}async $resolveTask(H,ee){const O=this._handlers.get(H);if(!O)return Promise.reject(new Error("no handler found"));if(ee.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${ee.definition.type}] cannot be resolved by provider of type [${O.type}].`);const R=await b.to(ee,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const N=await O.provider.resolveTask(R,i.CancellationToken.None);if(!!N){this.checkDeprecation(N,O);const $=b.from(N,O.extension);if(!$)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is($.execution)&&await this.addCustomExecution($,N,!0),await this.resolveTaskInternal($)}}nextHandle(){return this._handleCounter++}async addCustomExecution(H,ee,O){const R=await this._proxy.$createTaskId(H);!O&&!this._providedCustomExecutions2.has(R)&&this._notProvidedCustomExecutions.add(R),this._providedCustomExecutions2.set(R,ee.execution)}async getTaskExecution(H,ee){if(typeof H=="string"){const N=this._taskExecutionPromises.get(H);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let O=this._taskExecutionPromises.get(H.id);if(O)return O;const R=new Promise(async(N,$)=>{const U=ee||await b.to(H.task,this._workspaceProvider,this._providedCustomExecutions2);U?N(new F(this,H.id,U)):$("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(H.id,R),R.then(N=>(this._taskExecutions.set(H.id,N),N),N=>Promise.reject(N))}checkDeprecation(H,ee){H._deprecated&&this._deprecationService.report("Task.constructor",ee.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let O=this._notProvidedCustomExecutions.values(),R=O.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=O.next()}};K=je([Ke(0,c.IExtHostRpcService),Ke(1,d.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,C.IExtHostConfiguration),Ke(5,I.IExtHostTerminalService),Ke(6,h.ILogService),Ke(7,_.IExtHostApiDeprecationService)],K),e.ExtHostTaskBase=K;let fe=class extends K{constructor(H,ee,O,R,N,$,U,Q){super(H,ee,O,R,N,$,U,Q);this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(H,ee){if(!ee.execution)throw new Error("Tasks to execute must include an execution");const O=b.from(ee,H);if(O===void 0)throw new Error("Task is not valid");if(v.is(O.execution))await this.addCustomExecution(O,ee,!1);else throw new u.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution(O),ee);return this._proxy.$executeTask(O).catch(N=>{throw new Error(N)}),R}provideTasksInternal(H,ee,O,R){const N=[];if(R)for(let $ of R){this.checkDeprecation($,O),(!$.definition||!H[$.definition.type])&&this._logService.warn(`The task [${$.source}, ${$.name}] uses an undefined task type. The task will be ignored in the future.`);const U=b.from($,O.extension);U&&v.is(U.execution)?(N.push(U),ee.push(this.addCustomExecution(U,$,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:O.extension}}async resolveTaskInternal(H){if(v.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,ee){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(H,ee,O){}};fe=je([Ke(0,c.IExtHostRpcService),Ke(1,d.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,C.IExtHostConfiguration),Ke(5,I.IExtHostTerminalService),Ke(6,h.ILogService),Ke(7,_.IExtHostApiDeprecationService)],fe),e.WorkerExtHostTask=fe,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(J,e,w,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,w):P?P.value=w:e.set(J,w),w},Me=this&&this.__classPrivateFieldGet||function(J,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(J):k?k.value:e.get(J)},Wt=this&&this.__rest||function(J,e){var w={};for(var k in J)Object.prototype.hasOwnProperty.call(J,k)&&e.indexOf(k)<0&&(w[k]=J[k]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var P=0,k=Object.getOwnPropertySymbols(J);P<k.length;P++)e.indexOf(k[P])<0&&Object.prototype.propertyIsEnumerable.call(J,k[P])&&(w[k[P]]=J[k[P]]);return w};define(be[218],we([0,1,13,11,23,20,3,53,43,6,24,10,2,31,5,39,15,69,9,7,30,182,96]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a,g,h,_,m,u,p,t){"use strict";var n,s,r,l;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const f=(O,R)=>`${O}:${R.toString()}`;let v=class{constructor(R,N,$){this.documents=N,this.workspace=$,this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.ownedTests=new p.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(o.MainContext.MainThreadTesting),this.runQueue=new T(this.proxy),this.workspaceObservers=new H(this.proxy),this.textDocumentObservers=new ee(this.proxy,N)}registerTestController(R,N){const $=(0,d.generateUuid)();this.controllers.set($,{instance:N,extensionId:R}),this.proxy.$registerTestController($);const U=[...this.testControllers.keys()];return setTimeout(()=>{var Q;for(const Y of U)(Q=this.testControllers.get(Y))===null||Q===void 0||Q.subscribeFn($,N)},0),new m.Disposable(()=>{this.controllers.delete($),this.proxy.$unregisterTestController($)})}createTextDocumentTestObserver(R){return this.textDocumentObservers.checkout(R.uri)}createWorkspaceTestObserver(R){return this.workspaceObservers.checkout(R.uri)}async runTests(R,N=A.CancellationToken.None){const $=U=>U.map(this.getInternalTestForReference,this).filter(I.isDefined).map(Q=>({src:Q.src,testId:Q.item.extId}));await this.proxy.$runTests({exclude:R.exclude?$(R.exclude).map(U=>U.testId):void 0,tests:$(R.tests),debug:R.debug},N)}createTestRunTask(R,N,$,U=!0){return this.runQueue.createTestRunTask(R,N,$,U)}$publishTestResults(R){this.results=Object.freeze(R.map(N=>(0,i.deepFreeze)(_.TestResults.to(N))).concat(this.results).sort((N,$)=>$.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(R,N){const $=c.URI.revive(N),U=f(R,$);if(!this.testControllers.has(U)){const Q=new A.CancellationTokenSource;let Y;if(R===1){let Oe=this.documents.getDocument($);if(!Oe){const Te=new C.DisposableStore;Oe=await new Promise(Be=>{Te.add((0,k.disposableTimeout)(()=>Be(void 0),5e3)),Te.add(this.documents.onDidAddDocuments(x=>{const G=x.find(re=>re.document.uri.toString()===$.toString());G&&Be(G)}))}).finally(()=>Te.dispose())}if(Oe){const Te=await this.workspace.getWorkspaceFolder2($,!1);Y=Be=>Be.createDocumentTestRoot?Be.createDocumentTestRoot(Oe.document,Q.token):(0,e.createDefaultDocumentTestRoot)(Be,Oe.document,Te,Q.token)}}else{const Oe=await this.workspace.getWorkspaceFolder2($,!1);Oe&&(Y=Te=>Te.createWorkspaceTestRoot(Oe,Q.token))}if(!!Y){const ie=async(Oe,Te)=>{try{const Be=await Y(Te);Be&&Pe.addRoot(Be,Oe)}catch(Be){console.error(Be)}},pe=new C.DisposableStore,Pe=pe.add(this.ownedTests.createForHierarchy(Oe=>this.proxy.$publishDiff(R,N,Oe)));pe.add((0,C.toDisposable)(()=>Q.dispose(!0)));for(const[Oe,Te]of this.controllers)ie(Oe,Te.instance);Pe.pushDiff([3,-1]),this.testControllers.set(U,{store:pe,collection:Pe,subscribeFn:ie})}}}async $expandTest(R,N){const $=(0,w.mapFind)(this.testControllers.values(),U=>U.collection.treeId===R.src.tree?U:void 0);await($==null?void 0:$.collection.expand(R.testId,N<0?Infinity:N)),this.flushCollectionDiffs()}$unsubscribeFromTests(R,N){var $;const U=c.URI.revive(N),Q=f(R,U);($=this.testControllers.get(Q))===null||$===void 0||$.store.dispose(),this.testControllers.delete(Q)}$acceptDiff(R,N,$){R===1?this.textDocumentObservers.acceptDiff(c.URI.revive(N),$):this.workspaceObservers.acceptDiff(c.URI.revive(N),$)}async $runTestsForProvider(R,N){const $=this.controllers.get(R.tests[0].src.controller);if(!!$){const U=R.tests.map(({testId:ie,src:pe})=>this.ownedTests.getTestById(ie,pe==null?void 0:pe.tree)).filter(I.isDefined).map(([ie,pe])=>pe),Q=R.excludeExtIds.map(ie=>this.ownedTests.getTestById(ie)).filter(I.isDefined).filter(([ie,pe])=>U.some(Pe=>ie.comparePositions(Pe,pe)===1));if(!!U.length){const Y={tests:U.map(ie=>L.unwrap(ie.actual)),exclude:Q.map(([,ie])=>L.unwrap(ie.actual)),debug:R.debug};await this.runQueue.enqueueRun({dto:b.fromInternal(R),token:N,extensionId:$.extensionId,req:Y,doRun:()=>$.instance.runTests(Y,N)})}}}$lookupTest(R){const N=this.ownedTests.getTestById(R.testId);if(!N)return Promise.resolve(void 0);const $=N[1],{actual:U,discoverCts:Q,expandLevels:Y}=$,ie=Wt($,["actual","discoverCts","expandLevels"]);return Promise.resolve(ie)}flushCollectionDiffs(){for(const{collection:R}of this.testControllers.values())R.flushDiff()}getInternalTestForReference(R){var N,$;return($=(N=this.workspaceObservers.getMirroredTestDataByReference(R))!==null&&N!==void 0?N:(0,w.mapFind)(this.testControllers.values(),U=>U.collection.getTestByReference(R)))!==null&&$!==void 0?$:this.textDocumentObservers.getMirroredTestDataByReference(R)}};v=je([Ke(0,g.IExtHostRpcService),Ke(1,a.IExtHostDocumentsAndEditors),Ke(2,u.IExtHostWorkspace)],v),e.ExtHostTesting=v;class T{constructor(R){this.proxy=R,this.state=new Map}enqueueRun(R){let N=this.state.get(R.extensionId);N||(N={queue:[],current:void 0},this.state.set(R.extensionId,N));const $=new k.DeferredPromise,U=()=>{const Q=[],Y=new Set;N.current={publicReq:R.req,factory:ie=>{const pe=new E(ie,R.dto,Y,this.proxy);return Q.push(pe),R.token.onCancellationRequested(()=>pe.end()),pe}},this.invokeRunner(R.extensionId,R.dto.id,R.doRun,Q).finally(()=>$.complete())};return N.queue.push(U),N.queue.length===1&&U(),$.p}createTestRunTask(R,N,$,U){var Q,Y;const ie=this.state.get(R);if((ie==null?void 0:ie.current.publicReq)===N)return ie.current.factory($);const pe=b.fromPublic(N),Pe=new E($,pe,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:N.debug,exclude:(Y=(Q=N.exclude)===null||Q===void 0?void 0:Q.map(Oe=>Oe.id))!==null&&Y!==void 0?Y:[],id:pe.id,tests:N.tests.map(Oe=>Oe.id),persist:U}),Pe.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(pe.id)),Pe}invokeRunner(R,N,$,U){try{const Q=$();return(0,k.isThenable)(Q)?Q.then(()=>this.handleInvokeResult(R,N,U,void 0)).catch(Y=>this.handleInvokeResult(R,N,U,Y)):this.handleInvokeResult(R,N,U,void 0)}catch(Q){return this.handleInvokeResult(R,N,U,Q)}}async handleInvokeResult(R,N,$,U){const Q=this.state.get(R);!Q||(Q.queue.shift(),Q.queue.length>0?Q.queue[0]():this.state.delete(R),await Promise.all($.map(Y=>Y.onEnd.wait())))}}class b{constructor(R,N,$){this.id=R,this.include=N,this.exclude=$}static fromPublic(R){var N,$;return new b((0,d.generateUuid)(),new Set(R.tests.map(U=>U.id)),new Set(($=(N=R.exclude)===null||N===void 0?void 0:N.map(U=>U.id))!==null&&$!==void 0?$:y.Iterable.empty()))}static fromInternal(R){return new b(R.runId,new Set(R.tests.map(N=>N.testId)),new Set(R.excludeExtIds))}isIncluded(R){for(let N=R;N;N=N.parent){if(this.include.has(N.id))return!0;if(this.exclude.has(N.id))return!1}return!0}}class E{constructor(R,N,$,U){this.name=R,n.set(this,void 0),s.set(this,void 0),r.set(this,(0,d.generateUuid)()),l.set(this,void 0),this.onEnd=new k.Barrier,tt(this,n,U,"f"),tt(this,s,N,"f"),tt(this,l,$,"f"),U.$startedTestRunTask(N.id,{id:Me(this,r,"f"),name:R,running:!0})}setState(R,N,$){Me(this,s,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Me(this,n,"f").$updateTestStateInRun(Me(this,s,"f").id,Me(this,r,"f"),R.id,N,$))}appendMessage(R,N){Me(this,s,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Me(this,n,"f").$appendTestMessageInRun(Me(this,s,"f").id,Me(this,r,"f"),R.id,_.TestMessage.from(N)))}appendOutput(R){Me(this,n,"f").$appendOutputToRun(Me(this,s,"f").id,Me(this,r,"f"),P.VSBuffer.fromString(R))}end(){Me(this,n,"f").$finishedTestRunTask(Me(this,s,"f").id,Me(this,r,"f")),this.onEnd.open()}ensureTestIsKnown(R){const N=Me(this,l,"f");if(!N.has(R.id)){const $=[];for(;$.unshift(_.TestItem.from(R)),!(N.has(R.id)||(N.add(R.id),!R.parent));)R=R.parent;Me(this,n,"f").$addTestsToRun(Me(this,s,"f").id,$)}}}n=new WeakMap,s=new WeakMap,r=new WeakMap,l=new WeakMap;const F=async(O,R,N,$)=>{if(!!N){const U=await O.createWorkspaceTestRoot(N,$);if(!!U)return $.onCancellationRequested(()=>{L.removeFilter(R)}),L.getWrapperForTestItem(U,R)}};e.createDefaultDocumentTestRoot=F;class L extends m.TestItemImpl{constructor(R,N,$){super(R.id,R.label,R.uri,void 0);if(this.actual=R,this.filterDocument=N,this.actualParent=$,!(R instanceof m.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${R.id} did not`);this.debuggable=R.debuggable,this.runnable=R.runnable,this.description=R.description,this.error=R.error,this.status=R.status,this.resolveHandler=R.resolveHandler;const U=(0,h.getPrivateApiFor)(this);(0,h.getPrivateApiFor)(R).bus.event(Y=>{switch(Y[0]){case 3:this[Y[1]]=Y[2];break;case 0:const ie=L.getWrapperForTestItem(Y[1],this.filterDocument,this);(0,h.getPrivateApiFor)(ie).parent=R,ie.refreshMatch();break;default:U.bus.fire(Y)}})}static removeFilter(R){this.wrapperMap.delete(R)}static getWrapperForTestItem(R,N,$){let U=this.wrapperMap.get(N);if(U==null?void 0:U.has(R))return U.get(R);U||(U=new WeakMap,this.wrapperMap.set(N,U));const Q=new L(R,N,$);return U.set(R,Q),Q}static unwrap(R){return R instanceof L?R.actual:R}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var R;const N=this._cachedMatchesFilter;for(const U of this.actual.children.values()){const Q=L.getWrapperForTestItem(U,this.filterDocument,this);Q.hasNodeMatchingFilter?this.children.has(Q.id)||this.addChild(Q):Q.dispose()}const $=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=$,$!==N&&((R=this.actualParent)===null||R===void 0||R.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,h.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,h.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=L,L.wrapperMap=new WeakMap;class K extends t.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,_.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:N,removed:$}=this;return{get added(){return[...R].map(U=>U.revived)},get updated(){return[...N].map(U=>U.revived)},get removed(){return[...$].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class fe extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(R){let N=[];for(const $ of R){const U=this.items.get($);U&&N.push(U.revived)}return N}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,N){return Object.assign(Object.assign({},R),{revived:_.TestItem.toPlain(R.item),depth:N?N.depth+1:0,children:new Set})}createChangeCollector(){return new K(this.changeEmitter)}}e.MirroredTestCollection=fe;class j{constructor(){this.resources=new Map}checkout(R){var N,$;const U=R.toString(),Q=(N=this.resources.get(U))!==null&&N!==void 0?N:this.createObserverData(R);return($=Q.pendingDeletion)===null||$===void 0||$.dispose(),Q.observers++,{onDidChangeTest:Q.tests.onDidChangeTests,onDidDiscoverInitialTests:new S.Emitter().event,get tests(){return Q.tests.rootTestItems},dispose:(0,D.once)(()=>{--Q.observers||(Q.pendingDeletion=this.eventuallyDispose(R))})}}getMirroredTestDataByReference(R){for(const{tests:N}of this.resources.values()){const $=N.getMirroredTestDataByReference(R);if($)return $}}eventuallyDispose(R){return(0,k.disposableTimeout)(()=>this.unlisten(R),10*1e3)}createObserverData(R){const N=new fe,$=this.listen(R,Q=>N.apply(Q)),U={observers:0,tests:N,listener:$};return this.resources.set(R.toString(),U),U}unlisten(R){var N;const $=R.toString(),U=this.resources.get($);U&&(U.observers=-1,(N=U.pendingDeletion)===null||N===void 0||N.dispose(),U.listener.dispose(),this.resources.delete($))}}class H extends j{constructor(R){super();this.proxy=R,this.diffListeners=new Map}acceptDiff(R,N){var $;($=this.diffListeners.get(R.toString()))===null||$===void 0||$(N)}listen(R,N){this.proxy.$subscribeToDiffs(0,R);const $=R.toString();return this.diffListeners.set($,N),new m.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,R),this.diffListeners.delete($)})}}class ee extends j{constructor(R,N){super();this.proxy=R,this.documents=N,this.diffListeners=new Map}acceptDiff(R,N){var $;($=this.diffListeners.get(R.toString()))===null||$===void 0||$(N)}listen(R,N){if(!this.documents.getDocument(R))return new m.Disposable(()=>{});const U=R.toString();return this.diffListeners.set(U,N),this.proxy.$subscribeToDiffs(1,R),new m.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,R),this.diffListeners.delete(U)})}}}),define(be[219],we([0,1,13,51,28,58,22,18,14,25,8,10,2,115,140,92,48,174,217,41]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a,g,h,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(T,b,E,F){this.configurationService=T,this.workspaceContextService=b,this.editorGroupsService=E,this.pathService=F}text(T,b,E={}){T=this.getContentPattern(T,E);const F=this.configurationService.getValue(),L=b&&b.some(fe=>!this.configurationService.getValue({resource:fe}).search.useRipgrep),K=this.commonQuery(b==null?void 0:b.map(g.toWorkspaceFolder),E);return Object.assign(Object.assign({},K),{type:2,contentPattern:T,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:F.search.usePCRE2||L||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles})}getContentPattern(T,b){const E=this.configurationService.getValue();T.isRegExp&&(T.pattern=T.pattern.replace(/\r?\n/g,"\\n"));const F=Object.assign(Object.assign({},T),{wordSeparators:E.editor.wordSeparators});return this.isCaseSensitive(T,b)&&(F.isCaseSensitive=!0),this.isMultiline(T)&&(F.isMultiline=!0),F}file(T,b={}){const E=this.commonQuery(T,b);return Object.assign(Object.assign({},E),{type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey})}handleIncludeExclude(T,b){return T?(T=Array.isArray(T)?T.map(r):r(T),b?this.parseSearchPaths(T):{pattern:t(...Array.isArray(T)?T:[T])}):{}}commonQuery(T=[],b={}){const E=this.handleIncludeExclude(b.includePattern,b.expandPatterns),F=this.handleIncludeExclude(b.excludePattern,b.expandPatterns),L=T.length>1,K=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(H=>this.getFolderQueryForSearchPath(H,b,F)):T.map(H=>this.getFolderQueryForRoot(H,b,F,L))).filter(H=>!!H),fe={_reason:b._reason,folderQueries:K,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:F.pattern,includePattern:E.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const ee=w.coalesce(w.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(N=>N.resource)))).filter(R=>(0,m.pathIncludedInQuery)(fe,R.fsPath)),O=this.commonQueryFromFileList(ee);return Object.assign(Object.assign({},fe),O)}const j=b.extraFileResources&&b.extraFileResources.filter(H=>(0,m.pathIncludedInQuery)(fe,H.fsPath));return fe.extraFileResources=j&&j.length?j:void 0,fe}commonQueryFromFileList(T){const b=[],E=new S.ResourceMap,F={};let L=!1;return T.forEach(K=>{var fe,j;if(K.scheme!==D.Schemas.walkThrough)if((0,C.isAbsolutePath)(K)){const ee=(j=(fe=this.workspaceContextService.getWorkspaceFolder(K))===null||fe===void 0?void 0:fe.uri)!==null&&j!==void 0?j:K.with({path:y.dirname(K.fsPath)});let O=E.get(ee);O||(L=!0,O={folder:ee,includePattern:{}},b.push(O),E.set(ee,O));const R=y.relative(ee.fsPath,K.fsPath);(0,I.assertIsDefined)(O.includePattern)[R.replace(/\\/g,"/")]=!0}else K.fsPath&&(L=!0,F[K.fsPath]=!0)}),{folderQueries:b,includePattern:F,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(T,b){if(b.isSmartCase){if(T.isRegExp){if(i.containsUppercaseCharacter(T.pattern,!0))return!0}else if(i.containsUppercaseCharacter(T.pattern))return!0}return!!T.isCaseSensitive}isMultiline(T){return T.isMultiline||T.isRegExp&&(0,d.isMultilineRegexSource)(T.pattern)||T.pattern.indexOf(`
`)>=0?!0:!!T.isMultiline}parseSearchPaths(T){const b=O=>y.isAbsolute(O)||/^\.\.?([\/\\]|$)/.test(O),F=(Array.isArray(T)?T:n(T)).map(O=>{const R=this.pathService.resolvedUserHome;return R?(0,A.untildify)(O,R.scheme===D.Schemas.file?R.fsPath:R.path):O}),L=k.groupBy(F,O=>b(O)?"searchPaths":"exprSegments"),K=(L.exprSegments||[]).map(O=>i.rtrim(O,"/")).map(O=>i.rtrim(O,"\\")).map(O=>(O[0]==="."&&(O="*"+O),s(O))),fe={},j=this.expandSearchPathPatterns(L.searchPaths||[]);j&&j.length&&(fe.searchPaths=j);const H=w.flatten(K),ee=t(...H);return ee&&(fe.pattern=ee),fe}getExcludesForFolder(T,b){return b.disregardExcludeSettings?void 0:(0,m.getExcludes)(T,!b.disregardSearchExcludeSettings)}expandSearchPathPatterns(T){if(!T||!T.length)return[];const b=w.flatten(T.map(F=>{let{pathPortion:L,globPortion:K}=p(F);K&&(K=l(K));const fe=this.expandOneSearchPath(L);return w.flatten(fe.map(j=>this.resolveOneSearchPathPattern(j,K)))})),E=new Map;return b.forEach(F=>{const L=F.searchPath.toString(),K=E.get(L);K?F.pattern&&(K.pattern=K.pattern||{},K.pattern[F.pattern]=!0):E.set(L,{searchPath:F.searchPath,pattern:F.pattern?t(F.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(T){if(y.isAbsolute(T)){const b=this.workspaceContextService.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==D.Schemas.file?[{searchPath:b[0].uri.with({path:T})}]:[{searchPath:c.URI.file(y.normalize(T))}]}if(this.workspaceContextService.getWorkbenchState()===2){const b=this.workspaceContextService.getWorkspace().folders[0].uri;if(T=r(T),T.startsWith("../")||T===".."){const F=y.posix.resolve(b.path,T);return[{searchPath:b.with({path:F})}]}const E=l(T);return[{searchPath:b,pattern:E}]}else{if(T==="./"||T===".\\")return[];{const b=T.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(b){const E=b[1],F=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===E);if(F.length)return F.map(L=>{const K=b[2];return{searchPath:L.uri,pattern:K&&l(K)}});{const L=o.localize(0,null,E);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(T,b){const E=T.pattern&&b?`${T.pattern}/${b}`:T.pattern||b,F=[{searchPath:T.searchPath,pattern:E}];return E&&!E.endsWith("**")&&F.push({searchPath:T.searchPath,pattern:E+"/**"}),F}getFolderQueryForSearchPath(T,b,E){const F=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(T.searchPath),b,E,!1);return F?Object.assign(Object.assign({},F),{includePattern:T.pattern}):null}getFolderQueryForRoot(T,b,E,F){let L;const K=c.URI.isUri(T)?T:T.uri;if(E.searchPaths){const O=E.searchPaths.filter(R=>(0,C.isEqual)(R.searchPath,K))[0];if(O&&!O.pattern)return null;O&&(L=O.pattern)}const fe=this.configurationService.getValue({resource:K}),j=this.getExcludesForFolder(fe,b),H=Object.assign(Object.assign({},j||{}),L||{}),ee=c.URI.isUri(T)?(0,C.basename)(T):T.name;return{folder:K,folderName:F?ee:void 0,excludePattern:Object.keys(H).length>0?H:void 0,fileEncoding:fe.files&&fe.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!fe.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!fe.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!fe.search.followSymlinks}}};u=je([Ke(0,a.IConfigurationService),Ke(1,g.IWorkspaceContextService),Ke(2,h.IEditorGroupsService),Ke(3,_.IPathService)],u),e.QueryBuilder=u;function p(v){const T=v.match(/[\*\{\}\(\)\[\]\?]/);if(T){const b=T.index,E=v.substr(0,b).match(/[/|\\][^/\\]*$/);if(E){let F=v.substr(0,E.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:v.substr((E.index||0)+1)}}}return{pathPortion:v}}function t(...v){return v.length?v.reduce((T,b)=>(T[b]=!0,T),Object.create(null)):void 0}function n(v){return P.splitGlobAware(v,",").map(T=>T.trim()).filter(T=>!!T.length)}function s(v){return[`**/${v}/**`,`**/${v}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function r(v){return v.replace(/\\/g,"/")}function l(v){return r(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(v,T){v=w.distinct(v,F=>F.toString());const b=[],E=T.getWorkspace();return v&&v.forEach(F=>{let L;if(T.getWorkbenchState()===2)L=(0,C.relativePath)(E.folders[0].uri,F),L&&L!=="."&&(L="./"+L);else{const K=T.getWorkspaceFolder(F);if(K){const fe=K.name;if(E.folders.filter(H=>H.name===fe).length===1){const H=(0,C.relativePath)(K.uri,F);H===""?L=`./${K.name}`:L=`./${K.name}/${H}`}else L=F.fsPath}}L&&b.push(L)}),b}e.resolveResourcesForSearchIncludes=f}),define(be[220],we([0,1,25,2,20,12,4,219,41,48]),function(J,e,w,k,P,A,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(a,g){const h=g.activationEvents;if(!h)return Promise.resolve(void 0);const _=[],m=[];for(const r of h)if(/^workspaceContains:/.test(r)){const l=r.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||a.forceUsingSearch?m.push(l):_.push(l)}if(_.length===0&&m.length===0)return Promise.resolve(void 0);let u;const p=new Promise((r,l)=>{u=r}),t=r=>u({activationEvent:r}),n=Promise.all(_.map(r=>c(a,r,t))).then(()=>{}),s=d(a,g.identifier,m,t);return Promise.all([n,s]).then(()=>{u(void 0)}),p}e.checkActivateWorkspaceContainsExtension=I;async function c(a,g,h){for(const _ of a.folders)if(await a.exists(w.joinPath(k.URI.revive(_),g))){h(`workspaceContains:${g}`);return}}async function d(a,g,h,_){if(h.length===0)return Promise.resolve(void 0);const m=new P.CancellationTokenSource,u=a.checkExists(a.folders,h,m.token),p=setTimeout(async()=>{m.cancel(),_(`workspaceContainsTimeout:${h.join(",")}`)},i);let t=!1;try{t=await u}catch(n){A.isPromiseCanceledError(n)||A.onUnexpectedError(n)}m.dispose(),clearTimeout(p),t&&_(`workspaceContains:${h.join(",")}`)}function o(a,g,h,_){const m=a.get(S.IInstantiationService),u=a.get(y.ISearchService),t=m.createInstance(D.QueryBuilder).file(g.map(n=>(0,C.toWorkspaceFolder)(k.URI.revive(n))),{_reason:"checkExists",includePattern:h,exists:!0});return u.fileSearch(t,_).then(n=>!!n.limitHit,n=>A.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=o});var tt=this&&this.__classPrivateFieldSet||function(J,e,w,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,w):P?P.value=w:e.set(J,w),w},Me=this&&this.__classPrivateFieldGet||function(J,e,w,k){if(w==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?k:w==="a"?k.call(J):k?k.value:e.get(J)};define(be[35],we([0,1,132,14,80,25,11,6,22,2,19,5,34,185,78,30,33,183,12,26,18,23,161,7,67,4,27,79,15,65,70,40,3,220,74,162]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a,g,h,_,m,u,p,t,n,s,r,l,f,v,T,b,E,F,L,K,fe){"use strict";var j,H,ee;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let O=class Tn extends D.Disposable{constructor(U,Q,Y,ie,pe,Pe,Oe,Te,Be,x){super();this._onDidChangeRemoteConnectionData=this._register(new F.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Q,this._extHostContext=Y,this._initData=Oe,this._extHostWorkspace=ie,this._extHostConfiguration=pe,this._logService=Pe,this._extHostTunnelService=Be,this._extHostTerminalService=x,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._registry=new h.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new K.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=U.createChild(new T.ServiceCollection([o.IExtHostStorage,this._storage],[K.IExtHostSecretState,this._secretState]));const G=new Set;this._initData.hostExtensions.forEach(re=>G.add(m.ExtensionIdentifier.toKey(re))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(re,oe)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(re,oe)},actualActivateExtension:async(re,oe)=>{if(G.has(m.ExtensionIdentifier.toKey(re)))return await this._mainThreadExtensionsProxy.$activateExtension(re,oe),new d.HostExtension;const me=this._registry.getExtensionDescription(re);return this._activateExtension(me,oe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),P.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(U){_.onUnexpectedError(U)}}async deactivateAll(){let U=[];try{U=this._registry.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this._deactivate(pe))}catch(Q){}await Promise.all(U)}isActivated(U){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(U):!1}_activateByEvent(U,Q){return this._activator.activateByEvent(U,Q)}_activateById(U,Q){return this._activator.activateById(U,Q)}activateByIdWithErrors(U,Q){return this._activateById(U,Q).then(()=>{const Y=this._activator.getActivatedExtension(U);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(U=>this._registry)}getExtensionExports(U){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(U).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const U=y.TernarySearchTree.forPaths(),Q=this._registry.getAllExtensionDescriptions().map(Y=>{if(!!this._getEntryPoint(Y))return this._hostUtils.realpath(Y.extensionLocation.fsPath).then(ie=>U.set(C.URI.file(ie).fsPath,Y))});this._extensionPathIndex=Promise.all(Q).then(()=>U)}return this._extensionPathIndex}_deactivate(U){let Q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(U))return Q;const Y=this._activator.getActivatedExtension(U);if(!Y)return Q;try{typeof Y.module.deactivate=="function"&&(Q=Promise.resolve(Y.module.deactivate()).then(void 0,ie=>Promise.resolve(void 0)))}catch(ie){}try{(0,D.dispose)(Y.subscriptions)}catch(ie){}return Q}async _activateExtension(U,Q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier),this._doActivateExtension(U,Q).then(Y=>{const ie=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(U.identifier,ie.codeLoadingTime,ie.activateCallTime,ie.activateResolvedTime,Q),this._logExtensionActivationTimes(U,Q,"success",ie),Y},Y=>{throw this._logExtensionActivationTimes(U,Q,"failure"),Y})}_logExtensionActivationTimes(U,Q,Y,ie){const pe=R(U,Q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},pe),ie||{}),{outcome:Y}))}_doActivateExtension(U,Q){const Y=R(U,Q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const ie=this._getEntryPoint(U);if(!ie)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${U.identifier.value} ${JSON.stringify(Q)}`),this._logService.flush();const pe=new d.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this._loadCommonJSModule(U.identifier,(0,A.joinPath)(U.extensionLocation,ie),pe),this._loadExtensionContext(U)]).then(Pe=>(P.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),Tn._callActivate(this._logService,U.identifier,Pe[0],Pe[1],pe))).then(Pe=>(P.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),Pe))}_loadExtensionContext(U){const Q=new t.ExtensionGlobalMemento(U,this._storage),Y=new t.ExtensionMemento(U.identifier.value,!1,this._storage),ie=new fe.ExtensionSecrets(U,this._secretState),pe=U.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,Pe=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([Q.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Oe=this;let Te;return Object.freeze({globalState:Q,workspaceState:Y,secrets:ie,subscriptions:[],get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Be){return k.join(U.extensionLocation.fsPath,Be)},get storagePath(){var Be;return(Be=Oe._storagePath.workspaceValue(U))===null||Be===void 0?void 0:Be.fsPath},get globalStoragePath(){return Oe._storagePath.globalValue(U).fsPath},get logPath(){return k.join(Oe._initData.logsLocation.fsPath,U.identifier.value)},get logUri(){return C.URI.joinPath(Oe._initData.logsLocation,U.identifier.value)},get storageUri(){return Oe._storagePath.workspaceValue(U)},get globalStorageUri(){return Oe._storagePath.globalValue(U)},get extensionMode(){return pe},get extension(){return Te===void 0&&(Te=new N(Oe,U.identifier,U,Pe)),Te},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(U),Oe.extensionRuntime},get environmentVariableCollection(){return Oe._extHostTerminalService.getEnvironmentVariableCollection(U)}})})}static _callActivate(U,Q,Y,ie,pe){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(U,Q,Y,ie,pe).then(Pe=>new d.ActivatedExtension(!1,null,pe.build(),Y,Pe,ie.subscriptions))}static _callActivateOptional(U,Q,Y,ie,pe){if(typeof Y.activate=="function")try{pe.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const Pe=typeof global=="object"?global:self,Oe=Y.activate.apply(Pe,[ie]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(Oe).then(Te=>(pe.activateResolveStop(),Te))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(Y)}_activateOneStartupFinished(U,Q){this._activateById(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:Q}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(P.getMarks());for(const U of this._registry.getAllExtensionDescriptions())if(U.activationEvents)for(const Q of U.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(U,Q)}_handleEagerExtensions(){const U=this._activateByEvent("*",!0).then(void 0,pe=>{this._logService.error(pe)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(pe=>this._handleWorkspaceContainsEagerExtensions(pe.added)));const Q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(Q),ie=Promise.all([U,Y]).then(()=>{});return Promise.race([ie,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ie}_handleWorkspaceContainsEagerExtensions(U){return U.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Q=>this._handleWorkspaceContainsEagerExtension(U,Q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(U,Q){if(!this.isActivated(Q.identifier)){const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ie={folders:U.map(Pe=>Pe.uri),forceUsingSearch:Y,exists:Pe=>this._hostUtils.exists(Pe.fsPath),checkExists:(Pe,Oe,Te)=>this._mainThreadWorkspaceProxy.$checkExists(Pe,Oe,Te)},pe=await(0,L.checkActivateWorkspaceContainsExtension)(ie,Q);if(!!pe)return this._activateById(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:pe.activationEvent}).then(void 0,Pe=>this._logService.error(Pe))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(U){throw console.error(U),U}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:Q}=this._initData.environment;if(!U||!Q||Q.scheme!==u.Schemas.file)throw new Error(w.localize(0,null));const Y=(0,A.originalFSPath)(Q),ie=await this._loadCommonJSModule(null,Q,new d.ExtensionActivationTimesBuilder(!1));if(!ie||typeof ie.run!="function")throw new Error(w.localize(1,null,Y));return new Promise((pe,Pe)=>{const Oe=(Be,x)=>{Be?Pe(Be):pe(typeof x=="number"&&x>0?1:0)},Te=ie.run(Y,Oe);Te&&Te.then&&Te.then(()=>{pe(0)}).catch(Be=>{Pe(Be.toString())})})}async $extensionTestsExit(U){this._logService.info(`extension host terminating: test runner requested exit with code ${U}`),this._logService.info(`exiting with code ${U}`),this._logService.flush(),this._hostUtils.exit(U)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(U,Q){return this._resolvers[U]=Q,(0,D.toDisposable)(()=>{delete this._resolvers[U]})}async $resolveAuthority(U,Q){const Y=U.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const ie=U.substr(0,Y);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ie}`,!1);const pe=this._resolvers[ie];if(!pe)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ie}.`,detail:void 0}};try{P.mark(`code/extHost/willResolveAuthority/${ie}`);const Pe=await pe.resolve(U,{resolveAttempt:Q});P.mark(`code/extHost/didResolveAuthorityOK/${ie}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(pe));const Oe={authority:U,host:Pe.host,port:Pe.port,connectionToken:Pe.connectionToken},Te={extensionHostEnv:Pe.extensionHostEnv,trust:Pe.trust};return{type:"ok",value:{authority:Oe,options:Te,tunnelInformation:{environmentTunnels:Pe.environmentTunnels}}}}catch(Pe){if(P.mark(`code/extHost/didResolveAuthorityError/${ie}`),Pe instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:Pe._code,message:Pe._message,detail:Pe._detail}};throw Pe}}$startExtensionHost(U){return this._registry.keepOnly(U),this._startExtensionHost()}$activateByEvent(U,Q){return Q===1?this._activateByEvent(U,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(U,!1))}async $activate(U,Q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(U)?(await this._activateById(U,Q),!0):!1}async $deltaExtensions(U,Q){U.forEach(ie=>ie.extensionLocation=C.URI.revive(ie.extensionLocation));const Y=await this.getExtensionPathIndex();return await Promise.all(Q.map(async ie=>{const pe=this._registry.getExtensionDescription(ie);if(!!pe){const Pe=await this._hostUtils.realpath(pe.extensionLocation.fsPath);Y.delete(C.URI.file(Pe).fsPath)}})),await Promise.all(U.map(async ie=>{const pe=await this._hostUtils.realpath(ie.extensionLocation.fsPath);Y.set(C.URI.file(pe).fsPath,ie)})),this._registry.deltaExtensions(U,Q),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){let Q=p.VSBuffer.alloc(U),Y=Math.random()%256;for(let ie=0;ie<U;ie++)Q.writeUInt8(Y,ie);return Q}async $updateRemoteConnectionData(U){this._remoteConnectionData=U,this._onDidChangeRemoteConnectionData.fire()}};O=je([Ke(0,r.IInstantiationService),Ke(1,e.IHostUtils),Ke(2,v.IExtHostRpcService),Ke(3,a.IExtHostWorkspace),Ke(4,c.IExtHostConfiguration),Ke(5,i.ILogService),Ke(6,l.IExtHostInitDataService),Ke(7,f.IExtensionStoragePaths),Ke(8,b.IExtHostTunnelService),Ke(9,E.IExtHostTerminalService)],O),e.AbstractExtHostExtensionService=O;function R($,U){return{id:$.identifier.value,name:$.name,extensionVersion:$.version,publisherDisplayName:$.publisher,activationEvents:$.activationEvents?$.activationEvents.join(","):null,isBuiltin:$.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class N{constructor(U,Q,Y,ie){j.set(this,void 0),H.set(this,void 0),ee.set(this,void 0),tt(this,j,U,"f"),tt(this,H,Q,"f"),tt(this,ee,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=k.normalize((0,A.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=ie}get isActive(){return Me(this,j,"f").isActivated(Me(this,ee,"f"))}get exports(){if(this.packageJSON.api!=="none")return Me(this,j,"f").getExtensionExports(Me(this,ee,"f"))}activate(){return Me(this,j,"f").activateByIdWithErrors(Me(this,ee,"f"),{startup:!1,extensionId:Me(this,H,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=N,j=new WeakMap,H=new WeakMap,ee=new WeakMap}),define(be[103],we([0,1,14,2,3,11,5,7,169,30,35,39,173,34,170,15,4,10,46]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a,g,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,g.createDecorator)("IExtHostDebugService");let m=class{constructor(f,v,T,b,E){this._workspaceService=v,this._extensionService=T,this._editorsService=b,this._configurationService=E,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new P.Emitter,this._onDidTerminateDebugSession=new P.Emitter,this._onDidChangeActiveDebugSession=new P.Emitter,this._onDidReceiveDebugSessionCustomEvent=new P.Emitter,this._debugServiceProxy=f.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new P.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new p(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(L=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(f,v){const T=f;if(typeof T.sourceReference=="number"&&T.sourceReference>0){let b=`debug:${encodeURIComponent(T.path||"")}`,E="?";return v&&(b+=`${E}session=${encodeURIComponent(v.id)}`,E="&"),b+=`${E}ref=${T.sourceReference}`,k.URI.parse(b)}else{if(T.path)return k.URI.file(T.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const v=[];for(const T of f.getAllExtensionDescriptions())if(T.contributes){const b=T.contributes.debuggers;if(b&&b.length>0)for(const E of b)(0,o.isDebuggerMainContribution)(E)&&v.push(E.type)}this._debugServiceProxy.$registerDebugTypes(v)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const f=[];return this._breakpoints.forEach(v=>f.push(v)),f}addBreakpoints(f){this.startBreakpoints();const v=f.filter(E=>{const F=E.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,E),!0)});this.fireBreakpointChanges(v,[],[]);const T=[],b=new Map;for(const E of v)if(E instanceof D.SourceBreakpoint){let F=b.get(E.location.uri.toString());F||(F={type:"sourceMulti",uri:E.location.uri,lines:[]},b.set(E.location.uri.toString(),F),T.push(F)),F.lines.push({id:E.id,enabled:E.enabled,condition:E.condition,hitCondition:E.hitCondition,logMessage:E.logMessage,line:E.location.range.start.line,character:E.location.range.start.character})}else E instanceof D.FunctionBreakpoint&&T.push({type:"function",id:E.id,enabled:E.enabled,hitCondition:E.hitCondition,logMessage:E.logMessage,condition:E.condition,functionName:E.functionName});return this._debugServiceProxy.$registerBreakpoints(T)}removeBreakpoints(f){this.startBreakpoints();const v=f.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],v,[]);const T=v.filter(F=>F instanceof D.SourceBreakpoint).map(F=>F.id),b=v.filter(F=>F instanceof D.FunctionBreakpoint).map(F=>F.id),E=v.filter(F=>F instanceof D.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(T,b,E)}startDebugging(f,v,T){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,v,{parentSessionID:T.parentSession?T.parentSession.id:void 0,repl:T.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:T.noDebug,compact:T.compact})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,v,T){if(!v)return new D.Disposable(()=>{});const b=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:b,provider:v}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,T,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,b),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(E=>E.provider!==v),this._debugServiceProxy.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(f,v,T){if(!T)return new D.Disposable(()=>{});if(!this.definesDebugType(f,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.getAdapterDescriptorFactoryByType(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:v,handle:b,factory:T}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(v,b),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(E=>E.factory!==T),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(f,v){if(!v)return new D.Disposable(()=>{});const T=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:T,factory:v}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(b=>b.factory!==v)})}async $runInTerminal(f,v){return Promise.resolve(void 0)}async $substituteVariables(f,v){if(!this._variableResolver){const[E,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(E||[],this._editorsService,F)}let T;const b=await this.getFolder(f);return b&&(T={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(T,v)}createDebugAdapter(f,v){if(f.type==="implementation")return new s(f.implementation)}createSignService(){}async $startDASession(f,v){const T=this,b=await this.getSession(v);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(b.type),b).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const F=this.convertToDto(E),L=this.createDebugAdapter(F,b);if(!L)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const K=L;return this._debugAdapters.set(f,K),this.getDebugAdapterTrackers(b).then(fe=>(fe&&this._debugAdaptersTrackers.set(f,fe),K.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const H=j,ee={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const O=await this._signService.sign(H.arguments.value);ee.body={signature:O},K.sendResponse(ee)}else throw new Error("no signer")}catch(O){ee.success=!1,ee.message=O.message,K.sendResponse(ee)}}else fe&&fe.onDidSendMessage&&fe.onDidSendMessage(j),j=(0,o.convertToVSCPaths)(j,!0),T._debugServiceProxy.$acceptDAMessage(f,j)}),K.onError(j=>{fe&&fe.onError&&fe.onError(j),this._debugServiceProxy.$acceptDAError(f,j.name,j.message,j.stack)}),K.onExit(j=>{fe&&fe.onExit&&fe.onExit((0,h.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(f,(0,h.withNullAsUndefined)(j),void 0)}),fe&&fe.onWillStartSession&&fe.onWillStartSession(),K.startSession()))})}$sendDAMessage(f,v){v=(0,o.convertToDAPaths)(v,!1);const T=this._debugAdaptersTrackers.get(f);T&&T.onWillReceiveMessage&&T.onWillReceiveMessage(v);const b=this._debugAdapters.get(f);b&&b.sendMessage(v)}$stopDASession(f){const v=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),v&&v.onWillStopSession&&v.onWillStopSession();const T=this._debugAdapters.get(f);return this._debugAdapters.delete(f),T?T.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const v=[],T=[],b=[];if(f.added)for(const E of f.added){const F=E.id;if(F&&!this._breakpoints.has(F)){let L;if(E.type==="function")L=new D.FunctionBreakpoint(E.functionName,E.enabled,E.condition,E.hitCondition,E.logMessage);else if(E.type==="data")L=new D.DataBreakpoint(E.label,E.dataId,E.canPersist,E.enabled,E.hitCondition,E.condition,E.logMessage);else{const K=k.URI.revive(E.uri);L=new D.SourceBreakpoint(new D.Location(K,new D.Position(E.line,E.character)),E.enabled,E.condition,E.hitCondition,E.logMessage)}L._id=F,this._breakpoints.set(F,L),v.push(L)}}if(f.removed)for(const E of f.removed){const F=this._breakpoints.get(E);F&&(this._breakpoints.delete(E),T.push(F))}if(f.changed){for(const E of f.changed)if(E.id){const F=this._breakpoints.get(E.id);if(F){if(F instanceof D.FunctionBreakpoint&&E.type==="function"){const L=F;L.enabled=E.enabled,L.condition=E.condition,L.hitCondition=E.hitCondition,L.logMessage=E.logMessage,L.functionName=E.functionName}else if(F instanceof D.SourceBreakpoint&&E.type==="source"){const L=F;L.enabled=E.enabled,L.condition=E.condition,L.hitCondition=E.hitCondition,L.logMessage=E.logMessage,L.location=new D.Location(k.URI.revive(E.uri),new D.Position(E.line,E.character))}b.push(F)}}}this.fireBreakpointChanges(v,T,b)}$provideDebugConfigurations(f,v,T){return(0,A.asPromise)(async()=>{const b=this.getConfigProviderByHandle(f);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const E=await this.getFolder(v);return b.provideDebugConfigurations(E,T)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(f,v,T,b){return(0,A.asPromise)(async()=>{const E=this.getConfigProviderByHandle(f);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(v);return E.resolveDebugConfiguration(F,T,b)})}$resolveDebugConfigurationWithSubstitutedVariables(f,v,T,b){return(0,A.asPromise)(async()=>{const E=this.getConfigProviderByHandle(f);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(v);return E.resolveDebugConfigurationWithSubstitutedVariables(F,T,b)})}async $provideDebugAdapter(f,v){const T=this.getAdapterDescriptorFactoryByHandle(f);if(!T)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.getSession(v);return this.getAdapterDescriptor(T,b).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.convertToDto(E)})}async $acceptDebugSessionStarted(f){const v=await this.getSession(f);this._onDidStartDebugSession.fire(v)}async $acceptDebugSessionTerminated(f){const v=await this.getSession(f);v&&(this._onDidTerminateDebugSession.fire(v),this._debugSessions.delete(v.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,v){const T=await this.getSession(f);T&&T._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(f,v){const b={session:await this.getSession(f),event:v.event,body:v.body};this._onDidReceiveDebugSessionCustomEvent.fire(b)}convertToDto(f){if(f instanceof D.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof D.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const v=this._adapterFactories.filter(T=>T.type===f);if(v.length>0)return v[0].factory}getAdapterDescriptorFactoryByHandle(f){const v=this._adapterFactories.filter(T=>T.handle===f);if(v.length>0)return v[0].factory}getConfigProviderByHandle(f){const v=this._configProviders.filter(T=>T.handle===f);if(v.length>0)return v[0].provider}definesDebugType(f,v){if(f.contributes){const T=f.contributes.debuggers;if(T&&T.length>0){for(const b of T)if(b.label&&b.type&&b.type===v)return!0}}return!1}getDebugAdapterTrackers(f){const T=f.configuration.type,b=this._trackerFactories.filter(E=>E.type===T||E.type==="*").map(E=>(0,A.asPromise)(()=>E.factory.createDebugAdapterTracker(f)).then(F=>F,F=>null));return Promise.race([Promise.all(b).then(E=>{const F=E.filter(L=>!!L);if(F.length>0)return new n(F)}),new Promise((E,F)=>{const L=setTimeout(()=>{clearTimeout(L),F(new Error("timeout"))},1e3)})]).catch(E=>{})}async getAdapterDescriptor(f,v){const T=v.configuration.debugServer;if(typeof T=="number")return Promise.resolve(new D.DebugAdapterServer(T));if(f){const E=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>f.createDebugAdapterDescriptor(v,this.daExecutableFromPackage(v,E))).then(F=>{if(F)return F})}const b=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(v,b))}daExecutableFromPackage(f,v){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(f,v,T){(f.length>0||v.length>0||T.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:v,changed:T}))}async getSession(f){if(f)if(typeof f=="string"){const v=this._debugSessions.get(f);if(v)return v}else{let v=this._debugSessions.get(f.id);if(!v){const T=await this.getFolder(f.folderUri);v=new u(this._debugServiceProxy,f.id,f.type,f.name,T,f.configuration),this._debugSessions.set(v.id,v),this._debugServiceProxy.$sessionCached(v.id)}return v}throw new Error("cannot find session")}getFolder(f){if(f){const v=k.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}};m=je([Ke(0,a.IExtHostRpcService),Ke(1,C.IExtHostWorkspace),Ke(2,i.IExtHostExtensionService),Ke(3,I.IExtHostDocumentsAndEditors),Ke(4,d.IExtHostConfiguration)],m),e.ExtHostDebugServiceBase=m;class u{constructor(f,v,T,b,E,F){this._debugServiceProxy=f,this._id=v,this._type=T,this._name=b,this._workspaceFolder=E,this._configuration=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,v){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,v)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=u;class p{constructor(f){this.value=Object.freeze({append(v){f.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.ExtHostDebugConsole=p;class t extends c.AbstractVariableResolverService{constructor(f,v,T,b){super({getFolderUri:E=>{const F=f.filter(L=>L.name===E);if(F&&F.length>0)return F[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(E,F)=>T.getConfiguration(void 0,E).get(F),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(v){const E=v.activeEditor();if(E)return w.normalize(E.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(v&&b){const E=v.activeEditor();if(E){const F=b.getWorkspaceFolder(E.document.uri);if(F)return w.normalize(F.uri.fsPath)}}},getSelectedText:()=>{if(v){const E=v.activeEditor();if(E&&!E.selection.isEmpty)return E.document.getText(E.selection)}},getLineNumber:()=>{if(v){const E=v.activeEditor();if(E)return String(E.selection.end.line+1)}}},void 0,_.env)}}e.ExtHostVariableResolverService=t;class n{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(v=>v.onError?v.onError(f):void 0)}onExit(f,v){this.trackers.forEach(T=>T.onExit?T.onExit(f,v):void 0)}}class s extends y.AbstractDebugAdapter{constructor(f){super();this.implementation=f,f.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends m{constructor(f,v,T,b,E){super(f,v,T,b,E)}createVariableResolver(f,v,T){return new t(f,v,T)}};r=je([Ke(0,a.IExtHostRpcService),Ke(1,C.IExtHostWorkspace),Ke(2,i.IExtHostExtensionService),Ke(3,I.IExtHostDocumentsAndEditors),Ke(4,d.IExtHostConfiguration)],r),e.WorkerExtHostDebugService=r}),define(be[221],we([0,1,80,2,5,34,33,26,15,27,4,35,46,19]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(m,u,p,t,n,s,r){this._apiFactory=m,this._extensionRegistry=u,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),w.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,u,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(h,u,this._initData.environment.appUriScheme))}register(m){if(Array.isArray(m.nodeModuleName))for(let u of m.nodeModuleName)this._factories.set(u,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(u=>m.alternativeModuleName(u))}};o=je([Ke(2,i.IInstantiationService),Ke(3,A.IExtHostConfiguration),Ke(4,I.IExtHostExtensionService),Ke(5,C.IExtHostInitDataService),Ke(6,d.ILogService)],o),e.RequireInterceptor=o;class a{constructor(m,u,p,t,n){this._apiFactory=m,this._extensionPaths=u,this._extensionRegistry=p,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,u){const p=this._extensionPaths.findSubstr(u.fsPath);if(p){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(m,u){this.nodeModuleName="keytar";const{environment:p}=u,t=m.getProxy(P.MainContext.MainThreadKeytar);if(p.appRoot){let n=p.appRoot.fsPath;c.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,r)=>t.$setPassword(n,s,r),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(m,u){return this._impl}alternativeModuleName(m){const u=m.length;if(!(u<=7||!this.alternativeNames)){const p=u-7;if((m.charAt(p)==="/"||m.charAt(p)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}}};g=je([Ke(0,y.IExtHostRpcService),Ke(1,C.IExtHostInitDataService)],g);let h=class{constructor(m,u,p){this._extensionPaths=m,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(P.MainContext.MainThreadTelemetry);const t=p.getProxy(P.MainContext.MainThreadWindow);this._impl=(n,s)=>{const r=k.URI.parse(n);return s?this.callOriginal(n,s):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,s)}}load(m,u,p){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(m),this._impl}callOriginal(m,u){return this.sendNoForwardTelemetry(),this._original(m,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};h=je([Ke(2,y.IExtHostRpcService)],h)}),define(be[222],we([0,1,11,12,80,6,2,5,214,19,61,65,27,151,15,71,35,40]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(u,p,t,n){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const s=new y.RPCProtocol(u,null,n);p=_._transform(p,s);const r=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(c.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},p)),r.set(o.IExtHostRpcService,new o.ExtHostRpcService(s)),r.set(a.IURITransformerService,new a.URITransformerService(n)),r.set(g.IHostUtils,t);const l=new d.InstantiationService(r,!0),f=l.invokeFunction(E=>E.get(h.IExtHostTerminalService));this._disposables.add(f),this._logService=l.invokeFunction(E=>E.get(C.ILogService)),P.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=l.invokeFunction(E=>E.get(g.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(E=>{Error.prepareStackTrace=(F,L)=>{let K="",fe,j;for(const H of L)K+=`
	at ${H.toString()}`,j=H.getFileName(),!fe&&j&&(fe=E.findSubstr(j));return v.set(F,fe),`${F.name||"Error"}: ${F.message||""}${K}`}});const T=s.getProxy(D.MainContext.MainThreadExtensionService),b=s.getProxy(D.MainContext.MainThreadErrors);k.setUnexpectedErrorHandler(E=>{const F=k.transformErrorForSerialization(E),L=v.get(E);L?T.$onExtensionRuntimeError(L.identifier,F):b.$onUnexpectedError(F)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),k.setUnexpectedErrorHandler(t=>{});const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,w.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,p){u.extensions.forEach(n=>n.extensionLocation=S.URI.revive(p.transformIncomingURIs(n.extensionLocation))),u.environment.appRoot=S.URI.revive(p.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(n=>S.URI.revive(p.transformIncomingURIs(n)))),u.environment.extensionTestsLocationURI=S.URI.revive(p.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=S.URI.revive(p.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=S.URI.revive(p.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=S.URI.revive(p.transformIncomingURIs(u.logsLocation)),u.logFile=S.URI.revive(p.transformIncomingURIs(u.logFile)),u.workspace=p.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=_}),define(be[223],we([0,1,14,20,60,28,25,55,41]),function(J,e,w,k,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(c,d,o){this.config=c,this.provider=d,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&A.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&A.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const d=this.config.folderQueries||[];return new Promise((o,a)=>{const g=h=>{this.resultCount++,c(h)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(h=>{const _=h.toString(),m=w.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,m)||this.matchFile(g,{base:h,basename:m})}),Promise.all(d.map(h=>this.searchInFolder(h,g))).then(h=>{o({limitHit:this.isLimitHit,stats:h[0]||void 0})},h=>{a(new Error((0,P.toErrorMessage)(h)))})})}async searchInFolder(c,d){const o=new k.CancellationTokenSource,a=this.getSearchOptionsForFolder(c),g=this.initDirectoryTree(),h=new y.QueryGlobTester(this.config,c),_=!h.hasSiblingExcludeClauses();let m;try{this.activeCancellationTokens.add(o),m=D.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,o.token),p=m.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(n=>{const s=w.posix.relative(c.folder.path,n.path);if(_){const r=w.basename(n.path);this.matchFile(d,{base:c.folder,relativePath:s,basename:r});return}this.addDirectoryEntries(g,c.folder,s,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,h,d),{providerTime:p,postProcessTime:t.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(c){const d=(0,y.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),o=(0,y.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:o,includes:d,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},d,o,a){if(o===this.filePattern){const h=w.basename(this.filePattern);this.matchFile(a,{base:d,relativePath:this.filePattern,basename:h})}function g(h){const _=w.basename(h),m=w.dirname(h);let u=c[m];u||(u=c[m]=[],g(m)),u.push({base:d,relativePath:h,basename:_})}g(o)}matchDirectoryTree({rootEntries:c,pathToEntries:d},o,a){const g=this,h=this.filePattern;function _(m){const u=A.hasSiblingFn(()=>m.map(p=>p.basename));for(let p=0,t=m.length;p<t;p++){const n=m[p],{relativePath:s,basename:r}=n;if(!!o.includedInQuerySync(s,r,h!==r?u:void 0)){const l=d[s];if(l)_(l);else{if(s===h)continue;g.matchFile(a,n)}if(g.isLimitHit)break}}}_(c)}matchFile(c,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(d))}}class i{constructor(){this.sessions=new Map}fileSearch(c,d,o,a){const g=this.getSessionTokenSource(c.cacheKey),h=new C(c,d,g&&g.token);let _=0;const m=u=>{_+=u.length,o(u.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(h,i.BATCH_SIZE,m,a).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:u.stats}}))}clearCache(c){const d=this.getSessionTokenSource(c);d&&d.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new k.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:S.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,d,o,a){a.onCancellationRequested(()=>{c.cancel()});const g=_=>{_&&(h.push(_),d>0&&h.length>=d&&(o(h),h=[]))};let h=[];return c.search(g).then(_=>(h.length&&o(h),_),_=>(h.length&&o(h),Promise.reject(_)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(be[224],we([0,1,14,13,20,60,25,28,2,41,18]),function(J,e,w,k,P,A,S,D,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class I{constructor(_,m,u){this.query=_,this.provider=m,this.fileUtils=u,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(_,m){const u=this.query.folderQueries||[],p=new P.CancellationTokenSource;return m.onCancellationRequested(()=>p.cancel()),new Promise((t,n)=>{this.collector=new d(_);let s=!1;const r=(l,f)=>{if(!s&&!this.isLimitHit){const v=this.resultSize(l);a(l)&&typeof this.query.maxResults=="number"&&this.resultCount+v>this.query.maxResults&&(this.isLimitHit=!0,s=!0,p.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const T=this.resultSize(l);this.resultCount+=T,(T>0||!a(l))&&this.collector.add(l,f)}};Promise.all(u.map((l,f)=>this.searchInFolder(l,v=>r(v,f),p.token))).then(l=>{p.dispose(),this.collector.flush();const f=l.some(v=>!!v&&!!v.limitHit);t({limitHit:this.isLimitHit||f,stats:{type:"textSearchProvider"}})},l=>{p.dispose();const f=(0,A.toErrorMessage)(l);n(new Error(f))})})}resultSize(_){return a(_)?Array.isArray(_.ranges)?_.ranges.length:1:0}trimResultToSize(_,m){const u=Array.isArray(_.ranges)?_.ranges:[_.ranges],p=Array.isArray(_.preview.matches)?_.preview.matches:[_.preview.matches];return{ranges:u.slice(0,m),preview:{matches:p.slice(0,m),text:_.preview.text},uri:_.uri}}async searchInFolder(_,m,u){const p=new C.QueryGlobTester(this.query,_),t=[],n={report:l=>{if(!!this.validateProviderResult(l)){const f=_.folder.scheme===i.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(l.uri))):void 0,v=S.relativePath(_.folder,l.uri);v&&t.push(p.includedInQuery(v,w.basename(v),f).then(T=>{T&&m(l)}))}}},s=this.getSearchOptionsForFolder(_),r=await this.provider.provideTextSearchResults(c(this.query.contentPattern),s,n,u);return await Promise.all(t),r}validateProviderResult(_){if(a(_)){if(Array.isArray(_.ranges)){if(!Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(_.preview.matches.length!==_.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(_){const m=(0,C.resolvePatternsForProvider)(this.query.includePattern,_.includePattern),u=(0,C.resolvePatternsForProvider)(this.query.excludePattern,_.excludePattern),p={folder:y.URI.from(_.folder),excludes:u,includes:m,useIgnoreFiles:!_.disregardIgnoreFiles,useGlobalIgnoreFiles:!_.disregardGlobalIgnoreFiles,followSymlinks:!_.ignoreSymlinks,encoding:_.fileEncoding&&this.fileUtils.toCanonicalName(_.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return p.usePCRE2=this.query.usePCRE2,p}}e.TextSearchManager=I;function c(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class d{constructor(_){this._onResult=_,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,m=>this.sendItems(m))}add(_,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!S.isEqual(this._currentUri,_.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:_.uri,results:[]}),this._currentFileMatch.results.push(o(_))}pushToCollector(){const _=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,_)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(_){this._onResult(_)}}e.TextSearchResultsCollector=d;function o(h){return a(h)?{preview:{matches:(0,k.mapArrayOrNot)(h.preview.matches,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character})),text:h.preview.text},ranges:(0,k.mapArrayOrNot)(h.ranges,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function a(h){return!!h.preview}e.extensionResultIsMatch=a;class g{constructor(_,m){this.maxBatchSize=_,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(_,m){!_||this.addItemToBatch(_,m)}addItems(_,m){!_||this.addItemsToBatch(_,m)}addItemToBatch(_,m){this.batch.push(_),this.batchSize+=m,this.onUpdate()}addItemsToBatch(_,m){this.batch=this.batch.concat(_),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(be[104],we([0,1,6,5,4,223,15,71,19,2,224]),function(J,e,w,k,P,A,S,D,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,P.createDecorator)("IExtHostSearch");let I=class{constructor(a,g,h){this.extHostRpc=a,this._uriTransformer=g,this._logService=h,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,g){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const h=this._handlePool++;return this._textSearchProvider.set(h,g),this._proxy.$registerTextSearchProvider(h,this._transformScheme(a)),(0,w.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}registerFileSearchProvider(a,g){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const h=this._handlePool++;return this._fileSearchProvider.set(h,g),this._proxy.$registerFileSearchProvider(h,this._transformScheme(a)),(0,w.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(a,g,h,_){const m=c(h),u=this._fileSearchProvider.get(a);if(u)return this._fileSearchManager.fileSearch(m,u,p=>{this._proxy.$handleFileMatch(a,g,p.map(t=>t.resource))},_);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,g,h,_){const m=this._textSearchProvider.get(a);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const u=c(h);return this.createTextSearchManager(u,m).search(t=>this._proxy.$handleTextMatch(a,g,t),_)}createTextSearchManager(a,g){return new i.TextSearchManager(a,g,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h})}};I=je([Ke(0,S.IExtHostRpcService),Ke(1,D.IURITransformerService),Ke(2,y.ILogService)],I),e.ExtHostSearch=I;function c(o){return Object.assign(Object.assign({},o),{folderQueries:o.folderQueries&&o.folderQueries.map(d),extraFileResources:o.extraFileResources&&o.extraFileResources.map(a=>C.URI.revive(a))})}e.reviveQuery=c;function d(o){return Object.assign(Object.assign({},o),{folder:C.URI.revive(o.folder)})}}),define(be[225],we([0,1,129,20,12,3,47,2,122,85,116,59,64,5,190,189,76,191,34,192,193,194,176,195,39,35,196,177,198,199,200,100,180,203,204,205,78,40,206,181,9,7,209,50,101,30,33,51,166,197,93,99,102,103,104,19,71,15,27,201,164,70,75,187,207,163,79,77,212,210,211,188,49,218,208,74,160,94,202,67]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a,g,h,_,m,u,p,t,n,s,r,l,f,v,T,b,E,F,L,K,fe,j,H,ee,O,R,N,$,U,Q,Y,ie,pe,Pe,Oe,Te,Be,x,G,re,oe,me,De,Ne,ge,Ce,Ae,$e,_e,qe,z,te,ve,Ue,He,xe,Ye,W,se,de,q,Z,le,he,Ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ve(Fe){const We=Fe.get(Ne.IExtHostInitDataService),Qe=Fe.get(W.IExtHostFileSystemInfo),it=Fe.get(ve.IExtHostConsumerFileSystem),lt=Fe.get(r.IExtHostExtensionService),Ze=Fe.get(Y.IExtHostWorkspace),nt=Fe.get(le.IExtHostTelemetry),ht=Fe.get(_.IExtHostConfiguration),wt=Fe.get(me.IURITransformerService),ue=Fe.get(De.IExtHostRpcService),Se=Fe.get(j.IExtHostStorage),ae=Fe.get(te.IExtensionStoragePaths),V=Fe.get(oe.ILogService),Le=Fe.get(Ae.IExtHostTunnelService),Ie=Fe.get($e.IExtHostApiDeprecationService),Xe=Fe.get(Q.IExtHostWindow),et=Fe.get(q.IExtHostSecretState);ue.set(d.ExtHostContext.ExtHostFileSystemInfo,Qe),ue.set(d.ExtHostContext.ExtHostLogService,V),ue.set(d.ExtHostContext.ExtHostWorkspace,Ze),ue.set(d.ExtHostContext.ExtHostConfiguration,ht),ue.set(d.ExtHostContext.ExtHostExtensionService,lt),ue.set(d.ExtHostContext.ExtHostStorage,Se),ue.set(d.ExtHostContext.ExtHostTunnelService,Le),ue.set(d.ExtHostContext.ExtHostWindow,Xe),ue.set(d.ExtHostContext.ExtHostSecretState,et),ue.set(d.ExtHostContext.ExtHostTelemetry,nt);const ct=ue.set(d.ExtHostContext.ExtHostDecorations,Fe.get(Be.IExtHostDecorations)),rt=ue.set(d.ExtHostContext.ExtHostDocumentsAndEditors,Fe.get(s.IExtHostDocumentsAndEditors)),Ge=ue.set(d.ExtHostContext.ExtHostCommands,Fe.get(g.IExtHostCommands)),ft=ue.set(d.ExtHostContext.ExtHostTerminalService,Fe.get(H.IExtHostTerminalService)),at=ue.set(d.ExtHostContext.ExtHostDebugService,Fe.get(G.IExtHostDebugService)),vt=ue.set(d.ExtHostContext.ExtHostSearch,Fe.get(re.IExtHostSearch)),pt=ue.set(d.ExtHostContext.ExtHostTask,Fe.get(x.IExtHostTask)),Et=ue.set(d.ExtHostContext.ExtHostOutputService,Fe.get(E.IExtHostOutputService)),Dt=ue.set(d.ExtHostContext.ExtHostEditorTabs,new Z.ExtHostEditorTabs),It=ue.set(d.ExtHostContext.ExtHostUrls,new $.ExtHostUrls(ue)),bt=ue.set(d.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(ue,rt)),Pt=ue.set(d.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(ue,rt,V)),Gt=ue.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(V,bt,ue.getProxy(d.MainContext.MainThreadBulkEdits))),mt=ue.set(d.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(ue,Ge,rt,bt,V,ae)),Qt=ue.set(d.ExtHostContext.ExtHostNotebookKernels,new he.ExtHostNotebookKernels(ue,We,mt)),yt=ue.set(d.ExtHostContext.ExtHostEditors,new ee.ExtHostEditors(ue,rt)),Ht=ue.set(d.ExtHostContext.ExtHostTreeViews,new O.ExtHostTreeViews(ue.getProxy(d.MainContext.MainThreadTreeViews),Ge,V)),Jt=ue.set(d.ExtHostContext.ExtHostEditorInsets,new Pe.ExtHostEditorInsets(ue.getProxy(d.MainContext.MainThreadEditorInsets),yt,We.environment)),zt=ue.set(d.ExtHostContext.ExtHostDiagnostics,new m.ExtHostDiagnostics(ue,V)),ut=ue.set(d.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(ue,wt,bt,Ge,zt,V,Ie)),Yt=ue.set(d.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(ue,ut)),At=ue.set(d.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(ue,V,rt)),Nt=ue.set(d.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(ue,Ze,Ge)),cn=ue.set(d.ExtHostContext.ExtHostSCM,new K.ExtHostSCM(ue,Ge,V)),pn=ue.set(d.ExtHostContext.ExtHostComments,new h.ExtHostComments(ue,Ge,bt)),dn=ue.set(d.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(ue.getProxy(d.MainContext.MainThreadProgress))),Xt=ue.set(d.ExtHostContext.ExtHosLabelService,new Oe.ExtHostLabelService(ue)),Vt=ue.set(d.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(ue)),Mt=ue.set(d.ExtHostContext.ExtHostAuthentication,new _e.ExtHostAuthentication(ue)),vn=ue.set(d.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(ue,Ge)),Zt=ue.set(d.ExtHostContext.ExtHostWebviews,new U.ExtHostWebviews(ue,We.environment,Ze,V,Ie)),en=ue.set(d.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(ue,Zt,Ze)),jt=ue.set(d.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(ue,bt,ae,Zt,en)),bn=ue.set(d.ExtHostContext.ExtHostWebviewViews,new Ue.ExtHostWebviewViews(ue,Zt)),Tt=ue.set(d.ExtHostContext.ExtHostTesting,new se.ExtHostTesting(ue,rt,Ze)),tn=ue.set(d.ExtHostContext.ExtHostUriOpeners,new de.ExtHostUriOpeners(ue)),wn=(0,pe.values)(d.ExtHostContext);ue.assertRegistered(wn);const Ut=new Ye.ExtHostBulkEdits(ue,rt),nn=new a.ExtHostClipboard(ue),Ot=new b.ExtHostMessageService(ue,V),Rt=new u.ExtHostDialogs(ue),hn=new fe.ExtHostStatusBar(ue,Ge.converter),Bt=new T.ExtHostLanguages(ue,bt);return o.ExtHostApiCommands.register(Ge),function(Re,rn,sn){const gt=function(){let X=!Re.isUnderDevelopment;function ce(ke){X||(V.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(st){if(Array.isArray(st))st.forEach(ke);else if(typeof st=="string")ce(st);else{const B=st;typeof B.scheme=="undefined"&&ce(st),!Re.enableProposedApi&&typeof B.exclusive=="boolean"&&(0,ie.throwProposedApiError)(Re)}return st}}(),_n={getSession(X,ce,ke){return Mt.getSession(Re,X,ce,ke)},get onDidChangeSessions(){return Mt.onDidChangeSessions},registerAuthenticationProvider(X,ce,ke,st){return Mt.registerAuthenticationProvider(X,ce,ke,st)},get onDidChangeAuthenticationProviders(){return(0,ie.checkProposedApiEnabled)(Re),Mt.onDidChangeAuthenticationProviders},get providers(){return(0,ie.checkProposedApiEnabled)(Re),Mt.providers},logout(X,ce){return(0,ie.checkProposedApiEnabled)(Re),Mt.removeSession(X,ce)}},En={registerCommand(X,ce,ke){return Ge.registerCommand(!0,X,ce,ke)},registerTextEditorCommand(X,ce,ke){return Ge.registerCommand(!0,X,(...st)=>{const B=yt.getActiveTextEditor();if(!B){V.warn("Cannot execute "+X+" because there is no active text editor.");return}return B.edit(M=>{ce.apply(ke,[B,M,...st])}).then(M=>{M||V.warn("Edits from command "+X+" were not applied.")},M=>{V.warn("An error occurred while running command "+X,M)})})},registerDiffInformationCommand:(X,ce,ke)=>((0,ie.checkProposedApiEnabled)(Re),Ge.registerCommand(!0,X,async(...st)=>{const B=rt.activeEditor(!0);if(!B){V.warn("Cannot execute "+X+" because there is no active text editor.");return}const M=await yt.getDiffInformation(B.id);ce.apply(ke,[M,...st])})),executeCommand(X,...ce){return Ge.executeCommand(X,...ce)},getCommands(X=!1){return Ge.getCommands(X)}},qt={get machineId(){return We.telemetryInfo.machineId},get sessionId(){return We.telemetryInfo.sessionId},get language(){return We.environment.appLanguage},get appName(){return We.environment.appName},get appRoot(){var X,ce;return(ce=(X=We.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return We.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return ft.getDefaultShell(!1,sn)},get isTelemetryEnabled(){return nt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return nt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(We.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ce){return Xe.openUri(X,{allowTunneling:!!We.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},asExternalUri(X){return X.scheme===We.environment.appUriScheme?It.createAppUri(X):Xe.asExternalUri(X,{allowTunneling:!!We.remote.authority})},get remoteName(){return(0,Te.getRemoteName)(We.remote.authority)},get uiKind(){return We.uiKind}};We.environment.extensionTestsLocationURI||Object.freeze(qt);const fn=We.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,yn={registerTestController(X){return(0,ie.checkProposedApiEnabled)(Re),Tt.registerTestController(Re.identifier.value,X)},createDocumentTestObserver(X){return(0,ie.checkProposedApiEnabled)(Re),Tt.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return(0,ie.checkProposedApiEnabled)(Re),Tt.createWorkspaceTestObserver(X)},runTests(X){return(0,ie.checkProposedApiEnabled)(Re),Tt.runTests(X)},createTestItem(X,ce){return new N.TestItemImpl(X.id,X.label,X.uri,ce)},createTestRunTask(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),Tt.createTestRunTask(Re.identifier.value,X,ce,ke)},get onDidChangeTestResults(){return(0,ie.checkProposedApiEnabled)(Re),Tt.onResultsChanged},get testResults(){return(0,ie.checkProposedApiEnabled)(Re),Tt.results}},Sn={getExtension(X){const ce=rn.getExtensionDescription(X);if(ce)return new r.Extension(lt,Re.identifier,ce,fn)},get all(){return rn.getAllExtensionDescriptions().map(X=>new r.Extension(lt,Re.identifier,X,fn))},get onDidChange(){return rn.onDidChange}},Dn={createDiagnosticCollection(X){return zt.createDiagnosticCollection(Re.identifier,X)},get onDidChangeDiagnostics(){return zt.onDidChangeDiagnostics},getDiagnostics:X=>zt.getDiagnostics(X),getLanguages(){return Bt.getLanguages()},setTextDocumentLanguage(X,ce){return Bt.changeLanguage(X.uri,ce)},match(X,ce){return(0,I.score)(R.LanguageSelector.from(X),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(X,ce,ke){return ut.registerCodeActionProvider(Re,gt(X),ce,ke)},registerCodeLensProvider(X,ce){return ut.registerCodeLensProvider(Re,gt(X),ce)},registerDefinitionProvider(X,ce){return ut.registerDefinitionProvider(Re,gt(X),ce)},registerDeclarationProvider(X,ce){return ut.registerDeclarationProvider(Re,gt(X),ce)},registerImplementationProvider(X,ce){return ut.registerImplementationProvider(Re,gt(X),ce)},registerTypeDefinitionProvider(X,ce){return ut.registerTypeDefinitionProvider(Re,gt(X),ce)},registerHoverProvider(X,ce){return ut.registerHoverProvider(Re,gt(X),ce,Re.identifier)},registerEvaluatableExpressionProvider(X,ce){return ut.registerEvaluatableExpressionProvider(Re,gt(X),ce,Re.identifier)},registerInlineValuesProvider(X,ce){return ut.registerInlineValuesProvider(Re,gt(X),ce,Re.identifier)},registerDocumentHighlightProvider(X,ce){return ut.registerDocumentHighlightProvider(Re,gt(X),ce)},registerLinkedEditingRangeProvider(X,ce){return ut.registerLinkedEditingRangeProvider(Re,gt(X),ce)},registerReferenceProvider(X,ce){return ut.registerReferenceProvider(Re,gt(X),ce)},registerRenameProvider(X,ce){return ut.registerRenameProvider(Re,gt(X),ce)},registerDocumentSymbolProvider(X,ce,ke){return ut.registerDocumentSymbolProvider(Re,gt(X),ce,ke)},registerWorkspaceSymbolProvider(X){return ut.registerWorkspaceSymbolProvider(Re,X)},registerDocumentFormattingEditProvider(X,ce){return ut.registerDocumentFormattingEditProvider(Re,gt(X),ce)},registerDocumentRangeFormattingEditProvider(X,ce){return ut.registerDocumentRangeFormattingEditProvider(Re,gt(X),ce)},registerOnTypeFormattingEditProvider(X,ce,ke,...st){return ut.registerOnTypeFormattingEditProvider(Re,gt(X),ce,[ke].concat(st))},registerDocumentSemanticTokensProvider(X,ce,ke){return ut.registerDocumentSemanticTokensProvider(Re,gt(X),ce,ke)},registerDocumentRangeSemanticTokensProvider(X,ce,ke){return ut.registerDocumentRangeSemanticTokensProvider(Re,gt(X),ce,ke)},registerSignatureHelpProvider(X,ce,ke,...st){return typeof ke=="object"?ut.registerSignatureHelpProvider(Re,gt(X),ce,ke):ut.registerSignatureHelpProvider(Re,gt(X),ce,typeof ke=="undefined"?[]:[ke,...st])},registerCompletionItemProvider(X,ce,...ke){return ut.registerCompletionItemProvider(Re,gt(X),ce,ke)},registerDocumentLinkProvider(X,ce){return ut.registerDocumentLinkProvider(Re,gt(X),ce)},registerColorProvider(X,ce){return ut.registerColorProvider(Re,gt(X),ce)},registerFoldingRangeProvider(X,ce){return ut.registerFoldingRangeProvider(Re,gt(X),ce)},registerSelectionRangeProvider(X,ce){return ut.registerSelectionRangeProvider(Re,X,ce)},registerCallHierarchyProvider(X,ce){return ut.registerCallHierarchyProvider(Re,X,ce)},setLanguageConfiguration:(X,ce)=>ut.setLanguageConfiguration(Re,X,ce),getTokenInformationAtPosition(X,ce){return(0,ie.checkProposedApiEnabled)(Re),Bt.tokenAtPosition(X,ce)},registerInlineHintsProvider(X,ce){return(0,ie.checkProposedApiEnabled)(Re),ut.registerInlineHintsProvider(Re,X,ce)}},Cn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(X,ce,ke){const st=await(D.URI.isUri(X)?Promise.resolve(on.openTextDocument(X)):Promise.resolve(X));return yt.showTextDocument(st,ce,ke)},createTextEditorDecorationType(X){return yt.createTextEditorDecorationType(X)},onDidChangeActiveTextEditor(X,ce,ke){return yt.onDidChangeActiveTextEditor(X,ce,ke)},onDidChangeVisibleTextEditors(X,ce,ke){return yt.onDidChangeVisibleTextEditors(X,ce,ke)},onDidChangeTextEditorSelection(X,ce,ke){return yt.onDidChangeTextEditorSelection(X,ce,ke)},onDidChangeTextEditorOptions(X,ce,ke){return yt.onDidChangeTextEditorOptions(X,ce,ke)},onDidChangeTextEditorVisibleRanges(X,ce,ke){return yt.onDidChangeTextEditorVisibleRanges(X,ce,ke)},onDidChangeTextEditorViewColumn(X,ce,ke){return yt.onDidChangeTextEditorViewColumn(X,ce,ke)},onDidCloseTerminal(X,ce,ke){return ft.onDidCloseTerminal(X,ce,ke)},onDidOpenTerminal(X,ce,ke){return ft.onDidOpenTerminal(X,ce,ke)},onDidChangeActiveTerminal(X,ce,ke){return ft.onDidChangeActiveTerminal(X,ce,ke)},onDidChangeTerminalDimensions(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),ft.onDidChangeTerminalDimensions(X,ce,ke)},onDidWriteTerminalData(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),ft.onDidWriteTerminalData(X,ce,ke)},get state(){return Xe.state},onDidChangeWindowState(X,ce,ke){return Xe.onDidChangeWindowState(X,ce,ke)},showInformationMessage(X,...ce){return Ot.showMessage(Re,S.default.Info,X,ce[0],ce.slice(1))},showWarningMessage(X,...ce){return Ot.showMessage(Re,S.default.Warning,X,ce[0],ce.slice(1))},showErrorMessage(X,...ce){return Ot.showMessage(Re,S.default.Error,X,ce[0],ce.slice(1))},showQuickPick(X,ce,ke){return Nt.showQuickPick(X,!!Re.enableProposedApi,ce,ke)},showWorkspaceFolderPick(X){return Nt.showWorkspaceFolderPick(X)},showInputBox(X,ce){return Nt.showInput(X,ce)},showOpenDialog(X){return Rt.showOpenDialog(X)},showSaveDialog(X){return Rt.showSaveDialog(X)},createStatusBarItem(X,ce){let ke,st,B,M;return X&&typeof X!="number"?(ke=X.id,st=X.name,B=X.alignment,ce=X.priority,M=X.accessibilityInformation):(ke=Re.identifier.value,st=w.localize(0,null,Re.displayName||Re.name),B=X),hn.createStatusBarEntry(ke,st,B,ce,M)},setStatusBarMessage(X,ce){return hn.setStatusBarMessage(X,ce)},withScmProgress(X){return Ie.report("window.withScmProgress",Re,"Use 'withProgress' instead."),dn.withProgress(Re,{location:N.ProgressLocation.SourceControl},(ce,ke)=>X({report(st){}}))},withProgress(X,ce){return dn.withProgress(Re,X,ce)},createOutputChannel(X){return Et.createOutputChannel(X)},createWebviewPanel(X,ce,ke,st){return en.createWebviewPanel(Re,X,ce,ke,st)},createWebviewTextEditorInset(X,ce,ke,st){return(0,ie.checkProposedApiEnabled)(Re),Jt.createWebviewEditorInset(X,ce,ke,st,Re)},createTerminal(X,ce,ke){return typeof X=="object"?"pty"in X?ft.createExtensionTerminal(X):(X.message&&(0,ie.checkProposedApiEnabled)(Re),X.icon&&(0,ie.checkProposedApiEnabled)(Re),ft.createTerminalFromOptions(X)):ft.createTerminal(X,ce,ke)},registerTerminalLinkProvider(X){return ft.registerLinkProvider(X)},registerTreeDataProvider(X,ce){return Ht.registerTreeDataProvider(X,ce,Re)},createTreeView(X,ce){return Ht.createTreeView(X,ce,Re)},registerWebviewPanelSerializer:(X,ce)=>en.registerWebviewPanelSerializer(Re,X,ce),registerCustomEditorProvider:(X,ce,ke={})=>jt.registerCustomEditorProvider(Re,X,ce,ke),registerFileDecorationProvider(X){return ct.registerFileDecorationProvider(X,Re.identifier)},registerUriHandler(X){return It.registerUriHandler(Re.identifier,X)},createQuickPick(){return Nt.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Nt.createInputBox(Re.identifier)},get activeColorTheme(){return Vt.activeColorTheme},onDidChangeActiveColorTheme(X,ce,ke){return Vt.onDidChangeActiveColorTheme(X,ce,ke)},registerWebviewViewProvider(X,ce,ke){return bn.registerWebviewViewProvider(Re,X,ce,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,ie.checkProposedApiEnabled)(Re),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),mt.onDidChangeActiveNotebookEditor(X,ce,ke)},get visibleNotebookEditors(){return(0,ie.checkProposedApiEnabled)(Re),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ie.checkProposedApiEnabled)(Re),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),mt.onDidChangeNotebookEditorSelection(X,ce,ke)},onDidChangeNotebookEditorVisibleRanges(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),mt.onDidChangeNotebookEditorVisibleRanges(X,ce,ke)},showNotebookDocument(X,ce){return(0,ie.checkProposedApiEnabled)(Re),mt.showNotebookDocument(X,ce)},registerExternalUriOpener(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),tn.registerExternalUriOpener(Re.identifier,X,ce,ke)},get openEditors(){return(0,ie.checkProposedApiEnabled)(Re),Dt.tabs},get onDidChangeOpenEditors(){return(0,ie.checkProposedApiEnabled)(Re),Dt.onDidChangeTabs}},on={get rootPath(){return Ie.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(X){throw P.readonly()},getWorkspaceFolder(X){return Ze.getWorkspaceFolder(X)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(X){throw P.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(X){throw P.readonly()},updateWorkspaceFolders:(X,ce,...ke)=>Ze.updateWorkspaceFolders(Re,X,ce||0,...ke),onDidChangeWorkspaceFolders:function(X,ce,ke){return Ze.onDidChangeWorkspace(X,ce,ke)},asRelativePath:(X,ce)=>Ze.getRelativePath(X,ce),findFiles:(X,ce,ke,st)=>Ze.findFiles(R.GlobPattern.from(X),R.GlobPattern.from(ce),ke,Re.identifier,st),findTextInFiles:(X,ce,ke,st)=>{let B,M;return typeof ce=="object"?(B=ce,M=ke):(B={},M=ce,st=ke),Ze.findTextInFiles(X,B||{},M,Re.identifier,st)},saveAll:X=>Ze.saveAll(X),applyEdit(X){return Ut.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ce,ke,st)=>At.createFileSystemWatcher(R.GlobPattern.from(X),ce,ke,st),get textDocuments(){return bt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw P.readonly()},openTextDocument(X){let ce;const ke=X;if(typeof X=="string")ce=Promise.resolve(D.URI.file(X));else if(D.URI.isUri(X))ce=Promise.resolve(X);else if(!ke||typeof ke=="object")ce=bt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(st=>bt.ensureDocumentData(st).then(B=>B.document))},onDidOpenTextDocument:(X,ce,ke)=>bt.onDidAddDocument(X,ce,ke),onDidCloseTextDocument:(X,ce,ke)=>bt.onDidRemoveDocument(X,ce,ke),onDidChangeTextDocument:(X,ce,ke)=>bt.onDidChangeDocument(X,ce,ke),onDidSaveTextDocument:(X,ce,ke)=>bt.onDidSaveDocument(X,ce,ke),onWillSaveTextDocument:(X,ce,ke)=>Gt.getOnWillSaveTextDocumentEvent(Re)(X,ce,ke),onDidChangeConfiguration:(X,ce,ke)=>sn.onDidChangeConfiguration(X,ce,ke),getConfiguration(X,ce){return ce=arguments.length===1?void 0:ce,sn.getConfiguration(X,ce,Re)},registerTextDocumentContentProvider(X,ce){return Pt.registerTextDocumentContentProvider(X,ce)},registerTaskProvider:(X,ce)=>(Ie.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Re,X,ce)),registerFileSystemProvider(X,ce,ke){return Yt.registerFileSystemProvider(Re.identifier,X,ce,ke)},get fs(){return it.value},registerFileSearchProvider:(X,ce)=>((0,ie.checkProposedApiEnabled)(Re),vt.registerFileSearchProvider(X,ce)),registerTextSearchProvider:(X,ce)=>((0,ie.checkProposedApiEnabled)(Re),vt.registerTextSearchProvider(X,ce)),registerRemoteAuthorityResolver:(X,ce)=>((0,ie.checkProposedApiEnabled)(Re),lt.registerRemoteAuthorityResolver(X,ce)),registerResourceLabelFormatter:X=>((0,ie.checkProposedApiEnabled)(Re),Xt.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ce,ke)=>At.onDidCreateFile(X,ce,ke),onDidDeleteFiles:(X,ce,ke)=>At.onDidDeleteFile(X,ce,ke),onDidRenameFiles:(X,ce,ke)=>At.onDidRenameFile(X,ce,ke),onWillCreateFiles:(X,ce,ke)=>At.getOnWillCreateFileEvent(Re)(X,ce,ke),onWillDeleteFiles:(X,ce,ke)=>At.getOnWillDeleteFileEvent(Re)(X,ce,ke),onWillRenameFiles:(X,ce,ke)=>At.getOnWillRenameFileEvent(Re)(X,ce,ke),openTunnel:X=>((0,ie.checkProposedApiEnabled)(Re),Le.openTunnel(Re,X).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,ie.checkProposedApiEnabled)(Re),Le.getTunnels()},onDidChangeTunnels:(X,ce,ke)=>((0,ie.checkProposedApiEnabled)(Re),Le.onDidChangeTunnels(X,ce,ke)),registerPortAttributesProvider:(X,ce)=>((0,ie.checkProposedApiEnabled)(Re),Le.registerPortsAttributesProvider(X,ce)),registerTimelineProvider:(X,ce)=>((0,ie.checkProposedApiEnabled)(Re),vn.registerTimelineProvider(X,ce,Re.identifier,Ge.converter)),get isTrusted(){return(0,ie.checkProposedApiEnabled)(Re),Ze.trusted},requestWorkspaceTrust:X=>((0,ie.checkProposedApiEnabled)(Re),Ze.requestWorkspaceTrust(X)),onDidReceiveWorkspaceTrust:(X,ce,ke)=>Ze.onDidReceiveWorkspaceTrust(X,ce,ke)},mn={get inputBox(){return Ie.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(Re)},createSourceControl(X,ce,ke){return cn.createSourceControl(Re,X,ce,ke)}},xt={createCommentController(X,ce){return pn.createCommentController(Re,X,ce)}},Kt={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(X,ce,ke){return at.onDidStartDebugSession(X,ce,ke)},onDidTerminateDebugSession(X,ce,ke){return at.onDidTerminateDebugSession(X,ce,ke)},onDidChangeActiveDebugSession(X,ce,ke){return at.onDidChangeActiveDebugSession(X,ce,ke)},onDidReceiveDebugSessionCustomEvent(X,ce,ke){return at.onDidReceiveDebugSessionCustomEvent(X,ce,ke)},onDidChangeBreakpoints(X,ce,ke){return at.onDidChangeBreakpoints(X,ce,ke)},registerDebugConfigurationProvider(X,ce,ke){return at.registerDebugConfigurationProvider(X,ce,ke||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ce){return at.registerDebugAdapterDescriptorFactory(Re,X,ce)},registerDebugAdapterTrackerFactory(X,ce){return at.registerDebugAdapterTrackerFactory(X,ce)},startDebugging(X,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?at.startDebugging(X,ce,{parentSession:ke}):at.startDebugging(X,ce,ke||{})},stopDebugging(X){return at.stopDebugging(X)},addBreakpoints(X){return at.addBreakpoints(X)},removeBreakpoints(X){return at.removeBreakpoints(X)},asDebugSourceUri(X,ce){return at.asDebugSourceUri(X,ce)}},kn={registerTaskProvider:(X,ce)=>pt.registerTaskProvider(Re,X,ce),fetchTasks:X=>pt.fetchTasks(X),executeTask:X=>pt.executeTask(Re,X),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(X,ce,ke)=>pt.onDidStartTask(X,ce,ke),onDidEndTask:(X,ce,ke)=>pt.onDidEndTask(X,ce,ke),onDidStartTaskProcess:(X,ce,ke)=>pt.onDidStartTaskProcess(X,ce,ke),onDidEndTaskProcess:(X,ce,ke)=>pt.onDidEndTaskProcess(X,ce,ke)},an={openNotebookDocument:X=>((0,ie.checkProposedApiEnabled)(Re),mt.openNotebookDocument(X)),get onDidOpenNotebookDocument(){return(0,ie.checkProposedApiEnabled)(Re),mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,ie.checkProposedApiEnabled)(Re),mt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,ie.checkProposedApiEnabled)(Re),mt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,ie.checkProposedApiEnabled)(Re),mt.notebookDocuments.map(X=>X.notebookDocument)},registerNotebookSerializer(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),mt.registerNotebookSerializer(Re,X,ce,ke)},registerNotebookContentProvider:(X,ce,ke)=>((0,ie.checkProposedApiEnabled)(Re),mt.registerNotebookContentProvider(Re,X,ce,ke)),registerNotebookCellStatusBarItemProvider:(X,ce)=>((0,ie.checkProposedApiEnabled)(Re),mt.registerNotebookCellStatusBarItemProvider(Re,X,ce)),createNotebookEditorDecorationType(X){return(0,ie.checkProposedApiEnabled)(Re),mt.createNotebookEditorDecorationType(X)},onDidChangeNotebookDocumentMetadata(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),mt.onDidChangeNotebookDocumentMetadata(X,ce,ke)},onDidChangeNotebookCells(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),mt.onDidChangeNotebookCells(X,ce,ke)},onDidChangeCellExecutionState(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),mt.onDidChangeNotebookCellExecutionState(X,ce,ke)},onDidChangeCellOutputs(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),mt.onDidChangeCellOutputs(X,ce,ke)},onDidChangeCellMetadata(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),mt.onDidChangeCellMetadata(X,ce,ke)},createConcatTextDocument(X,ce){return(0,ie.checkProposedApiEnabled)(Re),new z.ExtHostNotebookConcatDocument(mt,bt,X,ce)},createNotebookCellExecutionTask(X,ce,ke){return(0,ie.checkProposedApiEnabled)(Re),mt.createNotebookCellExecution(X,ce,ke)},createNotebookController(X,ce,ke,st,B){return(0,ie.checkProposedApiEnabled)(Re),Qt.createNotebookController(Re,X,ce,ke,st,B)}};return{version:We.version,authentication:_n,commands:En,comments:xt,debug:Kt,env:qt,extensions:Sn,languages:Dn,notebook:an,scm:mn,tasks:kn,test:yn,window:Cn,workspace:on,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:P.CancellationError,CancellationTokenSource:k.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:c.FileType,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,Hover:N.Hover,IndentAction:i.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,UIKind:d.UIKind,Uri:D.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlineHint:N.InlineHint,InlineHintKind:N.InlineHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,RemoteTrustOption:Ee.RemoteTrustOption,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookDocumentMetadata:N.NotebookDocumentMetadata,NotebookCellMetadata:N.NotebookCellMetadata,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,LinkedEditingRanges:N.LinkedEditingRanges,TestItemStatus:N.TestItemStatus,TestResultState:N.TestResultState,TestMessage:N.TestMessage,TestMessageSeverity:N.TestMessageSeverity,WorkspaceTrustState:N.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ve}),define(be[226],we([0,1,61,100,30,99,34,76,39,40,102,103,104,79,78,70,75,101,77,49,74,94]),function(J,e,w,k,P,A,S,D,y,C,i,I,c,d,o,a,g,h,_,m,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(d.IExtensionStoragePaths,d.ExtensionStoragePaths),(0,w.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,w.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,w.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,w.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,w.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,w.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,w.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,w.registerSingleton)(m.IExtHostFileSystemInfo,m.ExtHostFileSystemInfo),(0,w.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService),(0,w.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,w.registerSingleton)(o.IExtHostStorage,o.ExtHostStorage),(0,w.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,w.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,w.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,w.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow),(0,w.registerSingleton)(P.IExtHostWorkspace,P.ExtHostWorkspace),(0,w.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,w.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry)}),define(be[227],we([0,1,225,35,221,7,11,5]),function(J,e,w,k,P,A,S,D){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(o){var a;const g=(a=self.trustedTypes)===null||a===void 0?void 0:a.createPolicy("TrustedFunctionWorkaround",{createScript:(_,...m)=>{m.forEach(n=>{var s;if(!((s=self.trustedTypes)===null||s===void 0?void 0:s.isScript(n)))throw new Error("TrustedScripts only, please")});const u=m.slice(0,-1).join(","),p=m.pop().toString();return`(function anonymous(${u}) {
${p}
})`}});function h(..._){return g?self.eval(g.createScript("",..._)):new Function(..._)}o.create=h})(C||(C={}));class i extends P.RequireInterceptor{_installInterceptor(){}getModule(a,g){for(let h of this._alternatives){let _=h(a);if(_){a=_;break}}if(this._factories.has(a))return this._factories.get(a).load(a,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const a=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);d(a,this._initData.environment.isExtensionDevelopmentDebug);const g=this._instaService.invokeFunction(w.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,g,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(a){return a.browser}async _loadCommonJSModule(a,g,h){var _,m,u,p,t,n,s,r;g=g.with({path:c(g.path,".js")}),a&&performance.mark(`code/extHost/willFetchExtensionCode/${a.value}`);const l=await fetch(g.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a.value}`),l.status!==200)throw new Error(l.statusText);const f=await l.text(),v=`${g.toString(!0)}#vscode-extension`,T=`${f}
//# sourceURL=${v}`;let b;try{b=C.create((m=(_=I._ttpExtensionScripts)===null||_===void 0?void 0:_.createScript("module"))!==null&&m!==void 0?m:"module",(p=(u=I._ttpExtensionScripts)===null||u===void 0?void 0:u.createScript("exports"))!==null&&p!==void 0?p:"exports",(n=(t=I._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(r=(s=I._ttpExtensionScripts)===null||s===void 0?void 0:s.createScript(T))!==null&&r!==void 0?r:T)}catch(K){throw a?console.error(`Loading code for extension ${a.value} failed: ${K.message}`):console.error(`Loading code failed: ${K.message}`),console.error(`${g.toString(!0)}${typeof K.line=="number"?` line ${K.line}`:""}${typeof K.column=="number"?` column ${K.column}`:""}`),console.error(K),K}const E={},F={exports:E},L=K=>{const fe=this._fakeModules.getModule(K,g);if(fe===void 0)throw new Error(`Cannot load module '${K}'`);return fe};try{return h.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a.value}`),b(F,E,L),F.exports!==E?F.exports:E}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a.value}`),h.codeLoadingStop()}}async $setRemoteEnvironment(a){throw new Error("Not supported")}async _waitForDebuggerAttachment(a=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const g=Date.now()+a;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,S.timeout)(10)}}}e.ExtHostExtensionService=I,I._ttpExtensionScripts=(y=self.trustedTypes)===null||y===void 0?void 0:y.createPolicy("ExtensionScripts",{createScript:o=>o});function c(o,a){return o.endsWith(a)?o:o+a}function d(o,a){g("info","log"),g("log","log"),g("warn","warn"),g("error","error");function g(m,u){const p=console[m];console[m]=function(){o.$logExtensionHostMessage({type:"__$console",severity:u,arguments:_(arguments)}),a&&p.apply(console,arguments)}}const h=1e5;function _(m){const u=[],p=[];if(m.length)for(let t=0;t<m.length;t++){if(typeof m[t]=="undefined")m[t]="undefined";else if(m[t]instanceof Error){const n=m[t];n.stack?m[t]=n.stack:m[t]=n.toString()}p.push(m[t])}try{const t=JSON.stringify(p,function(n,s){if(s&&typeof s=="object"){if(u.indexOf(s)!==-1)return"[Circular]";u.push(s)}return s});return t.length>h?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[228],we([0,1,61,19,35,227,213]),function(J,e,w,k,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(P.IExtHostExtensionService,A.ExtHostExtensionService),(0,w.registerSingleton)(k.ILogService,S.ExtHostLogService)}),define(be[230],we([0,1,23,3,184,222,215,14,80,226,228]),function(J,e,w,k,P,A,S,D,y){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const I=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=(C=self.trustedTypes)===null||C===void 0?void 0:C.createPolicy("extensionHostWorker",{createScriptURL:_=>_}),h=self.Worker;Worker=function(_,m){const u=`importScripts('${_}');`;m=m||{},m.name=m.name||D.basename(_.toString());const p=new Blob([u],{type:"application/javascript"}),t=URL.createObjectURL(p);return new h(g?g.createScriptURL(t):t,m)}}else self.Worker=class extends S.NestedWorker{constructor(g,h){super(I,g,Object.assign({name:D.basename(g.toString())},h))}};const c=new class{exit(g){i()}async exists(g){return!0}async realpath(g){return g}};class d{constructor(){const h=new MessageChannel,_=new k.Emitter;let m=!1;I(h.port2,[h.port2]),h.port1.onmessage=u=>{const{data:p}=u;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const t=w.VSBuffer.wrap(new Uint8Array(p,0,p.byteLength));if((0,P.isMessageOfType)(t,2)){m=!0,a("received terminate message from renderer");return}_.fire(t)},this.protocol={onMessage:_.event,send:u=>{if(!m){const p=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);h.port1.postMessage(p,[p])}}}}}function o(g){return new Promise(h=>{const _=g.onMessage(m=>{_.dispose();const u=JSON.parse(m.toString());g.send((0,P.createMessageOfType)(0)),h({protocol:g,initData:u})});g.send((0,P.createMessageOfType)(1))})}let a=g=>i();(function(){const h=new d;y.mark("code/extHost/willConnectToRenderer"),o(h.protocol).then(_=>{y.mark("code/extHost/didWaitForInitData");const m=new A.ExtensionHostMain(_.protocol,_.initData,c,null);a=u=>m.terminate(u)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/23a2409675bc1bde94f3532bc7c5826a6e99e4b6/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
